C /*****************************************************************************\
C * MPI/Pro and related software
C *
C * Copyright (C) 1998 MPI Software Technology, Inc.  All rights reserved.
C *
C * This source file contains trade secrets of MPI Software Technology, Inc.
C * and may not be displayed, reproduced, retransmitted, modified,
C * photocopied, or stored in an electronic information retrieval
C * system without express written permission of MPI Software Technology, Inc.
C * Use of this software is subject to written licensure and sub-licensure
C * agreement with MPI Software Technology, Inc., which defines the
C * rights and responsibilities of licensee and sub-licensee, and limits
C * MPI Software Technology's liability.  This copyright notice must not be
C * removed on copies and derivative works made under license and sub-license.
C *
C * Other copyrights may apply to this software, and are noted where
C * appropriate.
C *
C * Disclaimer of liability:
C * MPI Software Technology, Inc. provides a limited warranty as part of
C * the written licensure and sub-licensure agreements associated with this
C * software, and included here by implication.    MPI Software
C * Technology, Inc. makes no representations about the merchantability
C * of this software or suitability of for any particular purpose, and
C * specifically disclaims liability for lost revenue, profits  or other,
C * special, indirect and consequential damages, even if MPI Software
C * Technology, Inc. has been informed of the possibility of such damages.
C *
C * MPI Software Technology, Inc.
C * 1 Research Blvd., Suite 201
C * Starkville, MS 39759-9741
C * (601)320-4300; FAX: (601)320-4301; http://www.mpi-softtech.com/
C *
C * OEMs/ISVs add additional notices here:
C * -------------------------------------
C *
C \****************************************************************************/
C

C
C Return codes
C
      INTEGER MPI_SUCCESS,MPI_ERR_BUFFER,MPI_ERR_COUNT,MPI_ERR_TYPE
      INTEGER MPI_ERR_TAG,MPI_ERR_COMM,MPI_ERR_RANK,MPI_ERR_ROOT
      INTEGER MPI_ERR_GROUP
      INTEGER MPI_ERR_OP,MPI_ERR_TOPOLOGY,MPI_ERR_DIMS,MPI_ERR_ARG
      INTEGER MPI_ERR_UNKNOWN,MPI_ERR_TRUNCATE,MPI_ERR_OTHER
      INTEGER MPI_ERR_INTERN,MPI_ERR_IN_STATUS,MPI_ERR_PENDING
      INTEGER MPI_ERR_REQUEST, MPI_ERR_NOT_INITIALIZED
      INTEGER MPI_ERR_FINALIZED, MPI_ERR_COMM_MEDIUM
	  INTEGER MPI_ERR_LASTCODE
      PARAMETER (MPI_SUCCESS=0,MPI_ERR_BUFFER=1,MPI_ERR_COUNT=2)
      PARAMETER (MPI_ERR_TYPE=3,MPI_ERR_TAG=4,MPI_ERR_COMM=5)
      PARAMETER (MPI_ERR_RANK=6,MPI_ERR_ROOT=7,MPI_ERR_GROUP=8)
      PARAMETER (MPI_ERR_OP=9,MPI_ERR_TOPOLOGY=10,MPI_ERR_DIMS=11)
      PARAMETER (MPI_ERR_ARG=12,MPI_ERR_UNKNOWN=13)
      PARAMETER (MPI_ERR_TRUNCATE=14,MPI_ERR_OTHER=15)
      PARAMETER (MPI_ERR_INTERN=16,MPI_ERR_IN_STATUS=17)
      PARAMETER (MPI_ERR_PENDING=18,MPI_ERR_REQUEST=19)
      PARAMETER (MPI_ERR_NOT_INITIALIZED=20,MPI_ERR_FINALIZED=21)
      PARAMETER (MPI_ERR_COMM_MEDIUM=22,MPI_ERR_LASTCODE=23)
C
C Communicators, groups, errorhandlers, and keyvalues
C
      INTEGER MPI_CART, MPI_GRAPH 
      PARAMETER (MPI_CART = 1, MPI_GRAPH = 2)

      INTEGER MPI_ERRHANDLER_NULL
      PARAMETER (MPI_ERRHANDLER_NULL = 0)
      INTEGER MPI_ERRORS_ARE_FATAL, MPI_ERRORS_RETURN
      PARAMETER (MPI_ERRORS_ARE_FATAL=1, MPI_ERRORS_RETURN=2)
      
      INTEGER MPI_KEYVAL_INVALID, MPI_TAG_UB, MPI_HOST, MPI_IO
      PARAMETER (MPI_KEYVAL_INVALID = 0, MPI_TAG_UB = 1)
      INTEGER MPI_WTIME_IS_GLOBAL
      PARAMETER (MPI_HOST = 2, MPI_IO = 3, MPI_WTIME_IS_GLOBAL = 4)
      INTEGER MPI_NULL_COPY_FN, MPI_DUP_FN, MPI_NULL_DELETE_FN
      PARAMETER (MPI_NULL_COPY_FN = 1, MPI_DUP_FN = 2)
      PARAMETER (MPI_NULL_DELETE_FN = 3)
      
      INTEGER MPI_REQUEST_NULL
      PARAMETER (MPI_REQUEST_NULL = 0)
 
      INTEGER MPI_COMM_NULL, MPI_COMM_WORLD, MPI_COMM_SELF
      PARAMETER (MPI_COMM_NULL=0, MPI_COMM_WORLD=1, MPI_COMM_SELF=2)

      INTEGER MPI_GROUP_NULL, MPI_GROUP_EMPTY
      PARAMETER (MPI_GROUP_NULL=0, MPI_GROUP_EMPTY=1)
C
C Predefined datatypes
C
      INTEGER MPI_DATATYPE_NULL
      INTEGER MPI_PACKED, MPI_LB, MPI_UB
      INTEGER MPI_CHARACTER, MPI_LOGICAL, MPI_INTEGER
      INTEGER MPI_REAL, MPI_DOUBLE_PRECISION
      INTEGER MPI_COMPLEX, MPI_DOUBLE_COMPLEX
      INTEGER MPI_2INTEGER, MPI_2REAL, MPI_2DOUBLE_PRECISION
      INTEGER MPI_2COMPLEX, MPI_2DOUBLE_COMPLEX

      INTEGER MPI_INTEGER1, MPI_INTEGER2, MPI_INTEGER4
      INTEGER MPI_BYTE, MPI_REAL4, MPI_REAL8
  
      PARAMETER (MPI_DATATYPE_NULL=0)
      PARAMETER (MPI_PACKED=14, MPI_LB=15, MPI_UB=16)
      PARAMETER (MPI_CHARACTER=23, MPI_LOGICAL=24, MPI_INTEGER=25)
      PARAMETER (MPI_REAL=26, MPI_DOUBLE_PRECISION=27)
      PARAMETER (MPI_COMPLEX=28, MPI_DOUBLE_COMPLEX=29)
      PARAMETER (MPI_2INTEGER=30, MPI_2REAL=31)
      PARAMETER (MPI_2DOUBLE_PRECISION=32)
      PARAMETER (MPI_2COMPLEX=33, MPI_2DOUBLE_COMPLEX=34)

      PARAMETER (MPI_INTEGER1=1, MPI_INTEGER2=4, MPI_INTEGER4=25)
      PARAMETER (MPI_BYTE=3, MPI_REAL4=26, MPI_REAL8=27)
C
C Predefined reduction operations
C
      INTEGER MPI_OP_NULL, MPI_SUM, MPI_MAX, MPI_MIN
      INTEGER MPI_PROD, MPI_LAND, MPI_BAND
      INTEGER MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR
      INTEGER MPI_MAXLOC, MPI_MINLOC
      PARAMETER (MPI_OP_NULL=0, MPI_MAX=1, MPI_MIN=2)
      PARAMETER (MPI_SUM=3, MPI_PROD=4)
      PARAMETER (MPI_LAND=5, MPI_BAND=6, MPI_LOR=7, MPI_BOR=8)
      PARAMETER (MPI_LXOR=9, MPI_BXOR=10, MPI_MAXLOC=11)
      PARAMETER (MPI_MINLOC=12)
C
C Constants
C
      INTEGER MPI_SOURCE, MPI_TAG, MPI_ERROR
      PARAMETER(MPI_SOURCE=2, MPI_TAG=3, MPI_ERROR=4)
      INTEGER MPI_STATUS_SIZE
      PARAMETER (MPI_STATUS_SIZE=4)
      INTEGER MPI_MAX_PROCESSOR_NAME, MPI_MAX_ERROR_STRING
      PARAMETER (MPI_MAX_PROCESSOR_NAME=80)
      PARAMETER (MPI_MAX_ERROR_STRING=80)
      INTEGER MPI_MAX_NAME_STRING
      PARAMETER (MPI_MAX_NAME_STRING=80)

      INTEGER  MPI_UNEQUAL, MPI_IDENT, MPI_CONGRUENT, MPI_SIMILAR
      PARAMETER (MPI_UNEQUAL=0, MPI_IDENT=1, MPI_CONGRUENT=2)
      PARAMETER (MPI_SIMILAR=3)

      INTEGER MPI_BSEND_OVERHEAD
      PARAMETER ( MPI_BSEND_OVERHEAD = 32 )

      INTEGER MPI_ANY_TAG
      PARAMETER (MPI_ANY_TAG = (-1))
      INTEGER MPI_ANY_SOURCE
      PARAMETER (MPI_ANY_SOURCE = (-2))
      INTEGER  MPI_PROC_NULL
      PARAMETER (MPI_PROC_NULL = (-1))
      INTEGER MPI_UNDEFINED
      PARAMETER (MPI_UNDEFINED = (-32766))
      INTEGER MPI_VERSION, MPI_SUBVERSION
      PARAMETER (MPI_VERSION = 1, MPI_SUBVERSION = 2)

      COMMON /MPIPRO/ MPI_BOTTOM 
      INTEGER MPI_BOTTOM
      SAVE /MPIPRO/

      DOUBLE PRECISION MPI_WTIME, MPI_WTICK
      EXTERNAL MPI_WTIME, MPI_WTICK
