        SUBROUTINE MP_INIT
C  This subroutine initializes all the wildcard values and defines the
C  coarse and fine grain groups to be used

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
        include 'PARAMET.MP'
        include 'COMMON.MP'
        include 'COMMON.ODONNELL'
#ifdef WINNT
        COMMON/TTTIM/STTIM
#endif
#ifdef MPI
        include 'mpif.h'
        INTEGER IERR,STATUS(MPI_STATUS_SIZE)
#endif
C        INTEGER GID(0:maxnum_procs)
        INTEGER ALLMSG, NULLTASK
        INTEGER QTYPE
        INTEGER NELEM(3)
        INTEGER NBUF(4)
        INTEGER FGNUM
        INTEGER FperC
        INTEGER FGLIST(0:maxnum_procs,0:maxnum_procs)
        INTEGER TEMPLIST(maxnum_procs)
        INTEGER FGLABEL(maxnum_procs)
        INTEGER FGID(0:maxnum_procs)
        INTEGER BOSSTASK
        INTEGER IGID, LIST(4), IL, ISIZE
        INTEGER I,J

#ifdef MPL
        CALL MP_ENVIRON(NUMTASKS,TASKID)
#endif
#ifdef MPI
        CALL MPI_INIT(IERR)
        if (IERR.NE.0) THEN
           Write(*,*) '1-Error in MP_INIT'
!          call sleep(5)
        ENDIF

        CALL MPI_COMM_RANK(MPI_COMM_WORLD,TASKID,IERR)
        if (IERR.NE.0) THEN
           Write(*,*) '2-Error in MP_INIT'
!          call sleep(5)
        ENDIF
        CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUMTASKS,IERR)
        if (IERR.NE.0) THEN
           Write(*,*) '2-Error in MP_INIT'
!          call sleep(5)
        ENDIF
#endif
        write(*,*) "***********************"
        write(*,*) "TASKID=",TASKID
        write(*,*) "***********************"
        write(*,*)

#ifdef WINNT
!   START OF TIMED SEQUENCE
!       STTIM = SECNDS(0.0)
#endif

        YourJob = (TASKID.eq.MASTER)
        CGYes = .False.
C each processor now knows its taskid and the number of processors present
C In addition, each processor has assigned the logical flag YourJob.  If
C the proc is the MASTER, YourJob is .TRUE.  If not, YourJob is .FALSE.

        CGNUM = NUMTASKS
        DO I=0, NUMTASKS - 1
          CGLIST(I+1) = I
          ITSKFLG(I)=.FALSE.
          ITSKConfNo(I)=0
        ENDDO
#ifdef MPL
        CALL MP_GROUP(CGNUM,CGLIST,777,CGID)
#endif
#ifdef MPL
        FperC    = 0
        NELEM(1) = 1
        NELEM(2) = 2
        NELEM(3) = 4
        QTYPE    = 3
        
        CALL MP_TASK_QUERY(NBUF,NELEM(QTYPE),QTYPE)
        DONTCARE   = NBUF(1)
        ALLMSG     = NBUF(2)
        NULLTASK   = NBUF(3)
        ALLGRP     = NBUF(4)
C each processor now knows the wildcard values for dontcare, etc...

C The following code sets up the coarse and fine grain group structure
C The structure I have used is the following.  If we have a total of 20
C processors ( with ID's [0..19] and we want 4 fine grain processors per
C coarse grain (FperC = 4) then we will have 5 user defined groups.  The
C first of these is the group of all coarse grain procs. {0,5,10,15}
C The remaining groups contain each CG and its constituent FG's:
C Group #1:   {0,1,2,3,4}            Group #3:    {10,11,12,13,14}
C Group #2:   {5,6,7,8,9}            Group #4:    {15,16,17,18,19}
C Each of these groups takes the TASKID of the CG as its label.

C        CGNUM = 0
C        DO I=0, NUMTASKS-1
C          IF ((MOD(I,(FperC+1))).EQ.0) THEN 
C            BOSSTASK = I
C            FGLIST(BOSSTASK,0) = 0
C            FGNUM = 0
C            CGNUM = CGNUM + 1
C            CGLIST(CGNUM) = I 
C          ELSE
C            FGNUM = FGNUM + 1
C            FGLIST(BOSSTASK,FGNUM) = I
C            FGLIST(BOSSTASK,0) = FGNUM
C          ENDIF
C        ENDDO

C  We have set up the processor template and stored it in FGLIST(x,y)
C  where x is the TASKID of a CG proc. and 1<=y<=FperC holds the 
C  TASKID's for all its FG procs.  FGLIST(x,0) holds the actual number
C  of FG's in x's group.  This is usually equal to FperC but occasionally
C  there will be less than this in the last group to be defined.

C  Now we are going to define the MPL groups according to the previously
C  mentioned structure.

C        DO I=1, CGNUM
C          BOSSTASK = CGLIST(I)
C          ISIZE = FGLIST(BOSSTASK,0) + 1
C          IL = BOSSTASK
C          DO J=1, ISIZE - 1
C            TEMPLIST(J) = FGLIST(BOSSTASK,J)
C          ENDDO
C          TEMPLIST(ISIZE) = BOSSTASK 
C          DO J = 1, ISIZE
C            IF (TASKID.eq.TEMPLIST(J)) THEN
C              CALL MP_GROUP(ISIZE,TEMPLIST,IL,IGID)
C              write(*,*) 'IL = ',IL,'   IGID = ',IG
C            ENDIF
C            GID(TEMPLIST(J)) = IGID
C          ENDDO
C        ENDDO

C  Lastly, we are going to define the coarse grain group

C        DO J=1, CGNUM
C          IF (TASKID.eq.CGLIST(J)) THEN
C            CALL MP_GROUP(CGNUM,CGLIST,777,CGID)
C            CGYes = .True.
C          ENDIF
C        ENDDO
C        write(*,*) 'IGID = ', IGID,'  CGyes = ',CGYes
C        STOP 12345

C  the cgdone array is a series of logical flags the master uses to 
C  keep track of which workers are still minimizing and which ones
C  are waiting to exit the program.
#endif
        DO K = 2,CGNUM
          CGDONE(CGLIST(K)) = .FALSE.
        ENDDO
        RETURN

        END

C =========================================================================
C =========================================================================


        SUBROUTINE MASTER_MAIL
C  During this subroutine, the master reads all the incoming mail from the
C other CG nodes and processes their data.

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
        include 'PARAMET.MP'
        include 'COMMON.MP'
        include 'COMMON.CNTRL'
        include 'COMMON.ODONNELL'
        include 'COMMON.MYCONF'
        include 'COMMON.LIST0'
        include 'COMMON.GEN100'
        include 'COMMON.BONDSX'
        include 'COMMON.CALC'
        include 'COMMON.EDMC'
        include 'COMMON.SETUP'
        include 'COMMON.TOR2'
        include 'COMMON.TOR'
        INCLUDE 'COMMON.TRACK'
        INCLUDE 'COMMON.IOUNIT'
        INCLUDE 'COMMON.TERMAL'
        INCLUDE 'COMMON.NNDRUK'
        include 'COMMON.CLUSTER'
        include 'COMMON.TIME1'
#ifdef PHCALC
        INCLUDE 'param.ibems'
        include 'ecepp_ibems_intrf.h'
#endif
#ifdef WINNT
        COMMON/TTTIM/STTIM
#endif
#ifdef MPI
        include 'mpif.h'
        INTEGER IERR, STATUS(MPI_STATUS_SIZE)
        LOGICAL FLAG
        INTEGER IONE
        DATA IONE /1/
#endif
        LOGICAL GOOD, DUMMLOG

        INTEGER          SOURCE, MTYPE, NBYTES, BRCVD, DUMMYINT
        INTEGER          Tlprhi, Tlchar, Timov, Tiinc, Tnumvar, accept
        LOGICAL          YourOwn, Te_o_f, Tover, Tcngeo
        INTEGER          Index, NIN
        DOUBLE PRECISION ETMP(DESERTLENGTH)
        CHARACTER*14 TYP_GEN(3) /'electrostatic','random','thermal'/

        do i=1,DESERTLENGTH
           ETMP(I)=0.0D0
        ENDDO

        Tover = .FALSE.
#ifdef MPL
        SOURCE = DONTCARE
        MTYPE  = DONTCARE
        CALL MP_PROBE(SOURCE,MTYPE,NBYTES)
        DO WHILE (NBYTES.NE.-1)
#endif
#ifdef MPI
        SOURCE = MPI_ANY_SOURCE
        MTYPE  = MPI_ANY_TAG
        CALL MPI_IPROBE(SOURCE,MTYPE,MPI_COMM_WORLD,FLAG,STATUS,IERR)
        if (IERR.NE.0) THEN
           Write(*,*) "1 - Error in MASTER_MAIL, TASKID=",TASKID 
           Write(*,*) "1-Status=",STATUS 
           Write(*,*) "1-IERR=",IERR 
        ENDIF
!         GTIME=TCPU() 
#ifdef WINNT
!       GTIME=SECNDS(STTIM)
#endif
!       write(*,*)'Master checked for MSGS at ', GTIME,' FLAG =',FLAG
        DO WHILE (FLAG)
           SOURCE = STATUS(MPI_SOURCE)
           MTYPE  = STATUS(MPI_TAG)
!         write(*,*)'Master receiving MSG type=',MTYPE,
!    &         ' from  processor', SOURCE, ' at ', GTIME
!         write(JOUT,*)'Master receiving MSG type=',MTYPE,
!    &         ' from  processor', SOURCE, ' at ', GTIME

#endif
C            { while there is a message to be received }
C            write(*,*) ' MTYPE= ', MTYPE
           IF (MTYPE.EQ.WANTCONF) THEN
C              { worker wants a new conf for a MINTASK run }
#ifdef MPL
              CALL MP_BRECV(DUMMYINT,INTSIZE,SOURCE,WANTCONF,BRCVD)
#endif
#ifdef MPI
              CALL MPI_RECV(DUMMYINT,1,MPI_INTEGER,SOURCE,WANTCONF,
     & MPI_COMM_WORLD,STATUS,IERR)
               if (IERR.NE.0) THEN
                  Write(*,*) '2-Error in MASTER_MAIL' 
!                 call sleep(10)
               ENDIF
#endif
!
!Check if processor returned a minimized conformation:
              IF (ITSKFLG(SOURCE)) THEN
! Previous minimization on this processor failed
! then reorganized list for "sort_out"  indicating that
! conf ITSKConfNo(SOURCE)  has to be removed 
                 MYCONTMP=MYCON
                 MYCON= ITSKConfNo(SOURCE)
                 IDUMMY=99999 
!                WRITE(*,*) 'MP: 1-Eliminating Conformation ',MYCON
!    &         , ' from processor ', SOURCE
                 CALL SORT_OUT(IDUMMY,NDONE,.TRUE.)
                 MYCON= MYCONTMP
                 ENDIF              
              IF (NOT_DONE) THEN
C                { there are more conf's to be read -- tell worker }
                 YourOwn = .FALSE.
                 Te_o_f = .FALSE.
                 CALL READANG(Te_o_f,Tioldnum,Toldener,YourOwn)
#ifdef MPL
                 CALL MP_BSEND(Te_o_f,BOOLSIZE,SOURCE,POINTER,MSGID)
#endif
#ifdef MPI
                 CALL MPI_SEND(Te_o_f,1,MPI_LOGICAL,SOURCE,POINTER,
     &                         MPI_COMM_WORLD,IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '3-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
#endif
                 IF (Te_o_f) THEN
C                  { MASTER hit EOF in READANG -- tell workers }
                   NOT_DONE = .FALSE.
                   CGDONE(SOURCE) = .TRUE.
                 ELSE
C                  { successful reading of conf -- send it to worker }
C                 write(*,*) 'SendRead IOLD=',TIOLDNUM,' ETOT=',Desert(8)
#ifdef MPL
                  CALL MP_BSEND(Tlist,LISTSIZE,SOURCE,LISTMSG,MSGID)
                  CALL MP_BSEND(Tangles,ANGLESIZE,SOURCE,ANGLEMSG,MSGID)
                  CALL MP_BSEND(DESERT,DESERTSIZE,SOURCE,DESMSG,MSGID)
#endif
#ifdef MPI

                  CALL MPI_SEND(Tlist,maxnum_res,MPI_INTEGER,
     &                           SOURCE,LISTMSG,MPI_COMM_WORLD,IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '4-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
                  CALL MPI_SEND(Tangles,(maxnum_dihe*maxnum_res),
     &                           MPI_REAL,SOURCE,ANGLEMSG,
     &                           MPI_COMM_WORLD,IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '5-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
                  CALL MPI_SEND(DESERT,DESERTLENGTH,
     &                          MPI_DOUBLE_PRECISION,SOURCE,DESMSG,
     &                          MPI_COMM_WORLD,IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '6-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
#endif
                  ITSKFLG(SOURCE)=.TRUE.
                  ITSKConfNo(SOURCE)  = INT(DESERT(6) + 0.5)
 
                 ENDIF
              ELSE
C                { no more conf's -- tell the worker }
                 Te_o_f = .TRUE.
                 CGDONE(SOURCE) = .TRUE.
#ifdef MPL
                 CALL MP_BSEND(Te_o_f,BOOLSIZE,SOURCE,POINTER,MSGID)
#endif
#ifdef MPI
                 CALL MPI_SEND(Te_o_f,1,MPI_LOGICAL,SOURCE,POINTER,
     &                         MPI_COMM_WORLD,IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '7-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
#endif
              ENDIF
           ELSE IF (MTYPE.EQ.OUTMSG) THEN
              DO I=1,INUMRS
                 Tlist(I) = LIST(I)
                 DO J=1,MAXNUM_DIHE
                    Tangulo(J,I) = ANGULO(J,I) 
                 ENDDO
              ENDDO
              Tioldnum = IOLDNUM
              Tiamcon  = MYCON
************************
C Master put local variables in ETMP array
C EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA, DELPHI, EPROT, EDIS, EDIHC
              ETMP(8) =  ETOT
              ETMP(9) =  EES
              ETMP(10) = ENB
              ETMP(11) = ETOR
              ETMP(12) = EPRO
              ETMP(13) = ETORBR
              ETMP(14) = ELOOP
              ETMP(15) = EHYDA
              ETMP(16) = DELPHI
              ETMP(17) = EPROT
              ETMP(18) = EDIS
              ETMP(19) = EDIHC
              ETMP(20) = EVIB
#ifdef PHCALC
              DO I=1,NPOLRES_TEI
                 ETMP(I+20) = OPT_IONZ_EI(I)
              ENDDO
#endif
                
************************
#ifdef MPL
              CALL MP_BRECV(DUMMYINT,INTSIZE,SOURCE,OUTMSG,BRCVD)
              CALL MP_BRECV(LIST,LISTSIZE,SOURCE,LISTMSG,BRCVD)
              CALL MP_BRECV(ANGLES,ANGLESIZE,SOURCE,ANGLEMSG,BRCVD)
              CALL MP_BRECV(DESERT,DESERTSIZE,SOURCE,DESMSG,BRCVD)
#endif
#ifdef MPI
              CALL MPI_RECV(DUMMYINT,1,MPI_INTEGER,SOURCE,OUTMSG,
     &                         MPI_COMM_WORLD,STATUS,IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '8-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
              CALL MPI_RECV(LIST,maxnum_res,MPI_INTEGER,SOURCE,
     &                         LISTMSG,MPI_COMM_WORLD,STATUS,IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '9-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
              CALL MPI_RECV(ANGLES,(maxnum_dihe*maxnum_res),MPI_REAL,
     &                         SOURCE,ANGLEMSG,MPI_COMM_WORLD,STATUS,
     &                         IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '10-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
              CALL MPI_RECV(DESERT,DESERTLENGTH,MPI_DOUBLE_PRECISION,
     &                         SOURCE,DESMSG,MPI_COMM_WORLD,STATUS,IERR)
                 IF (IERR.NE.0) THEN
                    Write(*,*) '11-Error in MASTER_MAIL' 
!                   call sleep(10)
                 ENDIF
#endif
              IOLDNUM =  INT(DESERT(5) + 0.5)
              MYCON   =  INT(DESERT(6) + 0.5)
! The conformation was processed correctly, processor will be ready for
! a new one.
              ITSKFLG(SOURCE)=.FALSE.
!             WRITE(*,*) 'MP: GOOD CONF. - MYCON=  ',MYCON
!    &        , ' from processor', SOURCE
! Just a check
              IF(ITSKConfNo(SOURCE) .NE. MYCON)
     &         WRITE(*,*)' PROBLEMS WITH ITSKConfNo'
*********************************
C Master put variables  from slave processor in local commons for printing
C ETOT
C EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA, DELPHI, EPROT, EDIS, EDIHC, EVIB
              ETOT = DESERT(8)
              EES = DESERT(9)
              ENB = DESERT(10)
              ETOR= DESERT(11)
              EPRO= DESERT(12)
              ETORBR= DESERT(13)
              ELOOP= DESERT(14)
              EHYDA= DESERT(15)
              DELPHI= DESERT(16)
              EPROT= DESERT(17)
              EDIS= DESERT(18)
              EDIHC= DESERT(19)
              EVIB= DESERT(20)
#ifdef PHCALC
              DO I=1,NPOLRES_TEI
                 OPT_IONZ_EI(I)= DESERT(I+20) 
              ENDDO
#endif
 
*********************************


C                write(*,*)'IN MASTER MAIL,  IOLDNUM',  IOLDNUM
              IF (ETOT.LE. ETHRESH) THEN
!                WRITE(*,*) 'MP: 2-OUT Conformation ',MYCON
                 CALL SORT_OUT(IOLDNUM,NDONE,.FALSE.)
              ENDIF
              DO I=1,INUMRS
                 LIST(I) = Tlist(I)
                 DO J=1,MAXNUM_DIHE
                    ANGULO(J,I) = Tangulo(J,I) 
                 ENDDO
              ENDDO
              IOLDNUM = Tioldnum
              MYCON  = Tiamcon

************************
C Master recovers its local variables from ETMP array
              ETOT = ETMP(8)
              EES = ETMP(9)
              ENB = ETMP(10)
              ETOR= ETMP(11)
              EPRO= ETMP(12)
              ETORBR= ETMP(13)
              ELOOP= ETMP(14)
              EHYDA= ETMP(15)
              DELPHI= ETMP(16)
              EPROT= ETMP(17)
              EDIS= ETMP(18)
              EDIHC= ETMP(19)
              EVIB= ETMP(20)
#ifdef PHCALC
              DO I=1,NPOLRES_TEI
                 OPT_IONZ_EI(I)= ETMP(i+20)
              ENDDO
#endif
************************

              IF (ISTARTRND.EQ.1) THEN
                 IF (NOT_DONE) THEN
                    Tover = .FALSE.
                 ELSE
                    Tover = .TRUE.
C                    write(*,*)'MASTER MAIL, over for Proc',SOURCE
C                    { no more iterations -- tell worker to quit }
                    CGDONE(SOURCE) = .TRUE.
                 ENDIF
#ifdef MPL
                 CALL MP_BSEND(Tover,BOOLSIZE,SOURCE,OVERMSG,MSGID)
#endif
#ifdef MPI
                    CALL MPI_SEND(Tover,IONE,MPI_LOGICAL,SOURCE,
     &                           OVERMSG,MPI_COMM_WORLD,IERR)
                    IF (IERR.NE.0) THEN
                       Write(*,*) '12-Error in MASTER_MAIL' 
!                      call sleep(10)
                    ENDIF
#endif
c                GOTO 4444
              ENDIF

           ELSE IF (MTYPE.EQ.PTURBMSG) THEN
C               { worker wants a perturbed conf for an EDMC run }
              IF (MST.EQ.0) GOTO 4444
C               { mst = 0 means the master isn`t ready to share data }
C               { i.e. it has no accepted conf yet }
#ifdef MPL
              CALL MP_BRECV(DUMMYINT,INTSIZE,SOURCE,PTURBMSG,BRCVD)
#endif
#ifdef MPI
              CALL MPI_RECV(DUMMYINT,1,MPI_INTEGER,SOURCE,PTURBMSG,
     &                 MPI_COMM_WORLD,STATUS,IERR)
                    IF (IERR.NE.0) THEN
                       Write(*,*) '13-Error in MASTER_MAIL' 
!                      call sleep(10)
                    ENDIF
#endif
              IF (NOT_DONE) THEN
C               { there are still iterations to be done }
                 DO I=1,INUMRS
                    Tlist(I) = LIST(I)
                    DO J=1,MAXNUM_DIHE
                       Tangulo(J,I) = ANGULO(J,I) 
                    ENDDO
                 ENDDO
                 Teinit  = EINIT
                 Tiinc   = IINC
                 Tlprhi  = LPRHI
                 Tlchar  = LCHAR
                 CALL PERTURB(Timov,Tover)
#ifdef MPL
                 CALL MP_BSEND(Tover,BOOLSIZE,SOURCE,OVERMSG,MSGID)
#endif
#ifdef MPI
!          call MPI_Type_size ( MPI_LOGICAL,issize,jerr )
!          IF (JERR.NE.0)Write(*,*)'5.5-MP: JERR=',JERR
!          write(*,*)'5-MP: IERR=',IERR,' issize=',issize
                   CALL MPI_SEND(Tover,IONE,MPI_LOGICAL,SOURCE,
     &                               OVERMSG,MPI_COMM_WORLD,IERR)
                    IF (IERR.NE.0) THEN
                       Write(*,*) '14-Error in MASTER_MAIL' 
!                      call sleep(10)
                    ENDIF
#endif
                 IF (Tover) THEN
C                   { perturbation failed, time to quit }
                    NOT_DONE = .FALSE.
                    CGDONE(SOURCE) = .TRUE.
                    GOTO 4444
                 ELSE
C                     { perturbation succeeded -- send to worker }
#ifdef MPL
                    CALL MP_BSEND(LIST,LISTSIZE,SOURCE,LISTMSG,MSGID)
                    CALL MP_BSEND(ANGLES,ANGLESIZE,SOURCE,ANGLEMSG,
     &                          MSGIG)
#endif
#ifdef MPI
                    CALL MPI_SEND(LIST,maxnum_res,MPI_INTEGER,SOURCE,
     &                            LISTMSG,MPI_COMM_WORLD,IERR)
                    IF (IERR.NE.0) THEN
                       Write(*,*) '15-Error in MASTER_MAIL' 
!                      call sleep(10)
                    ENDIF
                    CALL MPI_SEND(ANGLES,(maxnum_dihe*maxnum_res),
     &                           MPI_REAL,SOURCE,ANGLEMSG,
     &                             MPI_COMM_WORLD,IERR)
                    IF (IERR.NE.0) THEN
                       Write(*,*) '16-Error in MASTER_MAIL' 
!                      call sleep(10)
                    ENDIF
#endif
                     DO K=1,DESERTLENGTH
                        DESERT(K) = 0.0D0
                     ENDDO
                  desert(1) = DFLOAT(Timov)
                  desert(2) = DFLOAT(iinc)
                  desert(3) = DFLOAT(lprhi)
                  desert(4) = DFLOAT(lchar)
                    DESERT(5) = einit
                  desert(6) = DBLE(temp)
#ifdef MPL
                    CALL MP_BSEND(DESERT,DESERTSIZE,SOURCE,DESMSG,
     &                           MSGID)
#endif
#ifdef MPI
                    CALL MPI_SEND(DESERT,DESERTLENGTH,
     &                          MPI_DOUBLE_PRECISION,SOURCE,DESMSG,
     &                             MPI_COMM_WORLD,IERR)
#endif
                    IF (IERR.NE.0) THEN
                       Write(*,*) '17-Error in MASTER_MAIL' 
!                      call sleep(10)
                 ENDIF
                   ENDIF
                 DO I=1,INUMRS
                    LIST(I) = Tlist(I)
                    DO J=1,MAXNUM_DIHE
                       ANGULO(J,I) = Tangulo(J,I) 
                    ENDDO
                 ENDDO
                 EINIT = Teinit
                 IINC  = Tiinc
                 LPRHI = Tlprhi
                 LCHAR = Tlchar
              ELSE
C                  { no more iterations -- tell worker to quit }
                 Tover = .TRUE.
#ifdef MPL
                 CALL MP_BSEND(Tover,BOOLSIZE,SOURCE,OVERMSG,MSGID)
#endif
#ifdef MPI
                   CALL MPI_SEND(Tover,IONE,MPI_LOGICAL,SOURCE,
     &                              OVERMSG,MPI_COMM_WORLD,IERR)
                    IF (IERR.NE.0) THEN
                       Write(*,*) '18-Error in MASTER_MAIL' 
!                      call sleep(10)
                    ENDIF
#endif
                 CGDONE(SOURCE) = .TRUE.
                 GOTO 4444
C test                                                     - DR DEC-8-98
                   ISTOP=1
              ENDIF

           ELSE IF (MTYPE.EQ.MAYBE) THEN
C              { worker has possible new conf for an EDMC run }
#ifdef MPL
              CALL MP_BRECV(DUMMYINT,INTSIZE,SOURCE,MAYBE,BRCVD)
#endif
#ifdef MPI
              CALL MPI_RECV(DUMMYINT,1,MPI_INTEGER,SOURCE,MAYBE,
     &              MPI_COMM_WORLD,STATUS,IERR)
                    IF (IERR.NE.0) THEN
                       Write(*,*) '19-Error in MASTER_MAIL' 
!                      call sleep(10)
                    ENDIF
#endif
              DO I=1,INUMRS
                 Tzimmk(I) =ZIMMK(I)
                 Tlist(I) = LIST(I)
                 DO J=1,MAXNUM_DIHE
                    Tangulo(J,I) = ANGULO(J,I) 
                 ENDDO
              ENDDO  
              DO I = 1,NUMVAR
                 Tx(I) = X(I)
              ENDDO
              Teinit   = EINIT
              Tiinc    = IINC
              Tlprhi   = LPRHI
              Tlchar   = LCHAR
              Tt_local = T_LOCAL
              Tnumvar  = NUMVAR              
              Tetot    = ETOT
#ifdef MPL
              CALL MP_BRECV(LIST,LISTSIZE,SOURCE,LISTMSG,BRCVD)
              CALL MP_BRECV(ANGLES,ANGLESIZE,SOURCE,ANGLEMSG,BRCVD)
              CALL MP_BRECV(X,XSIZE,SOURCE,XMSG,BRCVD)
              CALL MP_BRECV(DESERT,DESERTSIZE,SOURCE,DESMSG,BRCVD)
#endif
#ifdef MPI
!                 Write(*,*) 'MASTER_MAIL:receiving LIST' 
!                 call sleep(3)
              CALL MPI_RECV(LIST,maxnum_res,MPI_INTEGER,SOURCE,
     &             LISTMSG,MPI_COMM_WORLD,STATUS,IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '20-Error in MASTER_MAIL' 
!                 call sleep(10)
               ENDIF

!                 Write(*,*) 'MASTER_MAIL:receiving ANGLES' 
!                 call sleep(3)
              CALL MPI_RECV(ANGLES,(maxnum_dihe*maxnum_res),MPI_REAL,
     &             SOURCE,ANGLEMSG,MPI_COMM_WORLD,STATUS,IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '22-Error in MASTER_MAIL' 
!                 call sleep(10)
               ENDIF
!                 Write(*,*) 'MASTER_MAIL:receiving X' 
!                 call sleep(3)
              CALL MPI_RECV(X,maxnum_var,MPI_REAL,SOURCE,XMSG,
     &             MPI_COMM_WORLD,STATUS,IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '23-Error in MASTER_MAIL' 
!                 call sleep(10)
               ENDIF
!                 Write(*,*) 'MASTER_MAIL:receiving DESERT' 
!                 call sleep(3)
              CALL MPI_RECV(DESERT,DESERTLENGTH,MPI_DOUBLE_PRECISION,
     &          SOURCE,DESMSG,MPI_COMM_WORLD,STATUS,IERR)
!              IF (IERR.NE.0) THEN
!                 Write(*,*) '24-Error in MASTER_MAIL' 
!                 Write(*,*) '24-IERR, STATUS', IERR, STATUS
!                 write (*,*)
!    &                'MP: DESERT From ',source,(desert(i),i=1,8)
!                 call sleep(10)
!              ENDIF
#endif
              IMOC     = INT(DESERT(1) + 0.5)
              IINC     = INT(DESERT(2) + 0.5)
              LPRHI    = INT(DESERT(3) + 0.5)
              LCHAR    = INT(DESERT(4) + 0.5)
              EINIT    = DESERT(5)
              T_LOCAL  = DESERT(6)
              NUMVAR   = INT(DESERT(7) + 0.5)
              ETOT     = DESERT(8)
              ICOUNTER(IMOC)=ICOUNTER(IMOC)+1
#ifdef MP
              write (jout,'(a,i4,3a,e12.5,a,f10.1)')
     &            'From ',source,' type ',typ_gen(imoc), ' ETOT ',
     &             etot,' kcal/mole; T= ',t_local
c remove _ for NT, 7-26-99
#ifdef AIX
             call flush_(jout)
#endif
#ifdef WINNT
             call flush(jout)
#endif
#endif
              Tiaccept = METROPOLIS()
               IF (Tiaccept.gt.0) THEN
                  ndone = ndone + 1
C Master put local variables in ETMP array 
C EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA, DELPHI, EPROT, EDIS, EDIHC
                 ETMP(9) = EES
                 ETMP(10) = ENB
                 ETMP(11) = ETOR
                 ETMP(12) = EPRO
                 ETMP(13) = ETORBR
                 ETMP(14) = ELOOP
                 ETMP(15) = EHYDA
                 ETMP(16) = DELPHI
                 ETMP(17) = EPROT
                 ETMP(18) = EDIS
                 ETMP(19) = EDIHC
                 ETMP(20) = EVIB
#ifdef PHCALC
                 DO I=1,NPOLRES_TEI
                    ETMP(I+20) = OPT_IONZ_EI(I)
                 ENDDO
#endif

C ******  ORDER OF THE FOLLOWING INSTRUCTIONS IS IMPORTANT ******* DR JAN/22/98

C At this time, need to generate coordinates for evaluation of constraints and 
C electrostatic predictions.
                 NUK0=NUK
                 CALL ENE_EVAL

C ******  ORDER OF THESE INSTRUCTIONS IS IMPORTANT ******* DR JAN/22/98

C Now master puts variables from slave processor in local commons for printing 
C EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA, DELPHI, EPROT, EDIS, EDIHC, EVIB
C opt_ionz_ei(i)
C get ETOT again because it may have been changed by ENE_EVAL. DR JAN/22/98
                 ETOT= DESERT(8)
                 EES = DESERT(9) 
                 ENB = DESERT(10) 
                 ETOR= DESERT(11) 
                 EPRO= DESERT(12)
                 ETORBR= DESERT(13) 
                 ELOOP= DESERT(14) 
                 EHYDA= DESERT(15) 
                 DELPHI= DESERT(16) 
                 EPROT= DESERT(17) 
                 EDIS= DESERT(18) 
                 EDIHC= DESERT(19)
                 EVIB= DESERT(20)
#ifdef PHCALC
                 DO I=1,NPOLRES_TEI
                    OPT_IONZ_EI(I)= DESERT(I+20) 
                 ENDDO
#endif
                 Tcngeo = .TRUE.
                 WRITE(*,*) 'Accepted conformation from ',source, ETOT
                 WRITE(jout,*) 'Accepted conformation from ',source

                 CALL ACCEPTING(IMOC,Tcngeo)
              ENDIF
               good = (Tiaccept.gt.0)
C  see if conformation has to be added to the clusters.
               if (Tiaccept.ge.0) call add2cluster(good)
c              if (.not. good) then
c                write (jout,'(a)')
c    &           'New conformation not added to any cluster'
c              elseif (nmerged.gt.1) then
c                write (jout,'(a,i5,a)')
c    &           'The following',nmerged,' clusters merged.'
c                write (jout,'(16i5)') (imerged(i),i=1,nmerged)
c              endif
c              if (good) then
c               write (jout,'(a)') 'The ITRACK array:'
c               write (jout,'(8(2i4,2x))') (i,itrack(i),i=1,ngr)
c              endif
c              write (jout,'(a,i4)') 'Current cluster # is',icurrent

               if (onscreen) then
                  if (.not. good) then
c                    write (*,'(a)')
c    &                'New conformation not added to any cluster'
                   elseif (nmerged.gt.1) then
                     write (*,'(a,i5,a)')
     &                'The following',nmerged,' clusters merged.'
                     write (*,'(16i5)') (imerged(i),i=1,nmerged)
                   endif
                   if (good) then
                     write (*,'(a)') 'The ITRACK array:'
                     write (*,'(8(2i4,2x))') (i,itrack(i),i=1,ngr)
                   endif
c                  write (*,'(a,i4)') 'Current cluster # is',icurrent

               endif ! onscreen              
              DO I=1,INUMRS
                 ZIMMK(I) = Tzimmk(I)
                 LIST(I) = Tlist(I)
                 DO J=1,MAXNUM_DIHE
                    ANGULO(J,I) = Tangulo(J,I) 
                 ENDDO
              ENDDO  
              DO I=1, Tnumvar
                 X(I) = Tx(I)
              ENDDO

C ******  ORDER OF THE FOLLOWING INSTRUCTIONS IS IMPORTANT ******* DR JAN/22/98

              lprhi   = Tlprhi
              numvar  = Tnumvar
C Regenerate old coordinates and "hopefully" leave things as they were before 
C the communications with the slave processor. 
              CALL ENE_EVAL
              NUK=NUK0

              ETOT    = Tetot              
              IINC    = Tiinc
              lchar   = Tlchar
              einit   = Teinit
              T_LOCAL = Tt_local
              IF (Tiaccept.EQ.1) THEN
C Master recovers its local variables from ETMP array 
                 EES = ETMP(9)
                 ENB = ETMP(10)
                 ETOR= ETMP(11) 
                 EPRO= ETMP(12)
                 ETORBR= ETMP(13)
                 ELOOP= ETMP(14)
                 EHYDA= ETMP(15)
                 DELPHI= ETMP(16)
                 EPROT= ETMP(17)
                 EDIS= ETMP(18)
                 EDIHC= ETMP(19)
                 EVIB= ETMP(20)
#ifdef PHCALC
                 DO I=1,NPOLRES_TEI
                    OPT_IONZ_EI(I)= ETMP(i+20)
                 ENDDO
#endif
              ENDIF
C ******  ORDER OF PREVIOUS INSTRUCTIONS IS IMPORTANT ******* DR JAN/22/98

C test                                                    - DR DEC-7-98
           ELSE IF (MTYPE.EQ.DONEMSG) THEN
C              { worker has reached  time limit}
#ifdef MPL
              CALL MP_BRECV(DUMMLOG,BOOLSIZE,SOURCE,DONEMSG,BRCVD)
#endif
#ifdef MPI
              CALL MPI_RECV(DUMMLOG,1,MPI_LOGICAL,SOURCE,DONEMSG,
     &              MPI_COMM_WORLD,STATUS,IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '25-Error in MASTER_MAIL' 
!                 call sleep(10)
               ENDIF
#endif
              NOT_DONE = .FALSE.
              CGDONE(SOURCE) = .TRUE.
              DO K=2, CGNUM
                 IF (.NOT.CGDONE(CGLIST(K)))  THEN
                    CALL MPI_SEND(NOT_DONE,1,MPI_LOGICAL,CGLIST(K),
     &                          DONEMSG,MPI_COMM_WORLD,IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '26-Error in MASTER_MAIL' 
!                 call sleep(10)
               ENDIF

                 ENDIF
              ENDDO
              ISTOP=1


           ELSE
               write(*,*)'Unrecognized msg type: MTYPE= ', MTYPE

           ENDIF
#ifdef MPL
           SOURCE = DONTCARE
           MTYPE  = DONTCARE
           CALL MP_PROBE(SOURCE,MTYPE,NBYTES)
#endif
#ifdef MPI
           SOURCE = MPI_ANY_SOURCE
           MTYPE  = MPI_ANY_TAG
           CALL MPI_IPROBE(SOURCE,MTYPE,MPI_COMM_WORLD,FLAG,STATUS,
     & IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '27-Error in MASTER_MAIL' 
!                 call sleep(10)
               ENDIF
#endif
        ENDDO
4444    CONTINUE
        RETURN

        END


C ====================================================================
C ====================================================================
        SUBROUTINE SLAVE_MAIL
C  In this subroutine, the SLAVE probes for a msg from the
C Master telling him to finish.

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
        include 'PARAMET.MP'
        include 'COMMON.MP'
        include 'COMMON.EDMC'
        include 'COMMON.TIME1'
        logical isdone,ovrtim

#ifdef MPL
        INTEGER  NBYTES
        CALL MP_PROBE(MASTER,DONEMSG,NBYTES)
        IF (NBYTES.NE.-1) THEN
           CALL MP_BRECV(ISDONE,BOOLSIZE,MASTER,DONEMSG,BRCVD)
           NOT_DONE = .FALSE.
        ENDIF

#endif
#ifdef MPI
        include 'mpif.h'
        INTEGER IERR, STATUS(MPI_STATUS_SIZE)
        LOGICAL FLAG

        CALL MPI_IPROBE(MASTER,DONEMSG,MPI_COMM_WORLD,FLAG,STATUS,IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '1-Error in SLAVE_MAIL' 
!                 call sleep(10)
               ENDIF
        IF (FLAG) THEN 
           CALL MPI_RECV(ISDONE,1,MPI_LOGICAL,MASTER,DONEMSG,
     &                MPI_COMM_WORLD,STATUS,IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '2-Error in SLAVE_MAIL' 
!                 call sleep(10)
               ENDIF
           NOT_DONE = .FALSE.
        ENDIF
#endif

        IF ( NOT_DONE ) THEN
           IF ( OVRTIM() )THEN
              ISTOP=1
              NOT_DONE = .FALSE.
              CALL MPI_SEND(.TRUE.,1,MPI_LOGICAL,MASTER,DONEMSG,
     &                          MPI_COMM_WORLD,IERR)
               IF (IERR.NE.0) THEN
                  Write(*,*) '3-Error in SLAVE_MAIL' 
!                 call sleep(10)
               ENDIF
           ENDIF
        ENDIF
        RETURN
        END
