C
      SUBROUTINE MINTASK(ISEQ,ICOUNTS)
C driver routine for MINIMZATION AND VTF calculation.   
C                                          Written by    DR.   JAN95
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
#ifdef MP
      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'
      LOGICAL OVER
      DOUBLE PRECISION ETMP(100)
#endif
#ifdef MPI
      INCLUDE 'mpif.h'
      INTEGER IERR, STATUS(MPI_STATUS_SIZE)
#endif
      INCLUDE 'COMMON.ODONNELL'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GRID'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.KASOS'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.EXTPH'
      INCLUDE 'COMMON.VIBRAT'
#ifdef PHCALC
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.ATOMSS'
      REAL EXCOORD(3,maxnum_atoms)
      COMMON/EXPCOR/EXCOORD
      INCLUDE 'param.ibems'
      INCLUDE 'ecepp_ibems_intrf.h'
#endif

      INTEGER Index, NIN
      CHARACTER*3 NUMM
      CHARACTER*64 CFF,OLD_PREFIX
      LOGICAL END_OF_FILE,OVRTIM,YourOwn
      LOGICAL LCHG,LADDC
      LOGICAL FAIL,FAILM,FAILVTF
      LOGICAL FAILVIBENTR, FAILS
      DIMENSION URPARM(1)
      
      DATA IONE /1/, IZERO /0/,ITREIN /30/, IPUTC /-1/
C
#ifdef PKSR
      INCLUDE 'COMMON.PARRAY'
C
#endif
C
      NUK=0
      FAILM=.FALSE.
      FAILVTF=.FALSE.
      FAILS=.FALSE.
      FAILVIBENTR=.FALSE.
      VIBCOM=0.0D0
      NDONE= 0
      NPASS= 0
#ifdef MP
      OVER=.FALSE.
      DO I = 0, maxnum_track
        IAMMIN(I) = 0
      ENDDO
      IAMCON = 0
      NextOut = 1
      DO I=1,100
        ETMP(I)=0.0D0
      ENDDO
#endif
#ifdef PKSR
C This is for the parallel version, only.
      IF(ISEQ.NE.0) THEN
         CALL KSRINIT(ISEQ)

C Initialization of list array should be done here!
         DO J=1,INUMRS
            LIST(J)=LIST0(J)
         ENDDO

         KASO=1
         IF (ICUTOFF.NE.1) KASO=0
         CALL SETUP_X(IZERO)
      ENDIF
#endif
C
C***********************************
C THIS CODE IS FOR A SET OF INPUT CONFORMATIONS
C***********************************
 
C        write(*,*) 'CGNUM ', CGNUM
C       DO K=2, CGNUM
C        write(*,*) 'CGDONE (', CGLIST(K),')=',
C    &                CGDONE(CGLIST(K))
C       ENDDO

      IF (READCONFS) THEN
         write(jout,'(a)')'Reading "input" conformations'
         END_OF_FILE=.FALSE.
C
         RT = rboltz * 298.0
         NPASS = 0
         DO WHILE (NOT_DONE)
            FAIL=.FALSE.
#ifdef PKSR
C DONE IN PARALLEL.
            CALL PTHREAD_MUTEX_LOCK(IMUTEX,ISTAT)

            IF (ISTAT.NE.0) WRITE(JOUT,*) IDLEADER,
     +     'MINTASK1: Return from  mutex_lock = ',ISTAT

            WRITE(JOUT,*) 'Idleader ', IDLEADER, 'starting now'
#endif

#ifdef MP
            IF (TASKID.EQ.MASTER) THEN
#endif
               IF ( OVRTIM() ) THEN
                  WRITE (JOUT,'(/80(1H*)/10X,a/80(1H*)/)')
     &            'Time up. Finishing  & exiting MINTASK ... '
C
#ifdef PKSR
                  WRITE(JOUT,*) 'idleader ', IDLEADER, ' is leaving! '
#endif
                  NOT_DONE = .FALSE.
                  GOTO 4000
               END IF
#ifdef MP
               CALL MASTER_MAIL
            END IF
#endif
C =====================================================================
            YourOwn = .TRUE.
50          CALL READANG(END_OF_FILE,IOLDNUM, OLDENER,YourOwn) 
C =====================================================================
            IF (END_OF_FILE) THEN
             
!           WRITE(*,*)'Proc(',TASKID,') GOT END_OF_FILE ',END_OF_FILE
               NOT_DONE = .FALSE.
               WRITE(JOUT,'(/80(1H*)/10x,a/80(1H*))')
     &                    'All iterations done.'
               GOTO 4000
            ELSE
               CALL SETUP_X(IZERO)
#ifdef PKSR
CCKSR       write(jout,*)'PROCESSOR ',idleader,' going into minimization'
            CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
            IF (ISTAT.NE.0) WRITE(JOUT,*) IDLEADER,
     +       'MINTASK2: Return from  mutex_unlock = ',ISTAT
#endif
            ENDIF

C Parallel

C =====================================================================
!    #ifdef MP
!                  IF (TASKID.EQ.MASTER) THEN
!                     CALL MASTER_MAIL
!                  ENDIF
!    #endif
C =====================================================================

            IF ( (IRUNTYP .EQ. 1) .OR. (IRUNTYP .EQ. 3)) THEN
               IF (IRUNTYP .EQ. 1) CALL ENE_EVAL
               FAILM=.FALSE.
               IF (IRUNTYP .EQ. 3) CALL ENER_MINIM(FAIL)
               IF(FAIL) FAILM=.TRUE.

CHECK IF ETOT IS LOWER THAN ANY SPECIFIED CUTOFF ENERGY. 
               IF ((.NOT.FAIL).AND. (ETOT.GT. ETHRESH)) THEN
                  WRITE(JOUT,'(A10,I5,2X,A28,E10.3,A30,E10.3,A1)')
     &            'CONF. No. ',IOLDNUM,' was discarded. ENERGY ( ',
     &            OLDENER, ' ) > ETHRESH ( ', ETHRESH , ')'
                  GOTO 4000
               ENDIF
! Calculate conformational entropy contribution to the free energy
               IF ((.NOT.FAIL).AND.LFREE_ENE) THEN
                  write(*,*)' now computing the vibrational term'
                  FAILVIBENTR=.FALSE.
                  EVIB=0.0D0
                  CALL VIBENTR(0,VIBCOM,FAIL)
                   IF (FAIL) THEN
                     FAILVIBENTR=.TRUE.
                     write(jout,'(a10,i5,2x,a50)')
     &                'CONF. No. (old) ',IOLDNUM,
     &                ' is discarded. Free energy calculation failed.'
                   ELSE
                     EVIB=VIBCOM
                     ETOT=ETOT + EVIB
                   ENDIF
               ENDIF

#ifdef PHCALC
C 2/15/95 YV, DR & AL and Compute the average degree of ionization, if required.
               EPROT=0.0D0
               DELPHI=0.0D0
               IF ((PHS.GT.0.0).AND.(.NOT.FAIL)) THEN
                  FAILS=.FALSE.
                  CALL PROTONATION(FAIL)
                  IF(FAIL) FAILS=.TRUE.
               ENDIF
#endif

            ELSE IF (IRUNTYP .EQ. 7) THEN
               IF (.NOT.NOMINIM) THEN
                  FAILVTF=.FALSE.
                  CALL DO_VTF(FAIL)
                  IF(FAIL) FAILVTF=.TRUE.
               ENDIF
C  Calculate energies at final point and produce detailed output.
               CALL ENE_EVAL
            ENDIF 
C
#ifdef PKSR
            CALL PTHREAD_MUTEX_LOCK (IMUTEX,ISTAT)
#endif
            IF (.NOT.FAIL) THEN
               NPASS= NPASS+1

               WRITE(JOUT,248)IOLDNUM
C PRINT UNSATISFIED DISTANCE CONSTRAINTS
               NUKCO=1
               IF (WITHCNST) CALL DISPRT
               IF (DIHECNST) CALL CONST_DIEH(NUMVAR,X)
               NUKCO=0

C PRINT  ANGLES
               CALL DRUANG(JOUT,IOLDNUM)
#ifdef MP
               IF (TASKID.EQ.MASTER) THEN

                  DO I=1,INUMRS
                     Tlist(I) = LIST(I)
                     DO J=1,MAXNUM_DIHE
                        Tangulo(J,I) = ANGULO(J,I) 
                     ENDDO
                  ENDDO
                  Tioldnum = IOLDNUM
                  Tiamcon  = MYCON
C Master put local variables in ETMP array
C EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA, DELPHI, EPROT, EDIS, EDIHC
                  ETMP(8) =  ETOT
                  ETMP(9) =  EES
                  ETMP(10) = ENB
                  ETMP(11) = ETOR
                  ETMP(12) = EPRO
                  ETMP(13) = ETORBR
                  ETMP(14) = ELOOP
                  ETMP(15) = EHYDA
                  ETMP(16) = DELPHI
                  ETMP(17) = EPROT
                  ETMP(18) = EDIS
                  ETMP(19) = EDIHC
                  ETMP(20) = EVIB
#ifdef PHCALC
                  DO I=1,NPOLRES_TEI
                     ETMP(I+20) = OPT_IONZ_EI(I)
                  ENDDO
#endif

!                 ITSKFLG(MASTER)=.FALSE.
!        WRITE(*,*) 'CONF_CALC: (',TASKID,') OUT Conformation ',MYCON
                  CALL SORT_OUT(IOLDNUM,NDONE,.FALSE.)

                  DO I=1,INUMRS
                     LIST(I) = Tlist(I)
                     DO J=1,MAXNUM_DIHE
                        ANGULO(J,I) = Tangulo(J,I) 
                     ENDDO
                  ENDDO
                  IOLDNUM = Tioldnum
                  MYCON   = Tiamcon
************************
C Master recovers its local variables from ETMP array
                  ETOT = ETMP(8)
                  EES = ETMP(9)
                  ENB = ETMP(10)
                  ETOR= ETMP(11)
                  EPRO= ETMP(12)
                  ETORBR= ETMP(13)
                  ELOOP= ETMP(14)
                  EHYDA= ETMP(15)
                  DELPHI= ETMP(16)
                  EPROT= ETMP(17)
                  EDIS= ETMP(18)
                  EDIHC= ETMP(19)
                  EVIB= ETMP(20)
#ifdef PHCALC
                  DO I=1,NPOLRES_TEI
                     OPT_IONZ_EI(I)= ETMP(i+20)
                  ENDDO
#endif
               ELSE
                  DESERT(5) = IOLDNUM
                  DESERT(6) = MYCON
                  DESERT(8)= ETOT 
                  DESERT(9)=EES 
                  DESERT(10)=ENB 
                  DESERT(11)=ETOR 
                  DESERT(12)=EPRO 
                  DESERT(13)=ETORBR 
                  DESERT(14)=ELOOP 
                  DESERT(15)=EHYDA 
                  DESERT(16)=DELPHI 
                  DESERT(17)=EPROT 
                  DESERT(18)=EDIS 
                  DESERT(19)=EDIHC 
                  DESERT(20)=EVIB 
#ifdef PHCALC
                  DO I=1,NPOLRES_TEI
                     DESERT(i+20) = OPT_IONZ_EI(I)
                  ENDDO
#endif

C              write (*,*) 'Send IOLD=',IOLDNUM,'  ETOT=',DESERT(1)

#else
               NDONE=NDONE+1
               JCONFIN(NDONE)=IOLDNUM
               CALL DRUANG(JANG,IOLDNUM)
               IF(LFREE_ENE) THEN
                  ETOTT(NDONE)=ETOT-EVIB
                  ENEFREE(NDONE)=ETOT 
               ENDIF
#endif
#ifdef MPL
                  CALL SLAVE_MAIL
                  CALL MP_BSEND(TASKID,INTSIZE,MASTER,OUTMSG,
     &                             MSGID)
                  CALL MP_BSEND(LIST,LISTSIZE,MASTER,LISTMSG,
     &                             MSGID)
                  CALL MP_BSEND(ANGLES,ANGLESIZE,MASTER,ANGLEMSG,
     &                             MSGID)
                  CALL MP_BSEND(DESERT,DESERTSIZE,MASTER,DESMSG,
     &                             MSGID)
               ENDIF
#endif
#ifdef MPI
                  CALL SLAVE_MAIL
                  CALL MPI_SEND(TASKID,1,MPI_INTEGER,MASTER,OUTMSG,
     &                              MPI_COMM_WORLD,IERR)
                  CALL MPI_SEND(LIST,maxnum_res,MPI_INTEGER,MASTER,
     &                              LISTMSG,MPI_COMM_WORLD,IERR)
                  CALL MPI_SEND(ANGLES,(maxnum_dihe*maxnum_res),
     &                              MPI_REAL,MASTER,ANGLEMSG,
     &                              MPI_COMM_WORLD,IERR)
                  CALL MPI_SEND(DESERT,DESERTLENGTH,
     &                              MPI_DOUBLE_PRECISION,MASTER,DESMSG,
     &                              MPI_COMM_WORLD,IERR)
               ENDIF
#endif
C PRINT  ENERGY COMPONENTS
               CALL ENEPRINT
#ifdef PHCALC
               IF ((PRINT).OR. (OUTSURF) ) THEN
#else 
               IF (PRINT)  THEN
#endif
#ifdef MP
                  CALL NUMSTR(MYCON,NUMM)
#else 
                  CALL NUMSTR(NDONE,NUMM)
#endif
#ifdef PHCALC
                  IF (OUTSURF) THEN
                     NATMS=NPRE(INUMRS+1)
                     DO ij=1,NATMS
                         DO k=1,3
                             COORD(K,IJ)=EXCOORD(K,IJ)
                         ENDDO
                     ENDDO
                     CALL CONCAT(PSURF,NUMM,CFF)
                     CALL CONCAT(CFF,'.surf',PSURFIL)
                     CALL PRINSUR(PSURFIL)
                  ENDIF
#endif
                  CALL CONCAT(COORPREF,NUMM,CFF)
                  OLD_PREFIX=COORPREF
                  COORPREF=CFF
                  CALL OUTNW(IZERO,ITREIN,IOLDNUM)
                  COORPREF=OLD_PREFIX
               ENDIF  
               IF (REFCOD) THEN
                  CALL PLACE
                  WRITE (JOUT,'(/A)') 
     &              'ZIMMERMAN CODE of this conformation is:'
                  WRITE (JOUT,80) (ZIMMK(J), J=2, INUMRS-1)
80                FORMAT(20(A2,1X))
               ENDIF
C Write restart information.
               CURTIM=TCPU()
               IF (IRUNTYP .EQ. 7) THEN
C        	  CALL ITER_OVTF
                  WRITE (JOUT,100) CURTIM,TIMLIM,ndone,CURTIM-BATIME
                  IF (ONSCREEN) THEN
                    WRITE (*,100) CURTIM,TIMLIM,ndone,CURTIM-BATIME
                  ENDIF
                  BATIME=CURTIM
 100  FORMAT(/'*** Elapsed time so far:',E15.4,' seconds of ',E15.4,
     &          ' seconds ***'/
     &        '****** Time for iteration',I4,' was ',F11.2,
     &          ' seconds ******'/)

#ifdef MP
		  WRITE(JOUT,110) MYCON+1
#else 
		  WRITE(JOUT,110) NDONE+1
#endif
               ENDIF
               IF (CURTIM-PREVTIM.GE.BACKUP) THEN
C                 print *,'Calling SAVER.'
                  CALL SAVER
                  PREVTIM=CURTIM
               ENDIF
            ELSE
               IF(FAILM) WRITE(JOUT,*) 'Minimization for conformation ',
     &            IOLDNUM, 'failed.'
               IF(FAILS) WRITE(JOUT,*) 'Calculation of the Solvation ', 
     &            'Energy for conformation ',IOLDNUM, 'failed.'
               IF(FAILVTF) WRITE(JOUT,*) 'VTF calculation for ',
     &            'iteration ',IOLDNUM, ' failed.'
               IF(FAILVIBENTR) WRITE(JOUT,*) 'Calculation of ',
     &          'the Conformational Entropy for ',IOLDNUM, ' failed.'
#ifdef MP
! ITSKFLG NOT necessary for master with this instruction
               IF (TASKID.EQ.MASTER) THEN
                WRITE(*,*) 'CONF_CALC: MASTER ELIMINATES ',MYCON
                  CALL SORT_OUT(IOLDNUM,NDONE,.TRUE.)
               ENDIF
#endif
            ENDIF

4000        CONTINUE

#ifdef PKSR
            COUNTS(IDLEADER+1)=NCOUN+ COUNTS(IDLEADER+1)
            CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
#else
            CALL CLOSE_APP(JOUT,OUTFILE)
            ICOUNTS=NCOUN+ICOUNTS
#endif
            NCOUN=0
         ENDDO

         IF (((IRUNTYP .EQ. 1) .OR. (IRUNTYP .EQ. 3) ) .AND.
     &                                      (NPASS.EQ.0)) THEN
           WRITE(JOUT,'(A)') 'No conformation within specified range'
         ENDIF
C Initial Conformations will be generated randomly.

C***********************************
C THIS CODE IS FOR RANDOM GENERATION
C***********************************
C
      ELSEIF (ISTARTRND.EQ.1) THEN
#ifdef MP
         LMYCON=0
#endif
C Initial Conformations will be generated randomly.
C      write(*,*) 'RANDOM GENERATION '
	 WRITE(JOUT,'(/A/)')
     &  'MINIMIZATIONS from randomly generated conformations'

         DO WHILE (NOT_DONE)
            FAIL=.FALSE.
C
#ifdef PKSR
            CALL PTHREAD_MUTEX_LOCK(IMUTEX,ISTAT)

            IF (ISTAT.NE.0) WRITE(JOUT,*) IDLEADER,
     +        'MINTASK: Return from  mutex_lock = ',istat
            WRITE(JOUT,*) 'idleader ', IDLEADER, 'starting now'
#endif

C*******************************************
C   Each process should check the total run time here!
#ifdef MP
            IF (TASKID.EQ.MASTER) THEN
#endif
            IF ( OVRTIM() ) THEN
                WRITE (JOUT,'(/80(1H*)/10X,a/80(1H*)/)')
     &         'Time up. Finishing  & exiting mintask ... ' 
C
#ifdef PKSR
           WRITE(JOUT,*) 'Idleader ', IDLEADER, ' is leaving! '
#endif

                NOT_DONE = .FALSE.
                GOTO 5000
            END IF
#ifdef MP
            END IF
#endif

            IF (NDONE .LT. LICZM) THEN
C    ndone defines the no. of vtf iterations performed.
C Generate a random conformation.

               IF (EXCPRH.LT.1.0 .AND. LOGICPH) THEN
C   We have HIS or PRO and we attempt to change ring conformations.
C   PRO-UP to PRO-DOWN and viceversa, or HID to HIE and viceversa.
                 LCHG=.FALSE.
                 RNDX=RNUNF(1)
                 IF (RNDX.GT.EXCPRH) THEN
                   LPHINT= LPRHI
                   CALL CHISPRO(LCHG)
C   If there was a change in HIS or PRO then an extra change in a dihedral
C   angle could be added (for 0.5 < RNDX < 0.75  LADDC is .TRUE.).
                   IF ( LCHG  .AND.  (RNDX.GT.0.5*(1.0+EXCPRH)) )
     &               LADDC=.FALSE.
                   IF ( LCHG ) write(jout,'(A/A,i8,A,i8)')
     &              'HIS-PRO CHANGE: ',' OLD LPRHI= ',LPHINT,
     &               ' NEW LPRHI= ',LPRHI
                 ENDIF
               ENDIF

               DO I=1,INUMRS
                  CALL RANGUX(I)
               ENDDO
               DO I=1,NUMVAR
                 NDX=INDXV(I)
                 ANGL0=ANGLES(NDX)
                 IF ( (ABS(ANGL0).GT.1.0E+10) ) THEN
                    WRITE (*,*)'ERROR MINTASK: ANGLES(',NDX,') ',
     &                                        DEG*ANGL0
                 END IF

                 ANGL0=PINORM(ANGL0)
                 IF (OMEG180) THEN
                    CALL NDX_DECODE(NDX,IRRR,IANGU)
                    IF (IANGU.EQ.3)  THEN
c                      WRITE(*,*) 'omega(3,',IRRR,') set to 180'
                       ANGL0=PI
                    ENDIF
                 ENDIF
                 ANGLES(NDX)=ANGL0
                 VAR(I)=ANGL0
               ENDDO
#ifdef PKSR
CCKSR       WRITE(JOUT,*)'PROCESSOR ',idleader,' going into minimization'
               Call Pthread_mutex_unlock (imutex,istat)
               if (istat.ne.0) write(jout,*) Idleader,
     +           'MINTASK: Return from  mutex_unlock = ',istat
#endif

            ELSE
#ifdef MP
             IF (TASKID.EQ.MASTER) THEN
#endif
               NOT_DONE = .FALSE.
cKSR           write(jout,*)'PROCESSOR ',idleader,' THE WORK IS DONE '
               write(jout,'(/80(1h*)/10X,A/80(1h*))') 
     &                      'All iterations done.' 
               GOTO 5000
               ENDIF
#ifdef MP
             ENDIF
#endif
C    ***************************************************

C Parallel, when possible
            IF ((IRUNTYP .EQ. 1) .OR. (IRUNTYP .EQ. 3)) THEN
               IF (IRUNTYP .EQ. 1) THEN
C  Calculate  energy.
                  CALL ENE_EVAL
               ELSE
C                  WRITE (JOUT,*) 'Calling ENER_MINIM for ',
C    &                                 ' conformation: ',  ndone+1
C energy minimization
                  FAILM=.FALSE.
                  CALL ENER_MINIM(FAIL)
                  IF(FAIL) FAILM=.TRUE.
               ENDIF
! Calculate conformational entropy contribution to the free energy
               IF ((.NOT.FAIL).AND.LFREE_ENE) THEN
                  write(*,*)' now computing the vibrational term'
                  FAILVIBENTR=.FALSE.
                  EVIB=0.0D0
                  CALL VIBENTR(0,VIBCOM,FAIL)
                   IF (FAIL) THEN
                     FAILVIBENTR=.TRUE.
                     write(jout,'(a10,i5,2x,a50)')
     &                'CONF. No. (old) ',IOLDNUM,
     &                ' is discarded. Free energy calculation failed.'
                   ELSE
                     EVIB=VIBCOM
                     ETOT=ETOT + EVIB
                   ENDIF
               ENDIF

#ifdef PHCALC
C 2/15/95 YV, DR & AL and Compute the average degree of ionization, if required.
               EPROT=0.0D0
               DELPHI=0.0D0
               IF ((PHS.GT.0.0).AND.(.NOT.FAIL)) THEN
                  FAILS=.FALSE.
                  CALL PROTONATION(FAIL)
                  IF(FAIL) FAILS=.TRUE.
               ENDIF
#endif

            ELSE IF (IRUNTYP .EQ. 7) THEN
C Now perform the VTF procedure (in parallel, if processors are available).
               IF (.NOT.NOMINIM) THEN
C               WRITE (JOUT,*) 'Calling DO_VTF for conformation: ',
C    &                                    NDONE+1
                  FAILVTF=.FALSE.
                  CALL DO_VTF(FAIL)
                  IF(FAIL) FAILVTF=.TRUE.
               ENDIF
C  Calculate energies at final point and produce detailed output.
               IF (.NOT.FAIL) CALL ENE_EVAL

            ENDIF 
C
#ifdef PKSR
            CALL PTHREAD_MUTEX_LOCK (IMUTEX,ISTAT)
            IF (ISTAT.NE.0) WRITE(JOUT,*) IDLEADER,
     +         'MINTASK: Return from  mutex_lock = ',istat
#endif
C
            NPASS= NPASS+1
            IF (.NOT.FAIL .AND. NOT_DONE) THEN

               IF (ETOT.GT. ETHRESH) THEN
                  write(jout,'(a10,i5,2x,a28,e10.3,a30,e10.3,a1)')
     &             'CONF. No. ',NPASS+1,' was discarded. ENERGY ( ',
     &              ETOT, ' ) > ETHRESH ( ', ETHRESH , ')'
#ifndef MP
                  GOTO 5000
#endif
               ELSE
#ifdef MP
                  LMYCON=LMYCON+1
                  WRITE(JOUT,248)LMYCON
#else
                  NDONE=NDONE+1
                  WRITE(JOUT,248)NDONE
#endif
C PRINT UNSATISFIED DISTANCE CONSTRAINTS
                  NUKCO=1
                  IF (WITHCNST) CALL DISPRT
                  IF (DIHECNST) CALL CONST_DIEH(NUMVAR,X)
                  NUKCO=0
C PRINT  ANGLES
#ifdef MP
                  CALL DRUANG(JOUT,LMYCON)
#else
                  JCONFIN(NDONE)=IOLDNUM
                  CALL DRUANG(JOUT,NDONE)
                  CALL DRUANG(JANG,NDONE)
#endif
               ENDIF

#ifdef MP
               IF (TASKID.EQ.MASTER) THEN
                  IF (ETOT.GT. ETHRESH) GOTO 5000

                  DO I=1,INUMRS
                     Tlist(I) = LIST(I)
                     DO J=1,MAXNUM_DIHE
                        Tangulo(J,I) = ANGULO(J,I)
                     ENDDO
                  ENDDO
                  IOLDNUM = IPUTC
                  Tiamcon  = LMYCON
C Master put local variables in ETMP array
C EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA, DELPHI, EPROT, EDIS, EDIHC
                  ETMP(8) =  ETOT
                  ETMP(9) =  EES
                  ETMP(10) = ENB
                  ETMP(11) = ETOR
                  ETMP(12) = EPRO
                  ETMP(13) = ETORBR
                  ETMP(14) = ELOOP
                  ETMP(15) = EHYDA
                  ETMP(16) = DELPHI
                  ETMP(17) = EPROT
                  ETMP(18) = EDIS
                  ETMP(19) = EDIHC
                  ETMP(20) = EVIB
#ifdef PHCALC
                  DO I=1,NPOLRES_TEI
                     ETMP(I+20) = OPT_IONZ_EI(I)
                  ENDDO
#endif

               WRITE(*,*) 'CONF_CALC: 3-OUT Conformation ',MYCON
                  CALL SORT_OUT(IOLDNUM,NDONE,.FALSE.)
C                  write (*,*) 'NDONE= ', NDONE

                  DO I=1,INUMRS
                     LIST(I) = Tlist(I)
                     DO J=1,MAXNUM_DIHE
                        ANGULO(J,I) = Tangulo(J,I)
                     ENDDO
                  ENDDO
                  LMYCON   = Tiamcon
C Master recovers its local variables from ETMP array
                  ETOT = ETMP(8)
                  EES = ETMP(9)
                  ENB = ETMP(10)
                  ETOR= ETMP(11)
                  EPRO= ETMP(12)
                  ETORBR= ETMP(13)
                  ELOOP= ETMP(14)
                  EHYDA= ETMP(15)
                  DELPHI= ETMP(16)
                  EPROT= ETMP(17)
                  EDIS= ETMP(18)
                  EDIHC= ETMP(19)
                  EVIB= ETMP(20)  
#ifdef PHCALC
                  DO I=1,NPOLRES_TEI
                     OPT_IONZ_EI(I)= ETMP(i+20)
                  ENDDO
#endif
               ELSE
                  DESERT(5) = 1.0D0*(IPUTC-0.5D0)
                  DESERT(6) = LMYCON
                  DESERT(8)= ETOT
                  DESERT(9)=EES
                  DESERT(10)=ENB
                  DESERT(11)=ETOR
                  DESERT(12)=EPRO
                  DESERT(13)=ETORBR
                  DESERT(14)=ELOOP
                  DESERT(15)=EHYDA
                  DESERT(16)=DELPHI
                  DESERT(17)=EPROT
                  DESERT(18)=EDIS
                  DESERT(19)=EDIHC
                  DESERT(20)=EVIB
#ifdef PHCALC
                  DO I=1,NPOLRES_TEI
                     DESERT(i+20) = OPT_IONZ_EI(I)
                  ENDDO
#endif

C              write (*,*) 'Send IOLD=',DESERT(5),'  ETOT=',DESERT(1)

#else
                  IF(LFREE_ENE) THEN
!Vibrational entropy calculation
                     ETOTT(NDONE)=ETOT-EVIB
                     ENEFREE(NDONE)=ETOT 
                  ENDIF
#endif
#ifdef MPL
                  CALL SLAVE_MAIL
                  CALL MP_BSEND(TASKID,INTSIZE,MASTER,OUTMSG,
     &                              MSGID)
                  CALL MP_BSEND(LIST,LISTSIZE,MASTER,LISTMSG,
     &                              MSGID)
                  CALL MP_BSEND(ANGLES,ANGLESIZE,MASTER,ANGLEMSG,
     &                              MSGID)
                  CALL MP_BSEND(DESERT,DESERTSIZE,MASTER,DESMSG,
     &                              MSGID)
                  CALL MP_BRECV(OVER,BOOLSIZE,MASTER,OVERMSG,BRCVD)
#endif
#ifdef MPI
                  CALL SLAVE_MAIL
                  CALL MPI_SEND(TASKID,1,MPI_INTEGER,MASTER,OUTMSG,
     &                              MPI_COMM_WORLD,IERR)
                  CALL MPI_SEND(LIST,maxnum_res,MPI_INTEGER,MASTER,
     &                              LISTMSG,MPI_COMM_WORLD,IERR)
                  CALL MPI_SEND(ANGLES,(maxnum_dihe*maxnum_res),
     &                              MPI_REAL,MASTER,ANGLEMSG,
     &                              MPI_COMM_WORLD,IERR)
                  CALL MPI_SEND(DESERT,DESERTLENGTH,
     &                              MPI_DOUBLE_PRECISION,MASTER,DESMSG,
     &                              MPI_COMM_WORLD,IERR)
                  CALL MPI_RECV(OVER,1,MPI_LOGICAL,MASTER,OVERMSG,
     &                              MPI_COMM_WORLD,STATUS,IERR)
#endif
#ifdef MP
                  IF (OVER)  THEN
                    write (*,*) ' '
                    write (*,*) taskid,' PROCESSOR FORCED TO EXIT TASK'
                    NOT_DONE=.FALSE.
                    GOTO 5000
                  ENDIF
                  
                  IF (ETOT.GT. ETHRESH) GOTO 5000
               ENDIF
#endif
C PRINT  ENERGY COMPONENTS
               CALL ENEPRINT
#ifdef PHCALC
               IF ((PRINT).OR. (OUTSURF) ) THEN
#else 
               IF (PRINT)  THEN
#endif
#ifdef MP
                  CALL NUMSTR(LMYCON,NUMM)
#else
                  CALL NUMSTR(NDONE,NUMM)
#endif
#ifdef PHCALC
                  IF (OUTSURF) THEN
                     NATMS=NPRE(INUMRS+1)
                     DO ij=1,NATMS
                        DO k=1,3
                            COORD(K,IJ)=EXCOORD(K,IJ) 
                        ENDDO
                     ENDDO
                     CALL CONCAT(PSURF,NUMM,CFF)
                     CALL CONCAT(CFF,'.surf',PSURFIL)
                     CALL PRINSUR(PSURFIL)
                  ENDIF
#endif
                  CALL CONCAT(COORPREF,NUMM,CFF)
                  OLD_PREFIX=COORPREF
                  COORPREF=CFF
#ifdef MP
                  CALL OUTNW(IZERO,ITREIN,LMYCON)
#else
                  CALL OUTNW(IZERO,ITREIN,NDONE)
#endif
                  COORPREF=OLD_PREFIX
               ENDIF
               IF (REFCOD) THEN
                  CALL PLACE
                  WRITE (JOUT,'(/A)') 
     &              'ZIMMERMAN CODE of this conformation is: '
                  WRITE (JOUT,80) (ZIMMK(J), J=2, INUMRS-1)
                  do i=2, inumrs-1
                     if(zimmk(I).ne. zimmre(i) ) goto 4990
                  enddo
                  write(jout,'(a)')
     &               'Conformation with same CODE as REFERENCE '
4990              continue
               ENDIF
               IF (IRUNTYP .EQ. 7) THEN
C                 CALL ITER_OVTF
                  CURTIM=TCPU()
#ifdef MP
                  WRITE (JOUT,100) CURTIM,TIMLIM,LMYCON,CURTIM-BATIME
                  IF (ONSCREEN) THEN
                    WRITE (*,100) CURTIM,TIMLIM,LMYCON,CURTIM-BATIME
                  ENDIF
                  WRITE(JOUT,110) LMYCON+1
#else
                  WRITE (JOUT,100) CURTIM,TIMLIM,NDONE,CURTIM-BATIME
                  IF (ONSCREEN) THEN
                    WRITE (*,100) CURTIM,TIMLIM,NDONE,CURTIM-BATIME
                  ENDIF
                  IF (NDONE .LT. LICZM) WRITE(JOUT,110) NDONE+1
#endif
                  BATIME=CURTIM
               ENDIF
C PRINT  ANGLES
C Write restart information
               IF (CURTIM-PREVTIM.GE.BACKUP) THEN
#ifdef MP
                  IF (TASKID.EQ.MASTER) CALL SAVER
#else
                  CALL SAVER
#endif
                  PREVTIM=CURTIM
               ENDIF
            ELSE IF (FAIL) THEN
#ifdef MP
               LPRNUM= LMYCON+1
#else
               LPRNUM= NDONE+1
#endif
               IF(FAILM) WRITE(JOUT,*) 'Minimization for conformation ',
     &            LPRNUM, ' failed.'
c              IF(FAILVTF) WRITE(*,*) 'VTF calculation for ',
c    &            'conformation ',LPRNUM, ' failed.'
               IF(FAILVIBENTR) WRITE(*,*) 'Config. Entropy calculation',
     &            ' for conformation ',LPRNUM, ' failed.'
            ELSE
#ifdef MP
                WRITE(JOUT,*) 'Processor (',taskid,
     &            ') Ending after conformation ',LMYCON+1
#else
                WRITE(JOUT,*) 'Ending after conformation ',NDONE+1
#endif

            ENDIF

5000        CONTINUE
            ICOUNTS = ICOUNTS + NCOUN
            NCOUN=0

#ifdef PKSR
C ADD the No. of energy evaluations performed during energy minimization
C to the total for this processor.
            COUNTS(IDLEADER+1)=NCOUN+ COUNTS(IDLEADER+1)
            CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
            IF (ISTAT.NE.0) WRITE(JOUT,*) IDLEADER,
     +        'MINTASK: Return from mutex_unlock = ',istat
#else
            CALL CLOSE_APP(JOUT,OUTFILE)
            ICOUNTS=NCOUN+ICOUNTS
#endif
            NCOUN=0


         ENDDO

      ELSE
#ifdef PKSR
         call pthread_mutex_lock(imutex,istat)
         if (istat.ne.0) write(jout,*) Idleader,
     +     'MINTASK: Return from mutex_unlock = ',istat
#endif
             WRITE(JOUT,'(A)')'Unrecognized option in MINTASK'
#ifdef PKSR
         Call Pthread_mutex_unlock (imutex,istat)
         if (istat.ne.0) write(jout,*) Idleader,
     +     'MINTASK: Return from mutex_unlock = ',istat
#endif

      END IF

C Modified STOPX here for Parallel version!
      CURTIM=TCPU()
C ================================================================

#ifdef MP
      IF (TASKID.EQ.MASTER) THEN
#endif
      IF(ISTOP.EQ.0) THEN
         IF (READCONFS)   THEN 
            IF ( OVRTIM() )   THEN 
               CALL SAVER
               ISTOP=1
            ENDIF
         ELSE
            ISTOP=1
            IF ( OVRTIM() )  CALL SAVER
         ENDIF
      ENDIF
#ifdef MP
C       write(*,*) 'CGNUM ', CGNUM
        DO K=2, CGNUM
C        write(*,*) 'CGDONE (', CGLIST(K),')=',
C    &                CGDONE(CGLIST(K))
        ENDDO
        FINISHED = .TRUE.
        DO K=2, CGNUM
          IF (.NOT.CGDONE(CGLIST(K))) THEN
             FINISHED = .FALSE.
             write(*,*) 'STILL out is processor ', CGLIST(K)
          ENDIF
        ENDDO
        DO WHILE (.NOT.FINISHED)
          CALL MASTER_MAIL
          FINISHED = .TRUE.
          DO K=2, CGNUM
            IF (.NOT.CGDONE(CGLIST(K))) FINISHED = .FALSE.
          ENDDO
        ENDDO
      ENDIF
#endif
#ifdef MP
      IF (TASKID.EQ.MASTER) THEN
#endif
         IF (LFREE_ENE) THEN
            EMIN=ENEFREE(1)
            DO I=2,NDONE
               IF (ENEFREE(I).LT.EMIN) EMIN=ENEFREE(I)
            ENDDO
            FREE_ENE = 0.0
            ENE_AVE = 0.0
            DO I=1,NDONE
               EI = ENEFREE(I) - EMIN
               ETOTI = ETOTT(I)
               FREE_ENE = FREE_ENE + EXP (-EI/RT)
               ENE_AVE = ENE_AVE + ETOTI*EXP (-EI/RT)
            ENDDO
            ENE_AVE = ENE_AVE / FREE_ENE
            FREE_ENE = EMIN-ALOG (FREE_ENE) * RT
            WRITE (JOUT,'(/80(1H*)/a,e15.4,a,e15.4,a,e15.4)')
     &       'FREE ENERGY OF THE CONFORMATIONAL ENSEMBLE',FREE_ENE,
     &       ' AVERAGE ENERGY',ENE_AVE,' ENTROPY',
     &       (ENE_AVE - FREE_ENE)/298.0
         ENDIF
#ifdef MP
      ENDIF
#endif

C     WRITE(*,*) ' GOING OUT OF MINTASK'
C ===================================================================
      RETURN 
110   FORMAT('***********************************************'/
     &       '        Beginning iteration #',I4/
     &       '***********************************************')
248   FORMAT(//' RESULTS FOR INITIAL CONFORMATION No. ',i5 )

      END
      SUBROUTINE CONF_CALC
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
#ifdef MP
      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'
      LOGICAL  Te_o_f
      INTEGER  NUMB, TOTS, ICnts, STATS
#endif
#ifdef MPL
      EXTERNAL I_VADD
#endif
#ifdef MPI
      include 'mpif.h'
      INTEGER IERR, STATUS(MPI_STATUS_SIZE)
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.ODONNELL'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.GRID'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.EXTPH'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.XBOUNDX'
      include 'COMMON.SOLVAT'
      include 'COMMON.ATOMSS'
      REAL EXCOORD(3,MAXNUM_ATOMS)
      COMMON/EXPCOR/EXCOORD
      CHARACTER*3 NUMM
      CHARACTER*64 HISFILE
      CHARACTER*64 SPDBFIL
      CHARACTER*64 CFF,OLD_PREFIX
      CHARACTER*64 PSURFIL
      DATA IONE /1/, IZERO /0/,ITREIN /30/
      LOGICAL FAIL,FAILM,FAILS,FAILVIBENTR
C
#ifdef PKSR
C
      INCLUDE 'COMMON.PARRAY'
      DO M=1, NCELLS
         COUNTS(M)=0
      ENDDO
#else

      ICOUNTS=0
#endif
      FAIL=.FALSE.
      FAILS=.FALSE.

C Setup printing parameters and open files.
      NUK=0  

C Now do the job
      IF (N1.GT.0 .OR. N2.GT.0) THEN
C Phi-Psi map
        CALL MAP(ICOUNTS)
C       RETURN 

      ELSE IF ((.NOT.READCONFS).AND.(ISTARTRND.NE.1) ) THEN
C Energy or energy minimization of a single conformation.

        IF (IRUNTYP .EQ. 1) THEN
          NUK=0
C  Energy evaluation.
          CALL ENE_EVAL
C PRINT  ANGLES
#ifdef PKSR
          CALL PTHREAD_MUTEX_LOCK (IMUTEX,ISTAT)
#endif
          WRITE(JOUT,248) IONE
C PRINT UNSATISFIED DISTANCE CONSTRAINTS
          NUKCO=1  
          IF (WITHCNST) CALL DISPRT
          IF (DIHECNST) CALL CONST_DIEH(NUMVAR,X)
          NUKCO=0  
          CALL DRUANG(JOUT,IONE)
C PRINT  ENERGY COMPONENTS
          CALL ENEPRINT
          IF (PRINT) CALL OUTNW(IZERO,ITREIN,IONE)
#ifdef PKSR
          CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
          COUNTS(IDLEADER+1)=NCOUN+ COUNTS(IDLEADER+1)
#else
          ICOUNTS=NCOUN+ICOUNTS
#endif
        ELSE
          NUK=0
C  Energy minimization calculation.

          CALL ENE_EVAL
C PRINT  ANGLES
#ifdef PKSR
          CALL PTHREAD_MUTEX_LOCK (IMUTEX,ISTAT)
#endif
C         WRITE (*,'(/A)') 'CALLING  DRUANG '
          WRITE(JOUT,248)IZERO
          CALL DRUANG(JOUT,IONE)
C PRINT  ENERGY COMPONENTS
C         WRITE (*,'(/A)') 'CALLING  ENEPRINT '
          CALL ENEPRINT
#ifdef PKSR
          CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
#endif

C CARRY OUT THE ACTUAL ENERGY MINIMIZATION
C         WRITE (*,'(/A)') 'CALLING ENERGY-MINIMIZATION '
          FAILM=.FALSE.
          CALL ENER_MINIM(FAIL)
          IF(FAIL) FAILM=.TRUE.
! Calculate conformational entropy contribution to the free energy
          IF ((.NOT.FAIL).AND.LFREE_ENE) THEN
             EVIB=0.0D0
             CALL VIBENTR(0,VIBCOM,FAIL)
              IF (.NOT.FAIL) THEN
                FAILVIBENTR=.FALSE.
                EVIB=VIBCOM
                ETOT=ETOT + EVIB
             ELSE
                WRITE(JOUT,'(A10,I5,2X,A50)')
     &           'CONF. No. (old) ',IOLDNUM,
     &           ' is discarded. Free energy calculation failed.'
                FAILVIBENTR=.TRUE.
             ENDIF
          ENDIf

#ifdef PHCALC
C 2/15/95 YV, DR & AL and Compute the average degree of ionization, if required.
          EPROT=0.0D0
          DELPHI=0.0D0
          IF ((PHS.GT.0.0).AND.(.NOT.FAIL)) THEN
             FAILS=.FALSE.
             CALL PROTONATION(FAIL)
             IF(FAIL) FAILS=.TRUE.
          ENDIF
#endif

C PRINT  ANGLES
#ifdef PKSR
          CALL PTHREAD_MUTEX_LOCK (IMUTEX,ISTAT)
#endif
          IF ( .NOT.FAIL ) THEN
             WRITE(JOUT,248)IZERO
C PRINT UNSATISFIED DISTANCE CONSTRAINTS
             NUKCO=1
             IF (WITHCNST) CALL DISPRT
             IF (DIHECNST) CALL CONST_DIEH(NUMVAR,X)
             NUKCO=0
             CALL DRUANG(JOUT,IONE)
             CALL DRUANG(JANG,IONE)
C PRINT  ENERGY COMPONENTS
             CALL ENEPRINT


#ifdef PHCALC
               IF ((PRINT).OR. (OUTSURF) ) THEN
#else 
               IF (PRINT)  THEN
#endif
                CALL OUTNW(IZERO,ITREIN,IONE)
#ifdef PHCALC
                IF (OUTSURF) THEN
                   NATMS=NPRE(INUMRS+1)
                   DO IJ=1,NATMS
                      DO K=1,3
                         COORD(K,IJ)=EXCOORD(K,IJ)
                      ENDDO
                   ENDDO
                   CALL CONCAT(PSURF,'.surf',PSURFIL)
                   CALL PRINSUR(PSURFIL)
                ENDIF
#endif
             ENDIF
#ifdef PKSR
             CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
             COUNTS(IDLEADER+1)=NCOUN+ COUNTS(IDLEADER+1)
#else
             ICOUNTS=NCOUN+ICOUNTS
#endif
             NCOUN=0
          ELSE
            IF(FAILM) WRITE(JOUT,*)'Minimization of conformation ',
     &            'failed.'
            IF(FAILS) WRITE(JOUT,*) 'Calculation of the electrostatic ',
     &          ' contribution to the free energy of Solvation failed.'
            IF(FAILVIBENTR) WRITE(JOUT) 
     &                          'Config. Entropy calculation failed' 
          ENDIF
        ENDIF
        IF ( .NOT.FAIL .AND. REFCOD) THEN
C         WRITE (*,'(/A)') 'CALLING PLACE '
          CALL PLACE
          WRITE (JOUT,'(/A)') 
     &    'ZIMMERMAN CODE of this conformation is:'
          WRITE (JOUT,80) (ZIMMK(J), J=2, INUMRS-1)
80        FORMAT(20(A2,1X))
        ENDIF
      ELSE
C Energy evaluation or minimization of multiple conformations.
C
        PREVTIM=TCPU()
        IF (RESTART) THEN
          CALL GETOLD
          WRITE (JOUT,'(/80(1H*)/10X,A,I4,/)')
     &   'Restarting the MINIMIZATION procedure from iteration',NDONE+1
          NDOLD=NDONE
        ELSE
          IAMCON=0
          NDONE=0
        ENDIF 
        NOT_DONE=.TRUE.
#ifdef PKSR
C Generate other threads.
        CALL EDMC_PSTART
C         WRITE(jout,'(A40)') 'FINISHED call to pstart'
#endif
C
        ISEQ=0
C

#ifdef PKSR
C
C  Check in to the barrier
        CALL PTHREAD_BARRIER_CHECKIN (BARRIER_ID, ISEQ, ISTAT)
        IF (ISTAT .NE. 0) CALL OBITUARY
     &       ('1 Couldn''t check in to the  barrier', ISEQ)
#endif
C
C  Execute the code
        CALL MINTASK(ISEQ,ICOUNTS)
C       write (*,*) 'EXITING MINTASK!!'

 
#ifdef PKSR
C  Check out of the barrier
        CALL PTHREAD_BARRIER_CHECKOUT(BARRIER_ID, ISEQ, ISTAT)
        IF (ISTAT .NE. 0) THEN
            CALL OBITUARY ('2 Couldn''t check out of the barrier',
     $              ISEQ)
        ENDIF
#endif
      ENDIF

#ifdef PKSR
      EVALS = 0
      DO 192 M=1, NCELLS
        EVALS= EVALS + COUNTS(M)
192   CONTINUE
      CALL PTHREAD_MUTEX_LOCK (IMUTEX,ISTAT)
#endif

#ifdef MPL
      itimepr= int(tcpu())
C     write (*,*) 'ICOUNTS = ', ICOUNTS
C     write (*,*) 'into reduce'
      CALL MP_REDUCE(ICOUNTS,TotalCounts,INTSIZE,MASTER,I_VADD,CGID)
      CALL MP_REDUCE(itimepr,TotalTime,INTSIZE,MASTER,I_VADD,CGID)
#endif
#ifdef MPI
      itimepr= int(tcpu())
      CALL MPI_REDUCE(ICOUNTS,TotalCounts,1,MPI_INTEGER,MPI_SUM,
     & MASTER,MPI_COMM_WORLD,IERR)
      CALL MPI_REDUCE(itimepr,TotalTime,1,MPI_INTEGER,MPI_SUM,
     & MASTER,MPI_COMM_WORLD,IERR)
      IF (TASKID.EQ.MASTER.AND.(IERR.EQ.0)) write (*,*) 'out reduce'
#endif
#ifdef MP
      IF (TASKID.EQ.MASTER) THEN
!       write (*,*) 'TotalCounts = ', TotalCounts
!       write (*,*) 'TotalTime = ', TotalTime
!       write (*,*) 'time_in_master = ', itimepr
        TotalEvals = float(TotalCounts)
        TotalE_P_S = TotalEvals/tcpu()
        Average_time= float(TotalTime)/float(numtasks)
        WRITE (JOUT,'(2(/a,e12.5/))')
     &   ' Everybody''s evals = ', TotalEvals,
     &   ' Evals per sec (evals/time_in_master_processor) = ',
     &     TotalE_P_S
        write(jout,'(2(/a,e12.5/))')
     &   ' Everybody''s time = ',  float(Totaltime),
     &   ' Average Time per Processor = ', Average_time
      ENDIF
#else
      EVALS= FLOAT(ICOUNTS)
      EVAL_PER_SEC= EVALS/TCPU()
      WRITE (JOUT,'(2(/a,e12.5/))')
     &' Total Number of Energy Evals. = ', EVALS,
     &'Energy Evals. per sec = ', EVAL_PER_SEC
#endif
C ================================================================

#ifdef PKSR
        CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
#endif

      IF (PRINT.AND. ( (IFORM.EQ.3).OR. (IFORM.EQ.6)) ) CLOSE(ITREIN)
C     NUK=0  
C
248   FORMAT(//' Conf. No. ',i5 )
C
      RETURN 
      END
