      SUBROUTINE DEGIONZ
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.MYCONF'
      include 'COMMON.LIST0'
      INCLUDE 'COMMON.EXTPH'
C Interface to IMEMS
      include 'param.ibems'
      include 'ecepp_ibems_intrf.h'
      DATA IOUT /20/, IONE /1/

C    INITIALIZATION OF LIST0
      NIONZ = 0
C THE DEGREE OF IONIZATION OF THE END GROUPS IS NOW CONSIDERED. DR JUN17_93
C NON-IONIZABLE  END GROUPS AT THE AMINO-END ARE SET IN INIT_LRESI 
      ILIST= ABS( LIST(1) )         
      IF((ILIST.EQ.1).OR.(ILIST.EQ.2)) THEN  ! amino-H2 or amino-H3+
         LIST0(1)=1                          ! set to amino-H2
         LIST(1)= 1
         NIONZ = NIONZ + 1
      ELSE IF((ILIST.EQ.6).OR.(ILIST.EQ.7)) THEN ! amino-H2 followed by PRO
         LIST0(1)=LIST(1)                   ! set to amino-H2
         NIONZ = NIONZ + 1
      ELSE IF(ILIST.EQ.8) THEN    ! amino-H3 followed by PRO
C IN THIS CASE THE USER IS GIVING A CHARGED END GROUP AS INPUT;
C WE HAVE TWO POSSIBILITIES: NEUTRAL CIS OR NEUTRAL TRANS
C LET'S THROW A COIN!
         CALL VRND(IRAN1,IONE)
         RNDS=IRAN1/FCTOR
         IF(RNDS .LE. 0.5) THEN
              LIST0(1)=6       ! set to cis-H-PROLINE
         ELSE
              LIST0(1)=7      ! set to  trans-H-PROLINE
         ENDIF
         LIST(1)=LIST0(1)
         NIONZ = NIONZ + 1

      ENDIF 
   
C NON-IONIZABLE RESIDUES ARE SET IN INIT_LRESI 
      DO 23 JJ=2, INUMRS-1
         ILIST= ABS( LIST(JJ) )         
C NOW LET'S SEE IF THIS IS AN "L" OR "D" RESIDUE
         ISIGNO=ISIGN(1, LIST(JJ) )
         IF(ISIGNO.LT.0) THEN
         WRITE(IOUT,*)'SIGN OF LIST(',JJ,')=',ISIGNO
         END IF
         IF((ILIST.EQ.2).OR.(ILIST.EQ.31)) THEN !aspartic acid or aspartate
             LIST0(JJ)=ISIGNO*2       ! set to aspartic acid 
             LIST(JJ)=LIST0(JJ)
             NIONZ = NIONZ + 1
         ELSE IF((ILIST.EQ.4).OR.(ILIST.EQ.32)) THEN    ! glutamate
             LIST0(JJ)=ISIGNO*4       ! set to glutamic acid 
             LIST(JJ)=LIST0(JJ)
             NIONZ = NIONZ + 1
         ELSE IF((ILIST.EQ.7).OR.(ILIST.EQ.25)) THEN    ! histidine D or E
             LIST0(JJ)=LIST(JJ)
             NIONZ = NIONZ + 1
         ELSE IF(ILIST.EQ.28) THEN    ! histidine plus 
C IN THIS CASE THE USER IS GIVING A CHARGED HISTIDINE AS INPUT;
C WE HAVE TWO POSSIBILITIES: WE REPLACE IT WITH A NEUTRAL HID OR HIE
C LET'S THROW A COIN AGAIN!
             CALL VRND(IRAN1,IONE)
             RNDS=IRAN1/FCTOR
             IF(RNDS .LE. 0.5) THEN
                 LIST0(JJ)=ISIGNO*7       ! set to histidine HID 
             ELSE 
                 LIST0(JJ)=ISIGNO*25      ! set to histidine HIE 
             ENDIF 
             LIST(JJ)=LIST0(JJ)
             NIONZ = NIONZ + 1
         ELSE IF((ILIST.EQ.9).OR.(ILIST.EQ.29)) THEN    ! charged lysine 
             LIST0(JJ)=ISIGNO*9       ! set to uncharged lysine
             LIST(JJ)=LIST0(JJ)
             NIONZ = NIONZ + 1
         ELSE IF((ILIST.EQ.15).OR.(ILIST.EQ.30)) THEN    ! charged arginine 
             LIST0(JJ)=ISIGNO*15      ! set to uncharged arginine 
             LIST(JJ)=LIST0(JJ)
             NIONZ = NIONZ + 1
         ELSE IF((ILIST.EQ.20).OR.(ILIST.EQ.36)) THEN    ! charged tyrosine 
             LIST0(JJ)=ISIGNO*20      ! set to uncharged tyrosine 
             LIST(JJ)=LIST0(JJ)
             NIONZ = NIONZ + 1
         ELSE IF((ILIST.EQ.24).OR.(ILIST.EQ.27)) THEN    ! charged ornithine 
             LIST0(JJ)=ISIGNO*24      ! set to uncharged ornithine 
             LIST(JJ)=LIST0(JJ)
             NIONZ = NIONZ + 1
C RESIDUES WITH NMETHYL groups are missing
         ENDIF 
23    CONTINUE
C NOW CHECK FOR AN IONIZABLE GROUP AT THE CARBOXYL-END
C NON-IONIZABLE  END GROUPS AT THE CARBOXYL-END ARE SET IN INIT_LRESI 
      ILIST= ABS( LIST(INUMRS) )         
      IF((ILIST.EQ.11).OR.(ILIST.EQ.12)) THEN ! carboxyl-COOH or carboxyl-CO(-)
         LIST0(INUMRS)=11                     ! set to carboxyl-COOH
         LIST(INUMRS)= 11
         NIONZ = NIONZ + 1
      ENDIF
c NOW DETERMINE THE NUMBER OF POSSIBLE IONIZED STATES FOR THE WHOLE CHAIN
      IMS= 2**NIONZ
      WRITE(IOUT, 1118) NIONZ, IMS
1118  FORMAT(' No. IONIZABLE GROUPS (INCLUDING END GROUPS)', I2,/,
     &   'No. OF POSSIBLE IONIZED STATES=', I15)

      RETURN
      END
