      SUBROUTINE  CONST_DIEH(N,X)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.NNDRUK'
      DIMENSION X(N)
      
C     WRITE(JOUT,*) 'NDIHCO, NUMVAR ', NDIHCO, NUMVAR
      IF (NUKCO.EQ.1) THEN
         WRITE(JOUT,*) 'DIHEDRAL-ANGLE CONSTRAINTS: '
         WRITE(JOUT,'(a47,a31)')
     &   'Residue Dihedral   Mean-Val   Delta  Actual_Val',
     &   '    Const. Energy   Satisfied? '
      END IF
      PI_E=1.01*PI
      SWAPI=1.0*DWAPI
C Feng Ni, loop through all constraints
      TORC= 0.0
      DO I=1,NDIHCO
        NRESI = IDCN(1,I)
C Feng Ni, ECEPP numbering always includes end groups.
C This is for printing purposes, only.
        NRR1=NRESI
        IF(NUMB_PDB) NRR1=NRR1-1
        NANGI = IDCN(2,I)
C       WRITE(JOUT,'(a,2i4,2e12.5)') 'NRESI, NANGI, DCN(1,I), DCN(2,I)',
C    &                  NRR1, NANGI, DCN(1,I), DCN(2,I) 
        
c       INDX= (NRESI-1)*maxnum_dihe + NDXARR(NANGI,NRESI)
        INDX= (NRESI-1)*maxnum_dihe + NANGI
        DMED = DCN(1,I)*RAD
        IF ( (ABS(DMED).GT.1.0E+10)  ) THEN
           WRITE (*,*)'ERROR CONST_DIEH: DMED ',DEG*DMED 
        END IF

        DMED = PINORM( DMED)
        DDEL = DCN(2,I)*RAD
        IF ( (ABS(DDEL).GT.1.0E+10)  ) THEN
           WRITE (*,*)'ERROR CONST_DIEH: DDEL ',DEG*DDEL 
        END IF
        DDEL = PINORM(DDEL)
        DHUP=DMED + DDEL
        DHUP = PINORM(DHUP)
        DHLW=DMED - DDEL
        DHLW = PINORM(DHLW)
C Feng Ni, weight given in kcal/mol/degree^2 is converted to kcal/mol/radian^2.
        WEDH=WEDIH(I)*DEG*DEG
C       WRITE(JOUT,'(a,i4,2e12.5)') 'INDX, DMED, DDEL', INDX, DMED, DDEL
C Feng Ni, for each constraint, pick up the corresponding dihedral angle.
        DTERC=0.0
        DO J=1,NUMVAR
          IF (INDX.EQ.INDXV(J) ) THEN
             XJ=PINORM( X(J))
             IF(ABS(XJ).GT. PI_E) THEN
               WRITE(*,*) 'ERROR CONST_DIEH: BAD X(',J,')= ', XJ
               STOP 4646
             ENDIF
C Feng Ni, the following is Daniel's new implementation
             DLTXJ= XJ-DMED 
             DLTXJ= PINORM(DLTXJ)
             IF ( ABS(DLTXJ).GT.ABS(DDEL) ) THEN 
C Daniel's implementations:
C                DTERC=DLTXJ*DLTXJ*WEDH
C Feng Ni, new squared-well:
C The following transformations should take care of the following situations:
C   (1) DMED ~ pi and DMED+DDEL=DHUP>pi
C   (2) DMED ~-pi and DMED-DDEL=DHLW<-pi
                DXUP=XJ-DHUP
                DXUP=PINORM(DXUP)
                DXLW=XJ-DHLW
                DXLW=PINORM(DXLW)
                IF (DXUP.GT.0.0) THEN
                    TERXJ = DXUP
                ELSE IF (DXLW.LT.0.0) THEN
                    TERXJ = DXLW
                ELSE
                    TERXJ = 0.0
                END IF
                DTERC=TERXJ*TERXJ*WEDH
C Daniel
                IF (DTERC.LT.0.0) THEN
                  WRITE(JOUT,*)'ERROR: NEGATIVE DIHEDRAL TERM ', 
     & ' ON CONSTRAINT= ',I,' RESIDUE ',NRR1,' DIHEDRAL',NANGI
                ENDIF
C Daniel's implementation
C                TORC= TORC+ DTERC
                IF (NUKCO.EQ.1) THEN
                  WRITE(JOUT,1000)NRR1,NANGI,DCN(1,I),
     &             ABS(DDEL)*DEG,XJ*DEG,DTERC*WEITORC*0.5,'      NO '
1000             FORMAT(i4,6x,i2,5x,3(f8.3,2x),5x,e12.5,a9)
                END IF
             ELSE
                IF (NUKCO.EQ.1) THEN
                  WRITE(JOUT,1100)NRR1,NANGI,DCN(1,I),
     &               ABS(DDEL)*DEG,XJ*DEG, '      YES'
1100             FORMAT(i4,6x,i2,5x,3(f8.3,2x),17x,a9)
                END IF
             END IF
          END IF
C Daniel's previous implmentation
C          EDIHC=TORC*WEITORC
        ENDDO
C Feng Ni
        TORC= TORC+ DTERC
      ENDDO
C Feng Ni, the factor 1/2 included to conform to ECEPP/DG and ECEPP/MC
C conventions.  See also gradconx.
      EDIHC=0.5*TORC*WEITORC

      RETURN
      END

      SUBROUTINE  GRADCONX(N,X,G)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.XBOUNDX'
      REAL X(N), G(N)
    
      PI_E=1.01*PI
      SWAPI=1.0*DWAPI
C
      DO I=1,NDIHCO
        NRESI=IDCN(1,I)
        NANGI=IDCN(2,I)
        INDX= (NRESI-1)*maxnum_dihe + NANGI
        DMED = DCN(1,I)*RAD
        IF ( (ABS(DMED).GT.1.0E+10)  ) THEN
           WRITE (*,*)'ERROR GRADCONX: DMED ',DEG*DMED 
        END IF
        DMED=PINORM(DMED)
        DDEL=DCN(2,I)*RAD
        IF ( (ABS(DDEL).GT.1.0E+10)  ) THEN
           WRITE (*,*)'ERROR GRADCONX: DDEL ',DEG*DDEL
        END IF
        DDEL = PINORM(DDEL)
        DHUP=DMED + DDEL
        DHUP = PINORM(DHUP)
        DHLW=DMED - DDEL
        DHLW = PINORM(DHLW)
C Feng Ni, weight given in kcal/mol/degree^2 is converted to kcal/mol/radian^2.
        WEDH2=WEITORC*WEDIH(I)*DEG*DEG
        DO J=1,NUMVAR
          IF (INDX.EQ.INDXV(J)) THEN
             XJ=PINORM(X(J))
             IF(ABS(XJ).GT.PI_E) THEN
               WRITE(*,*)'ERROR GRADCONX: BAD X(',J,')= ', XJ
               STOP 4646
             ENDIF
C             WRITE (*,*)' X(',J,')= ',X(J),'(',DEG*X(J),')' 
C Feng Ni, the following is Daniel's new implementation
             DLTXJ=XJ-DMED 
             DLTXJ=PINORM(DLTXJ)
             IF (ABS(DLTXJ).GT.DDEL) THEN 
C                GTJ= 2.0*DLTXJ*WEDH2
C Feng Ni, the factor of 2 removed to conform to the conventions of ECEPP/DG
C and ECEPP/MC.  See also const_dieh.
C
C Daniel's implementation:
C                GTJ= DLTXJ*WEDH2
C Daniel Ripoll
C Feng Ni, new squared-well:
C The following transformations should take care of the following situations:
C   (1) DMED ~ pi and DMED+DDEL=DHUP>pi
C   (2) DMED ~-pi and DMED-DDEL=DHLW<-pi
                DXUP=XJ-DHUP
                DXUP=PINORM(DXUP)
                DXLW=XJ-DHLW
                DXLW=PINORM(DXLW)
                IF (DXUP.GT.0.0) THEN
                   TERXJ = DXUP
                ELSE IF (DXLW.LT.0.0) THEN
                   TERXJ = DXLW
                ELSE
                   TERXJ = 0.0
                END IF
                GTJ= TERXJ*WEDH2
C Feng Ni
C                IF ( (ABS(GTJ).GT.1.0E+5)  ) THEN
C                   WRITE (*,*)' X(',J,')= ',X(J),'(',DEG*X(J),')' 
C                   WRITE(*,*)'GRADCONX: LARGE G Component- G= ' 
C     &              ,G(J),' GTJ=',GTJ
C                   WRITE (*,*) ' DLTXJ =',DLTXJ
C                END IF
                G(J)= G(J)+GTJ 
             END IF
          END IF
        ENDDO
      ENDDO
      RETURN
      END
