C $Date: 1996/11/11 22:11:44 $
C $Revision: 3.4 $
C
C
C
      FUNCTION ALAM2(I)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.PEPT'
      IF (I.LT.NRES1) THEN
        RL2=ANGLAM(GAMA(I+2)-RRL(I)-PI)
      ELSE
        RL2=RRL(I)
      ENDIF
      ALAM2=RL2
      RETURN
      END
C**********************
      SUBROUTINE BANACH(N,AA,X)
C**********************
C     Banachiewicz
*     IMPLICIT REAL*8 (A-H,O-Z)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER (NMAX=3*maxnum_res)
      DIMENSION AA(NMAX,NMAX),X(NMAX),D(NMAX)
      COMMON /BANII/ D
      D(1)=1./AA(1,1)
      DO 80 I=2,N
      AA(I,1)=AA(1,I)
      DO 81 J=2,I-1
      XX=AA(J,I)
      DO 82 K=1,J-1
      XX=XX-AA(I,K)*AA(J,K)
   82 CONTINUE
      AA(I,J)=XX
   81 CONTINUE
      XX=AA(I,I)
      JJJJ=I-1
      DO 83 J=1,JJJJ
      AIJ=AA(I,J)
      AIJD=AIJ*D(J)
      AA(I,J)=AIJD
      XX=XX-AIJ*AIJD
   83 CONTINUE 
      D(I)=1./XX
   80 CONTINUE
C
      CALL BANAII(N,AA,X)
      RETURN
      END
C************************
      SUBROUTINE BANAII(N,AA,X)
C************************
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
*     IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NMAX=3*maxnum_res)
      DIMENSION AA(NMAX,NMAX),X(NMAX),D(NMAX)
      COMMON /BANII/ D
      DO 90 I=1,N
      Z=X(I)
      JJJJ=I-1
      DO 91 J=JJJJ,1,-1
      Z=Z-AA(I,J)*X(J)
   91 CONTINUE
      X(I)=Z
   90 CONTINUE
      DO 92 I=N,1,-1
      Z=X(I)*D(I)
      JJJJ=I+1
      DO 93 J=JJJJ,N
      Z=Z-AA(J,I)*X(J)
   93 CONTINUE
      X(I)=Z
   92 CONTINUE
      RETURN
      END
C
      subroutine analatm(nre1,at1,nre2,at2,num,loc,grpflg) 
C  THIS ROUTINE FIGURES OUT FROM THE LABEL OF THE ATOM IF THE BOUND IS 
C ASSOCIATED WITH A GROUP OF OVERLAPPING RESONANCE OR IF IT BELONGS 
C TO A STANDARD TYPE OF BOUND.
C THE ROUTINE WILL CALL CLASS TO OBTAIN ECEPP NUMBERS AND NUMBER OF
C ATOMS (NUM) WITH THE SAME LABEL
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.XBOUNDX'
      character*4 at1,at2,atmp
      dimension  num(2),loc(50,2),loctmp(50)
      logical lgr1,lgr2,grpflg
C FIRST CHECK IF LABELS CORRESPOND TO DEFINITION OF OVERLAPPING RESONANCES.
C     write(*,'(a)') 'IN ANALATM'
      lgr1=.false.
      lgr2=.false.
      grpflg=.false.
      if (nre1.le.igroupNum) then
C          write(*,*) 'groupName ',groupname(nre1)
	  if(at1.eq.groupname(nre1) ) then
            lgr1=.true.
          endif
      endif
      if (nre2.le.igroupNum) then
C          write(*,*) 'groupName ',groupname(nre2)
	  if (at2.eq.groupname(nre2) ) then
            lgr2=.true.
          endif
      endif

      if(lgr1.and.lgr2) then
C OVERLAPPING RESONANCES.
         grpflg=.true.
         num(1)=0
         do i=1,numOfsites(nre1)
            ires=iresNum(i,nre1)
            atmp=atomName(i,nre1)
c           write(*,*) 'call class1 with: ires,atmp',ires,atmp
            call class(ires,atmp,num1,loctmp(1))
            do j=1,num1
               loc(num(1)+j,1)=loctmp(j)
            enddo
            num(1)=num(1)+num1
         enddo
C        write(*,*) groupname(nre2), 'numOfsites= ',
C    &       numOfsites(nre2)
C      write(*,'(10i4)') (iresNum(l,nre2), l=1,numOfsites(nre2))
C      write(*,'(10a4)') (atomName(l,nre2),l=1,numOfsites(nre2))
         num(2)=0
         num1=0
         do i=1,numOfsites(nre2)
            ires=iresNum(i,nre2)
            atmp=atomName(i,nre2)
c           write(*,*) 'call class2 with: ires,atmp',ires,atmp
            call class(ires,atmp,num1,loctmp(1))
            do j=1,num1
              loc(num(2)+j,2)=loctmp(j)
            enddo
            num(2)=num(2)+num1
         enddo
      elseif ( (.not.lgr1).and.(.not.lgr2) ) then
C DEFINITION IS A STANDARD DISTANCE CONSTRAINT.
C  CHECK FIRST ATOM.
c        write(*,*) 'call class3 with: nre1,at1',nre1,at1
         call class(nre1,at1,num(1),loc(1,1))
C  CHECK SECOND ATOM.
c        write(*,*) 'call class4 with: nre2,at2',nre2,at2
         call class(nre2,at2,num(2),loc(1,2))
      else
         write(jout,'(4a)') 'ERROR IN ANALATM: only one of the label',
     & ' corresponds to definition of overlapping resonances ',at1,at2
      endif

      return
      end
      SUBROUTINE CLASS (N1, AT1, NUM, LOC)
C
C  THIS ROUTINE FIGURES OUT ECEPP NUMBERS FROM RESIDUE NUMBERS AND
C  ATOM TYPES. IT MAY FAIL IF YOU PUSH YOUR LUCK.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.XBOUNDX'
      CHARACTER*4 AT1
      DIMENSION  LOC(50)
      LOGICAL LFOUND

C     write(*,'(a)') 'IN CLASS'
      LFOUND=.FALSE.
      NUM = 0
C THIS IS USED WHEN SEQUENCE IS NUMBERED ACCORDING WITH FULL RESIDUES ORDER
      IF(NUMB_PDB) THEN
         JRES = IABS(LIST(N1+1))
         NP1 = NPRE(N1+1)
         NP2 = NPRE(N1+2)
      ELSE
C THIS IS FOR ECEPP SEQUENCE NUMBERING. 
         JRES = IABS(LIST(N1))
         NP1 = NPRE(N1)
         NP2 = NPRE(N1+1)
      ENDIF
      NUMAT=NP2-NP1
C     WRITE (*,7070) N1,AT1,JRES,NUMAT
C     WRITE (JOUT,7070) N1,AT1,JRES,NUMAT
7070  FORMAT('CLASS: N1= ',I4,' AT1= ',A4,' RES No= ',I4,' NUMAT= ',I2)
      IF (AT1(1:1).NE.'H') THEN
      write(*,'(3a,i4)') ' CONSTRAINT involves a NON-hydrogen atom ', 
     &                  AT1, ' in residue ', N1 
C Non-Hydrogen atom.
        NUM = 1
        DO J=1,NUMAT
           JATO=NP1+J
           IF (AT1(1:3).EQ.ALPH(JATO)) THEN
              NUM = 1
              LOC(1) = NP1 + J
              RETURN
           ENDIF
        ENDDO

      ELSE
C     write(*,'(3a)') 'atom= ', AT1, ' is a hydrogen atom.'
C     write(*,'(a,3i4)') ' JRES ',JRES, NUMH(JRES), NUMALTH(JRES)
C Hydrogen atom.
c  Look first for usual name of H.
        NUMHRES =  NUMH(JRES)
        NUMHTOT= NUMHRES + NUMALTH(JRES)
	
C       DO I=1,NUMHTOT
C          write(*,'(a,10i4)') nameh(i,jres),numgrh(i,jres),
C    &       (ihnum(l,i,jres), l=1,numgrh(i,jres) ),
C    &       (ilock(l,i,jres), l=1,numgrh(i,jres) )
C       ENDDO

        DO I=1,NUMHTOT
	   ILAST=I
           IF (AT1.EQ.NAMEH(I,JRES)) THEN
C  Atom was identified.
             NUMG=NUMGRH(I,JRES)
C     write(*,'(2a,i4)') 'atom= ', nameh(i,jres),NUMG
             DO  J=1,NUMG
                IHN=IHNUM(J,I,JRES)
                JLOC= ILOCK(J,I,JRES)
                DO  K=1,IHN
                    LOC(NUM+K) = NP1 + JLOC + K - 1
                ENDDO
                NUM = NUM+IHN
             ENDDO
             LFOUND=.TRUE.
             GOTO 200
           ENDIF
        ENDDO
      ENDIF

 200  CONTINUE
      IF (.NOT.LFOUND)  THEN
c Not found. 
C        WRITE (*,1000) AT1,N1,JRES
         WRITE (JOUT,1000) AT1,N1,JRES
         STOP 4056
      ELSE IF (ILAST.GT.NUMHRES) THEN
C Found under an alternative label.
        IJK= LOC(1)
C       WRITE (*,1100) AT1, ALPH(IJK), N1
        WRITE (JOUT,1100) AT1, ALPH(IJK), N1
      ELSE
C Found under the standard label.
C        WRITE (*,1200) AT1, N1, NUM, (LOC(1)-NP1)
         WRITE (JOUT,1200) AT1, N1, NUM, (LOC(1)-NP1)
      END IF

      RETURN

1000  FORMAT ('ERROR: Unrecognized atom ',a4, ' in residue ', I4,
     &  2X,' LIST No.= ',i3)
1100  FORMAT('ALTERNATIVE ATOM NAME ',a4,' is used for ',
     &               a4,' in residue ', I4)
1200  FORMAT('ATOM ',a4,' in res. No. ',i4,' NUM =',i4,
     &               ' LOC(1)-NPRE is  ',i4)
      END

      SUBROUTINE CONVRT(X,DIR)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      LOGICAL DIR
      DIMENSION X(3*maxnum_res)
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.ACAR'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.IOUNIT'
      LOGICAL LPROLIN
      IF (DIR) THEN
C In this mode the IINT array will be set up. For the Ith distance constraint,
C IINT(I) is the number of the LAST variable angle on which the distance
C depends. 
        DO I=1,maxnum_res
          DO J=1,maxcnstm
            B(I,J)=0.0
          ENDDO
        ENDDO
        DO I=1,NHPB
          IINTI=0
          DO J=IS,IHPB(I)
C Changed 11/13/93 to take into account VAR_ANGLES=SPEC and so on -- AL
            if (j.gt.is .and. nchvar(j,1).eq.1) IINTI=IINTI+1
            if (j.lt.ie .and. nchvar(j,2).eq.1) IINTI=IINTI+1
          ENDDO
          IINT(I)=IINTI
        ENDDO
        DO I=1,NLOOP
          IINTI=0
          DO J=IS,NPAIR(1,I)
C Changed 11/13/93 to take into account VAR_ANGLES=SPEC and so on -- AL
            if (j.gt.is .and. nchvar(j,1).eq.1) IINTI=IINTI+1
            if (j.lt.ie .and. nchvar(j,2).eq.1) IINTI=IINTI+1
          ENDDO
          IF (IINTI.EQ.0) IINTI=1
          IINT(NHPB+3*(I-1)+1)=IINTI
        ENDDO
        II=0
        NC=0
        DO I=IS,IE
C Changed 11/13/93 to take into account VAR_ANGLES=SPEC and so on -- AL
          if (i.gt.is .and. nchvar(i,1).eq.1) then
            II=II+1
            X(II)=ANGULO(1,I)
            IF (IFFIX(I).EQ.1) THEN
              NC=NC+1
              B(II,NC)=1.0
            ENDIF
          endif
          if (i.lt.ie .and. nchvar(i,2).eq.1) then
            II=II+1
            X(II)=ANGULO(2,I)
            IF (IPFIX(I).EQ.1) THEN
              NC=NC+1
              B(II,NC)=1.0
            ENDIF
          endif
        ENDDO
        IINTI=II+1
cd      WRITE (JOUT,*) 'NLOOP=',NLOOP
        DO I=1,NLOOP
          IINT(NHPB+3*(I-1)+2)=IINTI
cd        WRITE (JOUT,*) 'I=',I,' IND=',NHPB+3*(I-1)+2,' IINTI=',IINTI
          IINTI=IINTI+NKAI1(I)+NKAI2(I)
        ENDDO
cd      WRITE (JOUT,*) 'CONVRT: IINT ARRAY'
cd      WRITE (JOUT,'(20I4)') (IINT(I),I=1,NHPB+3*NLOOP)
        DO I=1,NLOOP
cd        WRITE (JOUT,*) 'I=',I,' NKAI1=',NKAI1(I),' NKAI2=',NKAI2(I)
          NP1=NPAIR(1,I)
          NP2=NPAIR(2,I) 
          DO J=1,NKAI1(I)
            NDX=ICHPOS1(I,J)
            if (ndx.gt.0) then
              II=II+1
              X(II)=ANGULO(NDX,NP1)
cd            WRITE (JOUT,*) 
cd   &        'J=',J,' II=',II,' NDX=',NDX,' X=',X(II)*DEG
              IF (ICHFIX1(I,J).EQ.1) THEN
                NC=NC+1
                B(II,NC)=1.0
              ENDIF
            endif
          ENDDO
          DO J=1,NKAI2(I)
            NDX=ICHPOS2(I,J)
            if (ndx.gt.0) then
              II=II+1
              X(II)=ANGULO(NDX,NP2)
cd            WRITE (JOUT,*) 
cd   &        'J=',J,' II=',II,' NDX=',NDX,' X=',X(II)*DEG
              IF (ICHFIX2(I,J).EQ.1) THEN
                NC=NC+1
                B(II,NC)=1.0
              ENDIF
            endif
          ENDDO
        ENDDO    
        NVAR=II
      ELSE
        II=0
        DO I=IS,IE
          if (i.gt.is .and. nchvar(i,1).eq.1) then
            II=II+1
            ANGULO(1,I)=X(II)
          endif
          if (i.lt.ie .and. nchvar(i,2).eq.1) then
            II=II+1
            ANGULO(2,I)=X(II)
          endif
        ENDDO
        DO I=1,NLOOP
          NP1=NPAIR(1,I)
          NP2=NPAIR(2,I)
          DO J=1,NKAI1(I)
            NDX=ICHPOS1(I,J)
            if (ndx.gt.0) then
              II=II+1
              ANGULO(NDX,NP1)=X(II)
            endif
          ENDDO
          DO J=1,NKAI2(I)
            NDX=ICHPOS2(I,J)
            if (ndx.gt.0) then
              II=II+1
              ANGULO(NDX,NP2)=X(II)
            endif
          ENDDO
        ENDDO    
cd      CALL DRUANG(JOUT,1)
      ENDIF
      END
      SUBROUTINE DISFF
C  Calculate distance term and gradient.
C Modification of  Max Vasquez  routine:  DISOFF         APR-12-94. DR
C constraint energy is: 
C            Econs= 1/2 * WEI_ENE * Sum        [ wei(j)*(| rj - R|)^2]
C                                   j E {pairs}
C 
C
C In the case of groups of protons with overlapping resonance (NPARES2 loop),
C the weighted sum of individual distances is used as described in:
C Ni et el. Biochemistry, vol 28.  pp 3094-3105. (1989)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.DERIV'
      INCLUDE 'COMMON.XBOUNDX'
      DIMENSION VIO(maxnum_dist), NUMVIO(2,numviol)
      DIMENSION DA(3), DA6(3,50,50), RRM6(50,50), RR12(50,50)
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.IOUNIT'
      REAL eexpon, eexpinv
      PARAMETER (eexpon = 6.0d+00, eexpinv= -1.0d0/6.0d0)
      REAL*8 GC1(3), GC2(3), GCM(3)

      DATA DIMAX /1.0e+12/, DIMIN /1.0e-12/

C     write(*,*) 'NOW IN DISFF'

      IPAR=0
      FDIS = 0.0
      EDIS = 0.0
c     write(*,*)'WEI(1),WEI2(1)', WEI(1),WEI2(1)  
      DO 40 I=1,NPARES1
        II1 = IOP(1,I)
        II2 = IOP(2,I)
        D1 = DOP(1,I)
        D2 = DOP(2,I)
        WEIBO=WEI(I)
c     write(*,*)'ATOM1 ATOM2 UPP LOW ', II1, II2, D1, D2
        D3SQ = 0.0
        DO 20 J=1,3
            DX = COORD(J,II1)-COORD(J,II2)
            D3SQ = D3SQ + DX**2
            DA(J) = DX
  20    CONTINUE
        D3INV = 1./ SQRT(D3SQ)
        D3 = 1./D3INV
C      JUST a check!!!  DR may/91)
        IF (( D1.GT.DIMAX).OR.(D1.LT.DIMIN).OR.( D2.GT.DIMAX)
     &                  .OR.( D3.GT.DIMAX).OR.(D3.LT.DIMIN)) THEN
           WRITE(JOUT, 2232) I, D1, D2, D3
        END IF
2232    FORMAT(' pair1, D1,D2,D3  in disff = ',i4,3e12.5)
        IF ( (D3.GT.D1) .OR. (D3.LT.D2) ) THEN
C          WRITE(JOUT,*) ' NPARES1: pair =', I
C          WRITE(JOUT,*)
C    &      'AT1=',II1,' AT2=',II2,' UPP=',D1,' LOW=',D2,' DIST=',D3 
C          WRITE(JOUT, *)' '
C there is a violation.
           DFACX = D3INV*WEI_ENE*WEIBO
C          IF (ABS(DFACX) .GT. 1.0E+05) 
C    &      WRITE(*, *)'NPARES1: LARGE FACTOR DFACX=', DFACX 
           IF(DSW.GT.0.0 .AND. D3.GT.(D1+DSW)) THEN
              TERD3 = D3-D1
              TD3INV = 1./ TERD3 
C             TDIS = TDIS + ASW + BSW*TD3INV*TD3INV + CSW*TERD3
              TDIS = ASW + BSW*TD3INV*TD3INV + CSW*TERD3
              DTRM = (-2.0*BSW*TD3INV*TD3INV*TD3INV + CSW)*DFACX*0.5
           ELSE 
              IF ( D3.GT.D1) TERD3 = D3-D1
              IF ( D3.LT.D2) TERD3 = D3-D2
C             TDIS = TDIS + TERD3**2
              TDIS = TERD3**2
              DTRM = TERD3 * DFACX
           END IF

C          FDIS = TDIS*WEIBO
           FDIS = FDIS + TDIS * WEIBO
           ICOUT=0
           DO 45  K=1,3
              DADD=DTRM*DA(K)
              IF (ABS(DADD).GT. 1.0E+05) THEN
                 IF (ICOUT.EQ.0) THEN 
                    ICOUT=1
                    WRITE(JOUT, *)'NPARES1:  LARGE FACTOR DADD=', DADD 
                 ENDIF
                 DADD = 1.0E+05*SIGN(1.0,DADD)
              ENDIF
              CGE(K,II1,ICG)=CGE(K,II1,ICG)+DADD
              CGE(K,II2,ICG)=CGE(K,II2,ICG)-DADD
              GC1(K)=CGE(K,II1,ICG)
              GC2(K)=CGE(K,II2,ICG)
              GCM(K)=DADD
 45        CONTINUE
C          WRITE(JOUT, *)'-1 ICG  atom1 atom2 ',ICG, II1,II2 
C          WRITE(JOUT,'(6(1x,d12.5))')(GC1(K),K=1,3),( GCM(K),K=1,3)
C          WRITE(JOUT,'(6(1x,d12.5))')(GC2(K),K=1,3),(-GCM(K),K=1,3)
C          WRITE(JOUT, *)' '
        END IF
  40  CONTINUE

      DO 300 I=1, NPARES2
        IPAR=IPAR+1
        RM6 = 0.0
        DO 120 J2=1, NUMT(2,I)
          DO 100 J1 = 1, NUMT(1,I)
            R12 = 0.0
            DO 80 K=1,3
              DAX = COORD(K,LOCT(J1,1,I))-COORD(K,LOCT(J2,2,I))
              R12 = R12 +  DAX**2
              DA6 (K,J1,J2) = DAX
 80         CONTINUE
            RI12 = 1.0/R12
C RR12 contains terms    r_{j,k}^(-2)
            RR12(J1,J2) = RI12
C 
C RRM6 contains terms    r_{j,k}^(-eexpon)
            RRM6(J1,J2) = RI12**(0.5e+0 * eexpon)
C
C  RM6 is: sum_j sum_k [ r_{j,k}^(-eexpon)]
            RM6 = RM6 + RRM6(J1,J2)
 100      CONTINUE
 120    CONTINUE
C  RA is:  { sum_j sum_k [ r_{j,k}^(-eexpon)] } ^(-1/eexpon)
        RA = (RM6)**(eexpinv)
        R6A = 1/ RM6
C ADDED BY FENG NI, 10/1/93
        UPP = DISG(1,I)
        ULO = DISG(2,I)
C
C       Check for overflow or underflow!!!  DR may/91)
        IF (( RA.GT.DIMAX).OR.(RA.LT.DIMIN).OR.( UPP.GT.DIMAX)
     &   .OR.(UPP.LT.DIMIN).OR.(RM6.GT.DIMAX).OR.(RM6.LT.DIMIN)) THEN
          WRITE(JOUT, 2231) I, RA, UPP, RM6
        END IF
2231    FORMAT('DISFF: pair2, RA, UPP,RM6 = ',i4,3e12.5)

        WEIBO=WEI2(I)
C Feng Ni, added distance smoothing
        IF ( (RA.LT.ULO) .OR. (RA.GT.UPP) )THEN

c There is violation.
C          WRITE(JOUT,*) ' NPARES2 =', IPAR
C          WRITE(JOUT,*)'ST AT1=',II1,' ST AT2=',II2,
C    &                 ' UPP ',UPP,' LOW ',ULO,' DIST=',RA 
C          WRITE(JOUT, *)' '
           DFACX=WEI_ENE*WEIBO*RA*R6A 

           IF (DSW.GT.0.0 .AND. RA.GT.(UPP+DSW)) THEN
              DEROUND = RA - UPP
              DRINV = 1./DEROUND 
C             TDIS = TDIS + ASW + BSW*DRINV*DRINV +CSW*DEROUND
              TDIS = ASW + BSW*DRINV*DRINV +CSW*DEROUND
              DERIV = (-2.*BSW*DRINV*DRINV*DRINV + CSW)*DFACX*0.50
           ELSE 
              IF (RA.GT.UPP) DEROUND = RA - UPP
              IF (RA.LT.ULO) DEROUND = RA - ULO
C             TDIS = TDIS + DEROUND**2
              TDIS = DEROUND**2
              DERIV = DEROUND*DFACX
           END IF

C          FDIS = TDIS*WEIBO
           FDIS =  FDIS+TDIS*WEIBO
           IF (ABS( FDIS).GT. 1.0E+06) 
     &             WRITE(*, *)'NPAIR2: LARGE FDIS=', FDIS 
           ICOUT=0
           DO 130 J2=1, NUMT(2,I)
              II2 = LOCT(J2,2,I)
              DO 140 J1 = 1, NUMT(1,I)
                II1 = LOCT(J1,1,I)
                DADE = DERIV*RRM6(J1,J2)*RR12(J1,J2)
                DO 150 K=1,3
                  DADD=DADE*DA6(K,J1,J2)
                  IF (ABS(DADD).GT. 1.0E+05) THEN
                     IF (ICOUT.EQ.0) THEN 
                        ICOUT=1
                        WRITE(*, *)'NPARES2: LARGE DADD='
C Some printing
                        IF(NUMB_PDB) THEN
                           NREV1 = LIST(NRE(1,I)+1)
                           NREV2 = LIST(NRE(2,I)+1)
                        ELSE
                           NREV1 = LIST(NRE(1,I))
                           NREV2 = LIST(NRE(2,I))
                        ENDIF

                        WRITE (JOUT,3010)IPAR, ARES(NREV1),NRE(1,I),
     &                  ATOM(1,I), ARES(NREV2), NRE(2,I), ATOM(2,I)

                        WRITE(JOUT, *)'NPAIR2: LARGE GRADIENT=', DADE 
                        WRITE(JOUT, *)'UPPER =', UPP,'  LOWER=', ULO
     &                   , ' RA=', RA ,' DFACX=', DFACX, ' R6A=', R6A 
c    &                    ,' WEI_ENE=', WEI_ENE,' WEIBO=', WEIBO  
                        WRITE(JOUT, *)' '

                        WRITE (*,3010)IPAR, ARES(NREV1),NRE(1,I),
     &                  ATOM(1,I), ARES(NREV2), NRE(2,I), ATOM(2,I)
3010                    FORMAT (i5,2X,2 (A3,I3,2X,A3,5X),30X,A3)

                        WRITE(*, *)'NPAIR2: LARGE GRADIENT=', DADE 
                        WRITE(*, *)'UPPER =', UPP,'  LOWER=', ULO
     &                   , ' RA=', RA ,' DFACX=', DFACX, ' R6A=', R6A 
c    &                    ,' WEI_ENE=', WEI_ENE,' WEIBO=', WEIBO  
                        WRITE(*, *)' '
c                       WRITE(*, *)
c    &                    'NUMT(2,I)=', NUMT(2,I),'NUMT(1,I)=', NUMT(1,I) 
c                       DO J2=1, NUMT(2,I)
c                         WRITE(*, '( (a10,i3,a1,i3,a3,i5,5a))')
c    &                    'From LOCT(',J2,'2',I,') =',LOCT(J2,2,I),' to'  
c                         DO J1 = 1, NUMT(1,I)
c                            WRITE(*, '((a22,i3,a1,i3,a3,i5, 5x))')
c    &                        '    LOCT(',J1,'1',I,') =', LOCT(J1,1,I) 
c                         ENDDO
c                       ENDDO
C End printing
                     ENDIF
                     DADD = 1.0E+05*SIGN(1.0,DADD)
                  ENDIF

                  CGE(K,II1,ICG)=CGE(K,II1,ICG)+DADD
                  CGE(K,II2,ICG)=CGE(K,II2,ICG)-DADD
                  GC1(K)=CGE(K,II1,ICG)
                  GC2(K)=CGE(K,II2,ICG)
                  GCM(K)=DADD
 150            CONTINUE
C              WRITE(JOUT, *)'-2 ICG  atom1 atom2 ',ICG, II1,II2 
C              WRITE(JOUT,'(6(1x,d12.5))')(GC1(K),K=1,3),( GCM(K),K=1,3)
C              WRITE(JOUT,'(6(1x,d12.5))')(GC2(K),K=1,3),(-GCM(K),K=1,3)
C              WRITE(JOUT, *)' '
 140          CONTINUE
 130       CONTINUE
        END IF
 300  CONTINUE
      EDIS= .5*WEI_ENE*FDIS
C     WRITE (JOUT,'(a,f8.2)') 'EDIS= ', EDIS
      RETURN
      END
      SUBROUTINE DISPRT
Calculate distance terms and print info about non satisfied distance .
constraints. Modification of  Max Vasquez  routine DISOFF   APR-7-94. DR
C 
C constraint energy is: 
C            Econs= 1/2 * WEI_ENE * Sum        [ wei(j)*(| rj - R|)^2]
C                                   j E {pairs}
C
C In the case of groups of protons with overlapping resonance (NPARES2 loop),
C the weighted sum of individual distances is used as described in:
C Ni et el. Biochemistry, vol 28.  pp 3094-3105. (1989)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.DERIV'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.XBOUNDX'
      DIMENSION VIO(maxnum_dist), NUMVIO(2,numviol),JVIO(maxnum_dist)
      DIMENSION DA(3), DA6(3,50,50), RRM6(50,50), RR12(50,50)
      CHARACTER*3 CHRANG
      REAL eexpon, eexpinv
      PARAMETER (eexpon = 6.0d+00, eexpinv= -1.0d0/6.0d0)
      DATA DIMAX /1.0e+12/, DIMIN /1.0e-12/

C     write(jout,*) ' NOW IN DISPRT '
      NUMSAT=0
      IPAR=0
      FDIS = 0.0
      EDIS = 0.0
      IF (NUKCO.GT.0) WRITE (JOUT,8888)
      NTOTPAR= NPARES1+NPARES2
      IF (NTOTPAR.GT.0) THEN
         DO 5 I=1,NTOTPAR
           VIO(I) = 0.0E0
 5       CONTINUE
         DO 10 J=1,numviol
         DO 10 I=1,2
              NUMVIO(I,J) = 0
 10      CONTINUE

C     write(jout,*) ' NPARES2 =', NPARES2
         DO 300 I=1, NPARES2
           IPAR=IPAR+1
           RWS = 100.0
           RM6 = 0.0
           DO 120 J2=1, NUMT(2,I)
             DO 100 J1 = 1, NUMT(1,I)
               R12 = 0.0
               DO 80 K=1,3
                 DAX = COORD(K,LOCT(J1,1,I))-COORD(K,LOCT(J2,2,I))
                 R12 = R12 +  DAX**2
                 DA6 (K,J1,J2) = DAX
 80            CONTINUE
               RWW = SQRT(R12)
               IF (RWW.LE.RWS) RWS = RWW
C               write(jout,*) ' RWS =', RWS
               RI12 = 1.0/R12
C RR12 contains terms    r_{j,k}^(-2)
               RR12(J1,J2) = RI12
C 
C RRM6 contains terms    r_{j,k}^(-eexpon)
               RRM6(J1,J2) = RI12**(0.5e+0 * eexpon)
C
C  RM6 is: sum_j sum_k [ r_{j,k}^(-eexpon)]
               RM6 = RM6 + RRM6(J1,J2)
 100         CONTINUE
 120       CONTINUE
           R6A = 1/ RM6
           RA = (RM6)**(eexpinv)
           UPP = DISG(1,I)
C
C                Check for overflow!!!  DR may/91)
           IF (( RA.GT.DIMAX).OR.(RA.LT.DIMIN).OR.( UPP.GT.DIMAX)
     &   .OR.(UPP.LT.DIMIN).OR.(RM6.GT.DIMAX).OR.(RM6.LT.DIMIN)) THEN
              IF (NUKCO.GT.0) WRITE(JOUT, 2231) I, RA, UPP
           END IF
2231       FORMAT(' pair2, RA, UPP in disprt = ',i4,3e12.5)
C
C ADDED BY FENG NI, 10/1/93
           ULO = DISG(2,I)
           WEIBO=WEI2(I)
C Feng Ni, added distance smoothing
           IF ( (RA.LT.(0.99*ULO)) .OR. (RA.GT.(1.01*UPP)) )THEN
c There is violation.
              IF (DSW.GT.0.0 .AND. RA.GT.(UPP+DSW)) THEN
                 DEROUND = RA - UPP
                 DRINV = 1./DEROUND 
C                TDIS = TDIS + ASW + BSW*DRINV*DRINV +CSW*DEROUND
                 TDIS = ASW + BSW*DRINV*DRINV +CSW*DEROUND
              ELSE 
                 IF (RA.GT.UPP) DEROUND = RA - UPP
                 IF (RA.LT.ULO) DEROUND = RA - ULO
C                TDIS = TDIS + DEROUND**2
                 TDIS = DEROUND**2
              END IF

C             FDIS = TDIS*WEIBO
              FDIS = FDIS+TDIS*WEIBO
              KK = KAES2(I)
              IF (KK.LE.5) THEN
                 IKK = 1
                 CHRANG= 'S-R'
              ELSE
                 IKK = 2
                 CHRANG= 'L-R'
              END IF
              IF(NUMB_PDB) THEN
                 NRE1 = LIST(NRE(1,I)+1)
                 NRE2 = LIST(NRE(2,I)+1)
	      ELSE
                 NRE1 = LIST(NRE(1,I))
                 NRE2 = LIST(NRE(2,I))
	      ENDIF
C
C After calculating the energy, we report the error between the 
C upper bound for proton-proton distance and the shortest
C distance between protons from different groups.

              DEROD=0.0
              IF  (RA.LT.ULO) DEROD= RA - ULO
              IF  (RA.GT.UPP) DEROD= RA - UPP
c      write(jout,*) 'RA= ',RA,' RWS =', RWS, 'DEROD= ', DEROD
              DTRN1 = ABS(DEROD)

C             IF ( (NUKCO.GT.0) .AND.    (RA.GT.UPP) ) THEN
              IF ((NUKCO.GT.0).AND.((RA.GT.UPP).OR.(RA.LT.ULO))) THEN
                 IF (ITYGRP2(I).EQ.0) THEN
                   WRITE (JOUT,1003) IPAR, ARES(NRE1), NRE(1,I),
     &               ATOM(1,I), ARES(NRE2), NRE(2,I), ATOM(2,I), 
     &               CHRANG, UPP, RA, ULO, DTRN1
                 ELSE
                   WRITE (JOUT,1002) IPAR,  NRE(1,I),
     &               ATOM(1,I), NRE(2,I), ATOM(2,I), 
     &               CHRANG, UPP, RA, ULO, DTRN1
                 ENDIF
              ENDIF
C             IF ( (NUKCO.GT.0) .AND.  (RA.LT.ULO) )  THEN
C                IF (ITYGRP2.EQ.0) WRITE (JOUT,1003) IPAR, ARES(NRE1),
C    &          NRE(1,I),ATOM(1,I), ARES(NRE2), NRE(2,I), ATOM(2,I),
C    &          CHRANG, UPP, RA, ULO, DTRN1
C             ENDIF
1002  FORMAT(i5,2X,2(4X,I3,1X,A4,3X),A3,4(2X,F7.2)) 
1003  FORMAT(i5,2X,2(A3,1X,I3,1X,A4,3X),A3,4(2X,F7.2)) 
              VIO(I) = DTRN1
              JVIO(I) = IPAR
C          WRITE(JOUT,6455) 'pair= ', I,' violation= ',VIO(I)
C6455      FORMAT(a,i3,a,f6.3)

              IF (DTRN1.GT.5.0) THEN
                NUMVIO(IKK,12) = NUMVIO(IKK,12) + 1
              ELSE IF (DTRN1.GT.2.0) THEN
                NUMVIO(IKK,11) = NUMVIO(IKK,11) + 1
              ELSE IF (DTRN1.GT.1.0) THEN
                NUMVIO(IKK,10) = NUMVIO(IKK,10) + 1
              ELSE IF (DTRN1.GT.0.8) THEN
                NUMVIO(IKK,9) = NUMVIO(IKK,9) + 1
              ELSE IF (DTRN1.GT.0.6) THEN
                NUMVIO(IKK,8) = NUMVIO(IKK,8) + 1
              ELSE IF (DTRN1.GT.0.5) THEN
                NUMVIO(IKK,7) = NUMVIO(IKK,7) + 1
              ELSE IF (DTRN1.GT.0.4) THEN
                NUMVIO(IKK,6) = NUMVIO(IKK,6) + 1
              ELSE IF (DTRN1.GT.0.3) THEN
                NUMVIO(IKK,5) = NUMVIO(IKK,5) + 1
              ELSE IF (DTRN1.GT.0.2) THEN
                NUMVIO(IKK,4) = NUMVIO(IKK,4) + 1
              ELSE IF (DTRN1.GT.0.1) THEN
                NUMVIO(IKK,3) = NUMVIO(IKK,3) + 1
              ELSE
                NUMVIO(IKK,2) = NUMVIO(IKK,2) + 1
              ENDIF
           ELSE 
              NUMSAT=  NUMSAT+1
           END IF

 300     CONTINUE

C     write(jout,*) ' NPARES1 =', NPARES1
         DO 40 I=1,NPARES1
           II1 = IOP(1,I)
           II2 = IOP(2,I)
           D1 = DOP(1,I)
           D2 = DOP(2,I)
           WEIBO=WEI(I)
           D3 = 0.0
           DO 20 J=1,3
               DX = COORD(J,II1)-COORD(J,II2)
               D3 = D3 + DX**2
               DA(J) = DX
  20       CONTINUE
           D3 = SQRT ( D3 )
           IF (( D1.GT.DIMAX).OR.(D1.LT.DIMIN).OR.( D2.GT.DIMAX)
     &                  .OR.( D3.GT.DIMAX).OR.(D3.LT.DIMIN)) THEN
              IF (NUKCO.GT.0) WRITE(JOUT, 2232) I, D1, D2, D3
           END IF
2232       FORMAT(' pair1, D1,D2,D3  in disprt = ',i4,3e12.5)

           IF ( (D3.GT.(1.01*D1)) .OR. (D3.LT.(0.99*D2))) THEN
C there is a violation.
              IF(DSW.GT.0.0 .AND. D3.GT.(D1+DSW)) THEN
                 TERD3 = D3-D1
                 TD3INV = 1./ TERD3 
C             TDIS = TDIS + ASW + BSW*TD3INV*TD3INV + CSW*TERD3
                 TDIS = ASW + BSW*TD3INV*TD3INV + CSW*TERD3
              ELSE 
                 IF ( D3.GT.D1) TERD3 = D3-D1
                 IF ( D3.LT.D2) TERD3 = D3-D2
C                TDIS = TDIS + TERD3**2
                 TDIS = TERD3**2
              END IF
C             FDIS = TDIS * WEIBO
              FDIS = FDIS+TDIS * WEIBO
              KK = KAES(I)
              IPAR=IPAR+1
              IF (KK.LE.5) THEN
                 IKK = 1
                 CHRANG= 'S-R'
              ELSE
                 IKK = 2
                 CHRANG= 'L-R'
              END IF
              DTRN1 = D3 - D1
              DTRL = D2 - D3
              IF (DTRL.GT.0.0) DTRN1 = DTRL
              IF(NUMB_PDB) THEN
                 NRE1 = LIST(NR1(1,I)+1)
                 NRE2 = LIST(NR1(2,I)+1)
	      ELSE
                 NRE1 = LIST(NR1(1,I))
                 NRE2 = LIST(NR1(2,I))
	      ENDIF
              IF (NUKCO.GT.0) WRITE (JOUT,1003)IPAR, ARES(NRE1),
     +          NR1(1,I),ATO1(1,I),ARES(NRE2),NR1(2,I),ATO1(2,I), 
     +          CHRANG,D1,D3,D2,DTRN1
                 VIO(I+NPARES2) = DTRN1
                 JVIO(I+NPARES2) = IPAR
              IF (DTRN1.GT.5.0) THEN
                 NUMVIO(IKK,12) = NUMVIO(IKK,12) + 1
              ELSE IF (DTRN1.GT.2.0) THEN
                 NUMVIO(IKK,11) = NUMVIO(IKK,11) + 1
              ELSE IF (DTRN1.GT.1.0) THEN
                 NUMVIO(IKK,10) = NUMVIO(IKK,10) + 1
              ELSE IF (DTRN1.GT.0.8) THEN
                 NUMVIO(IKK,9) = NUMVIO(IKK,9) + 1
              ELSE IF (DTRN1.GT.0.6) THEN
                 NUMVIO(IKK,8) = NUMVIO(IKK,8) + 1
              ELSE IF (DTRN1.GT.0.5) THEN
                 NUMVIO(IKK,7) = NUMVIO(IKK,7) + 1
              ELSE IF (DTRN1.GT.0.4) THEN
                 NUMVIO(IKK,6) = NUMVIO(IKK,6) + 1
              ELSE IF (DTRN1.GT.0.3) THEN
                 NUMVIO(IKK,5) = NUMVIO(IKK,5) + 1
              ELSE IF (DTRN1.GT.0.2) THEN
                 NUMVIO(IKK,4) = NUMVIO(IKK,4) + 1
              ELSE IF (DTRN1.GT.0.1) THEN
                 NUMVIO(IKK,3) = NUMVIO(IKK,3) + 1
              ELSE
                 NUMVIO(IKK,2) = NUMVIO(IKK,2) + 1
              ENDIF
           ELSE
              NUMSAT=  NUMSAT+1
           END IF
  40     CONTINUE
         EDIS= .5*WEI_ENE*FDIS
C        WRITE (JOUT,'(a,f8.2)') 'EDIS= ', EDIS
C
         VIOMAX = 0.0
         JMAX = 0.0
         DO 500 J=1,NPARES1 + NPARES2
             IF (VIO(J).GT.VIOMAX) THEN
               VIOMAX = VIO(J)
               JMAX = JVIO(J)
             END IF
 500     CONTINUE
         EROT =  SQRT ( FDIS /FLOAT(NPARES1+NPARES2) )
         IF (NUKCO.GT.0) WRITE (JOUT,1200) FDIS
         IF (NUKCO.GT.0) WRITE (JOUT,1230) EROT
         IF (NUKCO.GT.0) WRITE (JOUT, 1351)
         IF (NUKCO.GT.0) WRITE (JOUT,' (16X,12I5)') (NUMVIO(1,J),J=2,
     & numviol)
         IF (NUKCO.GT.0) WRITE (JOUT, 1401)
         IF (NUKCO.GT.0) WRITE (JOUT,' (16X,12I5)') (NUMVIO(2,J),J=2,
     & numviol)
         IF (NUKCO.GE.0) WRITE (JOUT,1300) VIOMAX, JMAX
         IF (NUKCO.GE.0) WRITE (JOUT,1501)  NUMSAT
      ENDIF
      RETURN
 1200 FORMAT (/' WEIGTHED SUM OF SQUARES OF ERRORS  ',1E13.6)
 1230 FORMAT ( ' WEIGTHED ROOT MEAN SQUARE', 1E13.6)
 1250 FORMAT (10I5)
 1300 FORMAT (/,'MAXIMUM VIOLATION: ',1F10.3,5X,'PAIR #',I5)
 1320 FORMAT ( ' EES   ENB   ', 2E15.6 )
 1351 FORMAT ( /,'SHORT RANGE  .LE.  0.1  0.2  0.3  0.4  0.5',
     &                          '  0.6  0.8  1.0  2.0  5.0  999' )
 1401 FORMAT ( /,'LONG RANGE  .LE.   0.1  0.2  0.3  0.4  0.5',
     &                          '  0.6  0.8  1.0  2.0  5.0  999' ) 
 1420 FORMAT ( ' CONFORMATION # ', I10, /, 'EN', 5E13.5,/)
 1501 FORMAT ( /,'NO. OF DISTANCE SATISFIED ',i5,/)
 1004 FORMAT (' PAIR, SUBPAIR, ACTUAL ', 3I5, F15.6)
 1010 FORMAT (2X,2 (A3,I3,2X,A3,5X))
 8888 FORMAT 
     &( /,'  ====  DISTANCE ANALYSIS  ====',/,' No.   RESIDUE ATM',
     & '    RESIDUE ATM   TYPE    UPPER    ACTUAL    LOWER    ERROR')
      END
      SUBROUTINE SET_DISC 
C Modification of  Max Vasquez  routine DISOF.         FEB-98. DR
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.IOUNIT'
      CHARACTER*4 LATOM(2)
      CHARACTER*4 RATOM1,RATOM2
      DIMENSION NUM(2), LOC(50,2), LNRE(2),NML(2)

      DATA SMALL /0.10000E-3/

C F.NI start
      IF(DSW.GT.0.0) THEN
        BSW=-DSW**4 + 0.5*CSW*DSW**3
        ASW=DSW**2 - BSW/DSW**2 - CSW*DSW
      END IF
C
      write(*,*) ' IN SET_DISC'

C DR JAN/29/98
      IF (CONGENF) CALL READ_CONGEN_CONS
      IF (((NPAIR1+NPAIR2).NE.0).AND.ECEPPCF) 
     &      CALL READ_ECEPP_CONS

      IF ( (NPAIR1+NPAIR2).NE.0) THEN
C    IF  STATEMENT FOR DISTANCE CONSTRAINTS


C  ORDER FIRST SET OF PAIRS BY INCREASING KAES
        IH = 1
 60     IH = 3*IH + 1
        IF ( IH.LT.NPAIR1) GOTO 60
 70     IH = IH / 3
        IH1 = IH + 1
        DO 100 I=IH1,NPAIR1
          IV = KAES(I)
          JJ = I
          IDV1 = IDI(1,I)
          IDV2 = IDI(2,I)
          DV1 = DISO(1,I)
          DV2 = DISO(2,I)
          LATOM(1) = ATO1(1,I)
          LATOM(2) = ATO1(2,I)
          LNRE(1) = NR1(1,I)
          LNRE(2) = NR1(2,I)
          NMOL1=NMOLA(1,I)
          NMOL2=NMOLA(2,I)
          WEIGHT=WEI(I)
 80       IF(KAES(JJ-IH).LE.IV) GOTO 90
          JJIH = JJ-IH
          ATO1(1,JJ) = ATO1(1,JJIH)
          ATO1(2,JJ) = ATO1(2,JJIH)
C            WRITE(JOUT,2003) JJ, ATO1(1,JJ),  ATO1(2,JJ)
C2003        FORMAT (  I5,'2003',9X,2A4 )
          NR1(1,JJ) = NR1(1,JJIH)
          NR1(2,JJ) = NR1(2,JJIH)
          KAES(JJ) = KAES(JJIH)
          IDI(1,JJ)= IDI(1,JJIH)
          IDI(2,JJ) = IDI(2,JJIH)
          DISO(1,JJ) = DISO(1,JJIH)
          DISO(2,JJ) = DISO(2,JJIH)
          NMOLA(1,JJ)= NMOLA(1,JJIH)
          NMOLA(2,JJ)= NMOLA(2,JJIH)
          WEI(JJ)=WEI(JJIH)
          JJ= JJ-IH
          IF (JJ.GT.IH) GOTO 80
 90       KAES(JJ) = IV
          I1 = 2*JJ-1
          I2 = I1 + 1
          NMOLA(1,JJ)= NMOL1
          NMOLA(2,JJ)= NMOL2
          NR1(1,JJ) = LNRE(1)
          NR1(2,JJ) = LNRE(2)
          ATO1(1,JJ) = LATOM(1)
          ATO1(2,JJ) = LATOM(2)
C           WRITE(JOUT,2004) JJ      , ATO1(1,JJ    ),  ATO1(2,JJ    )
C2004      FORMAT (  I5,'2004',9X,2A4 )
          IDI(1,JJ) = IDV1
          IDI(2,JJ) = IDV2
          DISO(1,JJ) = DV1
          DISO(2,JJ) = DV2
          WEI(JJ)=WEIGHT
 100    CONTINUE
        IF (IH.GT.1) GOTO 70
C       CREATE RANGES FOR FIRST SET OF PAIRS
        DO 110 I=1,INUMRS
           IP(I) = 0
 110    CONTINUE
        IF (IORDER.EQ.0.OR.IORDER.EQ.2) THEN
          DO 120 I=1,NPAIR1
            KL = KAES(I)
            IF ( KL.LE.0) KL = 1
            IP(KL) = IP(KL) + 1
C           WRITE (JOUT, 2020) I, NR1(1,I), ATO1(1,I), NR1(2,I), ATO1(2,I)
 120      CONTINUE
        ELSE
          IF (NPAIR1.LE.INUMRS) THEN
            DO 125 I=1, NPAIR1
              IP(I) = 1
125         CONTINUE
          ELSE
            NFR = NPAIR1/INUMRS
            NLEFT = MOD(NPAIR1,INUMRS)
            NLEFO = 0
            DO 130 I=1, INUMRS
              IP(I) = NFR
              IF (NLEFO.LT.NLEFT) THEN
                NLEFO = NLEFO + 1
                IP(I) = IP(I) + 1
              END IF
130         CONTINUE
          END IF
        END IF
        DO 140 I = 2, INUMRS
          IM1 = I - 1
          IP(I) = IP(IM1) + IP(I)
 140    CONTINUE
        IP (INUMRS) = NPAIR1
C                        ORDER SECOND SET OF PAIRS
        IH = 1
 160    IH = 3*IH + 1
        IF ( IH.LT.NPAIR2) GOTO 160
 170    IH = IH / 3
        IH1 = IH + 1
        DO 300 I=IH1,NPAIR2
          IV = KAES2(I)
          JJ = I
          DO 190 KK=1,2
            NUM(KK) = NUMT(KK,I)
            NML(KK)=NMOLB(KK,I)
            LNRE(KK) = NRE(KK,I)
            LATOM(KK) = ATOM(KK,I)
            DO 180 KK2=1,NUM(KK)
              LOC(KK2,KK) = LOCT(KK2,KK,I)
180         CONTINUE
190       CONTINUE
          DV1 = DISG(1,I)
          DV2 = DISG(2,I)
          WEIGHT=WEI2(I)
          IVY = ITYGRP2(I)
200       IF(KAES2(JJ-IH).LE.IV) GOTO 230
          JJIH = JJ-IH
          KAES2(JJ) = KAES2(JJIH)
          DO 220 KK=1,2
              NUMT(KK,JJ) = NUMT(KK,JJIH)
              NMOLB(KK,JJ) = NMOLB(KK,JJIH)
              NRE(KK,JJ) = NRE(KK,JJIH)
              ATOM(KK,JJ) = ATOM(KK,JJIH)
              DO 210 KK2=1,NUMT(KK,JJ)
                LOCT(KK2,KK,JJ) = LOCT(KK2,KK,JJIH)
210           CONTINUE
220       CONTINUE
          DISG(1,JJ) = DISG(1,JJIH)
          DISG(2,JJ) = DISG(2,JJIH)
          WEI2(JJ) = WEI2(JJIH)
          ITYGRP2(JJ) = ITYGRP2(JJIH)
          JJ= JJ-IH
          IF (JJ.GT.IH) GOTO 200
 230      KAES2(JJ) = IV
          DO 250 KK=1,2
            NUMT(KK,JJ) = NUM(KK)
            ATOM(KK,JJ) = LATOM(KK)
            NRE(KK,JJ) = LNRE(KK)
            NMOLB(KK,JJ) = NML(KK)
            DO 240 KK2=1,NUMT(KK,JJ)
              LOCT(KK2,KK,JJ) = LOC(KK2,KK)
240         CONTINUE
250       CONTINUE
          DISG(1,JJ) = DV1
          DISG(2,JJ) = DV2
          WEI2(JJ) = WEIGHT
          ITYGRP2(JJ) = IVY
300     CONTINUE
        IF (IH.GT.1) GOTO 170
C     CREATE RANGES FOR SECOND SET OF PAIRS
        DO 310 I=1,INUMRS
           IP2(I) = 0
 310    CONTINUE
        IF (IORDER.EQ.0.OR.IORDER.EQ.2) THEN
          DO 320 I=1,NPAIR2
            KL = KAES2(I)
            IF ( KL.LE.0) KL = 1
            IP2(KL) = IP2(KL) + 1
C           WRITE (JOUT,2030) I,KL,LOCT(1,1,I), LOCT(1,2,I)
 320      CONTINUE
        ELSE
          IF (NPAIR2.LE.INUMRS) THEN
            DO 325 I=1, NPAIR2
              IP2(I) = 1
325         CONTINUE
          ELSE
            NFR = NPAIR2/INUMRS
            NLEFT = MOD(NPAIR2,INUMRS)
            NLEFO = 0
            DO 330 I=1, INUMRS
              IP2(I) = NFR
              IF (NLEFO.LT.NLEFT) THEN
                NLEFO = NLEFO + 1
                IP2(I) = IP2(I) + 1
              END IF
330         CONTINUE
          END IF
        END IF
        DO 340 I = 2, INUMRS
          IM1 = I - 1
          IP2(I) = IP2(IM1) + IP2(I)
 340    CONTINUE
        IP2(INUMRS) = NPAIR2
  
C     WRITE(JOUT,*) 'NPAIR1= ',NPAIR1,' NPAIR2= ',NPAIR2
        DO I=1, NPAIR2
          DO KK=1, 2
            DO JJ=1, NUMT(KK,I)
                IF(LOCT(JJ,KK,I).LE.0)  THEN
                  WRITE(*,*)
     &           'LOCT(',JJ,',',KK,',',I ,')=',LOCT(JJ,KK,I )
                  WRITE(JOUT,*)
     &           'LOCT(',JJ,',',KK,',',I ,')=',LOCT(JJ,KK,I )
                ENDIF
            ENDDO
          ENDDO
        ENDDO

C END IF DISTANCE CONSTRAINTS
      END IF

      END
      SUBROUTINE DISTFORCE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER (nmax=3*maxnum_res)
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
C     INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.ACAR'
      INCLUDE 'COMMON.GRAD2'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.IOUNIT'
      DIMENSION DD(MAXCNSTM),Y(NMAX),Z(NMAX),DIAGA(NMAX),A(NMAX,NMAX)
      LOGICAL LPROLIN 
      DIMENSION X(NMAX),X1(NMAX),G(NMAX,MAXCNSTM),GGG(3)
      DATA MAXITER,MAXMAR,TOL /100,10,1.0E-3/

      NTOT=NHPB+3*NLOOP
      DO I=1,NHPB
        DDD=ALPHADIST(IHPB(I),JHPB(I))
        IF (DDD.GT.DUP(I)) THEN
          DHPB(I)=DUP(I)
        ELSE IF (DDD.LT.DLOW(I)) THEN
          DHPB(I)=DLOW(I)
        ELSE
          DHPB(I)=DDD
        ENDIF
cd      WRITE (JOUT,*) 'I',I,IHPB(I),JHPB(I),' DHPB',DHPB(I)
      ENDDO

      CALL CONVRT(X,.TRUE.)

cd    WRITE (JOUT,*) 'DISTFORCE:'
cd    WRITE (JOUT,*) 'NVAR',NVAR
      IF (NVAR.GT.NUMVAR) THEN
        WRITE (JOUT,'(/80(1H*)/10X,A,I4,A/10X,A,I4,A/80(1H*))') 
     &'Something wrong... There are',NVAR,' variable angles DISTFORCE,',
     &'but the total number of variable angles is only',NUMVAR,
     &'. Exitting...' 
        STOP
      ENDIF 
cd    WRITE (JOUT,*) 'IFFIX AND IPFIX ARRAY:'
cd    WRITE (JOUT,'(16I5)') (IFFIX(I),I=1,INUMRS)
cd    WRITE (JOUT,'(16I5)') (IPFIX(I),I=1,INUMRS)
cd    WRITE (JOUT,*) 'ICHFIX1 AND ICHFIX2 ARRAY:'
cd    DO I=1,NLOOP
cd      WRITE (JOUT,*) (ICHFIX1(I,J),J=1,NKAI1(I)) 
cd      WRITE (JOUT,*) (ICHFIX2(I,J),J=1,NKAI2(I)) 
cd    ENDDO
cd    WRITE (JOUT,*) 'MATRIX B'
cd    DO I=1,NVAR
cd      WRITE (JOUT,*) I,(B(I,J),J=1,NC)
cd    ENDDO 
cd    
cd    WRITE (JOUT,*) 'IINT:'
cd    DO I=1,NTOT
cd      WRITE (JOUT,*) IINT(I)
cd    ENDDO
cd
cd    CALL DRUANG(JOUT)
cd    WRITE (JOUT,*) 'DISTFORCE: X'
cd    WRITE (JOUT,'(8F10.5)') (DEG*X(I),I=1,NVAR)
C
C     CALL TRANSFER(NVAR,X,X1)
      DO IK=1,NVAR
        X1(IK)=X(IK)
      ENDDO
C
      RL=1.0 
      F0=FHPB(X,DD)
cd    WRITE (JOUT,*) 'DISTFORCE: F0=',F0
      DO IT=1,MAXITER
        DO I=1,NVAR
          DO J=1,NTOT
            G(I,J)=0.0
          ENDDO
        ENDDO
        DO I=1,NHPB
          I1=IHPB(I)
          I2=JHPB(I)
          CALL INGRAD
          NS1=NPRE(I1)+3
          NS2=NPRE(I2)+3
          DO J=1,3
            GGG(J)=(COORD(J,NS2)-COORD(J,NS1))/DD(I)
          ENDDO
          NS=NPRE(I1)+3
          DO L=1,3
            CGE(L,NS)=-GGG(L)
          ENDDO
          NS=NPRE(I2)+3
          DO L=1,3
            CGE(L,NS)=GGG(L)
          ENDDO
          CALL GRADCA
          IVAR=IINT(I)
          DO J=I1,I2
C Changed 11/13/93 to take into account VAR_ANGLES=SPEC and so on -- AL
            if (j.ne.i1 .and. nchvar(j,1).eq.1) then
              G(IVAR  ,I)=AGE(IFIND(J))
              ivar=ivar+1
            endif
            if (j.ne.i2 .and. nchvar(j,2).eq.1) then
              G(IVAR+1,I)=AGE(IPIND(J))
              ivar=ivar+1
            endif
          ENDDO
CD        WRITE (JOUT,*) 'I=',i,' Vector AGE:'
CD        WRITE (JOUT,'(10F8.3)') (AGE(J),J=1,NUMVAR)
CD        WRITE (JOUT,*)
        ENDDO
* 4/22/93 Bridge contribution.
cd      WRITE (JOUT,*) 'IINT:'
cd      DO I=1,NTOT
cd        WRITE (JOUT,*) IINT(I)
cd      ENDDO
        DO N=1,NLOOP
          NPREIJ=NPRE(NPAIR(1,N))
          NPREIK=NPRE(NPAIR(2,N))
          ITB1=ITB(N,1)
          ITB2=ITB(N,2)
          II=ITB(N,3)
          IND=NHPB+3*(N-1)
          AK1=CONB(1,II)
          AK2=CONB(2,II)
          AK3=CONB(3,II)
          IB1=NPREIJ+IBRID(2,ITB1)
          IS1=NPREIJ+IBRID(3,ITB1)
          IB2=NPREIK+IBRID(2,ITB2)
          IS2=NPREIK+IBRID(3,ITB2)
          IVAR1=IINT(IND+1)
          IVAR2=IINT(IND+2)
cd        WRITE (JOUT,*) 'N=',N,' IND=',IND,' IVAR1=',IVAR1,
cd   &' IVAR2=',IVAR2
          CALL BRIDGRAD(N,IS1,IS2,IND+1,IVAR1,IVAR2,AK1,DD,G)
          CALL BRIDGRAD(N,IB1,IS2,IND+2,IVAR1,IVAR2,AK2,DD,G)
          CALL BRIDGRAD(N,IS1,IB2,IND+3,IVAR1,IVAR2,AK3,DD,G)
CD        WRITE (16,*) 'EXITTED BRIDGRAD'
CD    WRITE (16,*) 'IBRIDJ=',IBRID(1,ITB1),IBRID(2,ITB1),IBRID(3,ITB1)
CD    WRITE (16,*) 'IBRIDK=',IBRID(1,ITB2),IBRID(2,ITB2),IBRID(3,ITB2)
        ENDDO

cd      WRITE(JOUT,'(A)') 'Comparison of analytical and numerical grad:'
cd      DO I=1,NVAR
cd        X(I)=X(I)+0.001
cd        FUPA=FHPB(X,Z)
cd        WRITE (JOUT,'(I5/5(10F8.3/))') I,(G(I,J),J=1,NTOT)
cd        WRITE (JOUT,'(I5/5(10F8.3/))') I,((Z(J)-DD(J))/0.001,J=1,NTOT)
cd        WRITE (JOUT,*)
cd        X(I)=X(I)-0.001
cd      ENDDO
cd      WRITE (JOUT,*) 'MATRIX B:'
cd      DO I=1,NVAR
cd        WRITE (JOUT,*) I,(B(I,J),J=1,NC)
cd      ENDDO 
cd      STOP
C
C 11/13/93 A few words of explanation -- AL  
C
C The matrix B stores the vectors along which our variables can't move (the 
C nodal space).
C Once the movement of variables that leads to restoring the desired 
C distances has been computed, these directions are removed from the
C displacement vector. Because at present we exclude just single variables
C (i.e. each column of B contains zeros and a only one "1"), this could be
C done by appropriately setting up the IINT array in CONVRT; we however
C keep this more general treatment for possible future uses when B (the
C nodal space) will have a different strucuture. 
C
        DO I=1,NTOT
          DO J=1,NC
            PROD=0.0
            DO K=1,NVAR
              PROD=PROD+B(K,J)*G(K,I)
            ENDDO
            DO K=1,NVAR
              G(K,I)=G(K,I)-PROD*B(K,J)
            ENDDO 
          ENDDO
        ENDDO

CD      DO I=1,NVAR
CD        WRITE (JOUT,'(8F10.5)') (G(I,K),K=1,NTOT)
CD      ENDDO

        DO I=1,NTOT
          DO J=I,NTOT
            AIJ=0.0
            DO K=1,NVAR
              AIJ=AIJ+G(K,I)*G(K,J)
            ENDDO
            A(I,J)=AIJ
            A(J,I)=AIJ
          ENDDO
          DIAGA(I)=A(I,I)
        ENDDO
        DO I=1,NTOT
          Z(I)=DHPB(I)-DD(I)
        ENDDO
* Bridge contribution
        DO N=1,NLOOP
          NPREIJ=NPRE(NPAIR(1,N))
          NPREIK=NPRE(NPAIR(2,N))
          ITB1=ITB(N,1)
          ITB2=ITB(N,2)
          II=ITB(N,3)
          IND=NHPB+3*(N-1)
          R01=R0B(1,II)
          R02=R0B(2,II)
          R03=R0B(3,II)
          AK1=CONB(1,II)
          AK2=CONB(2,II)
          AK3=CONB(3,II)
          IB1=NPREIJ+IBRID(2,ITB1)
          IS1=NPREIJ+IBRID(3,ITB1)
          IB2=NPREIK+IBRID(2,ITB2)
          IS2=NPREIK+IBRID(3,ITB2)
          Z(IND+1)=SQRT(AK1)*R01-DD(IND+1)
          Z(IND+2)=SQRT(AK2)*R02-DD(IND+2)
          Z(IND+3)=SQRT(AK3)*R03-DD(IND+3)
        ENDDO
        RL=RL/10.0
        DO 2 NUMMAR=1,MAXMAR  
          DO I=1,NTOT
            A(I,I)=DIAGA(I)+RL
            Y(I)=Z(I)
          ENDDO
          CALL BANACH(NTOT,A,Y)
          DIFX=0.0
CD        WRITE (JOUT,*) (Y(I),I=1,NTOT)
          DO I=1,NVAR
            XI=0.0
            DO K=1,NTOT
              XI=XI+G(I,K)*Y(K)
            ENDDO
CD          WRITE (JOUT,*) 'DX(',I,')=',DEG*XI
            IF ( (ABS(X(I)+X(I)).GT.1.0E+10) ) THEN 
               WRITE (*,*)'ERROR DISTFORCE: X1(',I,')=',DEG*(X(I)+XI)
            END IF
c             X1(I)=PINORM(X(I)+XI)
            X1IN=X(I)+XI
            X1(I)=PINORM(X1IN)
            IF (DIFX.LT.ABS(XI)) DIFX=ABS(XI)
          ENDDO
          IF (DIFX.LT.TOL .AND. RL.LT.1.0E-2) RETURN
          F1=FHPB(X1,DD)
cd        WRITE (JOUT,200) NUMMAR,RL,F1,DIFX
          IF (F1.LT.F0) THEN
            F0=F1
c           CALL TRANSFER(NVAR,X,X1)
c
            DO IK=1,NVAR
              X1(IK)=X(IK)
            ENDDO
c
            GOTO 1
          ELSE IF (ABS(F0-F1).LT.1.0E-5) THEN
            WRITE (JOUT,90)
            RETURN
          ENDIF
          RL=RL*10.0 
    2   CONTINUE
        WRITE (JOUT,90)
CD      STOP
        RETURN
cd  1   WRITE (JOUT,100) IT,F0,RL,(I,DEG*X(I),I=1,NVAR)
    1   CONTINUE
      ENDDO    
CD    DO I=1,NHPB
CD      WRITE (JOUT,*) I,DHPB(I),ALPHADIST(IHPB(I),JHPB(I))
CD    ENDDO
      RETURN
   90 FORMAT (/'Cannot improve the distance fit.')
  100 FORMAT (/'Iteration',I4,' distance',F10.4,' alpha',1PE8.1/
     1         'new X:',200(/I3,0PF10.4) )
  200 FORMAT ('Step',I4,'alpha',1PE8.1,' distance',0PF10.4,' difx=',
     & 1PE10.4)
      END
      SUBROUTINE FALSI(IRES,ILAM,X1,X2,F1,F2,YY,PHI0)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMS'
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.IOUNIT'
      DATA MAXITER /100/, TOLX /0.001/ TOLF /0.001/
*
* Regula falsi method
*       
      DO IT=1,MAXITER
        XMED=X1-F1*(X2-X1)/(F2-F1)
        IF (ILAM.EQ.1) THEN
          FMED=ANGLAM(PHI(IRES,XMED,YY)-PHI0)
        ELSE
          FMED=ANGLAM(PHI(IRES,YY,XMED)-PHI0)
        ENDIF
cd      write (jout,*) 'it',it,' xmed ',xmed,' fmed ',fmed
        IF ( (ABS(XMED-X1).LT.TOLX .OR. ABS(X2-XMED).LT.TOLX)
     1       .AND. ABS(FMED).LT.TOLF ) THEN
          X1=XMED
          F1=FMED
          RETURN
        ELSE IF ( FMED*F1.LT.0.0 ) THEN
          X2=XMED
          F2=FMED
        ELSE
          X1=XMED
          F1=FMED
        ENDIF
      ENDDO
      RETURN
      END 
      FUNCTION FHPB(X,DD)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      DIMENSION DD(MAXCNSTM),X(3*maxnum_res)
      DIMENSION A1(3),B1(3),S1(3),A2(3),B2(3),S2(3)

      CALL CONVRT(X,.FALSE.)
      CALL GENER
      FIT=0.0
      DO I=1,NHPB
        DD(I)=ALPHADIST(IHPB(I),JHPB(I))
        FIT=FIT+(DD(I)-DHPB(I))**2
      ENDDO
* 4/22/93 Bridge contribution.
      DO N=1,NLOOP
* correction for cyclic peptides     DR 4/29/94
        IJ=NPAIR(1,N)
        IK=NPAIR(2,N)
        NPREIJ=NPRE(IJ)
        NPREIK=NPRE(IK)
        IF (CYCLIC .AND. IJ.EQ.1) THEN
          IK=INUMRS
          NPREIK=NPRE(IK-1)
        ENDIF
* end correction
        IND=NHPB+3*(N-1)
        ITB1=ITB(N,1)
        ITB2=ITB(N,2)
        II=ITB(N,3)
        IA1=NPREIJ+IBRID(1,ITB1)
        IB1=NPREIJ+IBRID(2,ITB1)
        IS1=NPREIJ+IBRID(3,ITB1)
        IA2=NPREIK+IBRID(1,ITB2)
        IB2=NPREIK+IBRID(2,ITB2)
        IS2=NPREIK+IBRID(3,ITB2)
cd    WRITE (JOUT,*) 'IBRIDJ=',IBRID(1,ITB1),IBRID(2,ITB1),IBRID(3,ITB1)
cd    WRITE (JOUT,*) 'IBRIDK=',IBRID(1,ITB2),IBRID(2,ITB2),IBRID(3,ITB2)
        R01=R0B(1,II)
        R02=R0B(2,II)
        R03=R0B(3,II)
        AK1=CONB(1,II)
        AK2=CONB(2,II)
        AK3=CONB(3,II)
        AROB=ARB(II)
        NBBT=NBBB(II)
cd      WRITE (16,*) 'II=',II,' ITB1=',ITB1,' ITB2=',ITB2
cd      WRITE (16,*) 'IA1=',IA1,' IB1=',IB1,' IS1=',IS1
cd      WRITE (16,*) 'IA2=',IA2,' IB2=',IB2,' IS2=',IS2
cd      WRITE (16,*) 'R01=',R01,' R02=',R02,' R03=',R03
cd      WRITE (16,*) 'AK1=',AK1,' AK2=',AK2,' AK3=',AK3
        DO L=1,3                                 
          A1(L)=COORD(L,IA1)                          
          B1(L)=COORD(L,IB1)                         
          S1(L)=COORD(L,IS1)                        
          A2(L)=COORD(L,IA2)                        
          B2(L)=COORD(L,IB2)                       
          S2(L)=COORD(L,IS2)                      
        ENDDO                                     
        D1=DST(S1,S2)                              
        DD(IND+1)=D1*SQRT(AK1)
        FIT=FIT+AK1*(D1-R01)**2
        D2=DST(B1,S2)  
        DD(IND+2)=D2*SQRT(AK2)
        FIT=FIT+AK2*(D2-R02)**2
        D3=DST(S1,B2)      
        DD(IND+3)=D3*SQRT(AK3)
        FIT=FIT+AK3*(D3-R03)**2
      ENDDO
      FHPB=FIT
      RETURN
      END
      INTEGER FUNCTION KAX(K)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      DO 100 I=1,INUMRS
        JJ = I
        IF ( K. LE. NPRE(I) ) GOTO 110
 100  CONTINUE
 110  KAX = JJ -2
      RETURN
      END
      SUBROUTINE LAMEVAL(IRES,ILAM,IANG)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.BONDSX'
      REAL LAM1,LAM11,LAM2,LAMF
      LOGICAL SFLAG
      DIMENSION XINT(100,2),OBFUN(100,2)
      DATA NLAMSCAN /10/, NTRIAL /10/
      AINLAM=10.0*RAD
C     PHI0=-75.0*IANG*RAD
C
C 2/6/93 PHI0 corrected following the upgrade to ECEPP/3 force field.
C
C     PHI0=-68.780*IANG*RAD
C
C 10/17/93 PHI0 will be taken directly from the ANGULO array to avoid 
C          confusion.
C
      PHI0=ANGULO(1,IRES+1)
      NINT=0
cd    write (jout,*) 'ires',ires,' ilam',ilam,' iang',iang
cd    write (jout,*) (rrl(i),i=1,nres2)
      IF (ILAM.EQ.2) THEN
        LAM1=RRL(IRES-1)
cd      write (jout,*) 'ires',ires,' lam1 ',lam1
        LAMF=LAM1
      ELSE
        LAM2=ALAM2(IRES)
cd      write (jout,*) 'ires',ires,' lam2 ',lam2
        LAMF=LAM2
      ENDIF
      F1=0.0
      IF (ILAM.EQ.1) THEN
*********************
* Changes on 5/17/91
*
* LAMBDA1 to be varied. It should be approximately equal to the desired 
* value of the angle PHI. 
*
        LAM1=PHI0
        F1=ANGLAM(PHI(IRES,LAM1,LAM2)-PHI0)
        IF (ABS(F1).LT.1.0E-3) THEN
          RRL(IRES-1)=LAM1
          RETURN
        ENDIF
*
* Determine the search direction
*
        SFLAG=.FALSE.
*       write (jout,*) 'f1',f1
        DO I=1,NTRIAL
   20   LAM11=LAM1+AINLAM
        F2=ANGLAM(PHI(IRES,LAM11,LAM2)-PHI0)
*       write (jout,*) 'trial',i,' f2',f2
        IF (F2.LT.F1 .AND. F1.GT.0.0 .OR. F2.GT.F1 .AND. F1.LT.0.0) THEN
*         write (jout,*) 'huhu'
          DO II=1,NLAMSCAN
*           write (jout,*) f1,f2,f1*f2
            IF (F1*F2.LT.0.0) THEN
              NINT=1
              IF (LAM1.GT.LAM11) THEN
                AUX=LAM1
                LAM1=LAM11
                LAM11=AUX 
                AUX=F1
                F1=F2
                F2=AUX
              ENDIF
              XINT(1,1)=LAM1 
              XINT(1,2)=LAM11
              OBFUN(1,1)=F1
              OBFUN(1,2)=F2
              GO TO 10
            ELSE
              LAM1=LAM11
              LAM11=LAM11+AINLAM
              F1=F2
              F2=ANGLAM(PHI(IRES,LAM11,LAM2)-PHI0)
            ENDIF
          ENDDO
          NINT=0
          GO TO 10
        ELSE
          IF (SFLAG) THEN
            SFLAG=.FALSE.
            AINLAM=AINLAM/2.0
          ELSE
            SFLAG=.TRUE.
            AINLAM=-AINLAM
            GOTO 20
          ENDIF               
        ENDIF
        ENDDO
        NINT=0
        GO TO 10
      ELSE
*
* LAMBDA2 to be varied. Perhaps there is a solution, but we have to scan the
* whole interval.
* 
        DO I=-180,180,2
          LAM2=(I+0.0)*RAD
          F2=ANGLAM(PHI(IRES,LAM1,LAM2)-PHI0)
*         write (jout,*) 'x ',i*rad,' f ',f2
          IF (F1*F2.LT.0.0 .AND. ABS(F2-F1).LT.DWAPI-0.5) THEN
            NINT=NINT+1
            XINT(NINT,1)=(I-2)*RAD
            XINT(NINT,2)=I*RAD
            OBFUN(NINT,1)=F1
            OBFUN(NINT,2)=F2
*           write (jout,*) 'nint ',nint,' f1 ',f1,' f2 ',f2
          ENDIF 
          F1=F2
        ENDDO  
      ENDIF
   10 IF (NINT.EQ.0) THEN
      WRITE (JOUT,*) 'ERROR - PROLINE IMPOSSIBLE TO LOCATE'    
      ENDIF
*     write (jout,*) 'ires',ires,' ilam',ilam,' nint',nint
      DO II=1,NINT
*       write (jout,*) 'x1 ',xint(ii,1),' x2 ',xint(ii,2)
*       write (jout,*) 'f1 ',obfun(ii,1),' f2 ',obfun(ii,2) 
        CALL FALSI(IRES,ILAM,XINT(II,1),XINT(II,2),OBFUN(II,1),
     1             OBFUN(II,2),LAMF,PHI0)
*       write (jout,*) 'x ',xint(ii,1),' f ',obfun(ii,1)
        IF (ILAM.EQ.1) THEN  
          RRL(IRES-1)=XINT(II,1)
        ELSE
          IF (IRES.LT.NRES1) THEN
            RRL(IRES)=ANGLAM(RAD*GAMA(IRES+2)-PI-XINT(II,1))
          ELSE
            RRL(IRES)=XINT(II,1)
          ENDIF
        ENDIF
      ENDDO
      RETURN
      END
      FUNCTION PHI(I,RL1,RL2)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.IOUNIT'
C
C Calculate the angle phi given the angles lambda and gamma.
C
      TT=THET(I,RL1,RL2)
cd    write (jout,*) 'i',i,' lambda1 ',rl1/rad,' lambda2 ',rl2/rad,
cd   1            ' theta ',tt/rad
      COSKSI=COS(KSI(I))
      SINKSI=SIN(KSI(I))
      COSETA=COS(ETA(I))
      SINETA=SIN(ETA(I))
      COSL1=COS(RL1)
      SINL1=SIN(RL1)
      COSL2=COS(RL2)
      SINL2=SIN(RL2)
      COSTHETA=COS(TT)
      SINTHETA=SIN(TT)
      COSA=COS(ALPH1(I))
      SINA=SIN(ALPH1(I))
      U1=SINKSI
      U2=COSKSI*COSL1 
      U3=COSKSI*SINL1
      A1=COSKSI
      A2=-SINKSI*COSL1
      A3=-SINKSI*SINL1
      B1=COSTHETA*COSETA-SINTHETA*SINETA*COSL2
      B2=SINTHETA*COSETA+COSTHETA*SINETA*COSL2
      B3=SINETA*SINL2
      PROD=A1*B1+A2*B2+A3*B3
      V1=B1-PROD*A1
      V2=B2-PROD*A2
      V3=B3-PROD*A3
      VNORM=SQRT(V1*V1+V2*V2+V3*V3)
      V1=V1/VNORM
      V2=V2/VNORM
      V3=V3/VNORM
      UV1=U2*V3-U3*V2
      UV2=V1*U3-U1*V3
      UV3=U1*V2-U2*V1
      COSPHI=U1*V1+U2*V2+U3*V3
      znak=uv1*a1+uv2*a2+uv3*a3
      znak=-sign(1.0,znak)
*     write (2   ,*) arcos(cosphi)/rad,znak
      PHI=ZNAK*ARCOS(COSPHI)
      RETURN
      END        
      SUBROUTINE PHIPSI(IIRES)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      DIMENSION GAM1(MAXNUM_RES)
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.EDMC'
      LOGICAL LPROLIN
      DATA IONE /1/
* Calculate phi and psi for the succeeding residue
      IRES=IIRES
cd    call druang(jout,ndone)
cd    call gener
cd    write (jout,*) '************phipsi initial*************'
cd    write (jout,*) 'rl=',(rl(i)/conv,i=nst,nen-1)
cd    write (jout,*) 'theta=',(theta(i)/conv,i=nst,nen)
cd    write (jout,*) 'gamma=',(gama(i)/conv,i=nst,nen)
cd    do i=nst+1,nen-1
cd      phi1=beta(iat(i-1,3),iat(i,2),iat(i,1),iat(i,3))/conv
cd      psi1=beta(iat(i,2),iat(i,1),iat(i,3),iat(i+1,2))/conv 
cd      rl1=rl(i-1)  
cd      rl2=alam2(i)
cd      rrl2=beta(iat(i+1,2),iat(i+1,1),iat(i,1),iat(i-1,1))
cd      phi2=phi(i,rl1,rl2)/rad
cd      psi2=psi(i,rl1,rl2)/rad
cd      write (jout,'(2hi=,i2,4h phi=,2f10.3,4h psi=,2f10.3)') i,phi1,
cd   &               phi2,psi1,psi2
cd      write (jout,'(2x,5hlam1=,f10.3,6h lam2=,f10.3)') rl1/rad,rl2/rad
cd      write (jout,*) rrl2/conv
cd    enddo 
cd    do i=nst,nen-3
cd      i1=iat(i,1)
cd      i2=iat(i+1,1)
cd      i3=iat(i+2,1)
cd      i4=iat(i+3,1)
cd      gam1(i)=beta(i1,i2,i3,i4)
cd    enddo
cd    write (jout,*) 'gamma=',(gam1(i)/rad,i=nst,nen-3)
      IF (IRES.LT.NEN-1) THEN
        RL1=RL(IRES)
        RL2=ALAM2(IRES+1)
        ANGULO(1,IRES+1)=PHI(IRES+1,RL1,RL2)
        ANGULO(2,IRES+1)=PSI(IRES+1,RL1,RL2)
      ENDIF
* Move backward to calculate the phi and psi angles induced by the change
* in lambda.
      IPRO=1
      DO WHILE (IPRO.NE.0 .AND. IRES.GT.NST)
        IPRO=0
        IF (LPROLIN(IRES)) THEN
          IPRO=1
          IF (LIST(IRES).LT.0) IPRO=-1
          CALL LAMEVAL(IRES,IONE,IPRO)
        ENDIF
        RL1=RL(IRES-1)
        RL2=ALAM2(IRES)
        ANGULO(1,IRES)=PHI(IRES,RL1,RL2)
        ANGULO(2,IRES)=PSI(IRES,RL1,RL2)
cd      write (jout,*) 'dowhile ires=',ires,' rl1=',rl1/rad,
cd   1                     ' rl2=',rl2/rad
cd      write (jout,*) 'phi=',angulo(1,ires)/rad,' psi=',
cd   1angulo(2,ires)/conv
        IRES=IRES-1
      ENDDO
cd    call gener
cd    call druang(jout)
cd    write (6,*) '********************phipsi final****************' 
cd    write (6,*) 'rl=',(rl(i)/rad,i=nst,nen-1)
cd    write (6,*) 'theta=',(theta(i)/rad,i=nst,nen)
cd    write (6,*) 'gamma=',(gama(i)/rad,i=nst,nen)
cd    do i=nst,nen-3
cd      i1=iat(i,1)
cd      i2=iat(i+1,1)
cd      i3=iat(i+2,1)
cd      i4=iat(i+3,1)
cd      gam1(i)=beta(i1,i2,i3,i4)
cd    enddo
cd    write (jout,*) 'gamma=',(gam1(i)/rad,i=nst,nen-3)
cd    do i=nst+1,nen-1
cd      phi1=beta(iat(i-1,3),iat(i,2),iat(i,1),iat(i,3))/conv
cd      psi1=beta(iat(i,2),iat(i,1),iat(i,3),iat(i+1,2))/conv 
cd      rl1=rl(i-1)  
cd      rl2=alam2(i)
cd      rrl2=beta(iat(i+1,2),iat(i+1,1),iat(i,1),iat(i-1,1))
cd      phi2=phi(i,rl1,rl2)/conv
cd      psi2=psi(i,rl1,rl2)/conv
cd      write (jout,'(2hi=,i2,4h phi=,2f10.3,4h psi=,2f10.3)') i,phi1,
cd   &    phi2,psi1,psi2
cd      write (jout,'(2x,5hlam1=,f10.3,6h lam2=,f10.3)') rl1/rad,rl2/rad
cd      write (jout,*) rrl2/rad
cd    enddo 
      RETURN
      END
      SUBROUTINE PLACO (EPS)
C Modification of  Max Vasquez  routine PLACO.         APR-7-94. DR
c this is called at the beginning to prepare for sampling from
c `general' low-energy regions
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      DIMENSION P(2,20)

      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.COSACO'
C     COMMON/COSACO/ DEL (7,20), EX (10),ISX, IIP
C      REAL ISX, EXX (10)
       REAL EXX (10)

      DATA P /0.010,0.163,0.006,0.304,0.011,0.180,0.018,0.203,
     1 0.002,0.113,0.102,0.000,0.010,0.208,0.001,0.167,
     2 0.012,0.192,0.018,0.268,0.010,0.265,0.008,0.214,
     3 0.100,0.166,0.017,0.260,0.007,0.310,0.015,0.053,
     4 0.003,0.140,0.004,0.281,0.004,0.193,0.001,0.0084/
      DATA EXX /180.0,140.0,90.0,80.0,20.0,200.0,-10.0,170.0,
     1 20.,0.0/

C     IIP = 0
c  check if there are defined sampling regions
      IF( REGSAMP) CALL REGION
      DO 10 J=1,10
C        EX(J) = EXX(J)
C Convert to radians here.        DR APR94
        EX(J) = RAD*EXX(J)
10    CONTINUE
      DO 100 I=1,20
C
           II=I
           IF(I.EQ.13.OR.I.EQ.6) GO TO 50
C
C     ALA-TYPE RESIDUE
C
                T=1.0-EPS
                DEL(1,II)=T
                DEL(2,II)=1.0/EPS
                DEL(3,II)=T*(1.0-P(1,II))
                DEL(4,II)=1.0/(T*(P(1,II)))
                S=T*(1.0-P(1,II)-P(2,II))
                DEL(5,II)=S
                DEL(6,II)=1.0/(T*P(2,II))
                DEL(7,II)=1.0/S
           GO TO 100
C
 50   IF(I.EQ.6) GO TO 70
C
C   PROLINE
C
           JJ=0
           DO 60 J=1,2
           JJ=JJ+1
           DEL(JJ,II)=P(J,II)
           JJ=JJ+1
           DEL(JJ,II)=1.0/(1.0-P(J,II))
           JJ=JJ+1
           DEL(JJ,II)=1.0/P(J,II)
 60        CONTINUE
           GO TO 100
C
C    GLYCINE
C
 70        T=1.0-EPS
           DEL(1,II)=T
           DEL(2,II)=1.0/EPS
           S=(1.0-P(1,II))*T
           DEL(3,II)=S
           DEL(4,II)=1.0/(T*P(1,II))
           DEL(5,II)=1.0/S
C
 100  CONTINUE
C
C
      RETURN
      END
      FUNCTION PSI(I,RL1,RL2)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMS' 
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.IOUNIT'

      TT=THET(I,RL1,RL2)
cd    write (jout,*) 'i',i,' lambda1 ',rl1/rad,' lambda2 ',rl2/rad,
cd   1  ' theta ',tt/rad,theta(i+1)/rad
      COSKSI=COS(KSI(I))
      SINKSI=SIN(KSI(I))
      COSETA=COS(ETA(I))
      SINETA=SIN(ETA(I))
      COSL1=COS(RL1)
      SINL1=SIN(RL1)
      COSL2=COS(RL2)
      SINL2=SIN(RL2)
      COSTHETA=COS(TT)
      SINTHETA=SIN(TT)
      COSA=COS(ALPH1(I))
      SINA=SIN(ALPH1(I))
      U1=( COSTHETA*COSKSI-SINTHETA*SINKSI*COSL1-COSA*COSETA)/SINA
      U2=(-SINTHETA*COSKSI-COSTHETA*SINKSI*COSL1-COSA*SINETA*COSL2)/SINA
      U3=(-SINKSI*SINL1-COSA*SINETA*SINL2)/SINA
cd    u1= costheta*cosksi-sintheta*sinksi*cosl1
cd    u2=-sintheta*cosksi-costheta*sinksi*cosl1
cd    u3=-sinksi*sinl1
      V1= SINETA
      V2=-COSETA*COSL2
      V3=-COSETA*SINL2 
      A1= COSETA
      A2= SINETA*COSL2
      A3= SINETA*SINL2
cd    write (jout,*) 'cosa',u1*a1+u2*a2+u3*a3,'  ',cosa
      UV1=U2*V3-U3*V2
      UV2=V1*U3-U1*V3
      UV3=U1*V2-U2*V1
cd    print *,'UoA ',u1*a1+u2*a2+u3*a3
cd    print *,'VoA ',v1*a1+v2*a2+v3*a3
cd    print *,'UoU ',u1*u1+u2*u2+u3*u3
cd    print *,'VoV ',v1*v1+v2*v2+v3*v3
cd    print *,'AoA ',a1*a1+a2*a2+a3*a3
      COSPSI=U1*V1+U2*V2+U3*V3
      znak=uv1*a1+uv2*a2+uv3*a3
      znak=sign(1.0,znak)
cd    write (jout,*) 'cospsi',cospsi
cd    write (jout,*) arcos(cospsi)/rad,znak
      psi=znak*arcos(cospsi)
      return
      end
      subroutine region

C Modification of  Max Vasquez  routine REGION.         APR-7-94. DR
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.GEN100'
      include 'COMMON.IOUNIT'
      include 'COMMON.REGG'
      include 'COMMON.NNDRUK'
      character*2 tempch(20)
      integer itempw(20)
       real p(21)

      do i=1, nares
         if ( (izz(1,i).eq.1) .or. (izz(1,i).gt.(inumrs-1)) ) then
          write(jout,'(2a,i4,a,i4)') 'ERROR: Region sampling ',
     &     ' specified for a wrong residue=', izz(1,i), 
     &     ' INUMRS-1= ', inumrs-1
         stop
         endif
      enddo
C Check that we don't have repetitions (double especifications).
      do j=1,nares-1
         ifirst=0
         do i=j+1, nares
            if (izz(1,i).eq.izz(1,j) ) then
               write(jout,*)'Error: sampling regions for residue ',
     &                         j,'were specified more than once. '
            stop
            endif
         enddo
      enddo
C NARES must be smaller than INUMRS.
      nexpos=nares+1
      do 10 j=1, inumrs
         do i=1, nares
           if (izz(1,i).eq.j ) goto 10
         enddo
C no regions specified for residue j
         izz(1,nexpos)=j
         izz(2,nexpos)=0
         nexpos=nexpos+1 
10    continue

C reorder izz and zz arrays.
      do j=1, inumrs
         do i=1, inumrs
           if (i .ne.j .and. izz(1,i).gt.izz(1,j) ) then
              nzz1= izz(1,i)
              nzz2= izz(2,i)
              do k=1, nzz2
                 tempch(k)=zz(k,i)
                 itempw(k)=iwzz(k,i)
              enddo
              izz(1,i)= izz(1,j)
              izz(2,i)= izz(2,j)
              do k=1,izz(2,j)
                 zz(k,i)=zz(k,j)
                 iwzz(k,i)=iwzz(k,j)
              enddo
      
              izz(1,j)= nzz1
              izz(2,j)= nzz2
              do k=1, nzz2
                 zz(k,j)= tempch(k)
                 iwzz(k,j)= itempw(k)
              enddo
           endif
         enddo
      enddo

      do i=2, inumrs-1
        if(nukco.ne.0) write(jout,'(2i4,5x,20(1x,a2))') i,izz(1,i),
     &                             (zz(k,i), k=1,izz(2,i))
        if(nukco.ne.0) write(jout,'(2i4,5x,20i3)') i, izz(1,i),
     &    (iwzz(k,i), k=1,izz(2,i))
      enddo

C   Now, generate probability distribution for regions of each residue. 
C   DR  added  DEC94.
      do 20 i=2, inumrs-1
         nzz2= izz(2,i)
C
C Residues that are not specified will not have "region" sampling.
         if (nzz2.eq.0 ) goto 20
         do k=1, nzz2
            pzk(k)= 1.0*iwzz(k,i)
         enddo

         call gendistr(nzz2,pzk,p)
         do k=1, nzz2+1
            pzz(k,i)=p(k)
         enddo
C     write(jout,'(2i4,5x,10f6.1)') i,izz(2,i),(pzz(k,i),k=1,nzz2+1)
20    continue

40    return
1000  format (a2)
1010  format (5x,20a2)
      end
      FUNCTION THET(I,RL1,RL2)  
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMS'
      INCLUDE 'COMMON.PEPT'
C
C Calculate the virtual-bond angle theta given the angles lambda.
cd    print *,i,rl1/rad,rl2/rad,ksi/rad,eta/rad,alpha(i)
      COSKSI=COS(KSI(I))
      SINKSI=SIN(KSI(I))
      COSETA=COS(ETA(I))
      SINETA=SIN(ETA(I))
      COSL1=COS(RL1)
      SINL1=SIN(RL1)
      COSL2=COS(RL2)
      SINL2=SIN(RL2)
      COSALF=COS(ALPH1(I))
      BB=-SINKSI*COSETA*COSL1-COSKSI*SINETA*COSL2
      AA=COSKSI*COSETA-SINKSI*SINETA*COSL1*COSL2
      CC=-SINKSI*SINETA*SINL1*SINL2-COSALF
      DELTA=SQRT(AA*AA+BB*BB-CC*CC)
      T1=-ATAN((BB+DELTA)/(CC-AA))
      T2=-ATAN((BB-DELTA)/(CC-AA))
      IF (T1.LT.0.0) T1=T1+PI
      IF (T2.LT.0.0) T2=T2+PI
      T1=2.0*T1
      T2=2.0*T2
      T=T1
cd    print *,i,t1/rad,t2/rad
cd    pause
      IF (T1.GT.PI) T=T2
      THET=T
cd    print *,acos(aa*cos(t)+bb*sin(t)-sinksi*sineta*sinl1*sinl2)/rad
      RETURN
      END
      SUBROUTINE SAREG (BACK,RR,IRES)
C Modification of  Max Vasquez  routine SAREG.         APR-7-94. DR
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.IOUNIT'
      CHARACTER*2 RR
      CHARACTER*1 RR1, RR2
      REAL BACK (2)

      RR1 = RR(1:1)
      RR2 = RR(2:2)
      IF ((RR2.NE.'+').AND. (RR2.NE.'-')) THEN

C    SAMPLE FROM ZIMMERMAN REGIONS. 
C
         IF (RR2.EQ.' ') THEN
C     RR2 .EQ. ' '  REFERS TO THE NEGATIVE-PHI REGION
           SG = RAD
         ELSEIF (RR2.EQ.'*') THEN
C     RR2 .EQ. '*'  REFERS TO THE POSITIVE-PHI REGION
           SG = -1.0*RAD
         END IF
C RR1 is A to  H. 
         IF (RR1.EQ.'A') THEN
           BACK(1) = SG*(-110.0 + BACK(1)*70.0)
           BACK(2) = SG*(-90.0 + BACK(2)*80.0)
         ELSE IF (RR1.EQ.'B') THEN
C                   SUBDIVIDE 'B' REGION INTO TWO (EQUAL) RECTANGLES
C Note:  The random number for BACK(1) has to be renormalized.
           IF (BACK(1).LE.0.50) THEN
             BACK(1) = SG*(-180.0 + BACK(1)*70.0/0.50)
             BACK(2) = SG*(-40.0 + BACK(2)*60.0)
           ELSE
             BACK(1) = SG*(-110.0 + (BACK(1)-0.50)*70.0/0.50)
             BACK(2) = SG*(-10.0 + BACK(2)*60.0)
           END IF
         ELSE IF (RR1.EQ.'C') THEN
           BACK(1) = SG*(-110.0 + BACK(1)*70.0)
           BACK(2) = SG*(50.0 + BACK(2)*80.0)
         ELSE IF (RR1.EQ.'D') THEN
           BACK(1) = SG*(-180.0 + BACK(1)*70.0)
           BACK(2) = SG*(20.0 + BACK(2)*90.0)
         ELSE IF (RR1.EQ.'E') THEN
           BACK(1) = SG*(-180.0 + BACK(1)*70.0)
           BACK(2) = SG*(110.0 + BACK(2)*110.0)
         ELSE IF (RR1.EQ.'F') THEN
           BACK(1) = SG*(-110.0 + BACK(1)*70.0)
           BACK(2) = SG*(130.0 + BACK(2)*90.0)
         ELSE IF (RR1.EQ.'G') THEN
           BACK(1) = SG*(-180.0 + BACK(1)*70.0)
           BACK(2) = SG*(-90.0 + BACK(2)*50.0)
         ELSE IF (RR1.EQ.'H') THEN
C                   SUBDIVIDE 'H' REGION INTO TWO ( NON-EQUAL) RECTANGLES
C ratio of the two regions to the total area  is 0.3271 and 0.6729
           IF (BACK(1).LE.0.3271) THEN 
C    1/ 0.3271 = 3.0571691
C          	BACK(1) = SG*(-180.0 + BACK(1)*140.0*3.0571691)
           	BACK(1) = SG*(-180.0 + BACK(1)*428.00)
           	BACK(2) = SG*(-140.0 + BACK(2)*50.0)
           ELSE
C   1/ 0.6729 = 1.4861049
C          	BACK(1) = SG*(-40.0 + (BACK(1)-0.3271)*40.0*1.4861049)
           	BACK(1) = SG*(-40.0 + (BACK(1)-0.3271)*59.44)
           	BACK(2) = SG*(-180.0 + BACK(2)*360.0)
           END IF
         ELSE
           WRITE(JOUT,1000) IRES, RR
           STOP  1000
         ENDIF
      ELSE
C   SAMPLE FROM POPOV REGIONS. 
C RR1 IS S (SHEET) OR H (HELIX)
C     RR2 .EQ. '-' or '+'  DEFINES SAMPLING FROM POPOV'S REGIONS
         IF (RR2.EQ.'-') THEN
C     RR2 .EQ. '-'  REFERS TO THE NEGATIVE-PHI REGION
           SG = RAD
         ELSEIF (RR2.EQ.'+') THEN
C     RR2 .EQ. '*'  REFERS TO THE POSITIVE-PHI REGION
           SG = -1.0*RAD
         END IF
         IF (RR1.EQ.'H') THEN
           BACK(1) = SG*(-120.0 + BACK(1)*80.0)
           BACK(2) = SG*(-90.0 + BACK(2)*110.0)
         ELSE IF (RR1.EQ.'S') THEN
           BACK(1) = SG*(-180.0 + BACK(1)*140.0)
           BACK(2) = SG*(20.0 + BACK(2)*200.0)
         ELSE
           WRITE(JOUT,1000) IRES, RR
           STOP 1100
         END IF
      END IF
      RETURN
1000  FORMAT (2X, ' RES NUMBER', I5, 2X, 'HAS A WRONG CODE',2X,A2)
      END
      SUBROUTINE READ_ECEPP_CONS
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'

      INTEGER NUM(2), LOC(50,2)
      CHARACTER*4 RATOM1,RATOM2
      CHARACTER*80 LINE,LINE1,UCASE
      CHARACTER*64 FNAME
      CHARACTER*8   WORDDH
      CHARACTER*10 LCHARA(10)
      LOGICAL LCOM,GRPFLG,NOT_FINIS
      LOGICAL BLANKLINE,ERRFLAG

      DATA SMALL /0.10000E-3/

      WRITE(*,1002) NPAIR1, NPAIR2
      WRITE(JOUT,1992)
      WRITE(JOUT,1002) NPAIR1, NPAIR2
      UTOL = 0.10D0
      BTOL = 1.0 + UTOL
      STOL = 1.0 - UTOL
      IF ( STOL .LT. 0.0 ) STOL = 1.0E-5
      FNAME=DISTFILE
      JUNI=JDIST     
      WRITE(JOUT,'(A,I2,1X, A/)')'OPENING UNIT ',JUNI, FNAME
      OPEN (JDIST,FILE=DISTFILE,STATUS='OLD',ERR=5555)

C Use of NPAIR1 is  OBSOLETE since we can now point specifically to
C any atom using label descriptions through file "nmr_protons.data"  
C left only for compatibility with older versions.
C DR. FEB98

      DO 20 I=1,NPAIR1
 22     READ (JDIST,'(A)',END=808) LINE
C IF THE FIRST CHARACTER ON THE LINE IS '#' or '!' discard it.
        IF (  LCOM(1,LINE(1:1) )  ) GOTO 22
        READ (LINE,*,ERR=908) NMOL1, IFX, NMOL2, ISX, BLX, BUX, WEIGHT
C
C Unformatted: 1     34      1     51      1.900       5.000        10.0
C where       mol1 atm.No.  mol2 atm.No. lower-bound  upper-bound  weight
C if lower-bound is -1.000, then VDW contact is assumed.
C
C         write(JOUT,1000) IFX, ISX
C                          GET RESIDUE NUMBERS FOR ATOMS IFX AND ISX
C Code for more than 1 molecule has not been implemented, yet
        NMOLA(1,I)= NMOL1
        NMOLA(2,I)= NMOL2
        IF(ABS(WEIGHT).LT.SMALL) THEN
          WRITE(JOUT,'(a40,i4,a10,f8.3)')
     &      'Check: small WEIGHT for bound No: ',I, ' WEIGHT= ',WEIGHT
          WRITE(JOUT,'(A)' )LINE
        END IF
        WEI(I)=WEIGHT
        KI = KAX(IFX)
        KJ = KAX(ISX)
        NR1(1,I) = KI
        NR1(2,I) = KJ
        ATO1(1,I) = ALPH(IFX)
        ATO1(2,I) = ALPH(ISX)
        IF (IORDER.EQ.0) THEN
C                               Order by range, a la Braun-Go
          KAES(I) = IABS(KI-KJ)
        ELSE IF (IORDER.EQ.1) THEN
C                                 Keep order as in input distances
          KAES(I) = I
        ELSE
C                               Order by growing from N-terminus
          KAES(I) = MAX(KI,KJ)
        END IF
        IDI(1,I) = IFX
        IDI(2,I) = ISX
C       READ(JDIST,1001,END=908) BUX, BLX
C       WRITE(JOUT,1001) BUX, BLX
C TESTS TO CHECK IF UPPER AND LOWER BOUND ARE GIVEN IN THE CORRECT ORDER.
C DR   MAR94
        IF( BUX. LT. BLX ) THEN
          WRITE(JOUT,'(2A/A/A)')'WARNING: NPAIR1: UPPER AND',
     &     ' LOWER BOUND WERE ASSIGNED INCORRECTLY.',
     &     '(UPPER BOUND < LOWER BOUND) VALUES ARE EXCHANGED:', LINE
          BLLLX =BLX
          BLX= BUX
          BUX=BLLLX
        ENDIF
        IF( BUX. GE. 0.0 ) THEN
          IF ( BLX.LE.0.0) THEN
            BU = BTOL * BUX
            BL = STOL * BUX
          ELSE
            BU = BUX
            BL = BLX
          END IF
          DISO(1,I)=BU
          DISO(2,I)=BL
        ELSE
          DISO(1,I) = ABS(BUX)
          DISO(2,I) = 0.00
        END IF
 20   CONTINUE

      NPAI2 = 0
      DO 50 I=1,NPAIR2
 52     READ (JDIST,'(A80)',END=809) LINE
        IF (  LCOM(1,LINE(1:1) )  ) GOTO 52
C       WRITE(*,*)LINE(1:80)
C       READ (LINE,3000,ERR=909) NMOL1,NRE(1,I),RATOM1,
C    &              NMOL2,NRE(2,I),RATOM2, SUX, BUX, WEIGHT
C       READ (LINE,3000,ERR=909) NMOL1,NRE1,RATOM1,
C    &              NMOL2,NRE2,RATOM2, SUX, BUX, WEIGHT

c       WRITE(JOUT,*) ,NRE1,RATOM1, NRE2,RATOM2, SUX, BUX, WEIGHT
C formatted read: 
C           1    1    HCA     1     1    HCB   -1.000   3.000     10.0
C where   mol1  res1  atm    mol2  res2  atm    low-b    upp-b   weight
C if lower-bound is -1.000, then VDW contact is assumed.
C

        IPOS=1
        BLANKLINE=.FALSE.
        ERRFLAG=.FALSE.
C read the nine record of this info.
        DO  K= 1, 9
            CALL MYKEY(LINE,LINE1,IPOS,BLANKLINE,ERRFLAG)
            IE=1
            IF (ERRFLAG) GOTO 708
            IF (.NOT. BLANKLINE .AND. .NOT. ERRFLAG) THEN
              IE=2
              READ (LINE1,'(A10)',END=708,ERR=708) LCHARA(K)
            ELSE
              IE=3
              GOTO 708
            ENDIF
        ENDDO
        READ (LCHARA(1),'(I5)',ERR=708)  NMOL1
        READ (LCHARA(2),'(I5)',ERR=708)  NRE1
        READ (LCHARA(3),'(A4)',ERR=708)  RATOM1
        READ (LCHARA(4),'(I5)',ERR=708)  NMOL2
        READ (LCHARA(5),'(I5)',ERR=708)  NRE2
        READ (LCHARA(6),'(A4)',ERR=708)  RATOM2
        READ (LCHARA(7),*,ERR=708)  SUX
        READ (LCHARA(8),*,ERR=708)  BUX
        READ (LCHARA(9),*,ERR=708)  WEIGHT

        WRITE(JOUT,*)  NRE1,RATOM1, NRE2,RATOM2, SUX, BUX, WEIGHT

        RATOM1= UCASE(RATOM1)
        RATOM2= UCASE(RATOM2)
        IF(ABS(WEIGHT).LT.SMALL) THEN
          WRITE(JOUT,'(a,i4)')' Check: small WEIGHT for bound No. ',I
        END IF
C TESTS TO CHECK IF UPPER AND LOWER BOUND ARE GIVEN IN THE CORRECT ORDER.
C DR   MAR94
        IF( BUX. LT. SUX ) THEN
          WRITE(JOUT,'(2A/A/A)')'WARNING: NPAIR1: UPPER AND',
     &     ' LOWER BOUND WERE ASSIGNED INCORRECTLY.',
     &     '(UPPER BOUND < LOWER BOUND) VALUES ARE EXCHANGED:', LINE
          SUUUX =SUX
          SUX= BUX
          BUX=SUUUX
        ENDIF
C DETERMINE THE ATOMS AND TYPE OF BOUND. 
C       WRITE(*,*)' NRE1 RATOM1 NRE2 RATOM2', NRE1,RATOM1,NRE2,RATOM2
        CALL ANALATM(NRE1,RATOM1,NRE2,RATOM2,NUM,LOC,GRPFLG)
        ATOM(1,I)= RATOM1
        ATOM(2,I)= RATOM2
        NRE(1,I)= NRE1
        NRE(2,I)= NRE2
C         WRITE(JOUT,1071) NRE1,RATOM1,NRE2,RATOM2
C         WRITE(*,1071) NRE1,RATOM1,NRE2,RATOM2
C1071     FORMAT(' AT1= ',I5,1X, A4,' AT2= ',I5,1X, A4)

C         IF( GRPFLG) THEN
C           WRITE(*,*) ' num1= ',NUM(1),' num2= ',NUM(2),' GROUP'
C           WRITE(*,*) 'LOC1 ', (loc(k,1), k=1,num(1) ) 
C           WRITE(*,*) 'LOC2 ', (loc(k,2), k=1,num(2) ) 
C           WRITE(JOUT,*) ' num1= ',NUM(1),' num2= ',NUM(2),' GROUP'
C           WRITE(JOUT,*) 'LOC(K,1) ', (loc(k,1), k=1,num(1) ) 
C           WRITE(JOUT,*) 'LOC(K,2) ', (loc(k,2), k=1,num(2) ) 
C         ELSE
C           WRITE(*,1072) NUM(1),LOC(1,1),NUM(2),LOC(1,2)
C           WRITE(JOUT,1072) NUM(1),LOC(1,1),NUM(2),LOC(1,2)
C         ENDIF
C1072     FORMAT(' num1= ',i4,' loc1= ',i4,' num2= ',i4,' loc2= ',i4,/)

        IF (NUM(1).EQ.1.AND.NUM(2).EQ.1) THEN
           NPAIR1 = NPAIR1 + 1
C Code for more than 1 molecule has not been implemented, yet
           NMOLA(1,NPAIR1)= NMOL1
           NMOLA(2,NPAIR1)= NMOL2
           DISO(1,NPAIR1) = BUX
           DISO(2,NPAIR1) = SUX
           WEI(NPAIR1)=WEIGHT
           IDI(1,NPAIR1) = LOC(1,1)
           IDI(2,NPAIR1) = LOC(1,2)
           ATO1(1,NPAIR1) = ATOM(1,I)
           ATO1(2,NPAIR1) = ATOM(2,I)
           NR1(1,NPAIR1) = NRE(1,I)
           NR1(2,NPAIR1) = NRE(2,I)
c           WRITE(JOUT,2002) NPAIR1, ATO1(1,NPAIR1),  ATO1(2,NPAIR1)
c2002       FORMAT ( I5,9X,2A4 )
           IF (IORDER.EQ.0) THEN
C                                 Order by range, a la Braun-Go
              KAES(NPAIR1) = IABS(NRE(1,I)-NRE(2,I))
           ELSE IF (IORDER.EQ.1) THEN
C                                 Preserve original order
              KAES(NPAIR1) = NPAIR1
           ELSE
C                                 Order by growing from N-terminus
              KAES(NPAIR1) = MAX(NRE(1,I), NRE(2,I))

           END IF
        ELSE
c If this input `pair' involves equivalent protons, then save in separate
c list. This is needed because a R**(-EXPON) averaging (see DISFF) is
c now carried out. In this case it is not possible to have info on
c lower bounds beyond those implicit in the VDW contacts.

           NPAI2 = NPAI2 + 1
           ITYGRP2(NPAI2)= 0
           IF (IORDER.EQ.0) THEN
C                               Order by range, a la Braun-Go
              IF (GRPFLG) THEN
                 ITYGRP2(NPAI2)= 1
cd               MINKA=INUMRS
                 MINKA=0
                 DO K=1,numOfsites(NRE1)
                    IRE1=iresNum(K,NRE1)
                    DO J=1,numOfsites(NRE2)
                       IRE2=iresNum(J,NRE2)
                       KAA2=IABS(IRE1-IRE2)
cd                     MINKA=MIN(MINKA, KAA2)
                       MINKA=MAX(MINKA, KAA2)
                    ENDDO
                 ENDDO
                 KAES2(NPAI2) = MINKA
              ELSE
                 KAES2(NPAI2) = IABS(NRE(1,I)-NRE(2,I))
              ENDIF
           ELSE IF (IORDER.EQ.1) THEN
C                                  Keep order on reading
              IF (GRPFLG) THEN
                 ITYGRP2(NPAI2)= 1
              ENDIF
              KAES2(NPAI2) = NPAI2
           ELSE
C                                  Order by growing from N-terminus
              IF (GRPFLG) THEN
                 ITYGRP2(NPAI2)= 1
                 KA1=0
                 DO J=1,numOfsites(NRE1)
                    IRE1=iresNum(J,NRE1)
                    KA1= MAX(KA1,IRE1)
                 ENDDO
                 KA2=0
                 DO J=1,numOfsites(NRE2)
                    IRE2=iresNum(J,NRE2)
                    KA2= MAX(KA2,IRE2)
                 ENDDO
                 KAES2(NPAI2) = MAX(KA1,KA2)
              ELSE
                 KAES2(NPAI2) = MAX(NRE(1,I), NRE(2,I))
              ENDIF
C              WRITE(*,*) 'KAES2(',NPAI2,')=', KAES2(NPAI2)
           END IF
C Code for more than 1 molecule has not been implemented, yet
           NMOLB(1,NPAI2)= NMOL1
           NMOLB(2,NPAI2)= NMOL2
           WEI2(NPAI2)=WEIGHT
           DISG(1,NPAI2) = BUX
           DISG(2,NPAI2) = SUX
           ATOM(1,NPAI2) = ATOM(1,I)
           ATOM(2,NPAI2) = ATOM(2,I)
           NRE(1,NPAI2) = NRE(1,I)
           NRE(2,NPAI2) = NRE(2,I)
           DO 40 KK=1,2
              NUMT(KK,NPAI2) = NUM(KK)
              DO 30 JJ=1, NUM(KK)
                 LOCT(JJ,KK,NPAI2) = LOC(JJ,KK)
                 IF(LOCT(JJ,KK,NPAI2).LE.0)  THEN
                    WRITE(*,'(A)') 'ERROR in line: '
                    WRITE(*,'(A80)') LINE(1:80)
 
                    WRITE(*,*) 'LOC(',JJ,',',KK,')=',LOC(JJ,KK),
     &              'LOCT(',JJ,',',KK,',',NPAI2,')=',LOCT(JJ,KK,NPAI2) 

                    WRITE(JOUT,*) 'LOC(',JJ,',',KK,')=',LOC(JJ,KK),
     &              'LOCT(',JJ,',',KK,',',NPAI2,')=',LOCT(JJ,KK,NPAI2) 
                 ENDIF
 30           CONTINUE
 40        CONTINUE
        END IF
 50   CONTINUE

      NPAIR2 = NPAI2
C NOW READ DIHEDRAL CONSTRAINTS IF ANY.
      NDIH=0
      DIHECNST=.FALSE.
      NOT_FINIS=.TRUE.
      DO WHILE(NOT_FINIS)
         READ (JDIST,'(A)',END=806) LINE
         IF (  LCOM(1,LINE(1:1) )  ) GOTO 803
         WORDDH=UCASE(LINE(1:8))
         IF (  WORDDH.NE.'DIHEDRAL' )  GOTO 803
         DIHECNST=.TRUE.
         READ (LINE(9:80),*,ERR=920) NRE1,IDIH,VALDH,VALDD,VALWW
C         WRITE (JOUT,*) NRE1,IDIH, VALDH,VALDD, VALWW
         IF(NUMB_PDB) THEN
            NRE1=NRE1+1
         ENDIF
         IF (NCHVAR(NRE1,IDIH).NE.1) THEN
           WRITE (JOUT,*) 'DIST_SET% WARNING: Dihedral angle ',IDIH,
     &     ' of residue ', NRE1,' is NOT VARIABLE.'
           GOTO 803
         ENDIF
         NDIH=NDIH+1
         IDCN(1,NDIH)= NRE1
         IDCN(2,NDIH)= IDIH
         DCN (1,NDIH)= VALDH
         DCN (2,NDIH)= VALDD
         WEDIH (NDIH)= VALWW
         GOTO 803
806      NOT_FINIS=.FALSE.
803   ENDDO
      NDIHCO=NDIH
      WRITE(JOUT,*)' No. of dihedral constraints that will be used is ',
     &   NDIHCO

 807  CONTINUE

      CLOSE(JDIST)

      IF ( ((NPAIR1+NPAIR2).EQ.0).AND.(NDIH.EQ.0) ) THEN
        WRITE (JOUT,*)  'ERROR with constraints! No distance ',
     &   'constraints specified and dihedral angle constraints',
     &      ' are not given '
	STOP 1884
      ENDIF
      RETURN
 708  WRITE(JOUT,'(A,I4,A/A/A)') 'error(',IE ,') READING LINE: ',
     & LINE,LINE1
      STOP 708

 808  WRITE(JOUT,*)' ONLY ',I-1,' OF', NPAIR1,
     &               ' PAIRS OF TYPE 1 HAVE BEEN READ'
      STOP 808
 908  WRITE(JOUT,*)' ERROR READING INFO FOR PAIR (TYPE 1) ',I
      WRITE(JOUT,'(A)' )LINE
      STOP 908
 809  WRITE(JOUT,*)' ONLY ',I-1,' OF', NPAIR2,
     &               ' PAIRS OF TYPE 2 HAVE BEEN READ'
      STOP 809
 909  WRITE(JOUT,*)' ERROR READING INFO FOR PAIR (TYPE 2) ',I
      STOP 909
 920  WRITE(JOUT,*)' ERROR WHEN READING  DIEHEDRAL ANGLE CONSTRAINT'
      WRITE(JOUT,'(A)' )LINE
      STOP 920
5555   WRITE(JOUT,*)'ERROR OPENING FILE= ',FNAME,' UNIT=', JUNI
      STOP 5555

 1000 FORMAT (2I10)
 1001 FORMAT (2F10.3)
 1002 FORMAT (2I10,3X,F10.3)
 1992 FORMAT ( /,'   DISTANCE CONSTRAINTS ',/,
     &   '      TYPE 1    TYPE 2     ')
 2000 FORMAT (2(I5,2X,A3))
 2010 FORMAT (8I10)
 2020 FORMAT (2X, ' SET 1', I5,2X,I5,2X,A4,2X,I5,A4)
 2030 FORMAT (2X, ' SET 2', 5I10)
 3000 FORMAT (8X,2(2I4,1X,A3,2X),3F8.3)
       
        END
      SUBROUTINE READ_CONGEN_CONS
C FEB-98. DR
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      
      INTEGER NRE1,NRE2
      INTEGER NREC(4)
      INTEGER IATMN_CONG(2,1000,2)
      INTEGER IRESN_CONG(2,1000,2)
      INTEGER IMOLN_CONG(2,1000,2)
      INTEGER KRS(4)
      INTEGER NUM(2), LOC(50,2)
      REAL DIST_CONG(2,1000,2)
      REAL  DHWEI,DHMIN,DHMAX
      CHARACTER*1 ZMOL(4)
      CHARACTER*4 CONGATOM(4)
      CHARACTER*4 RATOM1,RATOM2,RATOM3,RATOM4
      CHARACTER*102 LINE
      CHARACTER*80 LINE1,UCASE,INFO_DIHE
      CHARACTER*64 FNAME
      CHARACTER*4 LATOM
      CHARACTER*4 LBATM_CONG(2,1000,2)
      CHARACTER*4 KATNM(4)
      CHARACTER*8 LCHARA(10)
      LOGICAL BLANKLINE,ERRFLAG
      LOGICAL GRPFLG
      LOGICAL NOT_FINIS
      EXTERNAL ILEN  
      INTEGER IERR

      write(*,*) ' IN READ_CONGEN_CONS'
      NPAIR1=0
      NPAIR2=0
      NPAI2=0
      NNNPAIR2=0
      NOT_FINIS=.TRUE.
      WEIGHT=0.0

C READ AND ASSIGN DISTANCE CONSTRAINTS

      JUNI= JCONGD
      FNAME=CONGDFILE
      WRITE(JOUT,'(A,I2,1X, A/)')'OPENING UNIT ',JCONGD,CONGDFILE

      OPEN(UNIT=JUNI,FILE=CONGDFILE,STATUS='OLD',ERR=5555) 
      DO WHILE (NOT_FINIS)
         READ (JUNI,'(A80)',END=50) LINE
         WRITE(JOUT,*) LINE(1:80)
         IF (LINE(1:6) .EQ.'WEIGHT') THEN
            READ (LINE(7:10),'(F4.1)',ERR=909) WEIGHT
            WRITE(JOUT,*) 'WEIGHT= ',WEIGHT
            GOTO 100
         ENDIF
         IF (LINE(1:9) .NE.'CONS ATOM') GOTO 100
         IERR=1
         READ (LINE,3500,ERR=909) ZMOL(1),NRE1,CONGATOM(1),
     &      ZMOL(2),NRE2,CONGATOM(2), SUX, BUX
         WRITE(JOUT,*) ZMOL(1),NRE1,CONGATOM(1),
     &      ZMOL(2),NRE2,CONGATOM(2), SUX, BUX

 3500 FORMAT (4X,2(6X,A1,I3,1X,A4,7X),4X,F5.2,6X,F5.2)

C TESTS TO CHECK IF UPPER AND LOWER BOUND ARE GIVEN IN THE CORRECT ORDER.
         IF( BUX. LT. SUX ) THEN
           WRITE(JOUT,'(2A/A/A)')'WARNING: NPAIR1: UPPER AND',
     &     ' LOWER BOUND WERE ASSIGNED INCORRECTLY.',
     &     '(UPPER BOUND < LOWER BOUND) VALUES ARE EXCHANGED:', LINE
           SUUUX =SUX
           SUX= BUX
           BUX=SUUUX
         ENDIF

C  FIRST: WE NEED TO ASSOCIATE ZMOL* (A CHARACTER VARIABLE) WITH A  
C  MOLECULE NUMBER.
         NMOL1=INMOLE(ZMOL(1))
         NMOL2=INMOLE(ZMOL(2))
C  SECOND: CONGEN DEFINES AN INTERACTING GROUP OF ATOMS WITH A "*"
C AFTER THE ATOM NAME.  IN ECEPPAK, WE RECOGNIZED THE ATOM GROUP
C DIRECTLY.

         LENLAB1=ILEN(CONGATOM(1))
         LENLAB2=ILEN(CONGATOM(2))
         RATOM1= UCASE(CONGATOM(1)(1:LENLAB1) )
         RATOM2= UCASE(CONGATOM(2)(1:LENLAB2) )

C  DETERMINE THE ATOMS AND TYPE OF BOUND.
C       WRITE(*,*)' NRE1 RATOM1 NRE2 RATOM2', NRE1,RATOM1,NRE2,RATOM2
        CALL ANALATM(NRE1,RATOM1,NRE2,RATOM2,NUM,LOC,GRPFLG)

         IF (NUM(1).LT.1) THEN
             WRITE(JOUT,*)'ERROR READ_CONGEND'
             WRITE(JOUT,'(a)')line
             WRITE(JOUT,*)'NUM1 LT IATN1 ', NUM1,IATN1
         ELSE IF  (NUM(1).GT.500) THEN
            WRITE(*,*) 'ERROR: TOO LARGE: NUM1=',NUM1
         ENDIF

         IF (NUM(2).LT.1) THEN
             WRITE(JOUT,*)'ERROR READ_CONGEND'
             WRITE(JOUT,'(a)')line
             WRITE(JOUT,*)'NUM2 LT IATN2 ', NUM2,IATN2
         ELSE IF  (NUM(2).GT.500) THEN
            WRITE(*,*) 'TOO LARGE: NUM2=',NUM2
         ENDIF

C THIS CAN BE USED TO WRITE AN ECEPPAK DC FILE 
c        WRITE(*,*) ' NNNPAIR2=',NNNPAIR2
         NNNPAIR2=NNNPAIR2+1
         IF (NNNPAIR2.GT.maxnum_dist) THEN
           WRITE(*,*)'ERROR: number of constraints > MAXNUM_DIST'
           WRITE(JOUT,*)'ERROR: number of constraints > MAXNUM_DIST'
           STOP 4567
         ENDIF
         IMOLN_CONG(1,NNNPAIR2,2)=NMOL1
         IRESN_CONG(1,NNNPAIR2,2)=NRE1
         IATMN_CONG(1,NNNPAIR2,2)=LOC(1,1)
         LBATM_CONG(1,NNNPAIR2,2)=RATOM1
         IMOLN_CONG(2,NNNPAIR2,2)=NMOL2
         IRESN_CONG(2,NNNPAIR2,2)=NRE2
         IATMN_CONG(2,NNNPAIR2,2)=LOC(1,2)
         LBATM_CONG(2,NNNPAIR2,2)=RATOM2
         DIST_CONG(1,NNNPAIR2,2)= SUX
         DIST_CONG(2,NNNPAIR2,2)= BUX

c        ATOM(1,I)= RATOM1
         ATOM(1,NNNPAIR2)= RATOM1
c        ATOM(2,I)= RATOM2
         ATOM(2,NNNPAIR2)= RATOM2
c        NRE(1,I)= NRE1
         NRE(1,NNNPAIR2)= NRE1
c        NRE(2,I)= NRE2
         NRE(2,NNNPAIR2)= NRE2

C ------------------------------------------------------------------------
C
C IT APPEARS THAT SHORT RANGE CONSTRAINS SHOULD BE WEIGHTED MUCH MORE
C THAN LONG RANGE CONSTRAINTS FOR MINIMIZATION TO BE EFFECTIVE. DR MAR/2/98.
C TESTING THIS ASSIGNMENT: 
         WFACT=1.0D0
         IDFFNRES= IABS(NRE2-NRE1)
         IF (IDFFNRES.LE.1) WFACT=50.0D0
         IF ((IDFFNRES.GT.1).AND.(IDFFNRES.LE.3)) WFACT=10.0D0
C ------------------------------------------------------------------------

         IF (NUM(1).EQ.1.AND.NUM(2).EQ.1) THEN
            NPAIR1 = NPAIR1 + 1
C Code for more than 1 molecule has not been implemented, yet
            NMOLA(1,NPAIR1)= NMOL1
            NMOLA(2,NPAIR1)= NMOL2
            DISO(1,NPAIR1) = BUX
            DISO(2,NPAIR1) = SUX
            WEI(NPAIR1)=WEIGHT*WFACT
            IDI(1,NPAIR1) = LOC(1,1)
            IDI(2,NPAIR1) = LOC(1,2)
            ATO1(1,NPAIR1) = ATOM(1,NNNPAIR2)
            ATO1(2,NPAIR1) = ATOM(2,NNNPAIR2)
            NR1(1,NPAIR1) = NRE(1,NNNPAIR2)
            NR1(2,NPAIR1) = NRE(2,NNNPAIR2)
c            WRITE(JOUT,2002) NPAIR1, ATO1(1,NPAIR1),  ATO1(2,NPAIR1)
c2002        FORMAT ( I5,9X,2A4 )
            IF (IORDER.EQ.0) THEN
C                                 Order by range, a la Braun-Go
               KAES(NPAIR1) = IABS(NRE(1,NNNPAIR2)-NRE(2,NNNPAIR2))
            ELSE IF (IORDER.EQ.1) THEN
C                                 Preserve original order
               KAES(NPAIR1) = NPAIR1
            ELSE
C                                 Order by growing from N-terminus
               KAES(NPAIR1) = MAX(NRE(1,NNNPAIR2), NRE(2,NNNPAIR2))
            END IF
         ELSE
c If this input `pair' involves equivalent protons, then save in separate
c list. This is needed because a R**(-EXPON) averaging (see DISFF) is
c now carried out. In this case it is not possible to have info on
c lower bounds beyond those implicit in the VDW contacts.

            NPAI2 = NPAI2 + 1
            IF (IORDER.EQ.0) THEN
C                               Order by range, a la Braun-Go
               IF (GRPFLG) THEN
                  ITYGRP2(NPAI2)= 1
                  MINKA=INUMRS
                  DO K=1,numOfsites(NRE1)
                     IRE1=iresNum(K,NRE1)
                     DO J=1,numOfsites(NRE2)
                        IRE2=iresNum(J,NRE2)
                        KAA2=IABS(IRE1-IRE2)
                        MINKA=MAX(MINKA, KAA2)
                     ENDDO
                  ENDDO
                  KAES2(NPAI2) = MINKA
               ELSE
                  KAES2(NPAI2) = IABS(NRE(1,NNNPAIR2)-NRE(2,NNNPAIR2))
               ENDIF
            ELSE IF (IORDER.EQ.1) THEN
C                                  Keep order on reading
               IF (GRPFLG) THEN
                  ITYGRP2(NPAI2)= 1
               ENDIF
               KAES2(NPAI2) = NPAI2
            ELSE
C                                  Order by growing from N-terminus
               IF (GRPFLG) THEN
                  ITYGRP2(NPAI2)= 1
                  KA1=0
                  DO J=1,numOfsites(NRE1)
                     IRE1=iresNum(J,NRE1)
                     KA1= MAX(KA1,IRE1)
                  ENDDO
                  KA2=0
                  DO J=1,numOfsites(NRE2)
                     IRE2=iresNum(J,NRE2)
                     KA2= MAX(KA2,IRE2)
                  ENDDO
                  KAES2(NPAI2) = MAX(KA1,KA2)
               ELSE
                  KAES2(NPAI2) = MAX(NRE(1,NNNPAIR2), NRE(2,NNNPAIR2))
               ENDIF
            END IF
C Code for more than 1 molecule has not been implemented, yet
            NMOLB(1,NPAI2)= NMOL1
            NMOLB(2,NPAI2)= NMOL2
            WEI2(NPAI2)=WEIGHT*WFACT
            DISG(1,NPAI2) = BUX
            DISG(2,NPAI2) = SUX
            ATOM(1,NPAI2) = ATOM(1,NNNPAIR2)
            ATOM(2,NPAI2) = ATOM(2,NNNPAIR2)
            NRE(1,NPAI2) = NRE(1,NNNPAIR2)
            NRE(2,NPAI2) = NRE(2,NNNPAIR2)
            DO 40 KK=1,2
               NUMT(KK,NPAI2) = NUM(KK)
               DO 30 JJ=1, NUM(KK)
                  LOCT(JJ,KK,NPAI2) = LOC(JJ,KK)
                  IF(LOCT(JJ,KK,NPAI2).LE.0)  THEN
                     WRITE(*,'(A)') 'ERROR in line: '
                     WRITE(*,'(A80)') LINE(1:80)
 
                     WRITE(*,*) 'LOC(',JJ,',',KK,')=',LOC(JJ,KK),
     &              'LOCT(',JJ,',',KK,',',NPAI2,')=',LOCT(JJ,KK,NPAI2)

                     WRITE(JOUT,*) 'LOC(',JJ,',',KK,')=',LOC(JJ,KK),
     &              'LOCT(',JJ,',',KK,',',NPAI2,')=',LOCT(JJ,KK,NPAI2)
                  ENDIF
 30            CONTINUE
 40         CONTINUE
         END IF

         GOTO 100
50       NOT_FINIS=.FALSE.

100      CONTINUE
      ENDDO
      NPAIR2 = NPAI2
      MPAIRS= NNNPAIR2
      WRITE(*,'(a)')
     &  'ALL DISTANCE CONSTRAINTS FROM CONGEN FILE WERE READ'
      CLOSE(JCONGD) 

      JUNI= JBND
      OPEN(UNIT=JUNI,FILE=DISTFILE,STATUS='UNKNOWN',ERR=5555) 
C     WRITE TO FILE DIST_CONST

      IF (NUMB_PDB) WRITE(JBND,'(a)')'! NUMBERING FULL RESIDUES '
      IF (.NOT.NUMB_PDB) WRITE(JBND,'(a)')'! ECEPP RESIDUE NUMBERS'
!      WRITE(JBND,'(a)')'WRITING COSTRAINTS TO ECEPPAK FILE'


      DO I=1,NNNPAIR2
C     WRITE(JBND,'(1x,2i5,a4,1x,2i5,a4,3f10.3)')
      WRITE(JBND,3000)
     &       IMOLN_CONG(1,I,2),IRESN_CONG(1,I,2),
     &                                   LBATM_CONG(1,I,2),
     &       IMOLN_CONG(2,I,2),IRESN_CONG(2,I,2),
     &                                   LBATM_CONG(2,I,2),
     &       DIST_CONG(1,I,2),  DIST_CONG(2,I,2), WEIGHT

 3000 FORMAT (8X,2(2I4,1X,A4,1X),3F8.3)

      ENDDO 
      

C NOW DIHEDRAL ANGLE CONSTRAINTS
      NDIH=0
      DIHECNST=.FALSE.
      JUNI= JCONGD
      FNAME=CONGDFILE
      NOT_FINIS=.TRUE.
      OPEN(UNIT=JUNI,FILE=CONGDFILE,STATUS='OLD',ERR=5555) 
      DO WHILE (NOT_FINIS)
         READ (JUNI,'(A102)',END=60) LINE
C        WRITE(JOUT,*) LINE(1:102)
         IF (LINE(1:9) .NE.'CONS DIHE') GOTO 200
         DIHECNST=.TRUE.
c        IF(NDIH.EQ.0 ) THEN
c           WRITE(JBND,'(a)')'DIHEDRAL'
c           WRITE(JBND,'(f7.2)')WEIGHT
c        ENDIF
         LFCHR=14
         DO J=1,4 
            ILC1=LFCHR*(J-1)+11
            ILC2=LFCHR*(J-1)+22
            IERR=2
            READ (LINE(ILC1:ILC2),'(a12)',ERR=909) INFO_DIHE
c           write(*,*) 'ILC1,ILC2 ', ILC1,ILC2, LINE(ILC1:ILC2)
c    &     ,INFO_DIHE
            IPOS=1
            BLANKLINE=.FALSE.
            ERRFLAG=.FALSE.
C read the three record of this info.
            DO  K= 1, 3
              CALL MYKEY(INFO_DIHE,LINE1,IPOS,BLANKLINE,ERRFLAG)
              IE=5
              IF (ERRFLAG) GOTO 808
              IF (.NOT. BLANKLINE .AND. .NOT. ERRFLAG) THEN
                IE=6
                READ (LINE1,'(A5)',END=808,ERR=808) LCHARA(K)
              ELSE
                IE=7
                GOTO 808
              ENDIF
            ENDDO
            READ (LCHARA(1),'(A1)',ERR=808)  ZMOL(J)
            READ (LCHARA(2),'(I5)',ERR=808)  NREC(J)
            READ (LCHARA(3),'(A4)',ERR=808)  CONGATOM(J)
         ENDDO

C        WRITE(JOUT,*)  'GOT '
C        WRITE(JOUT,*)  ZMOL(1),NREC(1),CONGATOM(1),
C    &                 ZMOL(2),NREC(2),CONGATOM(2),
C    &                 ZMOL(3),NREC(3),CONGATOM(3),
C    &                 ZMOL(4),NREC(4),CONGATOM(4) 

C********************************************
         IPOS=1
         BLANKLINE=.FALSE.
         ERRFLAG=.FALSE.
         IERR=3
         READ (LINE(73:102),'(a30)',ERR=909) INFO_DIHE
C read the three record of this info.
C        WRITE(JOUT,*)  ' INFO_DIHE ',  INFO_DIHE
         DO  K= 1, 5
              CALL MYKEY(INFO_DIHE,LINE1,IPOS,BLANKLINE,ERRFLAG)
              IE=5
              IF (ERRFLAG) GOTO 808
              IF (.NOT. BLANKLINE .AND. .NOT. ERRFLAG) THEN
                IE=6
C               WRITE(JOUT,*)  ' LINE1 ',  LINE1
                READ (LINE1,'(A8)',END=808,ERR=808) LCHARA(K)
              ELSE
                IE=7
                GOTO 808
              ENDIF
         ENDDO
         READ (LCHARA(1),'(f6.1)',ERR=808)  DHWEI
         READ (LCHARA(3),'(f6.1)',ERR=808)  DHMIN
         READ (LCHARA(5),'(f6.1)',ERR=808)  DHMAX
C********************************************
 

C       WRITE(JOUT,*) 'DHWEI,DHMIN,DHMAX ', DHWEI,DHMIN,DHMAX


C  FIRST: WE NEED TO ASSOCIATE ZMOL* (A CHARACTER VARIABLE) WITH A  
C  MOLECULE NUMBER.
         NMOL1=INMOLE(ZMOL(1))
         NMOL2=INMOLE(ZMOL(2))
         NMOL3=INMOLE(ZMOL(3))
         NMOL4=INMOLE(ZMOL(4))

         IF ( (NMOL1.NE.NMOL2) .OR. (NMOL1.NE.NMOL3) 
     &                          .OR. (NMOL1.NE.NMOL4) ) THEN

            WRITE(*,'(A)') 'ERROR, ERRRROR, ERRRRRRROOOORRR '
            WRITE(*,'(A/A)') 'ECEPPAK does not know how to treat',
     &       'dihedral angles defined by atoms in different molecules' 
            WRITE(JOUT,'(A/A)') 'ECEPPAK does not know how to treat',
     &       'dihedral angles defined by atoms in different molecules' 

         ENDIF


         LENLAB1=ILEN(CONGATOM(1))
         LENLAB2=ILEN(CONGATOM(2))
         LENLAB3=ILEN(CONGATOM(3))
         LENLAB4=ILEN(CONGATOM(4))

         KRS(1)=NREC(1)-NREC(2)+1
         KRS(2)=1
         KRS(3)=NREC(3)-NREC(2)+1
         KRS(4)=NREC(4)-NREC(2)+1
C LENLAB's cannot be greater than 3.

         KATNM(1)= UCASE(CONGATOM(1)(1:LENLAB1) )
         KATNM(2)= UCASE(CONGATOM(2)(1:LENLAB2) )
         KATNM(3)= UCASE(CONGATOM(3)(1:LENLAB3) )
         KATNM(4)= UCASE(CONGATOM(4)(1:LENLAB4) )

         NREKK= NREC(2)
         CALL FINDDIEH(NREKK,KRS, KATNM, IS_DIHE)
         IF (IS_DIHE.GT.MAXNUM_DIHE) THEN
            WRITE(JOUT,*)'ERROR READ_CONGEND: DIHEDRAL NOT FOUND'
            WRITE(JOUT,'(a)')line
         ENDIF
         IF ( (DHMIN.LT.0).AND.(DHMAX.GT.0) ) THEN
            DHMIN=DHMIN+360.0D0
C           DHMAX=DHMAX+360.0D0
         ENDIF
         VALUE_DH= 0.5D0*(DHMIN+DHMAX)
         DELTA_DH= DHMAX-VALUE_DH
         VRADDH= RAD*VALUE_DH 
         IF ( (ABS(VRADDH) .GT.1.0E+10) ) THEN
            WRITE (*,*)'ERROR READ_CONGEN_CONS: VRADDH ',DEG*VRADDH
         END IF
         VALUE_DH= DEG*PINORM(VRADDH)
         IF (RAD*DELTA_DH.GT.PI) WRITE(JOUT,'(a/a)')
     &    'WARNING: CHECK CORRECTNESS OF DIHEDRAL ANGLE CONSTRAINT',LINE 
         WRITE(JBND,'(a8,2x,2i10,5x,3f12.3)') 'DIHEDRAL',
     &         NREKK, IS_DIHE, VALUE_DH, ABS(DELTA_DH), DHWEI

         NRE1=NREKK
         IF(NUMB_PDB) THEN
            NRE1=NREKK+1
         ENDIF

         IF (NCHVAR(NRE1,IS_DIHE).NE.1) THEN
            WRITE (JOUT,*) 'DIST_SET% WARNING: Dihedral angle ',
     &      IS_DIHE,' of residue ', NRE1,' is NOT VARIABLE.'
            GOTO 200
         ENDIF
         NDIH=NDIH+1
         IDCN(1,NDIH)= NRE1
         IDCN(2,NDIH)= IS_DIHE
         DCN(1,NDIH)=  VALUE_DH
         DCN(2,NDIH)=  DELTA_DH
         WEDIH (NDIH)= DHWEI
         GOTO 200
60       NOT_FINIS=.FALSE.
      
200      CONTINUE
      ENDDO

      NDIHCO=NDIH
      WRITE(*,'(a)')'ALL  DIHEDRAL-ANGLE CONSTRAINTS FROM',
     &              ' CONGEN FILE WERE READ'
      CLOSE(JCONGD) 

      CLOSE(JBND) 
      IF ( ((NPAIR1+NPAIR2).EQ.0).AND.(NDIH.EQ.0) ) THEN
        WRITE (JOUT,*)  'ERROR with constraints! No distance ',
     &   'constraints specified and dihedral angle constraints',
     &      ' are not given '
        STOP 2884
      ENDIF


C READ AND ASSIGN DIHEDRAL ANGLE CONSTRAINTS
      RETURN


 808  WRITE(JOUT,'(A,I4,A/A/A)') 'error(',IE ,') READING LINE: ',
     & LINE,LINE1
      STOP 2808

 909  WRITE(JOUT,'(a/a/a,i5)') 'ERROR READING CONSTRAINT FILE ',LINE
     & ,'IERR= ',IERR
      STOP 2909

5555   WRITE(JOUT,*)'ERROR OPENING FILE= ',FNAME,' UNIT=', JUNI
      STOP 2555

      END

      INTEGER FUNCTION INMOLE(ZMOL)
C
      INCLUDE 'COMMON.DISTCO'
      CHARACTER*1 ZMOL

      IF (INDMOL .EQ.0) THEN
         INDMOL=1
         CHMOL(1)=ZMOL 
         INMOLE=1
      ELSE

         DO I=1,INDMOL
            IF(ZMOL.EQ.CHMOL(I) ) THEN
               INMOLE=I
               RETURN 
            ENDIF
            INDMOL=INDMOL+1
            CHMOL(INDMOL)=ZMOL 
            INMOLE=INDMOL
         ENDDO
      ENDIF
      RETURN 
      
      END
         
      SUBROUTINE FINDDIEH(NREKK,KRS, KATNM, IS_DIHE)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.THRLET'
      INTEGER KRS(4), IS_DIHE
      CHARACTER*4 KATNM(4)
      DIMENSION  LOCI(50), LOCO(50), MAYBE_DIH(10) 
      LOGICAL FOUND,AXIS_FOUND

      DO I=1,10
         MAYBE_DIH(I)=0
      ENDDO
      ILIST=IABS(LIST(NREKK))
      IF(NUMB_PDB) ILIST=IABS(LIST(NREKK+1))

C     WRITE(JOUT,*)'RESIDUE- LIST= ', NREKK, ILIST 
C     WRITE(JOUT,*)
C    &  'Dihedral angles of ', ARES(ILIST), ' are defined as:' 

C     DO J=1, NUMBDIH(ILIST)
C        WRITE(JOUT,'(4(5x,A4)/)' ) (DIHATM(K,J,ILIST),K=1,4)
C        WRITE(JOUT,'(4(5x,I3)/)' ) (JDIHRES(K,J,ILIST),K=1,4)
C     ENDDO

C        WRITE(JOUT,'(A20/4(5x,A4)/4(5x,I3)/)' )
C    &      'INPUT DIHEDRAL : ', (KATNM(K),K=1,4), 
C    &      (KRS(K),K=1,4)

C This Test may be floppy!
      DO J=1, NUMBDIH(ILIST)
         FOUND=.TRUE.
         DO K=1,4
            IF (JDIHRES(K,J,ILIST).NE.KRS(K) ) FOUND=.FALSE.
            IF (DIHATM(K,J,ILIST) .NE.KATNM(K) ) FOUND=.FALSE.
         ENDDO
         IF(FOUND) THEN
            IS_DIHE=J
C           WRITE(JOUT,*)'FINDDIEH: FIRST TEST SUCCESSFUL',
C    &         ' is Dihedral angle ', IS_DIHE
            RETURN
         ENDIF

      ENDDO
C This Test should  be better!
      WRITE(JOUT,*)'FINDDIEH: SECOND TEST NOW'
      LL=0
      DO J=1, NUMBDIH(ILIST)
         FOUND=.TRUE.
         AXIS_FOUND=.TRUE.
         DO K=1,4
            NRS=NREKK-1+KRS(K)
c           write(*,*) 'call class7 with: NRS,KATNM(',K,')',NRS,KATNM(K)
            CALL CLASS(NRS,KATNM(K),NUM1,LOCI)
c           write(*,*) 'call class8 with: NRS,
c    &              DIHATM(',K,',',J,',',ILIST,')',NRS,DIHATM(K,J,ILIST)
            CALL CLASS(NRS,DIHATM(K,J,ILIST), NUM2,LOCO)
            IF (LOCI(1) .NE. LOCO(1) ) FOUND=.FALSE.
            IF (K.EQ.2 .OR. K.EQ.3 ) THEN
              IF ( LOCI(1) .NE. LOCO(1) ) AXIS_FOUND=.FALSE.
            ENDIF
         ENDDO
         IF(FOUND) THEN
            IS_DIHE=J
C           WRITE(JOUT,*)'FINDDIEH: SECOND TEST SUCCESSFUL',
C    &         ' is Dihedral angle ', IS_DIHE
            RETURN
         ENDIF
         IF(AXIS_FOUND) THEN
            LL=LL+1
            MAYBE_DIH(LL)=J
         ENDIF

      ENDDO



      IF(LL.GT.1) THEN
         WRITE(JOUT,*)
     &      'ERROR: More than two definition of the dihedral angle',
     &     (MAYBE_DIH(I),I=1,LL)

      ELSE IF(LL.EQ.1) THEN
         WRITE(JOUT,'(A40/2(A10,4(5x,A4))/)' )
     &      'Dihedral angle is defined using different atoms',
     &      'INPUT: ', (KATNM(K),K=1,4),
     &      'DATABASE: ', (DIHATM(K,MAYBE_DIH(1),ILIST),K=1,4)
      ELSE
         WRITE(JOUT,*)'DIHEDRAL ANGLE NOT FOUND'
      ENDIF
      STOP 1313
      END
      SUBROUTINE CHNGWEI
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.SAVEWEI'
      REAL FCTRW

! WEIGHTS DIMINISHED LINEARLY AFTER EACH PASS, BUT NOT LESS THAN 30%.
      DO I=1,NPARES1
        IPASW(I)=IPASW(I)+1
        FCTRW= 1.0E0-IPASW(I)*DIMINW
        IF (FCTRW.GT. FCTMINWEI) THEN
          WEI(I)=FCTRW*WEI_P1(I)
        ENDIF
      ENDDO
      DO I=1,NPARES2
        IPASW2(I)=IPASW2(I)+1
        FCTRW= 1.0E0-IPASW2(I)*DIMINW
        IF (FCTRW.GT. FCTMINWEI) THEN
          WEI2(I)=FCTRW*WEI_P2(I)
        ENDIF
      ENDDO
      RETURN
      END

      SUBROUTINE RESTWEI
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.SAVEWEI'

      DO I=1,NPAIR1
        WEI(I)=WEI_P1(I)
        IPASW(I)=0
      ENDDO
      DO I=1,NPAIR2
        WEI2(I)=WEI_P2(I)
        IPASW2(I)=0
      ENDDO
      RETURN
      END

      SUBROUTINE SAVWEI
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.SAVEWEI'

      DO I=1,NPAIR1
        WEI_P1(I)=WEI(I) 
      ENDDO
      DO I=1,NPAIR2
         WEI_P2(I)=WEI2(I)
      ENDDO
      RETURN
      END
