      SUBROUTINE ECEPPIZE

      LOGICAL END_OF_FILE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.RMSFIT'
      INCLUDE 'COMMON.RMSPDB'
      INCLUDE 'COMMON.TYYY'
      INCLUDE 'COMMON.TRACK'
      DIMENSION IC(maxnum_atoms)
      CHARACTER*64 CFF,OLD_PREFIX
      CHARACTER*32 SPDBFIL
      CHARACTER*3 NUMM
      DATA IZERO /0/,ITREIN /30/
      LOGICAL SEQDIFF,YourOwn,FAIL, LGPRINT


C
C  INITIALIZE RADIA OF GYRATION FOR REFERENCE CONFORMATION
      RGXH=0.0
      RGXCA=0.0
      RGXBH=0.0
      RGXSH=0.0

      DO 5 I=1,maxnum_dihe
        AVER(1,I,J) = 0.0
        AVER(2,I,J) = 0.0
 5    CONTINUE

      IAMCON=0

      NATMOM=NPRE(INUMRS+1)

C   ############## REFERENCE #################
      IF (GENERATE_REF) THEN
C  IF REFERENCE FILE DOESN'T EXIST GENERATE ONE.
        IF (ITYPE_REF.NE.3) THEN
C         USE INPUT DATA FROM FILE "JINREF" (27)
          KUNIT=JINREF
          WRITE(*,*)
     &  'XRAY file not provided. Will generate one from UNIT ',JINREF
          IF (ITYPE_REF.EQ.1) THEN
            ITYPF=1
            WRITE(JOUT,'(2a)')'Input structure for ',
     &        'reference in ORIGINAL PDB format (no end groups)'
          ELSE IF (ITYPE_REF.EQ.2 ) THEN
            ITYPF=0
             WRITE(*,'(/2a/)') ' Input structure for reference ',
     &         'in ECEPP(or AMBER) PDB format (with end groups)'
             WRITE(JOUT,'(/2a/)')'Input structure for reference ',
     &         'in ECEPP(or AMBER) PDB format (with end groups)'
          END IF

C  ###  READ FILE #####
          CALL SUBPDB (NATMOM,XCOR,ICON,KUNIT)
C         WRITE(*,*) ' After SUBPDB  '

        END IF
        IF (ITYPE_REF.EQ.1) THEN
!eliminate the end goups for the fitting procedure
C N terminus
           DO I=1, npre(2)
              ICON(I) = 0
           ENDDO
C C terminus
           DO I= npre(inumrs)+1,npre(inumrs+1)
              ICON(I) = 0
           ENDDO
        END IF

! Check if code is necessary   (icon= 0 for H)
        IF (IGNORE_H) THEN
           DO I=1, NATMOM
              IF (ALPH(I)(1:1).EQ.'H') THEN
                 ICON(I) = 0
              ENDIF
           ENDDO
        ENDIF

        WRITE(*,*)'Now Translate and ROTATE XCOR   '
! For the first full residue, N atom sits in (0,0,0) and CA in x axis
        CALL ROTXCOR
        WRITE(*,'(2a)')' Writing REFERENCE coordinates to file: ',
     &           refxyfile
        WRITE(JOUT,'(2a)')'Writing REFERENCE coordinates to file: ',
     &           refxyfile
        DO I=1, NATMOM
            WRITE(JOUREF,1040) (XCOR(J,I),J=1,3),ICON(I),ALPH(I)
 1040       FORMAT (5X,3F9.3,I6,5X,A4)
        ENDDO
C   ############## END REFERENCE GENERATION   #################
      ELSE
C  ############  READ REFERENCE CONFORMATION (XRAY file).#########
        WRITE(JOUT,'(a,i4,a,i4)') 
     &   'Now reading Reference file; No. of atoms= ',NATMOM,
     &   ' from unit= ',JREFXY
        DO I=1,NATMOM
          READ (JREFXY,1010,END = 22) ( XCOR(J,I),J=1,3), ICON(I)
        ENDDO
 1010   FORMAT (5X,3F9.3,I6)
      ENDIF
C  WRITE XRAY COORDINATES IN CURRENT FRAME AS A PDB FILE.
              DO I=1,NATMOM
                DO J=1,3
                  COORD(J,I) = XCOR(J,I)
                ENDDO
              ENDDO
              CALL NUMSTR(IZERO,NUMM)
              CALL CONCAT(COORPREF,NUMM,CFF)
              OLD_PREFIX=COORPREF
              COORPREF=CFF
              NO_HYD_SET0=0
              if (.NOT.NO_HYDRG)  THEN
                 NO_HYDRG=.TRUE.
                 NO_HYD_SET0=1
              ENDIF
              IFORM=2
              CALL OUTNW(IZERO,ITREIN,IZERO)
              IF(NO_HYD_SET0.EQ.1) NO_HYDRG=.FALSE.
              COORPREF=OLD_PREFIX
     
C Save info on sequence of the reference  conformation. 
      DO J=1,INUMRS
        LISTMIN(J,1)=LIST(J)
      ENDDO

      
C  ################    GET INPUT FILE FOR THE COMPARISON.  ############

C ###  DETERMINE RESIDUES USED IN THE FITTING PROCESS
      IF( KK1 .LT.1) KK1=1
      IF(LRESD.EQ.0 .OR.  LRESD.GT.INUMRS) LRESD=INUMRS
      IF (KK1.GE.LRESD) THEN
         WRITE (JOUT,676) KK1,LRESD
688      FORMAT ( 'ERROR IN INPUT FILE',/,
     &     ' 1st residue no. = ',I4,/,' last residue no. = ',
     &     I4 ,/,' INUMRS is ', i4)
         STOP 132
      END IF

      WRITE(*,676) KK1,LRESD
      WRITE (JOUT,676) KK1,LRESD
676   FORMAT ( 'FITTING FOR RESIDUE NO ',I4,' TO ', I4)

!eliminate the end goups for the fitting procedure
C N terminus
           DO I=1, npre(KK1)
              ICON(I) = 0
           ENDDO
C C terminus
           DO I= npre(LRESD)+1,npre(inumrs+1)
              ICON(I) = 0
           ENDDO

         WRITE(JOUT,'(a)') 
     &       'Input Structure(s) on ECEPP OUTO format.'

C    ################ START RMS CALCULATION  ################  
         END_OF_FILE=.FALSE.
         NREADIN=0
         DO WHILE (.NOT. END_OF_FILE)
           YourOwn = .TRUE.
           CALL READANG(END_OF_FILE,IAMCON,OLDENER,YourOwn) 
           IF (.NOT. END_OF_FILE) THEN
              IF (OLDENER.GT. ETHRESH) GOTO 50
              NREADIN= NREADIN+1

C Compare sequences of the reference  and input  conformations. 

              SEQDIFF=.FALSE.
              DO J=1,INUMRS
                IF(LISTMIN(J,1).NE.LIST(J)) SEQDIFF=.TRUE.
              ENDDO

              IF (SEQDIFF) THEN
         	 write(jout, '(a,i4,a)') 'Conformation ',IAMCON,
     &   ' has a DIFFERENT SEQUENCE than the reference.'
	         write(jout, '(a)') 'Reference Sequence Adopted'
                 DO J=1,INUMRS
                    LIST(J)=LISTMIN(J,1)
                 ENDDO
              ENDIF

! #############  GENERATE CONFORMATION #############
              CALL SETUP_X(IZERO)
!    ################ FITTING  DEVIATIONS ################  
              IF (NREADIN.EQ.1) THEN
! XCOR need to be translated and rotated so that  coodinates of N and CA 
! of first full residue of the reference structure coincide with those of target
! 
              ENDIF
              WRITE(JOUT,*)'Now minimization ',IAMCON
              call ener_minim(fail)
              IF (FAIL) THEN
                 WRITE(JOUT,*)' INITIAL fitting for Conformation No. ',
     &                   IAMCON, ' has failed'
                 goto 50
              endif
              if ((ICOMP(1).EQ.2).and.(coen.gt.1.0)) then
                 WRITE(JOUT,*)
     &            'Second minimization with simple potential ',IAMCON
                 coen= 1.0
                 call mod_bd11
                 call ener_minim(fail)
              endif

              IF (.NOT.FAIL) THEN
                 WRITE(JOUT,*)'CONFORMATION No. ',IAMCON
! PRINT UNSATISFIED DISTANCE CONSTRAINTS
                 NUKCO=1
                 LGPRINT=.TRUE.
                 CALL RMSCONST(LGPRINT)
                 CALL DRUANG(JOUT,IAMCON)
                 CALL DRUANG(JANG,IAMCON)
C PRINT  ENERGY COMPONENTS
                 CALL ENEPRINT

                 CALL NUMSTR(NREADIN,NUMM)
                 CALL CONCAT(COORPREF,NUMM,CFF)
                 OLD_PREFIX=COORPREF
                 COORPREF=CFF
                 NO_HYD_SET0=0
                 if (.NOT.NO_HYDRG)  THEN
                    NO_HYDRG=.TRUE.
                    NO_HYD_SET0=1
                 ENDIF
                 CALL OUTNW(IZERO,ITREIN,NREADIN)
                 IF(NO_HYD_SET0.EQ.1) NO_HYDRG=.FALSE.
                 COORPREF=OLD_PREFIX

              ELSE
               WRITE(JOUT,*) 'eceppization for conformation ',
     &            IAMCON, ' has failed.'
              ENDIF

           ENDIF
50         CONTINUE
         ENDDO
         IF(NREADIN.EQ.0) THEN
           WRITE(JOUT,'(A)') 'No conformation within specified range'
           STOP 332
         ENDIF

!     COORPREF=OLD_PREFIX
      RETURN 

22    CONTINUE
      WRITE(JOUT,'(A60,/,A25,i5)')
     & 'INPUT FILE FOR REFERENCE GENERATION IS INCOMPLETE OR MISSING ',
     & 'NUMBER OF ATOMS READ IN: ', I-1
      STOP 333
      

      END
      SUBROUTINE ROTXCOR
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
!      INCLUDE 'COMMON.CNTRL'
!      INCLUDE 'COMMON.DEBUG'
       INCLUDE 'COMMON.IOUNIT'
       INCLUDE 'COMMON.FILES'
!      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.RMSFIT'
      INCLUDE 'COMMON.TYYY'

      real X_UV(3),Z_UV(3),XP_UV(3),YP_UV(3),CA_UV(3),SNOR_ca_x(3), 
     &     M1(3,3)
      real T(3),xt(3),yt(3),zt(3)

! unit vector in x
      X_UV(1)=1.0
      X_UV(2)=0.0
      X_UV(3)=0.0

! unit vector in z
      Z_UV(1)=0.0
      Z_UV(2)=0.0
      Z_UV(3)=1.0


      N_REF=npre(2)+1
      CA_REF=npre(2)+3
      if((icon(N_REF).NE.1).or.(icon(CA_REF).NE.1) ) then
         write(*,*)' ROTXCOR: No N and or CA coordinates for' 
     &              ,' first residue was provided. Aborting' 
         write(jout,*)'ROTXCOR: No N and or CA coordinates for' 
     &              ,' first residue was provided. Aborting' 
         stop 6432
      endif
      T(1)=XCOR(1,N_REF)-COORD(1,N_REF)
      T(2)=XCOR(2,N_REF)-COORD(2,N_REF)
      T(3)=XCOR(3,N_REF)-COORD(3,N_REF)

      do i=1,npre(inumrs+1)
         if (icon(i).eq.1) then
            do j=1,3
               xt(j)=XCOR(j,i)-T(j)
               XCOR(j,i)=xt(j)
            enddo
         endif
      enddo
      write (*,*)'xcor(CA_REF) =', xcor(1,CA_REF),
     & xcor(2,ca_ref),xcor(3,ca_ref)
      write (jout,*)'xcor(CA_REF) =', xcor(1,CA_REF),
     & xcor(2,ca_ref),xcor(3,ca_ref)
      X1_CA_REF=DLENG(xcor(1,CA_REF))
      write (*,*)' NORM OF Xcor(CA_REF)=', X1_CA_REF
      write (jout,*)' NORM OF Xcor(CA_REF)=', X1_CA_REF
!     
! Given C_alpha' vector in the x'-z plane (z'=z),
!  compute unit vector in x' direction
      call ortpal(xcor(1,CA_REF), Z_UV, XT, ZT)
      XT_NORM= DLENG(XT)
      XP_UV(1)= XT(1)/XT_NORM
      XP_UV(2)= XT(2)/XT_NORM
      XP_UV(3)= XT(3)/XT_NORM

      costh=XP_UV(1)     ! x_ux . xp_uv = cos(theta)
      sinth=-XP_UV(2)     ! x_ux x xp_uv = sin(theta)
 
! generate matriz for rotation around z axis
      M1(1,1)=costh
      M1(1,2)=-sinth
      M1(1,3)=0
      M1(2,1)=sinth
      M1(2,2)=costh
      M1(2,3)=0
      M1(3,1)=0
      M1(3,2)=0
      M1(3,3)=1
! carry out rotation around z
      do i=1,npre(inumrs+1)
         if (icon(i).eq.1) then
            do j=1,3
               tt=0
               do l=1,3
                  tt= M1(j,l)*XCOR(l,i) +tt
               enddo
               xt(j)= tt
            enddo
            XCOR(1,i)=xt(1)
            XCOR(2,i)=xt(2)
            XCOR(3,i)=xt(3)
         endif
      enddo
      do i=1,npre(3)
         write (*,'(8x,i2,3X,A3,14X,3F8.3)')
     &         i, alph(i), (XCOR(j,i),j=1,3)
         write (jout,'(8x,i2,3X,A3,14X,3F8.3)')
     &         i, alph(i), (XCOR(j,i),j=1,3)
      enddo

! Second and last transformation 
!
! Now C_alpha' vector in the x-z plane
!  compute unit vector in x' direction  of XCOR(CA_REF)
      XP_UV(1)= XCOR(1,CA_REF)/X1_CA_REF
      XP_UV(2)= XCOR(2,CA_REF)/X1_CA_REF
      XP_UV(3)= XCOR(3,CA_REF)/X1_CA_REF

      write (*,*)' Now C_alpha  vector in the x-z plane'
      write (*,*)'XCOR(CA_REF) =', XCOR(1,CA_REF),
     & XCOR(2,ca_ref),XCOR(3,ca_ref)
      write (jout,*)' Now C_alpha  vector in the x-z plane'
      write (jout,*)'XCOR(CA_REF) =', XCOR(1,CA_REF),
     & XCOR(2,ca_ref),XCOR(3,ca_ref)
      X1_CA_REF=DLENG(XCOR(1,CA_REF))
      write (jout,*)' NORM OF X1(CA_REF)=', X1_CA_REF

      write (*,*)' select vector xp_uv in the C_alpha direction'
!component in y direction of xp_uv should be zero
      write (*,*)'component in y of xp_uv should be zero'
      write (*,*)'xp_uv=',xp_uv

      write (jout,*)' select vector xp_uv in the C_alpha direction'
!component in y direction of xp_uv should be zero
      write (jout,*)'component in y of xp_uv should be zero'
      write (jout,*)'xp_uv=',xp_uv

      cosdel=XP_UV(1)     ! x_ux . xp_uv = cos(delta)
      sindel=XP_UV(3)     ! x_ux x xp_uv =-sin(delta)

      write (*,*)'cosdel=',cosdel,' sindel=',sindel
      write (jout,*)'cosdel=',cosdel,' sindel=',sindel

!***********************************
! Rotate about y axis  by +delta

      M1(1,1)=cosdel
      M1(1,2)=0
      M1(1,3)= sindel
      M1(2,1)=0
      M1(2,2)=1
      M1(2,3)=0
      M1(3,1)=-sindel
      M1(3,2)=0
      M1(3,3)=cosdel
! carry out rotation around y
      do i=1,npre(inumrs+1)
         if (icon(i).eq.1) then
            do j=1,3
               tt=0
               do l=1,3
                  tt= M1(j,l)*XCOR(l,i) +tt
               enddo
               xt(j)= tt
            enddo
            XCOR(1,i)=xt(1)
            XCOR(2,i)=xt(2)
            XCOR(3,i)=xt(3)
         endif
      enddo
      do i=1,npre(3)
         write (*,'(8x,i2,3X,A3,14X,3F8.3)')
     &         i, alph(i), (XCOR(j,i),j=1,3)
         write (jout,'(8x,i2,3X,A3,14X,3F8.3)')
     &         i, alph(i), (XCOR(j,i),j=1,3)
      enddo

      RETURN 
      END
