      SUBROUTINE DO_EDMC
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
C =======================================================
#ifdef MP
      include 'PARAMET.MP'
      include 'COMMON.MP'
      LOGICAL  Te_o_f
      INTEGER  NUMB, TOTS, ICnts, STATS
#endif
#ifdef MPL
      EXTERNAL I_VADD
#endif
#ifdef MPI
      include 'mpif.h'
      INTEGER IERR, STATUS(MPI_STATUS_SIZE)
#endif
C =======================================================
      include 'COMMON.ODONNELL'
      include 'COMMON.CNTRL'
      include 'COMMON.OMTOR'
      include 'COMMON.MINPAR'
      include 'COMMON.EDMC'
      include 'COMMON.SOLVAT'
      include 'COMMON.EXTPH'
      include 'COMMON.CALC'
      include 'COMMON.DEBUG'
      include 'COMMON.TOR'
      include 'COMMON.SETUP'
      include 'COMMON.BRIDGES'
      include 'COMMON.TERMAL'
      include 'COMMON.XBOUNDX'
      include 'COMMON.GEN002X'
      include 'COMMON.TIME1'
      include 'COMMON.BONDSX'
      include 'COMMON.TORPX'
      include 'COMMON.IOUNIT'
      include 'COMMON.BLOKA'
      include 'COMMON.GEN000'
      include 'COMMON.GEN100'
      include 'COMMON.GEN004'
      include 'COMMON.TOR2'
      include 'COMMON.TORQUEX'
      include 'COMMON.NNDRUK'
      include 'COMMON.MOVE'
      include 'COMMON.BRAIN'
      include 'COMMON.PICK'
      include 'COMMON.BIAS'
      include 'COMMON.TRACK'
      include 'COMMON.MYCONF'
      include 'COMMON.PROB'
      include 'COMMON.ATOMSS'
      include 'COMMON.FILES'
      include 'COMMON.CLUSTER'
      include 'COMMON.TRIPROB'
#ifdef PHCALC
      include 'COMMON.STRIBE'
      INCLUDE 'param.ibems'
      INCLUDE 'ecepp_ibems_intrf.h'
#endif
      external calcfpo, calcgpo, gradcax
      dimension iv(LIV), urparm(1)
      dimension v(1:LV)
      dimension x1(MAXNUM_VAR)
      logical over,ovrtim,fail,good
      character*14 typ_gen(3) /'electrostatic','random','thermal'/
      character*3 numm
      character*64 cff,old_prefix
C
#ifdef PKSR
C
      include 'COMMON.PARRAY'
#endif
C
      data izero /0/, ione /1/, ifour /4/, itrein /30/
 
      if (YourJob) then
         ecrit = ecrit*npre(inumrs+1)
         ecrit1 = 0.1 * ecrit
         write (jout,'(a,f10.5)') 'Energy similarity criterion:',ecrit

C select atoms for superposition
         call atselect
C if a database of low-energy conformation exists, read the data.
         if(list_tot.gt.0) call read_dbase_lowe(numrsp,list_tot,angel,
     &      etde,ipepsq,ipeplst,pepnam)
      endif


C Calculate the virtual-geometry parameters necessary to execute lambda-type
C perturbation.
      if (movang.eq.3) call attable

C  Initialize variables

C Initially set temperature at the lower limit.
      temp=tlow
C Obtain temperature jumps in heating and cooling, if applicable
      write(*,*) ' HERE should set TSTEPC and TSTEPH' 
      write(*,*) ' NSTEPC=',nstepc, '  NSTEPH= ',nsteph 
      if (nstepc.gt.0 .and. nsteph.gt.0) then
        tstepc=(tup/tlow)**(1.0/(nstepc+0.0))
        tsteph=(tup/tlow)**(1.0/(nsteph+0.0))
        write(*,*) ' TSTEPC=',tstepc, '  TSTEPH= ',tsteph 
      endif
      if (nwind.eq.0) then
        nwind=1
        iwind(1,1)=1
        iwind(1,2)=inumrs
      endif
C
#ifdef PKSR
      do m=1, ncells
         counts(m)=0.0
      enddo
#else
      icounts = 0
#endif

      prevtim=tcpu()
      eprot=0.0d0
      delphi=0.0d0
      do i=1,inumrs
         itrials(i)=0
      enddo

      if (restart) then
C
C BE CAREFUL!!! At present restart is available FOR SERIAL USE ONLY!!!
C
         call getold
         write (jout,'(/80(1h*)/10x,a,i4,1h./10x,2a/10x,2a/80(1h*)/)')
     &      'Restarting the EDMC/MCM procedure from iteration',ndone+1,
     &      'At present restart works for serial use only. If you ',
     &      'restarted','a parallel job, the results will most probably'
     &      ,' be incorrect.'
      else
C else, if not restart!

         ndone=0
         lther=.false.
         licz=0
         mst=0

         if (ichcnf.eq.1) then
C Generate a random conformation.
            do ijj=1,numvar
              rnds=2*pi*rnunf(1)
              var(ijj)=pinorm(rnds)
              if (abs(var(ijj)).gt.(2*pi) )  then
                write(*,*) 'EDMC-Warning: variables not normalized'
              endif
              ndx=indxv(ijj)
              angles(ndx)=var(ijj)
            enddo
            if (omeg180) then
               do ijj=1,numvar
                  ndx=indxv(ijj)
                  call ndx_decode(ndx,irrr,iangu)
                  if (iangu.eq.3)  then
c                   write(*,*) 'omega(3,',irrr,') set to 180'
                     var(ijj)=pi
                     angles(ndx)=pi
                  endif
               enddo
            endif
         end if
C evaluate the energy of the starting conformation
C       write(jout,'(a)') ' call ene_eval '
C       write(*,'(a)') ' call ene_eval '
         call ene_eval

#ifdef PHCALC
        write(jout,'(/a)') ' calculation of degree of protonation ',
     &       'is ommitted for the first energy evaluation '
C        eprot=0.0d0
C        delphi=0.0d0
C        if (phs.gt.0.0) call protonation(fail)
#endif

#ifdef PKSR
         call pthread_mutex_lock (imutex,istat)
#endif
         IF (YourJob) THEN
C print dihedral angles of initial conformation before energy 
C  minimization into main output (unit 20) and dihedral-angle file.
            write(jout,248)ndone
C           write(*,248)ndone
248         format(//' Conf. No. ',i5 )
            call druang(jout,izero)
            call druang(jang,izero)
C print energy to main output
C             write(jout,'(a)') ' call eneprint '
            call eneprint
#ifdef MP
#ifdef AIX
            call flush_(jout)
#endif
#ifdef WINNT
		   call flush(jout)
#endif
#endif
            call close_app(jout,outfile)
C
#ifdef PKSR
            call pthread_mutex_unlock (imutex,istat)
#endif

C minimize energy
C          write(jout,'(a)') ' call ener_minim '
            call ener_minim(fail)
            if (fail) then
              write(*,*) 'problems with the initial'
     &    ,' energy minimization'
              stop 44323
            end if 
            evib= 0.0D0
            if (.not.fail .and. lfree_ene) then
c               write(*,*) 'computing vibrational-energy term'
                call vibentr(0,vibcom, fail)
                if (.not.fail)  then
c                  write(*,*) 'vibrational-energy term',vibcom
                   evib= vibcom
                   etot= etot+evib
                else
                 write(*,*) 'problems with the initial calculation'
     &            ,' of the vibrational-energy term'
                endif
            endif

#ifdef PHCALC
            if(jump_prot) then
               write(*,*)' avoiding call to protonation '
               write(jout,*) 'avoiding call to protonation '
               etot=etot-ehyda
               ehyda=free_ene_cav
               delphi=free_ene_solv
               eprot=free_ene_hbind
               etot=etot+ehyda+delphi+eprot

               write(jout,*) ' '
               write(jout,*) 'Redefining energies'
               write(jout,*) 'EHYDA= ', EHYDA
               write(jout,*) 'DELPHI= ', DELPHI
               write(jout,*) 'EPROT= ', EPROT
               write(jout,*) 'ETOT= ', ETOT
               write(jout,*) ' '
            else
               eprot=0.0d0
               delphi=0.0d0
               if (phs.gt.0.0) call protonation(fail)
               if (fail) then
                 write(*,*) 'problems with the initial calculation'
     &            ,' of protonation state'
               end if 
            endif
#endif
            eval0 = float(ncoun)
            tcpu_zero = tcpu()
            write(*,*) ' Calculation for initial conformation ended'
            write (jout,'(2(a,e12.5/))')
     &    ' Number of Energy evals. for first Minimization = ', eval0,
     &    'Total Time in sec = ', tcpu_zero

C initialize lowest energy info.
            elowst=etot
            ilowst=izero

C 
            call symm(angulo)
C print dihedral angles of initial conformation AFTER minimization 
C  into main output (unit 20) and dihedral-angle file.
C
#ifdef PKSR
            call pthread_mutex_lock (imutex,istat)
#endif
            write(jout,248)ndone
            nukco=1
            if (withcnst) then
C        write (jout,'(a)') 'information regarding distance-constraints'
               call disprt
            endif
            if (dihecnst) call const_dieh(numvar,x)
            nukco=0

            call druang(jout,izero)
            call druang(jang,izero)
C print energy to main output
            call eneprint
#ifdef MP
#ifdef AIX
            call flush_(jout)
#endif
#ifdef WINNT
		   call flush(jout)
#endif
#endif

            call close_app(jout,outfile)
C print pdb if requested.
            if (print) then
              call numstr(ndone,numm)
              call concat(coorpref,numm,cff)
              old_prefix=coorpref
              coorpref=cff
              call outnw(izero,itrein,ndone)
              coorpref=old_prefix
            endif
C
#ifdef PKSR
            call pthread_mutex_unlock (imutex,istat)
#endif
C Check if weight initial value need to be changed.
            if (adptwei) then
               call modifwei
            endif

            call place
C store conformation.
            good = .true.
C  conformation has to be added to the clusters.
C       write(*,'(a)') ' call add2cluster '
            call add2cluster(good)
C Initialize counters.
            do i=1,3
              icounter(i)=0
              itotc(i)=0
            enddo
C
#ifdef PKSR
C
            call pthread_mutex_lock (imutex,istat)
#endif
C
            write (jout,'(/80(1h*)/20x,a/80(1h*)/)') 
     &        'EDMC/MCM procedure'
C
#ifdef PKSR
            call pthread_mutex_unlock (imutex,istat)
#endif


C Call THETA first time   

            if (arbt.lt.1.0) then
C           write (jout,'(a)') 'Calling theta for the first time'
               nuk=1
               call theta
               nuk=0
            endif

C Generate the a priori distribution of the probablities of dihedral-angle
C motion.

            call probres
            call probdi(izero)
         endif

C
#ifdef PKSR
         call pthread_mutex_lock (imutex,istat)
#endif
         if (YourJob) then
         write (jout,110) ndone+1
         else
            write (jout,*) ' ****** Starting the assigned task ******'
         endif
         if (onscreen .and.YourJob) write (*,110) ndone+1
C
#ifdef PKSR
         call pthread_mutex_unlock (imutex,istat)
#endif

C End if not restart!
      endif

      not_done=.true.
      istop=0
      batime=tcpu()

C
#ifdef PKSR
************************************************************************
C Generate other threads.
      call edmc_pstart
C     write(6,'(A40)') 'FINISHED call to pstart'
#endif
C
      iseq=0
C
#ifdef PKSR
C
C  Check in to the barrier
      call pthread_barrier_checkin (barrier_id, iseq, istat)
      if (istat .ne. 0) call obituary ('1 Couldn''t check in to the
     $         barrier', iseq)
#endif
C
C  Execute the code
      call edmctask(iseq,icounts)
C =======================================================================
#ifdef MP
      write(*,*) TASKID, ' JUST LEFT EDMCTASK!'
      IF (TASKID.EQ.MASTER) THEN
        FINISHED = .TRUE.
        DO K=2, CGNUM
          IF (.NOT.CGDONE(CGLIST(K))) FINISHED = .FALSE.
        ENDDO
        DO WHILE (.NOT.FINISHED)
          CALL MASTER_MAIL
          FINISHED = .TRUE.
          DO K=2, CGNUM
            IF (.NOT.CGDONE(CGLIST(K))) FINISHED = .FALSE.
          ENDDO
        ENDDO
        write (*,*)  'ALL THE SLAVES FINISHED'
      ENDIF
#endif
C =======================================================================

C
#ifdef PKSR
C
C  Check out of the barrier
      call pthread_barrier_checkout(barrier_id, iseq, istat)
      if (istat .ne. 0) then
         call obituary ('2 Couldn''t check out of the
     $           barrier', iseq)
      endif
C
C     call pthread_mutex_lock (imutex,istat)
C     write (jout,*)  ' Checking out the barrier '
C     call etoff(1)
C     write (jout,*)  ' etoff.... '
C     call printet
C     write (jout,*)  ' printet.... '
C     call pthread_mutex_unlock (imutex,istat)
#endif

      if (YourJob)  then
          write(jout,*)' '
          write(jout,*)'No of conf. in cluster database=' , ncon
          write(jout,*)' '
         write(jout,'(/a60)')
     &  '************************************************************'
         if (inumrs.lt.32) write(jout,'(a11,a54)') '  ACCP.CONF',
     &   '  No.-ITER    ENERGY      REPEAT No.CLUSTER  ZIMM.CODE'

         if (inumrs.ge.32) write(jout,'(a11,a43)') '  ACCP.CONF',
     &   '  No.-ITER    ENERGY      REPEAT No.CLUSTER'

         kk = 0
         do j=1, ncon  
!         write(jout,*)'laccept(' , j, ')= ',  laccept(j)
               if (laccept(j)) then
              kk=kk+1
                  if (inumrs.lt.32) then 
                     write(jout,'(2(4x,i5),3x,e12.5,2(3x,i5),5x,30a2)' ) 
     &                kk, niterat(j), enemin(j),
     &                ncount(j),icluster(j), (zimm(i,j), i=2,inumrs-1)
                  else
                     write(jout,'(2i5,1x,e12.5,2(2x,i3))')   
     &                kk,niterat(j), enemin(j),ncount(j),icluster(j)
                  endif

               endif
         enddo
         call druang(jclstr, iamcon)

         write(jout,'(/a60/)')
     &  '************************************************************'

         write(jout,9060)elowst,ilowst
9060  format( 'LOWEST ENERGY FOUND =',E12.5 ,' ITERATION No.',I4)
#ifdef MP
#ifdef AIX
         call flush_(jout)
#endif
#ifdef WINNT
		   call flush(jout)
#endif
#endif
      endif 

C
#ifdef PKSR
      evals = 0
      do 192 m=1, ncells
       evals= evals + counts(m)
192   continue
      eval_per_sec= evals/tcpu()
      Peval_per_sec= ( evals-eval0 )/(tcpu()-tcpu_zero)

      call pthread_mutex_lock (imutex,istat)

      write (jout,'(2(a,e12.5/))')
     & ' Total Number of Energy eval. = ', evals,
     & 'Energy Evals. per sec - whole run = ', eval_per_sec,
     & 'Energy Evals. per sec - parallel portion = ', Peval_per_sec

      call pthread_mutex_unlock (imutex,istat)
#else

      evals=  float(icounts)
      eval_per_sec= evals/tcpu()
      itimepr= int(tcpu())
      write (jout,'(2(a,e12.5/))')  
     +' Total Number of Energy evals. = ',evals,
     +' Energy evals. per sec = ', eval_per_sec
#endif
C ====================================================================
#ifdef MPL
C       write (*,*) 'ICOUNTS = ', ICOUNTS
C       write (*,*) 'into reduce'
        CALL MP_REDUCE(ICOUNTS,TotalCounts,INTSIZE,MASTER,I_VADD,CGID)
        CALL MP_REDUCE(itimepr,TotalTime,INTSIZE,MASTER,I_VADD,CGID)
C       write (*,*) taskid, 'out of reduce'
#endif
#ifdef MPI
c       write (*,*) 'into reduce'
        CALL MPI_REDUCE(ICOUNTS,TotalCounts,1,MPI_INTEGER,MPI_SUM,
     & MASTER,MPI_COMM_WORLD,IERR)
        CALL MPI_REDUCE(Itimepr,TotalTime,1,MPI_INTEGER,MPI_SUM,
     & MASTER,MPI_COMM_WORLD,IERR)
c       write (*,*) taskid, 'out of reduce'
#endif
#ifdef MP
        IF (TASKID.eq.MASTER) THEN
          write (*,*) 'TotalCounts = ', TotalCounts
          TotalEvals = FLOAT(TotalCounts)
          TotalE_P_S = TotalEvals/TCPU()
          Average_time= float(TotalTime)/float(numtasks)
          WRITE (JOUT,'(2(/a,e12.5/))')
     &     ' Everybody''s evals = ', TotalEvals,
     &     ' Evals per sec = ', TotalE_P_S
          write(jout,'(2(/a,e12.5/))')
     &     ' Everybody"S time = ',  float(Totaltime),
     &     ' Time per processor = ', Average_time
        ENDIF
#endif
C ================================================================
#ifdef MP
#ifdef AIX
      call flush_(jout)
#endif
#ifdef WINNT
	  call flush(jout)
#endif
#endif
      return                                                            
 110  format('***********************************************'/
     &       '        Beginning iteration #',I4/
     &       '***********************************************')

      end                                                               
      subroutine edmctask(iseq,icounts)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
C =======================================================
#ifdef MP
      include 'PARAMET.MP'
      include 'COMMON.MP'
#endif
#ifdef MPI
      include 'mpif.h'
      INTEGER IERR, STATUS(MPI_STATUS_SIZE)
#endif
C =======================================================
      include 'COMMON.ODONNELL'
      include 'COMMON.CNTRL'
      include 'COMMON.OMTOR'
      include 'COMMON.MINPAR'
      include 'COMMON.EDMC'
      include 'COMMON.CALC'
      include 'COMMON.SOLVAT'
      include 'COMMON.EXTPH'
      include 'COMMON.DEBUG'
      include 'COMMON.TOR'
      include 'COMMON.SETUP'
      include 'COMMON.BRIDGES'
      include 'COMMON.TERMAL'
      include 'COMMON.XBOUNDX'
      include 'COMMON.GEN002X'
      include 'COMMON.TIME1'
      include 'COMMON.BONDSX'
      include 'COMMON.TORPX'
      include 'COMMON.IOUNIT'
      include 'COMMON.FILES'
      include 'COMMON.BLOKA'
      include 'COMMON.GEN000'
      include 'COMMON.GEN100'
      include 'COMMON.GEN004'
      include 'COMMON.TOR2'
      include 'COMMON.TORQUEX'
      include 'COMMON.NNDRUK'
      include 'COMMON.MOVE'
      include 'COMMON.BRAIN'
      include 'COMMON.PICK'
      include 'COMMON.BIAS'
      include 'COMMON.TRACK'
      include 'COMMON.MYCONF'
      include 'COMMON.PROB'
      include 'COMMON.ATOMSS'
      include 'COMMON.KASOS'
      include 'COMMON.CLUSTER'
#ifdef PHCALC
      INCLUDE 'param.ibems'
      include 'ecepp_ibems_intrf.h'
#endif
C
#ifdef PKSR
      include 'COMMON.PARRAY'
#endif
      external calcfpo, calcgpo, gradcax
      dimension iv(liv), urparm(1)
      dimension v(1:lv)
      logical over,ovrtim,fail,cngeo,good
      character*14 typ_gen(3) /'electrostatic','random','thermal'/
      data izero /0/, ione /1/, ifour /4/
      cngeo=.true.

C This is for the parallel version, only.
#ifdef PKSR
      if (iseq.ne.0) then
         call ksrinit(iseq)

C Some initialization should be done here!
         lprhi=lprohis(1)
         lchar=lcharg(1)
         do ji=1,inumrs
            list(ji)=listmin(ji,1)
            do k=1,MAXNUM_DIHE
                angulo(k,ji)=angmin(k,ji,1)
            enddo
         enddo
         kaso=1
         if (icutoff.ne.1) kaso=0
         call setup_x(izero)
      endif
#endif
#ifdef MPI
      do i=1,DESERTLENGTH
         desert(i) = 0.0D0
      enddo
#endif

      do while (not_done)
 
#ifdef PKSR
         call pthread_mutex_lock(imutex,istat)

         if (istat.ne.0) write(jout,*) Idleader,
     +     'MYTASK1: Return from  mutex_lock = ',istat
         write(jout,*) 'idleader ', idleader, 'starting now'
#endif
 
C*******************************************
         IF (YourJob) THEN
          if ( ovrtim() ) then
            write (jout,'(/80(1h*)/10x,A/80(1h*)/)')
     &      'Time up. Finishing ... ' 
#ifdef PKSR
            write(jout,*) 'Idleader ', Idleader, ' is leaving! '
#endif
            not_done = .false.
!            write (*,*) '*****NOT_DONE #1*****'
            goto 5000
          end if
         ENDIF

         if (ndone .lt. liczm) then
           call perturb(imov,over)

           t_local=temp
           if (over) then
             not_done = .false.
!             write (*,*) '*****NOT_DONE #2*****'
CCKSR         write(jout,*)'PROCESSOR ',idleader,' There are no more minima '
#ifdef MP
             write (jout,'(80(1H*)/2a/80(1H*))') 
     &       ' The work is done, ',
     &       ' or the other minima are inaccessible.'
#else
             write (jout,'(80(1H*)/a/80(1H*))') 
     &       '            The other minima are inaccessible.'
#endif
             goto 5000
C ==========================================================================
           else
             DO JL=1,NUMVAR
               NDX=INDXV(JL)
               VAR(JL)=ANGLES(NDX)
             ENDDO
             IF (EXCPRH.LT.1.0 .AND. LOGICPH) THEN
               CALL SETUP_X(IZERO)
             ENDIF
C ==========================================================================
           endif
C
#ifdef PKSR
CCKSR       write(jout,*)'PROCESSOR ',idleader,' going into minimization'
           Call Pthread_mutex_unlock (imutex,istat)
           if (istat.ne.0) write(jout,*) Idleader,
     +     'MYTASK2: Return from  mutex_unlock = ',istat
#endif
         else
           not_done = .false.
!           write (*,*) '*****NOT_DONE #3*****'
CCKSR       write(jout,*)'PROCESSOR ',idleader,' THE WORK IS DONE '
           write(jout,'(/80(1h*)/10X,A/80(1h*))') 'All iterations done.' 
           goto 5000
         endif
C*******************************************
C NOW MINIMIZED THE CONFORMATION 
C   ********* THIS PART CAN BE DONE IN PARALLEL   *********
C

         call optimize(numvar,x,calcfpo,calcgpo,iv,v,iuparm,urparm,
     &                 gradcax,fail)
C        call minimize(numvar,x,calcfpo,calcgpo,iv,v,iuparm,urparm,
C    &                 gradcax,fail)
cd       write (jout,*) 'Exit MINIMIZE ndone',ndone

! Compute configuartional entropy, if requested.
         evib= 0.0D0
         if (.not.fail .and. lfree_ene) then
!            write(*,*) 'into  vibentr'
             call vibentr(0,vibcom, fail)
             if (.not.fail)  then
                evib= vibcom
             else
C if this calculation fails the conformation should be eliminated, 
C but just in case put a high value to evib. DR 10/99
                evib= 1.0D+15
             endif
         endif
C*******************************************
#ifdef PKSR
         Call Pthread_mutex_lock (imutex,istat)
         if (istat.ne.0) write(jout,*) Idleader,
     +     'MYTASK3: Return from  mutex_lock = ',istat
#endif
C
C ADD the No. of energy evaluations performed during energy minimization
C to the total for this processor.
#ifdef PKSR
         counts(idleader + 1) = counts(idleader + 1) + ncoun
#else
         icounts = icounts + ncoun
#endif
         ncoun=0

         if (.not.fail .and. not_done) then
C increment counters for rnd or elec
C            if (imov.eq.3) lther=.true.
             do i=1,numvar
               angles( indxv(i) ) = pinorm( x(i) )
             enddo
             call symm(angulo)
             call ene_eval
             iamcon=ndone
             if (lfree_ene) etot= etot+evib
  
cd            print *,'iamcon=',iamcon
#ifdef PHCALC
             eprot=0.0d0
             delphi=0.0d0
             if (phs.gt.0) call protonation(fail)
cd            print *,'After protonation: iamcon=',iamcon
c             write (jout,*) 'ETOT',etot
!
             if (.not.not_done) then
! overtime 
! NOT_DONE msy have  been reset in master_mail or slave_mail
!                write (*,*) '*****NOT_DONE #4*****'
                write(jout,*)'PROCESSOR ',idleader,' NO TIME LEFT '
               goto 5000
             endif
            
c
C 2/24/95 AL - discard the conformation, if error(s) occur in eletrostatic-
C         solvation calculation.
             IF (.NOT.FAIL) THEN

#endif
C ==================================================================
                IF (YourJob) THEN
C ==================================================================
C Increment global counters and reset local counters.
                  icounter(imov)=icounter(imov)+1 
                  llcount=0
                  do ii=1,3
                     llcount=icounter(ii)+llcount 
                  enddo
#ifdef MP
                  write (jout,'(a,i4,3a,e12.5,a,f10.1)') 
     & 'Proc. ',taskid,' type ',typ_gen(imov), ' ETOT ',
     & etot,' kcal/mole; T= ',t_local
#else
                  write (jout,'(a,i4,3a,e12.5,a,f10.1)') 
     & 'Conf. ',llcount,', type ',typ_gen(imov),
     & ' ETOT= ',etot,' kcal/mole; T= ',t_local
#endif
                  iaccept=metropolis()
C                 write(jout,*) 'another one', ndone
                  if (iaccept.gt.0) ndone = ndone + 1
                  good = (iaccept.gt.0) 
C  see if conformation has to be added to the clusters.
                  if (iaccept.ge.0) call add2cluster(good)
                  if (.not. good) then
c                   write (jout,'(a)') 
c    &              'New conformation not added to any cluster'
                  elseif (nmerged.gt.1) then
                    write (jout,'(a,i5,a)') 
     &              'The following',nmerged,' clusters merged.'
                    write (jout,'(16i5)') (imerged(i),i=1,nmerged)
                  endif
                  if (good) then
                   write (jout,'(a)') 'The ITRACK array:'
                   write (jout,'(8(2i4,2x))') (i,itrack(i),i=1,ngr)
                  endif
c                 write (jout,'(a,i4)') 'Current cluster # is',icurrent

                  if (onscreen) then
                     if (.not. good) then
c                       write (*,'(a)') 
c    &                   'New conformation not added to any cluster'
                      elseif (nmerged.gt.1) then
                        write (*,'(a,i5,a)') 
     &                   'The following',nmerged,' clusters merged.'
                        write (*,'(16i5)') (imerged(i),i=1,nmerged)
                      endif
                      if (good) then
                        write (*,'(a)') 'The ITRACK array:'
                        write (*,'(8(2i4,2x))') (i,itrack(i),i=1,ngr)
                      endif
c                     write (*,'(a,i4)') 'Current cluster # is',icurrent

                  endif ! onscreen
C Increment global counters and reset local counters.
                  if (iaccept.eq.1) then  
C ==================================================================
#ifdef MP
                    write(*,*) 
     &                  'Accepted conformation from            0', ETOT
                    write(jout,*) 
     &                  'Accepted conformation from            0', ETOT
#endif
                    CALL ACCEPTING(IMOV,CNGEO)
#ifdef MP
#ifdef AIX
                    call flush_(jout)
#endif
#ifdef WINNT
		     call flush(jout)
#endif
#endif
                  endif
C
#ifdef MP
                ELSE
C                 write(jout,*) 'Sending conformation ',TASKID
                  desert(1) = DFLOAT(imov)
                  desert(2) = DFLOAT(iinc)
                  desert(3) = DFLOAT(lprhi)
                  desert(4) = DFLOAT(lchar)
                  DESERT(5) = einit
                  desert(6) = DBLE(t_local)
                  desert(7) = DFLOAT(numvar)
C ETOT, EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA, DELPHI, EPROT, EDIS, EDIHC
                  DESERT(8) = ETOT
                  DESERT(9) = EES
                  DESERT(10) = ENB
                  DESERT(11) = ETOR
                  DESERT(12) = EPRO
                  DESERT(13) = ETORBR
                  DESERT(14) = ELOOP
                  DESERT(15) = EHYDA
                  DESERT(16) = DELPHI
                  DESERT(17) = EPROT
                  DESERT(18) = EDIS
                  DESERT(19) = EDIHC
                  DESERT(20) = EVIB
#ifdef PHCALC
C          opt_ionz_ei(i)
                 DO I=1,NPOLRES_TEI
                    DESERT(i+20) = OPT_IONZ_EI(I)
                 ENDDO
#endif

C                 write(jout,* ) etot,ees,enb,etor,epro,edis,edihc
C                 write(jout,*) ' '
#endif
#ifdef MPL
                  CALL MP_BSEND(TASKID,INTSIZE,MASTER,MAYBE,MSGID)
                  CALL MP_BSEND(LIST,LISTSIZE,MASTER,LISTMSG,MSGIG)
                  CALL MP_BSEND(ANGLES,ANGLESIZE,MASTER,ANGLEMSG,MSGID)
                  CALL MP_BSEND(X,XSIZE,MASTER,XMSG,MSGID)
                  CALL MP_BSEND(DESERT,DESERTSIZE,MASTER,DESMSG,MSGID)
#endif
#ifdef MPI
!            write(*,*) 'Sending conf to master '
!            write(*,*) 'MAYBE msg '
!                               call sleep(3)
                  CALL MPI_SEND(TASKID,1,MPI_INTEGER,MASTER,MAYBE,
     &                          MPI_COMM_WORLD,IERR)
!                               if (IERR.NE.0)  call sleep(10)
!            write(*,*) 'LIST msg '
!            call sleep(3)
                  CALL MPI_SEND(LIST,maxnum_res,MPI_INTEGER,MASTER,
     &                          LISTMSG,MPI_COMM_WORLD,IERR)
!                               if (IERR.NE.0)  call sleep(10)

!            write(*,*) 'ANGLES msg '
!            call sleep(3)
                  CALL MPI_SEND(ANGLES,(maxnum_dihe*maxnum_res),
     &                          MPI_REAL,MASTER,ANGLEMSG,
     &                          MPI_COMM_WORLD,IERR)
!                               if (IERR.NE.0)  call sleep(10)

!            write(*,*) "X's msg "
!            call sleep(3)
                  CALL MPI_SEND(X,maxnum_var,MPI_REAL,MASTER,XMSG,
     &                          MPI_COMM_WORLD,IERR)
!                               if (IERR.NE.0)  call sleep(10)
!            write(*,*) 'DESERT msg '
!            write (*,*)
!    &        'EDMC: DESERT sent by ',taskid,'  ',(desert(i),i=1,8)
!            call sleep(3)
                  CALL MPI_SEND(DESERT,DESERTLENGTH,
     &                          MPI_DOUBLE_PRECISION,MASTER,DESMSG,
     &                          MPI_COMM_WORLD,IERR)
!                               if (IERR.NE.0)  call sleep(10)
!            write(*,*) 'done sending msgs to master '
!            call sleep(3)
#endif
                ENDIF
C ==================================================================
#ifdef PHCALC
             ELSE
              write (*,*) ' conformation discarded, error(s) '
     &        ,' in electrostatic calculation'
C         solvation calculation.
             ENDIF
#endif

         endif
C Write restart information. Caution! FOR SERIAL USE ONLY!!!

C ==================================================================
         IF (YourJob) THEN
C ==================================================================
            curtim=tcpu()
C           print *,'curtim=',curtim
            if (curtim-prevtim.ge.backup) then
C             print *,'Calling SAVER.'
              call saver
C             print *,'Exit SAVER.'
              prevtim=curtim
            endif
         ENDIF

#ifdef MP
#ifdef AIX
            call flush_(jout)
#endif
#ifdef WINNT
      	 call flush(jout)
#endif
#endif
5000     continue

#ifdef PKSR
         Call Pthread_mutex_unlock (imutex,istat)
         if (istat.ne.0) write(jout,*) Idleader,
     +     'MYTASK4: Return from mutex_unlock = ',istat
#endif

      Enddo

C MODIFIED STOPX here!
      if(istop.eq.0) then
#ifdef PKSR
         Call Pthread_mutex_lock (imutex,istat)
         if (istat.ne.0) write(jout,*) Idleader,
     +  'MYTASK5: Return from mutex_lock = ',istat
#endif
c
         istop=1

C debugging only
         if ( ovrtim() ) then
            write (*,*) ' leaving'
!           call sleep(10)
         endif

         if ( ovrtim() )  call saver
#ifdef PKSR
         Call Pthread_mutex_unlock (imutex,istat)
         if (istat.ne.0) write(jout,*)  Idleader,
     +  'MYTASK6: Return from mutex_unlock = ',istat
#endif
      endif

      return
      end
