C $Date: 1995/08/23 21:31:38 $
C $Revision: 3.1 $
C
C
C
      SUBROUTINE BRIDGRAD(N,IA,IB,IND,IVAR1,IVAR2,CST,DD,G)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER (nmax=3*maxnum_res)
      INCLUDE 'COMMON.GRAD2'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.ACAR'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.IOUNIT'
      DIMENSION DD(MAXCNSTM)
      LOGICAL LPROLIN 
      DIMENSION G(NMAX,MAXCNSTM),GGG(3)
cd    WRITE (JOUT,*) 'BRIDGRAD:'
cd    WRITE (JOUT,*) 'N=',N,' IA=',IA,' IB=',IB,' IND=',IND,' IVAR1=',
cd   & IVAR1,' IVAR2=',IVAR2,' CST=',CST
      I1=NPAIR(1,N)
      I2=NPAIR(2,N)
      IF (I1.EQ.1) I1=2
      IF (I2.EQ.INUMRS) I2=I2-1
      DO I=1,NPRE(INUMRS+1)
        DO J=1,3
          CGE(J,I)=0.0D0
        ENDDO
      ENDDO
      DO I=1,NUMVAR
        AGE(I)=0.0D0
      ENDDO
      DO J=1,3
        GGG(J)=CST*(COORD(J,IB)-COORD(J,IA))/DD(IND)
      ENDDO
      DO L=1,3
        CGE(L,IA)=-GGG(L)
      ENDDO
      DO L=1,3
        CGE(L,IB)=GGG(L)
      ENDDO
      CALL GRADCA
cd    WRITE (JOUT,*) 'VECTOR AGE:'
cd    WRITE (JOUT,'(10F8.3)') (AGE(J),J=1,NUMVAR)
cd    WRITE (JOUT,*)
      IVAR=IVAR1
      DO J=I1,I2
C Changed 11/13/93 to take into account VAR_ANGLES=SPEC and so on -- AL
        if (j.gt.i1 .and. nchvar(j,1).eq.1) then
          G(IVAR,IND)=AGE(IFIND(J))
          ivar=ivar+1
        endif
        if (j.lt.i2 .and. nchvar(j,2).eq.1) then
          G(IVAR,IND)=AGE(IPIND(J))
          ivar=ivar+1
        endif
      ENDDO
      IVAR=IVAR2
      DO J=1,NKAI1(N)
        if (ichind1(n,j).gt.0) then 
          G(IVAR,IND)=AGE(ICHIND1(N,J))
          IVAR=IVAR+1
        endif
      ENDDO 
      DO J=1,NKAI2(N)
        if (ichind2(n,j).gt.0) then
          G(IVAR,IND)=AGE(ICHIND2(N,J))
          IVAR=IVAR+1
        endif
      ENDDO
cd    DO II=1,NUMVAR
cd      WRITE (JOUT,'(I3,F10.5)') II,AGE(II)
cd    ENDDO
      RETURN
      END
      SUBROUTINE CALCGPO( N, X, NF, G, IUPARM, URPARM, UFPARM )

      EXTERNAL UFPARM
      INTEGER IUPARM(1)
      REAL URPARM(1)
      REAL X(N), G(N)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.DERIV'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.VTFEX'
      DOUBLE PRECISION GMAX2
      DATA GMAX2 /1.0D30/
      DO 10 L=1,N
       G(L)=0.0
   10 CONTINUE
      ICG=MOD(NF,2)+1
C     write(6,*) 'NF,NFL, ICG',NF,NFL, ICG
      IF (NF-NFL+1) 20,30,40
   20 CALL CALCFPO( N, X, NF, F, IUPARM, URPARM, UFPARM )
      IF (NF.EQ.0) RETURN
      GO TO 40
C  30 CALL PPVAL(X,N)
C Normalize the X vector.
   30 DO 50 L=1,N
       IF ( (ABS(X(L)).GT.1.0E+10) ) THEN
          WRITE (*,*)'ERROR CALCGPO: X(',L,') ',DEG*X(L)
       END IF

       ANGLES( INDXV(L) ) = PINORM(X(L))
   50 CONTINUE
C     CALL REGEN(Y)
      CALL GENER

C  Convert Gradient from Cartesian to Dihedral.
C  40 CALL UFPARM(N,G,NF,IUPARM,GMAX2)
   40 CALL UFPARM(N,G,NF,IUPARM)

      IF (NF.EQ.0) RETURN
C  Calculate Gradient contribution from torsional terms.
      DO 60 L=1,N
        IF (IFTOR(L).EQ.1.AND.IFLOV.EQ.0) THEN
          BAN=A(L)*NS(L)*NB(L)
          DTRM=BAN*SIN(NB(L)*X(L))
          G(L)=G(L)-DTRM
C          WRITE(jout,122) L,deg*X(L), L, G(L)
        ENDIF
   60 CONTINUE
C  Calculate Gradient contribution from dihedral-constraint terms.
      CALL GRADCONX(N,X,G)

122   FORMAT('X(',i3,')=',f10.3,'G(',i3,')= ',E12.5)
      RETURN
      END
      SUBROUTINE CALSS(IS,IT,IU,IV,ARO,IMULT)
C THIS SUBROUTINE COMPUTES THE CONTRIBUTIONS TO THE
C CARTESIAN GRADIENT COMING FROM THE TORSIONAL TERMS
C OF THE DISULFIDE LOOP CLOSING POTENTIAL.
C IT USES THE RESULTS OF DIHV AND IS CALLED BY SSBRIJ.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      DOUBLE PRECISION DUK
      INCLUDE 'COMMON.DERIV'
      COMMON/DIVH/CPSI,DS(3),DT(3),DU(3),DV(3)
C Change 8/3/93 to handle all types of bridges.
C     UKA=UKA*(12.0*CPSI*CPSI-3)
      UKA=DENETOR(CPSI,ARO,IMULT)
      DO 1 L=1,3
      UK2=UKA*DS(L)
      DUK=UK2
C     CGE(L,IS)=CGE(L,IS)+DUK
      CGE(L,IS,ICG)=CGE(L,IS,ICG)+DUK
      UK2=UKA*DT(L)
      DUK=UK2
C     CGE(L,IT)=CGE(L,IT)+DUK
      CGE(L,IT,ICG)=CGE(L,IT,ICG)+DUK
      UK2=UKA*DU(L)
      DUK=UK2
C     CGE(L,IU)=CGE(L,IU)+DUK
      CGE(L,IU,ICG)=CGE(L,IU,ICG)+DUK
      UK2=UKA*DV(L)
      DUK=UK2
C     CGE(L,IV)=CGE(L,IV)+DUK
      CGE(L,IV,ICG)=CGE(L,IV,ICG)+DUK
 1    CONTINUE
      RETURN
      END
      subroutine check_grad
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (isuppl=maxnum_dihe-3)
      external gradcax,ufparm,calcgpo
      double precision e0
      dimension g(maxnum_var)
      include 'COMMON.CNTRL'
      include 'COMMON.IOUNIT'
      include 'COMMON.CALC'
      include 'COMMON.GEN100'
      include 'COMMON.TOR2'
      include 'COMMON.SETUP'
      include 'COMMON.GRAD2'
      include 'COMMON.THRLET'
      include 'COMMON.TORQUEX'
      include 'COMMON.INDXS'
      include 'COMMON.VTFEX'
      integer id(1)
      real urparm(1)
C
#ifdef PKSR
      include 'COMMON.PARRAY'
#endif
      character*5 aang,ang_ident(maxnum_dihe) 
     & /'phi','psi','omega',isuppl*'chi'/


      if (over_cutoff.gt.0.0 .or. icomp(1).eq.2) then
        simple_pot=.true.
        if(iflov.eq.0) iflov=1
      endif

      ID(1) = 2
      nf=1
      call ene_eval
C print  angles
#ifdef PKSR
      call pthread_mutex_lock (imutex,istat)
#endif
      write(*,248)
      write(jout,248)
248   format(//' Checking Gradients ')
      call druang(jout,ione)
C print  energy components
      call eneprint
#ifdef PKSR
      call pthread_mutex_unlock (imutex,istat)
#endif

      nf=1
      call calcfpo( numvar, x, nf, f, id, urparm, ufparm )
      e0=f

      write (*,*) 'e0=',e0,' etot=',f
      write (jout,*) 'e0=',e0,' etot=',f

C ICX to indicate that indexes for the loops on gradca should be calculated.
C                                                  DR  AUG-22-94
      icx=1
      nf=1
      call calcgpo(numvar,x,nf,g,id,urparm,gradcax)

#ifdef PKSR
      call pthread_mutex_lock (imutex,istat)
#endif
      write (*,'(/80(1h*)/10x,a/80(1h*)/)') 
     &'Comparison of analytical and numerical dihedral-angle gradient:'
      write (jout,'(/80(1h*)/10x,a/80(1h*)/)') 
     &'Comparison of analytical and numerical dihedral-angle gradient:'
      write (jout,'(a8,2x,a7,2x,a5,2x,a10,2a15,a10/76(1h-))')
     & 'variable','residue','angle','value','analytical','estimated',
     & '%diff'
      write (*,'(a8,2x,a7,2x,a5,2x,a10,2a15,a10/76(1h-))')
     & 'variable','residue','angle','value','analytical','estimated',
     & '%diff'
#ifdef PKSR
      call pthread_mutex_unlock (imutex,istat)
#endif

      ires1=0
      do i=1,numvar
        call ndx_decode(indxv(i),ires,iang)
        if (ires.ne.ires1) then
          ires1=ires
          write (jout,*)
        endif
        xi=x(i)
        x(i)=x(i)+0.0001
        call calcfpo(numvar,x,nf,f,id,urparm,calcgpo)
C       write (jout,*) 'etot=',f,' e0=',e0
c       gi=(f-e0)/0.0001
        gi=(f-e0)/0.001
        if (ires.eq.1 .or. ires.eq.inumrs) then
          aang='tau'
        else 
          aang=ang_ident(iang)
        endif
        lires=iabs(list(ires))
	if (ires.eq.1 .or. ires.eq.inumrs) lires=lires+num_restypes
        
#ifdef PKSR
        call pthread_mutex_lock (imutex,istat)
#endif
        if (ires.ne.1 .and. ires.ne.inumrs .and. iang.gt.3) then
          write (*,'(i5,5x,a3,i4,2x,a3,i3,1x,f10.3,2(1pe15.5),
     &                  0pf10.1)')
     &        i,ares(lires),ires,aang,iang-3,deg*xi,g(i),gi,
     &        100*abs(gi-g(i))/amax1(abs(g(i)),abs(gi),1.0E-5)
          write (jout,'(i5,5x,a3,i4,2x,a3,i3,1x,f10.3,2(1pe15.5),
     &                  0pf10.1)')
     &        i,ares(lires),ires,aang,iang-3,deg*xi,g(i),gi,
     &        100*abs(gi-g(i))/amax1(abs(g(i)),abs(gi),1.0E-5)
	elseif (ires.eq.1 .or. ires.eq.inumrs) then
          write (*,'(i5,5x,a3,i4,2x,a3,i3,1x,f10.3,2(1pe15.5),
     &                  0pf10.1)')
     &        i,ares(lires),ires,aang,iang,deg*xi,g(i),gi,
     &        100*abs(gi-g(i))/amax1(abs(g(i)),abs(gi),1.0E-5)
          write (jout,'(i5,5x,a3,i4,2x,a3,i3,1x,f10.3,2(1pe15.5),
     &                  0pf10.1)')
     &        i,ares(lires),ires,aang,iang,deg*xi,g(i),gi,
     &        100*abs(gi-g(i))/amax1(abs(g(i)),abs(gi),1.0E-5)
        else
          write (*,'(i5,5x,a3,i4,2x,a5,2x,f10.3,2(1pe15.5),
     &                  0pf10.1)')
     &        i,ares(lires),ires,aang,deg*xi,g(i),gi,
     &        100*abs(gi-g(i))/amax1(abs(g(i)),abs(gi),1.0E-5)
          write (jout,'(i5,5x,a3,i4,2x,a5,2x,f10.3,2(1pe15.5),
     &                  0pf10.1)')
     &        i,ares(lires),ires,aang,deg*xi,g(i),gi,
     &        100*abs(gi-g(i))/amax1(abs(g(i)),abs(gi),1.0E-5)
        endif
#ifdef PKSR
        call pthread_mutex_unlock (imutex,istat)
#endif

        x(i)=xi
      enddo
      return
      end
      SUBROUTINE CROSS(ICG,IAG,IA1)
C THIS SUBROUTINE PERFORMS THE ACTUAL TRANSFORMATION
C OF THE CARTESIAN GRADIENT CGE, TO THE DIHEDRAL GRADIENT
C AGE.  IT IS CALLED BY GRADCA.
      DOUBLE PRECISION DCX,DCY,DCZ,DBX,DBY,DBZ
      DOUBLE PRECISION GX, GY, GZ
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GRAD2'
      INCLUDE 'COMMON.ATOMSS'
      COMMON/GRAD3/DCX,DCY,DCZ
      DBX=COORD(1,ICG)-COORD(1,IA1)
      DBY=COORD(2,ICG)-COORD(2,IA1)
      DBZ=COORD(3,ICG)-COORD(3,IA1)
      GX = CGE(1,ICG)
      GY = CGE(2,ICG)
      GZ = CGE(3,ICG)
      DCX = DCX + DBY * GZ - DBZ * GY
      DCY = DCY + DBZ * GX - DBX * GZ
      DCZ = DCZ + DBX * GY - DBY * GX
      RETURN
      END
      FUNCTION DENETOR(CPSI,ARO,IMULT)
      IF (IMULT.EQ.1) THEN
        DENETOR=ARO
      ELSEIF (IMULT.EQ.2) THEN
        DENETOR=4.0*ARO*CPSI
      ELSEIF (IMULT.EQ.3) THEN
        DENETOR=ARO*(12.0*CPSI*CPSI-3.0)
      ELSE
        DENETOR=0.0
      ENDIF
      RETURN
      END
      SUBROUTINE DERIV
C THIS SUBROUTINE SETS UP THE ARRAYS NA,NB,IND AND RG
C FOR EACH VARIABLE DIHEDRAL ANGLE THE INFORMATION IN
C THESE ARRAYS IS AS FOLLOWS:
C  NA: IT CONTAINS THE ATOM NUMBER OF THE FIRST ATOM
C      OF THE BOND AROUND WHICH THE ANGLE IS DEFINED.
C NB: CONTAINS THE ATOM NUMBER OF THE OTHER ATOM
C     WHICH DEFINES THE BOND.
C IND(1,X): IT CONTAINS THE ATOM NUMBER OF THE FIRST
C ATOM AFFECTED BY ROTATION AROUND ANGLE X.
C IND(2,X): IT CONTAINS THE ATOM NUMBER OF THE LAST
C ATOM AFFECTED BY ROTATION AROUND X.
C RG: IT CONTAINS THE INVERSE OF THE MAGNITUDE OF
C     THE VECTOR BETWEEN NA & NB.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.LBONDSX'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.GRADT'
      IB=0
      KB=0
      DO 150 I=1,INUMRS
      NVR=NV(I)
      IF (NVR.EQ.0) GO TO 140
      DO 130 KK=1,NVR
      K=KB+KK
      JIK=NDXARR(KK,I)
      JIB=JIK+IB
      NA(K)=IE1(JIB)
      NB(K)=IE2(JIB)
 125  IND(1,K)=LROT1(JIB)
      IND(2,K)=LROT2(JIB)
  130 CONTINUE
  140 IB=IB+maxnum_dihe
      KB=KB+NVR
  150 CONTINUE
C
      DO 160 L=1,NUMVAR
         NA1 = NA(L)
         NA2 = NB(L)
         IAG = L
         CALL UNIMAG( NA1, NA2, IAG )
160   CONTINUE
C
      RETURN
      END
      SUBROUTINE DIHV(S,T,U,V)
C THIS SUBROUTINE COMPUTES THE COSINE OF THE DIHEDRAL
C ANGLE DETERMINED BY VECTORS S,T,U & V. IT ALSO
C COMPUTES THE VALUE OF THE PARTIAL DERIVATIVE OF
C THIS COSINE WITH RESPECT TO THE X,Y & Z COMPONENTS
C OF S,T,U & V.
C IT USES THE IDENTITY (AXB).(CXD)=(A.C)*(B.D)-(A.D)*(B.C)
C WHICH ALTHOUGH DOES NOT PRESENT ANY SIGNIFICANT INPROVMENT
C IN THE CALCULATION OF THE COSINE, IT DOES MAKE SIMPLER
C THE COMPUTATION OF THE PARTIAL DERIVATIVES.
      COMMON/DIVH/CPSI,DS(3),DT(3),DU(3),DV(3)
      DIMENSION S(3),T(3),U(3),V(3)
      DIMENSION TS(3),UT(3),VU(3)
      DO 1 L=1,3
      TS(L)=T(L)-S(L)
      UT(L)=U(L)-T(L)
      VU(L)=V(L)-U(L)
    1 CONTINUE
      RUT=0.0
      RUV=0.0
      RTS=0.0
      DUTS=0.0
      DUTV=0.0
      DUTV=0.0
      DALL=0.0
      DO 2 L=1,3
      RUT=RUT+UT(L)*UT(L)
      RUV=RUV+VU(L)*VU(L)
      RTS=RTS+TS(L)*TS(L)
      DUTS=DUTS+TS(L)*UT(L)
      DUTV=DUTV+UT(L)*VU(L)
      DALL=DALL+VU(L)*TS(L)
    2 CONTINUE
      BETA=RTS*RUT-DUTS*DUTS
      GAMMA=RUT*RUV-DUTV*DUTV
      RHO=DUTS*DUTV-DALL*RUT
      BGINV=BETA*GAMMA
      BGINV=SQRT(BGINV)
      BGINV=1.0/BGINV
      RBMT=RHO/BETA
      RGMT=RHO/GAMMA
      CPSI=RHO*BGINV
      DO 3 L=1,3
      DKT=RUT*TS(L)-DUTS*UT(L)
      DKU=2.0*DALL*UT(L)
      DKV=RUT*VU(L)-DUTV*UT(L)
      DKW=DUTS*VU(L)+DUTV*TS(L)
      DKX=RTS*UT(L)-DUTS*TS(L)
      DKY=DUTV*VU(L)-RUV*UT(L)
      DS(L)=BGINV*(DKV+RBMT*DKT)
      DT(L)=BGINV*(DKU-DKV-DKW+RBMT*DKX-RBMT*DKT-RGMT*DKY)
      DU(L)=BGINV*(DKW+DKT-DKU-RBMT*DKX+RGMT*DKV+RGMT*DKY)
      DV(L)=-BGINV*(DKT+RGMT*DKV)
 3    CONTINUE
      RETURN
      END
      SUBROUTINE GRADCA
C SUBROUTINE GRADCA DRIVES THE TRANSFORMATION OF
C THE CARTESIAN GRADIENT CGE TO THE DIHEDRAL GRADIENT
C AGE. IT USES THE INFORMATION STORED BY DERIV IN ARRAYS
C NA,NB AND IND.
      DOUBLE PRECISION DCX, DCY, DCZ
      DOUBLE PRECISION DUX, DUY, DUZ
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GRADT'
      INCLUDE 'COMMON.GRAD2'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.TOR2'
      COMMON/GRAD3/ DCX, DCY, DCZ
      COMMON/GRAD4/ DUX, DUY, DUZ
      DO 100 L=1,NUMVAR
      IAG=L
      NA1=NA(L)
      NA2=NB(L)
C NA1 AND NA2 DETERMINE THE BOND AROUND WHICH THE VARIABLE
C ANGLE "L" ROTATES.
      DCX = 0.0D0
      DCY = 0.0D0
      DCZ = 0.0D0
      DUX = COORD(1,NA2) - COORD(1,NA1)
      DUY = COORD(2,NA2) - COORD(2,NA1)
      DUZ = COORD(3,NA2) - COORD(3,NA1)
C
10    LRTO = IND(1,L)
C
      NM=IND(2,L)
C PSI IS TREATED AS A SPECIAL CASE: BECAUSE OF THE NUMBERING
C SYSTEM OF ECEPP IT IS NOT POSSIBLE TO DEFINE IND(1,L) AND
C IND(2,L) IN A DIRECT WAY FOR PSI. INSTEAD WE HAVE TO
C CALCULATE FIRST THE CONTRIBUTION FROM THE BACKBONE
C OXYGEN ATOM OF THE RESIDUE TO WHICH PSI BELONGS,
C AND THEN,NOW IN A DIRECT WAY, THE CONTRIBUTION FROM
C ATOMS LRTO(NITROGEN OF THE NEXT RESIDUE) TO NM(LAST
C ATOM IN THE POLYPEPTIDE).
      IF(LRTO.GT.0) GO TO 80
      ILO=-LRTO
      LRTO=NPRE(ILO)+1
      ILO=ILO-1
      ILOX=NPRE(ILO)+7
      CALL CROSS(ILOX,IAG,NA2)
 80   DO 90 IK=LRTO,NM
      ILOK=IK
      CALL CROSS(ILOK,IAG,NA2)
 90   CONTINUE
C
      AGE(IAG) = RG(IAG) * ( DCX*DUX + DCY*DUY + DCZ*DUZ ) + AGE(IAG)
C Change 4/22/93 (AL) Invert the sign of the components of the gradient
C                     corresponding to those angles of N-terminal group
C                     rotation of which affects the atoms next to bond
C                     axis.
      if (na1.gt.nm) age(iag)=-age(iag)
C
 100  CONTINUE
      RETURN
      END
      SUBROUTINE GRADCAX(N,G,NF,IUPARM)
C SUBROUTINE GRADCA DRIVES THE TRANSFORMATION OF
C THE CARTESIAN GRADIENT CGE TO THE DIHEDRAL GRADIENT
C AGE. IT USES THE INFORMATION STORED BY DERIV IN ARRAYS
C NA,NB AND IND.
      DIMENSION G(N)
      INTEGER IUPARM(1)
      DOUBLE PRECISION DCX, DCY, DCZ
      DOUBLE PRECISION DUX, DUY, DUZ
      DOUBLE PRECISION DBX, DBY, DBZ
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GRADT'
      INCLUDE 'COMMON.DERIV'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.INDXS'
      INCLUDE 'COMMON.IOUNIT'
C   N and NUMVAR are equivalent
      ICX=1
      IF (ICX.EQ.1) THEN
       DO 10  L=1,N
         INX(1,L)=1
         INX(2,L)=0
         LRTO = IND(1,L)
         IF (LRTO.LE.0)  THEN
            ILO=-LRTO
            LRTO=NPRE(ILO)+1
            ILO=ILO-1
            ILOX=NPRE(ILO)+7
            INX(1,L)=ILOX
            INX(2,L)=ILOX
         ENDIF
         INX(3,L)=LRTO
         INX(4,L)=IND(2,L)
 10    CONTINUE
       ICX=0
      ENDIF 

      DO 100 L=1,N
         NA1=NA(L)
         NA2=NB(L)
C NA1 AND NA2 DETERMINE THE BOND AROUND WHICH THE VARIABLE
C ANGLE "L" ROTATES.
         DCX = 0.0D0
         DCY = 0.0D0
         DCZ = 0.0D0
C     DUX = COORD(1,NA2) - COORD(1,NA1)
C     DUY = COORD(2,NA2) - COORD(2,NA1)
C     DUZ = COORD(3,NA2) - COORD(3,NA1)

         CA2X = COORD(1,NA2)
         CA2Y = COORD(2,NA2)
         CA2Z = COORD(3,NA2)
         DUX = CA2X - COORD(1,NA1)
         DUY = CA2Y - COORD(2,NA1)
         DUZ = CA2Z - COORD(3,NA1)
C
C        ISTR= INX(1,L)
C        IEND = INX(2,L)
C        DO 50 IK=ISTR, IEND
         DO 50 IK=INX(1,L), INX(2,L)
            DBX=COORD(1,IK)-CA2X
            DBY=COORD(2,IK)-CA2Y
            DBZ=COORD(3,IK)-CA2Z
            IAT3=3*(IK-1)
            GX = CGX((IAT3+1),ICG)
            GY = CGX((IAT3+2),ICG)
            GZ = CGX((IAT3+3),ICG)
            DCX = DCX + DBY * GZ - DBZ * GY
            DCY = DCY + DBZ * GX - DBX * GZ
            DCZ = DCZ + DBX * GY - DBY * GX
 50      CONTINUE

C        write(*,*)'GRADCAX-   Using, ICG =', ICG 
C        write(JOUT,*)'GRADCAX-   Using, ICG =', ICG 
C        ISTR= INX(3,L)
         IEND = INX(4,L)
C        DO 90 IK=ISTR, IEND
         DO 90 IK=INX(3,L), IEND
            DBX=COORD(1,IK)-CA2X
            DBY=COORD(2,IK)-CA2Y
            DBZ=COORD(3,IK)-CA2Z
            IAT3=3*(IK-1)
            GX = CGX((IAT3+1),ICG)
            GY = CGX((IAT3+2),ICG)
            GZ = CGX((IAT3+3),ICG)
            DCX = DCX + DBY * GZ - DBZ * GY
            DCY = DCY + DBZ * GX - DBX * GZ
            DCZ = DCZ + DBX * GY - DBY * GX
 90      CONTINUE
         G(L) = RG(L) * ( DCX*DUX + DCY*DUY + DCZ*DUZ ) + G(L)

C Change 4/22/93 (AL) Invert the sign of the components of the gradient
C                     corresponding to those angles of N-terminal group
C                     rotation of which affects the atoms next to bond
C                     axis.
         IF (NA1.GT. IEND) G(L)=-G(L)

C     write(6,*)'GRADCAX-   L, G(L)', L, G(L) 
C
 100  CONTINUE
      RETURN
      END
      SUBROUTINE INGRAD
C THIS SUBROUTINE INITIALIZES ARRAYS CGE AND AGE
C AND IS CALLED BY CALCG.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GRAD2'
      DO 1 J=1,MAXCGE
      DO 2 I=1,3
      CGE(I,J)=0.0D0
 2    CONTINUE
 1    CONTINUE
      DO 3 L=1,MAXAGE
      AGE(L)=0.0D0
 3    CONTINUE
      RETURN
      END
      SUBROUTINE SSGR(X,Y,R0X,DX,ARO,IX,IY)
C THIS SUBROUTINE CALCULATES TERMS IN CGE ARISING
C FROM THE CONS.*(R-RO)**2-TYPE TERMS IN THE 
C LOOP CLOSING POTENTIAL. IT IS CALLED BY ENEBRIDGE.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      DOUBLE PRECISION DUK
      INCLUDE 'COMMON.DERIV'
      DIMENSION X(3),Y(3)
      RM1=1.0/DX
      DELTA=ARO*RM1*(DX-R0X)
      DO 1 L=1,3
      DELTAP=DELTA*(X(L)-Y(L))
      DUK=DELTAP
C     CGE(L,IX)=CGE(L,IX)+DUK
C     CGE(L,IY)=CGE(L,IY)-DUK
      CGE(L,IX,ICG)=CGE(L,IX,ICG)+DUK
      CGE(L,IY,ICG)=CGE(L,IY,ICG)-DUK
    1 CONTINUE
      RETURN
      END
      FUNCTION UFPARM(HOG)
        PARAMETER(MT=38,LX=MT+20)
      PIG=HOG
      UFPARM=PIG
      RETURN
      END
