C $Date: 1997/10/31 18:42:20 $
C $Revision: 3.4 $
C
C
C
      SUBROUTINE INIT_INT_TABLE
C This subroutine will set up the interaction table.
C VERY IMPORTANT SOME ARRAYS used to define 1-4 interactions will apply
C to residues with no more than 31 atoms.   DR  12/91 ^^^&&&
C
C  -Altered 11/91  to include residues with N-methyl groups.
C   Generation: changes  in GENER, GNSIDE, added GNMET
C   ENERGY evaluation: ADJAMN, ADJNN, ADJPN, INT15, SSBRIJ.
C   1-4 interactions between HM and C-alpha are computed using the
C   NSX14and NFX14 arrays (see RSDATA file).
C
C  -Altered  7/91 to include loop closing energy terms allowing the
C   treatment of cyclic (backbone) polypeptide chains.
C It sets up  properly the part of the interaction array corresponding 
C to the first and the last residue of a cyclic chain.
C IMPORTANT! The first residue MUST NOT be proline or hydroxy-proline 
C and only ECEPP end groups 10 and 20 can be used.
C ****** SO BE CAREFUL!  Choose the starting and end residues so that
C this requirement is fulfilled.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      LOGICAL LPROLIN
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.TOR2'
C     INCLUDE 'COMMON.GRAD2'
      INCLUDE 'COMMON.IOUNIT'
C     INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.GEN008'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.DEBUG'
      DIMENSION RING(7),ringh(6),ringd(6)
C (02/06/91) new values for EPR following a modification of the
c    Proline geometry (Pro-up and Pro-down only) and N-terminal
c    Proline (ring(7))
      data ring(1),ring(2),ring(3),ring(4),ring(5),ring(6),ring(7)/
c    1   0.0,0.9495,0.4734,0.000,0.3398,0.000,1.2073/
c (08/18/97) new value for ring(7) revised by Kang
     1   0.0,0.9495,0.4734,0.000,0.3398,0.000,1.4491/
c (4/25/91) new values for EHPR = fixed energy of hydroxyproline
      data ringh(1),ringh(2),ringh(3),ringh(4),ringh(5),ringh(6)/
c    1     0.000,0.5829,0.9279,0.000,0.000,0.4642/
c (08/18/97) new value for ringh(7) revised by Kang
     1     0.000,0.5861,0.8301,0.000,0.000,0.3704/
c (4/22/99) new values for EHPD of 5,5 dimethylproline from Kang
      data ringd(1),ringd(2),ringd(3),ringd(4),ringd(5),ringd(6)/
     1     0.000,0.9248,0.3541,0.000,0.5053,0.0000/
C     DIMENSION RING(7)
C     DATA RING(1),RING(2),RING(3),RING(4),RING(5),RING(6),RING(7)/
C    1   1.366,0.520,0.318,0.920,0.186,0.000,0.994/
C
C     lprnt=.true.
      lprnt=.false.
      EPRO=0.0E0
      EPR=0.0E0
      EHPR=0.0E0
C LASTRS IS THE LAST RESIDUE OF THE MOLECULE, I. E., THE CARBOXYL END
C GROUP, IF ANY, OTHERWISE THE LAST FULL RESIDUE.
      LASTRS=INUMRS
      IF (KCARB.EQ.20) LASTRS=LASTRS-1
C
C STEP IJ
C IJ IS THE RESIDUE NUMBER OF J, THE 1ST ATOM OF THE INTERACTING PAIR
C
      DO 6 IJ=1,LASTRS
C
C IFEND=0 IF I IS NOT AN END GROUP.  IFEND=1 IF IT IS AN END GROUP
      IFEND=0
      IF(IJ.EQ.1.OR.IJ.EQ.INUMRS) IFEND=1
      LISTIJ=LIST(IJ)
      LISTIJ=IABS(LISTIJ)
      IF (IFEND.EQ.0) THEN
         KINDIJ=KNDRES(LISTIJ)
      ELSE
         KINDIJ=KNDEND(LISTIJ)
      ENDIF
      KINDIJ=IABS(KINDIJ)
C                                            DR 5-93
      IF(IJ.EQ.1) THEN
         KSAVEND= KINDIJ
      ENDIF
      KLOOP=0
cd    print *,'ij=',ij,' listij=',listij,' kindij=',kindij
C
C IF IJ IS A HALF-RESIDUE, THIS SECTION FINDS KLOOP
C (IF IT EXISTS), THE RESIDUE NUMBER OF THE OTHER HALF.
C
      DO 10 NBRIDGE=1,NLOOP
        NP1=NPAIR(1,NBRIDGE)
        NP2=NPAIR(2,NBRIDGE)
        IF(IJ.EQ.NP1) THEN
          KLOOP=NP2
          GOTO 201
        ENDIF
 10   CONTINUE
C
C JPRO=1 IF THE RESIDUE CONTAINING THE JTH ATOM IS A PROLINE OR A 
C H-PROLINE
 201  JPRO=0
      IF(IFEND.NE.1.AND.LPROLIN(IJ)) JPRO=1
C
C NPREIJ AND NPREIK WILL BE USED TO CONVERT ATOM NUMBERS
C J AND K NUMBERED WITHIN THE RESIDUE, TO JM AND KM, THE SAME
C ATOMS BUT NUMBERED WITHIN THE WHOLE MOLECULE.
      NPREIJ=NPRE(IJ)
      NPREIK=NPRE(IJ+1)
      JSTRT=1
      JFIN=NPREIK-NPREIJ
      IF (JFIN.EQ.0) GO TO 6
C
C DEFINE VARIABLES NEEDED BELOW (SEE DEFINITION OF VARIABLES)
      KPRO=0
      KINDIK=99
      IF (IJ.EQ.LASTRS) GO TO 22
      IK=IJ+1
      LISTIK=LIST(IK)
      LISTIK=IABS(LISTIK)
      KINDIK=KNDRES(LISTIK)
      IF (IK.EQ.INUMRS) KINDIK=KNDEND(LISTIK)
      KINDIK=IABS(KINDIK)
      IF((LPROLIN(IK)).AND.IK.NE.INUMRS) KPRO=1
C
C IF THE ENDGROUP IS TYPE 6, ADD TO EPRO THE INTERNAL ENERGY OF CIS-H-
C PROLINE RELATIVE TO TRANS-H-PROLINE.  IF THE NEXT RESIDUE IS PROLINE,
C OR HYDROXYPROLINE, ADD TO EPRO THE INTERNAL ENERGY OF THE FIXED PART
C OF THE PYRROLIDINE RING. THIS WILL DIFFER FOR CIS AND TRANS PEPTIDE
C BOND, AND FOR DIFFERENT RING GEOMETRIES (DOWN OR UP) AND IT WILL NOT
C BE TO ETOT IN THE MAIN PROGRAM.
C
* ECEPP/3 code
c     IF ((IFEND.EQ.1.AND.KINDIJ.EQ.6).AND.(.NOT.SIMPLE_POT) ) 
c (08/18/97) changed from cis to trans (Kang)
C Kang found that the internal energy of trans is larger than cis
C DeltaE (trans/cis)= 1.4491 kcal/mol,
C Thus, the internal energy of trans relative to cis is added, instead.
C DR 11/31/97 
      IF ((IFEND.EQ.1.AND.KINDIJ.EQ.7).AND.(.NOT.SIMPLE_POT) ) 
     &        				 EPRO=EPRO+RING(7)
      IF (KPRO.NE.0) THEN
         IFCIS=1
         L=maxnum_dihe*(IJ-1)+3
         IF (IJ.EQ.1) L=NBOND(LISTIJ)
         IF(COS(ANGLES(L)).LE.0.0) IFCIS=0
 56      JJS=3*IFCIS+NGEOM(LISTIK)
         IF(KINDIK.EQ.13) THEN
C           WRITE(JOUT,'(4(a,i4))') 'JJS= ', JJS, 'LISTIK= ', LISTIK
C    &   ,' NGEOM(LISTIK)= ', NGEOM(LISTIK), 'KINDIK= ', KINDIK
            EPR=EPR+RING(JJS)
C FOR Hydroxypro
         ELSE IF(KINDIK.EQ.22) THEN
            EHPR=EHPR+RINGH(JJS)
C FOR DimethylPRO
         ELSE IF(KINDIK.EQ.75) THEN
            EHPR=EHPR+RINGD(JJS)
         ELSE
            WRITE(JOUT,'(a,i4)') 'ERROR in INIT_INT_TABLE: KINDIK ='
     &        ,KINDIK
         ENDIF
      ENDIF
C
C STEP J
C WE NOW STEP OVER ALL THE ATOMS IN THE IJTH RESIDUE
C
 22   DO 5 J=JSTRT,JFIN
C
C J AND JM REFER TO THE 1ST ATOM OF THE INTERACTING PAIR. J IS THIS
C ATOM AS NUMBERED WITHIN RESIDUE I. JM IS THE SAME ATOM, NUMBERED
C WITHIN THE WHOLE MOLECULE.
      JM=J+NPREIJ
      JJ=NBTYPE(JM)
      QJ=CHARGE(JM)
C
C WE NOW CALCULATE THE INTRA-RESIDUE 1-4 AND 1-5 INTERACTIONS
      CALL INT14
      CALL INT15
C     if(lprnt) write(jout,*)'back from int15'
C
C
C THE FOLLOWING SECTION IS FOR CALCULATING THE INTERACTIONS BETWEEN
C ATOM J AND THE ATOMS OF THE ADJACENT RESIDUE
C
C IF IJ IS THE LAST REAL RESIDUE WE WILL SKIP THIS SECTION
      IF(IJ.EQ.LASTRS) GO TO 5
C
C RESET IK AND NIT BEFORE CALLING ADJCNT
C
      IK=IJ+1
      NIT=0
C
C SUBROUTINE ADJCNT CALCULATES THE APPROPRIATE INTER-RESIDUE
C ADJACENT INTERACTIONS
C     if(lprnt) write(jout,*)'calling adjcnt'
C     if(lprnt) write(jout,*)'kstrt=',kstrt,' kfin=',kfin
      CALL ADJCNT
C     if(lprnt) write(jout,*)'exit adjcnt'
      IJ2=IJ+2
C   ********  VTF ********             DR 3/94
      LASTRES=LASTRS
      IF(IRUNTYP.EQ.7) THEN
         LATIX = IJ + IRANG
         IF ( LATIX.GT.LASTRS) LATIX = LASTRS
         LASTRES=LATIX
      ENDIF
C     IF(IJ2.GT.LASTRS) GO TO 5
      IF(IJ2.GT.LASTRES) GO TO 5
C  ***********************
C
C STEP IK
C THIS SECTION CALCULATES THE APPROPRIATE INTER-RESIDUE
C NON-ADJACENT INTERACTIONS
C
C ************* CHANGE OCTOBER 31 *************************
C *****LOOP RESIDUE BY RESIDUE IF IJ IS A HALF-RESIDUE INVOLVED IN A
C ***** BRIDGE OR, IF IJ+1 IS PRO AND, THEREFORE, NIT IS 1 *******
C     if(lprnt) write(jout,*)'entering loop 4 with kloop= ',kloop 
      IF (KLOOP.NE.0.OR.NIT.EQ.1) THEN
C   ********  VTF ********             DR 3/94
CD       DO 4 IK=IJ2,LASTRS
        DO 4 IK=IJ2,LASTRES
          IF(IK.NE.KLOOP) GO TO 3
          NPREIK=NPRE(IK)
          LISTIK=IABS(LIST(IK))
cd        print *,'npreik=',npreik
cd        print *,'calling ssbrij'
          CALL GENBRIDGE
          NPREIK=NPRE(IJ+1)
          GO TO 4
C
C NO BRIDGE
C
 3        KSTRT=NPRE(IK)+1
cd        print *,'kstrt=',kstrt
          IF (NIT.NE.1) GO TO 31
C
C THIS SECTION CALCULATES THE 1-4 INTERACTION BETWEEN ATOM J
C OF RESIDUE IJ AND THE NITROGEN OF RESIDUE IJ+2
C
          KFIN=KSTRT
c         if(lprnt) write(jout,*)'from Init_Int_Table: cal14'
c         if(lprnt) write(jout,*)'kstrt=',kstrt,' kfin=',kfin
          CALL CAL14
          KSTRT=KSTRT+1
          NIT=0
C
 31       KFIN=NPRE(IK+1)
          IF(KSTRT.GT.KFIN) GO TO 4
c         if(lprnt) write(jout,*)'31:from Init_Int_Table: cal15'
c         if(lprnt) write(jout,*)'kstrt=',kstrt,' kfin=',kfin
          CALL CAL15
 4      CONTINUE
      ELSE
C ***ELSE, MAKE ONE SINGLE CALL TO CAL15 FOR IJ2 THRU LASTRS*********
        KSTRT = NPRE(IJ2)+1
C   ********  VTF ********             DR 3/94
CD       KFIN = NPRE(LASTRS+1)
        KFIN = NPRE(LASTRES+1)
CD       IF (CYCLIC .AND. IJ.EQ.2) KFIN=NPRE(LASTRS)
        IF (CYCLIC .AND. IJ.EQ.2) KFIN=NPRE(LASTRES)
C   ********  VTF END ********
        IF(KSTRT.LE.KFIN) THEN
          if(lprnt) write(jout,*)'ELSE:from Init_Int_Table: cal15'
          if(lprnt) write(jout,*)'kstrt=',kstrt,' kfin=',kfin
          CALL CAL15
        END IF
      END IF
*
* -- 8/11/93 (DR & AL)
*
* For the cyclic backbone, if IJ is the first full residue we need to 
* determine the part of the interaction table corresponding to the 
* "adjacent" interactions between the first and the last residue.
*
      IF (CYCLIC .AND. IJ.EQ.2) THEN
        IK=INUMRS-1
        NPREIK=NPRE(IK)
        NIT=0
        IF (LPROLIN(IK)) THEN
c       IF(LPRNT) WRITE (JOUT,*) 'CYCLIC: calling adjcycp '
           CALL ADJCYCP
        ELSE
c       IF(LPRNT) WRITE (JOUT,*) 'CYCLIC: calling adjcyc '
           CALL ADJCYC
        ENDIF
        NPREIK=NPRE(IJ+1)
      ENDIF
 5    CONTINUE
C ********* END** Change October 31***** END *************
C
 6    CONTINUE
      IF( .NOT.SIMPLE_POT) EPRO=EPRO+EPR+EHPR
      RETURN
      END
