        subroutine inputcrd_ib(iopt,ipas)  
c
c  : defines charged groups
c         
c LAST modification date -
c                          Oct.15, 97
c 
c--------------------------------------------------------------------------
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'COMMON.GEN100'
	include'param.ibems'
	include'comm.ibems'
	include'ecepp_ibems_intrf.h'
        include 'COMMON.MYCONF'
        include 'COMMON.EXTPH'

        integer iopt,ipas
        real*8 totalq,sxx,qqmmtot
        character*3 resnam
        integer iat_inclchgr(maxat)  !flag 0/1 No/Yes atom included in charged
        integer iat_inclS(maxat)    !flag 0/1 No/Yes atom included in S+ unit
        integer nresq_mx
        parameter(nresq_mx=200) ! =nres_max)
        character*3 resname_sq(nresq_mx) !residue name in the sequence
        character*3 resnams,resnamb
        integer resnumb_sq(nresq_mx)     !residue(.pdb) number
        character*3 ionresname(nresq_mx)
c ionresname- sequential names of ionized residues in the sequence 
	integer start_res(nresq_mx),stop_res(nresq_mx)
        integer nextend_res(nresq_mx)

        integer nchargr,natom,nnnc
        integer incrp,incrs,incr
        integer nterm_resn
        integer i,j,k
        integer ilisti, iat,ias,iaf
        integer kstar,kfin,kstep, kk,kadd,ipres
        integer iiprint0,iiprint1,iiprint2
        integer OPT_qsidech,OPT_qbackb,OPT_water
	integer inclat
        integer krs,krb,kr0
c---------------------------
        logical chargeds,chargedb
        logical water_gr
        logical OPT_ECEPP_pdb
        logical atomfnd
c....................................................................
c print OPTIONS
        iiprint0=0
        iiprint1=1
	iiprint2=2
        OPT_ECEPP_pdb=.true.
c------------------------------------------------------------------------------
c OPTION : polar side group incrs=Q_SIDECH=1/0
         OPT_qsidech=1 !=1/0 if polar side groups are considered
c                            as regular POLAR
c        OPT_qsidech=0 !if polar groups are treated as NOCHARGES all q=0. 
c                    for large PEPTIDE for FAST calculations
c------------------------------------------------------------------------------
c  OPTION : backbone units
c  incrp - 1/0 -Q_BACKB charged/uncharged peptide group 
         OPT_qbackb=1 ! 1 - REgular value,if peptide group considered 
c                         as charged group 
c        OPT_qbackb=0 ! for large PEPETIDEs for FAST calculations
c------------------------------------------------------------------------------
cw  OPTION : water
cw         OPT_water=1  !
cw        OPT_water=0  ! all water ingnored
cw         water_gr = .false.
c------------------------------------------------------------------------------
c initialization
	totalq=0.0d0
c       nclast_t=0
        qqmmtot=0.
        n_iona=0  !tot numb of charged atoms
        nchargr=0 !tot number of charged groups NCHARGR 

C nnnc counts the number of Ionizable groups that are not ionized (iopt=0)
        nnnc=0

        do i=1,nchargr_mx 
           jchargr_an(i)=0
        end do
        do i=1,nres_mx
           natm_polrs(i)=0
        end do ! i 

        npolres_t=0
        nat_backnt=0

c        natom=natoml  !tot numb of atoms
        if(iopt.eq.0) then
            natom=natom_ei
            natoml_n=natom_ei
            do i=1,natom
               atnamel(i)=atnamel_ei(i)
               iatnumbl(i) =iatnumbl_ei(i)
               resnamel(i)= resnamel_ei(i)
               resnumbl(i)=resnumbl_ei(i)
               do j=1,3
                  atmxyz(j,i)=atxyzl_ei(j,i)
                  atxyzl_n(j,i)=atxyzl_ei(j,i)
               end do
            enddo
        else
           natom=natomp_ei
           natoml_i=natomp_ei
           do i=1,natom
              atnamel(i)=atnamelp_ei(i)
              iatnumbl(i) =iatnumblp_ei(i)
              resnamel(i)= resnamelp_ei(i)
              resnumbl(i)=resnumblp_ei(i)
              do j=1,3
                 atmxyz(j,i)=atxyzlp_ei(j,i)
                  atxyzl_i(j,i)=atxyzl_ei(j,i)
              end do
           enddo
        endif
   
        do i=1,natom
           iat_inclchgr(i)=0
           iat_inclS(i)=0
           atmcha(i)=0.0
           atmrad(i)=0.0
        enddo

c******************************************
        if(inumrs.gt.nresq_mx)then
           write(*,*)'inputcrd:ERROR: nresq_mx too SMALL',nresq_mx
           kprotfail=-209
c           write(*,*) 'kprotfail=', iprotfail
           return
        end if

        do i=1, inumrs
           resname_sq(i)= resname_IBEM(i,iopt+1)
           resnumb_sq(i)=i
           start_res(i) =npre_IBEM(i,iopt+1)+1
           stop_res(i) =npre_IBEM(i+1,iopt+1)
        enddo
c******************************************

 

c control
        if(outdetl.ge.iiprint2)then
	   write(*,*)'START(n), STOP(n) for residues'
           do i=1,inumrs
              write(*,*) 'resN, start(n),stop(n)=',i,
     &          resname_sq(i),start_res(i),stop_res(i)
           enddo
           write(*,*)'-----------------------------------------'
	end if !outdetl
        nterm_resn=1 

c type of TERMINAL groups assigned.............................................
c
c if molec.cor/molec+.cor in ECEPP_pdb format,i.e. terminal groups are numerated
c as an independent residue, than calculate extend_res(i) - extended to include
c next residue in sequence if terminal groups have 
c a small number of atoms, i.e. if are equal: H2N,H3N,CXH,OCC

        do i=1,inumrs
           nextend_res(i)= joinr(ireslist_IBEM(i,iopt+1) )
        enddo !i
        if(outdetl.ge.iiprint2) then 
           write(*,*) 'nextend_res():'
           do i=1,inumrs
               write(*,*) i,nextend_res(i)
           enddo !i
        end if !outdetl

c... ASSIGN ALL charged groups..............................................
c... LOOP.. over  all residues:
        kr0=1    ! start


c LOOP over Sequence  
c initialization
1010    incrs=0
        incr=0
        incrp=0 
        chargedb=.false.
        chargeds=.false.

C  krb     !backbone
C  krs     !sideR
        krb=kr0
c       nextend_res(kr0)= joinr(iabs(list(kr0)) )
        nextend_res(kr0)= joinr(ireslist_IBEM(kr0,iopt+1) )

c       if (kr0.eq.1) then
c          nextend_res(1)= joinr(iabs(list(1)) +num_restypes)
c        endif

        krs=kr0+nextend_res(kr0)
        ias=start_res(krb)  !first atom in sequence
        iaf=stop_res(krs)   !last atom in sequence
c ********
c check for atoms in N-terminus first, then in first full residue.
        kstar=krb
        kfin=krs
        kstep=1
c ********
        if (kr0.eq.inumrs-1) then ! correct for C-end
c          nextend_res(inumrs-1)=
c    &              joinr( iabs(list(inumrs)) + num_restypes)
           nextend_res(inumrs-1)=
     &              joinr( ireslist_IBEM(inumrs,iopt+1) )
           krb=kr0+nextend_res(kr0)
           krs=kr0
           ias=start_res(krs)
           iaf=stop_res(krb)
c ********
c check for atoms in C-terminus first, then in last full residue.
           kstar=krb
           kfin=krs
           kstep=-1 
c ********
        end if !correct
        resnamb=resname_sq(krb)    !backbone
        resnams=resname_sq(krs)    !sideR
control 
        if(outdetl.ge.iiprint2)then
           write(*,*)'inputcrd: krb,krs,resnamB,resnamS,
     &     ias,iaf=',krb,krs,resnamb,resnams,ias,iaf
C          write(*,*)
        end if !outdetl

c. has this sideR polar (or charged) group?..
c. for molec.cor file only:
        if(iopt.eq.0)then ! PSo
           incrp=OPT_qbackb
           if ( POLRIB( ireslist_IBEM(krs,1) ) ) then
              incrs=OPT_qsidech !if sideR is polar
           end if 
        end if ! PSo

c. molec+.cor: list of charged groups are extracted ONLY from IONIZED residues!
        if(iopt.eq.1)then !assign for molec+.cor file
c. is this sideR residue ionizable? calculate status for variable 
c  charged =.true./.false.
            if ( CHRR(ireslist_IBEM(krs,2) ) ) then
               chargeds=.true.
               incrs=1
            end if 

c if the N-, C- terminal groups are charged
c           if ( (krb.eq.nterm_resn) .and.  CHRR(list(1)+num_restypes)
c    &       .or. (krb.eq.inumrs) .and.  CHRR(list(inumrs)+num_restypes)
c    &                                                           ) then  
            if ( (krb.eq.nterm_resn).and.CHRR(ireslist_IBEM(1,2))
     &      .or.(krb.eq.inumrs).and.CHRR(ireslist_IBEM(inumrs,2))) then  
               chargedb=.true.
                incrp=1
            end if !charged terminal groups
        end if !iopt=1 

control 
        if(outdetl.ge.iiprint2)then
           write(*,*)'inputcrd: kresB,kresS,resnamB,S,incrp,',
     &     'incrs=',krb,krs,resnamb,resnams,incrp,incrs
C          write(*,*)
        end if !outdetl

c........................................................................
c assign PEPTIDE BACKBONE + SIDE CH
c
c  BACKBONE

c!CHARGED groups : molec.cor or molec+.cor 
	if(incrp.eq.1)then  !backbone group NH-CA-CO
	   nchargr=nchargr+1
	
	   if(nchargr.gt.nchargr_mx)then
         	write(*,*)'inputcrd: ERROR nchargr_mx too small',
     &	      nchargr_mx
   	   end if
c
c sequential number for isolated S+i unit:
           if(iopt.eq.1.and.chargedb)then  !extract S+ unit
              npolres_t=npolres_t+1
              qqq_res(npolres_t)=dfloat(qqq_read(ireslist_IBEM(krb,2)))
              pK0_res(npolres_t)=pK0_read(ireslist_IBEM(krb,2))

control
              if(npolres_t.gt.nres_mx)then
                 write(*,*)'INCREAS param:nres_mx too small'
                 kprotfail=-201
                 write(*,*) 'kprotfail=', iprotfail
                 return
              end if
c. define global number of ionizable residue in the protein sequence
              ionresgl(npolres_t)=krb
c. define name of ionizable residue in sequence
              ionresname(npolres_t)=resnamb
           end if ! chargedb !extract S+ unit


c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C NEW LOOP1
c           ipres = iabs(list(krb) )
c           if (krb.eq.1) ipres=iabs(list(1)) + num_restypes 
c           if (krb.eq.inumrs)ipres=iabs(list(inumrs))+
c    &                                             num_restypes
           ipres= ireslist_IBEM(krb,iopt+1)
           if(outdetl.ge.iiprint2)then
              write(*,*) 'Now BACK '
              write(*,*) 'Residue= ', krb, ' list= ', ipres
              write(*,*) 'from atom = ', ias, ' to ', iaf
              write(*,*) 'Number of atoms in database= ', numai(ipres)
           endif
     
           kadd= 0
           do iat=ias,iaf
              atomfnd=.false.
              do kk=1, numai(ipres)
                 if (atnamel(iat)(1:3).eq.ALPHIB(kk,ipres)(1:3)) then 
c Center of group
                    if ((LPARIB(2,kk,ipres).eq.1).and.(incrp.eq.1)) then
                      jchargr_xyz(nchargr)=iat
                    endif
                    if (iat_inclchgr(iat).eq.0) then
                       if(outdetl.ge.iiprint2)then
                          write(*,*) 'atnamel(iat) = ', atnamel(iat), 
     &                    'ALPHIB(',kk,',', ipres,')= ',ALPHIB(kk,ipres)
                          write(*,*) 'LPARIB(1,kk,ipres)= ',LPARIB(1,kk,
     &                    ipres),
     &                    'LPARIB(3,kk,ipres)= ', LPARIB(3,kk,ipres),
     &                    'CHIBE(kk,ipres)= ', CHIBE(kk,ipres),
     &                    'RADIBE(kk,ipres)= ', RADIBE(kk,ipres)
                       endif
                       atomfnd=.true.
                       goto 222
                    endif
                 endif
              enddo
222           continue
              if (atomfnd) then
                 if (iopt.eq.0) then
C Equivalent to:  if(atnam3.eq.backqnam3(ir) ) inclat=1
                       if(outdetl.ge.iiprint2)
     &                 write(*,*) 'BACK: ATOM(', iat,')= ', atnamel(iat)  
                       atmcha(iat)=CHIBE(kk,ipres)
                       atmrad(iat)=RADIBE(kk,ipres)
                       atqql_n(iat)=CHIBE(kk,ipres)
                       atradl_n(iat)=RADIBE(kk,ipres)
                       atradl(iat)=RADIBE(kk,ipres)
                       if(outdetl.ge.iiprint2)
     &                 write(*,*) 'atmcha(',iat,' ) = ', atmcha(iat)  
                    if (LPARIB(1,kk,ipres).eq.1 ) then
                       kadd= 1
                       if(atmcha(iat).ne.0.0d0)  then
                         jchargr_an(nchargr)=jchargr_an(nchargr)+1
                         jchargr_al(jchargr_an(nchargr),nchargr)=iat
                         iat_inclchgr(iat)=1
                         if(jchargr_an(nchargr).gt.natinchgr_mx) then
                            write(*,*)'inputcrd :ERROR: ',
     &                      'natinchgr_mx is too SMALL',natinchgr_mx
                            kprotfail=-202
                            write(*,*) 'kprotfail=', iprotfail
                            return
                         end if !control

                       endif
                    endif

C Equivalent to if(atnam3.eq.backTqnam(ir) ) inclat=1
                 else if (iopt.eq.1) then
                    if(outdetl.ge.iiprint2)
     &                 write(*,*)'BACK+: ATOM(',iat,')= ', atnamel(iat)  
                    atmcha(iat)=CHIBE(kk,ipres)
                    atmrad(iat)=RADIBE(kk,ipres)
                    atqql_i(iat)=CHIBE(kk,ipres)
                    atradl_i(iat)=RADIBE(kk,ipres)
                    atradl(iat)=RADIBE(kk,ipres)
                    if(outdetl.ge.iiprint2)then
                        write(*,*) 'atmcha(',iat,' ) = ', atmcha(iat)  
                        write(*,*) 'atmrad(', iat,' ) = ', atmrad(iat)  
                    endif
                    if (LPARIB(3,kk,ipres).eq.1 ) then
                       kadd= 1
                       if(atmcha(iat).ne.0.0d0)then
                          jchargr_an(nchargr)=jchargr_an(nchargr)+1
                          jchargr_al(jchargr_an(nchargr),nchargr)=iat
                          iat_inclchgr(iat)=1
                          if(jchargr_an(nchargr).gt.natinchgr_mx)then
                             write(*,*)
     &                      'inputcrd ERR: natinchgr_mx is too SMALL',
     &                       natinchgr_mx
                             STOP
                         end if !control

                       endif
                    endif

C Equivalent to:     if(atnam3.eq.ntbackanam(i))then !include
C  and               if(atnam3.eq.ctbackanam(i))then !include
                    if (chargedb.and.( (krb.eq.1).or.(krb.eq.
     &                  inumrs) ).and.(LPARIB(1,kk,ipres).eq.1) )then
                       natm_polrs(npolres_t)=natm_polrs(npolres_t)+1
                       latm_polrs(natm_polrs(npolres_t),npolres_t)= iat
                       iat_inclS(iat)=1
C Control
                       if(natm_polrs(npolres_t).gt.natinrs_mx)then
                          write(*,*)'inputcrd :ERROR:',
     &                     'natines_mx is too SMALL',natinrs_mx
                          kprotfail=-203
                          write(*,*) 'kprotfail=', iprotfail
                          return
                       end if !control
                    endif
                 endif
              endif
           enddo
           if (kadd .eq.1) then
              chargr_nam(nchargr)=resnamb//'BACK'
              jchargr_rsn(nchargr)=resnumb_sq(krs) !point to res number (as in .PDB)
           endif

check is new group NOT empty
           if(jchargr_an(nchargr).eq.0)then
              if(outdetl.ge.iiprint2) 
     &             write(*,*)'empty gr nchargr=',nchargr
              nchargr=nchargr-1

           else 
              if ( (iopt.eq.0) .and. ((krb.eq.1).or.(krb.eq.inumrs))
     &            .and. (ionizable(ipres)) ) then
                 nnnc=nnnc+1
                 jchargr_kn(nchargr)=nnnc 
                 if(outdetl.ge.iiprint2) 
     &            write(*,*)' krb=', krb, ' group nchargr=',nchargr,
     &             'ionizable( ',ipres,' )= ',ionizable(ipres)
              end if
           end if
c
c. assign pointer to chargedGr number in the S+ unit:
           if(iopt.eq.1.and.chargedb)then !extract N-,C-terminal S+ unit
              lchargr_polrs(npolres_t)= nchargr
           end if !!extract N-,C-terminal S+ unit

 
control 
           if(outdetl.ge.iiprint2)then
              write(*,*)'nchargr=',nchargr,'jchargr_an(nchargr)',
     &         jchargr_an(nchargr)
           end if !out
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

        end if !incrp = 1 BACKBONE
c -------------------------------------------------------------------------
c
c SIDE chain in this peptide residue
c
	if(incrs.eq.1)then  !for both iopt=0,1
	   nchargr=nchargr+1
control
           if(nchargr.gt.nchargr_mx)then
              write(*,*)'inputcrd:ERROR: nchargr_mx is too SMALL',
     &        nchargr_mx
              kprotfail=-204
              write(*,*) 'kprotfail=', iprotfail
              return
           end if !

c sequential number for isolated S+i unit:
           if(iopt.eq.1.and.chargeds)then  !extract N-,C-terminal S+ unit
              npolres_t=npolres_t+1
              qqq_res(npolres_t)=qqq_read(ireslist_IBEM(krs,2))
              pK0_res(npolres_t)=pK0_read(ireslist_IBEM(krs,2))

control
              if(npolres_t.gt.nres_mx)then
                 write(*,*)'INCREAS param:nres_mx too small'
                 kprotfail=-205
                 write(*,*) 'kprotfail=', iprotfail
                 return
              end if
c. define global number of ionizable residue in the protein sequence
              ionresgl(npolres_t)=krs
c. define name of ionizable residue in sequence
              ionresname(npolres_t)=resnams
           end if ! chargeds !extract N-,C-terminal S+ unit
        end if 

c NEW LOOP2$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
        ipres= ireslist_IBEM(krs,iopt+1)
        if(outdetl.ge.iiprint2)then
           write(*,*) 'Now SIDE '
           write(*,*) 'Residue= ', krs, ' list= ', ipres
           write(*,*) 'from atom = ', ias, ' to ', iaf
           write(*,*) 'Number of atoms in database= ', numai(ipres)
        endif

        if ( (krs.eq.1).or.(krs.eq.inumrs) )then
c          write(*,*)'inputcrd :WARNING ',
c    &      'Sidechain polar group associated with end group'
        endif

        kadd= 0
        do iat=ias,iaf
           atomfnd=.false.
           do kk=1, numai(ipres)
              if (atnamel(iat)(1:3).eq.ALPHIB(kk,ipres)(1:3)) then 
c Center of group
                 if ((LPARIB(2,kk,ipres).eq.2).and.(incrs.eq.1)) then
                   jchargr_xyz(nchargr)=iat
                 endif
C Equivalent to if(atnam3.eq.backqnam3(ir) ) inclat=0
                 if(outdetl.ge.iiprint2)then
                    write(*,*) 'atnamel(iat) = ', atnamel(iat),
     &              ' ALPHIB(',kk,',', ipres,')= ', ALPHIB(kk,ipres)  
                    write(*,*) 'LPARIB(1,kk,ipres)= ', 
     &               LPARIB(1,kk,ipres),
     &              ' LPARIB(3,kk,ipres)= ', LPARIB(3,kk,ipres),
     &              ' CHIBE(kk,ipres)= ', CHIBE(kk,ipres),
     &              ' RADIBE(kk,ipres)= ', RADIBE(kk,ipres)
                 endif
                 atomfnd=.true.
                goto 333
              endif
           enddo
333        continue
           if (atomfnd) then
              if (iat_inclchgr(iat).eq.0 ) then
                 atmcha(iat)=CHIBE(kk,ipres)
                 atmrad(iat)=RADIBE(kk,ipres)
                 if(iopt.eq.0)  then 
                    if(outdetl.ge.iiprint2)
     &                 write(*,*) 'SIDE: ATOM(',iat,')= ', atnamel(iat)  
                    atqql_n(iat)=CHIBE(kk,ipres)
                    atradl_n(iat)=RADIBE(kk,ipres)
                    atradl(iat)=RADIBE(kk,ipres)
                 endif
                 if(iopt.eq.1) then
                    if(outdetl.ge.iiprint2)
     &                 write(*,*) 'SIDE: ATOM(',iat,')= ', atnamel(iat)  
                    atqql_i(iat)=CHIBE(kk,ipres)
                    atradl_i(iat)=RADIBE(kk,ipres)
                    atradl(iat)=RADIBE(kk,ipres)
                 endif
                 if(outdetl.ge.iiprint2)then
                    write(*,*) 'atmcha(',iat,' ) = ', atmcha(iat)  
                    write(*,*) 'atmrad(', iat,' ) = ', atmrad(iat)  
                 endif
                 if ( ( LPARIB(1,kk,ipres).eq.2 ) .and.
     &            (atmcha(iat).ne.0.0d0) .and.(incrs.eq.1)) then
                    kadd= 1
                    jchargr_an(nchargr)=jchargr_an(nchargr)+1
                    jchargr_al(jchargr_an(nchargr),nchargr)=iat
                    iat_inclchgr(iat)=1
                    if(jchargr_an(nchargr).gt.natinchgr_mx)then
                       write(*,*)'inputcrd :ERROR:',
     &                 ' natinchgr_mx is too SMALL',natinchgr_mx
                       kprotfail=-206
                       write(*,*) 'kprotfail=', iprotfail
                       return
                    end if !control
                 endif
              endif

C atoms of the submolecule for the charged S+i unit = H-N-CA-(sideR+)-C=O:
              if (iopt.eq.1 .and. chargeds) then
                 if (LPARIB(4,kk,ipres).eq.1 .and.
     &                          iat_inclS(iat).eq.0 ) then
                    natm_polrs(npolres_t)= natm_polrs(npolres_t)+1
                    latm_polrs(natm_polrs(npolres_t), npolres_t)= iat 
                    iat_inclS(iat)=1
c Control
                    if(natm_polrs(npolres_t).gt.natinrs_mx) then
                       write(*,*)'inputcrd :ERROR:',
     &                 'natinrs_mx is too SMALL',natinrs_mx
                       kprotfail=-207
                       write(*,*) 'kprotfail=', kprotfail
                       return
                    end if !control
                 endif
              endif
           endif
        enddo

	if(incrs.eq.1)then  !for both iopt=0,1
           if (kadd .eq.1) then
              chargr_nam(nchargr)=resnams//'SIDE'
              jchargr_rsn(nchargr)=resnumb_sq(krs) !point to res number (as in .PDB)
           endif

c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

check is new group NOT empty
           if(jchargr_an(nchargr).eq.0)then
              if(outdetl.ge.iiprint2) 
     &             write(*,*)'empty gr nchargr=',nchargr
              nchargr=nchargr-1
           else if ( (iopt.eq.0) .and. (ionizable(ipres)) ) then
              nnnc=nnnc+1
              jchargr_kn(nchargr)=nnnc 
           end if

c. assign pointer to chargedGr number in the S+ unit:
           if(iopt.eq.1.and.chargeds)then !extract N-,C-terminal S+ unit
              lchargr_polrs(npolres_t)= nchargr
           end if !!extract N-,C-terminal S+ unit

        end if !incrs eq 1	
c. END sideR
c.---------------------------------------------------------------------------

c return to next residue
        kr0=kr0+nextend_res(kr0) + 1

        if(kr0.le.inumrs)goto 1010
c END of protein sequence
c -------------------------------------------------------------------------
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	nchargr_t=nchargr
        nres_inzbl=nnnc
        if( (iopt.eq.0).and.(outdetl.ge.iiprint2)) then
           do i=1, nchargr_t
              write(*,*)'inputcrd:igr,jchargr_kn(',i,')=',jchargr_kn(i)
           enddo
           write(*,*)'Number of Ionizable groups=',nnnc
        end if
        if(nnnc.gt.nres_mx)then
           write(*,*)'inputcrd:ERROR nres_mx is low=',nres_mx
           kprotfail=-208
            write(*,*) 'kprotfail=', iprotfail
           return
        end if
c............. . . . . ......................................................

c define list of charged atoms
	n_iona=0
	totalq=0.d0
	do k=1,natom
           if(atmcha(k).ne.0.0)then

collect list of BACKB+sideR partially charged atoms from POLAR and NEUTRAL sideR 
c which are not included into S+i groups:
              if(iopt.eq.1.and.iat_inclchgr(k).eq.0)then !include (PS+ - allS+)
c                 iat_inclchgr(k)  !flag 0/1 No/Yes atom included in charged
                 nat_backnt=nat_backnt+1
                 latm_backnt(nat_backnt)= k
              end if !ipot.eq.1 !include (PS+ - allS+)

              n_iona=n_iona + 1  
              iona_list(n_iona)=k
              if(outdetl.ge.iiprint2)
     &        write(*,*) 'iona_list(',n_iona ,')=',iona_list(n_iona)
           end if
           totalq = totalq + atmcha(k)
	end do !k

c.
c -----------------------------------------------------------------------------
      
c          if(outdetl.ge.iiprint0)then 
c             if(iopt.eq.0)write(*,1030)
c             if(iopt.eq.1)write(*,1032)
c             write(*,7001)structname
c             write(*,1031)
c             do k =1,natom
c                write(*,1040) k,atnamel(k),resnamel(k),
c    &            Resnumbl(k),(atmxyz(j,k),j=1,3),atmrad(k),atmcha(k)
c             enddo 
c          end if !outdetl
c------------------------------------------------------------------------------

c..center of molecule 
	nnmlat=natom
	do i3=1,3
           rrrcen(i3)=0.0d0
           do iatom=1,nnmlat
              rrrcen(i3)=rrrcen(i3)+atmxyz(i3,iatom)
           end do
           rrrcen(i3)=rrrcen(i3)/nnmlat
        end do
        if(outdetl.ge.iiprint2)then
           write(*,*)
           write(*,*)'MOl centr =', rrrcen
           write(*,*)
        end if!

c.. move XYZ origin to center of molecule
        do iatom=1,nnmlat
           do i3=1,3
              atmxyz(i3,iatom)=atmxyz(i3,iatom)-rrrcen(i3)
           end do
        end do
c.
c ---------------------------------------------------------------------------
c PDB file in the molecular origin coordinates 
        if(outdetl.ge.iiprint1)then
           write (*,'(a)') 'REMARK molecular coords'
           do i=1,nnmlat
              write (*,
     &         '(A4,I7,1X,A4,1X,A3,I6,4X,3F8.3,2F8.4)')
     &         'ATOM',i,atnamel(i),resnamel(i),resnumbl(i),
     &         (atmxyz(j,i),j=1,3),atmrad(i),atmcha(i)
           enddo
        end if !outdetl
           
        if(outdetl.ge.iiprint1)then
           write(*,*)
           write(*,*)'number of partially charged atoms',
     &                          n_iona
           write(*,*)'total Q of atoms', totalq

c Charged groups
           write(*,*)
           write(*,*)'totalN of charged groups=',nchargr_t
        end if !outdetl

        if(outdetl.ge.iiprint1)then
           write(*,*)
           do i=1,nchargr_t
              write(*,*)'charged gr N=',i,' resN=',
     &         jchargr_rsn(i),' ChGrname=',chargr_nam(i)

              sxx=0.0d0
              do k=1,jchargr_an(i)
                 sxx=sxx+atmcha(jchargr_al(k,i))
              end do!k

              write(*,'(a25,f8.5)')'total group charge=',sxx
              write(*,*)'at_in_gr=',jchargr_an(i),' atList='
              write(*,*)'jchargr_al',(jchargr_al(k,i),k=1,
     &          jchargr_an(i))
              write(*,'(10f8.5)')(atmcha(jchargr_al(k,i)),
     &          k=1,jchargr_an(i))       
              write(*,*)'center xyz is at n',jchargr_xyz(i)
              write(*,*)
           end do !i
        end if !outdetl

c. atoms of the S+i submolecules
        if(iopt.eq.1)then ! molec+.cor
           if(outdetl.ge.iiprint0)then !
              write(*,*)'backbone+netral res list of atoms=',
     &                  nat_backnt
              write(*,'(10i5)')(latm_backnt(i),i=1,nat_backnt)
              write(*,*)'IONIZED res:npolres_t=', npolres_t
              do i=1,npolres_t
                 write(*,'(a5,i5,a7,i5)')'nS+i:',i,'natoms:',
     &                  natm_polrs(i)
                 write(*,'(10i5)')
     &               (latm_polrs(k,i),k=1,natm_polrs(i))
                 write(*,'(a30,i5)')
     &               'poin to nChGr(lchargr_polrs)=',lchargr_polrs(i)
              end do
c------------------------------------------------------------------------
              write(*,*)'qqq_res(i)='
              write(*,'(10f7.3)') (qqq_res(i),i=1,npolres_t)
              write(*,*)'pK0_res(i)='
              write(*,'(10f7.3)') (pK0_res(i),i=1,npolres_t)
           end if
c       write(*,*)'&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&'

        end if ! opt.eq.1

        
c. read *.pdp  
c7071   format(7x,i4,2x,a3,1x,a3,2x,i4,4x,3f8.3,2x,f4.3,f8.3)

1030    format(/5x,'*** MULTIGRID BOUNDARY ELEMENT METHOD***',/5x,
     &   'SOLVATION ENERGY and SOLVATION FORCES',//,
     &     5x,'Yury Vorobjev, 1996', /)
1032    format(/5x,'*** BOUNDARY ELEMENT METHOD***',/5x,
     &   '..ENERGY of EQUILIBRIUM PROTON BINDING  for zero SALT',//,
     &   5x,'Yury Vorobjev, 1995', /)
c..
1031    format(/5x,'ATOM  Coordinates: (Angstroms)', //6x,
     &   'ATOM',7x,'x',10x,'y',14x,'z',8x,'radius',7x,'q0',3x,'n_cla'/)
1040    format(1x,i5,1x,a3,1x,a3,1x,i5,1x,f8.3,2x,f8.3,2x,f8.3,
     &       2x,f5.3,2x,D14.6)
7001	format(/,2x,'TITLE:',2x,a60,/)
        return
        end
