c Solution of linear system Ax=b by biconjugate gradient method
c.Numerical Recepies p.79
       subroutine linbcg(n,b,x,itol,iter,itmax,err,ffl)
      
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
       include 'param.ibems'
       include 'comm.ibems'
       integer iter,itmax,itol,n,nmax
       real*8 err,tol,b(*),x(*),eps,ffl
       real*8 snrm_lbcg
c ffl parameter in lin eq. Ax=b*ffl
       parameter(nmax=nvect_uvmx)
c       parameter(eps=1.d-14)

c the matrix A is referenced only through the user-supplied subroutine
c ATIMES( ), which computes the product of euther A or A(transp) on a vector
c ASOLVE() solves auxilary eq. Dx=b, or D(tr)x=b, where D=diagonal A,
c or some other matrix which is close to initial A. A*D->Identity matrix
c
       integer j, iiprint1
       real*8 ak,akden,bk,bkden,bknum,bnrm,dxnrm,
     *        xnrm,zminrm,znrm,p(nmax),pp(nmax),r(nmax),rr(nmax),
     *        z(nmax),zz(nmax)
c 
       do j=1,n
        b(j)=ffl*b(j)
        end do

        iiprint1=2
        eps=delta_sigma

c calculate initial residual and check stopping criterion
        iter=0
        call atimes(n,x,r,0,ffl)

        do j=1,n
        r(j)=b(j)-r(j)
        rr(j)=r(j)
        end do

c       call atimes(n,r,rr,0,ffl) ! uncomment line to get the minimum 
c                               residual variant of the alghorithm

       znrm=1.0d0
       if(itol.eq.1)then
         bnrm= snrm_lbcg(n,b,itol)
       else if(itol.eq.2)then
         call asolve(n,b,z,0,ffl)
         bnrm= snrm_lbcg(n,b,itol)
        else if(itol.eq.3.or.itol.eq.4)then
         call asolve(n,b,z,0,ffl)
         bnrm= snrm_lbcg(n,z,itol)

         call asolve(n,r,z,0,ffl)
         bnrm= snrm_lbcg(n,z,itol)
        else
          pause 'illegal itol>4 in linbcg'
        end if

        call asolve(n,r,z,0,ffl)

100     if(iter.le.itmax)then   ! Main loop
         iter=iter+1
         if(iter.gt.itmax)then
          goto 1000
         end if
         zminrm=znrm
         call asolve(n,rr,zz,1,ffl) ! product with D(trasnp)
         bknum=0.d0
c calculate coeff bk and direction vectors p and pp
         do j=1,n
         bknum=bknum+z(j)*rr(j)
         end do !j

         if(iter.eq.1)then
         do j=1,n
         p(j)=z(j)
         pp(j)=zz(j)
         end do !j

           else

         bk=bknum/bkden
         do j=1,n
         p(j)=bk*p(j)+z(j)
         pp(j)=bk*pp(j)+zz(j)
         end do !j
         end if
c calculate coeff ak, new iterate x, and new residuals r and rr
         bkden=bknum
         call atimes(n,p,z,0,ffl)
         akden=0.d0
         do j=1,n
          akden=akden+z(j)*pp(j)
          end do !j
           
           ak=bknum/akden
          call atimes(n,pp,zz,1,ffl)

         do j=1,n
         x(j)=x(j)+ak*p(j)
         r(j)=r(j)-ak*z(j)
         rr(j)=rr(j)-ak*zz(j)
         end do !j
c solve Dz=r and check stopping criterion
         call asolve(n,r,z,0,ffl)
        
         if(itol.eq.1.or.itol.eq.2)then
         znrm=1.0d0
         err=snrm_lbcg(n,r,itol)/bnrm

         else if(itol.eq.3.or.itol.eq.4)then
          znrm=snrm_lbcg(n,z,itol)
            if(dabs(zminrm-znrm).gt.eps*znrm)then
         dxnrm=dabs(ak)*snrm_lbcg(n,p,itol)
         err=znrm/dabs(zminrm-znrm)*dxnrm
         
         else
            err=znrm/bnrm
            goto 100
         end if
         xnrm=snrm_lbcg(n,x,itol)
         if(err.le.0.5d0*xnrm)then
         err=err/xnrm
         else
         err=znrm/bnrm
         goto 100
         end if
         end if

         if(outdetl.ge.iiprint1)then
         write(kanalp,*)'LINBCG: it',iter,'M(Ax-b)/b=',err
     &                                     ,'M(b)=',bnrm
         end if
         
          if(err.gt.eps)goto 100

          end if

1000         return
         end

          FUNCTION snrm_lbcg(n,sx,itol)
          integer n,itol,i,isamax
          real*8 sx(n),snrm_lbcg,s
c vector sx norma = sum of moduls
          if(itol.le.3)then
           s=0.d0
          do i=1,n
c           s=s+dabs(sx(i))*area_uv(i) 
           s=s+dabs(sx(i)) 
          end do
          else
          isamax=1     ! largest component norm
             do i=1,n
         if(dabs(sx(i)).gt.dabs(sx(isamax))) isamax=i
            end do
           s=dabs(sx(isamax))
c sstot_sm - total surface area
         end if
         snrm_lbcg=s
         return
         end

c next subroutine is specificly designed for the case x=ff*KK*x+ff*b
c                                                     A=I-ff*KK
         subroutine atimes(n,x,r,itransp,ffl)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
         include'param.ibems'
         include'comm.ibems'
         real*8 x(nvect_uvmx),r(nvect_uvmx),ffl,ss
         integer n,itransp
         integer i,j

         ss=0.d0
         do i=1,n
         ss=0.d0
          if(itransp.eq.0)then
         do j=1,n
         ss=ss+ KKK_uv(j,i)*x(j)
         end do!j
c instead r(i)=ss
         r(i)=x(i)-ffl*ss
         end if

          if(itransp.eq.1)then
         do j=1,n
c         ss=ss+ KKK_uv(i,j)*x(j)
         ss=ss+ KKKt_uv(j,i)*x(j)
         end do!j
         r(i)=x(i)-ffl*ss
         end if

         end do !i

         return
         end

         subroutine asolve(n,b,x,itransp,ffl)
c x=x*KK*ffl+b
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
         include'param.ibems'
         include'comm.ibems'
         real*8 x(nvect_uvmx),b(nvect_uvmx),ffl,ss
         integer n,itransp
         integer i,j

         do i=1,n
         x(i)=b(i)/(1.0d0-ffl*KKK_uv(i,i))
         end do!i

          return
          end
