C $Date: 1996/03/06 18:06:30 $
C $Revision: 3.4 $
C
C
C
      PROGRAM MAIN_DRIVER
      CHARACTER*24 TODAY
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.TIME1'
C =====================================================================
#ifdef MP

C     This block of code includes the COMMONS needed for an MPL run.
C     INCLUDE '/usr/include/fexcp.h'
      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'
#endif
#ifdef SGI
      CHARACTER*8 HOUR
      CHARACTER*9 DAY
#endif
#ifdef MPI
      INCLUDE 'mpif.h'
      INTEGER IERR, STATUS(MPI_STATUS_SIZE)
#endif
#ifdef MP
C Initialization of the MPL interface.
C     WRITE (*,*)"STARTING PROGRAM"
C     CALL SIGNAL(SIGTRAP,xl__trce)
C     WRITE (*,*)"AFTER SIGNAL"
      CALL MP_INIT
C     WRITE (*,*)"AFTER MP_INIT"
#endif
C Obtain initial time
      STIME=0.0
      STIME=TCPU()


      CALL OPENUNITS
C ========================================================================

C
      WRITE (JOUT,1212)
1212  FORMAT (//
     *10X,'#########################################################'/
     *10X,'#                                                       #'/
     *10X,'# T  H  E    E  C  E  P  P  A  K    P  R  O  G  R  A  M #'/
     *10X,'#                                                       #'/
     *10X,"#      Series of programs from H.A. Scheraga's          #"/ 
     *10X,'#          Laboratory at Cornell University             #'/
     *10X,'#                                                       #'/
     *10X,'# written by                                            #'/
     *10X,'#             D.R. Ripoll   and    A. Liwo              #'/
     *10X,'#                                                       #'/
     *10X,'#########################################################'/)

#ifdef MP
      WRITE (jout, *) 
     &    "Parallel Version running with ",NUMTASKS, " processors."
#endif
C
#ifdef PKSR
**************************************************************************
C  Call related to parallel threads on ksr
C  Read info for parallel run and generate barriers and mutexes.
      CALL KSRINP
C Proc 0 looks now for a set of "slave" threads for the energy evaluation.
      IZEQ=0
      CALL KSRINIT(IZEQ)
**************************************************************************
#endif
C
C Setting default values of variables
      CALL SET_DEFAULTS
C
#ifdef AIX
C Following statement for the RiscSystem6000-based machines.
      CALL fdate_(TODAY)
      WRITE (JOUT,'(/15X,2A/)') 'Job started on ',TODAY
#endif
#ifdef WINNT
C Following statement for the NT machines.
c change for NT by removing "_", 7-27-99
      CALL fdate(TODAY)
      WRITE (JOUT,'(/15X,2A/)') 'Job started on ',TODAY
#endif
#ifdef SGI
C Following statement for the SGI.
      CALL DATE(DAY)
      CALL TIME(HOUR)
      WRITE (JOUT,'(2(/25X,2A/))') 'Job started on ', DAY, 
     &                               '      at ', HOUR
#endif
#ifdef SUN
C Following statement for the Sun.
C Instructions for machines that make call to the DATE system procedure.
      CALL FDATE(TODAY)
      WRITE (JOUT,'(/15X,2A/)') 'Job started on ',TODAY
#endif
#ifdef STARD
C Following statement for the Stardent.
      CALL FDATE(TODAY)
      WRITE (JOUT,'(/15X,2A/)') 'Job started on ',TODAY
#endif
C Read in the data
      CALL READKEY(JIN,JOUT)
C
C Set timers
      CALL SET_TIMERS
C
C Print data          
      CALL PRINT_DATA
C
C Obtain force field parameters, residue data base, and all other information
C necessary to proceed with the calculation.
      CALL SETUP
C
C Do the desired calculation
      GO TO (101,102,101,104,105,106,107,108) IRUNTYP
C
C single energy evaluation or a single energy minimization.
  101 CALL CONF_CALC
      GOTO 195
C
C comparison of analytical with numerical gradients.
  102 CALL CHECK_GRAD
      GOTO 195
C
C  EDMC run.
  104 write(jout,1312)
      CALL DO_EDMC
1312  FORMAT (/
     *10X,'##########################################################'/ 
     *10X,'#                                                        #'/
     *10X,'#                    Running:                            #'/
     *10X,'#                                                        #'/
     *10X,'# THE ELECTROSTATICALLY DRIVEN MONTE CARLO METHOD (EDMC) #'/
     *10X,'#                                                        #'/ 
     *10X,'##########################################################'/)
      GOTO 195
C
C rms fit.
  105 CALL RMS_CALC
      GOTO 195
C
C First step eceppization.
  106 CALL BOUNDS_CALC
      GOTO 195
C
C  VTF run.
  107 write(jout,1316)
      CALL SET_VTF
1316  FORMAT (/
     *10X,'**********************************************************'/ 
     *10X,'*                                                        *'/
     *10X,'*                                                        *'/
     *10X,'*     THE VARIABLE TARGET FUNCTION (VTF) PROCEDURE       *'/
     *10X,'*                                                        *'/ 
     *10X,'* implementation by:  D.R. Ripoll                        *'/
     *10X,'*                                                        *'/ 
     *10X,'* with major contributions from:                         *'/ 
     *10X,'*                     Feng Ni and Max  Vasquez           *'/
     *10X,'*                                                        *'/ 
     *10X,'**********************************************************'/) 
      GOTO 195
C
C eceppize.
  108 CALL ECEPPIZE 
C
  195 CURTIM=TCPU()
C
#ifdef WINNT
C Following statement for the NT machines.
      CALL fdate(TODAY)
      WRITE (JOUT,'(//80(1H*)/15X,2A/80(1H*))') 'Job ended on ',TODAY
#endif
#ifdef AIX
C Following statement for the RiscSystem6000-based machines.
      CALL fdate_(TODAY)
      WRITE (JOUT,'(//80(1H*)/15X,2A/80(1H*))') 'Job ended on ',TODAY
#endif
#ifdef SGI
C Following statement for the SGI.
      CALL DATE(DAY)
      CALL TIME(HOUR)
      WRITE (JOUT,'(2(/25X,2A/))') 'Job ended on ', DAY, 
     &                               '      at ', HOUR
#endif
#ifdef SUN
C Following statement for the Sun.
      CALL FDATE(TODAY)
      WRITE (JOUT,'(//80(1H*)/15X,2A/80(1H*))') 'Job ended on ',TODAY
#endif
#ifdef STARD
C Following statement for the Stardent
      CALL FDATE(TODAY)
      WRITE (JOUT,'(//80(1H*)/15X,2A/80(1H*))') 'Job ended on ',TODAY
#endif
      CALL DAJCZAS(CURTIM,HRTIME,MINTIME,SECTIME)

C #ifdef MPL
C       DO I=1, 12
C         CLOSE(UNIT=IFILE(I))
C       ENDDO
C #endif
C     CALL EXIT
C =======================================================================

#ifdef MPL
      CALL MP_SYNC(ALLGRP)
#endif
#ifdef MPI
c       write (*,*) 'Processor ', TASKID ,' HIT THE BARRIER'
        CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)
	CALL MPI_FINALIZE(IERR)
c       write (*,*) 'Processor ', TASKID ,' HAS FINISHED '
#endif
C =======================================================================
      SSTIME=TCPU()
      WRITE (*,*)"TIME for Run=", SSTIME
      stop 77777
      END
