      SUBROUTINE OPTIMIZE(NVAR,X,FUNC,GRAD,IV,V,IUPARM,URPARM,FDUM,FAIL)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.MINPAR'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.INDXS'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.CALC'
      include 'COMMON.VTFEX'
      EXTERNAL FUNC,GRAD,FDUM
      LOGICAL FAIL
      INTEGER IV(1:LIV)
      REAL V(1:LV)
      DIMENSION X(maxnum_var)
      REAL URPARM(1)
      INTEGER ITWO,IUPARM(1)
      DATA ITWO /2/

      FAIL=.FALSE.
      ETOT=0.0
      IF (OVER_CUTOFF.GT.0.0 .OR. ICOMP(1).EQ.2) THEN
        SIMPLE_POT=.TRUE.
	IFLOV_OLD=IFLOV
	IFLOV=1
C       WRITE (JOUT,*) 'Entering  minimization with simple potential'
        CALL MINIMIZE(NVAR,X,FUNC,GRAD,IV,V,IUPARM,URPARM,FDUM,FAIL)
C
C       do ijj=1,numvar
C          ndx=indxv(ijj)
C          angles(ndx)=x(ijj)
C       enddo

C       CALL ENE_EVAL
C       WRITE (JOUT,*) 'From simple potential: etot=',ETOT,
C    &                 ' over_flag=',OVER_FLAG

        IF (ICOMP(1).NE.2)  THEN
           SIMPLE_POT=.FALSE.
           IFLOV=IFLOV_OLD
        ELSE
           RETURN
        ENDIF
        FAIL=OVER_FLAG
	IF (NONOVERLAP_ENE) THEN
           IF (FAIL) RETURN
           DO I=1,NUMVAR
              IF ( (ABS(X(I)).GT.1.0E+10) ) THEN
                   WRITE (*,*)'ERROR OPTIMIZE: X(',I,') ',DEG*X(I)
              END IF

              ANGLES( INDXV(I) ) = PINORM( X(I) )
           ENDDO
  133      CALL ENE_EVAL
        WRITE (JOUT,*) 'After releaving overlaps',
     &                 ' ETOT is',ETOT
           RETURN
        ENDIF
	   
      ENDIF
      CALL MINIMIZE(NVAR,X,FUNC,GRAD,IV,V,IUPARM,URPARM,FDUM,FAIL)

      RETURN
      END
      SUBROUTINE ENER_MINIM(FAIL)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TOR'
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.NNDRUK'
      EXTERNAL CALCFPO, CALCGPO, GRADCAX
      CHARACTER*40 TITLE
      CHARACTER*80 LINE
      INTEGER IUPARM(1)
      DIMENSION V(LV)
      LOGICAL FAIL
C LENGTH OF V ARRAY.  MUST BE AT LEAST 71+N*(N+15)/2.
C AT LEAST 77+N*(N+17)/2 FOR SMSNO,
C AT LEAST 78+N*(N+12) FOR SUMSL.
      REAL URPARM
      DIMENSION IV(LIV), URPARM(1)
#ifdef PKSR
C
      INCLUDE 'COMMON.PARRAY'
#endif
C
      DATA IZERO /0/, IONE /1/, ITREIN /30/
      NF=0
      IV(1) = 0
C IUPARM is not used, yet                   DR.  APR94
      IUPARM(1)=0

      IF (CHISCAN) THEN
C
#ifdef PKSR
      CALL PTHREAD_MUTEX_LOCK(IMUTEX,ISTAT)
      IF (ISTAT.NE.0) WRITE(JOUT,*) ISEQUENCE,
     +  'ENER_MINIM:1 Return from mutex_lock = ',ISTAT
#endif
C
        WRITE (JOUT,'(/80(1H*)/5X,2A/80(1H*))')
     & 'Begin CHISCAN (scanning over selected dihedral angles for ',
     & 'lower energy)'
C
#ifdef PKSR
      CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
#endif
C
C DR 7/14/98
        call ene_eval
        ECHOLD=ETOT
C        NSCAN=3
        print *,'nscan=',nscan
        DO ISCAN=1,NSCAN
C
#ifdef PKSR
          CALL PTHREAD_MUTEX_LOCK(IMUTEX,ISTAT)
          IF (ISTAT.NE.0) WRITE(JOUT,*) ISEQUENCE,
     +      'ENER_MINIM:2 Return from mutex_lock = ',ISTAT
#endif
C
          WRITE (JOUT,'(/A,I2,A/)') '****** Cycle',ISCAN,' *****'
C
#ifdef PKSR
          CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
#endif
C
          CALL ROTCHI(NUMVAR,NSTEP)
          CALL OPTIMIZE(NUMVAR,X,CALCFPO,CALCGPO,IV,V,IUPARM,URPARM,
     &                   GRADCAX,FAIL)
C AL 7/6/98
          call ene_eval
          IF ( IV(1) .EQ. 11 ) THEN
             WRITE(JOUT,1409)
             stop 
          ENDIF
          call druang(jang,iscan)
          call outnw(0,30,iscan)
C
#ifdef PKSR
          CALL PTHREAD_MUTEX_LOCK(IMUTEX,ISTAT)
          IF (ISTAT.NE.0) WRITE(JOUT,*) ISEQUENCE,
     +      'ENER_MINIM:3 Return from mutex_lock = ',ISTAT
#endif
C
          WRITE (JOUT,100) ISCAN,ECHOLD,ETOT
          IF (ONSCREEN) WRITE (*,100) ISCAN,ECHOLD,ETOT
100   FORMAT(/'***** End of cycle:',I2,', previous energy:',E12.5,
     &     ', new energy:',E12.5,' *****')
C
#ifdef PKSR
          CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
#endif
C
          IF (ECHOLD-ETOT.LT.2.0) GOTO 133
          ECHOLD=ETOT
        ENDDO
      ELSE
        CALL OPTIMIZE(NUMVAR,X,CALCFPO,CALCGPO,IV,V,IUPARM,URPARM,
     &                 GRADCAX,FAIL)
C
        IF ( IV(1) .EQ. 11 ) THEN
#ifdef PKSR
          CALL PTHREAD_MUTEX_LOCK(IMUTEX,ISTAT)
          IF (ISTAT.NE.0) WRITE(JOUT,*) ISEQUENCE,
     +      'ENER_MINIM:4 Return from mutex_lock = ',ISTAT
#endif
C
           WRITE(JOUT,1409)
1409       FORMAT('STOPX termination.')
C
#ifdef PKSR
           CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
#endif
C
           STOP 
        ENDIF
C
#ifdef PKSR
        CALL PTHREAD_MUTEX_LOCK(IMUTEX,ISTAT)
        IF (ISTAT.NE.0) WRITE(JOUT,*) ISEQUENCE,
     +  'ENER_MINIM:5 Return from mutex_lock = ',ISTAT
#endif
C
        IF(NUK.NE.0) WRITE(JOUT,500)
500   FORMAT(/80(1H*)/20X,'Results of energy minimization'/80(1H*))
C
#ifdef PKSR
        CALL PTHREAD_MUTEX_UNLOCK (IMUTEX,ISTAT)
#endif
C
        DO 600 I=1,NUMVAR
           IF ( (ABS(X(I)).GT.1.0E+10)  ) THEN
              WRITE (*,*)'ERROR ENER_MINIM: X(',I,') ',DEG*X(I)
           END IF

           ANGLES( INDXV(I) ) = PINORM( X(I) )
600     CONTINUE
      ENDIF
  133 CALL ENE_EVAL
      RETURN
      END
      SUBROUTINE MINIMIZE(NVAR,X,FUNC,GRAD,IV,V,IUPARM,URPARM,FDUM,FAIL)
C when d(i)=1.0, then v(35) is the length of the initial step,
C calculated in the usual pythagorean way.
C absolute convergence occurs when the function is within v(31) of
C zero. unless you know the minimum value in advance, abs convg
C is probably not useful.
C will decrease by less than v(32)*abs(fun).
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.MINPAR'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.INDXS'
      EXTERNAL FUNC,GRAD,FDUM
      LOGICAL FAIL,GO_AGAIN
      INTEGER IV(1:LIV)
      REAL V(1:LV)
      DIMENSION X(maxnum_var)
      INTEGER IUPARM(1)
      REAL URPARM(1)
      INTEGER ITWO
      DATA ITWO /2/

      FAIL=.FALSE.
      GO_AGAIN=.TRUE.
      IF (LV.LT.77+NVAR*(NVAR+17)/2) THEN
        WRITE(JOUT,'(A)')'Increase lv in file PARAMET.ECEPP  '
        STOP
      END IF
      IF (NVAR.GT.MAXNUM_VAR) THEN
        WRITE(JOUT,*)'Increase maxnum_var in file PARAMET.ECEPP  '
        STOP
      END IF
      IV(1)=0
      CALL DEFLT(ITWO,IV,LIV,LV,V)
* 12 means fresh start, dont call deflt
      iv(1)=12
* max num of fun calls
      IV(17)=MAXFUN
* max num of iterations
      IV(18)=MAXIT
* controls output
      IV(19)=IPRINT(2)
* selects output unit
      IV(21)=IPRINT(1)
*  IV(22)= 1 means to print out value of X's, gradient and D's returned.
      IV(22)=IPRINT(3)
*  IV(23)= 1 means to print out summary stats.
      IV(23)=IPRINT(4)
*  IV(24)= 1 means to print initial x and d.
      IV(24)=IPRINT(5)
* min val for v(radfac) default is 0.1
      V(24)=0.1
* max val for v(radfac) default is 4.0
      V(25)=AMAXSTEP
* check false conv if (act fnctn decrease) .lt. v(26)*(exp decrease)
* the sumsl default is 0.1
      V(26)=VTNER1
* false conv if (act fnctn decrease) .lt. v(34)
* the sumsl default is 100*machep
c     V(34)=V(34)/100.0
      V(34)=V(34)*0.01D0

* absolute convergence
      V(31)=ABSTOL
* relative convergence
      V(32)=RELTOL
C V(LMAX0).... V(35) GIVES THE MAXIMUM 2-NORM ALLOWED FOR D TIMES THE
C             VERY FIRST STEP THAT SUMSL ATTEMPTS.  THIS PARAMETER CAN
C             MARKEDLY AFFECT THE PERFORMANCE OF SUMSL.
      V(35)=V(35)*1.4D0

C ICX INDICATES THAT INDEXES FOR THE LOOPS ON GRADCA SHOULD BE CALCULATED.
C                      DR                       NOV-17-93
      ICX=1
      IF (IMIN.EQ.1) THEN
        IGO=1
cd      WRITE(JOUT,'(A)') 'Calling SUMSL '
        DO WHILE (GO_AGAIN)
        CALL SUMSL(NVAR,D,X,FUNC,GRAD,IV,LIV,LV,V,IUPARM,URPARM,FDUM)
          CALL ANASUMS(FAIL,GO_AGAIN,IV)
          IGO=IGO+1
          IF (IGO.GT.6) THEN
             WRITE (JOUT,*) 'No. of Functions or iterations ',
     &                               'increased 5 times'
             GO_AGAIN=.FALSE.
          ENDIF
        ENDDO
      ELSE IF ( IMIN.EQ.2 ) THEN
        CALL SMSNO(NVAR,D,X,FUNC,IV,LIV,LV,V,IUPARM,URPARM,FUNC)
      ELSE 
        WRITE (JOUT,'(/80(1H*)/10X,A/80(1H*)/)') 
     &           'Unknown minimizer... Terminating.'
        STOP
      ENDIF
cd    write (jout,*) 'MINIMIZE: Number of function evaluations:',iv(6)
      RETURN
      END
      SUBROUTINE ANASUMS(FAIL,GO_AGAIN,IV)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.NNDRUK'
      LOGICAL FAIL,GO_AGAIN
      INTEGER IV(1:LIV)
      GO_AGAIN=.FALSE.
      FAIL=.TRUE.
      
C IV(1)........ ON OUTPUT, IV(1) IS A RETURN CODE....
C             3 = X-CONVERGENCE.
C             4 = RELATIVE FUNCTION CONVERGENCE.
C             5 = BOTH X- AND RELATIVE FUNCTION CONVERGENCE 
C             6 = ABSOLUTE FUNCTION CONVERGENCE. 
      IF( (IV(1).GE. 3). AND. (IV(1).LE. 6) ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.FALSE.
      ENDIF
C
C             7 = SINGULAR CONVERGENCE.  THE HESSIAN NEAR THE CURRENT
C                  ITERATE APPEARS TO BE SINGULAR OR NEARLY SO, AND A
C                  STEP OF LENGTH AT MOST V(LMAX0) IS UNLIKELY TO YIELD
C                  A RELATIVE FUNCTION DECREASE OF MORE THAN V(SCTOL).
      IF( IV(1).EQ. 7 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.FALSE.
         IF (NUK.NE.0) 
     &             WRITE (JOUT,*) 'SUMSL WARNING: SINGULAR CONVERGENCE'
      ENDIF
C             8 = FALSE CONVERGENCE.  THE ITERATES APPEAR TO BE CONVERG-
C                  ING TO A NONCRITICAL POINT.  THIS MAY MEAN THAT THE
C                  CONVERGENCE TOLERANCES (V(AFCTOL), V(RFCTOL),
C                  V(XCTOL)) ARE TOO SMALL FOR THE ACCURACY TO WHICH
C                  THE FUNCTION AND GRADIENT ARE BEING COMPUTED, THAT
C                  THERE IS AN ERROR IN COMPUTING THE GRADIENT, OR THAT
C                  THE FUNCTION OR GRADIENT IS DISCONTINUOUS NEAR X.
      IF( IV(1).EQ. 8 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.FALSE.
        IF (NUK.NE.0) 
     &              WRITE (JOUT,*) 'SUMSL WARNING: FALSE CONVERGENCE'
      ENDIF
C
C             9 = FUNCTION EVALUATION LIMIT REACHED WITHOUT OTHER CON-
C                  VERGENCE (SEE IV(MXFCAL)).
      IF( IV(1).EQ. 9 ) THEN
         IV(17) = IV(17) + 200 
         IV(1)=13
         GO_AGAIN=.TRUE.
         FAIL=.FALSE.
      ENDIF
C
C            10 = ITERATION LIMIT REACHED WITHOUT OTHER CONVERGENCE
C                  (SEE IV(MXITER)).
      IF( IV(1).EQ. 10 ) THEN
         IV(18) = IV(18) + 200 
         IV(1)=13
         GO_AGAIN=.TRUE.
         FAIL=.FALSE.
      ENDIF
C
C            11 = STOPX RETURNED .TRUE. (EXTERNAL INTERRUPT).  SEE THE
C                  USAGE NOTES BELOW.
      IF( IV(1).EQ. 11 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.FALSE.
      ENDIF
C
C            14 = STORAGE HAS BEEN ALLOCATED (AFTER A CALL WITH
C                  IV(1) = 13).
      IF( IV(1).EQ. 14 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.FALSE.
      ENDIF
C
C            17 = RESTART ATTEMPTED WITH N CHANGED.
      IF( IV(1).EQ. 17 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'SUMSL ERROR: RESTART ATTEMPTED WITH N CHANGED'
      ENDIF
C
C            18 = D HAS A NEGATIVE COMPONENT AND IV(DTYPE) .LE. 0.
      IF( IV(1).EQ. 18 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'SUMSL ERROR: D HAS A NEGATIVE COMPONENT'
      ENDIF
C
C            19...43 = V(IV(1)) IS OUT OF RANGE.
      IF( (IV(1).GE. 19). AND. (IV(1).LE. 43) ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'V(',IV(1),') IS OUT OF RANGE' 
      ENDIF
C
C            63 = F(X) CANNOT BE COMPUTED AT THE INITIAL X.
      IF( IV(1).EQ. 63 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'SUMSL ERROR: F CANNOT BE COMPUTED AT INITIAL X'
      ENDIF
C
C            64 = BAD PARAMETERS PASSED TO ASSESS (WHICH SHOULD NOT
C                  OCCUR).
      IF( IV(1).EQ. 64 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'SUMSL ERROR: BAD PARAMETERS PASSED'
      ENDIF
C
C            65 = THE GRADIENT COULD NOT BE COMPUTED AT X (SEE CALCG
C                  ABOVE).
      IF( IV(1).EQ. 65 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'SUMSL ERROR: GRADIENT CANNOT BE COMPUTED AT X'
      ENDIF
C
C            67 = BAD FIRST PARAMETER TO DEFLT.
      IF( IV(1).EQ. 67 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'SUMSL ERROR: BAD FIRST PARAMETER TO DEFLT'
      ENDIF
C            80 = IV(1) WAS OUT OF RANGE.
      IF( IV(1).EQ. 80 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'SUMSL ERROR: IV(1) WAS OUT OF RANGE.'
      ENDIF
C            81 = N IS NOT POSITIVE.
      IF( IV(1).EQ. 81 ) THEN
         GO_AGAIN=.FALSE.
         FAIL=.TRUE.
         WRITE (JOUT,*) 'SUMSL ERROR: N IS NOT POSITIVE'
      ENDIF

      RETURN

      END
      SUBROUTINE ROTCHI(NVAR,MAXSTEP)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.SCAN'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.SETUP'
      DATA MAXSCAN /3/
      DATA IONE /1/, IZERO /0/

C Check whether any angles to be scanned over were specified.
      DO I=2,INUMRS-1
        IF (NDIH(I).GT.0) GOTO 30
      ENDDO
C If no angles have been specified to be scanned over, specify all chi's.
      DO I=2,INUMRS-1
        NT=IABS(LIST(I))     
        NCH=NCHI(NT)
        NDIH(I)=NCH
        DO J=1,NCH
          NUMDIH(I,J)=J+3
        ENDDO
      ENDDO 
   30 STEP=DWAPI/MAXSTEP
      CALL ENE_EVAL
      EMIN=ETOT
      EPRE=ETOT
      WRITE (JOUT,100)
      IF (ONSCREEN) WRITE (*,100)
      DO ISCAN=1,MAXSCAN
        DO 20 IVAR=1,NVAR
          NDX=INDXV(IVAR)
          CALL NDX_DECODE(NDX,ID,IANG)
          DO II=1,NDIH(ID)
            IF (NUMDIH(ID,II).EQ.IANG) THEN
              VARI=VAR(IVAR)
              DO ISTEP=1,MAXSTEP-1 
                VARR=VAR(IVAR)+STEP
                IF ( (ABS(VARR).GT.1.0E+10)  ) THEN
                   WRITE (*,*)'ERROR ROTCHI: VARR ',DEG*VARR
                END IF
                VAR(IVAR)=PINORM(VARR)
                CALL ENE_EVAL
                IF (ETOT.LT.EMIN) THEN
                  EMIN=ETOT
                  VARI=VAR(IVAR)
                ENDIF
              ENDDO
              WRITE (JOUT,200) ID,IANG,VAR(IVAR)/RAD,EMIN 
              IF (ONSCREEN) WRITE (*,200) ID,IANG,VAR(IVAR)/RAD,EMIN 
              IF ( (ABS(VARI).GT.1.0E+10)  ) THEN
                  WRITE (*,*)'ERROR ROTCHI: VARI ',DEG*VARI
              END IF
              VAR(IVAR)=PINORM(VARI)
              ETOT=EMIN
              GOTO 20
            ENDIF
          ENDDO
   20   CONTINUE
        IF (EPRE-EMIN.LE.2.0) GOTO 10
      ENDDO   
cd 10 WRITE (JOUT,*) 'Angles as resulting from ROTCHI:' 
cd    CALL DRUANG(JOUT)
   10 RETURN
  100 FORMAT (/'Residue',2X,'angle',3X,'value','      energy')
  200 FORMAT (i4,5x,i3,2x,f8.1,e12.5)
      END
