      subroutine mseed(coords,atom_rad,d_probe,natoms,
     &                 dotden,dotcrd,dotnrm,dotarea,ndots)

cag...This routine copies user defined SINGLE precision input 
cag   arguments into the common block coor. Note that the 
cag   the common block coor is double precision. The routine 
cag   also copies the output double precision common block 
cag   dott into single precision output arguments.
cyu   restore 12 oktober
c. Feb.18,93 Double precision output  arguments


#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'param.ibems'
      integer maxato
      parameter(maxato=maxnum_atoms )

      integer outdetl
      common/outstl/outdetl
      include 'COMMON.SOLVAT'
      include 'COMMON.SOLVAT3'
      include 'COMMON.IOUNIT'
      real excoord(3,maxnum_atoms)
      common/expcor/excoord
      real*8 dottarx(4,nlargsemx_t)
      integer lpott(nlargsemx_t)
      common/expnts/dottarx,lpott,lpnts

C 2/24/95 AL Pass error flag from MSEED.
      include 'COMMON.MYCONF'
      integer iatom,ider,idot,iret,k,natoms,ndots
      integer iat,ierr
      real*8 dens,ftotal
      real*8 athresh

      real*8 atom_rad(*),coords(3,*),dotarea(*),
     &       dotcrd(3,*),dotden,dotnrm(3,*),d_probe
      real*8 surf,surf0,dxyz0
      real*8 badsurf,badsurf_mx

c     real*8 centr_xyz(3),centr_surf(3)

      iiprint0=0
      iiprint1=1  
      badsurf_mx=0.007d0
       
c     do i=1,3
c        centr_xyz(i)=0.d0
c        centr_surf(i)=0.d0
c     end do

cag...Copy input to seed

      radmx=0.0d0
C natoms passed as nat to common COOR
      nat=natoms
      
      dp  = dble(d_probe)
      do iatom=1,natoms
         radii(iatom) = dble(atom_rad(iatom))
         if(radmx.lt.radii(iatom)) radmx=dble(radii(iatom))
         do k=1,3  
            excoord(k,iatom) = coords(k,iatom)
            dxyz0 = dble(coords(k,iatom))
            xyz(k,iatom) = dxyz0
c           centr_xyz(k)=centr_xyz(k)+dxyz0
         end do
      end do
     
      ider=0
      ndott=0
 
C 2/24/95 AL - inserted code for handling MSEED errors.
      iret=1
      ierr=0

      do while (iret.eq.1)
         call seed(iret)
         if (iret.eq.-1) then
            kprotfail=-190
            return
         endif
         ierr=ierr+1
         if (ierr.gt.50) then
            kprotfail=-191
      write (jout,'(2a/a)') '(W) MSEED error: Increasing atomic radii',
     &  ' does not help to define the manifold.',
     & 'The program will recover by trying another conformation.'
            return
         endif
         if (iret.eq.1) then
	    do iat=1,natoms
	       radii(iat)=radii(iat)+1.0D-2
            enddo
          endif
      enddo

      call areac(iret,ider)
      if (iret.eq.-1) then
         kprotfail=-192
         return
      endif
      ftotal=0.0d0
      do iatom=1,natoms
         ftotal=ftotal+area(iatom)
      end do
c      print*,'mseed.f: total convex area ',ftotal
      dens = dble(dotden)
      call ccnx(iret)
      if (iret.eq.-1) then
         kprotfail=-193
         return
      endif
      call dox(dens,iret)
      if (iret.eq.-1) then
         kprotfail=-194
         return
      endif
      if (dp.gt.0.0d0) then 
         call sadx(dens,iret)
         call cnvx(dens,iret)
      end if
      if (iret.eq.-1) then
         kprotfail=-195
         return
      endif

cag...Copy output from seed into  argument list:
      surf=0.0d0
      ndots=ndott
C     write(*,*)' no. of surface points = ',ndott
      do idot=1,ndots             
c..singl prec vers       dotarea(idot)=sngl(dota(idot))
         dotarea(idot)=dota(idot)
         surf=surf+dotarea(idot)
         do k=1,3
            dotcrd(k,idot)=dotc(k,idot)
            dotnrm(k,idot)=dotn(k,idot)
c           centr_surf(k)=centr_surf(k)+dotc(k,idot)
         end do
      end do

      if (outsurf) then
c... surface area requested only.
         lpnts=ndott
         do idot=1,ndots
            lpott(idot)=ldott(idot)
            dottarx(4,idot)=dota(idot)
            do k=1,3
               dottarx(k,idot)=dotc(k,idot)
            end do
         end do
         kprotfail=-2 
      endif
c.. results of surface calculations
     
c     do k=1,3
c        centr_xyz(k)=centr_xyz(k)/dfloat(natoms)
c        centr_surf(k)=centr_surf(k)/dfloat(ndott)
c     end do     

      if (outdetl.ge.iiprint0)then
c        write(kanalp,*)'MOL_centr=',centr_xyz
c        write(kanalp,*)'SURF_centr=',centr_surf
         write(kanalp,*)
         write(kanalp,91)dens,ndots,surf
         write(kanalp,92)
      end if
c clean from negative s.e. and dotts with small area
      surf0=surf
      surf = 0.d0

c     athresh=0.05d0
c     athresh=athresh/dsqrt(dotden)
      athresh=0.0d0
      nnnd=ndots
      ndots=0
      do id=1,nnnd
         if(dotarea(id).le.athresh)then
            if(outdetl.ge.iiprint1)then
               write(kanalp,93)id,ldott(id),dotarea(id),
     &            (dotcrd(k,id),k=1,3),(dotnrm(k,id),k=1,3)
            end if
         else
            ndots=ndots+1
            ldott(ndots)=ldott(id)
            dotarea(ndots)=dotarea(id)
            surf = surf + dotarea(ndots)
            do k1=1,3
               dotcrd(k1,ndots)=dotcrd(k1,id)
               dotnrm(k1,ndots)=dotnrm(k1,id)
            end do
         end if
      end do

c.. results of surface calculations

      if(outdetl.ge.iiprint0)then
         write(kanalp,*)'Refined surface:'
         write(kanalp,91)dens,ndots,surf
         write(kanalp,*)'number of deleted dots=',nnnd-ndots 
      end if
c     write(jout,*)'deleted surface dots=',nnnd-ndots 
      badsurf=dabs(surf-surf0)/surf
c     write(jout,'(/A,e10.5/)')'BADSURF= ', badsurf
      if(badsurf.gt.badsurf_mx)then
         if(.not.outsurf) then
            write(jout,'(/A,e10.5,A/)')'WARNING: badsurf too large= ',
     *       badsurf, ' Trying new conformation ...'
            kprotfail=-196
         else
            write(jout,'(/A,e10.5/)')'WARNING: badsurf too large= ',
     *       badsurf
         end if
      end if

      if(outdetl.ge.iiprint1)then
          write(kanalp,92)
          do id=1,ndots
              write(kanalp,93)id,ldott(id),dotarea(id),
     &                 (dotcrd(k,id),k=1,3),(dotnrm(k,id),k=1,3)
          end do
      endif


91    format(/5x,'MSEED surface result:','dens=',f9.6,' ndots=',i6,
     &  ' areatot=',f12.6)
92    format(/,10x,'idot',2x,'area',5x,' x     y      z',8x,'norm x',
     & 2x,' norm y   norm z' )   
93    format(5x,i5,2x,i4,2x,f9.6,2x,3f8.4,2x,3f8.5)
c.
7071  format(a4,3x,i4,2x,a3,1x,a3,2x,i4,4x,3f8.3,2x,f4.3,f8.3) !orig PDB
c
      return 
      end

      subroutine prinsur(surfile)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

      include 'param.ibems'
      include 'COMMON.ATOMSS'
      include 'COMMON.GEN100'
      include 'COMMON.THRLET'
C     INCLUDE 'COMMON.SOLVAT3'
      include 'COMMON.IOUNIT'
      real*8 dottarx(4,nlargsemx_t)
      integer lpott(nlargsemx_t)
      common/expnts/dottarx,lpott,lpnts
      integer kolor
      character*6 dotsch
      character*18 atomref
      character*(*) surfile

      list2= iabs(list(2))

      open(unit=jpsurf,file=surfile,status='unknown')
      dotsch='DOTS  '
      kato=npre(2)+1
c. xyz of a reference atom for outdot.surf file
      atomref='ATOM_REF '//ares(list2)//':'//'2'//':'//'N  '
      write(jpsurf,'(a6)')dotsch
      write(jpsurf,'(a18,3f8.3)')atomref,(coord(j,kato),j=1,3)

c DOT Surface file for insigthII
c 
C     DO ID=1,NDOTT
C        IF(LDOTT(ID).EQ.1)KOLOR=60 ! violet
C        IF(LDOTT(ID).EQ.2)KOLOR=120  ! red
C        IF(LDOTT(ID).EQ.3)KOLOR=20   !dark blue
C        IF (DOTA(ID).LT.0.0D0)KOLOR=360  ! white
C        WRITE(JSURF,'(3F12.6,I5)') (DOTC(K,ID), K=1,3),KOLOR
C     END DO
      do id=1,lpnts
         if(lpott(id).eq.1)kolor=60 ! violet
         if(lpott(id).eq.2)kolor=120  ! red
         if(lpott(id).eq.3)kolor=20   !dark blue
         if (dottarx(4,id).lt.0.0d0)kolor=360  ! white
         write(jpsurf,'(3f12.6,i5)') (dottarx(k,id), k=1,3),kolor
      end do
      close(jpsurf)
c MOLXYZ.PDB file consisten with SURFACE

      RETURN 
      END
