C $Date: 1996/12/04 22:20:46 $
C $Revision: 3.2 $
C
C
      SUBROUTINE AMINO
C
C THIS SUBROUTINE SETS THE VALUES OF THE KSA14,KFA14, AND KSA15
C ARRAYS WHICH WILL BE USED LATER IN SUBROUTINE ADJAMN.
C
C IF J IS AN ATOM IN THE AMINO END GROUP, THEN
C   KSA14(J)=THE FIRST ATOM IN THE 2ND RESIDUE HAVING A 1-4
C            INTERACTION WITH J,
C   KFA14(J)=THE LAST ATOM IN THE 2ND RESIDUE HAVING A 1-4
C            INTERACTION WITH J, AND
C   KSA15(J)=THE FIRST ATOM IN THE 2ND RESIDUE HAVING A 1-5
C            INTERACTION WITH J.
C AMINO IS CALLED IN SPECV
C
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.PUT14'
      INCLUDE 'COMMON.PUT15'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.AMIN'
      LOGICAL LPROLIN
C
C IF THERE IS NO AMINO END GROUP,RETURN
C
      IF(KAMIN.EQ.10) RETURN
C
C DEFINE VARIABLES
C
      LIST2=LIST(2)
      LIST2=IABS(LIST2)
      KIND2=KNDRES(LIST2)
      KIND2=IABS(KIND2)
      NPRE2=NPRE(2)
      JFIN=NPRE2
C
C IS THE 2ND RESIDUE A PROLINE OR HYDROXYPROLINE?
      IF(LPROLIN(2)) GO TO 2
C
C THIS SECTION IS FOR THE SECOND RESIDUE NOT A PROLINE
C OR A HYDROXYPROLINE
      DO 1 J=1,JFIN
      KSA14(J)=MSX14(J,LAMIN)+NPRE2
      KFA14(J)=MFX14(J,LAMIN)+NPRE2
      KSA15(J)=MSX15(J,LAMIN)+NPRE2
 1    CONTINUE
      RETURN
C
C THE FOLLOWING SECTION IS FOR PROLINE OR HYDROXYPROLINE
C
 2    CONTINUE
C     WRITE(JOUT,*) 'AMINO FOR SECOND RESIDUE PRO, JFIN=',JFIN
      DO 7 J=1,JFIN
      KSTRT=MSX14(J,LAMIN)
      GO TO (3,4,5,6), KSTRT
C
C KSTRT=1
C
 3    CONTINUE
C     WRITE(JOUT,*) 'J= ', J, ' ENTER IN =',KSTRT
      KSTRT=1+NPRE2
      KSA14(J)=KSTRT
      KFA14(J)=KSTRT
      KSA15(J)=2+NPRE2
C     WRITE(JOUT,*)'KSA14(',J, ')= ',KSTRT,' KSA15(',J,')= ',KSA15(J)
      GO TO 7
C
C KSTRT=2
C
 4    CONTINUE
C     WRITE(JOUT,*) 'J= ', J, ' ENTER IN =',KSTRT
      KSA14(J)=2+NPRE2
C     WRITE(JOUT,*)'KSA14(',J, ')= ',KSA14(J)
      GO TO 7
C
C ERROR (KSTRT=3)
C
 5    WRITE (JPRINT,500)
      STOP
C
C KSTRT=4
C
C NOTICE THAT KFA14 AND KSA15 ARE NOT SET, SINCE THEY WILL
C NOT BE NEEDED IN ADJAMN
 6    CONTINUE
C     WRITE(JOUT,*) 'J= ', J, ' ENTER IN =',KSTRT
      KSA14(J)=7+NPRE2
C     WRITE(JOUT,*)'KSA14(',J, ')= ',KSA14(J)
C END OF PROLINE SECTION

 7    CONTINUE
      RETURN
  500 FORMAT(55H ERROR IN 1-4 INTERACTIONS BETWEEN 1ST AND 2ND RESIDUE.)
      END
      SUBROUTINE ADJAMN
C  -Altered 11/91  to include residues with N-methyl groups.
C
C THIS SUBROUTINE CALCULATES THE ENERGIES BETWEEN ATOM J IN
C THE AMINO END GROUP AND THE APPROPRIATE ATOMS IN THE SECOND
C RESIDUE.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.AMIN'
      LOGICAL NMETHYL
      LOGICAL LPRNT

      LPRNT=.FALSE.
      KSTRT=KSA14(J)
C
C     WRITE(JOUT,*) 'START ADJAMN FOR J= ', J,
C    &       ' KSTRT= ', KSTRT, ' NPREIK= ', NPREIK

C IS THE 2ND RESIDUE A PROLINE OR HYDROXYPROLINE?
      IF(KPRO.EQ.1) GO TO 2
C
C STANDARD CASE
C
      IF (KSTRT.EQ.NPREIK) GOTO 33
 1    KFIN=KFA14(J)
      CALL CAL14
C  **************************************************************
C  Modified to include residues with N-methyl groups. D.R.  ^^^&&& 11/91
C  Add the 1-4 interactions between the last atom (connecting one!) of
C  the amino end group and the H atoms of the N-methyl group of the
C  first residue.
   33 NK= IABS(LISTIK)
      IF ( (NMETHYL(IK)).AND.(J.EQ.NPREIK) ) THEN
         KSTR=NPREIK+LRT1(1,NK)
         KFIN=NPREIK+LRT1(1,NK)+NUM(1,NK)
         CALL CAL14
      END IF
C  **************************************************************
      KSTRT=KSA15(J)
      IF(KSTRT.EQ.NPREIK) RETURN
C  **************************************************************
C  Modified to include N-methyl groups    D.R.  ^^^&&&& 11/91
C  Do not compute the interactions between the C' of residue IJ
C  and the H atoms of the N-methyl group on residue IK as 1-5.
      IF ( (NMETHYL(IK)).AND.(J.EQ.NPREIK) ) THEN
         KFIN=NPREIK+LRT1(1,NK)-1
      ELSE
         KFIN=NPRE(3)
      END IF
C  **************************************************************
      CALL CAL15
      RETURN
C
C PROLINE SECTION
C
C NFIRST IS THE INTRA-RESIDUE NUMBER OF THE FIRST ATOM IN
C RESIDUE IK (=IJ+1) HAVING A 1-4 INTERACTION WITH J.
C NFIRST=1 FOR A NITROGEN, 7 FOR AN OXYGEN.
 2    NFIRST=KSTRT-NPREIK
C     WRITE(JOUT,*) 'ADJAMN:  NFIRST= ', NFIRST 
      IF(NFIRST.EQ.1) GO TO 1
      IF(NFIRST.EQ.7) GO TO 3
C     WRITE(JOUT,*) 'ADJAMN:  CALL PRO37'
      CALL PRO37
      RETURN
C
C OXYGEN SECTION (SEE FLOW CHART)
C
 3    KFIN=KSTRT
      CALL CAL14
      NIT=1
C
      IF (KINDIK.EQ.22) THEN
C CALCULATE EXPLICITLY THE INTERACTION OF ATOM J WITH
C THE HD1(K=15) OF HYDROXYPROLINE in THE NEXT RESIDUE
C
         KSTRT=15+NPREIK
         KFIN=KSTRT
      if(lprnt) write (jout,*) '1,4 kstrt=', kstrt,' kfin=',kfin
         CALL CAL14
      ELSE IF(KINDIK.EQ.75) THEN
C CALCULATE EXPLICITLY THE INTERACTION OF ATOM J WITH
C THE HE's OF DiMethyl-PROLINE in THE NEXT RESIDUE
         KSTRT=15+NPREIK
         KFIN=20+NPREIK
      if(lprnt) write (jout,*) '1,4 kstrt=', kstrt,' kfin=',kfin
         CALL CAL14

C        KSTRT=KSA15(J)
C        KFIN=20+NPREIK
C        CALL CAL15

      ENDIF
      RETURN
      END
C
      SUBROUTINE ADJCNT
C
C THIS SUBROUTINE IS NEEDED WHEN CALCULATING THE ENERGIES BETWEEN
C ADJACENT RESIDUES IJ AND IK.  IT SIMPLY DETERMINES AND
C CALLS THE APPROPRIATE SUBROUTINE.
C
C    ADJOXL IS CALLED IF IK=IJ+1 IS THE CARBOXYL END GROUP,
C          I.E., IF IJ IS THE LAST FULL RESIDUE
C
C    ADJAMN IS CALLED WHEN IJ IS THE AMINO END GROUP
C
C    ADJNN IS CALLED WHEN IJ AND IK ARE BOTH NON-END GROUPS AND
C          NEITHER IS A PROLINE OR HYDROXYPROLINE
C    ADJNP IS USED WHEN IJ IS NOT THE AMINO END GROUP AND IK IS
C          A PROLINE OR HYDROXYPROLINE
C    ADJPN IS CALLED WHEN IJ IS A PROLINE AND IK IS NOT THE
C          CARBOXYL END GROUP
C    ADJPP IS USED WHEN BOTH IJ AND IK ARE PROLINES (WHERE THE
C          TERM "PROLINE" INCLUDES HYDROXYPROLINE)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
C     INCLUDE 'COMMON.DEBUG'

      logical lprnt
      lprnt=.false.
c     lprnt=.true.
      if(lprnt) write(jout,*)' ADJCNT with JM', JM
C
      IF(IK.NE.INUMRS) GO TO 1
      if(lprnt)write(jout,*) 'CALL TO ADJOXL'
      CALL ADJOXL
      RETURN
 1    IF(IJ.GT.1) GO TO 2
      if(lprnt)write(jout,*) 'CALL TO ADJAMN'
      CALL ADJAMN
      RETURN
 2    IF(JPRO.EQ.1) GO TO 4
      IF(KPRO.EQ.1) GO TO 3
      if(lprnt)write(jout,*) 'CALL TO ADJNN'
      CALL ADJNN
      RETURN
 3    CONTINUE
      if(lprnt)write(jout,*) 'CALL TO ADJNP'
      CALL ADJNP
      RETURN
 4    IF(KPRO.EQ.1) GO TO 5
      if(lprnt)write(jout,*) 'CALL TO ADJPN'
      CALL ADJPN
      RETURN
 5    CONTINUE
      if(lprnt)write(jout,*) 'CALL TO ADJPP'
      CALL ADJPP
      RETURN
      END
      SUBROUTINE ADJCYC
C  -Altered 11/91  to include residues with N-methyl groups.
C
C This subroutine calculates the interaction pairs between atom j and the
C appropriate atoms in the residue IK adjacent to the N-terminus
C and _not_ to the C-terminus of the residue IJ. IJ and IK
C are both non-end groups and neither is a proline or hydroxy-
C proline. At present the subroutine is used to set up the non-
C bonded interaction table for the two terminal residues that close
C a cyclic backbone.
C
C -- As of 8/11/93 (DR & AL).
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER (isuppl=matres-7)
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
C     INCLUDE 'COMMON.DEBUG'
      LOGICAL LPRNT
      LOGICAL NMETHYL
      DIMENSION NSY14(matres,maxgrp),NFY14(matres,maxgrp),
     &          NSY15(matres,maxgrp),NFY15(matres,maxgrp)
C     DATA NSX14/1,0,2,2*1,4,2,24*0/
C     DATA NFX14/1,0,3,2*1,6,3,24*0/
C     DATA NSX15/2,1,4,2,2,7,4,24*1/
      DATA NSY14/1,3,3,6,6,6,0,isuppl*0,
     &           4,7,7,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0/
      DATA NFY14/1,3,3,6,6,6,0,isuppl*0,
     &           5,7,7,0,0,0,0,isuppl*0, 
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0/
      DATA NSY15/2,1,1,1,1,1,1,isuppl*1,
     &           8,4,4,7,7,7,0,isuppl*0,
     &           0,8,8,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0/
      DATA NFY15/2,2,2,5,5,5,0,isuppl*0,
     &           0,5,5,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0/
C
C     lprnt=.true.        ! for debugging
C      lprnt=.true.  
      lprnt=.false.
      if(lprnt) write(jout,*)' ADJCYC with JM', JM
C  **************************************************************
C  Modified to include residues with N-methyl groups. D.R.  ^^^&&& 11/91
C  Add the 1-4 interactions between the C' of residue IJ and the H atoms
C  of the N-methyl group of the residue in the (IJ+1) position.
      NJ= IABS(LISTIJ)
      IF (NMETHYL(IJ)) THEN
         JSTRC=NPREIJ+LRT1(1,NJ)
         JFINC=NPREIJ+LRT1(1,NJ)+NUM(1,NJ)-1
         IF (J.LE.JSTRC .AND. J.GE.JFINC) THEN
           do iint=1,maxgrp
             nsy14(j,iint)=nsy14(4,iint)
             nfy14(j,iint)=nfy14(4,iint)
             nsy15(j,iint)=nsy15(4,iint)
             nfy15(j,iint)=nfy15(4,iint)
           enddo 
         ENDIF
      ENDIF
C Loop through the groups of interactions.
      do iint=1,maxgrp
         kstrt=npreik+nsy14(j,iint)
         if (kstrt.gt.npreik) then 
           kfin=npreik+nfy14(j,iint)
           if(lprnt) write (jout,*) '1,4 iint=',iint,' kstrt=',
     &           kstrt,' kfin=',kfin 
           call cal14
         endif
         kstrt=npreik+nsy15(j,iint)
         if (kstrt.gt.npreik) then
           kfin=npreik+nfy15(j,iint)
           if (kfin.eq.npreik) kfin=npre(ik+1)
           if(lprnt) write (jout,*) '1,5 iint=',iint,' kstrt=',
     &           kstrt,' kfin=',kfin 
           call cal15
         endif
      enddo
      RETURN
      END
      SUBROUTINE ADJCYCP
C  -Altered 11/91  to include residues with N-methyl groups.
C
C This subroutine calculates the energies between atom j and the
C appropriate atoms in the residue IK adjacent to the N-terminus
C and _not_ to the C-terminus of the residue IJ. IJ and IK
C are both non-end groups and neither is a proline or hydroxy-
C proline. At present the subroutine is used to set up the non-
C bonded interaction table for the two terminal residues that close
C a cyclic backbone.
C
C -- As of 8/11/93 (DR & AL).
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER (isuppl=matres-7)
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.DEBUG'
C     LOGICAL LPRNT
      LOGICAL NMETHYL
      DIMENSION NSY14(matres,maxgrp),NFY14(matres,maxgrp),
     &          NSY15(matres,maxgrp),NFY15(matres,maxgrp)
      DATA NSY14/1,3,3,6,6,6,0,isuppl*0,
     &           4,7,7,0,0,0,0,isuppl*0,
     &           8,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0/
      DATA NFY14/2,3,3,6,6,6,0,isuppl*0,
     &           5,7,7,0,0,0,0,isuppl*0, 
     &          14,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0/
      DATA NSY15/0,1,1,1,1,1,1,isuppl*1,
     &           0,4,4,7,7,7,0,isuppl*0,
     &           0,8,8,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0/
      DATA NFY15/0,2,2,5,5,5,0,isuppl*0,
     &           0,5,5,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0,
     &           0,0,0,0,0,0,0,isuppl*0/
C
C     lprnt=.true.        ! for debugging
      lprnt=.false.
      if(lprnt) write(jout,*)' ADJCYC with JM', JM
C  **************************************************************
C  Modified to include residues with N-methyl groups. D.R.  ^^^&&& 11/91
C  Add the 1-4 interactions between the C' of residue IJ and the H atoms
C  of the N-methyl group of the residue in the (IJ+1) position.
      NJ= IABS(LISTIJ)
      IF (NMETHYL(IJ)) THEN
         JSTRC=NPREIJ+LRT1(1,NJ)
         JFINC=NPREIJ+LRT1(1,NJ)+NUM(1,NJ)-1
         IF (J.LE.JSTRC .AND. J.GE.JFINC) THEN
           do iint=1,maxgrp
             nsy14(j,iint)=nsy14(4,iint)
             nfy14(j,iint)=nfy14(4,iint)
             nsy15(j,iint)=nsy15(4,iint)
             nfy15(j,iint)=nfy15(4,iint)
           enddo 
         ENDIF
      ENDIF
C Loop through the groups of interactions.
      do iint=1,maxgrp
         kstrt=npreik+nsy14(j,iint)
         if (kstrt.gt.npreik) then 
           kfin=npreik+nfy14(j,iint)
           if(lprnt) write (jout,*) '1,4 iint=',iint,' kstrt=',
     &           kstrt,' kfin=',kfin 
           call cal14
         endif
         kstrt=npreik+nsy15(j,iint)
         if (kstrt.gt.npreik) then
           kfin=npreik+nfy15(j,iint)
           if (kfin.eq.npreik) kfin=npre(ik+1)
           if(lprnt) write (jout,*) '1,5 iint=',iint,' kstrt=',
     &           kstrt,' kfin=',kfin 
           call cal15
         endif
      enddo
      RETURN
      END
      SUBROUTINE ADJNN
C  -Altered 11/91  to include residues with N-methyl groups.
C
C THIS SUBROUTINE CALCULATES THE ENERGIES BETWEEN ATOM J AND THE
C APPROPRIATE ATOMS IN THE ADJACENT RESIDUE (IK=IJ+1).  IJ AND IK
C ARE BOTH NON-END GROUPS AND NEITHER IS A PROLINE OR HYDROXY-
C PROLINE.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
C     INCLUDE 'COMMON.DEBUG'
      LOGICAL LPRNT
      LOGICAL NMETHYL

C FOLLOWING ARRAYS WERE MODIFIED ON OCT-93              DR.
C     DIMENSION NSX14(31),NFX14(31),NSX15(31)
C     DATA NSX14/1,0,2,2*1,4,2,24*0/
C     DATA NFX14/1,0,3,2*1,6,3,24*0/
C     DATA NSX15/2,1,4,2,2,7,4,24*1/

      PARAMETER (isuppl=matres-7)
      DIMENSION NSX14(matres),NFX14(matres),NSX15(matres)
      DATA NSX14/1,0,2,2*1,4,2,isuppl*0/
      DATA NFX14/1,0,3,2*1,6,3,isuppl*0/
      DATA NSX15/2,1,4,2,2,7,4,isuppl*1/
C
      lprnt=.false.
C     lprnt=.true.

      if(lprnt) write(jout,*)' ADJNN with JM', JM

      KSTRT=NSX14(J)
C
C FIRST WE CALCULATE THE 1-4 INTERACTIONS
C
      IF(KSTRT.EQ.0) GO TO 1
      KSTRT=KSTRT+NPREIK
      KFIN=NFX14(J)+NPREIK
      if(lprnt)write(jout,*) '1-4 j=',j,' kstrt=',kstrt,' kfin=',kfin
      CALL CAL14
C  **************************************************************
C  Modified to include residues with N-methyl groups. D.R.^^^&&& 11/91
C  Add the 1-4 interactions between the C' of residue IJ and the H 
C  atoms of the N-methyl group of the residue in the (IJ+1) position.
      NK= IABS(LISTIK)
      IF ( (NMETHYL(IK)).AND.(J.EQ.6) ) THEN
         KSTRT=NPREIK+LRT1(1,NK)
         KFIN=NPREIK+LRT1(1,NK)+NUM(1,NK)-1
      if(lprnt)write(jout,*) '1-4 j=',j,' kstrt=',kstrt,' kfin=',kfin
         CALL CAL14
      END IF
C  **************************************************************
C
C NOW WE CALCULATE THE 1-5 INTERACTIONS
C
 1    KSTRT=NSX15(J)+NPREIK
C  **************************************************************
C  Modified to include N-methyl groups    D.R.  ^^^&&&& 11/91
C  Do not compute the interactions between the C' of residue IJ
C  and the H atoms of the N-methyl group on residue IK as 1-5.
      IF ( (NMETHYL(IK)).AND.(J.EQ.6) ) THEN
         KFIN=NPREIK+LRT1(1,NK)-1
      ELSE
C In most cases the residue adjacent to IJ is IJ+1; therefore KFIN 
C could be set as the last atom of that residue (NPRE(IJ+2)). However, 
C for cyclic peptides, if IJ=INUMRS-1, the adjacent residue is 2 
C (that is the first full residue) and _not_ IJ+1. Therefore, in 
C general, the adjacent residue has the number IK and not IJ+1.
C       KFIN=NPRE(IJ+2)       
        KFIN=NPRE(IK+1)
      END IF
C  **************************************************************
      if(lprnt)write(jout,*)'1-5 j=',j,' kstrt=',kstrt,' kfin=',kfin
      CALL CAL15
      RETURN
      END
      SUBROUTINE ADJNP
C
C THIS SUBROUTINE CALCULATES THE ENERGIES BETWEEN ATOM J AND
C THE APPROPRIATE ATOMS IN THE ADJACENT RESIDUE (IK=IJ+1).  IJ AND IK
C ARE BOTH NON-END GROUPS.  IJ IS NOT A PROLINE OR HYDROXY-
C PROLINE, BUT IK IS.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.DEBUG'
C     logical lprnt
      INCLUDE 'COMMON.IOUNIT'
C FOLLOWING ARRAYS WERE MODIFIED ON OCT-93              DR.
C     DIMENSION NPSX14(31),NPFX14(31),NPSX15(31)
C     DATA NPSX15/2,1,7,2,2,0,7,24*1/
C     DATA NPFX14/1,0,6,1,1,7,6,24*0/
C     DATA NPSX14/1,0,2,1,1,7,2,24*0/

      PARAMETER (isuppl=matres-7)
      DIMENSION NPSX14(matres),NPFX14(matres),NPSX15(matres)
      DATA NPSX15/2,1,7,2,2,0,7,isuppl*1/
      DATA NPFX14/1,0,6,1,1,7,6,isuppl*0/
      DATA NPSX14/1,0,2,1,1,7,2,isuppl*0/
C
      if(lprnt) write(jout,*)' ADJNP'
      IF (J.EQ.3.OR.J.EQ.7) GO TO 2
      IF(J.EQ.6) NIT=1
C
C FIRST CALCULATE THE 1-4 INTERACTIONS
C
      KSTRT=NPSX14(J)+NPREIK
      IF(KSTRT.EQ.NPREIK) GO TO 1
      KFIN=NPFX14(J)+NPREIK
      if(lprnt) write (jout,*) '1,4 kstrt=', kstrt,' kfin=',kfin
      CALL CAL14
C
C     IF (KINDIK.NE.22.OR.J.NE.6) GO TO 1
      IF (KINDIK.EQ.22.AND.J.EQ.6) THEN
C CALCULATE EXPLICITLY THE INTERACTION OF ATOM C' WITH 
C THE HD1(K=15) OF HYDROXYPROLINE in THE NEXT RESIDUE
C
         KSTRT=15+NPREIK
         KFIN=KSTRT
      if(lprnt) write (jout,*) '1,4 kstrt=', kstrt,' kfin=',kfin
         CALL CAL14
      ELSE IF(KINDIK.EQ.75.AND.J.EQ.6) THEN
C CALCULATE EXPLICITLY THE INTERACTION OF ATOM C' WITH 
C THE HE's OF DiMethyl-PROLINE in THE NEXT RESIDUE
         KSTRT=15+NPREIK
         KFIN=20+NPREIK
      if(lprnt) write (jout,*) '1,4 kstrt=', kstrt,' kfin=',kfin
         CALL CAL14
      ENDIF  
C
C NOW CALCULATE THE 1-5 INTERACTIONS
C
 1    KSTRT=NPSX15(J)+NPREIK
      IF(KSTRT.EQ.NPREIK) RETURN
C In most cases the residue adjacent to IJ is IJ+1; therefore KFIN could
C be set as the last atom of that residue (NPRE(IJ+2)). However, for cyclic
C peptides, if IJ=INUMRS-1, the adjacent residue is 2 (that is the first full
C residue) and _not_ IJ+1. Therefore, in general, the adjacent residue has the
C number IK and not IJ+1.
C     KFIN=NPRE(IJ+2)       
      KFIN=NPRE(IK+1)

      if(lprnt) write (jout,*) '1-5 kstrt=', kstrt,' kfin=',kfin
      CALL CAL15
      RETURN
C
C CALCULATE RING
C THIS SECTION IS FOR THE SPECIAL CASE OF J A C3 OR O7
C
 2    CALL PRO37
      RETURN
      END
      SUBROUTINE ADJOXL
C
C THIS SUBROUTINE CALCULATES THE APPROPRIATE INTERACTIONS
C BETWEEN ATOM J IN THE LAST FULL RESIDUE AND THE ATOMS IN
C THE CARBOXYL END GROUP
C
C THE ARRAYS KSC14, KFC14, AND KSC15 ARE INITIALIZED IN
C SUBROUTINE CBOXL.  KSC14 AND KFC14 REFER TO THE STARTING AND
C FINAL 1-4 INTERACTIONS.  KSC15 REFERS TO THE STARTING 1-5
C INTERACTION.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CARB'
      INCLUDE 'COMMON.CALC'
C
      NUMATM=NPRE(INUMRS+1)
C
C FIRST CALCULATE THE 1-4 INTERACTIONS
C
      KSTRT=KSC14(J)
      IF(KSTRT.EQ.NPREIK) GO TO 1
      KFIN=KFC14(J)
      CALL CAL14
C
C NOW CALCULATE THE 1-5 INTERACTIONS
C
 1    KSTRT=KSC15(J)
      IF(KSTRT.EQ.NPREIK) RETURN
      KFIN=NUMATM
      CALL CAL15
      RETURN
      END
      SUBROUTINE ADJPN
C  -Altered 11/91  to include residues with N-methyl groups.
C
C THIS SUBROUTINE CALCULATES THE APPROPRIATE INTERACTIONS
C BETWEEN ATOM J AND THE ATOMS IN RESIDUE IK=IJ+1
C IJ IS A PROLINE RESIDUE AND IK IS NOT
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CALC'
C DiMethyl PRO added 5/12/98 DR
C     INTEGER PNSX14(15),PNFX14(15),PNSX15(15)
c     DATA PNSX14/1,1,2,1,1,4,2,1,1,1,1,1,1,1,0/
c     DATA PNFX14/1,1,3,1,1,6,3,1,1,1,1,1,1,1,0/
c     DATA PNSX15/2,2,4,2,2,7,4,2,2,2,2,2,2,2,1/
      INTEGER PNSX14(20),PNFX14(20),PNSX15(20)
******* modified for Hyp & dmPro (03/25/99) *****************
      DATA PNSX14/1,1,2,1,1,4,2,1,1,1,1,1,1,1,0,0,0,0,0,0/
      DATA PNFX14/1,1,3,1,1,6,3,1,1,1,1,1,1,1,0,0,0,0,0,0/
      DATA PNSX15/2,2,4,2,2,7,4,2,2,2,2,2,2,2,1,1,1,1,1,1/
C

      LOGICAL NMETHYL
C
C FIRST CALCULATE THE 1-4 INTERACTIONS
C
      KSTRT=PNSX14(J)+NPREIK
      IF(KSTRT.EQ.NPREIK) GO TO 1
      KFIN=PNFX14(J)+NPREIK
      CALL CAL14
C  **************************************************************
C  Modified to include residues with N-methyl groups. D.R.  ^^^&&& 11/91
C  Add the 1-4 interactions between the C' of the PRO residue ( IJ )
C  and the H atoms of the N-methyl group of the residue in the (IJ+1)
C  position.
      NK= IABS(LISTIK)
      IF ( (NMETHYL(IK)).AND.(J.EQ.6) ) THEN
         KSTRT=NPREIK+LRT1(1,NK)
         KFIN=NPREIK+LRT1(1,NK)+NUM(1,NK)-1
         CALL CAL14
      END IF
C  **************************************************************
C
C NOW CALCULATE THE 1-5 INTERACTIONS
C
 1    KSTRT=PNSX15(J)+NPREIK
C  **************************************************************
C  Modified to include N-methyl groups    D.R.  ^^^&&&& 11/91
C  Do not compute the interactions between the C' of the IJ proline
C  and the H atoms of the N-methyl group on residue (IJ+1) as 1-5.
      IF ( (NMETHYL(IK)).AND.(J.EQ.6) ) THEN
         KFIN=NPREIK+LRT1(1,NK)-1
      ELSE
C In most cases the residue adjacent to IJ is IJ+1; therefore KFIN could
C be set as the last atom of that residue (NPRE(IJ+2)). However, for cyclic
C peptides, if IJ=INUMRS-1, the adjacent residue is 2 (that is the first full
C residue) and _not_ IJ+1. Therefore, in general, the adjacent residue has the
C number IK and not IJ+1.
C       KFIN=NPRE(IJ+2)       
        KFIN=NPRE(IK+1)
      END IF
C  **************************************************************
      CALL CAL15
      RETURN
      END
      SUBROUTINE ADJPP
C
C THIS SUBROUTINE CALCULATES THE INTERACTIONS BETWEEN
C ATOM J IN RESIDUE IJ AND THE APPROPRIATE ATOMS IN RESIDUE
C IK=IJ+1.  IJ AND IK ARE BOTH PROLINES (WHERE 'PROLINE'
C INCLUDES HYDROXYPROLINE)
C

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
      LOGICAL LPRNT
C DiMethyl PRO added 5/12/98 DR
C     INTEGER PPSX14(15),PPFX14(15),PPSX15(15)
c     DATA PPSX14/1,1,2,1,1,7,2,1,1,1,1,1,1,1,0/
c     DATA PPFX14/1,1,6,1,1,7,6,1,1,1,1,1,1,1,0/
c     DATA PPSX15/2,2,7,2,2,0,7,2,2,2,2,2,2,2,1/
      INTEGER PPSX14(20),PPFX14(20),PPSX15(20)
      DATA PPSX14/1,1,2,1,1,7,2,1,1,1,1,1,1,1,0,0,0,0,0,0/
      DATA PPFX14/1,1,6,1,1,7,6,1,1,1,1,1,1,1,0,0,0,0,0,0/
      DATA PPSX15/2,2,7,2,2,0,7,2,2,2,2,2,2,2,1,1,1,1,1,1/

      LPRNT=.FALSE.

C
      IF (J.EQ.3.OR.J.EQ.7) GO TO 2
      IF(J.EQ.6) NIT=1
C
C FIRST CALCULATE THE 1-4 INTERACTIONS, IF ANY
C
      KSTRT=PPSX14(J)+NPREIK
      IF(KSTRT.EQ.NPREIK) GO TO 1
      KFIN=PPFX14(J)+NPREIK
      CALL CAL14
C
C CALCULATE EXPLICITLY THE INTERACTION WITH THE HD1(K=15) OF HYDROXYPROLINE
C
C      IF (KINDIK.NE.22.OR.J.NE.6) GO TO 1
C      KSTRT=15+NPREIK
C      KFIN=KSTRT
C      CALL CAL14
      IF (KINDIK.EQ.22.AND.J.EQ.6) THEN
C CALCULATE EXPLICITLY THE INTERACTION OF ATOM C' WITH
C THE HD1(K=15) OF HYDROXYPROLINE IN THE NEXT RESIDUE
C
        KSTRT=15+NPREIK
        KFIN=KSTRT
      if(lprnt) write (jout,*) '1,4 kstrt=', kstrt,' kfin=',kfin
        CALL CAL14
      ELSE IF(KINDIK.EQ.75.AND.J.EQ.6) THEN
C CALCULATE EXPLICITLY THE INTERACTION OF ATOM C' WITH
C THE HE's OF DiMethyl-PROLINE in THE NEXT RESIDUE
         KSTRT=15+NPREIK
         KFIN=20+NPREIK
      if(lprnt) write (jout,*) '1,4 kstrt=', kstrt,' kfin=',kfin
         CALL CAL14
      ENDIF

C
C NOW CALCULATE THE 1-5 INTERACTIONS, IF ANY
C
 1    KSTRT=PPSX15(J)+NPREIK
      IF(KSTRT.EQ.NPREIK) RETURN
C See the comment in ADJNN, etc. Although we don't need this change here
C (proline cannot be the first full residue and therefore no such cyclic
C peptide will be formed), we introduce this generalization with regard to
C possible future changes. 
C     KFIN=NPRE(IJ+2)       
      KFIN=NPRE(IK+1)
      CALL CAL15
      RETURN
C
C CALCULATE RING (SEE FLOW CHART)
C THIS SECTION IS FOR THE SPECIAL CASE OF J A C3 OR O7
C
 2    CALL PRO37
      RETURN
      END
      SUBROUTINE BLOCK
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.BLOKA'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.LBONDSX'
      IB=0
      NATM=NPRE(INUMRS+1)
      KB=0
      JSAV=1
      KA=1
      KAS=0
      DO 1 J=1,NATM
    1 NBLK(J)=0
      DO 15 I=1,INUMRS
      NVR=NV(I)
      IF(NVR.EQ.0) GO TO 14
      KC=0
      JST=JSAV
      DO 13 KK=1,NVR
      K=KB+KK
      JIK=NDXARR(KK,I)
      JIB=JIK+IB
      LRS=LROT1(JIB)
      LR2=LROT2(JIB)
      LR1=LRS
      IF(JIK.GT.3) GO TO 7
C
C BACKBONE VARIABLES
C
    2 LOX=0
      IF(LRS.GT.0) GO TO 3
      II=-LRS
      LR1=NPRE(II)+1
      LOX=NPRE(II-1)+7
      NAT1 = NPRE(I)
      NAT2 = NPRE(I+1)
    3 DO 5 J=JST,NATM
      JSV=J
      IF(J.GE.LR1) GO TO 6
      IF(J.NE.LOX) GO TO 4
      NBLK(LOX)=KA+1
      GO TO 5
    4 IF (NBLK(J).EQ.0) NBLK(J)=KA
    5 CONTINUE
    6 IF(JIB.EQ.1.OR.KK.EQ.NVR) JST=JSV
      KA=KA+1
      JSAV=JST
      GO TO 13
C
C SIDECHAIN VARIABLES
C
    7 KAS=KAS-1
      DO 12 J=LR1,LR2
      NBLK(J)=KAS
   12 CONTINUE
C
C
   13 CONTINUE
   14 IB=IB+maxnum_dihe
      KB=KB+NVR
   15 CONTINUE
      DO 16 J=JSAV,NATM
      IF(NBLK(J).NE.0) GO TO 16
      NBLK(J)=KA
   16 CONTINUE
C     WRITE (JOUT,160) (NBLK(J),J=1,NATM)
  160 FORMAT (/,33H ATOM BLOCK NUMBERS (NBLK ARRAY):,//,(10I5))
      RETURN
      END
      SUBROUTINE CALINT
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INTEGER INPREV(MXINT),JOTAM(MXINT),JOTAML(MXINT),JOTOFF(MXINT)
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.PARALE'
      INCLUDE 'COMMON.IOUNIT'
C
#ifdef PKSR
      INCLUDE 'COMMON.PARRAY'
#endif
C
      NINT=0
      JM1=1
      JMLST=0
      JMOFF=0
C     WRITE(JOUT,'(a,I4)') 'LEN=', LEN
      DO 100 L=1,LEN
         INPREV(L)= NINT
         JOTAM(L)= JM1
         JOTAML(L)= JMLST
         JOTOFF(L)= JMOFF
         KOFF=INTER(1,L)
         IF (KOFF) 100,10,20
   10    JM1=JM1+1
         GO TO 100
   20    KST=JM1+KOFF
         K5ST=KST+INTER(2,L)
         KEY=INTER(3,L)
         KFINL=K5ST+KEY-1
         IF (KEY.LT.0) KFINL=NATM
         IF (JM1.EQ.JMLST) GO TO 30
         JMOFF=3*(JM1-1)
         JMLST=JM1
   30    DO 80 KM=KST,KFINL
              NINT=NINT+1
   80    CONTINUE
C        write(70,444) L, JM1, NINT
444      FORMAT(' LEN= ',i5,' JM1=', i5,' No of INTERACT', i6)
         IF (KEY.GE.0) GO TO 100
         JM1=JM1+1
  100 CONTINUE
      INPREV(LEN)= NINT
C Determine the maximum no of interactions per processor to
C be computed.  We assume that NINT >> NPROCS.
#ifdef PKSR
      NPROCS= nthreads
#else
      NPROCS= 1
#endif
      INOLD = 0
      NOINT= INT(NINT/NPROCS)
C     WRITE(JOUT,'(a,I10)') 'NOINT=', NOINT
      LEN_F= 0
      DO 110 I=1,NPROCS
         LEN_INI(I) = LEN_F + 1
         JM_PROC(I)= JOTAM(LEN_F+1)
         JML_PROC(I)= JOTAML(LEN_F+1)
         JMOF_PROC(I)= JOTOFF(LEN_F+1)
         LI= I*NOINT
         DO 120 L=1,LEN-1
              IF( INPREV(L+1).GE.LI) GO TO 130
  120    CONTINUE
  130    LEN_F= L
         IF( I.EQ.NPROCS) THEN
              LEN_FIN(I) = LEN
         ELSE
              LEN_FIN(I) = LEN_F
         END IF
         IDINP= INPREV(L+1)-INOLD
C     write(JOUT,445) I,JM_PROC(I),JML_PROC(I),
c    &            LEN_INI(I),LEN_FIN(I),IDINP
445   FORMAT('I =',i3,' JM_PROC= ',i5,' JML_PROC= ',i5,
     &   ' LEN_INI=',i3,' LEN_FIN= ',i3,' No INT=',i5)
      INOLD = INPREV(L+1)
  110 CONTINUE

      RETURN
      END
      SUBROUTINE CAL14
C
C THIS VERSION IS FOR GENERATION OF THE INTERACTION ARRAY
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.KASOS'
      LOGICAL LJUMP
      KFIN_OLD=KFIN
      NEXKST=0
10    IF(ICUTOFF.EQ.2.AND.KASO.EQ.0) THEN
         CALL LOOK_BLCK(JM,KSTRT,KFIN,NEXKST,LJUMP)
         IF(LJUMP) RETURN
      ENDIF
C******************************************************
C ORDER ON THE NEXT LINES IS IMPORTANT!      DR   NOV93
      LNUM=4
      CALL PREP
      JMLAST=JM
      KMLAST=KFIN
      LNUMS=4
C******************************************************
      IF(ICUTOFF.EQ.2.AND.KASO.EQ.0) THEN
         KSTRT=NEXKST
         KFIN= KFIN_OLD
         GOTO 10
      ENDIF
      RETURN
      END
      SUBROUTINE CAL15
C
C THIS VERSION IS FOR GENERATION OF THE INTERACTION ARRAY
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.KASOS'
      LOGICAL LJUMP
      KFIN_OLD=KFIN
      NEXKST=0
10    IF(ICUTOFF.EQ.2.AND.KASO.EQ.0) THEN
         CALL LOOK_BLCK(JM,KSTRT,KFIN,NEXKST,LJUMP)
         IF(LJUMP) RETURN
      ENDIF
C******************************************************
C ORDER ON THE NEXT LINES IS IMPORTANT!      DR   NOV93
      LNUM=5
      CALL PREP
      JMLAST=JM
      KMLAST=KFIN
      LNUMS=5
C******************************************************
      IF(ICUTOFF.EQ.2.AND.KASO.EQ.0) THEN
         KSTRT=NEXKST
         KFIN= KFIN_OLD
         GOTO 10
      ENDIF
      RETURN
      END
      SUBROUTINE CBOXL
C
C THIS SUBROUTINE SETS UP THE ARRAYS KSC14, KFC14, AND KSC15,
C WHICH WILL BE USED IN SUBROUTINE ADJOXL TO CALCULATE THE
C 1-4 AND 1-5 INTERACTIONS BETWEEN THE LAST FULL RESIDUE AND THE
C CARBOXYL END GROUP
C CBOXL IS CALLED IN SPECV
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CARB'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.PUT14'
      INCLUDE 'COMMON.PUT15'
      INCLUDE 'COMMON.TOR2'
      LOGICAL LPROLIN
C
C IF THERE IS NO CARBOXYL END GROUP, RETURN
      IF(KCARB.EQ.20) RETURN
C
C DEFINE VARIABLES
      NPREIK=NPRE(INUMRS)
      JFIN=NPREIK-NPRE(INUMRS-1)
      LISTIJ=LIST(INUMRS-1)
      LISTIJ=IABS(LISTIJ)
      KINDIJ=KNDRES(LISTIJ)
      KINDIJ=IABS(KINDIJ)
      JPRO=0
      IF(LPROLIN(INUMRS-1)) JPRO=1
C
C STEP J
C
      DO 3 J=1,JFIN
C
C IS J A BACKBONE ATOM?
      IF(J.LE.7) GO TO 2
C
C IS J A SIDECHAIN ATOM AND PART OF THE PROLINE RING?
      IF(JPRO.EQ.1.AND.J.NE.15) GO TO 1
C
C THE FOLLOWING SECTION IS FOR J A SIDECHAIN ATOM BUT NOT PART
C OF THE PROLINE RING
C
      KSC14(J)=NPREIK
      KFC14(J)=NPREIK
      KSC15(J)=1+NPREIK
      GO TO 3
C
C PROLINE RING
C THE FOLLOWING SECTION IS FOR J A SIDECHAIN ATOM
C BUT PART OF A PROLINE RING
C
 1    KSC14(J)=MSX14(1,LCARB)+NPREIK
      KFC14(J)=MFX14(1,LCARB)+NPREIK
      KSC15(J)=MSX15(1,LCARB)+NPREIK
      GO TO 3
C
C BACKBONE
C THE FOLLOWING SECTION IS FOR J LESS THAN 7, I. E., J
C IS A BACKBONE ATOM
C
C IF J IS THE C2 OF A PROLINE, THEN IT ALSO BELONGS TO THE
C PROLINE RING
 2    IF(JPRO.EQ.1.AND.J.EQ.2) GO TO 1
      KSC14(J)=MSX14(J,LCARB)+NPREIK
      KFC14(J)=MFX14(J,LCARB)+NPREIK
      KSC15(J)=MSX15(J,LCARB)+NPREIK
C
C END OF LOOP
 3    CONTINUE
      RETURN
      END
      subroutine bridge_hyd(jm1,km)
c
c   This subroutine calculates the contribution of the 1-4 interactions
c   from a bridge (i.e., where the bridge is between atoms 2 and 3 in
c   1 -- 2 -- 3 -- 4), since this interaction is not treated in CALCFPO.
c                                           6-13-96  jda
c
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.DERIV'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.SOLVAT'
      DOUBLE PRECISION CX,CY,CZ
      ii = ictsol(jm1)
      jj = ictsol(km)
      locat = ioltec(ii) + 8*(jj - ii - 1)
      X1 = COORD(1,KM) - COORD(1,JM1)
      X2 = COORD(2,KM) - COORD(2,JM1)
      X3 = COORD(3,KM) - COORD(3,JM1)
      R2JK = X1*X1 + X2*X2 + X3*X3
      A1 = sconst(locat+1)*exp(sconst(locat+2)*r2jk)
      A2 = sconst(locat+3)*exp(sconst(locat+4)*r2jk)
      A3 = sconst(locat+5)*exp(sconst(locat+6)*r2jk)
      A4 = sconst(locat+7)*exp(sconst(locat+8)*r2jk)
cj the energy of hydration
      EHYDA = EHYDA + (A1 + A2 + A3 + A4) * WGHSUR
cj the cartesian derivatives
      if (surder) then
         JMOFF=3*(JM1-1)
         KMOFF=3*(KM-1)
         HDER = -2.0*(sconst(locat+2)*A1 + sconst(locat+4)*A2
     1     + sconst(locat+6)*A3 + sconst(locat+8)*A4)*WGHSUR
cj
cj   minus sign is used to be consistent with calcfpo.F
cj
         CX = X1 * HDER
         CY = X2 * HDER
         CZ = X3 * HDER
         CGX(KMOFF+1,ICG) = CGX(KMOFF+1,ICG) - CX
         CGX(KMOFF+2,ICG) = CGX(KMOFF+2,ICG) - CY
         CGX(KMOFF+3,ICG) = CGX(KMOFF+3,ICG) - CZ
         CGX(JMOFF+1,ICG) = CX + CGX(JMOFF+1,ICG)
         CGX(JMOFF+2,ICG) = CY + CGX(JMOFF+2,ICG)
         CGX(JMOFF+3,ICG) = CZ + CGX(JMOFF+3,ICG)
      endif
      return
      end
      SUBROUTINE ENEBRIDGE
C
C THIS SUBROUTINE COMPUTES THE INTERNAL ENERGY OF A BRIDGE. THAT IS 
C THE HARMONIC TERMS AND THE TORSIONAL TERMS ASSOCIATED WITH THE 
C "IMPLICIT" TORSIONAL ANGLES. ADAPTED FROM THE OLD ECEPP SSBRIJ 
C ROUTINE, GENERALIZED TO HANDLE ANY TYPE OF BRIDGE, INCLUDING 
C CYCLIZED BACKBONE.
C
C AS OF 8/3/93
C
cj volume hydration contribution added.    6/13/96 jda  
      DOUBLE PRECISION DUK,ESAVE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.TORPX'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TOR'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.CNTRL'
      COMMON/DIVH/CPSI,DS(3),DT(3),DU(3),DV(3)
      DIMENSION A1(3),B1(3),S1(3),C1(3),DD1(3),
     & A2(3),B2(3),S2(3),C2(3),DD2(3)
      dimension idi(2,3)

      logical lprnt
C     lprnt=.true.    ! for debugging
      lprnt=.false.

C LOOP OVER BRIDGES.
      ELOOP = 0.0
      ETORBR= 0.0 
      DO IBRIDGE=1,NLOOP
      IJ=NPAIR(1,IBRIDGE)
      IK=NPAIR(2,IBRIDGE)
      LISTIJ=IABS(LIST(IJ))
      LISTIK=IABS(LIST(IK))
      NPREIJ=NPRE(IJ)
      NPREIK=NPRE(IK)
      if (cyclic .and. ij.eq.1) then
        ik=inumrs
        npreik=npre(ik-1)
      endif
      ITB1=ITB(IBRIDGE,1)
      ITB2=ITB(IBRIDGE,2)
      II=ITB(IBRIDGE,3)
      IA1=NPREIJ+IBRID(1,ITB1)
      IB1=NPREIJ+IBRID(2,ITB1)
      IS1=NPREIJ+IBRID(3,ITB1)
      IC1=IBRID(4,ITB1)
      IF (IC1.NE.0) IC1=IC1+NPREIJ
      ID1=IBRID(5,ITB1)
      IF (ID1.NE.0) ID1=ID1+NPREIJ
      IF (.NOT. CYCLIC .OR. IK.NE.INUMRS) THEN
        IA2=NPREIK+IBRID(1,ITB2)
        IB2=NPREIK+IBRID(2,ITB2)
        IS2=NPREIK+IBRID(3,ITB2)
        IC2=IBRID(4,ITB2)
        IF (IC2.NE.0) IC2=IC2+NPREIK
        ID2=IBRID(5,ITB2) 
        IF (ID2.GT.0) ID2=ID2+NPREIK
      ELSE
        IA2=NPREIK+IABS(IBRID(1,ITB2))
        IB2=NPREIK+IABS(IBRID(2,ITB2))
        IS2=NPREIK+IABS(IBRID(3,ITB2))
        IC2=IABS(IBRID(4,ITB2))
        IF (IC2.NE.0) IC2=IC2+NPREIK
        ID2=IABS(IBRID(5,ITB2))
        IF (ID2.NE.0) ID2=ID2+NPREIK
      ENDIF
      idi(1,1)=ib1
      idi(1,2)=ic1
      idi(1,3)=id1
      idi(2,1)=ib2
      idi(2,2)=ic2
      idi(2,3)=id2
      if (lprnt) 
     &WRITE(jout,*) 'IBRIDJ=',IBRID(1,ITB1),IBRID(2,ITB1),IBRID(3,ITB1)
      if (lprnt) 
     &WRITE(jout,*) 'IBRIDK=',IBRID(1,ITB2),IBRID(2,ITB2),IBRID(3,ITB2)
      R01=R0B(1,II)
      R02=R0B(2,II)
      R03=R0B(3,II)
      R04=R0B(4,II)
      R05=R0B(5,II)
      R06=R0B(6,II)
      R07=R0B(7,II)
      AK1=CONB(1,II)
      AK2=CONB(2,II)
      AK3=CONB(3,II)
      AK4=CONB(4,II)
      AK5=CONB(5,II)
      AK6=CONB(6,II)
      AK7=CONB(7,II)
      impropi1=improp(1,ii)
      impropi2=improp(2,ii)
      arim1=arim(1,ii)
      arim2=arim(2,ii)
      if (itb2.lt.itb1) then
	call exchr(arim1,arim2)
	call exch(impropi1,impropi2)
        call exchr(r02,r03)
        call exchr(r04,r05)
        call exchr(r06,r07)
        call exchr(ak2,ak3)
        call exchr(ak4,ak5)
        call exchr(ak6,ak7)
      endif
      AROB=ARB(II)
      NBBT=NBBB(II)
      if (lprnt) WRITE(jout,*) 'II=',II,' ITB1=',ITB1,' ITB2=',ITB2
      if (lprnt) WRITE(jout,*) 'IA1=',IA1,' IB1=',IB1,' IS1=',IS1
      if (lprnt) WRITE(jout,*) 'IC1=',IC1,' ID1=',ID1
      if (lprnt) WRITE(jout,*) 'IA2=',IA2,' IB2=',IB2,' IS2=',IS2
      if (lprnt) WRITE(jout,*) 'IC2=',IC2,' ID2=',ID2
      if (lprnt) WRITE(jout,*) 'R01=',R01,' R02=',R02,' R03=',
     & R03,' R04=',R04,' R05=',R05,' R06=',R06,' R07=',R07
      if (lprnt) WRITE(jout,*) 'AK1=',AK1,' AK2=',AK2,' AK3=',
     & AK3,' AK4=',AK4,' AK5=',AK5,' AK6=',AK6,' AK7=',AK7
      if (lprnt) write (jout,*) 'IMPROPI1=',IMPROPI1,' ARIM1=',ARIM1,
     & ' IMPROPI2=',IMPROPI2,' ARIM2=',ARIM2
      DO 110 L=1,3                                                      
      A1(L)=COORD(L,IA1)                                                
      B1(L)=COORD(L,IB1)                                                
      S1(L)=COORD(L,IS1)                                                
      A2(L)=COORD(L,IA2)                                                
      B2(L)=COORD(L,IB2)                                                
      S2(L)=COORD(L,IS2)                                                
  110 CONTINUE                                                          
      ESAVE=ELOOP                                                       
      D1=DST(S1,S2)                                                     
C     ELOOP=ELOOP+100.*(D1-R01)**2                                      
      ELOOP=ELOOP+AK1*(D1-R01)**2
C     ARO=200.0                                                         
      ARO=2.0*AK1
      if (lprnt) WRITE(jout,*) 'D1=',D1,' R01=',R01,
     &         ' ELOOP=',AK1*(D1-R01)**2
C WHEN THE VALUE OF THE GRADIENT IS REQUIRED, SUBROUTINE                
C  SSGR IS CALLED.  SSGR COMPUTES CONTRIBUTIONS TO THE                  
C   ENERGY GRADIENT ASSOCIATED WITH THE LOOP CLOSING                    
C   POTENTIAL .                                                         
      CALL SSGR(S1,S2,R01,D1,ARO,IS1,IS2)                
      D2=DST(B1,S2)                                                     
C     ELOOP=ELOOP+100.*(D2-R02)**2                                      
      ELOOP=ELOOP+AK2*(D2-R02)**2
      if (lprnt)WRITE (jout,*) 'D2=',D2,' R02=',R02,
     &         ' ELOOP=',AK2*(D2-R02)**2
      ARO=2.0*AK2
      CALL SSGR(B1,S2,R02,D2,ARO,IB1,IS2)                
      D3=DST(S1,B2)                                                     
C     ELOOP=ELOOP+100.*(D3-R03)**2                                      
      ELOOP=ELOOP+AK3*(D3-R03)**2
      if (lprnt)WRITE (jout,*) 'D3=',D3,' R03=',R03,
     &         ' ELOOP=',AK3*(D3-R03)**2
      ARO=2.0*AK3
      CALL SSGR(S1,B2,R03,D3,ARO,IS1,IB2)                
      IF (IC1.GT.0) THEN
        DO L=1,3
          C1(L)=COORD(L,IC1)
        ENDDO
        D4=DST(C1,S2)                                                     
        ELOOP=ELOOP+AK4*(D4-R04)**2
        if (lprnt)WRITE (jout,*) 'D4=',D4,' R04=',R04,
     &         ' ELOOP=',AK4*(D4-R04)**2
        ARO=2.0*AK4
        CALL SSGR(C1,S2,R04,D4,ARO,IC1,IS2)                
      ENDIF
      IF (IC2.GT.0) THEN
        DO L=1,3
          C2(L)=COORD(L,IC2)
        ENDDO
        D5=DST(C2,S1)                                                     
        ELOOP=ELOOP+AK5*(D5-R05)**2
        if (lprnt)WRITE (jout,*) 'D5=',D5,' R05=',R05,
     &      ' ELOOP=',AK5*(D5-R05)**2
        ARO=2.0*AK5
        CALL SSGR(S1,C2,R05,D5,ARO,IS1,IC2)                
      ENDIF
      IF (ID1.GT.0) THEN
        DO L=1,3
          DD1(L)=COORD(L,ID1)
        ENDDO
        D6=DST(DD1,S2)                                                     
        ELOOP=ELOOP+AK6*(D6-R06)**2
CD      WRITE (16,*) 'D6=',D6,' R06=',R06,' ELOOP=',AK6*(D6-R06)**2
        ARO=2.0*AK6
        CALL SSGR(DD1,S2,R06,D6,ARO,ID1,IS2)                
      ENDIF
      IF (ID2.GT.0) THEN
        DO L=1,3
          DD2(L)=COORD(L,ID2)
        ENDDO
        D7=DST(DD2,S1)                                                     
        ELOOP=ELOOP+AK7*(D7-R07)**2
CD      WRITE (16,*) 'D7=',D7,' R07=',R07,' ELOOP=',AK7*(D7-R07)**2
        ARO=2.0*AK7
        CALL SSGR(S1,DD2,R07,D7,ARO,IS1,ID2)                
      ENDIF
C     D4=DST(B1,B2)                                                     
C     ARO=2*AR(3,LISTIJ)                                                
C     UK=ARO*0.5*(D4-R04)*(D4-R04)                                      
C     CALL SSGR(B1,B2,R04,D4,ARO,IB1,IB2)                
C
C CHANGE 4/17/93: EXPLICIT TORSIONAL TERMS INCLUDED FOR BRIDGE ANGLES.
C
c Determine the number of torsions associated with a bridge (AL 12/28/94)
      nbond1=1
      if (ic1.gt.0) then
	nbond1=nbond1+1
        if (id1.gt.0) nbond1=nbond1+1
      endif
      nbond2=1
      if (ic2.gt.0) then
	nbond2=nbond2+1
        if (id2.gt.0) nbond2=nbond2+1
      endif
      nta=nbond1*nbond2
c Spread the torsional energy uniformly on all angles involved (AL 12/28/94).
      arob=arob/nta
      uk=0.0
      do ii=1,3
	idii=idi(1,ii)
	if (idii.gt.0) then
          do jj=1,3
	    idij=idi(2,jj)
            if (idij.gt.0) then
	      call dihv(coord(1,idii),s1,s2,coord(1,idij))
	      if (ii.eq.1 .and. jj.eq.1) CTORS(IBRIDGE)=CPSI
              uk=uk+enetor(cpsi,arob,nbbt) 
      if (lprnt)WRITE (jout,*) 'AROB=',AROB,' NBBT=',NBBT,' CPSI=',
     &    CPSI,' UK=',UK
              call calss(idii,is1,is2,idij,arob,nbbt)
            endif
          enddo
        endif
      enddo
C Calculate contributions from improper torsions, if any.
      if (ic1.gt.0 .and. id1.eq.0 .and. impropi1.gt.0) then
	call dihv(b1,s2,s1,c1)
	uk=uk+enetor(cpsi,arim1,impropi1)
        if (lprnt)WRITE (jout,*) 'ARIM1=',ARIM1,' IMPROPI1=',IMPROPI1,
     &    ' CPSI=',CPSI,' UK=',UK
        call calss(ib1,is2,is1,ic1,arim1,impropi1)
	call dihv(s2,b1,s1,c1)
	uk=uk+enetor(cpsi,arim1,impropi1)
        if (lprnt)WRITE (jout,*) 'ARIM1=',ARIM1,' IMPROPI1=',IMPROPI1,
     &    ' CPSI=',CPSI,' UK=',UK
         call calss(is2,ib1,is1,ic1,arim1,impropi1)
      endif
      if (ic2.gt.0 .and. id2.eq.0 .and. impropi2.gt.0) then
	call dihv(b2,s1,s2,c2)
	uk=uk+enetor(cpsi,arim2,impropi2)
        if (lprnt)WRITE (jout,*) 'ARIM2=',ARIM2,' IMPROPI2=',IMPROPI2,
     &    ' CPSI=',CPSI,' UK=',UK
        call calss(ib2,is1,is2,ic2,arim2,impropi2)
	call dihv(s1,b2,s2,c2)
	uk=uk+enetor(cpsi,arim2,impropi2)
        if (lprnt)WRITE (jout,*) 'ARIM2=',ARIM2,' IMPROPI2=',IMPROPI2,
     &    ' CPSI=',CPSI,' UK=',UK
        call calss(is1,ib2,is2,ic2,arim2,impropi2)
      endif
      if (lprnt)WRITE (jout,*) (B1(L),L=1,3)
      if (lprnt)WRITE (jout,*) (S1(L),L=1,3)
      if (lprnt)WRITE (jout,*) (B2(L),L=1,3)
      if (lprnt)WRITE (jout,*) (S2(L),L=1,3)
c     CALL DIHV(B1,S1,S2,B2)
c     UK=ENETOR(CPSI,AROB,NBBT) 
      DUK=UK                                                            
      ETORBR=ETORBR+DUK                                                 
c     CALL CALSS(IB1,IS1,IS2,IB2,AROB,NBBT)
CD    WRITE (16,*) 'LISTIJ=',LIST(IJ)
      IF (LIST(IJ).EQ.10) THEN
CD      WRITE (16,*) 'EXIT SSBRIJ'
        RETURN
      ENDIF
      IF (IJ.EQ.1 .OR. IJ.EQ.INUMRS) THEN
        NTORIJ=NTORN(LISTIJ)+1
        IMULTIJ=NBBN(NTORIJ,LISTIJ)
        AROIJ=NSSN(NTORIJ,LISTIJ)*AAN(NTORIJ,LISTIJ)
      ELSE
        NTORIJ=NTOR(LISTIJ)+1
        IMULTIJ=NBB(NTORIJ,LISTIJ)
        AROIJ=NSS(NTORIJ,LISTIJ)*AR(NTORIJ,LISTIJ)
      ENDIF
      CALL DIHV(A1,B1,S1,S2)                                            
C     UK2=AR(2,LISTIJ)*(1.+ CPSI*(4*CPSI*CPSI-3))                       
      UK2=ENETOR(CPSI,AROIJ,IMULTIJ)
      if (lprnt)WRITE (jout,*) 'IJ=',IJ,' LISTIJ=',LISTIJ,' NTORIJ='
     & ,NTORIJ,' IMULTIJ=',IMULTIJ,' AROIJ=',AROIJ,' UK2=',UK2
      DUK=UK2                                                           
      ETORBR=ETORBR+DUK                                                 
C     ARO=AR(2,LISTIJ)                                                  
C SUBROUTINE DIHV COMPUTES THE COSINE OF THE DIHEDRAL                   
C  ANGLES ASSOCIATED WITH THE LOOP CLOSING POTENTIAL                    
C   AS WELL AS THE COMPONENTS OF THE DERIVATIVE OF                      
C THE COSINE WITH RESPECT TO THE CARTESIAN COORDINATES                  
C OF THE ATOMS INVOLVED . THESE LAST INFORMATION WILL                   
C  BE USED BY SUBROUTINE CALSS                                          
      CALL CALSS(IA1,IB1,IS1,IS2,AROIJ,IMULTIJ) 
C SUBROUTINE CALSS CALCULATES THE CONTRIBUTION                          
C TO THE (CARTESIAN) GRADIENT OF THE TORSIONAL                          
C PART OF THE LOOP CLOSING POTENTIAL                                    
      CALL DIHV(S1,S2,B2,A2)                                            
      IF (IK.EQ.1 .OR. IK.EQ.INUMRS) THEN
        NTORIK=NTORN(LISTIK)+1
        IMULTIK=NBBN(NTORIK,LISTIK)
        AROIK=NSSN(NTORIK,LISTIK)*AAN(NTORIK,LISTIK)
      ELSE
        NTORIK=NTOR(LISTIK)+1
        IMULTIK=NBB(NTORIK,LISTIK)
        AROIK=NSS(NTORIK,LISTIK)*AR(NTORIK,LISTIK)
      ENDIF
C     UK2=AR(2,LISTIJ)*(1.0+CPSI*(4*CPSI*CPSI-3))                       
      UK2=ENETOR(CPSI,AROIK,IMULTIK)
      if (lprnt)WRITE (jout,*) 'IK=',IK,' LISTIK=',LISTIK,
     &' NTORIK=',NTORIK,' IMULTIK=',IMULTIK,' AROIK=',AROIK,' UK2=',UK2
      DUK=UK2                                                           
      ETORBR=ETORBR+DUK                                                 
      CALL CALSS(IS1,IS2,IB2,IA2,AROIK,IMULTIK)
cj
cj  now treat the hydration contribution for the 1-4 interactions
cj  which are treated here, not in CALCFPO.   6/13/96  jda
cj
      if(icomp(4) .eq. 5) then
         if(nstype(ib1) .ne. 0 .and. nstype(ib2) .ne. 0) then
            call bridge_hyd(ib1,ib2)
         endif
         if(nstype(ia1) .ne. 0 .and. nstype(is2) .ne. 0) then
            call bridge_hyd(ia1,is2)
         endif
         if(nstype(is1) .ne. 0 .and. nstype(ia2) .ne. 0) then
            call bridge_hyd(is1,ia2)
         endif
      endif
      ENDDO
      RETURN
  100 FORMAT (/39H GEOMETRY AND ENERGIES FOR CYSTINE PAIR,I4,1X,I3)
  200 FORMAT (/28X,8HDISTANCE/8X,5HATOMS,14X,11H(ANGSTROMS))
  300 FORMAT (/5X,8HSG1  SG2,12X,F11.3/5X,8HCB1  SG2,12X,F11.3/
     1 5X,8HSG1  CB2,12X,F11.3/5X,8HCB1  CB2,12X,F11.3)
  400 FORMAT (/27X,10HBOND ANGLE/28X,9H(DEGREES))
  500 FORMAT (/5X,13HCB1  SG1  SG2,10X,F8.3/5X,13HSG1  SG2  CB2,
     1 10X,F8.3)
  600 FORMAT (/25X,14HDIHEDRAL ANGLE,6X,16HTORSIONAL ENERGY/
     1 28X,9H(DEGREES),11X,11H(KCAL/MOLE))
  700 FORMAT (/5X,18HCB1  SG1  SG2  CB2,5X,F8.3,12X,F8.3
     1        /5X,18HCA1  CB1  SG1  SG2,5X,F8.3,12X,F8.3,
     2        /5X,18HSG1  SG2  CB2  CA2,5X,F8.3,12X,F8.3)
  800 FORMAT (/5X,47HLOOP-CLOSING ENERGY FOR THIS PAIR (KCAL/MOLE) =,
     1 E12.5)
      END
      FUNCTION ENETOR(CPSI,ARO,IMULT)
      IF (IMULT.EQ.1) THEN
        ENETOR=ARO*(1.0+CPSI)
      ELSEIF (IMULT.EQ.2) THEN
        ENETOR=2.0*ARO*CPSI*CPSI
      ELSEIF (IMULT.EQ.3) THEN
        ENETOR=ARO*(1.0+CPSI*(4*CPSI*CPSI-3))
      ELSE
        ENETOR=0.0
      ENDIF
      RETURN
      END
      SUBROUTINE GENITER
C THIS SUBROUTINE GENERATES THE INTERACTION ARRAY.   DR  OCT28-93
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.IOUNIT'

C******************************************************
C ORDER ON THE NEXT LINES IS IMPORTANT!      DR   NOV93
      LNUMS=0
      IOFF=0
      I4RUN=0
      I5RUN=0
      JMLAST=0
      KMLAST=0
      LEN=1
      NATM=NPRE(INUMRS+1)
      CALL INIT_INT_TABLE
      LNUM=4
      CALL PREP
      INTER(1,LEN)=-1
      INTER(2,LEN)=0
      INTER(3,LEN)=0
C NOW DIVIDE THE INTERACCTION ARRAY EVENLY AMONG PROCESSORS
C FOR PARALLEL (FINE GRANULARITY).
      CALL CALINT
C********************************************************** 
      RETURN
      END
      INTEGER FUNCTION INBRID(LISTI)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.BRIDGES'
      DO I=1,NRB
        IF (NBRID(I).EQ.LISTI) THEN 
          INBRID=I
          RETURN
        ENDIF
      ENDDO
      INBRID=0
      RETURN
      END
      SUBROUTINE INIT_BRIDGE
C                                                           
C This subroutine checks to see if the polypeptide chain   
C contains at least two half-residues.  if so it  
C processes the bridge information that has been read in the READ_BRIDGE
C subroutine.
C Code taken from AL's RDCYS modiefied on 4/16/93 to handle all types of bridge.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.THRLET'
      character*3 res1,res2
      LASTFL=INUMRS-1                                                   
      NHALF=0                                                           
      NCYS=0
      DO 1 I=1,INUMRS
      LISTI=LIST(I)                                                     
      LISTI=IABS(LISTI)                                                 
      if (i.eq.1 .or. i.eq.inumrs) listi=listi+num_restypes
c     write(*,*) 'listi, inbrid(listi)' , listi, inbrid(listi)
      if (inbrid(listi).eq.0) goto 1
      NHALF=NHALF+1                                                     
 1    CONTINUE                                                          
      ncys=nhalf/2
      if (ncys*2.ne.nhalf) then
        write (jprint,'(2a)') 
     & 'Error in INIT_BRIDGE: the sequence has an odd number of',
     & ' bridging residues.'
        stop
      endif
      if (nhalf.ne.nloop) then
        write (jprint,'(a,i4,a/a,i4,2a)') 
     & 'Error in INIT_BRIDGE: ',nhalf,' bridging residues have been ',
     & 'found in the sequence but',nloop,' have been read in',
     & ' READ_BRIDGE.'
        stop
      endif
   2  if (ncys.eq.0)  return                                            
      write (jprint,210)
      do i=1,ncys
        if (npair(1,i).gt.npair(2,i)) call exch(npair(1,i),npair(2,i))
        if (npair(1,i).eq.npair(2,i)) then 
          write (jprint,*) 'Error - cannot bridge a single residue.'
          stop
        endif
        listi=iabs(list(npair(1,i)))
        listj=iabs(list(npair(2,i)))
        if (npair(1,i).eq.1 .or. npair(1,i).eq.inumrs) listi=listi+
     &   num_restypes
        if (npair(2,i).eq.1 .or. npair(2,i).eq.inumrs) listj=listj+
     &   num_restypes
c       call pdbres(listi,res1)
        res1=ares(listi)
c       call pdbres(listj,res2)
        res2=ares(listj)
        np1=inbrid(listi)
        np2=inbrid(listj)
        if (np1.eq.0 .or. np2.eq.0) then
          write (jprint,220) res1,npair(1,i),res2,npair(2,i)
          stop
        endif
        ii=icant(np1,np2)
        if (r0b(1,ii)*r0b(2,ii)*r0b(3,ii).eq.0) then
          write (jprint,230) res1,npair(1,i),res2,npair(2,i)
          stop
        endif
        itb(i,1)=np1
        itb(i,2)=np2
        itb(i,3)=ii
	if (np1.le.np2) then
	  iom_flag(1,i)=iiomeg(1,ii)
	  iom_flag(2,i)=iiomeg(2,ii)
        else
	  iom_flag(1,i)=iiomeg(2,ii)
	  iom_flag(2,i)=iiomeg(1,ii)
        endif
C       write (jprint,*) 'i=',i,' np1=',np1,' np2=',np2,' iom_flag:',
C    &    iom_flag(1,i),iom_flag(2,i)
        write (jprint,240) res1,npair(1,i),res2,npair(2,i),
     &        (r0b(k,ii),k=1,3),(conb(k,ii),k=1,3)
      enddo
      nloop=ncys
      RETURN       
 210  format(/'The following bridges exist in the chain:'/
     & '     Residues         R01     R02     R03',
     & '      K1      K2      K3')
 220  format(//'Error - residues ',A3,'(',I3,') and ',A3,'(',I3,')',
     & ' cannot form a bridge.')
 230  format(//'Error - constants missing for the bridge formed by ',
     &  A3,'(',I3,') and ',A3,'(',I3,')')
 240  format(A3,'(',I3,')-',A3,'(',I3,')',6f8.3)
      END 
      SUBROUTINE INITOR (VAR)
C
C THE SUBROUTINE (1) CALCULATES THE INITIAL TORSIONAL ENERGY
C OF THE POLYPEPTIDE (BY CALLING TORTOT), (2) INITIALIZES THE
C TORSIONAL ARRAYS (A,NB,NS, AND IFTOR), (3) CALCULATES ETORS,
C THAT PART OF THE TOTAL TORSIONAL ENERGY WHICH DOES NOT VARY,
C AND (4) SETS THE VARIABLE ARRAYS INDXV AND VAR (SEE DEF'N
C OF VARIABLES).
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      DOUBLE PRECISION DUK
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.TOR'
      INCLUDE 'COMMON.TORPX'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.OMTOR'
      INCLUDE 'COMMON.IOUNIT'
      DIMENSION VAR (maxnum_var)
C
C CALL TORTOT TO CALCULATE THE TOTAL TORSIONAL ENERGY OF THE
C POLYPEPTIDE
C
      CALL TORTOT
      ETORS=0.0
      if (intor.NE.0) ETORS=ETOR
C
C IF THE USER HAS SPECIFIED NO VARIABLES, RETURN
C     WRITE (jout,*) 'Initor: Numvar=',Numvar
      IF(NUMVAR.EQ.0) RETURN
      LASTFL=INUMRS-1
      NDXTOT=0
      NUMVAT=0
C
C STEP RESIDUE
C
      DO 70 I=1,INUMRS
      NVR=NV(I)
cd    WRITE (jout,*) 'i',i,' nv',nv(i)
      IF(NVR.EQ.0) GO TO 70
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
C
C STEP VARIABLE
C
      DO 60 LL=1,NVR
      L=NUMVAT+LL
      NDX=NDXARR(LL,I)
      IFT=0
C
C IS I THE CARBOXYL END GROUP?
c CORRECTED            NOV/92           DR
      IF (I.EQ.INUMRS.AND.KCARB.EQ.(-18).AND.NDX.EQ.2) GO TO 25
      IF(I.EQ.INUMRS) GO TO 50
C
C IS I THE AMINO END GROUP?
      IF(I.NE.1) GO TO 10
C
C DOES THE VARIABLE IN QUESTION HAVE A TORSIONAL TERM?
C     IF(KAMIN.LT.0.AND.NDX.EQ.NANGN(LAMIN)) GO TO 20
C     GO TO 50
C Changes on 4/15/93 (AL) to handle N-terminal groups in a general manner.
      if (kamin.lt.0) then
        do ii=1,ntorn(lamin)
          if (ndx.eq.nangn(ii,lamin)) then
cd          WRITE (jout,*) 'ndx=',ndx,' ii=',ii
            a(l)=aan(ii,lamin)
            nb(l)=nbbn(ii,lamin)
            ns(l)=nssn(ii,lamin)
cd          write (jout,*) 'a=',a(l),' nb=',nb(l),' ns=',ns(l)
            ift=intor
            goto 50
           endif
        enddo
      endif
      goto 50
C
C SET TORSIONAL ARRAYS
C
C IS THE VARIABLE IN QUESTION AN OMEGA?
 10   IF(NDX.NE.3) GO TO 30
C
C IS I THE LAST FULL RESIDUE?
      IF(I.NE.LASTFL) GO TO 20
C
C DOES THE 3RD BACKBONE DIHEDRAL ANGLE OF THE LAST FULL
C RESIDUE HAVE A TORSIONAL TERM?
cd    WRITE (jout,*) 'LCARB',lcarb
      IF(KCARB.GE.0) GO TO 30
C     A(L)=AAN(LCARB)
C     NB(L)=NBBN(LCARB)
C     NS(L)=NSSN(LCARB)
C     IFT=1
C     GO TO 50
* Changes on 4/15/93 (AL) to handle C-terminal residues in a general manner.
cd    WRITE (jout,*) 'ntorn(lcarb)=',ntorn(lcarb)
      do ii=1,ntorn(lcarb)
        indkarb=nangn(ii,lcarb)
cd      WRITE (jout,*) 'ii=',ii,' nangn=',nangn(ii,lcarb),' ndx=',ndx,
cd   & ' indkarb=',indkarb
        if (ndx.eq.indkarb) then
          a(l)=aan(ii,lcarb)
          nb(l)=nbbn(ii,lcarb)
          ns(l)=nssn(ii,lcarb)
C         ift=1
          ift=intor
cd        WRITE (jout,*) 'a=',a(l),' nb=',nb(l),' ns=',ns(l)
          goto 50
         endif
      enddo
      goto 50
C
C OMEGA
C THIS SECTION COMPUTES THE OMEGA CONTRIBUTION TO THE TORSIONAL ENERGY.
 20   A(L)=10.0
      NB(L)=2
      NS(L)=-1
C     IFT=1
      ift=intor
C June 1993. Omega can now be forced to assume a value close to 180.
      if (omcon) then
        a(l)=forcon
        nb(l)=1
        ns(l)=1
      endif
      GO TO 50
C
C  SIDECHAIN TORSIONAL FOR ETHYL ESTER ENDGROUP
C
  25  A(L) = 1.35
      NB(L) = 3
      NS(L) = 1
C     IFT = 1
      ift=intor
C
C SIDECHAIN
C
C IS THE VARIABLE IN QUESTION A BACKBONE DIHEDRAL ANGLE
C OR A CHI?
  30  IF (NDX.LT.4) GO TO 50
      KINDI=KNDRES(LISTI)
C
C DOES THE RESIDUE IN QUESTION HAVE A SIDECHAIN TORSIONAL TERM?
      IF(KINDI.GE.0) GO TO 50
      NKT=NTOR(LISTI)
      IF (KINDI.EQ.(-3)) NKT=1
C     WRITE (jout,*) 'KINDI=',KINDI,' nkt',nkt
      DO 32 J=1,NKT
      NA=NANG(J,LISTI)
C
C IS THE SIDECHAIN VARIABLE IN QUESTION THE ONE WHICH HAS A
C TORSIONAL TERM?
      IF (NDX.NE.NA) GO TO 32
      A(L)=AR(J,LISTI)
      NB(L)=NBB(J,LISTI)
      NS(L)=NSS(J,LISTI)
C     IFT=1
      ift=intor
C     WRITE (jout,*) 'a=',a(l),' nb=',nb(l),' ns=',ns(l)
  32  CONTINUE
C
C SET VARIABLE ARRAYS
C
 50   NDX=NDX+NDXTOT
C
C SEE DEFINITION OF VARIABLES FOR AN EXPLANATION OF THE
C FOLLOWING ARRAYS.
      INDXV(L)=NDX
      VAR(L)=ANGLES(NDX)
      IFTOR(L)=IFT
C     WRITE (jout,*) 'ndx=',ndx,' ift=',ift
C
C DOES THE VARIABLE BEING CONSIDERED HAVE A TORSIONAL TERM?
      IF(IFT.EQ.0) GO TO 60
      DUK=UTOR(NDX)
      ETORS=ETORS-DUK
C     WRITE (jout,*) 'duk=',duk,' etors=',etors
C
C END OF VARIABLE LOOP
 60   CONTINUE
      NUMVAT=NUMVAT+NVR
C
C END OF RESIDUE LOOP
C70   NDXTOT=NDXTOT+10
 70   NDXTOT=NDXTOT+maxnum_dihe
C     WRITE (jout,'(2i4,f10.5,2i5)') (i,iftor(i),a(i),nb(i),ns(i),
C    & i=1,numvar)
      IF (NUMVAT.NE.NUMVAR)  THEN 
          WRITE (jout,*)
     & 'ERROR in INITOR; NUMVAR=', NUMVAT,' INSTEAD OF ', NUMVAR
      ENDIF
      RETURN
      END
      SUBROUTINE INT14
C
C THIS SUBROUTINE CALCULATES THE 1-4 INTERACTIONS BETWEEN ATOM J
C AND ALL APPROPRIATE ATOMS K IN THE SAME RESIDUE
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.PUT14'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.IOUNIT'
C     INCLUDE 'COMMON.DEBUG'
      LOGICAL LPRNT
      LOGICAL LPROLIN
      LOGICAL NMETHYL
      LOGICAL NSWITCH

      LPRNT=.FALSE.
C     lprnt=.true.
C     if(lprolin(ij)) lprnt=.true.
C     if(jm.eq.56) lprnt=.true.
C     write (jout,*) 'INT14'

      IF(IFEND.EQ.1) THEN
C THIS SECTION IS FOR CALCULATING THE INTRA-RESIDUE 1-4 INTER-
C ACTIONS FOR END GROUPS
        DO IINT=1,N14(J,LISTIJ)
          KSTRT=MSN14(J,LISTIJ,IINT)
          IF(KSTRT.EQ.0) RETURN
          KSTRT=KSTRT+NPREIJ
          KFIN=MFN14(J,LISTIJ,iint)+NPREIJ
C     write (jout,*) 'j=',j,' iint=',iint,' kstrt=',kstrt,' kfin=',kfin
          CALL CAL14
        ENDDO

      ELSE
C THIS SECTION CALCULATES THE INTRA-RESIDUE 1-4 INTERACTIONS
C FOR FULL RESIDUES
C
C       if(lprnt) write(jout,*)' INT14 with JM', JM 
        KSTRT=NSN14(J,LISTIJ)
        NJ= IABS(LISTIJ)
        IF(KSTRT.EQ.0) THEN
          IF ( (NMETHYL(IJ)).AND.(J.EQ.3) ) THEN
C  **************************************************************
C DONE ON FRIDAY AUGUST 13th, 1993.  IT SHOULD NOT WORK!!!!!!
C  Modified to include residues with N-methyl groups. 
C  Add the 1-4 interactions between the CA of residue IJ and the H
C  atoms on the N-methyl group.
            KSTRT=NPREIJ+LRT1(1,NJ)
            KFIN=NPREIJ+LRT1(1,NJ)+NUM(1,NJ)-1
            if(lprnt)write(jout,*) '1-4 CA j=',j,' kstrt=',kstrt,
     &                 ' kfin=',kfin
            CALL CAL14
           ENDIF
        ELSE
           KSTRT=KSTRT+NPREIJ
           KFIN=NFN14(J,LISTIJ)+NPREIJ
           CALL CAL14
C  **************************************************************
C DONE ON FRIDAY AUGUST 13th, 1993.  IT SHOULD NOT WORK!!!!!!
C  Modified to include residues with N-methyl groups. 
C  Add the 1-4 interactions between the CA of residue IJ and the H
C  atoms on the N-methyl group.
           IF ( (NMETHYL(IJ)).AND.(J.EQ.3) ) THEN
              KSTRT=NPREIJ+LRT1(1,NJ)
              KFIN=NPREIJ+LRT1(1,NJ)+NUM(1,NJ)-1
              if(lprnt)write(jout,*) '1-4 CA j=',j,
     &                 ' kstrt=',kstrt,' kfin=',kfin
              CALL CAL14
           ELSE IF ( NSWITCH(IJ) ) THEN
C Residues 42 and 43 are SXRAYIN1 and SLLXRAYIN of Gal. SEP-1-93
C explicit interactions between atoms 1 & 4 with 17 
C and atom 2 with 8 to 16 should be computed.
C (interaction between 5 and 7 is computed later on in this 
C routine).
              IF ( J.EQ.1 .OR. J.EQ.4 ) THEN
                 KSTRT= 17+NPREIJ
                 KFIN = 17+NPREIJ
                 CALL CAL14
              ELSE IF ( J.EQ.2 ) THEN
                 KSTRT= 8+NPREIJ
                 KFIN =16+NPREIJ
                 CALL CAL14
              ENDIF
           END IF
        ENDIF
C  **************************************************************
        IF(KINDIJ.EQ.22.AND.J.LE.5) THEN
C IF THE RESIDUE IS A HYDROXYPROLINE, THE HD1(K=15) MUST BE EXPLICITLY
C CALCULATED FOR ATOMS 1-5
           KSTRT=15+NPREIJ
           KFIN=KSTRT
           CALL CAL14
        ELSE IF (KINDIJ.EQ.75.AND.((J.EQ.1).OR.(J.EQ.4)) ) THEN
C CALCULATE EXPLICITLY THE INTERACTION OF ATOMS 1 and 3 to 5 (atom 2 excluded 
C is  CD) WITH THE HE's OF DiMethyl-PROLINE WITHIN THE SAME RESIDUE. 
           KSTRT=15+NPREIJ
           KFIN=20+NPREIJ
        if(lprnt) write (jout,*) '1,4 kstrt=', kstrt,' kfin=',kfin
           CALL CAL14
        ENDIF

        IF(J.EQ.5) THEN
C THE INTERACTION BETWEEN ATOMS 5 AND 7 MUST BE EXPLICITLY
C CALCULATED
          KSTRT=7+NPREIJ
          KFIN=KSTRT
          CALL CAL14
        ENDIF
C     lprnt=.false.
      ENDIF
      RETURN
      END
      SUBROUTINE INT15
C  -Altered 11/91  to include residues with N-methyl groups.
C
C THIS SUBROUTINE CALCULATES THE 1-5 INTERACTIONS BETWEEN ATOM J
C AND ALL APPROPRIATE ATOMS K IN THE SAME RESIDUE
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.PUT15'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
C     INCLUDE 'COMMON.DEBUG'
      LOGICAL LPRNT
      LOGICAL LPROLIN
      LOGICAL NMETHYL

      lprnt=.false.
C     lprnt=.true.
C     if(lprolin(ij)) lprnt=.true.
C     if(jm.eq.27) lprnt=.true.

      if(lprnt) write(jout,*)' INT15 with JM', JM
C  **************************************************************
C  Modified to include N-methyl groups    D.R.  ^^^&&&& 11/91
      NT= IABS(LISTIJ)
      IF ((IFEND.EQ.0).AND.(NMETHYL(IJ)).AND.(J.LE.3)) THEN
      if (lprnt) write (jout,*) 'end-methyl residue '
C N-methylated full residues.
        KSTRT=NSN15(J,LISTIJ)
        IF(KSTRT.EQ.0) RETURN
        KSTRT=KSTRT+NPREIJ
        KFIN=NPREIJ+LRT1(1,NT)-1
      if (lprnt) write (jout,*) 'j<4 j=',j,
     $                ' kstrt=',kstrt,' kfin=',kfin,' jfin=',jfin,
     $                ' npreij=',npreij,' lrt1=',lrt1(1,nt)
        CALL CAL15
C Regular full residues.
      if (lprnt) write (jout,*)' Regular full residues '
      ELSE IF (IFEND.EQ.0) THEN
        KSTRT=NSN15(J,LISTIJ)
        IF(KSTRT.EQ.0) RETURN
        KSTRT=KSTRT+NPREIJ
        KFIN=JFIN+NPREIJ
      if (lprnt) write (jout,*) 'j=',j,
     $                ' kstrt=',kstrt,' kfin=',kfin,' jfin=',jfin
        CALL CAL15
      ELSE IF (IFEND.EQ.1) THEN
      if (lprnt) write (jout,*) 'end-group '
C End groups.
C Change 8/3/93 (AL) to handle the end groups in a general manner.
        DO IINT=1,N15(J,LISTIJ)
          KSTRT=MSN15(J,LISTIJ,IINT)
          IF(KSTRT.EQ.0) RETURN
          KSTRT=KSTRT+NPREIJ
          KFIN=MFN15(J,LISTIJ,IINT)
          IF (KFIN.EQ.0) KFIN=JFIN
          KFIN=KFIN+NPREIJ
      if (lprnt) write (jout,*) 'j=',j,' iint=',iint,' kstrt=',
     &       kstrt,' kfin=',kfin
          CALL CAL15
        ENDDO
      END IF
C  **************************************************************
C     lprnt=.false.
      RETURN
      END
      SUBROUTINE LOOK_BLCK(J,KSTRT,KFIN,NEXKST,LJUMP)
C THIS SUBROUTINE DETERMINES IF THE KM AND JM ATOMS BELONG TO 
C THE SAME FIXED BLOCK.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.BLOKA'
      INCLUDE 'COMMON.IOUNIT'
      LOGICAL LJUMP

      LJUMP= .FALSE.
      NOJ=NBLK(J)
C
C SET LJUMP TO TRUE (TERMINATION FLAG).
      IF(KFIN.LT.KSTRT) THEN 
        LJUMP= .TRUE.
        RETURN
      END IF

C     KSTRT_OLD=KSTRT
C
C DETERMINE NEW KSTRT IF ANY.
      DO 10 K=KSTRT,KFIN
        IF(NBLK(K).NE.NOJ) GOTO 20
10    CONTINUE
C     WRITE(JOUT,'(a,i5)')
C    &     'LOOK_BLCK : NO INTERACTIONS FOR JM= ',J
      LJUMP= .TRUE.
      RETURN

20    KSTRT=K
C     LKREM=K-1
C     WRITE(JOUT,'(3(a,i5))')
C    &'REMOVING INTS FOR JM= ',J,' with KM= ',KSTRT_OLD,' to ',LKREM 
C
      DO 30 K=KSTRT,KFIN
        IF(NBLK(K).EQ.NOJ) GOTO 40
30    CONTINUE
C   COMPUTE FROM THIS KSTRT UNTIL THE ORIGINAL KFIN.
      NEXKST=KFIN+1
      RETURN
C
C   THE ORIGINAL SET OF INTERACTIONS SHOULD BE SPLITTED.
40    KFIN=K-1
C  NEXKST  IS THE STARTING KM OF THE NEXT SET.
      NEXKST=K
      RETURN
      END
      SUBROUTINE PREP
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.IOUNIT'
C     INCLUDE 'COMMON.DEBUG'
      INTEGER JRUN,ISKIP
      INCLUDE 'COMMON.CALC'
      logical lprnt
      logical lprolin

C      lprnt=.true.
      lprnt=.false.
C     if(lprolin(ij)) lprnt=.true.
C     if(jm.gt.54.and. jm.lt.58) lprnt=.true.

C
C
      ISKIP=JM-JMLAST-1
      JRUN=KFIN-KSTRT+1
      if(lprnt)
     & write(jout,1004)0,LNUM,LNUMS,ISKIP,JRUN
1004  FORMAT( i4,'-  LNUM ',i4,' LNUMS ',i4,' ISKIP ',i4,' JRUN ',i4)
      IF (LNUM.EQ.4) GO TO 210
C
C THIS SECTION IS FOR 1-5'S 1-5'S 1-5'S 1-5'S 1-5'S 1-5'S 1-5'S 1-5'S
C
      IF (LNUMS.EQ.5) GO TO 110
      IF (LNUMS.EQ.0) GO TO 236
C
C THE LAST CALL WAS FROM CAL14
C
      IF (JM.NE.JMLAST) GO TO 100
      I5RUN=JRUN
      NEXT=KMLAST+1
      IF (KSTRT.NE.NEXT) GO TO 50
C     write(jout,*)' 1- JM,JMLAST,KSTRT,KFIN,LEN ',JM,JMLAST,KSTRT,KFIN,LEN
      if(lprnt)write(jout,1005) 1,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
1005  FORMAT( i1,'-  JM',i4,' JMLAST',i4,' KSTRT',i4,' KFIN',i4,
     & ' KMLAST',i4,' LEN',i4)
c     pause
      RETURN
C
C THE CURRENT RUN OF 1-5'S DOES NOT FOLLOW CONSECUTIVELY THE RUN OF
C 1-4'S FOR THIS JM.
C
   50 INTER(1,LEN)=IOFF
C     INTER(2,LEN)=8*I4RUN
      INTER(2,LEN)=I4RUN
      INTER(3,LEN)=0
      LEN=LEN+1
      IOFF=KSTRT-JM
      I4RUN=0
      if(lprnt)write(jout,1005) 2,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C
C THERE ARE NO 1-5'S FOR THE PREVIOUS JM AND (SO FAR) NO 1-4'S FOR THE
C CURRENT JM.
C
  100 KEY=0
      INTER(1,LEN)=IOFF
C      INTER(2,LEN)=8*I4RUN
      INTER(2,LEN)=I4RUN
      INTER(3,LEN)=KEY
      LEN=LEN+1
      IOFF=0
      I4RUN=0
      INTER(1,LEN)=IOFF
C      INTER(2,LEN)=8*I4RUN
      INTER(2,LEN)=I4RUN
      INTER(3,LEN)=KEY
      LEN=LEN+1
      GO TO 130
C
C THE LAST CALL WAS FROM CAL15
C
  110 IF (JM.NE.JMLAST) GO TO 120
      KSKIP=KSTRT-KMLAST-1
      IF (KSKIP.GT.0) GO TO 120
      I5RUN=I5RUN+JRUN
      if(lprnt)write(jout,1005) 3,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C
C THERE ARE NO 1-4'S FOR THE CURRENT ATOM JM
C
C OR 1-5'S FOR ATOM JM ARE NOT CONSECUTIVE.
C FIX TO BUG FOR DISULFIDE BRIDGES, SEPTEMBER 1979.
C
  120 KEY=I5RUN
      IF (KMLAST.EQ.NATM) KEY=JMLAST+IOFF+I4RUN-NATM-2
      INTER(1,LEN)=IOFF
C      INTER(2,LEN)=8*I4RUN
      INTER(2,LEN)=I4RUN
      INTER(3,LEN)=KEY
      LEN=LEN+1
C
C FIX TO BUG FOR CARBOXYL END GROUP -O OR -OH, AND
C FINAL RESIDUE LARGER THAN ALANINE. NOVEMBER 12, 1980.
C
      IF (KMLAST.EQ.NATM) GO TO 130
      IF (JM.EQ.JMLAST) GO TO 130
      INTER(1,LEN)=0
      INTER(2,LEN)=0
      INTER(3,LEN)=0
      LEN=LEN+1
C
  130 I4RUN=0
      I5RUN=JRUN
      IOFF=KSTRT-JM
      if(lprnt)write(jout,1005) 4,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C
C THIS SECTION IS FOR 1-4'S 1-4'S 1-4'S 1-4'S 1-4'S 1-4'S 1-4'S 1-4'S
C
  210 IF (LNUMS.EQ.4) GO TO 220
      IF (LNUMS.EQ.0) GO TO 235
C
C THE LAST CALL WAS FROM CAL15 SO PRINT OFFSET, LENGTH OF RUN, AND KEY.
C
      KEY=I5RUN
      IF (KMLAST.EQ.NATM) KEY=JMLAST+IOFF+I4RUN-NATM-2
      INTER(1,LEN)=IOFF
C      INTER(2,LEN)=8*I4RUN
      INTER(2,LEN)=I4RUN
      INTER(3,LEN)=KEY
      LEN=LEN+1
C
      IF (ISKIP.LE.0) GO TO 150
      DO 140 I=1,ISKIP
      INTER(1,LEN)=0
      INTER(2,LEN)=0
      INTER(3,LEN)=0
      LEN=LEN+1
  140 CONTINUE
      GO TO 160
  150 IF (KMLAST.EQ.NATM) GO TO 160
      IF (JM.EQ.JMLAST) GO TO 160
      INTER(1,LEN)=0
      INTER(2,LEN)=0
      INTER(3,LEN)=0
      LEN=LEN+1
C
  160 I4RUN=JRUN
      IOFF=KSTRT-JM
      if(lprnt)write(jout,1005) 5,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C
C THE LAST CALL WAS FROM CAL14
C
  220 KSUM=KMLAST+1
      IF (KSUM.NE.KSTRT) GO TO 230
      IF (JM.NE.JMLAST) GO TO 225
C
C THIS RUN FOLLOWS CONSECUTIVELY THE LAST 1-4 RUN
C
      I4RUN=I4RUN+JRUN
      if(lprnt)write(jout,1005) 6,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C
C FIX TO BUG FOR NULL CARBOXYL END GROUP.  NOVEMBER 13, 1980.
C THIS IS A NEW JM
C
  225 KEY=0
      INTER(1,LEN)=IOFF
C      INTER(2,LEN)=8*I4RUN
      INTER(2,LEN)=I4RUN
      INTER(3,LEN)=KEY
      LEN=LEN+1
C FIX TO SAME BUG FOR PRO AS THE LAST RESIDUE.        DR 1993
      IF (ISKIP.LE.0) GO TO 226
      DO 227 I=1,ISKIP
      INTER(1,LEN)=0
      INTER(2,LEN)=0
      INTER(3,LEN)=0
      LEN=LEN+1
  227 CONTINUE
  226 INTER(1,LEN)=0
      INTER(2,LEN)=0
      INTER(3,LEN)=0
      LEN=LEN+1
      IOFF=KSTRT-JM
      I4RUN=JRUN
      if(lprnt)write(jout,1005) 7,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C
C THIS 1-4 RUN DOES NOT FOLLOW CONSECUTIVELY THE LAST 1-4 RUN.
C
  230 KEY=0
      INTER(1,LEN)=IOFF
C      INTER(2,LEN)=8*I4RUN
      INTER(2,LEN)=I4RUN
      INTER(3,LEN)=KEY
      LEN=LEN+1
      IF (JM.NE.JMLAST) GO TO 240
  235 I4RUN=JRUN
      IOFF=KSTRT-JM
      if(lprnt)write(jout,1005) 8,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C CONSIDER THE CASE OF LNUM=5; LNUMS=0 (INITIAL ATOM 1-4 
C INTERACTIONS DO NOT EXIST).               DR       NOV93 
  236 I5RUN=JRUN
      IOFF=KSTRT-JM
      if(lprnt)write(jout,1005) 9,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C
C THIS IS A NEW ATOM JM, AND THE LAST JM HAD A 1-4 RUN NOT
C FOLLOWED BY 1-5'S.
C
  240 I4RUN=0
      IOFF=0
      ISKIP=ISKIP+1
      IF (JM.EQ.NATM) ISKIP=1
      DO 245 I=1,ISKIP
      INTER(1,LEN)=IOFF
C      INTER(2,LEN)=8*I4RUN
      INTER(2,LEN)=I4RUN
      INTER(3,LEN)=KEY
      LEN=LEN+1
  245 CONTINUE
      I4RUN=JRUN
      IOFF=KSTRT-JM
      if(lprnt)write(jout,1005)10,JM,JMLAST,KSTRT,KFIN,KMLAST,LEN
c     pause
      RETURN
C
C
  710 FORMAT (3I5)
      END
      SUBROUTINE PRO37
C
C THIS SUBROUTINE EXPLICITLY CALCULATES THE 1-4 AND 1-5
C INTERACTIONS BETWEEN J AND THE APPROPRIATE ATOMS OF
C RESIDUE IK=IJ+1 WHEN (1) J IS A C3 OR O7, AND (2) IK IS A
C PROLINE OR HYDROXYPROLINE
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CALC'
C
C FIRST CALCULATE THE 1-4 INTERACTIONS BETWEEN J AND THE ATOMS
C 2-6 AND 8-14 OF RESIDUE IJ+1
      KSTRT=2+NPREIK
      KFIN=6+NPREIK
      CALL CAL14
      KSTRT=8+NPREIK
      KFIN=14+NPREIK
      CALL CAL14
C NOW CALCULATE THE 1-5 INTERACTIONS BETWEEN J AND THE O7
C (AND HD1(K=15) IF HYDROXYPROLINE) OF RESIDUE IJ+1
      KSTRT=7+NPREIK
      KFIN=KSTRT
      CALL CAL15
C
C CALCULATE EXPLICITLY THE INTEREACTION BETWEEN ATOM J IN RESIDUE IJ AND
C THE HD1(K=15) OF THE HYDROXYPROLINE (RESIDUE IK=IJ+1)
C     IF (KINDIK.NE.22) RETURN
      IF (KINDIK.EQ.22) THEN
         KSTRT=15+NPREIK
         KFIN=KSTRT
         CALL CAL15
C CALCULATE EXPLICITLY THE INTEREACTION BETWEEN ATOM J IN RESIDUE IJ AND
C THE HE*(K=15  to 20) OF THE 5,5 DYMETHYLPROLINE (RESIDUE IK=IJ+1)
      ELSE IF(KINDIK.EQ.75) THEN
         KSTRT=15+NPREIK
         KFIN=20+NPREIK
         CALL CAL15
      ENDIF
      RETURN
      END
      SUBROUTINE SPECV(LICZ)
C
C THIS SUBROUTINE DETERMINES VARIABLE DIHEDRAL ANGLES BASED ON THE INFORMATION
C READ IN READ_SPEC
C
C IVARFLAG=
C 1 ("BACK") VARIES ALL BACKBONE DIHEDRAL ANGLES
C 2 ("SIDE") VARIES ALL SIDECHAIN DIHEDRAL ANGLES
C 3 ("ALL ") VARIES ALL DIHEDRAL ANGLES
C 4 ("SPEC") MEANS THE USER SPECIFIES EXPLICITLY VIA DATA CARDS WHICH
C       DIHEDRAL ANGLES HE WANTS TO VARY
C 5 ("NONE") MEANS THERE ARE NO VARIABLE DIHEDRAL ANGLES
C 6 ("PHPS") VARIES PHI-PSI DIHEDRAL ANGLES
C 7 ("BKSD") VARIES PHI, PSI AND CHI'S.
C
C This subroutine is the modified subroutine SPECV of old ECEPP.
C Variable-angle specification is read in READ_SPEC and passed
C as the integer variable IVARFLAG. IVARFLAG=1 thru 7 corresponds
C to the former KV1 thru KV7. In addition to variable-angle
C specification of old ECEPP we introduced the possibility of
C specifying the _residues_ with variable angles, while still
C specifying the variable dihedrals in a "general" manner that
C is "ALL", "SIDE", etc. If "SPEC" is specified (IVARFLAG=4),
C the variable angles are read in READ_SPEC and SPECV will only
C print their indices for information.
C
C 20 Nov 1984: The last omega is no longer a variable for BACK and BKSD.
C
C 29 Feb 1984: 1. BKSD option corrected so that NV for proline equals 1.
C ----------------------------------------------------------------------
C As of August 2, 1993
C ***
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
C     CHARACTER *4 KV,KV1,KV2,KV3,KV4,KV5, KV6, KV7
      INTEGER KV,KV1,KV2,KV3,KV4,KV5, KV6, KV7
      INCLUDE 'COMMON.CNTRL' 
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.KVS'
      INCLUDE 'COMMON.PICK'

      LOGICAL LPROLIN
      CHARACTER*4  QKV(7)/'BACK','SIDE','ALL ','SPEC','NONE',
     &   'PHPS', 'BKSD' /
      DATA KV1,KV2,KV3,KV4,KV5,KV6,KV7 /1,2,3,4,5,6,7/
C
C READ KV
C Change 8/2/93 DR & AL: The KV is now passed from READ_SPEC. 
      KV=IVARFLAG
      IF (LICZ.EQ.1) WRITE (JOUT,200) QKV(KV)
      IF ( (NVARRES.EQ.0) .AND. (KV.NE.5) ) THEN
C This is for QKV= BACK, SIDE, ALL, PHPS,BKSD.
        NVARRES=INUMRS
        DO I=1,INUMRS
          NUMVARRES(I)=I
        ENDDO
      ELSE IF (KV.NE.4) THEN
        IF (LICZ.EQ.1) WRITE (JOUT,201) ( NUMVARRES(K), K=1,NVARRES)
  201 FORMAT('For residues in the following list ' ,/,20i4)
      ENDIF
      IF (KV.EQ.4) THEN
C  If  kv = 4 ("SPEC" flag), then, the variables NUMVR0 and NV0 were 
C  already set in read_spec routine.                          DR NOV93.
C            IF (NUMVAR.EQ.0) THEN
        IF (NUMVR0.EQ.0) THEN
           WRITE (JOUT,'(2A/A)')
     &      'Error in SPEC: the card VAR_ANGLES=SPEC was ',
     &      'specified in $CNTRL , but ',
     &      'no $SPEC card seems to be present in the input data'
           stop 
        ELSE
C Pass the variables read to local variables of the processor. 
C Also check for inconsistencies in the definition of variables,e.g.
C defining a number of variables larger than the total number 
C of dihedral angles for the residue or a variable PHI in PRO residues.
C  MAR95
           NUMVAR = 0
           DO I=1,INUMRS
             LISTI=IABS(LIST(I))
             INDIG=NCHI(LISTI)+3
             IF(NV0(I).GT.INDIG) THEN
                NV(I)=INDIG
                WRITE(JOUT,'(2a,i4,/a)')'SPEC WARNING: The number of',
     &            'variables specified for residue',i,
     &          ' exceeds the total number of dihedral for the residue'
             ELSE
                NV(I)=NV0(I)
             ENDIF
             KK=0
             DO K=1,NV(I)
                IF(LPROLIN(I).AND. (NDXARR0(K,I).EQ.1) )THEN
                   WRITE(JOUT,'(a,i4,a)')'SPEC WARNING: proline  PHI(',
     &                          I,') was specified as a variable'
                   NV(I)=NV(I)-1
                   NUMVAR = NUMVAR+1
                ELSE
                   KK=KK+1
                   NDXARR(KK,I)= NDXARR0(K,I)
                ENDIF
             ENDDO
           ENDDO
        ENDIF
      ELSE
        NUMVAR=0
        DO I=1,INUMRS
          NV(I)=0
        ENDDO
      ENDIF
C
C SET VARIABLES USED BELOW
      LASTFL=INUMRS-1
      LAST1=INUMRS+1
      LAMIN=LIST(1)
      LCARB=LIST(INUMRS)
      KAMIN=KNDEND(LAMIN)
      KCARB=KNDEND(LCARB)
      JFLAG=0
      DO 5 I=2,LASTFL
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      KINDI=KNDRES(LISTI)
      KINDI=IABS(KINDI)
      IF (KINDI.EQ.22) JFLAG=1
      IF (JFLAG.EQ.1) GO TO 6
 5    CONTINUE
 6    IF (LICZ .EQ. 1) THEN
         IF (JFLAG.EQ.1) WRITE(JOUT,1600)
      END IF
C
C SUBROUTINES AMINO AND CBOXL ARE NOT NEEDED IN SPECV BUT
C ARE CALLED HERE FOR CONVENIENCE.  THEY MUST NOT BE CALLED
C BEFORE KAMIN AND KCARB ARE DEFINED ABOVE.
      CALL AMINO
      CALL CBOXL
C
      IF (KV.EQ.KV5) RETURN
      IF (KV.EQ.KV4) GO TO 40
      IF (KV.EQ.KV2) GO TO 20
      IF ( KV .EQ. KV1 ) GO TO 10
      IF ( KV .EQ. KV3 ) GO TO 10
      IF ( KV .EQ. KV6 ) GO TO 10
      IF ( KV .EQ. KV7 ) GO TO 10
C       UNRECOGNIZED OPTION.
      GO TO 44
C
C BACKBONE
C THIS SECTION IS FOR KV "BACK" OR "ALL "; I.E., ALL BACKBONE ANGLES ARE
C VARIED.  ALSO FOR KV "PHPS" or "BKSD".
C
C 1ST WE TAKE CARE OF THE NON-END GROUPS
C10   DO 14 I=2,LASTFL
 10   DO 14 II=1,NVARRES
      I=NUMVARRES(II)
      IF (I.EQ.1) GOTO 18 
      IF (I.EQ.INUMRS) GOTO 19 
      NV(I)=3
      IF ( KV .EQ. KV6 .OR. KV .EQ. KV7 ) NV(I) = 2
      NOPHI=0
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      KINDI=KNDRES(LISTI)
      KINDI=IABS(KINDI)
C     IF(KINDI.NE.13.AND.KINDI.NE.22) GO TO 12
C DR APR99        
      IF(LPROLIN(I)) THEN
         NOPHI=1
         NV(I)=2
         IF ( KV .EQ. KV6 .OR. KV .EQ. KV7 ) NV(I) = 1
      ENDIF  
 12   IF (I.NE.LASTFL) GO TO 121
      LISTN=LIST(INUMRS)
      KINDN=KNDEND(LISTN)
C     IF ( KV .EQ. KV6 .OR. KV .EQ. KV7 ) NV(I) = NV(I) + 1   
      IF (KINDN.NE.12.AND.KINDN.NE.20) GO TO 121
      NV(I)=NV(I) - 1
 121  NVR=NV(I)
      DO 13 L=1,NVR
 13   NDXARR(L,I)=L+NOPHI
      GOTO 14 
C
C NOW WE CONSIDER THE AMINO END
18    NDIHED=NBOND(LAMIN)
      NV(1)=NDIHED
      IF(NDIHED.EQ.0) GO TO 16
      DO 15 L=1,NDIHED
 15   NDXARR(L,1)=L
 16   CONTINUE
      GOTO 14
C
C NOW WE CONSIDER THE CARBOXYL END
19    NDIHED=NBOND(LCARB)-1
      IF(NDIHED.LE.0) GO TO 14
      NV(INUMRS)=NDIHED
      DO 17 L=1,NDIHED
 17   NDXARR(L,INUMRS)=L
 14   CONTINUE
      NUMVAR=1
C
C DOES THE USER WANT TO VARY ONLY THE BACKBONE DIHEDRAL ANGLES?
      IF ( KV .EQ. KV1 .OR. KV .EQ. KV6 ) RETURN
C
C SIDECHAIN
C THIS SECTION IS FOR KV "SIDE" OR "ALL "; I.E., ALL SIDECHAIN ANGLES
C ARE VARIED
C
C20   DO 22 I=2,LASTFL
 20   DO 22 II=1,NVARRES
      I=NUMVARRES(II)
      IF (I.EQ.1 .OR. I.EQ.INUMRS) GOTO 22
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      NUMCHI=NCHI(LISTI)
      IF(NUMCHI.EQ.0) GO TO 22
      NVBACK=NV(I)
      NV(I)=NVBACK+NUMCHI
      DO 21 L=1,NUMCHI
      LP=L+NVBACK
 21   NDXARR(LP,I)=L+3
 22   CONTINUE
      NUMVAR=1
C     RETURN
C
C USER SPECIFIES
C THIS SECTION IS USED WHEN THE READER WANTS TO SPECIFY THE ANGLES TO BE
C VARIED.  THE USER GIVES THE RESIDUE NUMBER, THE NUMBER OF VARIABLES IN
C THAT RESIDUE, AND THE ANGLES TO BE VARIED.
C  the following variables were already read in read_spec routine in this
C version.   DR NOV93.
C
C Uncomment the following line for printing of variable angles
40    CONTINUE
      IF (LICZ .EQ. 1 .AND. (KV.NE.3) ) THEN
         WRITE (JOUT,300)
      END IF
      DO 42 I=1,LAST1
      NVAR=NV(I)
      IF (NVAR.EQ.0) GOTO 42
      IF (LICZ .EQ. 1 .AND. (KV.NE.3) ) THEN
         WRITE(JOUT,500) I,NVAR,(NDXARR(K,I),K=1,NVAR)
      END IF
 42   CONTINUE
      RETURN
  44  WRITE (JOUT,700)
      STOP
  100 FORMAT (A4)
  200 FORMAT(/,'Angles to be treated as variables ' ,A4)
  300 FORMAT (/, ' Res.No.  ',' variables','   angles to be varied')
  400 FORMAT (16I5)
  500 FORMAT (I5,5X,I5,5X,12I5)
 1600 FORMAT(/,' The internal conformational energy of the fixed part ',
     1 'of the',/, ' hydroxyproline ring is not included in EPRO.' )
  700 FORMAT (/1X,'Illegal input data for variable KV as read in ',
     1 ' subroutine SPECV.' )
      END
      SUBROUTINE TORTOT
C
C THIS SUBROUTINE CALCULATES THE INITIAL TOTAL TORSIONAL ENERGY
C (ETOR) OF THE POLYPEPTIDE CHAIN.  IT STORES THE INDIVIDUAL
C TERMS IN ARRAY UTOR.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      DOUBLE PRECISION DUK
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.TOR'
      INCLUDE 'COMMON.TORPX'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.OMTOR'
      INCLUDE 'COMMON.IOUNIT'
C
      LASTFL=INUMRS-1
      ETOR=0.0D0
      IRES10=maxnum_dihe*INUMRS
      DO 10 L=1,IRES10
 10   UTOR(L)=0.0
C
C DO TORSIONAL TOTAL HERE, STARTING WITH THE END GROUPS
C
C DOES THE AMINO END GROUP HAVE A TORSIONAL TERM?
      IF (KAMIN.GE.0) GO TO 20
C calculate the torsional term for the dihedral angles of
C the amino end group (changes on 4/15/93)
      do ii=1,ntorn(lamin)
        iang=nangn(ii,lamin)
        enssn=float(nssn(ii,lamin))
        enbbn=float(nbbn(ii,lamin))
        uk=aan(ii,lamin)*(1.0+enssn*cos(enbbn*angles(iang)))
        utor(iang)=uk
        duk=uk
        etor=etor+duk
      enddo
C
C STEP FULL RESIDUES
C NOW WE CALCULATE THE NON-END GROUP CONTRIBUTIONS TO THE TORSIONAL
C ENERGY
 20   DO 50 I=2,LASTFL
      I10=maxnum_dihe*(I-1)
      IANG=I10+3
C
C 1ST CALCULATE OMEGA CONTRIBUTION
C
C THE THIRD BACKBONE ANGLE OF THE NEXT TO THE LAST RESIDUE
C WILL BE CONSIDERED LATER.
      IF(I.EQ.LASTFL) GO TO 30
      if (omcon) then
        uk=forcon*(1.0+cos(angles(iang)))
      else
        uk=10.*(1.-cos(2.*angles(iang)))
      endif
      UTOR(IANG)=UK
      DUK=UK
      ETOR=ETOR+DUK
 30   LISTI=LIST(I)
      LISTI=IABS(LISTI)
C
C ALL RESIDUES WITH THE EXCEPTION OF GLYCINE AND PROLINE MAKE
C SIDECHAIN CONTRIBUTIONS TO THE TORSIONAL ENERGY.  THESE SIDECHAIN
C TERMS (EXCEPT FOR THE SPECIAL CASE OF CYSTINE) ARE CALCULATED NOW.
C
      NKT=NTOR(LISTI)
      KINDI=KNDRES(LISTI)
C
C DOES THE ITH RESIDUE HAVE A SIDECHAIN TORSIONAL TERM?
C
      IF(KINDI.GE.0) GO TO 50
      IF (KINDI.EQ.(-3)) NKT=1
C     if (kindi.eq.(-3)) write (jout,'(a6,i3,a3,i3)')
C    &                            'kindi=',kindi,' nkt',nkt
      DO 31 J=1,NKT
C     if (kindi.eq.(-3)) write (jout,*)
C    &'I,J,LISTI,AR(J,LISTI)', I,J,LISTI,AR(J,LISTI)
      NA=NANG(J,LISTI)
      IANG=I10+NA
      ANG=ANGLES(IANG)
      ENSS=FLOAT(NSS(J,LISTI))
      ENBB=FLOAT(NBB(J,LISTI))
      UK=AR(J,LISTI)*(1.+ENSS*COS(ENBB*ANG))
      UTOR(IANG)=UK
      DUK=UK
      ETOR=ETOR+DUK
  31  CONTINUE
 50   CONTINUE
C
C DOES THE DIHEDRAL ANGLE BETWEEN THE LAST FULL RESIDUE AND
C THE CARBOXYL END GROUP HAVE A TORSIONAL TERM?
      IF(KCARB.GE.0) RETURN
C Change 4/15/93 to handle C-terminal groups in a general manner.
      do ii=1,ntorn(lcarb)
        iang=(inumrs-2)*maxnum_dihe+nangn(ii,lcarb)
        ang=angles(iang)
        enssn=float(nssn(ii,lcarb))
        enbbn=float(nbbn(ii,lcarb))
        uk=aan(ii,lcarb)*(1.+enssn*cos(enbbn*ang))
        utor(iang)=uk
        duk=uk
        etor=etor+duk
      enddo
  310 IF (KCARB.NE.(-18)) RETURN
      IANG=(INUMRS-1)*maxnum_dihe+2
      ANG=ANGLES(IANG)
      UK=1.35*(1.+COS(3.*ANG))
      UTOR(IANG)=UK
      DUK=UK
      ETOR=ETOR+DUK
      RETURN
      END
