      subroutine openunits
    
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.IOUNIT'
      include 'COMMON.FILES'
      character*64 inpf,outf,bndf,anaf,reff,runtyp,fname,rmsname(10)
      integer lenpre,ilen,ifile(10)
      EXTERNAL ILEN
#ifdef MP 
C     include '/usr/include/fexcp.h'
      include 'PARAMET.MP'
      include 'COMMON.MP'
      character*3 tasknu

      call numstr(taskid,tasknu)
      lentsk=ilen(tasknu)
#endif

      call getenv('RUNTYP',runtyp)
      call getenv('INPF',inpf)

      write(*,'(2a)')' RUNTYP is ',runtyp

C open main input
      lenpre=ilen(inpf)
      infile=inpf(:lenpre)//'.inp'
      fname=infile
      iii=jin
      write(*,'(a,i2,1x, a)')' opening unit ',iii, fname
#ifdef WINNT
      open (jin,file=infile,status='old',
     & action='read',iostat=ivar,err=100)
#else
      open (jin,file=infile,status='old',iostat=ivar,err=100)
#endif

      call getenv('OUTF',outf)
      lenpre=ilen(outf)
#ifdef MP 
      outfile='main_out.'//tasknu(:lentsk)//outf(:lenpre)
C outo file for output
      angfile='outo.'//tasknu(:lentsk)//outf(:lenpre)
C sumsl file for output
      sumslfile='sumsl.'//tasknu(:lentsk)//outf(:lenpre)
#else
      outfile='main_out.'//outf(:lenpre)
C outo file for output
      angfile='outo.'//outf(:lenpre)
C sumsl file for output
      sumslfile='sumsl.'//outf(:lenpre)
#endif
C open main output
      fname=outfile
      iii=jout
      write(*,'(a,i2,1x, a)')' opening unit ',iii, fname
      open (jout,file=fname,status='unknown',err=100)

      if (index(runtyp,'EDMC').gt.0) then
C file  that stores clusters of conformations 
      clstrfile='clstr.'//outf(:lenpre)
      endif

C residue databases directory
      call getenv('RSDBS',rsdbs)
C open residue database 
      call getenv('RSDATA',readfile)
      lenpre=ilen(readfile)
      fname=readfile(:lenpre)
      iii=jread
      write(*,'(a,i2,1x, a)')' opening unit ',iii, fname
#ifdef WINNT
!for NT 
!	  fname="H:\users\ripoll\eceppak\Data\Residue\rsdata.dat"
      open (jread,file=fname,status='old',action='read',iostat=ivar,
     & err=100)
#else
      open (jread,file=fname,status='old',iostat=ivar,err=100)
#endif

C solvation databases directory
      call getenv('SOLVDBS',solvdbs)

C database with solvation parameters  ( surface or volume)
      call getenv('SOLVFILE',solvfile)

C database with remaining volume-solvation parameters
      call getenv('FXVOLFILE',fxvolfile)

C database with proton labels 
      call getenv('HLABELFILE',Hlabelfile)

C database with dihedral angle definitons 
      call getenv('DIHDEFILE',dihdefile)
C     write(*,'(a,1x, a)')'Dihedral definitions in ',dihdefile

      call getenv('TGTARS',tgtarsfile)

C distance constraints file  (input)
      call getenv('BNDF',bndf)
      lenpre=ilen(bndf)
      if (lenpre.gt.0) then
        distfile='bounds.'//bndf(:lenpre)
        congdfile='congen.'//bndf(:lenpre)
      endif

      call getenv('ANAF',anaf)
      lenpre=ilen(anaf)
      if (lenpre.gt.0) then
        if (index(runtyp,'BOUNDS').gt.0) then
C When run is BOUNDS (generate upper and lower bounds):
C pdb file for generating distance constraints (input)
          inpdbfile=anaf(:lenpre)//'.pdb'

C set name for distance constraints file  (for output)
          distfile='bounds.'//outf
        else 
C open outo file for input
          savefile='outo.'//anaf(:lenpre)
        endif
      endif

      if (index(runtyp,'RMS_FIT').gt.0) then
C When run is RMS_FIT.

        inpdbfile=anaf(:lenpre)//'.pdb'

        call getenv('REFF',reff)
        lenpre=ilen(reff)

        if (lenpre.gt.0) then

          refxyfile='xray.'//reff(:lenpre) 

          inreffile=reff(:lenpre)//'.pdb'

          lenout=ilen(outf)
C Open output files here.

#ifdef MP 
          rmsname(1)='sidev.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(2)='hedev.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(3)='badev.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(4)='rgyr.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(5)='ouref.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(6)='chefol.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(7)='comso.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(8)='cmskd.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(9)='kmsba.'//tasknu(:lentsk)//outf(:lenout)
          rmsname(10)='endtoend.'//tasknu(:lentsk)//outf(:lenout)
#else
          rmsname(1)='sidev.'//outf(:lenout)
          rmsname(2)='hedev.'//outf(:lenout)
          rmsname(3)='badev.'//outf(:lenout)
          rmsname(4)='rgyr.'//outf(:lenout)
          rmsname(5)='ouref.'//outf(:lenout)
          rmsname(6)='chefol.'//outf(:lenout)
          rmsname(7)='comso.'//outf(:lenout)
          rmsname(8)='cmskd.'//outf(:lenout)
          rmsname(9)= 'kmsba.'//outf(:lenout)
          rmsname(10)='endtoend.'//outf(:lenout)
!         write(*,*) 'lenout ', lenout
!         write(*,*) outf
!         write(*,*) outf(:lenout)
#endif

          ifile(1)=jsidev
          ifile(2)=jhedev
          ifile(3)= jbadev
          ifile(4)=jrgyr
          ifile(5)=jouref
          ifile(6)=jchefo
          ifile(7)=jcomso
          ifile(8)=jcmskd
          ifile(9)=jkmsba
          ifile(10)=jete

          do j=1,10
             lenpre=ilen(rmsname(j))
             fname=rmsname(j)(:lenpre)
             iii=ifile(j)
             open (iii,file=fname,status='unknown',err=100)
          enddo
          
        else
          write (*,'(a)') 
     &   'Error - RMS requested but reference file not specified.'
          stop
        endif
  
      endif
      if (index(runtyp,'ECEPPIZE').gt.0) then
C When run is ECEPPIZE.

        inpdbfile=anaf(:lenpre)//'.pdb'

        call getenv('REFF',reff)
        lenpre=ilen(reff)

        if (lenpre.gt.0) then

          refxyfile='xray.'//reff(:lenpre) 

          inreffile=reff(:lenpre)//'.pdb'

          lenout=ilen(outf)
        else
          write (*,'(2a)')  'Error - ECEPPIZATION requested',
     &            ' but reference file not specified.'
          stop
        endif
  
      endif

C set name for restart file
      call getenv('RESTFILE',restfile)

C set name for buckup file for the random number generator.
      call getenv('RANDFILE',randfile)

#ifdef PHCALC
C Files used by IBEM

C file with Atomic charges, radii and other parameters for IBEM
      call getenv('IBEMCHG',ibemchgfile)
      lenpre=ilen(ibemchgfile)
      fname=ibemchgfile(:lenpre)
      iii=jibemchg
      write(*,'(a,i2,1x, a)')' opening unit ',iii, fname
#ifdef WINNT
      open (jibemchg,file=fname,status='old',
     & action='read',iostat=ivar,err=100)
#else
      open (jibemchg,file=fname,status='old',err=100)
#endif

#endif

      goto 110
  100 write (*,'(a,i4,/2a)') 'ERR_Openunits: can"t open logical unit',
     &      iii, ' file= ', fname
      print *,'iostat = ', ivar
      call sleep(10)
      stop
  110 continue
      return
      end

