c   find optimal ionization microstate xxoptim() for given mol.structure
c        energy of optimal ionization microstate gggoptim
c        statistical average ionization degrees  opt_ionz()
c        free energy of ionization(proton bindihg) P + H(+)--PH(+)
c                       fre_hbind
c.
c   given desolv coeff ggg000_is(ix);
c         PSneutr-S+i  ggg001_is(ix)
c         pmf Si - Sj  gggpmf(i,j)
c   makes optimal sigma_ and atmcha() according to optimal microstate

        subroutine optim_ionstate(pH,xxoptim,gggoptim,optionz,frehbind)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
        include'param.ibems' 
        include'comm.ibems' 
        integer ix,jx 
        real*8 gggoptim,pH
        real*8 big, gggmin,sum0,sum1,aa,ggg,pkt,sum2
        integer xx(nres_mx),xxmin(nres_mx),xxoptim(nres_mx),nionstat
        real*8 optionz(nres_mx),frehbind, zzz ,rrtt, aaa
        integer ip,il,is,lg,natm,ia,k,j,i,nn,kk,ist

c.
        rrtt=0.593
        pkt=2.303*rrtt      ! ln10*kT for T=25C
        big=1.0d10
        if(outdetl.ge.0)then
        write(kanalp,*)'Desolvation energ ggg000_is:'
        write(kanalp,'(10f7.3)')(ggg000_is(i),i=1,npolres_t)
        write(kanalp,*)
        write(kanalp,*)'Interaction with backbobe PS - S(ch)i:'
        write(kanalp,'(10f7.3)')(ggg001_is(i),i=1,npolres_t)
        end if !outdetl

        do i=1,nres_mx-1
        do j=i+1,nres_mx
        gggpmf(j,i)=gggpmf(i,j)
        end do
        end do
        do i=1,nres_mx
        gggpmf(i,i)=0.d0
        optionz(i)=0.d0
        end do
        zzz=0.d0
        
c. 
        if(outdetl.ge.0)then
        write(kanalp,*)
        write(kanalp,*)'PMF Si-Sj     '
        do i=1,npolres_t
        write(kanalp,'(i5,10f7.3)')i,(gggpmf(i,k),k=1,npolres_t)
        end do !i
        end if !outdetl
c.
c.
c. define xxinit(i)
c. npolres_t - actual number of ionizable residues
c. niostat = 2**npolres_t
        
        nionstat=2**npolres_t
        
        gggmin=big

        do ist=1,nionstat
        kk=ist-1
        nn=nionstat
        do i=npolres_t,1,-1
        xx(i)=0
        nn=nn/2
        xx(i)=kk/nn
        kk=kk-xx(i)*nn
        end do ! i
c. ionization state xx(i) is available
        if(outdetl.gt.1)then
        write(kanalp,'(10i5)')(xx(k),k=1,npolres_t)
        end if !outdetl
c . define energy on the basis of desolvation en of side groups ggg000_is()
c. their interaction with neutral PS gggoo1_rs(), and the PMF gggpmf(i,j)
         sum0=0.d0
         sum1=0.d0
         sum2=0.d0
         do ix=1,npolres_t
         sum0=sum0+xx(ix)*(ggg000_is(ix)+ggg001_is(ix))
         sum2=sum2 + xx(ix)*(pH - pK0_res(ix))*qqq_res(ix)        
         if(ix.lt.npolres_t)then
         do jx=ix+1,npolres_t
         sum1=sum1+xx(ix)*xx(jx)*gggpmf(ix,jx)
         end do !jx
         end if
         end do !ix
         sum2=sum2*pkt
         ggg=sum0 + sum1 + sum2
c ggg  is an energy of ionization state xx()
         aaa = dexp(-ggg/rrtt)
         zzz = zzz + aaa

         do ix=1,npolres_t
         optionz(ix)=optionz(ix)+ xx(ix)*aaa
         end do
         
c.. optimal state search
         if(ggg.lt.gggmin)then
         gggmin=ggg
         do ix=1,npolres_t
         xxmin(ix)=xx(ix)
         end do !ix
         end if !gggmin

         if(outdetl.gt.1)then
         write(kanalp,*)'sum(pH-pK0)=',sum2
         write(kanalp,*)'sum0=',sum0,'sum1=',sum1
         write(kanalp,*)'ggg=',ggg,'gggmin=',gggmin
         end if !outdetl

         end do ! all xx states
c..
         gggoptim=gggmin
         frehbind=-rrtt*dlog(zzz)
         
         do i=1,npolres_t
         xxoptim(i)=xxmin(i)
         xx_final(i)=xxmin(i)
         optionz(i)=optionz(i)/zzz
         end do
c.
c..
       if(outdetl.ge.0)then
       write(kanalp,*)
       write(kanalp,*)'------------------------------------'
       write(kanalp,*)'optim_ionst: gggoptim=',gggmin
       write(kanalp,*)'xxoptim(i)='
       write(kanalp,'(10i5)')(xxmin(i),i=1,npolres_t)
       write(kanalp,*)'optionz(i)='
       write(kanalp,'(10f7.4)')(optionz(i),i=1,npolres_t)
       end if !outdetl
  
c.
c. part II - construction of optimal sigma's and atmcha rges to calculate
c            solvation forces
c.
c.     inizialization

c      return   ! force calculation is not used in EDMC

       do is=1,nsmalse_tm
       sigmasmt_t(is)=0.d0
       end do 
       do il=1,nlargse_tm 
       sigmalgt_t(il)=0.d0
        end do
       do ip=1,nsurfp_tm
       surfp_q(ip)=0.d0
       end do
c.
       sum0=0.d0
       sum1=0.d0
       
c. only atoms of charged residues are charged
       do ia=1,nnmlat
       atmcha(ia)=0.0d0
       end do !ia

       do ix=1,npolres_t
c. ix - ionized residue

       natm=natm_polrs(i)
       do ia=1,natm
       lg=latm_polrs(ia,ix)
c lg - global number of atom
       
       atmcha(lg)=atmcha(lg)*xxmin(ix)
       sum0=sum0+atmcha(lg)
       end do ! ia
c.
       do is = 1,nsmalse_tm 
       sigmasmt_t(is)=sigmasmt_t(is)+xxmin(ix)*sigmasmt_tv(is,ix)
       end do
       
       do il = 1,nlargse_tm 
       sigmalgt_t(il)=sigmalgt_t(il)+xxmin(ix)*sigmalgt_tv(il,ix) 
       end do

       do ip=1,nsurfp_tm
       surfp_q(ip)=surfp_q(ip)+ xxmin(ix)*surfp_qv(ip,ix)
       end do
c..
       end do !ix
c. end of assignment
c.control
       if(outdetl.gt.1)then
       sum1=0.d0
       do is=1,nsmalse_tm
       sum1=sum1+areasmalse_tm(is)*sigmasmt_t(is)
       end do
c.
       write(kanalp,*)'optim_ionstate: charge list'
       do ia=1,nnmlat
       write(kanalp,*)ia,atmcha(ia)
       end do
c.
       write(kanalp,*)'optim_ionstate: tot mol charge=',sum0
       write(kanalp,*)'                tot ind sigma=',sum1
       end if !outdetl
c.

       return
       end
