c.. double precission
        subroutine potential_eql
      
c
c  electrostatic potential on LATTICE for EQUILIBRIUM ionization state
c
c  OUT: in file :pot_latt.out
c  (xyz,pp_cl,pp_rf,pp_tot)
c  xyz  - xyz of lattice point
c  p_cl - Coulombic potential of Protein atomic charges
c  p_rf - Reaction Field Potential
c  P-tot- total potential
c

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include'param.ibems'
      include'comm.ibems'
      	 
      real*8 pp_cl,pp_rf,pp_tot 
      real*8 xyz(3)

      real*8 coord(3,maxat),atmq_ps(maxat)
      real*8 p_cl,p_rf,p_tot
      integer ncoord
      integer ivarc,nlev0,nlev1,nlev2
      real*8 sigmalev0(nsmalsemx_t),sigmalev1(nlargsemx_t)
      real*8 sigmalev2(maxat),epsout,epsin
      real*8  arealev0(nsmalsemx_t),sxyzlev0(3,nsmalsemx_t)
      real*8  arealev1(nlargsemx_t),sxyzlev1(3,nlargsemx_t)
      real*8  arealev2(maxat),sxyzlev2(3,maxat)
      integer nsurfp_lev0(maxat)
      integer lsurfp_lev0(nsmse_pmx,maxat)
      integer nsurfp_lev1(maxat)
      integer lsurfp_lev1(nlgse_pmx,maxat)
      real*8 xi
      integer iiprint0,iiprint1
      integer is,ia,igr,il,nn,nl
      integer i,j,k,l,ll(3),lattindex
      real*8 sig1,sig2,sig3,qtotback,qtotionz

c 
c Lattice coordinates, potentials
      integer lattsize,lattsize2
      integer nlatt_mx
      parameter (lattsize=65)   ! =2^n + 1
      parameter(nlatt_mx=lattsize**3)
      real*4 lattice_xyz(3,nlatt_mx)
      real*4 lattice_potcl(nlatt_mx) !Coul
      real*4 lattice_potrf(nlatt_mx) !RField
      real*4 lattice_potff, phimap
      dimension lattice_potff(nlatt_mx) !total
      dimension phimap(lattsize,lattsize,lattsize)
      real*4 volfill                 ! portion of BOX filled by molecule
      parameter(volfill=0.67)        ! it's define lattice grid size h
      real*4 hlatt,rmax(3),rmin(3)
      real*4  side, difr, scale 
      real*4 low,big,maxsize,boxsize,center
      character*10 potfile 
c     integer kanalpot 
C*********************************************************
C for compatibility with DelPhi  DR APR96
      equivalence (lattice_potff(1),phimap(1,1,1))
      character*10 nxtlbl
      character*80 phifilo
      character*60 toplbl
      real*4  centmol
      common/molcentre/ centmol(3)
C*********************************************************

c       
c
      potfile='out.potlat'

C     open(unit=kanalpot,file=potfile,status='unknown',
C    &       form='formatted')
      
      iiprint1=1
      iiprint0=0
      epsout=epssol
      epsin=epsmol
      pp_cl=0.0
      pp_rf=0.0
      pp_tot=0.0
c
c GENERATION of LATTICE COORDINATES
c
      
c define Molecule MAXSiZE
      low=-1.e10
      big=1.e10
      do k=1,3
         rmin(k)=big
         rmax(k)=low
      end do !k

      do ia=1,natoml_n
         do k=1,3
            if(atxyzl_n(k,ia).gt.rmax(k))rmax(k)=atxyzl_n(k,ia)
            if(atxyzl_n(k,ia).lt.rmin(k))rmin(k)=atxyzl_n(k,ia)
         end do !k
      end do !ia

      maxsize=low
      do k=1,3
         if(rmax(k)-rmin(k).gt.maxsize)maxsize=rmax(k)-rmin(k)
      end do!k
c BOX size
      lattsize2=lattsize**2
      boxsize=maxsize/volfill
      hlatt=boxsize/(lattsize-1)  !lattice grid size
      scale=1/hlatt


c lattice coordinates
      center=(lattsize-1)*hlatt/2
      do k=1,lattsize
         ll(3)=k
         do j=1,lattsize
            ll(2)=j
            do i=1,lattsize
               ll(1)=i
               lattindex=lattsize2*(k-1)+lattsize*(j-1)+i
               do l=1,3
                  lattice_xyz(l,lattindex)=(ll(l)-1)*hlatt-center
C                 lattice_xyz(l,lattindex)=(ll(l)-1)*hlatt-center
C    &                                                 +centmol(l)
               end do!l
            end do!i
         end do!j
      end do!k


c initialization of potential on LATTICE
      do k=1,3
         xyz(k)=0.0
      end do!k

      do i=1,nlatt_mx
         lattice_potcl(i)=0.0
         lattice_potrf(i)=0.0
         lattice_potff(i)=0.0
         do k=1,3
            xyz(k)=xyz(k)+lattice_xyz(k,i)
         end do!k
      end do!i
      do k=1,3
         xyz(k)=xyz(k)/nlatt_mx
      end do!k

c      write(kanalpl,*)'potential:'
c      write(kanalpl,*)
c      write(kanalpl,*)'center of Lattice:',xyz
c

c PART 1:
c neutral part: Pbackb + sum[(1-Xi)*PS0i] - atomic charg and polariz density
        
c initialization
      ncoord=natoml_n
      do ia=1,ncoord
         atmq_ps(ia)=0.0
         do k=1,3
            coord(k,ia)=atxyzl_n(k,ia)
         end do
      end do!ia

      nlev0=nsmalse_tn
      nlev1=nlargse_tn
      nlev2= nsurfp_tN

c Assign sigma due to bacbone + unIonizable polar side groups
      do is=1,nlev0
        sigmalev0(is)=sigmasmt_tb(is)
      end do
      do is=1,nlev1
        sigmalev1(is)=sigmalgt_tb(is)
      end do
      do is=1,nlev2
        sigmalev2(is)=surfp_qb(is)
      end do

      
c
c collect charges 
c      write(kanalpl,*)'Neutr Molec:nchargr_t0=',nchargr_t0

      do igr=1,nchargr_t0
         if(jchargr_an0(igr).gt.0)then
            xi=1.0
            if(jchargr_kn0(igr).gt.0)then
C  this igr is ionizable, take  eq xi
              xi=1.0-opt_ionz(jchargr_kn0(igr))
            end if
            do il=1,jchargr_an0(igr)
              ia=jchargr_al0(il,igr)
              atmq_ps(ia)= atqql_n(ia)*xi
            end do!il
c
c Collect sigma: add contribution from ionizable groups 
            if(jchargr_kn0(igr).gt.0)then
               nn=jchargr_kn0(igr)
               do is=1,nlev0
                  sigmalev0(is)=sigmalev0(is)+xi*sigmasmt_tn(is,nn)
               end do!lev0
               do is=1,nlev1
                  sigmalev1(is)=sigmalev1(is)+xi*sigmalgt_tn(is,nn)
               end do !lev1
               do is=1,nlev2
                  sigmalev2(is)=sigmalev2(is)+xi*surfp_qn(is,nn)
               end do!is
            end if !gt 0
c end sigma
         end if ! gt 0
      end do!igr

c Assign Surface PS0 

      sig1=0.d0
      sig2=0.d0
      sig3=0.d0
      do k=1,3
         xyz(k)=0.0
      end do!k

      do is=1,nlev0
         arealev0(is)=areasmalse_tn(is)
         sig1=sig1+sigmalev0(is)*arealev0(is)
         do k=1,3
            sxyzlev0(k,is)=cxyzsmalse_tn(k,is)
            xyz(k)=xyz(k)+cxyzsmalse_tn(k,is)
         end do!k
      end do!is

      do is=1,nlev1
         arealev1(is)=arealargse_tn(is)
         sig2=sig2+sigmalev1(is)*arealev1(is)
         do k=1,3
            sxyzlev1(k,is)=cxyzlargse_tn(k,is)
         end do!k
      end do!is
      do is=1,nlev2
         arealev2(is)=surfp_sN(is)
         sig3=sig3+sigmalev2(is)*arealev2(is)
         do k=1,3
            sxyzlev2(k,is)=surfp_xyzN(k,is)
         end do!k
      end do!is

c      do k=1,3
c      xyz(k)=xyz(k)/nlev0
c      end do!k
c test:

c      qtotback=0.0

c      do k=1,3
c      xyz(k)=0.0
c      end do!k
c      write(kanalpl,*)
c      write(kanalpl,*)' Neutral Molecule xyz q'
c      do ia=1,ncoord
c      qtotback=qtotback+atmq_ps(ia)
c      write(kanalpl,'(i4,3f8.3,2x,f6.3)')
c     &      ia,(coord(l,ia),l=1,3), atmq_ps(ia)
c      do k=1,3
c      xyz(k)=xyz(k)+coord(k,ia)/ncoord
c      end do!k
c      end do!ia

c      write(kanalpl,*)'molecule center=',xyz

c      write(kanalpl,*)'potential:BACKB+UNionizRes:'
c      write(kanalpl,*)
c     &  ' qtotback=',qtotback,
c     &  ' siglev0,siglev1,siglev2=', sig1,sig2,sig3


Calculate potential on LATTICE
       
      do nl=1,nlatt_mx
         do k=1,3
            xyz(k)=lattice_xyz(k,nl)
         end do!k

         call potential_xyz(xyz,p_cl,p_rf,p_tot,
     &     ncoord,coord,atmq_ps,
     &     nlev0,arealev0,sxyzlev0,sigmalev0,
     &     nlev1,arealev1,sxyzlev1,sigmalev1,
     &     nlev2,arealev2,sxyzlev2,sigmalev2,
     &     nsurfp_lev0,lsurfp_lev0,nsurfp_lev1,lsurfp_lev1,
     &     epsout,epsin)
c
         lattice_potcl(nl)=p_cl
         lattice_potrf(nl)=p_rf 
         lattice_potff(nl)=p_tot

      end do !nl   

c Result
c      if(outdetl.ge.iiprint0)then
c       write(kanalpl,*)
c       write(kanalpl,*)'hlatt=',hlatt
c       write(kanalpl,*)
c       write(kanalpl,*)'   BACKB+UnIonzRes    potential:(kcal.mol) '
c       write(kanalpl,*)'   x      y      z       Coul     Rf    Tot:'
c         do nl=1,nlatt_mx
c         do k=1,3
c         xyz(k)=lattice_xyz(k,nl)
c         end do!k
c         write(kanalpl,'(3f7.2,2x,3f7.2)')xyz,      
c     &   lattice_potcl(nl),lattice_potrf(nl),lattice_potff(nl)
c         end do
c      end if
c......................................................................
c
c Part 1: finish
c
c PART 2:
c ionized part:  sum[Xi*PS+i] - atomic charg and polariz density
        
c initialization
      ncoord=natoml_i
      do ia=1,ncoord
         atmq_ps(ia)=0.0
         do k=1,3
            coord(k,ia)=atxyzl_i(k,ia)
         end do
      end do!ia

      nlev0=nsmalse_tm
      nlev1=nlargse_tm
      nlev2= nsurfp_tm

      do is=1,nlev0
        sigmalev0(is)=0.0d0
      end do
      do is=1,nlev1
        sigmalev1(is)=0.0d0
      end do
      do is=1,nlev2
        sigmalev2(is)=0.0d0
      end do
      
c
c collect charges 
      do igr=1,npolres_t
         if(natm_polrs(igr).gt.0)then
            xi=opt_ionz(igr)  !this igr is ionized, take eq xi

            do il=1,natm_polrs(igr)
               ia=latm_polrs(il,igr)
               atmq_ps(ia)= atqql_i(ia)* xi
            end do!il

c assign sigma
            do is=1,nlev0
               sigmalev0(is)=sigmalev0(is)+xi*sigmasmt_tv(is,igr)
            end do!lev0
            do is=1,nlev1
               sigmalev1(is)=sigmalev1(is)+xi*sigmalgt_tv(is,igr)
            end do !lev1
            do is=1,nlev2
               sigmalev2(is)=sigmalev2(is)+xi*surfp_qv(is,igr)
            end do!is

         end if !gt 0
      end do!igr

c Assign SUrface PS+ 
      sig1=0.d0
      sig2=0.d0
      sig3=0.d0
      do k=1,3
         xyz(k)=0.0
      end do!k

      do is=1,nlev0
         arealev0(is)=areasmalse_tm(is)
         sig1=sig1+sigmalev0(is)*arealev0(is)
         do k=1,3
            sxyzlev0(k,is)=cxyzsmalse_tm(k,is)
            xyz(k)=xyz(k)+sxyzlev0(k,is)
         end do
      end do


      do is=1,nlev1
         arealev1(is)=arealargse_tm(is)
         sig2=sig2+sigmalev1(is)*arealev1(is)
         do k=1,3
            sxyzlev1(k,is)=cxyzlargse_tm(k,is)
         end do!k
      end do!is

      do is=1,nlev2
         arealev2(is)=surfp_sm(is)
         sig3=sig3+sigmalev2(is)*arealev2(is)
         do k=1,3
            sxyzlev2(k,is)=surfp_xyzm(k,is)
         end do!k
      end do!is
c test:
c      do k=1,3
c      xyz(k)=xyz(k)/nlev0
c      end do!k
c        write(kanalpl,*)'potential:IonizResMolecule:'
c      write(kanalpl,*)
c      write(kanalpl,*)'center of Surface:',xyz
c      qtotionz=0.0
c      do k=1,3
c      xyz(k)=0.0
c      end do!k
c
c      do ia=1,ncoord
c      qtotionz=qtotionz+atmq_ps(ia)
c      write(kanalpl,'(i4,3f8.3,2x,f6.3)')
c     &      ia,(coord(l,ia),l=1,3), atmq_ps(ia)
c      do k=1,3
c      xyz(k)=xyz(k)+coord(k,ia)/ncoord
c      end do!k
c      end do!ia
c      write(kanalpl,*)'Ionized molecule center=',xyz
c      write(kanalpl,*)
c        write(kanalpl,*)'potential: IonizRes:'
c        write(kanalpl,*)
c     &  ' qtotionz=',qtotionz,
c     &  ' siglev0,siglev1,siglev2=', sig1,sig2,sig3

      	   

      			 
Calculate potential on LATTICE

      do nl=1,nlatt_mx
         do k=1,3
            xyz(k)=lattice_xyz(k,nl)
         end do!k
      				 
         call potential_xyz(xyz,p_cl,p_rf,p_tot,
     &     ncoord,coord,atmq_ps,
     &     nlev0,arealev0,sxyzlev0,sigmalev0,
     &     nlev1,arealev1,sxyzlev1,sigmalev1,
     &     nlev2,arealev2,sxyzlev2,sigmalev2,
     &     nsurfp_lev0,lsurfp_lev0,nsurfp_lev1,lsurfp_lev1,
     &     epsout,epsin)
c
         lattice_potcl(nl)=lattice_potcl(nl)+p_cl
         lattice_potrf(nl)=lattice_potrf(nl)+p_rf
         lattice_potff(nl)=lattice_potff(nl)+p_tot

c          lattice_potcl(nl)=p_cl
c          lattice_potrf(nl)=p_rf
c          lattice_potff(nl)=p_tot
      end do !nl 
c
c Part 2 finish
c
c TOTAL POTENTIAL on LATTICE FINISH
c

c Result
c     if(outdetl.ge.iiprint0)then
c        write(kanalpl,*)'sizelatt=',lattsize
c        write(kanalpl,*)'hlatt   =',hlatt
c        write(kanalpl,*)
c        write(kanalpl,*)
c    &       ' BACK+UnIonz+IonzRes   potential:(kcal.mol) '
c        write(kanalpl,*)
c    &       '   x      y      z       Coul     Rf    Tot:'

C write only the first 10 values.
c        do nl=1,10
C        do nl=1,nlatt_mx
c           do k=1,3
c              xyz(k)=lattice_xyz(k,nl)
c           end do!k
c           write(kanalpl,'(3f7.2,2x,3f7.2)')xyz,      
c    &      lattice_potcl(nl),lattice_potrf(nl),lattice_potff(nl)
c        end do
c     end if
c      close(kanalpl)
c......................................................................
      write(kanalpl,*)'center of molecule', centmol
c     write(kanalpl,*)'center of molecule', centmol
       side = float(lattsize)/scale
c      paramfile= 'param.potential'
c      open(unit=72,file=paramfile,form='formatted')
        write(72,5317) lattsize, lattsize, lattsize
        write(6,5317) lattsize, lattsize, lattsize
        write(72,5318) side, side, side
        write(6,5318) side, side, side
        write(72,5318) 1., 0., 0.
        write(6,5318) 1., 0., 0.
        write(72,5318) 0., 1., 0.
        write(6,5318) 0., 1., 0.
        write(72,5318) 0., 0., 1.
        write(6,5318) 0., 0., 1.
        write(72,5318) centmol(1), centmol(2), centmol(3)
        write(6,5318) centmol(1), centmol(2), centmol(3)
5317    format(3i5)
5318    format(3E12.5)
C      close(72)
      nxtlbl = 'potential '
      phifilo= 'potential.phi'
      toplbl= 'from IBEMS calculation'
      open(unit=74,file=phifilo,form='unformatted')
      write(6,*)'potential map written to file'
      write(6,*)phifilo
      write(6,*)'  '
      write(74)'now starting phimap '
      write(74)nxtlbl,toplbl
      write(74)phimap
      write(74)' end of phimap  '
      write(74)scale,centmol
      close(74)
         
      return 
      end
