c.. double precision

	subroutine potential_xyz(xyz,p_cl,p_rf,p_tot,
     &	ncoord,coord,atmq_ps,        
     &  nlev0,arealev0,sxyzlev0,sigmalev0,
     &  nlev1,arealev1,sxyzlev1,sigmalev1,
     &  nlev2,arealev2,sxyzlev2,sigmalev2,
     &  nsurfp_lev0,lsurfp_lev0,nsurfp_lev1,lsurfp_lev1,
     &  epsout,epsin)
c
c  calculation of electrostatic potential at point xyz 
c  
c  OUT:
c  p_cl - Coulombic potential of Protein atomic charges
c  p_rf - Reaction Field Potential
c  P-tot- total potential
c
c  IN:
c  xyz - point inside or outside protein
c  nsoord, soord(k,na) atom coordinates atmq_ps()-charges
c  nlev0,arealev0,arealev0,sxyzlev0,sigmalev0 - number of se and full
c  rerpesentation on sm lev0 : area,xyz,sigma density. the same for lev1,lev2
c  nsurfp_lev0(ip)- number of sf elem lev0 in sp ip
c  lsurfp_lev0(list,ip)- list of sf elem lev0 in sp ip. the same for lev1
c  
c


c	implicit none
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'

	integer nssmx,nlgmx
	parameter(nssmx=nsmse_pmx)
	parameter(nlgmx=nlgse_pmx)
        integer ncoord
        real*8 coord(3,ncoord),atmq_ps(ncoord)
        real*8 p_cl,p_rf,p_tot 
        integer nlev0,nlev1,nlev2
        real*8  arealev0(nlev0),sxyzlev0(3,nlev0),sigmalev0(nlev0)
        real*8  arealev1(nlev1),sxyzlev1(3,nlev1),sigmalev1(nlev1)
        real*8  arealev2(nlev2),sxyzlev2(3,nlev2),sigmalev2(nlev2)
	real*8 xyz(3),epsin,epsout
	integer nsurfp_lev0(nlev2),lsurfp_lev0(nssmx,nlev2)
	integer nsurfp_lev1(nlev2),lsurfp_lev1(nlgmx,nlev2)

        real*8 gconst1,ss,rrlock2,rrlock1,ppi,toler
	real*8 rrlock22,rrlock12,pd2
        real*8 sd,sd1,sd2,sn,snl,snd,senl,seni,send
        real*8 qind,qs
        integer ia,i,j,k,ii,jj,ns,index,ip,il,is,nsg
        integer ioutdt,iiprint1,iiprint0

	ioutdt=0
        iiprint1=1
        iiprint0=0
	ppi=1.7724539d0  !sqrt(pi)
	toler = 0.005
c


c radius of calculation by smal se
	rrlock1=5.0
	rrlock12=rrlock1**2
        rrlock2=10.0
	rrlock22=rrlock2**2

        senl=0.d0
	seni=0.d0
        send=0.d0
	qind=0.0d0

c..................................................................
c..direct coulombic potential
	 p_cl=0.0d0
         do jj=1,ncoord
	 if(abs(atmq_ps(jj)).gt.0.0)then
         sd2=0.d0
         do k=1,3
         sd2=sd2+(coord(k,jj)-xyz(k))**2
         end do! k
         sd1=dsqrt(sd2) + toler
         p_cl=p_cl+atmq_ps(jj)/sd1
	 end if
	 end do
      
	 p_cl=coefel*p_cl/epsin 

c.................................................................
c.search for surface piece number

        do 400 ip=1,nlev2

        pd2=0.d0
        do k=1,3
        pd2=pd2+(xyz(k)-sxyzlev2(k,ip))**2
        end do
c.......................................................
         if(pd2.le.rrlock12)then
c. piece ip included in local surface  which  is considered as collection
c. of small se

         do ns=1,nsurfp_lev0(ip)
c.nsg global number of small s.e.
         nsg=lsurfp_lev0(ns,ip)
         sd2=0.d0
         do k=1,3
         sd2=sd2+(xyz(k)-sxyzlev0(k,nsg))**2
         end do
         sd1=dsqrt(sd2)
	 if(sd2*pi.lt.arealev0(nsg))then
	 sd1=dsqrt(arealev0(nsg))/ppi
	 end if
         qs=sigmalev0(nsg)*arealev0(nsg)
	 qind=qind+qs
         senl=senl+qs/sd1
         end do! ns
         end if !loc
c...........................................................
         if(pd2.gt.rrlock12.and.pd2.lt.rrlock22)then
c. distant surface

         do ns=1,nsurfp_lev1(ip)
c.nsg global number of large s.e.
         nsg=lsurfp_lev1(ns,ip)
         sd2=0.d0
         do k=1,3
         sd2=sd2+(xyz(k)-sxyzlev1(k,nsg))**2
         end do
         sd1=dsqrt(sd2)
         qs=sigmalev1(nsg)*arealev1(nsg)
         seni=seni+qs/sd1
	 qind=qind+qs
         end do! ns

         end if ! intr

	 if(pd2.gt.rrlock22)then
         sd1=dsqrt(pd2)
	 qs=sigmalev2(ip)*arealev2(ip)
	 qind=qind+qs
	 send=send+qs/sd1
	 end if
c...................................................................
400      continue
c...................................................................
c         if(ioutdt.ge.iiprint0)then
c	 write(kanalpl,*)'potential: qindtot=',qind
c	 end if

	 p_rf=(senl+seni+send)*coefel
	 p_tot=p_rf+p_cl

c
c         if(ioutdt.ge.iiprint0)then
c         write(kanalpl,*)'potential:(kcal.mol):'
c         write(kanalpl,*)'coul from protein =',p_cl
c         write(kanalpl,*)'reaction field pot=',p_rf
c         write(kanalpl,*)'tot potential     =',p_tot
c         end if
c......................................................................
         
         return 
         end
