C $Date: 1995/08/23 21:32:02 $
C $Revision: 3.1 $
C
C
C
      REAL FUNCTION RMDCON(K)
C
C  ***  RETURN MACHINE DEPENDENT CONSTANTS USED BY NL2SOL  ***
C
C +++  COMMENTS BELOW CONTAIN DATA STATEMENTS FOR VARIOUS MACHINES.  +++
C +++  TO CONVERT TO ANOTHER MACHINE, PLACE A C IN COLUMN 1 OF THE   +++
C +++  DATA STATEMENT LINE(S) THAT CORRESPOND TO THE CURRENT MACHINE +++
C +++  AND REMOVE THE C FROM COLUMN 1 OF THE DATA STATEMENT LINE(S)  +++
C +++  THAT CORRESPOND TO THE NEW MACHINE.                           +++
C
      INTEGER K
C
C  ***  THE CONSTANT RETURNED DEPENDS ON K...
C
C  ***        K = 1... SMALLEST POS. ETA SUCH THAT -ETA EXISTS.
C  ***        K = 2... SQUARE ROOT OF 1.001*ETA.
C  ***        K = 3... UNIT ROUNDOFF = SMALLEST POS. NO. MACHEP SUCH
C  ***                 THAT 1 + MACHEP .GT. 1 .AND. 1 - MACHEP .LT. 1.
C  ***        K = 4... SQUARE ROOT OF 0.999*MACHEP.
C  ***        K = 5... SQUARE ROOT OF 0.999*BIG (SEE K = 6).
C  ***        K = 6... LARGEST MACHINE NO. BIG SUCH THAT -BIG EXISTS.
C
      REAL BIG, ETA, MACHEP
      REAL SQRT
      REAL ONE001, PT999
C
#ifdef WINNT 
c use intrinsics huge, tiny, and epsilon to find the numbers
      real x
      DATA ONE001/1.001E+0/, PT999/0.999E+0/
      big = huge(x)
      eta = tiny(x)
      machep = epsilon(x)
#endif
#ifdef AIX 
c use intrinsics huge, tiny, and epsilon to find the numbers
      real x
      DATA ONE001/1.001E+0/, PT999/0.999E+0/
      big = huge(x)
      eta = tiny(x)
      machep = epsilon(x)
C BIG 0.3402823466E+39  ETA 0.1175494351E-37  MACHEP 0.1192092896E-06
#endif
C
#ifdef ES9000 
C  +++  IBM 360, IBM 370, OR XEROX  +++
C
      DATA ONE001/1.001E+0/, PT999/0.999E+0/
      DATA BIG/Z7FFFFFFF/, ETA/Z00100000/, MACHEP/Z3C100000/

#endif
C
#ifdef KSR
      PARAMETER (ONE001=1.001E+0, PT999=0.999E+0)
      DATA BIG/1.7E+38/, ETA/2.939E-39/, MACHEP/5.9604645E-08/
#endif
C
#ifdef SGI
C  +++  Sgi  +++
      DATA ONE001/1.001E+0/, PT999/0.999E+0/
      DATA BIG/3.40282347E+38/,ETA/1.17549435E-38/,
     &                                  MACHEP/1.19209290E-07/
#endif
C
#ifdef SGIDP
C  +++  Sgi  +++
      DATA ONE001/1.001E+0/, PT999/0.999E+0/
      DATA BIG/1.7976931348623157E+308/, ETA/2.2250738585072014E-308/,
     &      MACHEP/2.2204460492503131E-16/
#endif
C
#ifdef SUN
C  +++  Sun  +++
      DATA ONE001/1.001E+0/, PT999/0.999E+0/
      DATA BIG/3.4E+38/, ETA/1.4E-38/, MACHEP/2.8E-8/
#endif
C
#ifdef STARD
C  +++  Stardent  +++
      DATA ONE001/1.001E+0/, PT999/0.999E+0/
      DATA BIG/3.4E+38/, ETA/1.4E-38/, MACHEP/2.8E-8/
#endif
C
C
C  +++  DATA GENERAL  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/0.7237E+76/, ETA/0.5398E-78/, MACHEP/0.9537E-06/
C
C  +++  DEC 11  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/1.7E+38/, ETA/2.9388E-39/, MACHEP/1.1921E-07/
C
C  +++  HP3000  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/1.1579E+77/, ETA/8.6362E-78/, MACHEP/2.3842E-07/
C
C  +++  HONEYWELL  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/O376777000000/, ETA/O404400400000/,
C    1     MACHEP/O716400000000/
C
C  +++  DEC10  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/"377777777777/, ETA/"000400000021/,
C    1     MACHEP/"147400000000/
C
C  +++  BURROUGHS  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/O0777777777777777/, ETA/O1771000000000000/,
C    1     MACHEP/O1301000000000000/
C
C  +++  CONTROL DATA  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/37754000000000000000B/, ETA/00024000000000000000B/,
C    1     MACHEP/16414000000000000000B/
C
C  +++  PRIME  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/1.7E+76/, ETA/1.47E-77/, MACHEP/2.38419E-12/
C
C  +++  UNIVAC  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/1.69E+38/, ETA/5.9E-39/, MACHEP/1.4901162E-8/
C
C  +++  VAX  +++
C
C     DATA ONE001/1.001E+0/, PT999/0.999E+0/
C     DATA BIG/1.7E+38/, ETA/2.939E-39/, MACHEP/5.9604645E-08/
C
C
C-------------------------------  BODY  --------------------------------
C
      GO TO (10, 20, 30, 40, 50, 60), K
C
 10   RMDCON = ETA
      GO TO 999
C
 20   RMDCON = SQRT(ONE001*ETA)
      GO TO 999
C
 30   RMDCON = MACHEP
      GO TO 999
C
 40   RMDCON = SQRT(PT999*MACHEP)
      GO TO 999
C
 50   RMDCON = SQRT(PT999*BIG)
      GO TO 999
C
 60   RMDCON = BIG
C
 999  RETURN
C  ***  LAST CARD OF RMDCON FOLLOWS  ***
      END
