      SUBROUTINE RMS_CALC

      LOGICAL END_OF_FILE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.RMSFIT'
      INCLUDE 'COMMON.TYYY'
      INCLUDE 'COMMON.TRACK'
      DIMENSION IC(maxnum_atoms)
      CHARACTER*64 CFFX(4),OLD_PREFIX
      CHARACTER*64 SPDBFIL
      DATA IZERO /0/,ITREIN /30/
      LOGICAL SEQDIFF,YourOwn


C
C  INITIALIZE RADIA OF GYRATION FOR REFERENCE CONFORMATION
      RGXH=0.0
      RGXCA=0.0
      RGXBH=0.0
      RGXSH=0.0

      DO 5 I=1,maxnum_dihe
        AVER(1,I,J) = 0.0
        AVER(2,I,J) = 0.0
 5    CONTINUE

      IAMCON=0

      NATMOM=NPRE(INUMRS+1)
C    ################ GENERATE SUFFIX FOR OUTPUT PDB FILES  ################  
      OLD_PREFIX=COORPREF
      CALL CONCAT(COORPREF,'_HVY',CFFX(1))
      CALL CONCAT(COORPREF,'_CA',CFFX(2))
      CALL CONCAT(COORPREF,'_BCK',CFFX(3))
      CALL CONCAT(COORPREF,'_SID',CFFX(4)) 

      IF (PRINT.AND. (IFORM.EQ.6) ) THEN
C PDB FILE FOR SELECTED ATOMS
         CALL CONCAT(COORPREF,'.pdb',SPDBFIL)
         WRITE(JOUT,'(2A)') 'Writing PDB file for selected atoms:',
     &       SPDBFIL
         OPEN (ITREIN,FILE=SPDBFIL,STATUS='UNKNOWN')
         WRITE(ITREIN,'(2A)') 'REMARK ', COORPREF
      ENDIF

C   ############## REFERENCE GENERATION   #################
C     WRITE(*,*) 'GENERATE_REF ', GENERATE_REF,' ITYPE_REF ', ITYPE_REF
      IF (GENERATE_REF) THEN
C  IF REFERENCE FILE DOESN'T EXIST GENERATE ONE.
C
        IF (ITYPE_REF.NE.3) THEN
C         USE INPUT DATA FROM FILE "JINREF" (27)
C
          KUNIT=JINREF
          WRITE(*,*)
     &  'XRAY file not provided. Will generate one from UNIT ',JINREF
          WRITE(JOUT,'(/,a,i3/)') 
     &  'XRAY file not provided. Will generate one from UNIT ',JINREF
          IF (ITYPE_REF.EQ.1) THEN
            ITYPF=1
            WRITE(JOUT,'(2a)')'Input structure for ',
     &        'reference in ORIGINAL PDB format (no end groups)'
          ELSE IF (ITYPE_REF.EQ.2 ) THEN
            ITYPF=0
             WRITE(*,'(/2a/)') ' Input structure for reference ',
     &         'in ECEPP(or AMBER) PDB format (with end groups)'
             WRITE(JOUT,'(/2a/)')'Input structure for reference ',
     &         'in ECEPP(or AMBER) PDB format (with end groups)'
          END IF

C  ###  READ FILE #####
          CALL SUBPDB (NATMOM,XCOR,ICON,KUNIT)
C         WRITE(*,*) ' After SUBPDB  '
        ELSE 
          WRITE(JOUT,'(2a,i6)')'Reference conformation generated from ',
     & 'given dihedral angles; No/ of atoms is: ',NATMOM
          DO 80 I=1, NATMOM
            IF (ALPH(I)(1:1).EQ.'H') THEN
              ICON(I) = 0
            ELSE
              ICON(I) = 1
                   DO 85 J=1,3
                        XCOR(J,I)= COORD(J,I)
85                 CONTINUE
            ENDIF
  80      CONTINUE
        END IF
        WRITE(*,'(2a)')' Writing REFERENCE coordinates to file: ',
     &           refxyfile
        WRITE(JOUT,'(2a)')'Writing REFERENCE coordinates to file: ',
     &           refxyfile
        DO I=1, NATMOM
            WRITE(JOUREF,1040) (XCOR(J,I),J=1,3),ICON(I),ALPH(I)
 1040       FORMAT (5X,3F9.3,I6,5X,A4)
        ENDDO
C   ############## END REFERENCE GENERATION   #################
      ELSE
C  ############  READ REFERENCE CONFORMATION (XRAY file).#########
        WRITE(JOUT,'(a,i4,a,i4)') 
     &   'Now reading Reference file; No. of atoms= ',NATMOM,
     &   ' from unit= ',JREFXY
        DO 10 I=1,NATMOM
          READ (JREFXY,1010,END = 22) ( XCOR(J,I),J=1,3), ICON(I)
  10    CONTINUE
 1010   FORMAT (5X,3F9.3,I6)
      ENDIF
     
C END-to-END DISTANCE
C  First N atom
      N1AT= NPRE(2)+1
C  Last C' atom
      N2AT= NPRE(INUMRS-1)+6
      END_TO_END= DISTA( XCOR(3,N1AT),XCOR(3,N2AT))
      WRITE(JOUT,*) 'END_TO_END REFERENCE', END_TO_END
      WRITE(*,*) 'END_TO_END REFERENCE', END_TO_END
      WRITE(JOUT,*) ' '

C Save info on sequence of the reference  conformation. 

      DO J=1,INUMRS
        LISTMIN(J,1)=LIST(J)
      ENDDO

      
C  ################    GET INPUT FILE FOR THE COMPARISON.  ############

C ###  DETERMINE RESIDUES USED IN THE COMPARISON ######
      IF( KK1 .LT.1) KK1=1
      IF(LRESD.EQ.0 .OR.  LRESD.GT.INUMRS) LRESD=INUMRS
      IF (KK1.GE.LRESD) THEN
         WRITE (JOUT,676) KK1,LRESD
688      FORMAT ( 'ERROR IN INPUT FILE',/,
     &     ' 1st residue no. = ',I4,/,' last residue no. = ',
     &     I4 ,/,' INUMRS is ', i4)
         STOP 132
      END IF

      WRITE(*,676) KK1,LRESD
      WRITE (JOUT,676) KK1,LRESD
676   FORMAT ( 'RMS EVALUATED FOR RESIDUE NO ',I4,' TO ', I4)
C     WRITE (JOUT,'(a,i4)') 'ITYPE_INP=', ITYPE_INP
C     WRITE (*,'(a,i4)') 'ITYPE_INP=', ITYPE_INP

C #########  WHAT IS THE FORMAT OF THE INPUT CONFORMATION. #########
      IF  (ITYPE_INP.NE.3 ) THEN
         IF  (ITYPE_INP.EQ.1 ) THEN
            ITYPF=1
            WRITE(JOUT,'(a)') 
     & 'Input Structure in ORIGINAL PDB format (without end groups).'
         ELSE IF (ITYPE_INP.EQ.2 ) THEN
            ITYPF=0
            WRITE(JOUT,'(2a)') 
     & 'Input Structure in ECEPP(or AMBER) PDB format',
     & ' (with end groups).'
         ELSE 
            WRITE(JOUT,'(a)') 
     & 'FORMAT of Input Structure is UNKNOWN.'
            stop 33442
         END IF
         E1=0.0
         KUNIT=INPDB
         WRITE(*,'(a,i3)')'Reading Input structure from Unit ',kunit
         WRITE(JOUT,'(a,i3)')'Reading Input structure from Unit ',kunit
C  ###  READ  INPUT PDB FILE FOR COMPARISON #####
         CALL SUBPDB ( NATMOM, COORD, IC, KUNIT )
C   ASSURE THAT ALL THE ATOMS USED FOR COMPARISON HAVE BEEN READ.
         DO K=1,NATMOM
             IF(ICON(K).EQ.1 .AND. IC(K).EQ.0) ICON(K)=0
         ENDDO
C 
C    ########## CALCULATE RMS DEVIATIONS FOR SINGLE FILE #######
         IAMCON=IAMCON+1
         CALL DO_RMS(IAMCON,CFFX)
      ELSE 
         WRITE(*,'(a)') 
     &       'Input Structure(s) on ECEPP OUTO format.'
         WRITE(JOUT,'(a)') 
     &       'Input Structure(s) on ECEPP OUTO format.'
C #############  TITLES ON OUTPUT FILES:    ##############
C 
C #############        RMS (unit 46)         ############
         WRITE(JCHEFO,1630)
C #############  RADIA OF GYRATION (unit 34) ##############
         WRITE(JRGYR,1640)

C    ################ START RMS CALCULATION  ################  
         END_OF_FILE=.FALSE.
         NREADIN=0
         DO WHILE (.NOT. END_OF_FILE)
           YourOwn = .TRUE.
           CALL READANG(END_OF_FILE,IAMCON,OLDENER,YourOwn) 
           IF (.NOT. END_OF_FILE) THEN
              IF (OLDENER.GT. ETHRESH) GOTO 50
              NREADIN= NREADIN+1
C Average over dihedral angles has not been implemented, yet.
C             DO 40 I=1,INUMRS
C                DO 30 J=1,maxnum_dihe
C                  IF (I.GE.2.OR.I.LT.INUMRS) THEN
C                     AVER(1,J,I) = AVER(1,J,I) + COS(ANGULO(J,I))
C                     AVER(2,J,I) = AVER(2,J,I) + SIN(ANGULO(J,I))
C                  END IF
C 30              CONTINUE
C 40           CONTINUE

C Compare sequences of the reference  and input  conformations. 

              SEQDIFF=.FALSE.
              DO J=1,INUMRS
                IF(LISTMIN(J,1).NE.LIST(J)) SEQDIFF=.TRUE.
              ENDDO

              IF (SEQDIFF) THEN
         	write(jout, '(a,i4,a)') 'Conformation ',IAMCON,
     &   ' has a DIFFERENT SEQUENCE than the reference.'
	 write(jout, '(2a)') 'Errors may occur if you haven"t used' ,
     &   ' the keyword "ADOPT_REF_SEQ" '
              ENDIF
              IF (ADOPT_REF_SEQ) THEN
                 DO J=1,INUMRS
                    LIST(J)=LISTMIN(J,1)
                 ENDDO

              ENDIF

C #############  GENERATE CONFORMATION #############
              CALL SETUP_X(IZERO)
C         END-to-END DISTANCE
C          First N atom
              N1AT= NPRE(2)+1
C          Last C' atom
              N2AT= NPRE(INUMRS-1)+6
              END_TO_END= DIST(N1AT,N2AT)
              WRITE(JOUT,*)'END_TO_END CONF(',NREADIN,')', END_TO_END
C             WRITE(*,*) 'N1AT N2AT ', N1AT, N2AT
C             WRITE(*,*) (COORD(J,N1AT), J=1,3), (COORD(J,N2AT), J=1,3)
              WRITE(JETE,'(i5,2x,E12.5,2x,f8.3)')
     &                           NREADIN,OLDENER,END_TO_END
 

C    ################ CALCULATE  RMS DEVIATIONS ################  
              CALL DO_RMS(NREADIN,CFFX)
           ENDIF
50         CONTINUE
         ENDDO
         IF(NREADIN.EQ.0) THEN
           WRITE(JOUT,'(A)') 'No conformation within specified range'
           STOP 332
         ENDIF
      END IF

      COORPREF=OLD_PREFIX
      RETURN 

22    CONTINUE
      WRITE(JOUT,'(A60,/,A25,i5)')
     & 'INPUT FILE FOR REFERENCE GENERATION IS INCOMPLETE OR MISSING ',
     & 'NUMBER OF ATOMS READ IN: ', I-1
      STOP 333
      
1630  FORMAT ( ' Conf. #',5X,'Energy',3X,'all Hvy.Ats.',4X,
     &' CA',4X,'Bk.Hvy.Ats.',3X,'SC.Hvy.Ats',/,22X,'    RMS     ',4X,
     &'RMS',4X,'   RMS     ',3X,'    RMS   ',/ )
1640  format(
     &'  CONFOR.   RAD.OF GYR.  RAD.OF GYR. RAD.OF GYR. RAD.OF GYR.',/,
     &'    No.     All Hvy Ats      CA      BK Hvy Ats  SC Hvy Ats',/)

      END
      SUBROUTINE DO_RMS(IAMCON,CFFX)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.RMSFIT'
      INCLUDE 'COMMON.RMSPDB'
      REAL*8 RMS, RGY
      REAL*8 RM1, RM2, RM3, RM4, RGH, RGCA, RGBH, RGSH
      CHARACTER*3 NUMM
      CHARACTER*64 CFF,CFFX(4)
      LOGICAL FAIL
      DATA IZERO /0/,IONE /1/,ITWO /2/,ITRES /3/,IFOUR /4/,ITREIN /30/


      RM1=0.0
      RM2=0.0
      RM3=0.0
      RM4=0.0
      RGH=0.0
      RGCA=0.0
      RGBH=0.0
      RGSH=0.0
C     IAMCON=IAMCON+1
      WRITE ( JOUT, 1450 ) IAMCON, ETOT
      WRITE ( JCMSKD, 1450 ) IAMCON, ETOT
 1450 FORMAT (/,' Conformation # ', I4, 
     &      '    (Energy value read= ', E13.5,')')

      CALL NUMSTR(IAMCON,NUMM)
C
C #### PROCEED WITH THE RMS ANALYSIS FOR ALL HEAVY ATOMS. #### 
C 
      IF(ALL_HVY) THEN
         FAIL=.FALSE.
         CALL RMS_EVAL(IAMCON,IONE,CFFX(1),RGY,RMS,FAIL)
         IF(.NOT.FAIL) THEN
            IF (PDB_ALIGN_HVY)  THEN
C    ##   WRITE COORDINATES IF REQUESTED.  ##  
               CALL CONCAT(CFFX(1),NUMM,CFF)
               COORPREF=CFF
C              NO_HYDRG=.FALSE.
               CALL OUTNW(IZERO,ITREIN,IAMCON)
            ENDIF
            RGH=RGY
            RM1=RMS
         ELSE
            WRITE(JOUT,*)'RMS CALCULATION FOR HEAVY ATOMS FAILED'
            RGH=9999.0
            RM1=9999.0
         ENDIF
      ENDIF
C #### PROCEED WITH THE RMS ANALYSIS FOR C-ALPHA ATOMS. #### 
      IF(ALPHA_C) THEN
         FAIL=.FALSE.
         CALL RMS_EVAL(IAMCON,ITWO,CFFX(2),RGY,RMS,FAIL)
         IF(.NOT.FAIL) THEN
            IF (PDB_ALIGN_CA)  THEN
C        ##   WRITE COORDINATES IF REQUESTED.  ##  
               CALL CONCAT(CFFX(2),NUMM,CFF)
               COORPREF=CFF
C              NO_HYDRG=.FALSE.
               CALL OUTNW(IZERO,ITREIN,IAMCON)
            ENDIF
            RGCA=RGY
            RM2=RMS
         ELSE
            WRITE(JOUT,*)'RMS CALCULATION FOR C-ALPHA ATOMS FAILED'
            RGCA=9999.0
            RM2=9999.0
         ENDIF
      ENDIF

C #### PROCEED WITH THE RMS ANALYSIS FOR BACKBONE ATOMS. #### 
      IF(BACKBONE) THEN
         FAIL=.FALSE.
         CALL RMS_EVAL(IAMCON,ITRES,CFFX(3),RGY,RMS,FAIL)
         IF(.NOT.FAIL) THEN
            IF (PDB_ALIGN_BACK)  THEN
C      ##   WRITE COORDINATES IF REQUESTED.  ##  
               CALL CONCAT(CFFX(3),NUMM,CFF)
               COORPREF=CFF
C              NO_HYDRG=.FALSE.
               CALL OUTNW(IZERO,ITREIN,IAMCON)
            ENDIF
            RGBH=RGY
            RM3=RMS
         ELSE
            WRITE(JOUT,*)'RMS CALCULATION FOR BACKBONE ATOMS FAILED'
            RGBH=9999.0
            RM3=9999.0
         ENDIF
      ENDIF

C #### PROCEED WITH THE RMS ANALYSIS FOR HEAVY SIDE_CHAIN ATOMS. #### 
      IF(SIDE_CHAIN) THEN
         FAIL=.FALSE.
         CALL RMS_EVAL(IAMCON,IFOUR,CFFX(4),RGY,RMS,FAIL)
         IF(.NOT.FAIL) THEN
            IF (PDB_ALIGN_SIDE)  THEN
C      ##   WRITE COORDINATES IF REQUESTED.  ##  
               CALL CONCAT(CFFX(4),NUMM,CFF)
               COORPREF=CFF
C              NO_HYDRG=.FALSE.
               CALL OUTNW(IZERO,ITREIN,IAMCON)
            ENDIF
            RGSH=RGY
            RM4=RMS
         ELSE
            WRITE(JOUT,*)'RMS CALCULATION FOR SIDE_CHAIN ATOMS FAILED'
            RGSH=9999.0
            RM4=9999.0
         ENDIF
      ENDIF

      IF (IAMCON.EQ.1) THEN
         WRITE(JRGYR,1660) RGXH, RGXCA, RGXBH, RGXSH
      ENDIF
      WRITE(JRGYR,'(2x,I5,3x,4F12.5)') IAMCON,RGH,RGCA,RGBH,RGSH
      WRITE(JCHEFO,'(I5,5X,5(F10.3,1X))')IAMCON,ETOT,RM1,RM2,RM3,RM4

      RETURN 

1660  format(4X,'Xray  ',4F12.5)

      END
      SUBROUTINE RMS_EVAL(IAMCON,IPR,CPREF,RGY,RMS,FAIL)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.RMSFIT'
      INCLUDE 'COMMON.RMSPDB'
      REAL*8 RM22
      REAL*8 RMS, RGY
      REAL DK(maxnum_res), DEN(maxnum_res)
      REAL DISDEL(maxnum_res,maxnum_res)
      DIMENSION REDEV(maxnum_res), NPREH(maxnum_res)
      DIMENSION REDEP(maxnum_res)
      CHARACTER*3 NUMM
      CHARACTER*64 CPREF,CFF,OLD_PREFIX
      DATA IZERO /0/, IONE /1/,ITREIN /30/
      LOGICAL FAIL

      IF(IPR.EQ.1) THEN

C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C     I     ALL HEAVY ATOMS 
C
C       WRITE(JOUT,7800) 
C7800    FORMAT ('ALL HEAVY ATOMS' )
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C SEE IF WE CAN ALIGN ALL THE ATOMS.  DR   10/90
        DO 80 I=1, NATMOM
           DO 90 J=1,3
              X1_AL(J,I) = COORD(J,I)
              X2_AL(J,I) = XCOR(J,I)
  90       CONTINUE
C          WRITE(JOUT,1040) ( COORD(J,I),J=1,3), ICON(I), ALPH(I)
C1040      FORMAT (5X,3F9.3,I6,5X,A4)
  80    CONTINUE
C*****
C*************************************************
C      SELECT HEAVY ATOMS
        NUCO = 0
        DO 120 JJ=KK1, LRESD
          NPREH(JJ-1) = NUCO
          DO 110 I = NPRE(JJ) + 1, NPRE(JJ+1)
C             KI = I - NPRE(JJ)
              IF ( ALPH(I)(1:1).EQ.'H')THEN
C                   WRITE(JOUT,16550) KI, JJ, I
                   GOTO 110
              ENDIF
              IF ( ICON(I).EQ.1 ) THEN
                   NUCO = NUCO + 1
                   DO 100 J=1,3
                        X1(J,NUCO) = COORD(J,I)
                        X2(J,NUCO) = XCOR(J,I)
 100               CONTINUE
              END IF
 110      CONTINUE
 120    CONTINUE
        IATMCD = NUCO

        IF (IATMCD.EQ.0) THEN
          RMS= 0.0
          RM22 = 0.0
          WRITE(JOUT,5400) KK1, LRESD
5400      FORMAT ('NO ATOMS SELECTED FOR EVALUATING RMS FOR ALL HVY',
     &     ' FROM RESIDUES ',i5,' TO ',i5)
        ELSE
          IF (METHRMS.EQ.1)  THEN
             CALL KABSCH  ( RMS )
          ELSE IF (METHRMS.EQ.2) THEN 
             CALL GOLUB  ( RMS, FAIL )
             IF (FAIL) RETURN
          ENDIF
          WRITE(JOUT,'(A20,I4)') 'NO. OF HVY ATOMS= ', IATMCD

C    THE FOLLOWING HAS NOT BEEN IMPLEMENTED, YET.
C    INGEN RECOVERS DIHEDRAL ANGLES FROM COORDINATES OF HEAVY ATOMS
C         IF (IAMCON.EQ.1) CALL INGEN (X2,LIST,NPREH,NRES)

C RGXH AND RGY  ARE THE RADIA OF GYRATION OF THE XRAY AND THE CONSIDERED
C CONFORMATION CALCULATED BY USING ALL THE HEAVY ATOMS.
          IF (IAMCON.EQ.1) CALL RGYR(IZERO,RGXH)
          CALL RGYR (IAMCON,RGY)

          IF (DIST_RMS) THEN
            RM22 = 0.0
            DO 160 I=1,NUCO-1
               DO 161 J=I+1,NUCO
                 DI = 0.0
                 DJ = 0.0
                 DO 140 K=1,3
                   DI = DI + ( X1(K,I)-X1(K,J))**2
                   DJ = DJ + ( X2(K,I)-X2(K,J))**2
  140            CONTINUE
                 DELTA = ( SQRT(DI)-SQRT(DJ))**2
                 RM22 = RM22 + DELTA
  161          CONTINUE
  160       CONTINUE
            RM22 = DSQRT ( RM22*2.0/ DFLOAT(NUCO*(NUCO+1)) )
            WRITE(JOUT,1480) RM22
1480        FORMAT ( 'DISTANCE RMS ALL HEAVY ATOMS', 1E15.6)
          ENDIF
C
C     CALCULATE DEVIATIONS PER RESIDUE
          WRITE(JHEDEV,1580) IAMCON
1580  FORMAT (/,'CONFORMATION #',I4,6X,'HVY-ATOMS',6x,'  ALL ATOMS',
     &        /,'   RESIDUE    ',  10X,'    RMS  ',6x,'     RMS'/)
          NUBO = 0
          DO 240 I=1,INUMRS
           DEVIT = 0.0
           DENO= 0.0
           IF(I.GE.KK1.AND.I.LE.LRESD) THEN
             DO 220 K=NPRE(I)+1, NPRE(I+1)
C                KI = K - NPRE(I)
                IF ( ALPH(K)(1:1).EQ.'H')THEN
C                  WRITE(JOUT,16550) KI, K, I
                   GOTO 220
                ENDIF
                IF (ICON(K).EQ.1) THEN
                   NUBO = NUBO + 1
                   DEVI = 0.0
                   DO 200 J=1,3
                      DEVI=DEVI+(X2(J,NUBO)-UX1(J,NUBO))**2
 200               CONTINUE
                   DEVIT = DEVIT + SQRT(DEVI)
                   DENO = DENO + 1.0
                END IF
 220         CONTINUE
           END IF
           IF (DENO. GT. 0.0) THEN
              REDEV (I) = DEVIT / DENO
           ELSE
              REDEV(I) = 999.999999
              IF(IAMCON.EQ.1) WRITE(JOUT,33633) I
33633      FORMAT ('ALL HVY: No deviations computed for residue ',i4)
           END IF
C************   DR   10/90************************************
C ALL HEAVY atoms fitted; now calculating deviations for whole residue
           DEPIT = 0.0
           DEPO= 0.0
           DO 230 K=NPRE(I)+1, NPRE(I+1)
C                KI = K - NPRE(I)
               IF ( ALPH(K)(1:1).EQ.'H')THEN
C                 WRITE(JOUT,16550) KI, K, I
                  GOTO 230
               ENDIF
               DEPI = 0.0
               DO 201 J=1,3
                  DEPI=DEPI+(X2_AL(J,K)-UX1_AL(J,K))**2
 201           CONTINUE
               DEPIT = DEPIT + SQRT (DEPI)
               DEPO = DEPO + 1.0
C*************************************************************
 230        CONTINUE
C************   DR   10/90************************************
            IF (DEPO. GT. 0.0) THEN
               REDEP(I) = DEPIT / DEPO
            ELSE
               REDEP(I) = 999.999999
              IF(IAMCON.EQ.1) WRITE(JOUT,3435) I
3435           FORMAT ('WARNING - ALL HVY. FITTING: no deviations',
     &         ' computed for residue ',i4)
            END IF
C************   DR   10/90************************************
            WRITE (JHEDEV,1560) I, REDEV(I), REDEP(I)
 240      CONTINUE
C
          IF (PDB_ALIGN_HVY) THEN 
C  PRINTING OF COORDINATES AFTER ALIGNMENT WAS REQUESTED.
            IF (IAMCON.EQ.1) THEN
C  WRITE XRAY COORDINATES IN FIRST PLACE.
              DO 255 I=1,NATMOM
                DO 290 J=1,3
                  COORD(J,I) = X2_AL(J,I) 
 290            CONTINUE
255           CONTINUE
              CALL NUMSTR(IZERO,NUMM)
              CALL CONCAT(CPREF,NUMM,CFF)
              COORPREF=CFF
              NO_HYD_SET0=0
              if (.NOT.NO_HYDRG)  THEN
                 NO_HYDRG=.TRUE.
                 NO_HYD_SET0=1
              ENDIF
              CALL OUTNW(IZERO,ITREIN,IZERO)
              IF(NO_HYD_SET0.EQ.1) NO_HYDRG=.FALSE.
              COORPREF=CPREF
            END IF

C  PASS COORDINATES OF CONFORMATION AFTER ALIGNMENT FOR PRINTING.
            DO 280 I=1, NATMOM
              DO 291 J=1,3
                COORD(J,I) = UX1_AL(J,I) 
 291          CONTINUE
 280        CONTINUE
          END IF
C
        ENDIF
        WRITE(JOUT,1420) METHOD_RMS, RMS
 1420   FORMAT ( ' RMS (',A6,') ALL HEAVY ATOMS ', 1E15.6 )
C END ALL HVY
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C
C
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      ELSE IF(IPR.EQ.2) THEN
C   II      ALPHA CARBONS 
C        WRITE(JOUT,7810) 
C7810    FORMAT (' ALPHA CARBONS ' )
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C     SELECT CA'S
C******************DR 10/90 *******************************
C SEE IF WE CAN ALIGN ALL THE ATOMS.  DR   10/90
        DO 286 I=1, NATMOM
           DO 296 J=1,3
              X1_AL(J,I) = COORD(J,I)
              X2_AL(J,I) = XCOR(J,I)
 296       CONTINUE
 286    CONTINUE
C**********************************************************
 390    NUCA = 0
        DO 420 I=KK1,LRESD
           IF ( I.EQ.1 .OR. I.EQ.INUMRS) GOTO 420
           NCAX = NPRE(I) + 3
           IF ( ICON(NCAX).EQ.1 ) THEN
              NUCA = NUCA + 1
              DO 400 J=1,3
                X1(J,NUCA) = COORD(J,NCAX)
                X2(J,NUCA) = XCOR(J,NCAX)
400           CONTINUE
           END IF
420     CONTINUE
        DO 440 J=1,NUCA
           DEN(J) = 0.0
           DK(J) = 0.0
           DO 442 K=1,NUCA
             DISDEL(K,J)=99.999
442        CONTINUE
440     CONTINUE
        IATMCD = NUCA
C         WRITE(JOUT,'(3F15.6)') ((X1(J,I),J=1,3),I=1,IATMCD)
C         WRITE(JOUT,'(3F15.6)') ((X2(J,I),J=1,3),I=1,IATMCD)

        IF (IATMCD.EQ.0) THEN
          RMS= 0.00
          RM22 = 0.0
          WRITE(JOUT,5410)
5410      FORMAT ('NO ATOMS TO EVALUATE RMS FOR C-ALPHA',
     &     ' FROM RESIDUES ',i5,' TO ',i5)
        ELSE
          IF (METHRMS.EQ.1)  THEN
             CALL KABSCH  ( RMS )
          ELSE IF (METHRMS.EQ.2) THEN 
             CALL GOLUB  ( RMS, FAIL )
             IF (FAIL) RETURN
          ENDIF
          WRITE(JOUT,'(A20,I4)') 'NO. OF CA ATOMS= ', IATMCD

C RGXCA AND RGY  ARE THE RADIA OF GYRATION OF THE XRAY AND THE
C CONSIDERED CONFORMATION CALCULATED BY USING THE C ALPHA.
          IF ( IAMCON.EQ.1) CALL RGYR(IZERO,RGXCA)
          CALL RGYR (IAMCON,RGY)

          IF (DIST_RMS) THEN
            RM22 = 0.0
            DO 480 I=1,NUCA-1
             DO 481 J=I+1,NUCA
                DI = 0.0
                DJ = 0.0
                DO 460 K=1,3
                  DI = DI + ( X1(K,I)-X1(K,J))**2
                  DJ = DJ + ( X2(K,I)-X2(K,J))**2
460             CONTINUE
C               DELTA =  ( SQRT(DI)-SQRT(DJ))**2
                DELTD =  ABS( SQRT(DI)-SQRT(DJ) )
                DELTA =  DELTD**2
                DISDEL(I,J) =  DELTD
                DISDEL(J,I) =  DELTD
                RM22 = RM22 + DELTA
                DEN(J-I) = DEN(J-I) + 1.0
                DK(J-I) = DK(J-I) + DELTA
481          CONTINUE
480         CONTINUE
            RM22 = DSQRT ( RM22*2.0/ DFLOAT(NUCA*(NUCA+1)) )
            WRITE(JOUT,1490) RM22
1490        FORMAT ( 'DISTANCE RMS ALPHA CARBONS', 1E15.6 )

            WRITE(JCMSKD,1680)
1680  FORMAT ('MANFRED SIPPL"S DKs',/,' Residue           DK     ')
            DO 500 J=1,NUCA-1
               IF ( DEN(J).GE.1.0) THEN
                 DK(J) = SQRT ( DK(J) / DEN(J) )
                 WRITE(JCMSKD,1500) J , DK(J)
1500             FORMAT ( I5,5X, F15.7)
               END IF
500         CONTINUE
            WRITE(JCMSKD,1681)
1681  FORMAT (' Residue           DK     ')
            DO J=1,NUCA
               WRITE(JCMSKD,'(10F8.3)') (DISDEL(K,J), K=1,NUCA)
            ENDDO
          ENDIF

C    CALCULATE DEVIATIONS PER RESIDUE
          WRITE(JKMSBA,1540) IAMCON
1540  FORMAT (/,'CONFORMATION #',I4,6X,' C-ALPHAS ',6x,'  ALL ATOMS',
     &        /,'   RESIDUE    ',  10X,'    RMS  ',6x,'     RMS'/)
          NUCA = 0
          DO 540 I=1,INUMRS
            DEVIT = 0.0
            DENO= 0.0
            NCAX = NPRE(I) + 3
            IF ( (I.GE.KK1 .AND. I.LE.LRESD) .AND. 
     &       (I.NE.1 .AND. I.NE.INUMRS) .AND. (ICON(NCAX).EQ.1)) THEN
                NUCA = NUCA + 1
                DEVI = 0.0
                DO 520 J=1,3
                     DEVI = DEVI +(X2(J,NUCA)-UX1(J,NUCA))**2
 520            CONTINUE
                REDEV(I) = SQRT ( DEVI )
            ELSE
                REDEV(I) = 999.999999
            ENDIF

C************   DR   10/90************************************
C C-ALPHA atoms fitted; now calculating deviations for whole residue
            DEPIT= 0.0
            DEPO= 0.0
            DO 3310 K=NPRE(I)+1, NPRE(I+1)
C               KI = K - NPRE(I)
               IF(ALPH(K)(1:1).EQ.'H')THEN
C                 WRITE(JOUT,16550) KI, K, I
                  GOTO 3310
                ENDIF
                DEPI = 0.0
                DO 221 J=1,3
                   DEPI = DEPI + ( X2_AL(J,K)-UX1_AL(J,K))**2
 221            CONTINUE
                DEPIT = DEPIT + SQRT (DEPI)
                DEPO = DEPO + 1.0
3310        CONTINUE
            IF (DEPO. GT. 0.0) THEN
              REDEP (I) = DEPIT / DEPO
            ELSE
              REDEP(I) = 999.999999
              IF(IAMCON.EQ.1) WRITE(JOUT,8465) I
8465          FORMAT ('WARNING - C-ALPHA FITTING: no deviations were',
     &        ' computed for residue ',i4)
            END IF
            WRITE(JKMSBA,1560) I, REDEV(I), REDEP(I)
C************   DR   10/90************************************
 540      CONTINUE

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
          IF (CA_TRACE) THEN
C   WRITE A CA TRACE                     D.R  11/90
            IF (IAMCON.EQ.1) THEN
              WRITE(JCHEFO,3327)
3327          FORMAT('REMARK  XRAY OR "PATRON", CA TRACE')
              IATN=0
              DO 9455 I=1, NATMOM
               IF ( I.NE.1 .AND. I.NE.INUMRS) THEN
                 IATN=IATN+1
                 IATM=IATM+1
                 NCAX = NPRE(I) + 3
                 WRITE(JCHEFO,3328)IATM,IATN,(X2_AL(J,NCAX),J=1,3)
3328             FORMAT('ATOM',I7,2X,'CA ',1X,'RES',I6,4X,3F8.3)
               END IF
9455          CONTINUE
            END IF
            WRITE(JCHEFO,3326) IAMCON
3326        FORMAT('REMARK  CA TRACE  OF CONFORMATION NO ',I4)
            IATN=0
            DO 9420 I=1, NATMOM
              IF ( I.NE.1 .AND. I.NE.INUMRS) THEN
                IATN=IATN+1
                IATM=IATM+1
                NCAX = NPRE(I) + 3
                WRITE(JCHEFO,3328)IATM,IATN,(UX1_AL(J,NCAX),J=1,3)
              END IF
9420        CONTINUE

CD          IF (IAMCON.EQ.1) THEN
CD           WRITE(45,3327)
CD           DO 455 I=1,NUCA
CD                WRITE(45,3328) I, I, ( X2(J,I),j=1,3)
CD455        CONTINUE
CD          END IF
CD          WRITE(45,3326)    IAMCON
CD          DO 456 I=1,NUCA
CD           WRITE(45,3328) I,I, (UX1(J,I),j=1,3)
CD456       CONTINUE

          END IF

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
          IF (PDB_ALIGN_CA) THEN
C  PRINTING OF COORDINATES AFTER ALIGNMENT WAS REQUESTED.
            IF ((IAMCON.EQ.1).AND. (IFORM.NE.6)) THEN
C  WRITE XRAY COORDINATES IN FIRST PLACE.
              DO 356 I=1,NATMOM
                DO 357 J=1,3
                  COORD(J,I) = X2_AL(J,I)
 357            CONTINUE
 356           CONTINUE
               CALL NUMSTR(IZERO,NUMM)
               CALL CONCAT(CPREF,NUMM,CFF)
               COORPREF=CFF
               IF (.NOT.NO_HYDRG)  THEN
                  NO_HYDRG=.TRUE.
                  NO_HYD_SET0=1
               ENDIF
               CALL OUTNW(IZERO,ITREIN,IZERO)
               IF(NO_HYD_SET0.EQ.1) NO_HYDRG=.FALSE.
               COORPREF=CPREF
            END IF

C  PASS COORDINATES OF CONFORMATION AFTER ALIGNMENT FOR PRINTING.
            DO 580 I=1, NATMOM
               DO 590 J=1,3
                 COORD(J,I) = UX1_AL(J,I) 
 590           CONTINUE
 580        CONTINUE
          END IF

        ENDIF
        WRITE(JOUT,1430) METHOD_RMS, RMS
 1430   FORMAT ( ' RMS (',A6,')  ALPHA CARBONS ', 1E15.6 )

C   END C-ALPHA's
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C
C
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      ELSE IF(IPR.EQ.3) THEN

C    III    BACKBONE  ATOMS 

C        WRITE(JOUT,7820) 
C7820    FORMAT ('  BACKBONE  ATOMS ' )
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


C******************DR 10/90 *******************************
C SEE IF WE CAN ALIGN ALL THE ATOMS.  DR   10/90
        DO 686 I=1, NATMOM
         DO 696 J=1,3
              X1_AL(J,I) = COORD(J,I)
              X2_AL(J,I) = XCOR(J,I)
 696     CONTINUE
 686    CONTINUE
C**********************************************************
        NUBO = 0
        DO 740 I=KK1,LRESD
C     SELECT BACKBONE  ATOMS
         IF ( I.EQ.1 .OR. I.EQ.INUMRS) THEN
              NLASTA = NPRE(I+1)-NPRE(I)
         ELSE
              NLASTA = 7
         ENDIF
         DO 720 K=1,NLASTA
              NPI = NPRE(I) + K
              IF ( ALPH(NPI)(1:1).EQ.'H')THEN
c                  WRITE(JOUT,16550) K, I, NPI
                   GOTO 720
              ENDIF
              IF ( ICON(NPI) .EQ. 1) THEN
                   NUBO = NUBO +1
                   DO 700 J=1,3
                        X1(J,NUBO) = COORD(J,NPI)
                        X2(J,NUBO) = XCOR (J,NPI)
700                CONTINUE
              END IF
720      CONTINUE
740     CONTINUE
        IATMCD = NUBO

        IF (IATMCD.EQ.0) THEN
          RMS= 0.0
          RM22 = 0.0
          WRITE(JOUT,5430) KK1, LRESD
5430      FORMAT ('NO ATOMS TO EVALUATE RMS FOR BK HVY ATS ',
     &     ' FROM RESIDUES ',i5,' TO ',i5)
        ELSE
          IF (METHRMS.EQ.1)  THEN
             CALL KABSCH  ( RMS )
          ELSE IF (METHRMS.EQ.2) THEN 
             CALL GOLUB  ( RMS, FAIL )
             IF (FAIL) RETURN
          ENDIF
          WRITE(JOUT,'(A20,I4)') 'NO. OF BCK. ATOMS= ', IATMCD
C RGXBH AND RGY  ARE THE RADIA OF GYRATION OF THE XRAY AND THE
C CONSIDERED CONFORMATION CALCULATED BY USING THE BKBONE. HEAVY ATOMS.
          IF ( IAMCON.EQ.1) CALL RGYR(IZERO,RGXBH)
          CALL RGYR (IAMCON,RGY)

          IF (DIST_RMS) THEN
            RM22 = 0.0
            DO 759 I=1,NUBO-1
               DO 761 J=I+1,NUBO
                 DI = 0.0
                 DJ = 0.0
                 DO 762 K=1,3
                   DI = DI + ( X1(K,I)-X1(K,J))**2
                   DJ = DJ + ( X2(K,I)-X2(K,J))**2
  762            CONTINUE
                 DELTA = ( SQRT(DI)-SQRT(DJ))**2
                 RM22 = RM22 + DELTA
  761          CONTINUE
  759       CONTINUE
            RM22 = DSQRT ( RM22*2.0/ DFLOAT(NUBO*(NUBO+1)) )
            WRITE(JOUT,2480) RM22
2480        FORMAT ( 'DISTANCE RMS BACKBONE ATOMS', 1E15.6)
          ENDIF
C
C    CALCULATE DEVIATIONS PER RESIDUE
          WRITE(JBADEV,1600) IAMCON
1600  FORMAT (/,'CONFORMATION #',I4,6X,' BACKBONE',6x,'  ALL ATOMS',
     &        /,'   RESIDUE    ',  10X,'    RMS  ',6x,'     RMS'/)
          NUBO = 0
          DO 770 I=1,INUMRS
           DENO = 0.0
           DEVIT = 0.0
           IF(I.GE.KK1.AND.I.LE.LRESD) THEN
            IF ( I.EQ.1 .OR. I.EQ.INUMRS) THEN
              NLASTA = NPRE(I+1)-NPRE(I)
            ELSE
              NLASTA = 7
            ENDIF
            DO 760 K=1, NLASTA
              NPI = NPRE(I) + K
              IF ( ALPH(NPI)(1:1).EQ.'H')THEN
c                   WRITE(JOUT,16550) K,I,NPI
                   GOTO 760
              ENDIF
16550         FORMAT(' Hydrogen No. ',i2,' at residue ',i4,
     &                ' discarded;  atom No. ',I4)
              IF ( ICON(NPI) .EQ. 1) THEN
                   NUBO = NUBO + 1
                   DEVI = 0.0
                   DO 750 J=1,3
                        DEVI = DEVI + (X2(J,NUBO)-UX1(J,NUBO))**2
 750               CONTINUE
                   DEVIT = DEVIT + SQRT ( DEVI )
                   DENO = DENO + 1.0
               END IF
 760        CONTINUE
           ENDIF
           IF (DENO. GT. 0.0) THEN
              REDEV(I) = DEVIT / DENO
           ELSE
              REDEV(I) = 999.999999
              IF(IAMCON.EQ.1) WRITE(JOUT,33673) I
33673      FORMAT ('BACK: No deviations computed for residue ',i4)
           END IF
C************   DR   10/90************************************
C  BACKBONE atoms fitted; now calculating deviations for whole residue
            DEPIT= 0.0
            DEPO= 0.0
            DO 3810 K=NPRE(I)+1, NPRE(I+1)
C             KI = K - NPRE(I)
              IF ( ALPH(K)(1:1).EQ.'H')THEN
C                 WRITE(JOUT,16550) KI, K, I
                  GOTO 3810
              ENDIF
              DEPI = 0.0
              DO 781 J=1,3
                  DEPI = DEPI + ( X2_AL(J,K)-UX1_AL(J,K))**2
 781          CONTINUE
              DEPIT = DEPIT + SQRT (DEPI)
              DEPO = DEPO + 1.0
3810        CONTINUE
            IF (DEPO .GT. 0.0) THEN
              REDEP (I) = DEPIT / DEPO
            ELSE
              REDEP(I) = 999.999999
              IF(IAMCON.EQ.1) WRITE(JOUT,9465) I
9465           FORMAT ('WARNING - BACKBONE FITTING: no deviations ',
     &                   'computed for residue ',i4)
            END IF
C************   DR   10/90************************************
            WRITE(JBADEV,1560) I, REDEV (I), REDEP(I)
 770      CONTINUE

          IF (PDB_ALIGN_BACK) THEN
C  PRINTING OF COORDINATES AFTER ALIGNMENT WAS REQUESTED.
            IF (IAMCON.EQ.1) THEN
C  WRITE XRAY COORDINATES IN FIRST PLACE.
              DO 775 I=1,NATMOM
                DO 776 J=1,3
                  COORD(J,I) = X2_AL(J,I)
 776            CONTINUE
775           CONTINUE
              CALL NUMSTR(IZERO,NUMM)
              CALL CONCAT(CPREF,NUMM,CFF)
              COORPREF=CFF
              IF (.NOT.NO_HYDRG)  THEN
                 NO_HYDRG=.TRUE.
                 NO_HYD_SET0=1
              ENDIF
              CALL OUTNW(IZERO,ITREIN,IZERO)
              IF(NO_HYD_SET0.EQ.1) NO_HYDRG=.FALSE.
              COORPREF=CPREF
            END IF

C  PASS COORDINATES OF CONFORMATION AFTER ALIGNMENT FOR PRINTING.
            DO 780 I=1, NATMOM
               DO 790 J=1,3
                 COORD(J,I) = UX1_AL(J,I) 
 790           CONTINUE
 780        CONTINUE
          END IF

        ENDIF
        WRITE(JOUT,1440) METHOD_RMS, RMS
 1440   FORMAT ( ' RMS (',A6,')  BACKBONE HEAVY ATOMS ', 1E15.6 )

C   END BACKBONE
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C
C
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      ELSE IF(IPR.EQ.4) THEN

C  IV     SIDE-CHAIN HEAVY ATOMS

C        WRITE(JOUT,7830) 
C7830    FORMAT (' SIDE-CHAIN HEAVY ATOMS ' )
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


C******************DR 10/90 *******************************
C SEE IF WE CAN ALIGN ALL THE ATOMS.  DR   10/90
        DO 786 I=1, NATMOM
         DO 796 J=1,3
              X1_AL(J,I) = COORD(J,I)
              X2_AL(J,I) = XCOR(J,I)
 796     CONTINUE
 786    CONTINUE
C**********************************************************
C     SELECT SIDE-CHAIN HEAVY ATOMS
        NUBO = 0
        DO 840 I=KK1, LRESD
           IF ( I.EQ.1 .OR. I.EQ.INUMRS) GOTO 840
           DO 820 K=NPRE(I)+8, NPRE(I+1)
              NPI = K
              IF ( ICON(NPI) .EQ. 1) THEN
                   NUBO = NUBO +1
                   DO 800 J=1,3
                        X1(J,NUBO) = COORD(J,NPI)
                        X2(J,NUBO) = XCOR (J,NPI)
800                CONTINUE
              END IF
820        CONTINUE
840     CONTINUE
        IATMCD = NUBO
        IF (IATMCD.EQ.0) THEN
          RMS= 0.00
          RM22 = 0.0
          WRITE(JOUT,5440) KK1, LRESD
5440  FORMAT ('NO ATOMS TO EVALUATE RMS FOR SIDE-CHAIN HVY ATS.',
     &     ' FROM RESIDUES ',i5,' TO ',i5)
        ELSE
          IF (METHRMS.EQ.1)  THEN
             CALL KABSCH  ( RMS )
          ELSE IF (METHRMS.EQ.2) THEN 
             CALL GOLUB  ( RMS, FAIL )
             IF (FAIL) RETURN
          ENDIF
          WRITE(JOUT,'(A26,I4)') 'NO. OF SIDE-CHAIN ATOMS= ', IATMCD
C RGXSH AND RGY  ARE THE RADIA OF GYRATION OF THE XRAY AND THE
C CONSIDERED CONFORMATION CALCULATED BY USING THE SIDE CHAIN HEAVY
C ATOMS.
          IF ( IAMCON.EQ.1) CALL RGYR (IZERO,RGXSH)
          CALL RGYR (IAMCON,RGY)
C
          IF (DIST_RMS) THEN
            RM22 = 0.0
            DO 865 I=1,NUBO-1
               DO 866 J=I+1,NUBO
                 DI = 0.0
                 DJ = 0.0
                 DO 867 K=1,3
                   DI = DI + ( X1(K,I)-X1(K,J))**2
                   DJ = DJ + ( X2(K,I)-X2(K,J))**2
  867            CONTINUE
                 DELTA = ( SQRT(DI)-SQRT(DJ))**2
                 RM22 = RM22 + DELTA
  866          CONTINUE
  865       CONTINUE
            RM22 = DSQRT ( RM22*2.0/ DFLOAT(NUBO*(NUBO+1)) )
            WRITE(JOUT,3480) RM22
3480        FORMAT ( 'DISTANCE RMS HVY SIDE-CHAIN ATOMS', 1E15.6)
          ENDIF
C
C    CALCULATE DEVIATIONS PER RESIDUE
          WRITE(JSIDEV,1620) IAMCON
1620  FORMAT (/,'CONFORMATION #',I4,6X,'SIDECHAIN',6x,'  ALL ATOMS',
     &        /,'   RESIDUE    ',  10X,'    RMS  ',6x,'     RMS'/)
          NUBO = 0
          DO 870 I=1,INUMRS
           DENO = 0.0
           DEVIT = 0.0
           IF(I.GE.KK1.AND.I.LE.LRESD) THEN
              IF (I.NE.1 .AND. I.NE.INUMRS) THEN
                DO 861 K=NPRE(I)+8, NPRE(I+1)
                  NPI = K
                  IF ( ICON(NPI) .EQ. 1) THEN
                      NUBO = NUBO + 1
                      DEVI = 0.0
                      DO 850 J=1,3
                        DEVI = DEVI + (X2(J,NUBO)-UX1(J,NUBO))**2
 850                  CONTINUE
                      DEVIT = DEVIT + SQRT ( DEVI )
                      DENO = DENO + 1.0
                  END IF
 861            CONTINUE
              END IF
           END IF
           IF (DENO. GT. 0.0) THEN
              REDEV(I) = DEVIT / DENO
           ELSE
              REDEV(I) = 999.999999
              IF(IAMCON.EQ.1) WRITE(JOUT,33633) I
           END IF

C************   DR   10/90************************************
C  SideChain atoms fitted; now calculating deviations for whole residue
           DEPIT= 0.0
           DEPO= 0.0
           DO 3910 K=NPRE(I)+1, NPRE(I+1)
C             KI = K - NPRE(I)
              IF ( ALPH(K)(1:1).EQ.'H')THEN
C                 WRITE(JOUT,16550) KI, K, I
                  GOTO 3910
              ENDIF
              DEPI = 0.0
              DO 822 J=1,3
                   DEPI = DEPI + ( X2_AL(J,K)-UX1_AL(J,K))**2
 822          CONTINUE
              DEPIT = DEPIT + SQRT (DEPI)
              DEPO = DEPO + 1.0
3910       CONTINUE
           IF (DEPO. GT. 0.0) THEN
              REDEP(I) = DEPIT / DEPO
           ELSE
              REDEP(I) = 999.999999
              IF(IAMCON.EQ.1) WRITE(JOUT,9565) I
9565          FORMAT ('WARNING - SIDE CHAINS FITTING: no deviations',
     &           ' computed for residue ',i4)
           END IF
           WRITE(JSIDEV,1560) I, REDEV(I), REDEP(I)
 870      CONTINUE
C
          IF (PDB_ALIGN_SIDE) THEN
C  PRINTING OF COORDINATES AFTER ALIGNMENT WAS REQUESTED.
            IF (IAMCON.EQ.1) THEN
C  WRITE XRAY COORDINATES IN FIRST PLACE.
              DO 875 I=1,NATMOM
                DO 876 J=1,3
                  COORD(J,I) = X2_AL(J,I)
876             CONTINUE
875           CONTINUE
              CALL NUMSTR(IZERO,NUMM)
              CALL CONCAT(CPREF,NUMM,CFF)
              COORPREF=CFF
              IF (.NOT.NO_HYDRG)  THEN
                 NO_HYDRG=.TRUE.
                 NO_HYD_SET0=1
              ENDIF
              CALL OUTNW(IZERO,ITREIN,IZERO)
              IF(NO_HYD_SET0.EQ.1) NO_HYDRG=.FALSE.
              COORPREF=CPREF
            END IF
C  PASS COORDINATES OF CONFORMATION AFTER ALIGNMENT FOR PRINTING.
            DO 880 I=1, NATMOM
               DO 890 J=1,3
                 COORD(J,I) = UX1_AL(J,I) 
 890           CONTINUE
 880        CONTINUE

          ENDIF
        ENDIF
        WRITE(JOUT,1520) METHOD_RMS, RMS
1520    FORMAT (' RMS (',A6,')  SIDE-CHAIN HEAVY ATOMS ', 1E15.6)
      ELSE 
        WRITE (JOUT, '(A,I4)') 'UNRECOGNIZED OPTION ', IPR
      END IF
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C
C
      RETURN

1560  FORMAT (3X, I4,14X, F12.3,4x,f12.3)

      END
