      SUBROUTINE RMSCONST(LGPRINT) 
! Calculate distance terms. Modification of DISFF   
!
! constraint energy is:
!            Econs= 1/2 * WEI_RMSD * Sum    [ (| rj - Rj|)^2]
!                                   j E {pairs}
!
! with rj and Rj coordinates of atoms from target and reference, respectively 
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.GEN100'
      include 'COMMON.ATOMSS'
      include 'COMMON.CALC'
      include 'COMMON.DERIV'
c     include 'COMMON.THRLET'
      include 'COMMON.IOUNIT'
      include 'COMMON.RMSFIT'
      include 'COMMON.RMSCNST'
      logical lgprint
      real da(3)
      data dimax /1.0E+12/, dimin /-1.0e-10/
      data dixmin /1.0e-1/

      do i=1, npre(inumrs+1)
! only atoms that can be fitted to the reference [icon(i)=1] will be considered
         if (icon(i) .eq.1) then
            dsq=0.0
            do j=1, 3
               dx=coord(j,i) -xcor(j,i)
               dsq=dsq + dx**2
               da(j)=dx
            enddo
            if (abs(dsq).lt. 1E-10) then 
               di=0.0
            else
               diinv=1./sqrt(dsq)
               di=1./diinv
            endif
            if (( di.gt.dimax).or.(di.lt.dimin)) write(*,*) 
     &       'ERROR RMSCONST ',' d(',i,')= ', di

            if (di.gt. dixmin) then
! dixmin is the minimum distance between reference and target atoms
! a value gt dixmin required this distance to be penalized.

               TERDS = (di-dixmin)
               TDIS = TERDS**2
               ermsd=ermsd+.5*tdis*wei_rmsd
               dfacx=diinv*wei_rmsd
               dtrm=TERDS*dfacx
               do k=1,3
                  dadd=dtrm*da(k)
                  if (abs(dadd).gt. 1.0e+05) then
                     if (icout.eq.0) then
                        icout=1
                        write(*, *) 'RMS_CONST:',
     &                       ' ATOM(',i,')large factor dadd=', dadd
                     endif
                     dadd = 1.0e+05*sign(1.0,dadd)
                  endif
!                 if (i.lt. npre(2)) dadd =-dadd
                  cge(k,i,icg)=cge(k,i,icg)+dadd
               enddo
               if(lgprint) write(JOUT,*) 'atom=',i,' dstance=',di
            endif
         endif
      enddo
      end
