      SUBROUTINE SET_DEFAULTS
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.MINPAR'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.EXTPH'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.OMTOR'
      INCLUDE 'COMMON.THERMO'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.BIAS'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.SCAN'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.KVS'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.BRAIN'
      INCLUDE 'COMMON.PRTBKTK'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.DISTCO'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.CLUSTAT'
      INCLUDE 'COMMON.CLUSTER'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.RMSPDB'
      EXTERNAL ILEN
      CHARACTER*64 OUTF
#ifdef PHCALC
      INCLUDE 'COMMON.CALC'
      INCLUDE 'param.ibems'
      INCLUDE 'assign_qr.h'
      INCLUDE 'comm.ibemsav'
      INCLUDE 'comm.ibems'
#endif
#ifdef MP
      integer lentsk
C     include '/usr/include/fexcp.h'
      include 'PARAMET.MP'
      include 'COMMON.MP'
      character*3 tasknu

      call numstr(taskid,tasknu)
      lentsk=ilen(tasknu)
      Highest=0
#endif

C Supress debugging. Set LPRNT to .true. intead of this, if you want extensive
C diagnostic output. This will however be very much!
      LPRNT=.FALSE.
      LPTOR=.FALSE.
C By default only energy will be evaluated
      IRUNTYP=1
C Set default time limit
      BATIME=10.0**10
C Set defaults for the parameters that control printing of Cartesian coords.
      PRINT=.FALSE.
C The sequence is by default read in ECEPP code
      ICODE=1
C All dihedral angles will be varied by default
      IVARFLAG=3
C No printing of atom exposed surfaces by default 
      ISFOUT=0
      ETHRESH=.1E+30
*******************************************************
C Defaults for force field
      IREP=0
C  use ECEPP potential (not the simplified one) 
      SIMPLE_POT=.FALSE.
C  COEN is the contact energy in Kcal/mol.
      COEN=10.0
      ICOMP(1)=1

      ICOMP(2)=0
      ICOMP(3)=0
      ICOMP(4)=0
      OMCON=.FALSE.
      FORCON=0.0
      INTOR=1
      TSTART=0.0
      TEND=0.0
      SURDER=.FALSE.
      PHS=0.0
      ICUTOFF=1
      VARDIEL=.FALSE.
      NONOVERLAP_ENE=.FALSE.
C No pre-minimization as a default.
      OVER_CUTOFF=0.0
C
C Set default prefix for Cartesian-coordinate filenames.
C 9/25/96 AL
C Grab OUTF from recepp.s instead of setting to arbitrary string
C
      call getenv('OUTF',outf)
      len_outf=ilen(outf)
#ifdef MP
      COORPREF=outf(:len_outf)//tasknu(:lentsk)//'coords'
C     COORPREF='tsk'//tasknu(:lentsk)//'coords'
#else
      COORPREF=outf(:len_outf)
C     COORPREF='coords'
#endif
C Eliminate Hydrogens in PDB files (default is write them).
      NO_HYDRG=.FALSE.
C
C  Compute Free_energy
      lfree_ene=.false.

C Defaults for minimizers
      IMIN=1
      MAXFUN=1000
      MAXIT=1000
      AMAXSTEP=4.0
      VTNER1=0.1
      ABSTOL=0.001
      RELTOL=0.00001
      IDSCALE=0
      DVALUE=4.0
      DO I=1,5
        IPRINT(I)=0
      ENDDO
********************************************************
C Defaults for the Monte Carlo procedure

      MOVANG=2
      ISEED=-4493211
      BACKUP=3600.0
      RESTART=.FALSE.
      LICZM=200
      ICHCNF=0
      ARBT=0.1
      NREPMM=50
      NRANM=100
      NTERMM=20
      MAXEL=400
      EFINAL=-10000.0
      TLOW=1000.0
      TUP=1000.0
      NSTEPC=0
      NSTEPH=0
      NWIND=0
      NPRINT_ELEC=10
      OMPROB=5000.0
      POMGPPRO=0.3
      NUMDEF=0
      EXCPRH=0.5
C Backbone backtracking.
      ITYPBK=1
C Max. no of variables changed at the same time during backtracking
C is equal to mxbktrc+2
      MXBKTRC=5
C logical variables used in routine PERTURB during backtracking.
      BKTKPR=.TRUE.
C Percentage of randomly-generated conformations  with dihedral angles
C forming regular structures, i.e. helices or sheet.
      REGSTRUC= 0.1
C Percentage of randomly-generated conformations  with dihedral angles
C selected using the PHI-PSI map.
      PHIPSIMAP= 0.6
C MAXKZIMM is the maximum number of times that the same backbone
C conformation  can be accepted. When this limit is attained, the
C conformations with same Zimmerman code are rejected, unless is
C an improvement on the current global minimum.    
      MAXKZIMM=20
C By default all residues are assumed to prefer trans configuration.
      DO I=1,MAXNUM_RES
        OMREF(I)=180.0
      ENDDO
C As a default, the omegas of Pro and N-Met residues will not be 
C searched (promet=.false.)
      PROMET=.FALSE.
C print information about distance and dihedral angle constraints 
C on every iteration.
      nprnt_cnst = 1
C Energy similarity criterion. Conformations  will be rejected if their
C energies are within the range [(Ecurr - ecrit),(Ecurr + ecrit)]
      ecrit = 0.00015 
********************************************************
C  Bridges
C Set the number of bridges at zero as a default
      NLOOP=0
C
********************************************************
C No chi-angle scanning as a default!
      NREAD=0
C No distance constraints during sampling except those implied by the 
C presence of bridges.
      WITHCNST=.FALSE.
C Constraints are read from ECEPP FILE, thus, the flag indicating to
C read form congen file is set to false.  
      ECEPPCF =.TRUE.
      CONGENF=.FALSE.
C
      NHPB=0
      IS=0
      IE=0
C
C Default for Energy calculation, energy minimization and VTF. 
C  used in VTF to abort when error in X occur. DRR 3/98
      ERR_X=.false.
C Don't read multiple conformations.
      READCONFS= .FALSE.
C Don't generate random  conformations.
      ISTARTRND=0
C Default of the types of superposed atoms
      NNAT=1
      IDATT(1)='HEAVY'
      ChooseCluster=.9
      rcut = 0.5
      ncon = 0
      ngr = 0
C Set default prefix for "outo "files containing lowe energy conformers
C of tripeptides
      tripfile='tripep'
C
C Default for VTF and Distance Constraints.
C
C No group definition of protons.
      igroupNum=0
C No pairs of bounds to read in.
      NPAIR1=0
      NPAIR2=0
C INDEX counting molecules in congen input set to zero
      INDMOL =0
C    default for weight on distance constraints energy.
      WEI_ENE=1.0
C    default weight for dihedral-angle constraints energy.
      WEITORC=1.0
C Used torsional potential.
      IFLOV=0
C iorder=0       default; Order by range, a la Braun-Go
      IORDER=0
C  Only distance constraints up to rank irangmx will be used.
C  Default for irangmx should be set later to maximum no. of residues (INUMRS).
      IRANGMX=1000000
C  Original Max Vasquez program allows the definition of regions of
C sampling for each amino acids.
C J. of Biomol. Struc & Dyn. vol5 pp 757 (1988)
      REGSAMP=.FALSE.
C
C Minimization will be performed during VTF procedure.
      NOMINIM=.false.
C NO printing during energy and distance-constraint evaluations
      NUK=0
      NUKCO=0
C largest distance violation allowed in a conformation from a VTF calculation
      BIGGEST_VIO=1.0E+10
C number of VTF steps in which the maximum violation is allowed to excede
C  BIGGEST_VIO. (Usually, after some steps exceding this value, subsequent
C iterations may be able to reduce the error) 
      MAXVIOSTP= 10

#ifdef PHCALC
C  set  to zero parameters for records read on ibem (assign_qr.h)
      irtot=0
      ictot=0
      notread=.true.
C  set  counter for printing surfaces to zero.
      ikount=0
C  set default conformational entropy to zero
      evib=0.0d0
#endif
      RETURN
      END
