c SIMS: public
c Smooth Invariant Molecular Surface 
c Yury N Vorobjev , February 21, 1997
c All copyright reserved
c to obtain copy of SIMS contact
c (919)966-8625; Fax: (919)966-2852
c vorobjev@femto.med.unc.edu
c
c 
c.  Double precision input/output  arguments

       subroutine surf_sims(coords,
     &                 atom_rad,
     &                 ntoms,d_probe,dotden,
     &                 dotcrd,dotnrm,dotarea,
     &                 dot_IATNUM,dot_ISHAPE,ndots)

c INPUT:
c       coords(3,*) coord of atoms
c       atom_rad(*) atomic radii
c       ntoms      number of atoms
c       d_probe     probe diameter
c       dotden      dot density per A^2
c
c RESULT:
c       dotcrd(3,*) dot coords
c       dotnrm(3,*) normal vectors
c       dotarea(*)  dot area
c       dot_iatnum(*) atom number to which dot(*) belongs too
c       dot_ishape(*) face type (1,2,3 - contact, saddle, reentrant concave)
c                     to which dot(*) belongs too
c       ndots         number of dots on sufrace
c
c
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
        include'param.ibems'
        include'comm.ibems'
        
        real*8 atom_rad(*),coords(3,*),dotarea(*),
     &       dotcrd(3,*),dotden,dotnrm(3,*),d_probe

	integer ntoms,ndots

                                                      
c
c local VARIABLES:
c

        integer id,iatnn,nnnd
        integer iprint0,iprint1
c       integer kanalpl
	character*4 satom
	character*18 atomref
	character*6 dotsch
	real*8 badsurf_mx,badsurf,surfa,surf1,surf0
	real*8 athresh,athreshmx

	integer*2 ATint(3,maxnbr),BTint(3,ndotccmx,maxnbr)
	integer ndotconc_ijk(maxnbr)
	integer maxnbr1
	real*8  ATrea(6,maxnbr),BTrea(4,ndotccmx,maxnbr)
	logical*1 ATlgc(2,maxnbr),BTlgc(ndotccmx,maxnbr)

c SIMS:: probe positions and dots for this probe positions
	integer nprobpos,nprobpos_t
	integer probmax1,maxdot1
	integer*2 WPIIN(3,maxprob)
	real*8 WPPcAv(6,maxprob)
	logical*1 WPYONB(2,maxprob)
	integer start_dotn(maxprob)

	integer ndotccsd, ndotccsd_t
	integer*2 WDN123(3,maxdot)
	real*8 WDScAr(4,maxdot)     !WDScAr - xyz, area for dot
	logical*1 WDYON(maxdot)
	logical*1 WDYONRm(maxdot)   !flag .true. if dot have to be removed

        integer ndot_cc
        real*8 uvx(3)
        real*8 rpr,rpr2
	real*8 dot_vij,dot_vik,dot_vjk
        real*8 center(3)
        real*8 vpi_m(3),vpj_m(3),vpk_m(3)
        real*8 curv_triang_area
        real*8 area_cc
        real*8 dens
        real*8 vdot_cc(3,ndotccmx),vndot_cc(3,ndotccmx)
        real*8 area_dot_cc(ndotccmx)                  ! up to level 5

        logical OPT_CCdot_ProbProj
	logical OPT_CCdot_TriDiv
        real*8 OPT_triTetMx
        integer n_cc_tridiv,n_cc_PrbPrj
        integer nua(maxtyp)


        real*8 CO(3,maxat)
        real*8 radatm(maxat)
        real*8 atom_srf(maxat)
        integer IAS(maxat)
        integer*2 MOLNUM(maxat)
        integer*2 IAT(maxat)
        logical*1 SRS(maxat)
        integer*2 ICO(3,maxat),ICUPTR(maxat)
        integer*2 icol
        real*8 COMIN(3)
        integer*2 ICUBE(MAXCUB,MAXCUB,MAXCUB)
        logical*1 SCUBE(MAXCUB,MAXCUB,MAXCUB)
        logical*1 SSCUBE(MAXCUB,MAXCUB,MAXCUB)

        real*8 ERNBR(maxnbr)
        real*8 DISNBR(maxnbr)
        real*8 CNBR(3,maxnbr),RNBR(maxnbr)
        logical*1 SNBR(maxnbr),MNBR(maxnbr)
        integer*2 MOLNBR(maxnbr)
        integer*2 INBR(maxnbr)
        integer*2 LKNBR(maxnbr)
        integer*2 ITNL(maxnbr)
        real*8 UP(3,maxsph),TETP(maxsph)  !dots_xyz on Probe, teta 
        real*8 UA(3,maxchil,maxsph)       ! parent= children 1 
	real*8 dotchild(3,maxchil)        ! Coord of Children dots 
	real*8 dotchildr(3,maxchil)       ! Rotated Coord of Children dots 
	logical dotchsf(maxchil)          ! status flag of Children dots 
	logical dotchrf(maxchil)          ! rotation flag 
	real*8 ARUA(maxsph)               !area for dots 
	real*8 ARUP(maxsph)               !dot area on Probe sphere 
	integer NCHIUA(maxsph)            !number of child dots for this parent 
	integer NCHmx                     !max number of children dots
	integer NUV                       !number of parent dot on sphere 

        real*8 CI(3), CJ(3), CK(3)
        logical SI,SJ,SK,SNS

	real*8 Q1(3),UQ1(3),UT1(3),TVP(3)
        real*8 VIJ(3),UIJ(3),Q(3),T(3),CIJK(3),VIJK(3),UIJK(3)
        real*8 BIJ(3),AIJ(3),BIJK(3),AIJK(3,2),AIJP(3,2),A(3)
        real*8 P(3),PIJ(3),PIJP(3,2),PIJK(3,2),PIPT(3)
	real*8 PrPIJK(3)
        real*8 VPI(3),VPJ(3),VPK(3)
        real*8 VPS0(3,maxarc),VBS0(3,maxarc,2),VBS(3),ARCA(maxarc)
        real*8 VECTOR(3)
	real*8 RId,RJd,HIJd,DIJd
	real*8 RI2
	real*8 v0_arc(3,maxarc)
	logical dot_cross(maxarc)   
	real*8 H05(3,3),GH05GT(3,3) 
	real*8 rotate_angl
	real*8 arch,archI,archJ
	real*8 storanal        
	real*8 areaARC,areaARC_a
	real*8 areaSDnorm
	real*8 areaSADDLE_n,areaSADDLE_a
	real*8 areaCONCAVE,areaCONC_ij
	real*8 aa1,aa2,aa3,aa4,vbkat(3) !temporary variables
	real*8 saddle_angl_min
	real*8 cshift_k(3),ashift
	real*8 Ar_singularSD,Ar_singularCC
	real*8 ar_singCC_ij

	integer NARCT,narci,narcj
	integer ndotSADDLE
	integer ndotCONCAVE,ndotCONC_ij
	integer N_singularSD
	integer n_singulTor
	integer N_singularCC
	integer n_singCC_ij
	integer iconcf
	integer iavert,javert,kavert
	integer nijs_face        !temporary variables
	integer nsf,k1,k2,k3,isf,it,ich
	integer nn1,nn2,nn3
	integer putsmall
	logical arc_cross
	logical free_tor
	logical singularSD
	logical singularCC
	logical delete_pp
	logical doshift_k

	integer ntor_i(maxat)  !number of DIFFERENT torus for atom IATOM
	integer Jattor_i(maxnbr,maxat) !JATOMs which make torus with IATOM
	integer MAXntor_i
	integer frame_cx
	real*8  dot_aw(maxsph)
	real*8  dotCO(3,maxsph)
	real*8 sizeDot,sizeDot4,sizeDtet
	real*8 sizeBE,sizeDW
	real*8 Dstor_i(maxnbr,maxat) !Ds and Sign for torus JI, of IATOM
	real*8 delta(maxnbr) ! distance from CUTTINg plane
	real*8 range_cx    !range for refined cut
	real*8 sintet
	real*8 dotvUIJ
	integer RSwrite     !flag if Reentrant Surface was written
	integer OPT_sizeBE
	integer OPT_refcut
	integer itormx
	logical lastcut


         integer nconc_glob_mx
         integer nconc_ij_mx
	 integer ndotCCmax
         parameter (nconc_glob_mx=3*maxat)
         parameter (nconc_ij_mx=maxnbr)
	 parameter (ndotCCmax=128)    !max dots per one CC face
         integer  nconc_glob,nconc_ij
         integer  nvertex(maxat)                !number of vertexes for atoms
         integer  atvert_conc(maxnbr,maxat)     !vertex nmb point to CCf glnmb
         integer  conc_gl_ijk(6,nconc_glob_mx)
         integer nconc_glb_nprpos(nconc_glob_mx) !CCface glb nmb points to 
c	                                         !nprobpos glb nmb 
         integer  conc_ij_k(2,nconc_ij_mx) !local CCface nmb adjacent to IJ
c                                          !point to :1-KATOM,2-nconc_glob
	 integer  concf_ijf(nconc_ij_mx)   !Full list of glb CC nmb for ij pair
         real*8   cprobe_ijk(3,nconc_glob_mx)  !CC probe coord for CCface glb
         real*8 cvertex(3,maxnbr,maxat)  !vertex CRDtes for atoms

	 real*8 AREA_dotCC(ndotCCmax)

         integer  katt,kpos,icc                  !temporary var
         integer OPT_printcc,OPT_printsd
	 integer OPT_printcx
	 integer OPT_printrem
	 logical OPT_overlap_RE_remove
	 logical OPT_removeCC

       integer nbr_mx,iatm_mx,nconc_mx
       integer icfIJ,kref
       real*8 AIJarcS(3,maxnbr)
       real*8 GarcS(3,3,maxnbr)
       real*8 RotAng(maxnbr)
       integer SignRotS(maxnbr)

	integer nprob_mx
	integer ndot_mx 
	integer nconcij_mx

        real*8 G(3,3),H(3,3),GHGT(3,3),POW(3,3)
        
        real*8 S(3,maxppp),torus(maxppp)
        integer*2 N1(maxppp),N2(maxppp),N3(maxppp)
        logical*1 YON(maxppp)
        integer*2 IMOL
        integer*2 NP

        logical BOTH,PAIR(2),AYON(maxarc)
        logical FOUND
        logical*1 YONPRB
        logical*1 BURY
       
        real*8 PY(3,MAXYON),AY(3,MAXYON)
        real*8 PV(3,MAXVIC),AV(3,MAXVIC)
        integer*2 IVIC(MAXVIC),IVICP(MAXVIC)
        integer*2 MOLYON(MAXYON),MOLVIC(MAXVIC)


        integer*4 NIAS(3)
        integer*4 NSHAPE(3),NLOST(3)
	real*8 ARLOST(3)                 

        integer*2 IATNUM(3),ISHAPE
        integer*2 IB
        character*80 filnam
	character*10 number
	real*8 OUTCO(3),OUTVEC(3)

        logical COLLID
        logical BURIED

        real*8 D,RP,WIDTH,D2,AREAC,AREAR
        real*8 RI,SUNI,radMAX,FI,SUMI,HIJ
        real*8 VECT1,VECT2,VECT3,RJ
        real*8 DIJ,F1,F2,RK,DK,RIJK,DIJK
        real*8 HIJK,AREA,SIGN,DSI,DSJ,DSK
        real*8 RK2,RIJ,AVH,ANGLE,DUIJ,HT,DP
	real*8 ANGLE05
        real*8 DP2,RP2,X,Y,Z,SUM,F
	real*8 FIJ,FJI
	real*8 RNROT
	real*8 DPt,RP2t,DP2t

	logical compare_ijk,compare_ij
        real*8 DET,DOT,DDIST,DDIST2,DDLENG
        integer*4 IBURY,IABLS,ISPH,K,N,I
        integer*4 J,IATOM,IPTR,J1,I1,MAXNB
        integer*4 NY,NUP,NCIRC,ICI,ICJ,ICK,NNBR
        integer*4 NIMOL,JCK,JCJ,JCI
        integer*4 JATOM,JMOLD,IUSE,JMIN,JNBR
        integer*4 JMINNBR,LFK,L,L1,L2,MUTUAL,KNBR
        integer*4 KATOM,IP,NROT,NARC,IROT,IDX,IY
	integer*4 npos_sd
        integer*4 NV,IFRLST,JP,IHASH,IPREV,IFREE
        integer*4 NEAT,NYEAT,IPT,kolor,JMINBR,LKF

	integer icyv,icyv2,newtypeyv ! loop counter
	integer idot  ! dot counter
	integer*2 ndot_type(3),dndot_type(3)
        integer*2 dot_IB(maxdot)
        integer*4 dot_IATNUM(maxdot),dot_ISHAPE(maxdot)
	real*8 surf_type(3),dsurf_type(3)
	real*8 atomradyv
        real*8 ddot
        integer iiprint0,iiprint1,iiprint2
	 real*8 PI2,null,onehalf,one,two,three,four,big,small
	 common/CONSTANTI/PI2,null,onehalf,one,two,three,four,big,small
         real*8 nulls

	 real*8  toler_nb,toler_pr,toler_yon,toler_d,toler_cx,toler_ovr 
         real*8 toler_bur
	 real*8  ktoler_yon
         real*8 toler2_yon
	 common/TOLERANCE/toler_nb,toler_pr,toler_yon,toler_d,
     &	 toler_cx,toler_ovr,ktoler_yon
          
         logical CONTROL      !control test output
         CHARACTER*3 NUMM
         CHARACTER*24 CFF
         CHARACTER*64 filenme

c Print 
  	 iiprint0=0
	 iiprint1=1
 	 iiprint2=2



          CONTROL = .false.
C         kanalpl = kanalp
c         kanalpl = 6
         
         if(kanalpl.ne.6)then
           filenme='SIMSres.out'
#ifdef AIX
   	   open(unit=kanalpl,file=filenme,status='unknown',
     &                   position='append')
#else
	   open(unit=kanalpl,file=filenme,status='unknown',
     &                   access='append')
#endif

         end if
	 if(outdetl.ge.iiprint1)then
           write(kanalpl,*) 'SURFACE COMPUTATION '
           write(*,*)'SIMS: NTOMS ', ntoms,' DOTDEN ', 
     &      DOTDEN,'d_probe ',d_probe
C    &     ,'PRINTING TO UNIT ', kanalpl
CDR          PRINTING GOES TO UNIT 32
         end if
	 if(outdetl.ge.iiprint2)then
           do n=1,ntoms
           write(*,*) n, (coords(i,n),i=1,3), atom_rad(n)
           end do
         end if

	 null=0.0d0
         nulls = null
	 small = 1.0d-6
	 onehalf=0.5d0
	 one = 1.0d0
	 two = 2.0d0
	 three = 3.0d0
	 four = 4.0d0
	 big = 1.0d6
         PI2 = DACOS(-one)

	D=dotden
	RP=d_probe*0.5d0
        if(RP.lt.0.0d0)RP=0.0d0

        IBURY = 0  
        IABLS = 0



	 OPT_CCdot_TriDiv = .true. 
	 OPT_CCdot_ProbProj = .not.OPT_CCdot_TriDiv
         OPT_triTetMx = dcos(PI2*0.375d0)*RP**2
c	OPT_printcc=1 !test print CONCAVE construction
	OPT_printcc=0 ! NO print

c	OPT_printsd=1 !test print SADDLE construstion
	OPT_printsd=0 ! No print

c	OPT_printcx=1 !test print for CONVEX
	OPT_printcx=0 !NO test print CONVEX

c	OPT_printrem=1 !test OVERLAP dots remove
	OPT_printrem=0

	OPT_overlap_RE_remove=.true. !remove overlaping nonsymmetry REntrant S 
c	OPT_overlap_RE_remove=.false.

c	OPT_removeCC=.false.
	OPT_removeCC=.true.   

c CONVEX dots CUTting method:
	OPT_sizeBE=0 ! step-wise cut - prostoe i LUCHSHEE
	OPT_refcut=4 ! 5 dot  ---> + permanent children dots in Glob Syst

c Warning
	badsurf_mx=0.005d0

c:SIMS: initialize 
        n_cc_tridiv = 0
        n_cc_PrbPrj = 0
	nprobpos = 0
	nprobpos_t = 0
	ndotccsd = 0
	ndotccsd_t = 0

	do i=1,maxprob
	start_dotn(i)=0
	end do

	do i=1,maxat
	nvertex(i)=0
	end do

	do i=1,maxdot
	WDYONRm(i)=.false.
	end do

	putsmall=1    ! OPTIMAL: saddle arc  will have at leas one point


	areaCONCAVE=0.0d0
	areaSADDLE_a=0.0d0
	areaSADDLE_n=0.0d0
	MAXntor_i = 0    !max number of torus for any atom
	frame_cx = 0     ! frame type
	ndotCONCAVE=0
	ndotSADDLE=0
	RSwrite=0
	probmax1 = maxprob
	maxnbr1=maxnbr
	maxdot1=maxdot
	NCHmx = maxchil  !max number of children dots per one parent
c
  	toler_nb=1.0d-8    !tolerance in ariphmetic IF for NEIGHBRS calculation
c        toler_nb=0.0d0    !BAD, COLLIDE give unstable result

        toler_bur = 0.0d0  !tolerance to calculte burrid atoms and torus

        toler_pr=1.0d-6    !to compare probe position, 4-atom touch

  	toler_d=1.0d-6    !Oct.29  distance from CUTTING plane to delete CONVEXdot
c        toler_d=0.0d0     ! horosho rabotaet with step-wise CUT

	toler_cx = 0.0d0 !min area weight to delete CONVEX dot

c	ktoler_yon = 0.1d0 !in A, Aug 12 OPTIMAL cut off for Singular Noses
        ktoler_yon = 0.0d0 
c	toler_yon = ktoler_yon/dsqrt(dotden) ! min dist to SYmm Plane 
c	                                     ! to define  dot as YON
c                                        for CONCAVE and SADDLE
c                                        taking into account DOT size
	toler_yon= ktoler_yon   !

	toler2_yon=toler_yon**2/(RP*two)

	toler_ovr = toler_yon ! overlapping NonSymm SD and CC dots
c
	saddle_angl_min = 0.05d0 !OPTIMAL: min angle ARC rotation around IJ axis
c	ashift=0.00050d0   ! amplitude to shift Katom to DESTROY 4-atom touch
        ashift=20.0d0*toler_pr        ! to the PROBE SPHERE

	singularSD=.false.
	singularCC=.false.
	N_singularCC=0
	N_singularSD=0
	n_singulTor=0
	Ar_singularCC=0.0d0
	Ar_singularSD=0.0d0

        IF (RP .LT. null) CALL ERROR(120,0,RP)
        IF (IBURY .LT. 0 .OR. IBURY .GT. 2) CALL ERROR(127,IBURY,nulls)

        radMAX = 0.0d0


        if(ntoms.gt.maxat)then
        write(*,*)'FATAL ERROR: ntoms > maxat !!!'
        write(kanalp,*)'FATAL ERROR: ntoms > maxat !!!'
            stop 3001
        end if

	do n=1,ntoms
        radatm(n)=atom_rad(n)
        if(radMAX.lt.radatm(n))radMAX=radatm(n)
        end do

        WIDTH = 2 * (radMAX + RP)

        do k = 1,3
           NIAS(k) = 0
           COMIN(K) = big
        end do


	do  N=1,ntoms
	IAS(N)=2  ! SURF REQ NUMBER: surface for atom will be calculated
	MOLNUM(N)=1  ! all atoms belongs to molecule 1
        atom_srf(N)=0.0d0
	do K=1,3
	CO(K,N)=coords(K,N)
	enddo !K

        IF (N .GT. maxat) CALL ERROR(150,N,nulls)
        IF (IAS(N) .LT. 0 .OR. IAS(N) .GT. 2) CALL ERROR(160,N,nulls)

        do k = 1,3
           IF (CO(K,N) .LT. COMIN(K)) COMIN(K) = CO(K,N)
        end do

        do K = 1,3
           IF (IAS(N) .EQ. K-1) NIAS(K) = NIAS(K) + 1
        end do

        end do !N



        DO I = 1,ntoms

           DO K = 1,3
              icol = (CO(K,I)-COMIN(K))/WIDTH 
              ICO(K,I) = icol + 1

        IF (ICO(K,I) .LT. 1)then
        write(*,*)'CUBE COORDINATE TOO SMALL'
        write(*,*)'Total Atoms=',ntoms
        do J=1,ntoms
        write(*,'(a4,i4,a8,3f15.10)')'at=',J,
     & 'CO(K,J)=',CO(1,J),CO(2,J),CO(3,J)
        end do!j
        write(*,'(a12,3f15.7,a7,f10.6)')'COMIN(K)=',COMIN,
     & 'WIDTH=',WIDTH
        STOP 
        end if

              IF (ICO(K,I) .GT. MAXCUB)

     1         STOP 'CUBE COORDINATE TOO LARGE'

         end do !K

         end do !I



        DO  K = 1,MAXCUB
           DO J = 1,MAXCUB
              DO I = 1,MAXCUB

                 ICUBE(I,J,K) = 0
                 SCUBE(I,J,K) = .FALSE.
                 SSCUBE(I,J,K) = .FALSE.
               end do !I
            end do !J
          end do !K



        DO I = 1,ntoms
           ICUPTR(I) = 0
        end do !I


        DO 1250 IATOM = 1,ntoms


           IF (IAS(IATOM) .EQ. 0) GO TO 1250

           I = ICO(1,IATOM)

           J = ICO(2,IATOM)

           K = ICO(3,IATOM)

           IF (ICUBE(I,J,K) .LE. 0) THEN


              ICUBE(I,J,K) = IATOM

           ELSE


              IPTR = ICUBE(I,J,K)

1100          CONTINUE


              D2 = DDIST2(CO(1,IATOM),CO(1,IPTR))

              IF (D2 .LE. null) THEN

                 IAS(IATOM) = 0

                 WRITE (kanalpl,1150) IATOM,IPTR

1150             FORMAT(1X,'ATOM',I5,' DROPPED (SAME CO AS ',I5,')')

                 GO TO 1250

              END IF

              IF (ICUPTR(IPTR) .LE. 0) GO TO 1200


              IPTR = ICUPTR(IPTR)

              GO TO 1100

1200          CONTINUE


              ICUPTR(IPTR) = IATOM

           END IF


           IF (IAS(IATOM) .EQ. 2) SCUBE(I,J,K) = .TRUE.

1250    CONTINUE




        DO 1550 K = 1,MAXCUB

           DO 1500 J = 1,MAXCUB

              DO 1450 I = 1,MAXCUB

                 IF (ICUBE(I,J,K) .EQ. 0) GO TO 1450


                 DO 1400 K1 = K-1,K+1

                    IF (K1 .LT. 1 .OR. K1 .GT. MAXCUB) GO TO 1400

                    DO 1350 J1 = J-1,J+1

                       IF (J1 .LT. 1 .OR. J1 .GT. MAXCUB) GO TO 1350

                       DO 1300 I1 = I-1,I+1

                       IF (I1 .LT. 1 .OR. I1 .GT. MAXCUB) GO TO 1300

                          IF (SCUBE(I1,J1,K1)) SSCUBE(I,J,K) = .TRUE.

1300                   CONTINUE

1350                CONTINUE

1400             CONTINUE

1450          CONTINUE

1500       CONTINUE

1550    CONTINUE




        MAXNB = 0


        DO  K = 1,3

           NSHAPE(K) = 0
           NLOST(K) = 0     
	   ARLOST(K)=null 

         end do !K


        NY = 0


        AREAC = null
        AREAR = null


        IF (D .LE. null) STOP 'NON-POSITIVE DENSITY'


        do IATOM = 1,ntoms
           SRS(IATOM) = .FALSE.
        end do



	NUP = (4.0d0*PI2*RP**2 )*D

        IF (NUP .GT. maxsph) NUP = maxsph
        IF (NUP .LT. 12) NUP = 12          !minimal number of points
	call GENUN01(RP,UP,ARUP,TETP,NUP)

        if(CONTROL)write(*,*)'MS: precalc finish'

	idot=0
	nconc_glob=0

	 do i=1,maxat
	 ntor_i(i)=0
	 do k=1,maxnbr
	 atvert_conc(k,i)=0
	 end do
	 end do
c  * * * * * * * *  * *  * * *  *   * * * * * * * * *  * * * * * ** * * 
c  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
        do IATOM = 1, ntoms

        if(CONTROL)write(*,*)'MS: bigLoop iatom=',IATOM


           IF (IAS(IATOM) .EQ. 0) GO TO 5650


           ICI = ICO(1,IATOM)

           ICJ = ICO(2,IATOM)

           ICK = ICO(3,IATOM)


           IF (.NOT. SSCUBE(ICI,ICJ,ICK)) GO TO 5650


           RI = radatm(IATOM)

           SI = IAS(IATOM) .EQ. 2

           DO  K = 1,3
              CI(K) = CO(K,IATOM)
           end do !K

           IMOL = MOLNUM(IATOM)




           NNBR = 0

           NIMOL = 0


           SNS = .FALSE.


           SUMI = two * RP + RI


           DO 2550 JCK = ICK-1,ICK+1

              IF (JCK .LT. 1 .OR. JCK .GT. MAXCUB) GO TO 2550

              DO 2500 JCJ = ICJ-1,ICJ+1

                 IF (JCJ .LT. 1 .OR. JCJ .GT. MAXCUB) GO TO 2500

                 DO 2450 JCI = ICI-1,ICI+1

                    IF (JCI .LT. 1 .OR. JCI .GT. MAXCUB) GO TO 2450

                    JATOM = ICUBE(JCI,JCJ,JCK)

2300                CONTINUE


                    IF (JATOM .LE. 0) GO TO 2400


                    SUM = SUMI + radatm(JATOM) + toler_nb ! SIMS: add  toler
c						       ! to make MORE neighbours

                    VECT1 = DABS(CO(1,JATOM) - CI(1))

                    IF (VECT1 .GE. SUM) GO TO 2350  !skip

                    VECT2 = DABS(CO(2,JATOM) - CI(2))

                    IF (VECT2 .GE. SUM) GO TO 2350

                    VECT3 = DABS(CO(3,JATOM) - CI(3))

                    IF (VECT3 .GE. SUM) GO TO 2350

                    D2 = VECT1 ** 2 + VECT2 ** 2 + VECT3 ** 2

                    IF (D2 .GE. SUM ** 2) GO TO 2350 !skip


                    IF (IATOM .EQ. JATOM) GO TO 2350

c SIMS::  check if atoms I,J are INSIDE of each other
	   aa1=dsqrt(D2)
	   if(aa1+RI.le.radatm(JATOM)+toler_bur)then
	   if((OPT_printcx.ge.iiprint1).or.CONTROL)then
	   write(*,*)'Iatom ',IATOM, ' is inside of Jatom',JATOM
	   end if
	   goto 5650
	   end if ! Iatom is inside

	   if(aa1+radatm(JATOM).le.RI+toler_bur) then
	   if((OPT_printcx.ge.iiprint1).or.CONTROL)then
	   write(*,*)'Jatom ',JATOM, ' is inside of Iatom',IATOM
	   end if
	   go to 2350
	   end if ! inside


                    NNBR = NNBR + 1


                    IF (NNBR .GT. maxnbr)  then
                      CALL ERROR(210,NNBR,nulls)
                    ENDIF


                    ITNL(NNBR) = JATOM


                IF (IAS(JATOM) .EQ. 2 .AND. MOLNUM(JATOM) .EQ. IMOL)

     1       SNS = .TRUE.


                    IF (IMOL .EQ. MOLNUM(JATOM)) NIMOL = NIMOL + 1

2350                CONTINUE


                    JATOM = ICUPTR(JATOM)

                    GO TO 2300

2400                CONTINUE

2450             CONTINUE

2500          CONTINUE

2550       CONTINUE



           IF (NNBR .GT. MAXNB) MAXNB = NNBR




           IF (IBURY .EQ. 1 .AND. NIMOL .EQ. NNBR) GO TO 5650




           IF (.NOT. SI .AND. .NOT. SNS) GO TO 5650





           JMOLD = 0
           if(NNBR.GE.1)then
           DO 2700 IUSE = 1,NNBR

              JMIN = ntoms + 1

              DO 2600 JNBR = 1,NNBR


                 IF (ITNL(JNBR) .LE. JMOLD) GO TO 2600

                 IF (ITNL(JNBR) .LT. JMIN) THEN

                    JMIN = ITNL(JNBR)

                    JMINBR = JNBR

                 END IF

2600          CONTINUE

              JMOLD = JMIN

              JNBR = JMINBR

              JATOM = ITNL(JNBR)



              INBR(IUSE) = JATOM

              DO K = 1,3
                 CNBR(K,IUSE) = CO(K,JATOM)
              end do !K

              RNBR(IUSE) = radatm(JATOM)

              SNBR(IUSE) = IAS(JATOM) .EQ. 2

              MOLNBR(IUSE) = MOLNUM(JATOM)

              ERNBR(IUSE) = RNBR(IUSE) + RP

              DISNBR(IUSE) = DDIST2(CI,CNBR(1,IUSE))


              LKNBR(IUSE) = 0

2700       CONTINUE
           end if !NNBR ge 1




           LKF = 0



           DO 2750 L = 1,NNBR

              IF (IMOL .NE. MOLNBR(L)) GO TO 2750

              LKF = L

              GO TO 2800

2750       CONTINUE

           IF (LKF .EQ. 0) GO TO 3000

2800       CONTINUE


           DO 2950 L = LKF+1,NNBR

              IF (IMOL .NE. MOLNBR(L)) GO TO 2950

              L1 = 0

              L2 = LKF

2850          CONTINUE

              IF (DISNBR(L) .LT. DISNBR(L2)) GO TO 2900

              L1 = L2

              L2 = LKNBR(L2)

              IF (L2 .NE. 0) GO TO 2850

2900          CONTINUE


              IF (L1 .EQ. 0) THEN

                 LKF = L

                 LKNBR(L) = L2

              ELSE

                 LKNBR(L1) = L

                 LKNBR(L) = L2

              END IF

2950       CONTINUE

3000       CONTINUE

           if(CONTROL)write(*,*)'MS:Finish neighbList of IATOM'





           IF (RP .EQ. null) GO TO 5200


           IF (NIMOL .LE. 0) GO TO 5200




           if(NNBR.GE.1)then
           DO 5150 JNBR = 1,NNBR

              JATOM = INBR(JNBR)

              if(CONTROL)
     &     write(*,*)'MS:MEDIUM LOOP JNBR,JATOM=',JNBR,JATOM



              IF (JATOM .LE. IATOM) GO TO 5150


              IF (IMOL .NE. MOLNBR(JNBR)) GO TO 5150


              RJ = RNBR(JNBR)

              SJ = SNBR(JNBR)

              DO  K = 1,3
                 CJ(K) = CNBR(K,JNBR)
              end do











              DO K = 1,3
                 VIJ(K) = CJ(K) - CI(K)
              end do !k




	      DIJ = DDLENG(VIJ)

	       IF (DIJ .LE. null) THEN  

                 WRITE (kanalpl,3150) IATOM,JATOM

3150             FORMAT(1X,'ATOMS',2I5,' HAVE THE SAME CENTER')

                 GO TO 5150

              END IF

ctt
ctt             write(kanalp,*)'aft3150: VIJ=',VIJ

              CALL DVNORM(VIJ,UIJ)
ctt
ctt              write(kanalp,*)'aft3150: UIJ=',UIJ
ctt

              CALL VPERP(UIJ,Q)

              CALL DVECTPR(UIJ,Q,T)


	      aa1 = onehalf*((RI+RP)**2-(RJ+RP)**2)/DIJ**2

c SIMS::
	      F = onehalf + aa1
	      FIJ = F*DIJ
	      FJI = (onehalf - aa1)*DIJ


              DO K = 1,3
              BIJ(K) = CI(K) + F * VIJ(K)
              end do !K

ctt
ctt        write(kanalp,'(a12,3f6.3,1x,4f6.3)')'aft3200:BIJ', BIJ,CI
ctt        write(kanalp,'(a14,3f6.3,1x,f6.3)')'aft3200:VIJ,F',VIJ,F

              F1 = (RI+RJ+2*RP)**2 - DIJ**2


              IF (F1 .LE. null ) GO TO 5150

              F2 = DIJ**2 - (RI-RJ)**2


              IF (F2 .LE. null) GO TO 5150


              HIJ = DSQRT(F1*F2) / (two*DIJ)

ctt
ctt              write(kanalp,'(a20,2i3,1x,f8.4)')'IAt,Jat, HIJ =',
ctt     &     IATOM, JATOM, HIJ
ctt

	      if(HIJ.lt.null)then
	      write(kanalpl,*)
     & 'WARNING!  HEIGHT (radIUS OF SADDLE CIRCLE) ',
     & ' too SMALL=', HIJ
	      end if


              DO K = 1,3
                 AIJ(K) = HIJ * Q(K)
              end do !k




              MUTUAL = 0

              DO 3300 KNBR = 1, NNBR

                 D2 = DDIST2(CJ,CNBR(1,KNBR))

                 MNBR(KNBR) = D2 .LT. (two*RP+RJ+RNBR(KNBR))**2

     1    .AND. KNBR .NE. JNBR

                 IF (MNBR(KNBR)) MUTUAL = MUTUAL + 1

3300          CONTINUE



              ISHAPE = 3

c LOCAL i-j pair 
c initialize nconc_ij number of conc probe positions for this ij pair

c SIMS:: initialize
	       doshift_k=.false.
	       KNBR=1
               KATOM = INBR(KNBR)
               
	       do k=1,3
	       cshift_k(k)=null
	       end do

4020	       nconc_ij=0
	       areaCONC_ij=null
	       ndotCONC_ij=0
	       n_singCC_ij = 0
	       ar_singCC_ij = 0
		if(doshift_k)then
		 aa1=IATOM**2+JATOM**2+KATOM**2
		 cshift_k(1)=ashift*IATOM**2/aa1
		 cshift_k(2)=ashift*JATOM**2/aa1
		 cshift_k(3)=ashift*KATOM**2/aa1

ctt		    if(OPT_printcc.ge.iiprint1)then
                write(kanalpl,*)'! ! ! ! ! ! ! ! ! ! ! ! ! !'
		write(kanalpl,*)'Break Sym: DO shift for KATOM=',KATOM
ctt		write(*,*)'cshift_k(k)=',cshift_k
ctt		    end if

		do k=1,3
		CK(k)=CK(k)+cshift_k(k)
		CNBR(k,KNBR)=CK(k)
		CO(k,KATOM) = CK(k)
		end do

		doshift_k=.false.
		end if

		  if(OPT_printcc.ge.iiprint1)then
	       write(kanalpl,*)' * ! * ! * ! * ! * ! * ! * ! *'
	       write(kanalpl,*)
     &    ' START TRIPLETS IATOM< JATOM=', IATOM,JATOM
	       write(kanalpl,*)
		  end if

	       KNBR=0

4200           KNBR=KNBR+1

	       if(KNBR.GT.NNBR)goto 4202         !end of loop

                 IF (.NOT. MNBR(KNBR)) GO TO 4200

                 KATOM = INBR(KNBR)


                 IF (KATOM .LE. JATOM) GO TO 4200

                 SK = SNBR(KNBR)


                 IF (.NOT. (SI .OR. SJ .OR. SK)) GO TO 4200


                 IF (IMOL .NE. MOLNBR(KNBR)) GO TO 4200


                 RK = RNBR(KNBR)

                 DO K = 1,3
                    CK(K) = CNBR(K,KNBR)
                 end do !K
                 
		    if(OPT_printcc.ge.iiprint2)then
		 write(kanalpl,*)'XYZ I=',CI
		 write(kanalpl,*)'XYZ J=',CJ
		 write(kanalpl,*)'XYZ K=',CK
                    end if




           DK = UIJ(1) * (BIJ(1)-CK(1)) + UIJ(2) * (BIJ(2)-CK(2)) +

     1UIJ(3) * (BIJ(3)-CK(3))


                 RIJK = (RK+RP) ** 2 - DK ** 2


                 IF (RIJK .LE. null) GO TO 4200

                 RIJK = DSQRT(RIJK)


                 DO K = 1,3
                    CIJK(K) = CK(K) + DK * UIJ(K)
                 end do !K


                 DO K = 1,3
                    VIJK(K) = CIJK(K) - BIJ(K)
                 end do !k

                 DIJK = DDLENG(VIJK)

                 IF (DIJK .LE. null) THEN

                    WRITE (kanalpl,3500) IATOM,JATOM,KATOM

3500                FORMAT(1X,'ATOMS',3I5,' HAVE CONCENTRIC CIRCLES')

                    GO TO 4200

                 END IF

                 F = onehalf * (one+(HIJ**2-RIJK**2)/DIJK**2)


                 DO  K = 1,3
                    BIJK(K) = BIJ(K) + F * VIJK(K)
                  end do !k

                 F1 = (HIJ+RIJK)**2 - DIJK**2


                 IF (F1 .LE. null) GO TO 4200

                 F2 = DIJK**2 - (HIJ-RIJK)**2



                 IF (F2 .LE. null) GO TO 4200

                 HIJK = DSQRT(F1*F2) / (two*DIJK)

                 CALL DVNORM(VIJK,UIJK)



                 CALL DVECTPR(UIJ,UIJK,AIJK)


                 DO K = 1,3
                    AIJK(K,1) = HIJK * AIJK(K,1)
                    AIJK(K,2) = - AIJK(K,1)
                 end do !k


                 DO 3700 IP = 1,2

                    DO K = 1,3
                       PIJK(K,IP) = BIJK(K) + AIJK(K,IP)
                    end do !K 


            PAIR(IP) = .NOT. COLLID(PIJK(1,IP),RP,CNBR,ERNBR,MNBR,

     1NNBR,maxnbr,ISHAPE,JNBR,KNBR,MOLNBR,IMOL,LKF,LKNBR)

	     if(OPT_printcc.ge.iiprint1)then
	    write(kanalpl,*)'start IP,PAIR(IP)=',IP,PAIR(IP)
             end if

3700             CONTINUE


                 IF (.NOT. PAIR(1) .AND. .NOT. PAIR(2)) GO TO 4200

                 BOTH = PAIR(1) .AND. PAIR(2)


                 SRS(IATOM) = .TRUE.

                 SRS(JATOM) = .TRUE.

                 SRS(KATOM) = .TRUE.


                 DO 4150 IP = 1,2

                    IF (.NOT. PAIR(IP)) GO TO 4150


                    BURY = .FALSE.


           IF (IBURY .GT. 0) BURY = BURIED(PIJK(1,IP),RP,CNBR,RNB

     1R,MNBR,NNBR,maxnbr,ISHAPE,JNBR,KNBR,MOLNBR,IMOL)


                 IF (IBURY .EQ. 1 .AND. .NOT. BURY) GO TO 4150


                 YONPRB = HIJK .LE. RP+toler_yon .AND. .NOT. BOTH !SIMS: CCdot




                    DO K = 1,3

                       VPI(K) = (CI(K) - PIJK(K,IP)) * RP / (RI + RP)
                       VPJ(K) = (CJ(K) - PIJK(K,IP)) * RP / (RJ + RP)
                       VPK(K) = (CK(K) - PIJK(K,IP)) * RP / (RK + RP)

                    end do !K

	    nconc_glob=nconc_glob+1
	    nconc_ij=nconc_ij+1
  	    nprobpos=nprobpos+1
c check limits
	  if(nconc_glob.gt.nconc_glob_mx)then
          write(*,*)'ERROR:Parameter nconc_glob_mx too SMALL'
          write(kanalpl,*)'ERROR:Parameter nconc_glob_mx too SMALL'
            stop 3002
	  end if !check limit
	   
	   if(nconc_ij.gt.nconc_ij_mx)then
	   write(*,*)'ERROR:Parameter nconc_ij_mx too SMALL'
	   write(kanalpl,*)'ERROR:Parameter nconc_ij_mx too SMALL'
            stop 3003
	   end if
c
c KATOM for this IJ pair
c
          conc_ij_k(1,nconc_ij)=KATOM
	  conc_ij_k(2,nconc_ij)=nconc_glob

c Total number of vertex for I,J,K atoms

	    nvertex(IATOM)=nvertex(IATOM)+1
	    nvertex(JATOM)=nvertex(JATOM)+1
	    nvertex(KATOM)=nvertex(KATOM)+1

	    if(OPT_printcc.ge.iiprint1)then
	    write(kanalpl,*)'CONCAVE face Nglob=',nconc_glob
	    write(kanalpl,*)'concave face ij_k =',nconc_ij  
	    write(kanalpl,*)'IATOM,JATOM,KATOM=',IATOM,JATOM,KATOM
	    write(kanalpl,*)'nvertex(IATOM)=',nvertex(IATOM)
	    write(kanalpl,*)'nvertex(JATOM)=',nvertex(JATOM)
	    write(kanalpl,*)'nvertex(KATOM)=',nvertex(KATOM)
	    write(kanalpl,*)' IP=',IP,' PROBE xyz =', (PIJK(k,IP),k=1,3)
            end if

	    if(nvertex(IATOM).gt.maxnbr.or.
     &         nvertex(JATOM).gt.maxnbr.or.
     &         nvertex(KATOM).gt.maxnbr)then
	    write(*,*)
     & 'NUMBER OF VERTEX on ATOM is LARGE then maxnbr'
	    write(kanalpl,*)
     & 'NUMBER OF VERTEX on ATOM is LARGE then maxnbr'
                stop 3004
	    end if

	  do k=1,3
	  cprobe_ijk(k,nconc_glob)=PIJK(k,IP)
          end do
ctt
         if(OPT_printcc.ge.iiprint1)then
          write(kanalpl,'(a24,3i5,/,3f18.13)')
     & 'IATOM,JATOM,KATOM,PIJK ',
     &   IATOM,JATOM,KATOM,(PIJK(k,IP),k=1,3)
         end if

	  delete_pp=.false.
	  if(nconc_ij.gt.1)then
	  do icc=1,nconc_ij-1 
	  aa1=big

	  if(KATOM.ne.conc_ij_k(1,icc))then
	  aa1=null
	  do k=1,3
	  aa1=aa1+abs(PIJK(k,IP)-cprobe_ijk(k,conc_ij_k(2,icc)))
	  end do !k
	  end if
	  if(aa1.lt.toler_pr)delete_pp=.true.
          end do!icc
          end if !nconc_ij gt 1

	  if(nconc_glob.gt.1)then
	  if(.not.delete_pp)then !compare with all glob ijk triplets

          do icc=1,nconc_glob-1 
	  nn1=conc_gl_ijk(1,icc)
	  nn2=conc_gl_ijk(2,icc)
	  nn3=conc_gl_ijk(3,icc)

	  if(compare_ij(IATOM,JATOM,nn1,nn2,nn3))then
	  aa1=null
	  do k=1,3
	  aa1=aa1+abs(PIJK(k,IP)-cprobe_ijk(k,icc))
	  end do !k
	  if(aa1.lt.toler_pr)delete_pp=.true.
	  end if !compare_ij

          end do!icc

	  end if !.not.delete_pp
	  end if !nconc_glob.gt.1

           
	  if(delete_pp)then  

c return initial values for numbers:
            nprobpos=nprobpos - nconc_ij           !glob nmb for CC/SD prb pos
            nconc_glob=nconc_glob - nconc_ij
	    nvertex(IATOM)=nvertex(IATOM) - nconc_ij
	    nvertex(JATOM)=nvertex(JATOM) - nconc_ij
c more complicated for KATOMs
	    do icc=1,nconc_ij
	    k1=conc_ij_k(1,icc)    !restore KATOM number
	    nvertex(k1)=nvertex(k1) - 1
	    end do !icc

	  nconc_ij=0
	  doshift_k=.true.

	   if(OPT_printcc.ge.iiprint1)then
	  write(kanalpl,*)'DO shift:'
	  write(kanalpl,*)'IP,IATOM,JATOM,KATOM=',IP,IATOM,JATOM,KATOM
	  write(kanalpl,*)'UPDATED nvertex = ',(nvertex(k),k=1,ntoms)
	  end if

	  goto 4020    ! shift coordinates of KATOM and UPDATE KNBR LOOP
	  end if
	  conc_gl_ijk(1,nconc_glob)=IATOM
	  conc_gl_ijk(2,nconc_glob)=JATOM
	  conc_gl_ijk(3,nconc_glob)=KATOM
	  conc_gl_ijk(4,nconc_glob)=nvertex(IATOM)
	  conc_gl_ijk(5,nconc_glob)=nvertex(JATOM)
	  conc_gl_ijk(6,nconc_glob)=nvertex(KATOM)

	  nconc_glb_nprpos(nconc_glob)=nprobpos
c
	  atvert_conc(nvertex(IATOM),IATOM)=nconc_glob
          atvert_conc(nvertex(JATOM),JATOM)=nconc_glob
	  atvert_conc(nvertex(KATOM),KATOM)=nconc_glob


c VERTEX coordinates
            do k=1,3
c	    cvertex(k,nvertex(IATOM),IATOM)= PIJK(k,IP)+VPI(k)
c	    cvertex(k,nvertex(JATOM),JATOM)= PIJK(k,IP)+VPJ(k)
c	    cvertex(k,nvertex(KATOM),KATOM)= PIJK(k,IP)+VPK(k)
c
	     
c vectors from PROBE-->VERTEX
	    cvertex(k,nvertex(IATOM),IATOM)= VPI(k)
	    cvertex(k,nvertex(JATOM),JATOM)= VPJ(k)
	    cvertex(k,nvertex(KATOM),KATOM)= VPK(k)
	    end do!k

	    do k=1,3
	    center(k)=null
	    vpi_m(k)=VPI(k)
	    vpj_m(k)=VPJ(k)
	    vpk_m(k)=VPK(k)
	    PrPIJK(k)=PIJK(k,IP)
	    end do!k

            rpr=RP
	    rpr2=rpr*rpr
	    dens=dotden

       
	    SIGN = DET(VPI,VPJ,VPK)

	    dot_vij = DDOT(VPI,VPJ)
	    dot_vik = DDOT(VPI,VPK)
	    dot_vjk = DDOT(VPJ,VPK)

	 OPT_CCdot_TriDiv = .true. 
           if(dot_vij.lt.OPT_triTetMx          !large triangles
     &        .or.dot_vik.lt.OPT_triTetMx
     &         .or.dot_vjk.lt.OPT_triTetMx)then
         OPT_CCdot_TriDiv = .false.
           end if
         OPT_CCdot_ProbProj = .not.OPT_CCdot_TriDiv 
            

	    if(SIGN.eq.null)then
	    write(kanalpl,*)
     & 'Warn: Concave vect VPI,VPJ,VPK are in plane !!'
	    end if

	    if(dot_vij.eq.-rpr2)then
	    write(kanalpl,*)
     &  'WARN: Concave vect VPI,VPJ are in line !! '
	    end if
	    if(dot_vik.eq.-rpr2)then
	    write(kanalpl,*)
     &  'WARN: Concave vect VPI,VPK are in line !! '
	    end if
	    if(dot_vjk.eq.-rpr2)then
	    write(kanalpl,*)
     &  'WARN: Concave vect VPJ,VPK are in line !! '
	    end if

	    if(OPT_CCdot_triDiv)then
            n_cc_tridiv=n_cc_tridiv + 1

	    call gener_conc_dot01(vpi_m,vpj_m,vpk_m,rpr,dens,
     &               area_cc,vdot_cc,area_dot_cc,vndot_cc,ndot_cc)

	    if(ndot_cc.gt.ndotccmx)then
	    write(*,*)'ERROR: param ndotccmx is small',
     &	    ' increase to',ndot_cc
	    write(kanalpl,*)'ERROR: param ndotccmx is small',
     &	    ' increase to',ndot_cc
                stop 3005
	    end if

	    end if !OPT_CCdot_triDiv 

	    if(OPT_CCdot_ProbProj)then
            n_cc_PrbPrj = n_cc_PrbPrj + 1

            call gener_conc_dot02(UP,ARUP,TETP,PrPIJK,
     &            vpi_m,vpj_m,vpk_m,rpr,dens,
     &            area_cc,vdot_cc,area_dot_cc,vndot_cc,NUP,ndot_cc)
				

	    end if !OPT_CCdot_ProbProj

c add new CC dots:

	    ndotCONC_ij=ndotCONC_ij + ndot_cc

             if(OPT_printcc.ge.iiprint1)then
	    write(kanalpl,*)'conc_dot generated ',ndot_cc
             end if

	    AREA=area_cc/dfloat(ndot_cc)

c	    toler_yon = ktoler_yon*dsqrt(AREA)
	    toler_yon = ktoler_yon

	    areaCONC_ij=areaCONC_ij + area_cc

c	    if(OPT_printcc.ge.iiprint1)then
           if(CONTROL)then
           iatnn = 1
           if(IATOM.eq.iatnn.or.JATOM.eq.iatnn.or.KATOM.eq.iatnn)then
	    write(kanalp,*)'CONCAVE face N=',nconc_glob
	    write(kanalp,'(a22,3i5)')'IATOM,JATOM,KATOM=',
     &      IATOM,JATOM,KATOM
            write(kanalp,'(a6,3f10.6)')'VPI=',VPI
            write(kanalp,'(a6,3f10.6)')'VPJ=',VPJ
            write(kanalp,'(a6,3f10.6)')'VPK=',VPK
	    write(kanalpl,*)' IP=',IP,' PAIR(iP)=',PAIR(IP)
	    write(kanalp,*)'BOTH = ', BOTH
	    write(kanalp,'(a12,3f10.6)')
     &      'PROBE xyz =', (PIJK(k,IP),k=1,3)
	    write(kanalp,*)'curv_triang_area=',area_cc
            end if
            end if
c            end if



                    NP = 1


		 do 4000 I=1,ndot_cc


                   aa1=null	           

		   do k=1,3
		 uvx(k)=vdot_cc(k,I) !dot vector from center of PROBE not UNIT
		 aa1=aa1+uvx(k)*AIJK(k,IP)
                   end do !k

	       AREA = area_dot_cc(I)  ! Ag.5,96 exact area for each dot

              IF (NP .GT. maxppp) CALL ERROR(320,NP,nulls)


	   YON(NP) = (HIJK + aa1/HIJK).LE.toler_yon !taking into account
						 !dot size and position
ctt
ctt        write(kanalp,'(a26,3i3,1x,f8.4)')'IAT,JAT,KAT,HIJK =',
ctt     &  IATOM,JATOM,KATOM,HIJK
ctt        write(kanalp,'(a23,/,4D16.8,1x,L1)')'toler_y,aa1,aa2,aa3,YON',
ctt     &  toler_yon,aa1,aa2,aa3,YON(NP)
ctt


	       if(YON(NP) .AND. BOTH)then !concave face intersect ijk plane 
	       singularCC=.true.
	       n_singCC_ij = n_singCC_ij + 1
	       ar_singCC_ij = ar_singCC_ij + AREA

	       if(OPT_printcc.ge.iiprint1)then  !write
	       write(kanalpl,*)'OVERLAPPING CONCAVE dot is REMOVED'
	       write(kanalpl,*)'number I=',I
	       if(OPT_printcc.ge.2)then  !write
	       do k=1,3
	       uvx(k)=uvx(k)+PIJK(k,IP)
	       end do!k
	       write(kanalpl,*)'coordinates ', uvx
	       end if !write
	       end if! write

	       GO TO 4000

	       end if 



                       do K = 1,3
                       S(K,NP) = PIJK(K,IP) + uvx(K)
                       end do

		      AREA_dotCC(NP)=AREA      


                       DSI = DDIST(S(1,NP),CI) - RI

                       DSJ = DDIST(S(1,NP),CJ) - RJ

                       DSK = DDIST(S(1,NP),CK) - RK

                       IF (DSI .LE. DSJ .AND. DSI .LE. DSK) GO TO 3850

                       IF (DSJ .LE. DSI .AND. DSJ .LE. DSK) GO TO 3900

                       IF (.NOT. SK) GO TO 4000

                       N1(NP) = KATOM

                       N2(NP) = IATOM

                       N3(NP) = JATOM

                       GO TO 3950

3850                   CONTINUE

                       IF (.NOT. SI) GO TO 4000

                       N1(NP) = IATOM

                       N2(NP) = JATOM

                       N3(NP) = KATOM

                       GO TO 3950

3900                   CONTINUE

                       IF (.NOT. SJ) GO TO 4000

                       N1(NP) = JATOM

                       N2(NP) = IATOM

                       N3(NP) = KATOM

3950                   CONTINUE

                       NP = NP + 1


4000                CONTINUE

                    NP = NP - 1

	  ndotconc_ijk(nconc_ij)=NP

	  if(OPT_printcc.ge.iiprint1)then
	  if(NP.lt.1)then
	  write(kanalpl,*)'This CC face nconc_ij',nconc_ij,
     &  ' IATOM,JATOM,KATOM=', IATOM,JATOM,KATOM, ' has Ndot=', NP,
     &  ' Initial Ndot_cc=', ndot_cc
	  end if
	  write(kanalpl,*)'********************************'
          end if


ct ms:          IF (NP .LE. 0) GO TO 4150


	 RSwrite=RSwrite+1

	 call SwriteA(IMOL,ISHAPE,NP,PIJK(1,IP),AIJK(1,IP),
     &                YONPRB,BURY,
     &                nconc_ij,ATint,ATrea,ATlgc)      


                    IF (YONPRB) THEN


                       IF (NY .GE. MAXYON) CALL ERROR(720,NY,nulls)

                       NY = NY + 1

                       MOLYON(NY) = IMOL

                       DO K = 1,3

                          PY(K,NY) = PIJK(K,IP)
                          AY(K,NY) = AIJK(K,IP)

                       end do !K

                    END IF


                   
		    if(NP.ge.1)then          
                    do I = 1,NP
		    AREA = AREA_dotCC(I)   

	 call SwriteB(N1(I),N2(I),N3(I),S(1,I),AREA,YON(I),
     &                I,nconc_ij,BTint,BTrea,BTlgc)      

                    end do
		    end if                   


4150             CONTINUE

	       if(KNBR.le.NNBR-1)goto 4200     !to CONCAVE REENTRANT LOOP

4202           continue

c SIMS:: write back concave surface points on
	       if(nconc_ij.ge.1)then

	      areaCONCAVE=areaCONCAVE + areaCONC_ij
	      ndotCONCAVE=ndotCONCAVE + ndotCONC_ij
	       N_singularCC=N_singularCC + n_singCC_ij
	       Ar_singularCC=Ar_singularCC + ar_singCC_ij 

c decrease before k1 loop
	       nprobpos=nprobpos - nconc_ij

	       do k1=1,nconc_ij

	       nprobpos=nprobpos + 1! glob number for probe position
               ndotccsd=ndotccsd + ndotconc_ijk(k1) !glob numb dots
	       
		if(nprobpos.ge.maxprob)then
		write(*,*)'SIMS::ERROR:maxprob too small',maxprob
		write(kanalpl,*)'SIMS::ERROR:maxprob too small',maxprob
                stop 3006
		end if

	call  SwriteA_WP(maxnbr1,k1,ATint,ATrea,ATlgc,
     & 	probmax1,nprobpos,WPIIN,WPPcAv,WPYONB)

                
                call  SwriteA_WD(maxnbr1,ndotconc_ijk(k1),k1,
     &		BTint,BTrea,BTlgc,
     &	    maxdot1,start_dotn(nprobpos),WDN123,WDScAr,WDYON)

	        start_dotn(nprobpos+1)=start_dotn(nprobpos)+
     &		ndotconc_ijk(k1) 

               end do !k1

	       end if


              ISHAPE = 2



              IF (.NOT. (SI .OR. SJ)) GO TO 5150










	      free_tor=.true.   ! set FREE torus for this pair IATOM-JATOM
              iconcf=0
            
	      if(OPT_printsd.ge.iiprint1)then
	      write(kanalpl,*)'***********************************'
	      write(kanalpl,*)'SADDLE for IATOM,JATOM=',IATOM,JATOM
	      write(kanalpl,*)'nvertex(IATOM)=',nvertex(IATOM),
     &   ' nvertex(JATOM)=',nvertex(JATOM)
	      end if

	      if(nvertex(IATOM).ge.1.and.nvertex(JATOM).ge.1)then ! notfree_tor
	      do i=1,nvertex(IATOM)
	      iconcf=atvert_conc(i,IATOM)

	      do j=1,nvertex(JATOM)
	      if(iconcf.eq.atvert_conc(j,JATOM))then
	      free_tor=.FALSE.
              iavert=i
	      javert=j
	      go to 4240
	      end if
	      end do!j
	      end do!i
	      end if ! ?notfree_tor

4240          continue
             
	      if(OPT_printsd.ge.iiprint1)then
	      write(kanalpl,*)'SADDLE: Iatom, Jatom=',IATOM,JATOM
	      write(kanalpl,*)'This FREE torus status=',free_tor
	      if(.not.free_tor)then
	      write(kanalpl,*)'This SADDLE come from CONC face=',iconcf
	      end if
	      end if
c
c store for CONVEX surface calculation
	      ntor_i(IATOM)=ntor_i(IATOM)+1
	      ntor_i(JATOM)=ntor_i(JATOM)+1
	      if(ntor_i(IATOM).gt.maxnbr.or.
     &        ntor_i(JATOM).gt.maxnbr)then
	      write(*,*)'ERROR!! increase maxnbr'
	      write(*,*)
     &    'NUMBER of torus for IATOM is LARGE maxnbr!!'
	      write(kanalpl,*)'ERROR!! increase maxnbr'
	      write(kanalpl,*)
     &    'NUMBER of torus for IATOM is LARGE maxnbr!!'
                stop 3007
	      end if

	      Jattor_i(ntor_i(IATOM),IATOM)=JATOM
	      Jattor_i(ntor_i(JATOM),JATOM)=IATOM

	      Dstor_i(ntor_i(IATOM),IATOM)=RI*FIJ/(RI+RP)  
	      Dstor_i(ntor_i(JATOM),JATOM)=RJ*FJI/(RJ+RP)
	    

	     if(free_tor.AND. MUTUAL .GT. 0) THEN  ! burried?

                 DO 4250 KNBR = 1,NNBR

                    IF (.NOT. MNBR(KNBR)) GO TO 4250

                    IF (IMOL .NE. MOLNBR(KNBR)) GO TO 4250

                    D2 = DDIST2(BIJ,CNBR(1,KNBR))

		    aa2=null
		    do k=1,3
		    vbkat(k)=CNBR(k,KNBR)-BIJ(k)
		    aa2=aa2+vbkat(k)**2
		    end do
		    aa1= DDOT(vbkat,UIJ)
		     
                    if(aa2.lt.toler_bur)then
		    aa3 = null
		    else
		    aa3=one - aa1**2/aa2
		    if(aa3.lt.null)aa3=null
		    aa3=dsqrt(D2*aa3)                 ! D*cos(tet2)
		    end if

		    RK2=ERNBR(KNBR) ** 2 - HIJ ** 2 + two*aa3*HIJ !SIMS:
               
		 if(D2 .LT. RK2+toler_bur)then

		 if(OPT_printsd.ge.iiprint1)then
		 write(kanalpl,*)'THIS torus is BURRIED'
		 end if
        	  GO TO 5150  !skipp SURFACE calculation, torus is burried

		 end if

4250             CONTINUE

              END IF   !burried?
c
c    1:
	       
              if(free_tor)then ! FREE torus	    

	      nijs_face=1


              DO K = 1,3

                 G(K,1) = UIJ(K)
                 G(K,2) = Q(K)
                 G(K,3) = T(K)
		 AIJ(K) = HIJ*Q(K)  ! Q(k) depends on Lab xyz

              end do !K

ctt
ctt              write(*,'(a13,9f6.3)')'FreeTr : G=',G

	      end if !FREE torus

	      if(.not. free_tor)then 
c
c define number of saddle faces for IJ pair:  nijs_face
c start and stop angles of probe for each face RotAngl(f)
c sign of rotation SignRotS(f)
c altitude vector  AIJarcS(3,f)
c transformation matrix from local to glob frame GarcS(3,3,f)
c
	iatm_mx=maxat
	nbr_mx=maxnbr
	nconc_mx=nconc_glob_mx

      	call torus_rot_angl(iatm_mx,nbr_mx,nconc_mx,
     &          IATOM,JATOM,UIJ,HIJ,nvertex,atvert_conc,cvertex,
     &          cprobe_ijk,conc_gl_ijk,                 
     &          icfIJ,concf_ijf,RotAng,SignRotS,AIJarcS,GarcS)

	 nijs_face=icfIJ/2

              end if ! not free torus:define frame
c
c
c 

	      rpr=RP
	      RId=RI
	      RJd=RJ
	      HIJd=HIJ
	      DIJd=DIJ
	      dens=dotden
c
c
	    if(OPT_printsd.ge.iiprint1)then
	    write(kanalpl,*)'call ARC_points: generator'
	    end if

c initialize  
            arc_cross = .false.
           
c calculate 
	     call arc_points(RId,RJd,DIJd,HIJd,rpr,dens,putsmall,
     &	     NARCT,narci,narcj,archI,archJ,v0_arc,storanal,arc_cross,
     &       dot_cross)
      
	    if(arc_cross)n_singulTor = n_singulTor + 1

	    if(OPT_printsd.ge.iiprint1)then
	    write(kanalpl,*)'ARC: generated'
	    end if

	    if(OPT_printsd.ge.iiprint1)then
	    write(kanalpl,*)'ARC: generated'
	    write(kanalpl,*)'RI,RJ,HIJ,RP=',RI,RJ,HIJ,RP
	    write(kanalpl,*)'Analyt AREA for this FULLtorus',storanal
	    write(kanalpl,*)'ARC_CROSS IJ axis=',arc_cross

	    write(kanalpl,*)'NARCT,narci,narcj=',NARCT,narci,narcj
	    write(kanalpl,*)'archI,archJ=',archI,archJ
	    end if

            if(OPT_printsd.ge.iiprint2)then
	    write(kanalpl,*)'ARC points in LOC syst:'

	    do i=1,NARCT
	    write(*,*)'xyz=',(v0_arc(k,i),k=1,3)
	    end do !i
	    end if !OPT_printsd

            if(NARCT .GT. maxarc) CALL ERROR(440,NARC,nulls)

	    if(NARCT.EQ.0)then
	    if(OPT_printsd.ge.iiprint1)then
	    write(kanalpl,*)'SADDLE ARC: no points '
	    end if
	    goto 5150  !no DOTS for this saddle faces
	    end if

c
c
	      do isf=1,nijs_face    ! LOOP over SADDLE faces for this IJ
	      nsf=2*isf-1
 
              RIJ = RI/(RI + RP) + RJ/(RJ + RP)

              AVH = (DABS(HIJ-RP) + HIJ * RIJ)/three

c free torus : 2PI rotation:
	      if(free_tor)then
	      rotate_angl= two*PI2
	      end if
	       
              if(.not.free_tor)then
	      rotate_angl= RotAng(nsf+1)-RotAng(nsf)
	      end if


              RNROT = DSQRT(D) * AVH * rotate_angl
              NROT = dint(RNROT + onehalf)


             if(NROT.lt.1.and.rotate_angl.gt.saddle_angl_min) NROT = 1

	      if(OPT_printsd.ge.iiprint1)then
	      write(kanalpl,*)
     &    'ARC rotations NROT= ',NROT,' ANGLE=',rotate_angl
	      if(NROT.lt.1.or.rotate_angl.le.saddle_angl_min)then
	      write(kanalpl,*)'torus of ZERO ANGLx rotation!'
	      write(kanalpl,*)'IAt,JAT =', IATOM,JATOM
	      write(kanalpl,*)'DIJ,HIJ,RI,RJ=',DIJ,HIJ,RI,RJ
	      end if
	      end if

	     if(NROT.ge.1)then   ! ARC will be rotated

              ANGLE = rotate_angl/float(NROT)

	      areaARC_a=ANGLE*storanal*onehalf/PI2
              areaSADDLE_a=areaSADDLE_a + 
     &	                    rotate_angl*storanal*onehalf/PI2	     


	      CALL IMATX(H)

              H(2,2) = DCOS(ANGLE)

	      H(3,3) = H(2,2)

	      H(3,2) = DSIN(ANGLE)

	      H(2,3) = - H(3,2)


	      CALL IMATX(H05)

	      ANGLE05=ANGLE*onehalf

              H05(2,2) = DCOS(ANGLE05)

	      H05(3,3) = H05(2,2)

	      H05(3,2) = DSIN(ANGLE05)
              
              H05(2,3) = - H05(3,2)

	    if(.not.free_tor)then

            if(SignRotS(nsf).lt.null)then ! make -ANGLE rotation
	    H(3,2) = -H(3,2)
            H(2,3) = -H(2,3)

	    H05(3,2) = -H05(3,2)
            H05(2,3) = -H05(2,3)
	    end if !-ANGLE 


	    do k1=1,3
	    AIJ(k1)= AIJarcS(k1,nsf)
	    do k2=1,3
	    G(k2,k1)=GarcS(k2,k1,nsf)
	    end do!k2
	    end do !k1

	    end if !not free_tor

	    areaARC=null      ! area associated with the ARC

            do NARC=1,NARCT

            call MULTV(v0_arc(1,NARC),G,VBS0(1,NARC,1))

ctt
	    if(OPT_printsd.ge.iiprint1)then
            write(kanalpl,*)'ARC points in LOC syst :'
            write(kanalpl,*)'xyz=',(v0_arc(k,NARC),k=1,3)
            write(kanalpl,'(a10,9f6.3)')'Rot mat G:', G
	    write(kanalpl,*)'ARC points in ROTATED LOC syst:'
	    write(kanalpl,*)'xyz=',(VBS0(k,NARC,1),k=1,3)
            end if


                 DUIJ = DDOT(UIJ,VBS0(1,NARC,1))

                 DO K = 1,3
                 VBS0(K,NARC,2) = - VBS0(K,NARC,1) + two*DUIJ*UIJ(K)
                 end do !K

            if(OPT_printsd.ge.iiprint2)then
	    write(kanalpl,*)'inverted ARC points in ROTATED LOC syst:'
	    write(kanalpl,*)'xyz=',(VBS0(k,NARC,2),k=1,3)
	    end if


		  HT = v0_arc(2,NARC)
		  AYON(NARC) = dot_cross(NARC)

		 if(NARC.le.narci)arch=archI
		 if(NARC.gt.narci)arch=archJ
c 
                 ARCA(NARC) = RP*DABS(HT)*arch*ANGLE ! SD dot area
                 areaARC=areaARC+ARCA(NARC)
                 
             if(OPT_printsd.ge.iiprint1)then
	     if(ARCA(NARC).eq.null)then
		 write(kanalpl,*)'ARCA(NARC),NARC=',ARCA(NARC),NARC
		 write(kanalpl,*)'HT,arch,ANGLE,rotate_angl=',HT,arch,
     & 	 ANGLE,rotate_angl
            end if
	    end if !OPT_printsd

            end do ! loop NARC

           NARC=NARCT

	   if(areaARC.eq.null)then
	   write(kanalpl,*)'ARC of ZERO area !!'
	   write(kanalpl,*)'NARC=',NARC
	   write(kanalpl,*)'ARCA(i)=',(ARCA(k),k=1,NARC)

	   areaSDnorm=one
	   else
	   areaSDnorm=areaARC_a/areaARC
	   end if


              CALL CONJ(H,G,GHGT)

	      CALL CONJ(H05,G,GH05GT)

	      do k2=1,3
	      do k1=1,3
	      POW(k1,k2)=GH05GT(k1,k2)
	      end do
	      end do


              KNBR = 0


	      npos_sd=0    

              DO 5100 IROT = 1,NROT


                 CALL MULTV(AIJ,POW,AIJP(1,1))


                 do K = 1,3
                    AIJP(K,2) = - AIJP(K,1)
                 end do


                 DO 4650 IP = 1,2

                    DO K = 1,3
                       PIJP(K,IP) = BIJ(K) + AIJP(K,IP)
                    end do !K

	     if(free_tor)then  ! no check for COLLISIONS WITH NEIGHBORING ATOMS
	     PAIR(IP)= .TRUE.  !both IP=1,2 is allowed
	     end if !free_tor


             if(.not.free_tor)then
	     PAIR(1)= .TRUE.   

	     PAIR(2)= .FALSE.  

	     if(IP.eq.2.and.arc_cross)then
             PAIR(IP) = .NOT. COLLID(PIJP(1,IP),RP,CNBR,ERNBR,MNBR,
     &           NNBR,maxnbr,ISHAPE,JNBR,KNBR,MOLNBR,IMOL,LKF,LKNBR)

	     end if! IP
	     end if! .not.free_tor

4650             CONTINUE


                 IF (.NOT. PAIR(1) .AND. .NOT. PAIR(2)) GO TO 5050

                 BOTH = PAIR(1) .AND. PAIR(2)


                 SRS(IATOM) = .TRUE.

                 SRS(JATOM) = .TRUE.


                 IF (NARC .LE. 0) GO TO 5050


                 IP=1  

                  IF (.NOT. PAIR(IP)) GO TO 5000

                 npos_sd=npos_sd+1
	   if(OPT_printsd.ge.iiprint1)then
           write(kanalpl,*)'ACCEPTED Probe position IROT,IP=', IROT,IP
	   end if

                    BURY = .FALSE.


             IF (IBURY .GT. 0) BURY = BURIED(PIJP(1,IP),RP,CNBR,RNB

     1R,MNBR,NNBR,maxnbr,ISHAPE,JNBR,KNBR,MOLNBR,IMOL)


            IF (IBURY .EQ. 1 .AND. .NOT. BURY) GO TO 5000


                YONPRB = arc_cross .AND. .NOT. BOTH 

		    NP = 1


                    DO 4850 I = 1,NARC
		     

               IF (BOTH .AND. AYON(I))then !control
	       singularSD=.true.
	       N_singularSD=N_singularSD+1
	       Ar_singularSD=Ar_singularSD + AREA

            if(OPT_printsd.ge.iiprint1)then
	       write(kanalpl,*)'SADDLE dot REMOVED, Iarc,NP=',I,NP
	       end if
            end if
                       IF (BOTH .AND. AYON(I)) GO TO 4850

                       IF (NP .GT. maxppp) CALL ERROR(480,NP,nulls)


ctt
ctt         write(kanalp,'(a14,3f6.3,1x,3f6.3)')'VBS0,VBS=',
ctt     &   (VBS0(K1,I,IP),K1=1,3),VBS
ctt         write(kanalp,'(a10,9f6.3)')'POW=',
ctt     &   POW

                       CALL MULTV(VBS0(1,I,IP),POW,VBS)


                       DO  K = 1,3
                       S(K,NP) = BIJ(K) + VBS(K)
                       end do !K

ctt 
ctt             write(kanalp,'(a10,i3,1x,3f6.3,1x,6f6.3)')'aft4700',NP,
ctt     &                 (S(k1,NP),k1=1,3), BIJ, VBS

		 
		 if(I.le.narci)then
		 N1(NP)= IATOM
		 N2(NP)= JATOM
		 
		 else
		 N1(NP)= JATOM
		 N2(NP)= IATOM
		 
		 end if

		 N3(NP)= 0



                       YON(NP) = AYON(I)

                       torus(NP) = ARCA(I)*areaSDnorm  !:SIMS DotArea 

                       NP = NP + 1


4850                CONTINUE

                    NP = NP - 1

                    IF (NP .LE. 0) GO TO 5000  ! NO record


	 RSwrite=RSwrite+1

		nprobpos=nprobpos + 1  

		if(nprobpos.ge.maxprob)then
		write(*,*)'SIMS:: ERROR: maxprob too small', maxprob
		write(kanalpl,*)'SIMS:: ERROR: maxprob too small', maxprob
                    stop 3008
		end if


           call SwriteWP(IMOL,ISHAPE,NP,PIJP(1,IP),AIJP(1,IP),
     &                YONPRB,BURY,
     &                probmax1,nprobpos,WPIIN,WPPcAv,WPYONB)

	   start_dotn(nprobpos+1)=start_dotn(nprobpos) + NP

           IF (YONPRB) THEN



                       IF (NY .GE. MAXYON) CALL ERROR(720,NY,nulls)

                       NY = NY + 1

                       MOLYON(NY) = IMOL

                       DO K = 1,3
                          PY(K,NY) = PIJP(K,IP)
                          AY(K,NY) = AIJP(K,IP)
                       end do !K

                    END IF


                    DO 4950 I = 1,NP

         ndotccsd=ndotccsd + 1	

ctt	 
ctt           write(kanalp,'(a21,4i5,2x,4f8.4)')'bef SwriteD ndot=',
ctt     &     ndotccsd,N1(I),N2(I),N3(I),
ctt     &     (S(k1,I),k1=1,3),torus(I)
 
         call SwriteWD(N1(I),N2(I),N3(I),S(1,I),torus(I),YON(I),
     &        maxdot1,ndotccsd,WDN123,WDScAr,WDYON)


4950                CONTINUE



5000             CONTINUE

	   if(OPT_printsd.ge.iiprint1)then
           write(kanalpl,*)
     & 'This Probe Saddle position generates Ndot=', NP
	   end if

5050             CONTINUE

                 CALL CAT(POW,GHGT)

5100          CONTINUE

	     if(OPT_printsd.ge.iiprint1)then
	      write(kanalpl,*)'Accepted probe positions=',npos_sd
	      end if

	      ndotSADDLE=ndotSADDLE+npos_sd*NARC
	      areaSADDLE_n=areaSADDLE_n+areaARC*npos_sd*areaSDnorm

	      if(OPT_printsd.ge.iiprint1)then
	      write(kanalpl,*)'Tot area SADDLE_n=',areaSADDLE_n
	      write(kanalpl,*)'Tot dots SADDLE=',ndotSADDLE
	      write(kanalpl,*)'**********************************'
	      end if !
 

	      end if !NROT ge 1
	      end do !isf LOOP over SADDLE faces of IJ pair

	nprob_mx=maxprob
	ndot_mx = maxdot
	nconcij_mx=nconc_ij_mx
	nconc_mx = nconc_glob_mx

	if(.not.free_tor.and.OPT_removeCC.and.arc_cross)then
	call remove_ccdot(nprob_mx,ndot_mx,nconcij_mx,nconc_mx,
     &                  icfIJ,
     &                  RP,BIJ,UIJ,HIJ,
     &                  cprobe_ijk,concf_ijf,nconc_glb_nprpos,
     &                  start_dotn,WDScAr,WDYON,WDYONRm)

	end if

5150       CONTINUE
           end if !NNBR ge 1



5200       CONTINUE


           ISHAPE = 1


           IF (.NOT. SI) GO TO 5650

	   if(OPT_printcx.ge.iiprint1)then
          write(kanalpl,*)'* * * * * * * * * * * '
	  write(kanalpl,*)'CONVEX : ATOM IATOM ',IATOM 
	   end if





           IF (.NOT. BURY .AND. RP .GT. null .AND.

     1    NIMOL .GT. 0 .AND. .NOT. SRS(IATOM)) THEN

	   if(OPT_printcx.ge.iiprint1)then
	  write(kanalpl,*)
     & 'ATOM IATOM ',IATOM , ' COMPLETELY INACCESSIBLE'
	   end if

	  GO TO 5650

	  end if


	NUV = (4.0d0*PI2*RI**2 )*D


        IF (NUV .GT. maxsph) NUV = maxsph

        IF (NUV .LT. 12) NUV = 12          !minimal number of points

       	CALL GENUN02(RI,UA,ARUA,NCHIUA,NUV,NCHmx)

c area per convex dot of IATOM
c average dot area 
           AREA = (four*PI2 * RI ** 2) / dfloat(NUV)

	   sizeDot = dsqrt(AREA)
	   sizeDot4 = 0.25d0*sizeDot  !1/4 of linear size of the dot

	   range_cx = one

	   RI2 = RI**2

c dot uncutted area initialization
	   do I=1,NUV 
	   dot_aw(I)=one
	   end do!I

c ALL CONVEX surface is accessible
           IB = 0


           JNBR = 0

           KNBR = 0
           
	   if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'***********************************'
	   write(kanalpl,*)'CONVEX face IATOM=',IATOM
           end if
	   if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'OPT_sizeBE = 0',OPT_sizeBE
	   end if
	   if(ntor_i(IATOM).le.0)then  !no torus
	   if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'CONVEX LOOP: atom',IATOM,' HAS no torus'
	   end if

	   do I=1,NUV 
	   dot_aw(I)=ARUA(I)         !dot areas
	   do k=1,3
	   dotCO(k,I)=UA(k,1,I) !frame origin at the CI of IATOM 
	   end do!k
	   end do!I
	   end if ! NO torus
	   
           if(ntor_i(IATOM).ge.1)then

	   if(MAXntor_i.lt.ntor_i(IATOM))MAXntor_i=ntor_i(IATOM)

	   if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'CONVEX:CUT dot from IATOM=',IATOM
	   write(kanalpl,*)'totalNumb of torus(IATOM)=',ntor_i(IATOM)
	   end if

	   if(OPT_printcx.ge.iiprint1)then
	   if(IATOM.lt.10)then
	   write(kanalpl,*)'IATOM',IATOM
	   write(kanalpl,*)'make torus with JATOM:',
     &	   (Jattor_i(k1,IATOM),k1=1,ntor_i(IATOM))
	   do k1=1,ntor_i(IATOM)
	   write(kanalpl,*)'Ds, ',Dstor_i(k1,IATOM)
	   end do!k1
	   end if
	   write(kanalpl,*)'MAXntor_i=',MAXntor_i
	   end if !print

	   frame_cx = 0
	   JATOM=Jattor_i(1,IATOM)

	   do k=1,3
	   VIJ(k)=CO(k,JATOM) - CI(k)
	   end do

	   call DVNORM(VIJ,UIJ)

	   if(ntor_i(IATOM).eq.1)then  

	   call VPERP(UIJ,Q)
	   frame_cx=1
	   end if !one

	   if(ntor_i(IATOM).ge.2)then  

	   KATOM=Jattor_i(2,IATOM)
	   do k=1,3
	   VIJ(k)=CO(k,KATOM)-CI(k)
	   end do !k

           aa1=DDOT(VIJ,UIJ)
	   do k=1,3
	   VIJ(k)=VIJ(k) - aa1*UIJ(k)
	   end do!k

c cheak linearity
	   aa2 = DDLENG(VIJ)
	   if(aa2.le.small)then ! linear Kat--Iat--Jat

	   if(ntor_i(IATOM).ge.3)then !try next neighbor

	   KATOM=Jattor_i(3,IATOM)
	   do k=1,3
	   VIJ(k)=CO(k,KATOM)-CI(k)
	   end do !k

           aa1=DDOT(VIJ,UIJ)
	   do k=1,3
	   VIJ(k)=VIJ(k) - aa1*UIJ(k)
	   end do!k
	   call DVNORM(VIJ,Q)   
	   frame_cx=3

	   else                       ! no 3 neighbor
	   call VPERP(UIJ,Q)
	   frame_cx=1
	   end if ! 3 neighb

	   else                       ! nonlinear Kat--Iat--Jat
	   call DVNORM(VIJ,Q)
	   frame_cx=3
	   end if !linear Kat--Iat--Jat

	   end if ! 2 neighb


	   call DVECTPR(UIJ,Q,T)

     
	   do k=1,3
	   G(k,3)=T(k)
	   G(k,2)=Q(k)
	   G(k,1)=UIJ(k)
	   end do
 
	   if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'frameIATOM',IATOM,' frame_axis',frame_cx

	   if(ntor_i(IATOM).lt.2)then
	   write(kanalpl,*)'One axis frame IATOM',IATOM,' ntor_i ',
     &	   ntor_i(IATOM)
	   end if

	   write(kanalpl,'(a14,3f9.6)')'rmatr:G(k,1)=',(G(k,1),k=1,3)
	   write(kanalpl,'(a14,3f9.6)')'rmatr:G(k,2)=',(G(k,2),k=1,3)
	   write(kanalpl,'(a14,3f9.6)')'rmatr:G(k,3)=',(G(k,3),k=1,3)
	   end if
c
c
	   do I=1,NUV 
	   dot_aw(I)=one

           do k=1,3
	   dotCO(k,I)=null
	   end do

	   do k2=1,3
	   do k1=1,3
	   dotCO(k1,I)=dotCO(k1,I) + G(k1,k2)*UA(k2,1,I)
	   end do!k1
	   end do!k2

	   if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,'(a22,i4,1x,3f8.4)')
     &	   'initial I, dotCO=',I,(UA(k,1,I),k=1,3)
	   write(kanalpl,'(a22,i4,1x,3f8.4)')
     &	   'Rotated I, dotCO=',I,(dotCO(k,I),k=1,3)
           end if!print

	   end do!I

c
c
	   I=0

5320       I=I+1
	   if(I.gt.NUV)goto 5325   ! end of LOOP

           if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'IATOM ',IATOM,' I dot=',I,'area=',ARUA(I)
             end if

c dot size
	   sizeDot = dsqrt(ARUA(I))
	   sizeDtet = sizeDot/RI
	   sizeDot4 = 0.50d0*sizeDot  !1/2 of linear size of the dot

	   do ich=1,NCHmx
	   dotchsf(ich)=.true.     !dot accept flag for refcut09 
	   dotchrf(ich)=.false.    !dot rotate flag for refcut09

	   do k=1,3
	   dotchild(k,ich)=UA(k,ich,I)    !children dots coord in Loc system
	   dotchildr(k,ich)=null          !initialization rotated
	   end do !k
	   end do !ich

	   dotchrf(1)=.true.
	   do k=1,3
	   dotchildr(k,1)=dotCO(k,I)
	   end do !k
c
c
	   lastcut = .false.       ! parameter for refcut09

	   do it=1,ntor_i(IATOM)

	   if(it.eq.ntor_i(IATOM))lastcut=.true.

	   JATOM=Jattor_i(it,IATOM)
	   do k=1,3
	   VIJ(k)=CO(k,JATOM) - CI(k)
	   end do

	   call DVNORM(VIJ,UIJ)

	   aa1=null
	   do k=1,3
	   aa1=aa1+UIJ(k)*dotCO(k,I)
	   end do

c dot product dotCO*UIJ
           dotvUIJ = aa1
	    

	   if(OPT_sizeBE.eq.0)then
	   if(aa1.gt.Dstor_i(it,IATOM) - toler_d)then
	   dot_aw(I)=null
           if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'DOT removed '
	   end if

	   goto 5320           !next dot
	   end if
           end if!OPT_sizeBE eq 0

	   if(OPT_sizeBE.eq.1)then   ! OK 
	   aa2 = one-(Dstor_i(it,IATOM)/RI)**2    ! sin(tet)**2
	   if(aa2.lt.null)aa2=null
	   sintet = dsqrt(aa2)                       ! sin(tet)
	   sizeBE=sizeDot4*sintet                    !1/2 dotsize

	   if(sizeBE.gt.null)then
           delta(it)=(aa1 - Dstor_i(it,IATOM))/sizeBE
	   else
	   delta(it)=null
	   end if

	   if(delta(it) .le. - range_cx)then 
           if(OPT_printcx.ge.iiprint1)then
           write(kanalpl,*)'!!** dot ',I, ' is accepted*!!'
	   end if

	   goto 5322                         !next cut plane
	   end if ! le -range_cx

	   if(delta(it) .ge. range_cx)then  
	   dot_aw(I)=null
           if(OPT_printcx.ge.iiprint1)then
           write(kanalpl,*)'!!** dot ',I, ' is deleted**!!'
	   end if
	   goto 5320                        ! next dot I
	   end if ! ge. range_cx

           if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'it, delta(it):',it,delta(it)
	   write(kanalpl,*)' DsDot=',aa1
	   write(kanalpl,*)' sizeDot4,sizeBE=', sizeDot4,sizeBE
	   write(kanalpl,*)' sizeDtet =', sizeDtet
             end if



	  call cxdotrfcut5(G,dotchild,dotchildr,dotchrf,
     &	  dotchsf,dotCO(1,I),UIJ,Dstor_i(it,IATOM),
     &               RI,dot_aw(I),NCHmx,lastcut)
!     &               RI,dot_aw(I),NCHmx)


	   end if!OPT_sizeBE eq 1

5322       continue
	   end do !it loop over torus
ctt
	   if(OPT_printcx.ge.iiprint1)then
	   write(*,*)'IATOM=',IATOM,'ACCEP Ndot,dot_aw=',I,dot_aw(I)
           end if

c
c

	   goto 5320

5325       continue    ! end of LOOP over dots on sphera IATOM

c final area of dots
	   do I=1,NUV 
	   dot_aw(I)=dot_aw(I)*ARUA(I)
	   end do!I

	   if(OPT_printcx.ge.iiprint1)then
           do I=1,NUV
	   write(*,*)'final dot I area=',I,dot_aw(I)
           end do !I
	   end if

	   end if! CUTTING plane number: ntor_i ge 1

c final LOOP
           do I = 1,NUV

	   if(dot_aw(I).le.toler_cx)goto 5600


              NSHAPE(1) = NSHAPE(1) + 1

              AREAC = AREAC + dot_aw(I) 
              IATNUM(1) = IATOM
              IATNUM(2) = 0
              IATNUM(3) = 0

              do K = 1,3
	      OUTCO(K) = CI(K) + dotCO(K,I)
              OUTVEC(K) = dotCO(K,I)/RI
              end do

	      idot=idot + 1
	      dot_IATNUM(idot)=IATNUM(1) !atom number to which dot belong to
	      dot_ISHAPE(idot)=ISHAPE
	      dotarea(idot)=dot_aw(I)
	      dot_IB(idot)=IB  ! 0/1 if dot belongs to acces/burr molsrf

	      do K =1,3
	      dotcrd(K,idot)=OUTCO(K)
	      dotnrm(K,idot)=OUTVEC(K)
	      enddo !k

5600         end do ! I->NUV

	   if(OPT_printcx.ge.iiprint1)then
	   write(kanalpl,*)'END CONVEX Surf IATOM=', IATOM
	   end if

5650       end do !IATOM BIG LOOP


	   nprobpos_t = nprobpos
	   ndotccsd_t = ndotccsd

	   if(OPT_printrem.gt.iiprint0)then
	   write(kanalpl,*)' nprobpos_t =',nprobpos_t
	   write(kanalpl,*)' ndotccsd_t =',ndotccsd_t
	   end if

	   if(OPT_printrem.gt.iiprint1)then
           write(kanalpl,*)'WDN123  WDScArea   WDYON '

	   do k=1,nprobpos_t
           write(kanalpl,*)' probe'
	   write(kanalpl,'(i4,3i4,1x,3f9.5,1x,3f9.5,1x,2L1,1x,i4)')
     & k,(WPIIN(k2,k),k2=1,3),(WPPcAv(k2,k),k2=1,6),
     & WPYONB(1,k),WPYONB(2,k),start_dotn(k)

	   write(kanalpl,*)'dots:'

	   do k1=1+start_dotn(k),start_dotn(k+1)
	   write(kanalpl,'(i5,2x,3i5,2x,3f14.10,f7.5,2x,L2)')
     &  k1,(WDN123(k2,k1),k2=1,3),(WDScAr(k2,k1),k2=1,4),WDYON(k1)
	   end do
	   end do
	   end if
c
c




        IF (RP .EQ. null) GO TO 8000





	 if(RSwrite.eq.0)then 
	 write(kanalpl,*)'NO REENTRANT SURFACE'
	 goto 7850
	 end if 


        I = 1
	 
        nprobpos = 0    !initialize number of probe position and dots
	ndotccsd = 0    ! to read

7000    CONTINUE

	 nprobpos = nprobpos + 1
	 if(nprobpos.gt.nprobpos_t)goto 7850

         call SreadWP(IMOL,ISHAPE,NP,P,A,
     &                YONPRB,BURY,
     &                probmax1,nprobpos,WPIIN,WPPcAv,WPYONB)


	if(NP.eq.0)goto 7800

        DO 7750 J = 1,NP

	   ndotccsd = ndotccsd + 1

	   if(ndotccsd.gt.ndotccsd_t)then
	   write(*,*)'SIMS:: ERROR : wrong NDOTccsd ',ndotccsd
	   write(kanalpl,*)'SIMS:: ERROR : wrong NDOTccsd ',ndotccsd
                stop 3009
	   end if

           call SreadWD(N1(1),N2(1),N3(1),S(1,1),AREA,YON(1),
     &                  maxdot1,ndotccsd,WDN123,WDScAr, WDYON)

ctt
ctt           write(kanalp,'(a11,4i5,2x,4f8.4)')'out SreadWD ndot=',
ctt     &     ndotccsd,N1(1),N2(1),N3(1),
ctt     &     (S(k1,1),k1=1,3),AREA

	   if(ISHAPE.eq.2.and.YON(1)) goto 7700

	   if(ISHAPE.eq.3.and.WDYONRm(ndotccsd))then

c print: 
          if(CONTROL)then
           write(kanalp,'(a11,4i5,2x,4f8.4)')'NonSymm Dot is Removed',
     &     ndotccsd,N1(1),N2(1),N3(1),
     &     (S(k1,1),k1=1,3),AREA
           end if

            goto 7700
           end if
	

           do  K = 1,3
              OUTVEC(K) = (P(K) - S(K,1))/RP
           end do

           NSHAPE(ISHAPE) = NSHAPE(ISHAPE) + 1
           AREAR = AREAR + AREA

           IB = 0
           IF (IBURY .GT. 0 .AND. BURY) IB = 1

           IATNUM(1) = N1(1)
           IATNUM(2) = N2(1)
           IATNUM(3) = N3(1)

           DO K = 1,3
              OUTCO(K) = S(K,1)
           end do !K

	      idot=idot + 1
	      dot_IATNUM(idot)=IATNUM(1) !atom number to which dot belongs
	      dot_ISHAPE(idot)=ISHAPE
	      dotarea(idot)=AREA
	      dot_IB(idot)=IB

	      do K =1,3
	      dotcrd(K,idot)=OUTCO(K)
	      dotnrm(K,idot)=OUTVEC(K)
	      enddo !k
ctt 
	if(outdetl.ge.iiprint2)then
	write(kanalpl,93)idot,dot_IATNUM(idot),dot_ISHAPE(idot),
     &   dotarea(idot),
     &  (dotcrd(k1,idot),k1=1,3),(dotnrm(k1,idot),k1=1,3)
        end if

           GO TO 7750

7700       CONTINUE

           NLOST(ISHAPE) = NLOST(ISHAPE) + 1

	   ARLOST(ISHAPE)=ARLOST(ISHAPE) + AREA   !SIMS:


7750    CONTINUE


7800    CONTINUE

        I = I + 1

        GO TO 7000

7850    CONTINUE

8000    CONTINUE

        ndots=idot
c
c
	      surf1=null
	      surf0=null
              surfa = null

       do k=1,3
       surf_type(k)=null
       dsurf_type(k)=null
       ndot_type(k)=0
       dndot_type(k)=0
       VECTOR(k)=0.0d0
       end do !k

       athreshmx = 0.1 ! A**2 max area of REMOVED dots
       athresh=0.10 
       athresh=athresh/dotden      
       if(athresh.gt.athreshmx)athresh=athreshmx
        nnnd=ndots
        ndots=0

	if(outdetl.gt.iiprint1)then
        write(kanalpl,*)
	write(kanalpl,*)'REMOVED small area DOTS' 
	write(kanalpl,*)'       id  iat type  area               xyz',
     &  '                 nvect'
	end if

        do id=1,nnnd
       surf0=surf0 + dotarea(id)
        if(dotarea(id).le.athresh)then    !remove
       k=dot_ISHAPE(id)
       dsurf_type(k)=dsurf_type(k) + dotarea(id)
       dndot_type(k)=dndot_type(k) + 1
       surf1=surf1+dotarea(id) 

ctt write REMOVED dots
        if(outdetl.gt.iiprint1)then    ! wtt
	write(kanalpl,93)id,dot_IATNUM(id),dot_ISHAPE(id),dotarea(id),
     &  (dotcrd(k1,id),k1=1,3),(dotnrm(k1,id),k1=1,3)
        end if !wtt
     

        else                              !keep
        ndots=ndots+1
        dot_ISHAPE(ndots)=dot_ISHAPE(id)
        dot_IATNUM(ndots)=dot_IATNUM(id)
	dotarea(ndots)=dotarea(id)
	surfa = surfa + dotarea(ndots)

	surf_type(dot_ISHAPE(ndots))=surf_type(dot_ISHAPE(ndots))+
     &  dotarea(ndots)
	ndot_type(dot_ISHAPE(ndots))=ndot_type(dot_ISHAPE(ndots))+1

        atom_srf(dot_IATNUM(ndots))=atom_srf(dot_IATNUM(ndots))
     &  + dotarea(ndots)
	
        do k1=1,3
	dotcrd(k1,ndots)=dotcrd(k1,id)
	dotnrm(k1,ndots)=dotnrm(k1,id)
        VECTOR(k1)=VECTOR(k1) + dotcrd(k1,ndots)*dotarea(ndots)
        end do !k

	end if
	end do !id
 
        if(surfa.gt.0.0d0)then
        do k=1,3
        VECTOR(k)=VECTOR(k)/surfa
        end do!k
        end if

c
c RESULT
c
	if(outdetl.ge.iiprint0)then
        write(kanalpl,*)
	write(kanalpl,'(a13,i6)')'SIMS: ntoms:',ntoms
        write(kanalpl,'(a21,3f10.6)')'SIMS:Surface Center:',VECTOR
        write(kanalpl,'(a31,i6)')'SIMS:Total number of Dots    :',ndots
	write(kanalpl,'(a31,f8.3)')'SIMS:Total Surface area, A^2 :'
     & ,surfa
        write(kanalp,'(a12,f10.4,a12,i6,a16,f10.4)')'SIMS: Dens= '
     & ,dotden, ' No. Dots: ',ndots, ' Surface (A^2): ',surfa

        if(outdetl.ge.iiprint1)then 
        write(kanalpl,*)
	write(kanalp,'(a35,3(1x,i5,8x))')
     &  'SIMS:Deleted Ndot    types(1,2,3) ', dndot_type
	write(kanalpl,'(a35,3(1x,i5,8x))')
     &  'SIMS:Deleted Ndot    types(1,2,3) ', dndot_type
	write(kanalpl,'(a35,3f13.6)')'SIMS:Deleted DotArea types(1,2,3) ',
     &	dsurf_type
	write(kanalpl,*)
	write(kanalpl,*)'SIMS:Step_Wise method of CONVEX dot cutting '
        end if

	write(kanalpl,*)
	write(kanalpl,'(a27,3f13.6)')
     & 'SIMS: DotArea types(1,2,3)',surf_type
        write(kanalpl,'(a27,3(1x,i5,8x))')
     &  'SIMS:   Ndot types(1,2,3) ',ndot_type
	write(kanalpl,'(a25,i5)')'SIMS:  N_singularTorus: ', n_singulTor
        if(outdetl.ge.iiprint1)then	
        write(kanalpl,*)
	write(kanalpl,'(a41,2f12.5)')
     & 'SIMS: Area of SADDLE faces (anlyt,numr) ',
     &  areaSADDLE_a,areaSADDLE_n
	write(kanalpl,'(a40,f12.5)')
     &  'SIMS: ANALYTICAL area of CONCAVE faces:',
     &  areaCONCAVE
        write(kanalpl,'(a19,i6,a13,i6)')
     &  'SIMS: N_CC_triDiv=', n_cc_tridiv,' N_CC_PrbPrj=',n_cc_PrbPrj
        end if
	write(kanalpl,*)
	write(kanalpl,'(a32,i5,a29,f12.6)')
     &	'SIMS:SymSingul CC dots Removed ',N_singularCC,
     &	'   AreaSymSingul_CC=',AR_singularCC

	write(kanalpl,'(a32,i5,a29,f12.6)')
     &	'SIMS:SymSingul SD dots Removed ',N_singularSD,
     &	'   AreaSymSingul_SD=',AR_singularSD

	write(kanalpl,'(a42,i5,7x,i5)')
     &	'SIMS:NONsymSingl DOTS REMOVED: CC and SD ',
     &  NLOST(3),NLOST(2)

	write(kanalpl,'(a42,2f12.6)')
     &	'SIMS:NONsymSingl AREA REMOVED: CC and SD ',
     &  ARLOST(3),ARLOST(2)

	badsurf=surf1/surfa
     
	if(badsurf.gt.badsurf_mx)then
	write(kanalpl,*)
	write(kanalpl,*)
     & '!!! WARNINIG !!! too much surf is removed %reltval=',badsurf
        end if
        end if

        if(outdetl.ge.iiprint0)
     &  write(kanalpl,*)'SIMS: normalEND of SIMS ...'

93      format(i5,1x,i4,i2,2x,f8.5,2x,3f8.3,2x,3f7.3,1x,f6.4)

       
        if(kanalpl.ne.6)then
           close(kanalpl)
        end if
	RETURN
        END
