c LAST modification: Apr. 4, 96 : potencial in equil.ion state
c
c     SOLVATION AND EQUILIBRIUM PROTON BINDING  in water 95'
c.
c  program provides - free energy of transport from VACUUM 
c                    to SOLVENT   (with no salt) = fre_cav  + fre_solv
c
c     fre_hbind      free energy of equilibrium proton binding
c                    for  pH=7.0, t.e.
c                    defines an optimal ionization state and free
c                    energy of this ionization state
c                    and statistical average over all ionozation states
c    average ionization degrees and FREE energy of proton binding
c
c. all input method related information are in files input.ibe
c.    PARSE parameters of Honig                      atrad.siz
c     PARSE  parameters of Honig                     atcrg.crg
c.    Protein coordinates can be readed from         molec.cor
c                                                    molec+.cor
c. PBD files for neutral (residues) and all ionizable (residues) for
c  the same conformation
c-------------------------------------------------------------------        

      subroutine solv_eqpb(fre_cav,fre_solv,fre_hbind,fre_tot)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include'param.ibems'
      include'comm.ibems'
      include'comm.ibemsav'
      include 'COMMON.EXTPH'
      include 'COMMON.MYCONF'
      include'ecepp_ibems_intrf.h'
      include 'COMMON.TIME1'
      include 'COMMON.ODONNELL'
c*
      real*8 fre_solv,fre_cav,fre_tot,fre_hbind
c
      real*8 soord(3,maxat),rad_ps(maxat),atmq_ps(maxat)
      real*8 force_c(3,maxat),force_s(3,maxat),force_h(3,maxat)
      real*8 force_t(3,maxat), forcen_t(3,maxat)
      real*8 en_cl,en_sl,en_frt,en_hopt
      real*8 el_freng,hp_freng,pH,sol_freng
      integer xxinit(nres_mx),xxfinal(nres_mx)
      real*8 ggg00,ggg01,ggg02,ggg03,qqbb
      real*8 sol_frena,sol_frenb,epssols
      integer iter,index,nsoord,kr,i,ia,ir,ix,iph,k,ionecentr_s
      integer iiprint0,iiprint1,ivarc0,ivarc1
      data ione /1/,izero /0/
C      logical OPT_potential
      logical stopx

C       write(*,*) 'in  Solv_eqpb'
      iiprint0=0
      iiprint1=1
C     OPT_potential=.TRUE. 
      if(outdetl.ge.iiprint0)then
        write(*,*)'ENERGY of transfering to water and ENERGY of'
     &  , ' Proton binding'
      end if

!     tstar0=tcpu()
C Initialization of a few  variables is done here.
      epssol=epssol_sav
      epsmol=epsmol_sav
      ichargroup=ichargroup_sav
      ionecentr=ionecentr_sav
c      write(*,*)'solv_ibem: 1,  epssol, epsmol ',epssol, epsmol

c atomic coordinates 	
c. for test 
      call inputcrd_ib(izero,ione)
c      write(*,*)'OUT of inputcrd_ib(izero,ione)'
      if (kprotfail.le.-1) then
        write(*,*)'ERROR IN inputcrd_ib'
        return
      endif

        if (stopx(izero)) then
          write(*,*) 'Time is running out '
          write(*,*) 'Aborting in solv_ibems_DR'
          kprotfail=-999
          return
        endif

!     timeint=tcpu()-tstar0
c     write(kanalp,*) 'time reading=', timeint  
c     write(*,*) 'time reading=', timeint  

c Apr4 Safe atom list for charged groups in neutral state
      nchargr_t0=nchargr_t 
      do ia=1,nchargr_t0
         jchargr_xyz0(ia)=jchargr_xyz(ia)
         jchargr_an0(ia)=jchargr_an(ia)
         jchargr_rsn0(ia)= jchargr_rsn(ia)
         jchargr_kn0(ia)=jchargr_kn(ia)
         chargr_nam0(ia)=chargr_nam(ia)
         if(jchargr_an0(ia).gt.0)then
            do k=1,jchargr_an0(ia)
               jchargr_al0(k,ia)=jchargr_al(k,ia)
            end do !k
         end if
      end do !ia
c Apr4 END
c........................................................................
c  Solvation energy for initial state...neutral peptide 
c  backbone charges are taking into account.
      nsoord=nnmlat
c       write(*,*)'solv_ibems: Number of atoms=', nsoord
      qqbb=0.0d0
      do ia=1,nsoord 
         rad_ps(ia)=atmrad(ia)
         atmq_ps(ia)=atmcha(ia) 
         qqbb=qqbb+atmcha(ia)
         do k=1,3
            soord(k,ia)=atmxyz(k,ia)
         end do
c       write(kanalp,*) ia, atmcha(ia), (soord(k,ia),k=1,3)
      end do

      if(outdetl.ge.iiprint0)then
c       write(*,*)'solv_ibems: tot charge=',qqbb
C        write(kanalp,*)'solv_ibems: tot charge=',qqbb
      
         if(outdetl.ge.iiprint1)then
            write(*,*)'initial neutral PS xyz r q'  
c           write(kanalp,*)'initial neutral PS xyz r q'  
            do ia=1,nsoord
               write(*,'(5f8.3)')(soord(k,ia),k=1,3),rad_ps(ia),
     &                                              atmq_ps(ia)
c              write(kanalp,'(5f8.3)')(soord(k,ia),k=1,3),rad_ps(ia),
c    &                                              atmq_ps(ia)
            end do
         end if
      end if
c........................................................................	
c.. energy of transport of neutral(all residues are neutral) protein
c.. from VACUUM to SOLVENT ..........................................
c.. need two calculation of E_solv(evac/epsmol) and E_solv(epssol/epsmol)
c.. solv energy of neutral peptide is calculated by group method
      ionecentr_s=ionecentr
      ionecentr=0    ! total molecule never be considered in onecenter  
c                                                              approximation

c.
c     write(*,*)'INTO solv_trans'
      call solv_trans(nsoord,soord,rad_ps,atmq_ps,
     &                      sol_freng,el_freng,hp_freng)         

c     write(*,*)'OUT of solv_trans'

!     timet=tcpu()-tstar0
c     write(kanalp,*) 'time after  solv_trans=', timet  
      if (kprotfail.le.-1) then
         write(*,*) 'failed' ,kprotfail
        return
      endif
      fre_solv = sol_freng
      fre_cav = hp_freng
      fre_hbind= 0.0d0
      fre_tot= fre_solv+fre_cav+fre_hbind

      if(outdetl.ge.iiprint0)then
         write(*,*)' '
         write(*,*)'FREE ENERGY of transport from VACUUM to WATER'
         write(*,*)'fre_cav = ',fre_cav
         write(*,*)'fre_solv =', fre_solv
         write(*,*)'fre_tot = ', fre_tot
         write(*,*)' '
         index=1
         call timit(index)
c         write(*,*)'finish solv_trans'
c         write(kanalp,*)'finish solv_trans'
      end if

c. back to original
      ionecentr=ionecentr_s
c

c proton binding inizialization
 	do i=1,nres_mx
 	opt_ionz(i)=0.d0
 	end do!i


c-------------------------------------------------------------
c.  PROTON BINDING 
c-------------------------------------------------------------
c        write(kanalp,*)'Start multiproton binding calculation....' 
c 
c for ONE fixed value pH
      ivarc1=1
      pH=pHs
c     write(*,*)'INTO  proton_bind'
      call proton_bind(ivarc1,pH,fre_hbind)
c     write(*,*)'OUT of proton_bind'
!     timet=tcpu()-tstar0
c     write(kanalp,*) 'time after  proton_bind=', timet  
      fre_tot= fre_tot + fre_hbind
      if(outdetl.ge.iiprint0)then

        write(*,*)
     &            'free energy of multiproton binding=',fre_hbind 
        write(*,*) '                               pH=',pH
        write(*,*) 
        write(*,*)'TOTAL free energy of SOLVATION and PROTON',
     &          ' binding=' , fre_tot     
        write(*,*)
        write(*,*)
     &                'Average ionization degree of ionizable residues'
        write(*,'(10f7.3)')(opt_ionz(i),i=1,npolres_t)
        write(*,'(10(i5,2x))')(ionresgl(i),i=1,npolres_t)
        write(*,*)
        write(*,*)'----------------------------------------------
     &-------------------'

c       write(kanalp,*)
c    &            'free energy of multiproton binding=',fre_hbind 
c       write(kanalp,*) '                               pH=',pH
c       write(kanalp,*) 
c       write(kanalp,*)'TOTAL free energy of SOLVATION and PROTON',
c    &          ' binding=' , fre_tot     
c       write(kanalp,*)
c       write(kanalp,*)
c    &                'Average ionization degree of ionizable residues'
c       write(kanalp,'(10f7.3)')(opt_ionz(i),i=1,npolres_t)
c       write(kanalp,'(10(i5,2x))')(ionresgl(i),i=1,npolres_t)
c       write(kanalp,*)
c       write(kanalp,*)'----------------------------------------------
c    &-------------------'
      end if
c
c. Uncomment next fragment to calculate 
c. multiproton binding for standart pH grid=2,3,4,5,6,7,8,9,10,11,12
c. ! only one call of PROTON_bind is allowed
c        ivarc0=0
c        call proton_bind(ivarc0,pH,fre_hbind)
c
C       if(outdetl.ge.iiprint0)then
c        index=1
c        call timit(index)
c        write(kanalp,*)'FINISH of Free energy of Proton binding '
C        end if

      if(outdetl.ge.iiprint0)then
        write(*,*)
        write(*,*)'FINISH IBEM calculations'
        write(*,*)'----------------------------------------------'

C       write(kanalp,*)
C       write(kanalp,*)'FINISH IBEM calculations'
C       write(kanalp,*)'-----------------------------------------'
      end if

c FINAL POTENTIAL created by the protein in the equilibrium Ioniz state
      if(OPT_potential)then
         if(outdetl.ge.iiprint1)
     &    write(*,*)'Compute Potential on Lattice '
	 call potential_eql
C  	   index=1
C          call timit(index)
C          write(kanalp,*)'FINISH Potential on Lattice '
      end if


      return
      end
c----------------------------------------------------------
      subroutine proton_bind(ivarc,pH,fre_hbind)
c. free energy of equilibrium proton binding for a given pH if ivarc=1
c  if ivarc=0 then calculations are for pH=2,3,4,5,6,7,8,9,10,11,12

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include'param.ibems'
      include'comm.ibems'
      include'comm.ibemsav'
      include'ecepp_ibems_intrf.h'
      include 'COMMON.TIME1'
      include 'COMMON.ODONNELL'
      include 'COMMON.MYCONF'
c*
      real*8 force_c(3,maxat),force_s(3,maxat),force_h(3,maxat)
      real*8 force_t(3,maxat)
      integer xxinit(nres_mx),xxfinal(nres_mx)
      real*8 ggg00,ggg01,ggg02,ggg03,qqbb
      real*8 fre_hbind,pH, optionz(nres_mx)
      real*8 en_hopt
      integer iter,index,nsoord,ir,ix,iph
      integer iiprint1,ivarc,iiprint0,k
      logical stopx
      real*8 pH_v(gph_mx)      
      data pH_v/2.0d0,3.0d0,4.0d0,5.0d0,6.0d0,7.0d0,8.0d0,
     &            9.0d0,10.0d0,11.0d0,12.0d0/
      data ione /1/,izero /0/

!     tstar0=tcpu()
c     if (YourJob) write(kanalp,*) 'In proton_bind at Time= ',tstar0
      iiprint0=0
      iiprint1=1
      if(outdetl.ge.iiprint0)then
         index=1
         call timit(index)
c        write(*,*)'Start Free energy of Proton binding '
      end if

c        call openfile_ib

c        call input1_ib
C This call to input1_ib was eliminated DR 3/97. Initialization of a 
C few  variables is done, instead.
      epssol=epssol_sav
      epsmol=epsmol_sav
      ichargroup=ichargroup_sav
      ionecentr=ionecentr_sav
c      write(*,*)'solv_ibem: 2, epssol, epsmol ',epssol, epsmol


c atomic coordinates 	
      call inputcrd_ib(ione,ione)
      if (kprotfail.le.-1) then
         write(*,*)'ERROR IN inputcrd_ib'
         return
      endif
!     timeint=tcpu()-tstar0
c     if (YourJob) write(kanalp,*) 'time after inputcrd_ib ', timeint

      if (stopx(index)) then
         write(*,*) 'Aborting in solv_ibems_DR'
         kprotfail=-999
         return
      endif
c..........................................................................
      ichargroup=0   ! n.e. 0 is prohibited here.
c                        can be applied only for total molecule
c                        because a partition into groups is peformed for 
c                        initial molecule   and is not applicable for parts 
c                                                      of the molecule
c.. optimal ionization state
      do ix=1,npolres_t
         xxinit(ix)=0
         xxfinal(ix)=1
      end do
c.
c        ionecentr=1   ! one center approach to calculate desolvation GGG000

      call en_ggg000(xxinit,xxfinal,ggg00)           

      if (kprotfail.le.-1) return
      call timit(index)
c       write(kanalp,*)'finish en_ggg000 '

!     timeint=tcpu()-tstar0
c     if (YourJob) write(kanalp,*) 'time after en_ggg000 ', timeint

      if (stopx(index)) then
         write(*,*) 'Aborting in solv_ibems_DR'
         kprotfail=-999
         return
      endif

      call en_ggg001(xxinit,xxfinal,ggg01,ggg02,ggg03)

      if(outdetl.ge.iiprint1)then
         call timit(index)
c         write(kanalp,*)'finish en_ggg001'
      end if

!     timeint=tcpu()-tstar0
c     if (YourJob) write(kanalp,*) 'time after en_ggg001 ', timeint
        if (stopx(index)) then
          write(*,*) 'Aborting in solv_ibems_DR'
          kprotfail=-999
          return
        endif
c. optimal ionization degrees for ONE given pH=pH in subparam. list
      if(ivarc.eq.1)then
         call optim_ionstate(pH,xxfinal,ggg00,optionz,fre_hbind)
         freehbind_en=fre_hbind
c         if(outdetl.ge.iiprint0)then
c           write(*,*)'Free energy of multiproton binding',fre_hbind
c           write(kanalp,*)'Free energy of multiproton binding',fre_hbind
c         end if
!        timeint=tcpu()-tstar0
c         write(kanalp,*) 'time after optim_ionstate(1)', timeint
      end if

c .. optimal ionization degrees for different pH for given pH grid
      if(ivarc.eq.0)then
         do iph=1,gph_mx
c            write(*,*)' PROTON BINDING  pH  =  ',pH
            pH=pH_v(iph)     
            call optim_ionstate(pH,xxfinal,ggg00,optionz,fre_hbind)
c.. fre_hbind  - free energy of equilibrium proton binding 

!           timeint=tcpu()-tstar0
c            write(kanalp,*) 'time after optim_ionstate(2)', timeint
       
            do ir=1,npolres_t
               xxfinal_v(iph,ir)=xxfinal(ir)
               optionz_v(iph,ir)=optionz(ir)
            end do !ir

c. energies of proton binding for pH grid 
            fre_hbind_v(iph)=fre_hbind
            if(outdetl.ge.iiprint0)then
               write(*,*)'Free energy of PROTON binding',
     &           fre_hbind
               write(*,*)'ionization degrees:pH=',pH
               write(*,'(10f7.4)')
     &           (optionz_v(iph,k),k=1,npolres_t)
            end if
         end do !iph
      end if ! ivarc
c..................................................................

       npolres_tei=npolres_t
       do ix=1,npolres_t
          opt_ionz(ix)=optionz(ix)
          opt_ionz_ei(ix)=optionz(ix)
          ionresgl_ei(ix)=ionresgl(ix)
       end do

c       call forces_at(force_c,force_s,force_h,force_t)
	                 
c       call timit(index)
c..........................................................................
       if (stopx(index)) then
          write(*,*) 'Aborting in solv_ibems_DR'
          kprotfail=-999
          return
       endif
       return 
       end
