!.. calculation of free energy of transport from vacuum to solvent 
!                                               for given molecule

        subroutine solv_trans(nsoord,soord,rad_ps,atmq_ps,
     &                      sol_freng,el_freng,hp_freng)         

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
	include'ecepp_ibems_intrf.h'
        include 'COMMON.MYCONF'
        include 'COMMON.TIME1'
        include 'COMMON.ODONNELL'
        include 'COMMON.SOLVAT'
!*
        real*8 soord(3,maxat),rad_ps(maxat),atmq_ps(maxat)
        integer nsoord,irg
        real*8 envc_cl,envc_sl,envc_frt
        real*8 enww_cl,enww_sl,enww_frt
        real*8 el_freng,hp_freng,sol_freng
        real*8 dotdenl
        real*8 gama_a,gama_b,en_frtot
         integer ivarc,nlev0,nlev1,nlev2,nnnggg
        real*8 sigmalev0(nsmalsemx_t),sigmalev1(nlargsemx_t)
        real*8 sigmalev2(maxat),epsout,epsin,epssol_s,epsmol_s

	real*8 rp,ssacces,cxyzlargsel(3,nlargsemx_t),
     &     vnlargsel(3,nlargsemx_t),arealargsel(nlargsemx_t)
        integer nlargsel,ia,k,i,index,iiprint1
        integer ii,iii,is,ip,iiprint0,iiprintm
        integer dot_IATNUMS(nsmalsemx_t),dot_ISHAPES(nsmalsemx_t)
        integer dot_IATNUML(nlargsemx_t),dot_ISHAPEL(nlargsemx_t)
        integer ig,nn, izero
        logical stopx

        izero=0
        tstar0 =tcpu()
!       if (YourJob)  write(kanalp,*) 'ON solv_trans TIME =',tstar0
        iiprint1=1
        iiprint0=0
        iiprintm=-1
!.........................................................................
        call precal01(nsoord,soord,rad_ps,atmq_ps)


!.. compute high density boundary elements	
        nat=nsoord
	rp=rp_rpr
        if(outdetl.ge.iiprint1)then
           index=1
	   call timit(index)
!           write(kanalp,*)'calling MSEED from solv_ibems'
        end if

        if (use_mseed) then
           call mseed(soord,rad_ps,2.0d0*rp,nat,dotden_h,cxyzsmalse_t,
     &       vnsmalse_t,areasmalse_t,nsmalse_t)
!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 'time after mseed (1) ', timeint
        else
!          call surf_connolly(soord,rad_ps,2.0d0*rp,nat,dotden_h,
!    &        cxyzsmalse_t,vnsmalse_t,areasmalse_t,nsmalse_t)
           ikount=ikount+1
           call surf_sims(soord, rad_ps,nat,2.0d0*rp,dotden_h,
     &       cxyzsmalse_t,vnsmalse_t,areasmalse_t,
     &       dot_IATNUMS,dot_ISHAPES, nsmalse_t)

!           timeint=tcpu()-tstar0
!           if (YourJob) write(kanalp,*)
!     &            'time after surf_sims (2) ', timeint

        endif
        if (nsmalse_t .gt. nsmalsemx_t) then
           write (*,*) '1.-too many surface elements',
     &      'Increase nsmalsemx_t'
           stop 6061
        endif
!          write(*,*)'nsmalse_t', nsmalse_t
!          write(*,*)'areasmalse_t'
!          write(*,*)(areasmalse_t(i),i=1,10)

        if (kprotfail.le.-1) return

        if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
          kprotfail=-999
          return
        endif


!.......................................................................
!.. compute low  density boundary elements	

        if(outdetl.ge.iiprint1)then
           index=1
	   call timit(index)
!          write(kanalp,*)'calling MSEED from solv_ibems'
        end if

        rp=rp_rpr
        if (use_mseed) then
           call mseed(soord,rad_ps,2.0d0*rp,nat,dotden_l,cxyzlargse_t,
     &             vnlargse_t,arealargse_t,nlargse_t)
!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 'time after mseed (2) ', timeint
        else
!           call surf_connolly(soord,rad_ps,2.0d0*rp,nat,dotden_l,
!    &       cxyzlargse_t,vnlargse_t,arealargse_t,nlargse_t)
           ikount=ikount+1
           call surf_sims(soord,rad_ps,nat,2.0d0*rp,dotden_l,
     &         cxyzlargse_t,vnlargse_t,arealargse_t,
     &         dot_IATNUML,dot_ISHAPEL, nlargse_t)
!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 
!     &              'time after surf_sims (2) ', timeint
        endif

        if (nlargse_t .gt. nlargsemx_t) then
           write (*,*) '2.-too many surface elements.',
     &      'Increase nlargsemx_t'
           stop 6062
        endif

!          write(*,*)'solv_trans: nlargse_t', nlargse_t
!          write(*,*)'arealargse_t'
!          write(*,*)(arealargse_t(i),i=1,10)

        if (kprotfail.le.-1) return

        if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
          kprotfail=-999
          return
        endif

        if(outdetl.ge.iiprint1)then
           index=1
	   call timit(index)
!          write(kanalp,*)' finish MSEED low density Surface '
        end if
!.......................................................................

        call connect_ha(nsoord,soord,rad_ps)

        if (kprotfail.le.-1) return
        if(outdetl.ge.iiprint1)then
           index=1
   	   call timit(index)
!          write(kanalp,*)'connect_ha: finish'
        end if

        call connect_la(nsoord,soord,rad_ps)

        if (kprotfail.le.-1) return
        if(outdetl.gt.1)then
           index=1
	   call timit(index)
!          write(kanalp,*)'connect_la: finish'
        end if


        call connect_lh
        if (kprotfail.le.-1) return
        if(outdetl.ge.iiprint1)then
           index=1
	   call timit(index)
!          write(kanalpl,*)'connect_lh: finish'
        end if

c.Apr4: Safe surface SP0 for neutral molecule
	nsmalse_tn=nsmalse_t
     	sstot_sn=sstot_s
	do is=1,nsmalse_t
	   areasmalse_tn(is)=areasmalse_t(is)
   	   do k=1,3
	      cxyzsmalse_tn(k,is)=cxyzsmalse_t(k,is)
	   end do
	end do

	nlargse_tn=nlargse_t
	sstot_ln=sstot_l
	do is=1,nlargse_t
	   arealargse_tn(is)=arealargse_t(is)
	   do k=1,3
                 cxyzlargse_tn(k,is)= cxyzlargse_t(k,is)
           end do 
        end do

        nsurfp_tN= nsurfp_t
	sstot_pN=sstot_p
	do is=1, nsurfp_tN

	   nsurfp_sm0(is)=nsurfp_sm(is)
	   nsurfp_lg0(is)=nsurfp_lg(is)
	   surfp_sN(is)=surfp_s(is)

	   do k=1,3
	      surfp_xyzN(k,is)=surfp_xyz(k,is)
	   end do

	   if(nsurfp_sm(is).gt.0)then
	      do k=1,nsurfp_sm(is)
	         lsurfp_ism0(k,is)=lsurfp_ism(k,is)
	      end do!k
	   end if

	   if(nsurfp_lg(is).gt.0)then
	      do k=1,nsurfp_lg(is)
	         lsurfp_ilg0(k,is)=lsurfp_ilg(k,is)
	      end do!k
	   end if

        end do!is
! Apr4 END

        if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
          kprotfail=-999
          return
        endif

!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 'time after connect_lh ', timeint
!   KKK_sp matrix       
        call sp_KKK

        if (kprotfail.le.-1) return

         if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
          kprotfail=-999
          return
        endif

        timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 'time after sp_KKK ', timeint

        if(outdetl.ge.iiprint1)then
           index=1
	   call timit(index)
!          write(kanalp,*)'sp_KKK finish '
        end if

!-----------------------------------------------------------------
!. hydrophobic solvation energy 
        hp_freng= 0.d0 
        gama_a=0.005d0   ! kcal/ang*2
        gama_b=0.86d0    ! J.Phys.Ch.(1994)V.98,p.1978-1988;B.Honig

        nat=nsoord

        dotdenl=dotden_l*2.0d0

        ssacces=0.d0
        if (use_mseed) then
!. With mseed we use a calculation of the solvent accessible surface area
!. rad_ps are extended by water radius rp_rpr
           do i=1,nat
              rad_ps(i)=rad_ps(i)+rp_rpr
           end do
           call mseed(soord,rad_ps,2.0d0*rp,nat,dotden_l,cxyzlargsel,
     &       vnlargsel,arealargsel,nlargsel)

           if (kprotfail.le.-1) return
           do i=1,nlargsel
              ssacces=ssacces+arealargsel(i)
           end do
        else
!. With SIMS we use the molecular surface area instead of the accessible surface area
! DR MAR/1997
           do i=1,nsmalse_t
              ssacces=ssacces+areasmalse_t(i)
           end do
        endif
        if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
          kprotfail=-999
          return
        endif

!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 'time after mseed (3) ', timeint


        hp_freng= ssacces*gama_a+gama_b

        if(outdetl.ge.iiprint1)then
           write(*,*)'Solvent accessible surface(A**2)=',ssacces
           write(*,*)'Cavity creation free en=',hp_freng
        end if

        do i=1,nat
           rad_ps(i)=rad_ps(i)-rp_rpr
        end do
!..................................................................
! electrostatic solvation energy

! define list of charged atoms and their geom centr
        n_iona=0
        do k=1,3
           xyzonecent(k)=0.0d0
        end do
!       write(*,*) 'solv_trans'
        do ia=1,nsoord
           if(atmq_ps(ia).ne.0.0d0)then
              n_iona=n_iona+1
              iona_list(n_iona)=ia
!             write(*,*) 'iona_list(',n_iona ,')=',iona_list(n_iona)
              do k=1,3
                 xyzonecent(k)=xyzonecent(k)+soord(k,ia)
              end do
           end if !
        end do ! ia

        if(n_iona.ge.1)then
           do k=1,3
              xyzonecent(k)=xyzonecent(k)/float(n_iona)
           end do
        end if
        if(outdetl.gt.iiprint1)then
           write(*,*)'solv_trans:xyzonecent=',xyzonecent 
        end if
!.
! solvation energy
!
         
        if(outdetl.ge.iiprint1)then
           index=1
	   call timit(index)
	   write(*,*)'Start : IBEMS induced charge density'
        end if


        if(icharatom.eq.1)nnnggg=n_iona
        if(ichargroup.ge.1)nnnggg=nchargr_t
        if(ionecentr.eq.1)nnnggg=1

!.inizialization
        epssol_s=epssol
        epsmol_s=epsmol
!       write(*,*)'solv_trans: epssol, epsmol ',epssol, epsmol

        do is=1,nsmalsemx_t
           sigmasmt_t(is)=0.d0  
        end do
        do ip=1,maxat
           surfp_q(ip)=0.d0
        end do

        nlev0=nsmalse_t
        nlev1=nlargse_t
        nlev2=nsurfp_t

        do is=1,nlev0
           sigmasmtvc_t(is)=0.d0
           sigmasmtww_t(is)=0.d0
	   sigmasmt_tb(is)=0.d0
	   do ig=1,nres_inzbl
	      sigmasmt_tn(is,ig)=0.d0
	   end do!ig
        end do!is

        do is=1,nlev1
           sigmalgtvc_t(is)=0.d0
           sigmalgtww_t(is)=0.d0
	   sigmalgt_tb(is)=0.d0
	   do ig=1,nres_inzbl
	      sigmalgt_tn(is,ig)=0.d0
	   end do!ig
        end do!is

        do is=1,nlev2
           surfpvc_q(is)=0.d0
           surfpww_q(is)=0.d0
	   surfp_qb(is)=0.d0
	   do ig=1,nres_inzbl
	      surfp_qn(is,ig)=0.d0
	   end do!ig
        end do!is
!       write(*,*)'solv_trans:nnnggg ', nnnggg
!.............................................................
!.polarization density
        do ii=1,nnnggg

           if(outdetl.ge.iiprint1)then
             write(kanalp,*)'solv_trans:start charged atom/group ii=',ii
           end if

           iii=ii

           call surf_loc01(iii,soord)
!          timeint=tcpu()-tstar0
!           if (YourJob) write(kanalp,*) 'time after surf_loc01 ', timeint

           if (kprotfail.le.-1) return

            if (stopx(izero)) then
           write(*,*) 'TIME is running out, aborting in solv_transSIMS'
              kprotfail=-999
              return
            endif

           call surf_loc02(iii,soord)
!          timeint=tcpu()-tstar0
!            if (YourJob) write(kanalp,*) 'time after surf_loc02 ', timeint

           if (kprotfail.le.-1) return

           if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
             kprotfail=-999
             return
           endif

           if(outdetl.ge.iiprint1)then
              call timit(index)
!               write(kanalp,*)'surf_loc : finish'
           end if

           call sigma0_loc(iii,soord,rad_ps,atmq_ps)
!          timeint=tcpu()-tstar0
!            if (YourJob) write(kanalp,*) 'time after sigma0_loc ', timeint

           if (kprotfail.le.-1) return

           if(outdetl.ge.iiprint1)then
              call timit(index)
!               write(kanalp,*)'sigma0_loc : finish'
           end if

!. two calls : 1) v-->mol 2)mol-->solvent

           ivarc=1

           do is=1,nlev0
              sigmalev0(is)=sigmasmtvc_t(is)
           end do
           do is=1,nlev1
              sigmalev1(is)=sigmalgtvc_t(is)
           end do
           do is=1,nlev2
              sigmalev2(is)=surfpvc_q(is)
           end do

           epsout=1.0d0
           epsin=epsmol
!  polarization in vacuum
!          write(*,*)'solv_trans 1 : call sigma_loc'
!          write(*,*)'ivarc,nlev0,nlev1,nlev2',ivarc,nlev0,nlev1,nlev2

	   call sigma_loc(iii,soord,rad_ps,atmq_ps,
     &       ivarc,nlev0,sigmalev0,nlev1,sigmalev1,nlev2,sigmalev2,
     &       epsin,epsout)
         
           if (kprotfail.le.-1) return
         
           do is=1,nlev0
              sigmasmtvc_t(is)=sigmalev0(is)
           end do
           do is=1,nlev1
              sigmalgtvc_t(is)=sigmalev1(is)
           end do
           do is=1,nlev2
              surfpvc_q(is)=sigmalev2(is)
           end do
           if(outdetl.ge.iiprint1)then
              index=1
	      call timit(index)
!               write(kanalp,*)'Polariz in vacuum finish'
           end if
!..
!.. polarization in WATER
           do is=1,nlev0
              sigmalev0(is)=sigmasmtww_t(is)
           end do
           do is=1,nlev1
              sigmalev1(is)=sigmalgtww_t(is)
           end do
           do is=1,nlev2
              sigmalev2(is)=surfpww_q(is)
           end do

           epsout=epssol_s
           epsin=epsmol_s

!          write(*,*)'solv_trans 2 : call sigma_loc'
!          write(*,*)'ivarc,nlev0,nlev1,nlev2',ivarc,nlev0,nlev1,nlev2

	   call sigma_loc(iii,soord,rad_ps,atmq_ps,
     &       ivarc,nlev0,sigmalev0,nlev1,sigmalev1,nlev2,sigmalev2,
     &       epsin,epsout)

           if (kprotfail.le.-1) return

!          timeint=tcpu()-tstar0
!             if (YourJob) write(kanalp,*) 'time after sigma_loc ', timeint

           if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
             kprotfail=-999
             return
           endif

! Apr4: assign sigma for PSi0 and PSback0 groups
 	   if(jchargr_kn(iii).eq.0)then
	      do is=1,nlev0
	         sigmasmt_tb(is)= sigmasmt_tb(is)+
     &	            (sigmalev0(is)-sigmasmtww_t(is))
	      end do
	      do is=1,nlev1
	         sigmalgt_tb(is)= sigmalgt_tb(is)+
     &              (sigmalev1(is)-sigmalgtww_t(is))
	      end do
	      do is=1,nlev2
	         surfp_qb(is)= surfp_qb(is)+sigmalev2(is)-surfpww_q(is)
              end do
           end if ! back

  	   if(jchargr_kn(iii).gt.0)then
              nn=jchargr_kn(iii)
	      do is=1,nlev0
	         sigmasmt_tn(is,nn)= sigmalev0(is)-sigmasmtww_t(is)
	      end do
	      do is=1,nlev1
	         sigmalgt_tn(is,nn)= sigmalev1(is)-sigmalgtww_t(is)
	      end do
	      do is=1,nlev2
	         surfp_qn(is,nn)= sigmalev2(is)-surfpww_q(is)
              end do
           end if ! PSi0

! Assign total sigma
           do is=1,nlev0
              sigmasmtww_t(is)=sigmalev0(is)
           end do
           do is=1,nlev1
              sigmalgtww_t(is)=sigmalev1(is)
           end do
           do is=1,nlev2
              surfpww_q(is)=sigmalev2(is)
           end do
           if(outdetl.ge.iiprint1)then
              index=1
              call timit(index)
!             write(kanalp,*)'polarization in water finish'
           end if
           if(outdetl.ge.iiprint1)then
!             write(kanalp,*)'sigma_ibem:finish charged atom/group ii='
!    &             ,ii
           end if
! --------------------------------------------------------------       
        end do ! ii
!.......................................................
!...sigma end
!
        if(outdetl.ge.iiprint1)then
           index=1
           call timit(index)
	   write(*,*)'FINISH: IBEMS charge density'
        end if
!.
!. polarization energy in vacuum
        ivarc=1
        do is=1,nlev0
           sigmalev0(is)=sigmasmtvc_t(is)
        end do
        do is=1,nlev1
           sigmalev1(is)=sigmalgtvc_t(is)
        end do
        do is=1,nlev2
           sigmalev2(is)=surfpvc_q(is)
        end do
        epsout=1.0d0
        epsin=epsmol_s
	call ssolv_en(nsoord,soord,atmq_ps,envc_cl,envc_sl,envc_frt,       
     &    ivarc,nlev0,sigmalev0,nlev1,sigmalev1,nlev2,sigmalev2,
     &    epsout,epsin)

!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 'time after ssolv_en ', timeint

        if (kprotfail.le.-1) return
         
        if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
          kprotfail=-999
          return
        endif

!.. polarization in water
        do is=1,nlev0
           sigmalev0(is)=sigmasmtww_t(is)
        end do
        do is=1,nlev1
           sigmalev1(is)=sigmalgtww_t(is)
        end do
        do is=1,nlev2
           sigmalev2(is)=surfpww_q(is)
        end do
        epsout=epssol_s
        epsin=epsmol_s
	call ssolv_en(nsoord,soord,atmq_ps,enww_cl,enww_sl,enww_frt,       
     &    ivarc,nlev0,sigmalev0,nlev1,sigmalev1,nlev2,sigmalev2,
     &    epsout,epsin)
        
        if (kprotfail.le.-1) return
        
        if (stopx(izero)) then
          write(*,*) 'TIME is runnning out, aborting in solv_transSIMS'
          kprotfail=-999
          return
        endif

!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 'time after ssolv_en (2) ', timeint

        if(outdetl.ge.iiprint1)then
           index=1
           call timit(index)
           write(kanalp,*)' Finish solvation energy'
        end if
!..
        sol_freng=enww_sl - envc_sl
        el_freng=envc_cl+sol_freng
        en_frtot=el_freng+hp_freng
 
        electcl_en=envc_cl 
        solvate_en=sol_freng
        cavity_en=hp_freng
        freetot_en=sol_freng+hp_freng

        if(outdetl.ge.iiprint0)then
        write(*,*)'RESULT :'
        write(*,*)'surf_mol:            =',sstot_sm
        write(*,*)'surf_accessible      =',ssacces
        write(*,*)'solv_ibems: en_coul  =',envc_cl
        write(*,*)'polariz en in vacuum =',envc_sl
        write(*,*)'polariz en in solvent=',enww_sl
        write(*,*)'solv_en(rect. field) =',sol_freng 
        write(*,*)'elect_freng_tot      =',en_frtot
        write(*,*)'cavity creat energy  =',hp_freng
        write(*,*)'total free en(cl+sl+cv) = ',en_frtot
        end if
!       if(outdetl.ge.iiprintm)then
!          write(kanalp,*)'RESULT :'
!          write(kanalp,*)'surf_mol:            =',sstot_sm
!          write(kanalp,*)'surf_accessible      =',ssacces
!          write(kanalp,*)'solv_ibems: en_coul  =',envc_cl
!          write(kanalp,*)'polariz en in vacuum =',envc_sl
!          write(kanalp,*)'polariz en in solvent=',enww_sl
!          write(kanalp,*)'solv_en(rect. field) =',sol_freng 
!          write(kanalp,*)'elect_freng_tot      =',en_frtot
!          write(kanalp,*)'cavity creat energy  =',hp_freng
!          write(kanalp,*)'total free en(cl+sl+cv) = ',en_frtot
!       end if
!     
!...............................................................
!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*) 'TIME on solv_trans ', timeint
       
        return
        end
