c.. double precision

	subroutine ssolv_en(nsoord,soord,atmq_ps,en_cl,en_sl,en_frt,       
     &  ivarc,nlev0,sigmalev0,nlev1,sigmalev1,nlev2,sigmalev2,
     &  epsout,epsin)
c  calculation of solvation energy 
c  nsoord, soord(k,na) atom coordinates atmq_ps()-charges
c  ivarc - option 0/1- =1 if sigma ,epssol/mol are taken from parameter list
c                      =0    sigma,epssol/mol are taken from COMMON 
c  use sigma: sigmasmt_t(),sigmalgt_t(),surfp_q()
c  en_cl,en_sl - direct Coulombic and solvation; en_frt - total


#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'
        real*8 soord(3,maxat),atmq_ps(maxat)
        real*8 en_cl,en_sl,en_frt
        integer nsoord
        integer ivarc,nlev0,nlev1,nlev2
        real*8 sigmalev0(nsmalsemx_t),sigmalev1(nlargsemx_t)
        real*8 sigmalev2(maxat),epsout,epsin
c*	
        real*8 gconst1,elect_d,elect_l,qinl,qind,ss,rrlock2
        real*8 sd,sd1,sd2,sn,snl,snd,ffg,qqtot,qat,senl,send
        real*8 xyz(3),ssm,ssl,ssp,qsm,qsl,qsp,sm,sl,sq,qs,ql,pd2
        real*8 gggsol_en,sent
        integer jj,jatom,iatom,k,ns,index,nsg,ip,nsmal,il,is
        integer ii,iii,ilg,isg,nlarg,iiprint1,iiprint0

        iiprint1=1
        iiprint0=0
c
c  ASSIGN
        if(ivarc.eq.1)then
        epsmol=epsin 
        epssol=epsout
 
        do is=1,nlev0
        sigmasmt_t(is)=sigmalev0(is)
        end do
        do is=1,nlev1
        sigmalgt_t(is)=sigmalev1(is)
         end do
        do is=1,nlev2
        surfp_q(is)=sigmalev2(is)
        end do
        nsmalse_t=nlev0
        nlargse_t=nlev1
        nsurfp_t= nlev2

c        write(*,*)'ssolv_en:nlev0,nlev1,nlev2=',nlev0,nlev1,nlev2
        end if !ivarc=1


c..................................................

        ffg=1.0/epsmol -1.0/epssol
        qqtot=0.d0

c radius of calculation by smal se
        rrlock2=rrlock_en*rrlock_en

c.............................................
c. check induced sigma
        qsm=0.d0
        qsp=0.d0
        qsl=0.d0
        ssm=0.d0
        ssp=0.d0
        ssl=0.d0


        do is=1,nsmalse_t
        ssm=ssm+areasmalse_t(is)
        qsm=qsm+sigmasmt_t(is)*areasmalse_t(is)
        end do !is
c       write(*,*)'total ind qqq(smalse)=',qsm,'tot surf=',ssm
        
        do il=1,nlargse_t
        ssl=ssl+arealargse_t(il)
        qsl=qsl+sigmalgt_t(il)*arealargse_t(il)
        end do !il
c        write(*,*)'total ind qqq(large )=',qsl,'tot surf=',ssl
        qsm=0.d0
        qsp=0.d0
        qsl=0.d0
        ssm=0.d0
        ssp=0.d0
        ssl=0.d0
        do ip=1,nsurfp_t

        sm=0.d0
        qs=0.d0
        nsmal=nsurfp_sm(ip)

        do is=1,nsmal
        isg=lsurfp_ism(is,ip)
        sm=sm+areasmalse_t(isg)
        qs=qs+areasmalse_t(isg)*sigmasmt_t(isg)
        end do !is

        qsm=qsm+qs
        ssm=ssm+sm
        qs=qs/sm
        if(dabs(sm-surfp_s(ip)).gt.0.1d-9)then
        write(*,*)'ssolv_en: ERROR0 surf sm ne. sp ip=',ip,
     &  'sm=',sm,'sp=',surfp_s(ip)
        end if
        if(dabs(qs-surfp_q(ip)).gt.0.1d-9)then
        write(*,*)'ssolv_en: ERROR01 sig sm, sig sp=',
     &  qs,surfp_q(ip), 'ip=',ip
        end if

        sl=0.d0
        ql=0.d0
        nlarg=nsurfp_lg(ip)
        do il=1,nlarg     
        ilg=lsurfp_ilg(il,ip)  
        sl=sl+arealargse_t(ilg)
        ql=ql+arealargse_t(ilg)*sigmalgt_t(ilg)
        end do !il
        qsl=qsl+ql
        ssl=ssl+sl
        ql=ql/sl

        if(dabs(sl-surfp_s(ip)).gt.0.1d-10)then
        write(*,*)'ssolv_en: ERROR03 surf lg ne. sp ip=',ip,
     &  'sl=',sl,'sp=',surfp_s(ip)
        end if

        if(dabs(ql-surfp_q(ip)).gt.0.1d-9)then
        write(*,*)'ssolv_en: ERROR04 sig lg, sig sp=',
     &  ql,surfp_q(ip), 'ip=',ip
        end if

        qsp=qsp+surfp_s(ip)*surfp_q(ip)
        ssp=ssp+surfp_s(ip)
         end do !ip
        
        if(outdetl.ge.iiprint1)then
        write(*,*)'ssolv_en: input control'
        write(*,*)'total expected ind charge=',-qmlcur*ffg
        write(*,*)'total ind qqq(smalse)=',qsm,'tot surf=',ssm
        write(*,*)'total ind qqq(largse)=',qsl,'tot surf=',ssl
        write(*,*)'total ind qqq(spiece)=',qsp,'tot surf=',ssp
        end if  !outdetl
c...................................................................
       
        
        solvate_en=0.d0
        electcl_en=0.d0
        do 200  ii=1,n_iona
c  atom number iatom
        iii=ii
        iatom=iona_list(iii)
        if(converge(iii).eq.'NO CONVERGENCE')then
        write(*,*)'charge iii=',iii,converge(iii)
        kprotfail=-160
        return
c       stop
        end if

        senl=0.d0
        send=0.d0
        qinl=0.d0
        qind=0.d0

        do k=1,3
        xyz(k)=soord(k,iatom)
         end do
c..................................................................
c..direct coulombic energy
         do 300 jj=ii+1,n_iona
         jatom=iona_list(jj)
         sd2=0.d0
         do k=1,3
         sd2=sd2+(soord(k,jatom)-xyz(k))**2
         end do! k
         sd1=dsqrt(sd2)
300      electcl_en=electcl_en+atmq_ps(iatom)*atmq_ps(jatom)/sd1
c.................................................................
c.search for surface piece number

        do 400 ip=1,nsurfp_t

        pd2=0.d0
        do k=1,3
         pd2=pd2+(xyz(k)-surfp_xyz(k,ip))**2
         end do
c.......................................................
         if(pd2.le.rrlock2)then
c. piece ip included in local surface  which  is considered as collection
c. of small se
c.         write(*,*)'ssolv_en: loc surf'

         nsmal=nsurfp_sm(ip)
         ss=0.d0
         do ns=1,nsmal
c.nsg global number of small s.e.
         nsg=lsurfp_ism(ns,ip)
         sd2=0.d0
         do k=1,3
         sd2=sd2+(xyz(k)-cxyzsmalse_t(k,nsg))**2
         end do
         sd1=dsqrt(sd2)
         ss=ss+areasmalse_t(nsg)
         qs=sigmasmt_t(nsg)*areasmalse_t(nsg)
         qinl=qinl+qs
         senl=senl+qs/sd1
         end do! ns

         if(dabs(ss-surfp_s(ip)).gt.0.1d-9)then
         write(*,*)'ssolv_en:ERROR1 in surf area'
         end if

c       write(*,*)'slv_en:ip,nsmal',ip,nsmal,'ssp',ss,'qinl',qinl       
         end if !loc
c...........................................................
         if(pd2.gt.rrlock2)then
c. distant surface
c.         npiece_dist=npiece_dist+1
         ss=0.d0
         nlarg=nsurfp_lg(ip)

         do ns=1,nlarg
c.nsg global number of large s.e.
         nsg=lsurfp_ilg(ns,ip)
         sd2=0.d0
         do k=1,3
         sd2=sd2+(xyz(k)-cxyzlargse_t(k,nsg))**2
         end do
         sd1=dsqrt(sd2)
c         qs=surfp_q(ip)*arealargse_t(nsg)
         qs=sigmalgt_t(nsg)*arealargse_t(nsg)
         ss=ss+arealargse_t(nsg)
c.. induced sigma on lg se taken = of that on surfpiece
         qind=qind+qs
         send=send+qs/sd1
         end do! ns

         if(dabs(ss-surfp_s(ip)).gt.0.1d-9)then
         write(*,*)'ssolv_en:ERROR2 in surf area'
         end if

         end if ! dist
c...................................................................
400      continue
c...................................................................
         
c        normalization
         qat=atmq_ps(iatom)
         qqtot=qinl+qind

         if(outdetl.gt.iiprint1)then
         write(*,*)'ssolv_en atom iii=',iatom,'induced qq=',qqtot
         write(*,*)' qind(loc)=',qinl,  ' qind(dis)=',qind
         end if

         senl=0.5*senl*coefel*qat
         send=0.5*send*coefel*qat
         sent=senl+send
         solvate_en=solvate_en + sent

c         write(*,*)'ssolv_en atom iii=',iatom,'solv_en(ii)',sent,
c     &   '/','solven(loc)',senl, 'solven(dis)=',send
c...........................................................
200      continue    ! next iii
c............................................................
c
        if(outdetl.gt.1)then
        index=1
        call timit(index)
         end if
c. final energies....................................................
         electcl_en=electcl_en*coefel/epsmol
         gggsol_en=solvate_en+electcl_en

         en_cl=electcl_en
         en_sl=solvate_en
         en_frt=gggsol_en


         if(outdetl.ge.iiprint1)then
         write(*,*)'ssolv_en: final energies(kcal.mol):'
         write(*,*)'elecoul_en=',electcl_en
         write(*,*)' solvation_en=',solvate_en
         write(*,*)'tot free_en=', gggsol_en
         end if
c......................................................................
         
         return 
         end
