      SUBROUTINE VIBENTR(NPRINT,VIBCOM,FAIL)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.SETUP' 
      include 'COMMON.CALC'
      include 'COMMON.GEN100'
      include 'COMMON.GEN002X'
      include 'COMMON.NNDRUK'
      include 'COMMON.TORQUEX'
      include 'COMMON.BONDSX'
      include 'COMMON.ATOMSS'
      include 'COMMON.TOR2'
      include 'COMMON.IOUNIT'
      include 'COMMON.GRAD2'
      INTEGER ITK
      double precision e0,gi
      real minval
      COMMON /DIGMAT/ H(600,600),C(600,600),TEMP(600),AINT(600)               
      DATA MAXJAC /100000/, E /1.0D-7/, AINC /0.001D0/, AINC2 /0.002D0/
      DOUBLE PRECISION H,C,TEMP,AINT,E,AINC,AINC2,CNORM
      real g(maxnum_var)
      real urparm
      integer iuparm
      external gradcax
      LOGICAL FAIL
c      print *,'in THERMO'
C                                                                       
C SETS UP THE SECOND DERIVATIVE MATRIX. ITS ELEMENTS ARE APPROXIMATED   
C BY SYMMETRIZED DIVIDED DIFFERENCES. THE OFF-DIAGONAL ELEMENTS ARE     
C AVERAGED SO AS TO MAKE THIS MATRIX SYMMETRIC.                         
C                                                                       
C NN IS THE DIMENSION OF THE MATRIX H.                                
C                                                                       
      NN=NUMVAR                                                    
      IF (NN.LE.1) FAIL=.TRUE.
      IF (NN.LE.1) RETURN
c      write (6,'(i5,f10.5)') (i,x(i),i=1,numvar)
c      print *,'Constructing energy Hessian'
      DO 1 I=1,NN                                                        
c      print *,'i',i
      XI=X(I)                                                        
      X(I)=XI+AINC                                                    
      icx=1 

      nf=1
      call calcfpo( numvar, x, nf, f, id, urparm, ufparm )
      e0=f
c      write (*,*) 'e0=',e0,' etot=',f
c      write (jout,*) 'e0=',e0,' etot=',f

C ICX to indicate that indexes for the loops on gradca should be calculated.
C                                                  DR  AUG-22-94
      call calcgpo(numvar,x,nf,g,id,urparm,gradcax)

      do k=1,nn
        temp(k)=g(k)
      enddo
      X(I)=XI                                                        
      XI=X(I)                                                        
      X(I)=XI-AINC                                                   

      nf=1
      call calcfpo( numvar, x, nf, f, id, urparm, ufparm )
      e0=f
c      write (*,*) 'e0=',e0,' etot=',f
c      write (jout,*) 'e0=',e0,' etot=',f

C ICX to indicate that indexes for the loops on gradca should be calculated.
C                                                  DR  AUG-22-94
      call calcgpo(numvar,x,nf,g,id,urparm,gradcax)
      X(I)=XI                                                        
      DO 4 K=1,NN
c      write (6,'(2i5,2f20.10)') i,k,temp(k),g(k)
    4 H(I,K)=(TEMP(K)-G(K))/AINC2    
    1 CONTINUE
      IF (NPRINT.GT.3) THEN                                                          
      WRITE (JOUT,1000)                                                 
 1000 FORMAT (//11X,'SECOND DERIVATIVE MATRIX')                         
      CALL PIS(600,1,NN,1,NN,6)
      ENDIF                                
      NN1=NN-1                                                      
C                                                                       
C NOW THE H MATRIX IS BEING SYMMETRIZED                                 
C                                                                       
      DO 5 I=1,NN1                                                    
      I1=I+1                                                            
      DO 5 J=I1,NN                                                    
      H(I,J)=0.5*(H(I,J)+H(J,I))                                        
    5 H(J,I)=H(I,J)  
      IF (NPRINT.GE.3) THEN                                                   
      WRITE (JOUT,1001)                                                 
 1001 FORMAT(//11X,'SYMMETRIZED SECOND DERIVATIVE MATRIX')              
      CALL PIS(600,1,NN,1,NN,6)
      ENDIF                                
C                                                                       
C DIAGONALIZES THE MASS-SCALED H MATRIX IN ORDER TO DETERMINE           
C NORMAL MODES.                                                         
C                                                                       
c      print *,'Diagonalizing'
      CALL JACOBI(NN,600,MAXJAC,E)                        
c      print *,'End diagonalizing'
      DO 12 I=1,NN
      CNORM=DABS(C(1,I))
      DO 13 J=2,NN
      IF (CNORM.LT.ABS(C(J,I))) CNORM=DABS(C(J,I))
   13 CONTINUE
      IF (CNORM.GT.0.0) CNORM=1.0/CNORM                             
      DO 14 J=1,NN                                                    
   14 H(J,I)=C(J,I)*CNORM                                               
   12 CONTINUE
      IF (NPRINT.GT.0) THEN    
      WRITE (JOUT,1003)                                                 
 1003 FORMAT (//11X,'EIGENVECTORS AND EIGENVALUES OF THE HESSIAN')        
      CALL EIGOUT(NN,NN,600,NN)
!     ELSE
!     WRITE (JOUT,1004) (I,TEMP(I),I=1,NN)
!1004 FORMAT (/'EIGENVALUES OF THE HESSIAN:',150(/I5,1PE15.4))
      ENDIF                         
*
* Calculate thermo
*
      IF (TEMP(1).LE.0.0) THEN
        WRITE (JOUT,*) '!!! ENERGY HESSIAN IS NOT POSITIVE DEFINITE'
        FAIL=.TRUE.
        RETURN
      ENDIF
      VIBCOM=0.5*NN*DLOG(PI*RBOLTZ*298.0)
      DO I=1,NN
        VIBCOM=VIBCOM-0.5*DLOG(TEMP(I))
      ENDDO
      VIBCOM=0.3005*VIBCOM
!     WRITE (JOUT,*) 'ENTROPY CONTRIBUTION TO THE FREE ENERGY:',VIBCOM 
      RETURN                                                            
      END
*******************************************************************************
      SUBROUTINE JACOBI(N,NMAX,MAXJAC,E)                        
      IMPLICIT REAL*8 (A-H,O-Z)
C     THE JACOBI DIAGONALIZATION PROCEDURE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.IOUNIT'
      COMMON /DIGMAT/ A(600,600),C(600,600),AII(600),AJJ(600)               
      SIN45 = .70710678                                                 
      COS45 = .70710678                                                 
      S45SQ = 0.50                                                      
      C45SQ = 0.50                                                      
C     UNIT EIGENVECTOR MATRIX                                           
      DO 70 I = 1,N                                                     
      DO 7 J = I,N                                                      
      A(J,I)=A(I,J)                                                     
      C(I,J) = 0.0                                                      
    7 C(J,I) = 0.0                                                      
   70  C(I,I) = 1.0                                                     
C     DETERMINATION OF SEARCH ARGUMENT, TEST                            
      AMAX = 0.0                                                        
      DO 1 I = 1,N                                                      
      DO 1 J = 1,I                                                      
      TEMPA=DABS(A(I,J))                                                 
      IF (AMAX-TEMPA) 2,1,1                                             
    2 AMAX = TEMPA                                                      
    1 CONTINUE                                                          
      TEST = AMAX*E                                                     
C     SEARCH FOR LARGEST OFF DIAGONAL ELEMENT                           
      DO 72 IJAC=1,MAXJAC                                               
      AIJMAX = 0.0                                                      
      DO 3 I = 2,N                                                      
      LIM = I-1                                                         
      DO 3 J = 1,LIM                                                    
      TAIJ=DABS(A(I,J))                                                  
       IF (AIJMAX-TAIJ) 4,3,3                                           
    4 AIJMAX = TAIJ                                                     
      IPIV = I                                                          
      JPIV = J                                                          
    3 CONTINUE                                                          
      IF(AIJMAX-TEST)300,300,5                                          
C     PARAMETERS FOR ROTATION                                           
    5 TAII = A(IPIV,IPIV)                                               
      TAJJ = A(JPIV,JPIV)                                               
      TAIJ = A(IPIV,JPIV)                                               
      TMT = TAII-TAJJ                                                   
      IF(DABS(TMT/TAIJ)-1.0D-12) 60,60,6                                 
   60 IF(TAIJ) 10,10,11                                                 
    6 ZAMMA=TAIJ/(2.0*TMT)                                              
   90 IF(DABS(ZAMMA)-0.38268)8,8,9                                       
    9 IF(ZAMMA)10,10,11                                                 
   10 SINT = -SIN45                                                     
      GO TO 12                                                          
   11 SINT = SIN45                                                      
   12 COST = COS45                                                      
      SINSQ = S45SQ                                                     
      COSSQ = C45SQ                                                     
      GO TO 120                                                         
    8 GAMSQ=ZAMMA*ZAMMA                                                 
      SINT=2.0*ZAMMA/(1.0+GAMSQ)                                        
      COST = (1.0-GAMSQ)/(1.0+GAMSQ)                                    
      SINSQ=SINT*SINT                                                   
      COSSQ=COST*COST                                                   
C     ROTATION                                                          
  120 DO 13 K = 1,N                                                     
      TAIK = A(IPIV,K)                                                  
      TAJK = A(JPIV,K)                                                  
      A(IPIV,K) = TAIK*COST+TAJK*SINT                                   
      A(JPIV,K) = TAJK*COST-TAIK*SINT                                   
      TCIK = C(IPIV,K)                                                  
      TCJK = C(JPIV,K)                                                  
      C(IPIV,K) = TCIK*COST+TCJK*SINT                                   
   13 C(JPIV,K) = TCJK*COST-TCIK*SINT                                   
      A(IPIV,IPIV) = TAII*COSSQ+TAJJ*SINSQ+2.0*TAIJ*SINT*COST           
      A(JPIV,JPIV) = TAII*SINSQ+TAJJ*COSSQ-2.0*TAIJ*SINT*COST           
      A(IPIV,JPIV) = TAIJ*(COSSQ-SINSQ)-SINT*COST*TMT                   
      A(JPIV,IPIV) = A(IPIV,JPIV)                                       
      DO 30 K = 1,N                                                     
      A(K,IPIV) = A(IPIV,K)                                             
   30 A(K,JPIV) = A(JPIV,K)                                             
   72 CONTINUE                                                          
      WRITE (JOUT,1000) AIJMAX                                             
 1000 FORMAT (/1X,'NONCONVERGENT JACOBI. LARGEST OFF-DIAGONAL ELE',     
     1 'MENT = ',1PE14.7)                                               
C     ARRANGEMENT OF EIGENVALUES IN ASCENDING ORDER                     
  300 DO 14 I=1,N                                                       
   14 AJJ(I)=A(I,I)                                                     
      LT=N+1                                                            
      DO15 L=1,N                                                        
      LT=LT-1                                                           
      AIIMIN=1.0E+30                                                    
      DO16 I=1,N                                                        
      IF(AJJ(I)-AIIMIN)17,16,16                                         
   17 AIIMIN=AJJ(I)                                                     
      IT=I                                                              
   16 CONTINUE                                                          
      IN=L                                                              
      AII(IN)=AIIMIN                                                    
      AJJ(IT)=1.0E+30                                                   
      DO15 K=1,N                                                        
   15 A(IN,K)=C(IT,K)                                                   
      DO 18 I=1,N                                                       
      IF(A(I,1))19,22,22                                                
   19 T=-1.0                                                            
      GO TO 91                                                          
   22 T=1.0                                                             
   91 DO 18 J=1,N                                                       
   18 C(J,I)=T*A(I,J)                                                   
      RETURN                                                            
      END
*******************************************************************************
      SUBROUTINE PIS(IT,I1,I2,J1,J2,ICOL)
      IMPLICIT REAL*8 (A-H,O-Z)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.IOUNIT'
      COMMON /DIGMAT/ A(600,600),CTTT(600,600),TMMM(600),HHHH(600)               
      JD=J2-J1+1                                                        
      IF(ICOL.EQ.6) GOTO 10                                             
      IPA=JD/16                                                         
      IF(IPA.EQ.0) GOTO 3                                               
      DO 4 J=1,IPA                                                      
        JA=J1+16*(J-1)                                                  
        JB=J1-1+16*J                                                    
        WRITE(JOUT,21) (K,K=JA,JB)                                         
4       WRITE(JOUT,22) (I,(A(I,K),K=JA,JB),I=I1,I2)                        
      IF(16*IPA.EQ.JD)RETURN                                            
3     JC=16*IPA+J1                                                      
      WRITE(JOUT,21) (J,J=JC,J2)                                           
      DO 6 I=I1,I2                                                      
6     WRITE(JOUT,23) I,(A(I,J),J=JC,J2)                                    
      RETURN                                                            
10    CONTINUE                                                          
      IPA=JD/6                                                          
      IF(IPA.EQ.0)GOTO 43                                               
      DO 44 J=1,IPA                                                     
        JA=J1+6*(J-1)                                                   
        JB=J1-1+6*J                                                     
      WRITE(JOUT,31)(K,K=JA,JB)                                            
44    WRITE(JOUT,32)(I,(A(I,K),K=JA,JB)                                    
     *      ,I=I1,I2)                                                   
      IF(6*IPA.EQ.JD) RETURN                                            
43    JC=6*IPA+J1                                                       
      WRITE(JOUT,31) (J,J=JC,J2)                                           
      DO 46 I=I1,I2                                                     
46    WRITE(JOUT,33) I,(A(I,J),J=JC,J2)                                    
      RETURN                                                            
31    FORMAT(/10X,6(I3, 9X))                                         
32    FORMAT(/(I3,3X,6(1PE10.3,2X)))                                 
33    FORMAT(I3,3X,6(1PE10.3,2X))                                    
21    FORMAT(/9X,16(I2,5X))                                          
22    FORMAT(/(1X,I3,3X,16(F5.2,2X)/))                                  
23    FORMAT(1X,I3,3X,16(F5.2,2X))                                      
      END
*******************************************************************************
      SUBROUTINE EIGOUT(NC,NR,LM2,LM3)
      IMPLICIT REAL*8 (A-H,O-Z)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.IOUNIT'
      COMMON /DIGMAT/ A(600,600),C(600,600),B(600),AINT(600)               
      KA=1                                                              
      KC=6                                                              
    1 KB=MIN0(KC,NC)                                                    
      WRITE(JOUT,600) (I,I=KA,KB)                                          
      WRITE(JOUT,601) (B(I),I=KA,KB)                                       
      WRITE(JOUT,602)                                                      
    2 N=0                                                               
      DO 3  I=1,NR                                                      
      WRITE(JOUT,603) I,(A(I,J),J=KA,KB)                                   
      N=N+1                                                             
      IF(N.LT.10) GO TO 3                                               
      WRITE(JOUT,602)                                                      
      N=0                                                               
    3 CONTINUE                                                          
    4 IF (KB.EQ.NC) RETURN                                              
      KA=KC+1                                                           
      KC=KC+6                                                           
      GO TO 1                                                           
  600 FORMAT (// 9H ROOT NO.,I4,9I11)                                   
  601 FORMAT (/5X,10(1PE11.4))                                              
  602 FORMAT (2H  )                                                     
  603 FORMAT (I5,10F11.5)                                               
  604 FORMAT (1H1)                                                      
      END
