C $Date: 1997/12/17 19:05:04 $
C $Revision: 3.3 $
C
C
C
      subroutine set_timers
c
      include 'COMMON.TIME1'
C Diminish the assigned time limit a little so that there is some time to
C end a batch job
      timlim=batime-150.0
      batime=stime
      return 
      end

      logical function stopx(idummy)
C
C     ..................................................................
C
C     *****PURPOSE...
C     THIS FUNCTION MAY SERVE AS THE STOPX (ASYNCHRONOUS INTERRUPTION)
C     FUNCTION FOR THE NL2SOL (NONLINEAR LEAST-SQUARES) PACKAGE AT
C     THOSE INSTALLATIONS WHICH DO NOT WISH TO IMPLEMENT A
C     DYNAMIC STOPX.
C
C     *****ALGORITHM NOTES...
C     AT INSTALLATIONS WHERE THE NL2SOL SYSTEM IS USED
C     INTERACTIVELY, THIS DUMMY STOPX SHOULD BE REPLACED BY A
C     FUNCTION THAT RETURNS .TRUE. IF AND ONLY IF THE INTERRUPT
C     (BREAK) KEY HAS BEEN PRESSED SINCE THE LAST CALL ON STOPX.
C
C     $$$ MODIFIED FOR USE AS  THE TIMER ROUTINE.
C     $$$                              WHEN THE TIME LIMIT HAS BEEN
C     $$$ REACHED     STOPX IS SET TO .TRUE  AND INITIATES (IN ITSUM)
C     $$$ AND ORDERLY EXIT OUT OF SUMSL.  IF ARRAYS IV AND V ARE
C     $$$ SAVED, THE SUMSL ROUTINES CAN BE RESTARTED AT THE SAME
C     $$$ POINT AT WHICH THEY WERE INTERRUPTED.
C
C     ..................................................................
C
      integer idummy
      include 'COMMON.TIME1'
!       COMMON/TTTIM/STTIM
C ======================================================================

C     When executing an MP run, this #ifdef block allows the master
C  to check for incoming messages from the workers.  This is done on
C  every interation on an energy evaluation.

#ifdef MP
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'PARAMET.MP'
      include 'COMMON.MP'
!     GTIME=SECNDS(STTIM)
!     write(*,*)TASKID,'Time checked at ', GTIME
C     IF (TASKID.EQ.MASTER) call MASTER_MAIL
      IF (TASKID.EQ.MASTER)  THEN
         CALL MASTER_MAIL
      ELSE
         CALL SLAVE_MAIL
      ENDIF
#endif
C ======================================================================
      if (istop.eq.0) then
         stopx = .false.
      else
         stopx = .true.
      endif
      return
      end


      logical function ovrtim() 
      include 'COMMON.TIME1'
      curtim= tcpu()
C  curtim is the current time in seconds.
      ovrtim=(curtim .ge. timlim )
      return                                               
      end
**************************************************************************      
      function tcpu()
      include 'COMMON.TIME1'
#ifdef ES9000 
****************************
C Next definition for EAGLE (ibm-es9000)
      real*8 micseconds
      integer rcode
      tcpu=cputime(micseconds,rcode)
      tcpu=(micseconds/1.0E6) - stime
****************************
#endif
#ifdef SUN
****************************
C Next definitions for sun
      integer seconds
      real*8 etime
      dimension tarray(2)
      tcpu=etime(tarray)
      tcpu=tarray(1)-stime
****************************
#endif
#ifdef KSR
****************************
C Next definitions for ksr
C this function uses the ksr timer ALL_SECONDS from the PMON library to
C return the elapsed time in seconds
      tcpu= all_seconds() - stime
****************************
#endif
#ifdef SGI
****************************
C Next definitions for sgi
      real timar(2), etime
      seconds = etime(timar)
C      usrsec = timar(1)
C      syssec = timar(2)
      tcpu=seconds - stime
****************************
#endif
#ifdef CRAY
****************************
C Next definitions for Cray
C     call date(curdat)
C     curdat=curdat(1:9)
C     call clock(curtim)
C     curtim=curtim(1:8)
      cpusec = second()
      tcpu=cpusec - stime
****************************
#endif
#ifdef AIX
****************************
C Next definitions for RS6000
        integer*4 i1,mclock
       i1 = mclock()
       tcpu = float(i1) / 100.0E0
#endif
#ifdef WINNT
****************************
C Next definitions for NT. sverdlik   7-27-99
C CPU_TIME returns time in seconds
!       real*4 ti1
!       call cpu_time(ti1)
!       tcpu = ti1
! ***********************
!       real*4 ti1(2)
!       tcpu = etime(ti1)
! The two procedures above don't seem to be provide the
! time in seconds DR 8/12/99
        integer*2 ihr, imin, isec, i100th 
        CALL GETTIM (ihr, imin, isec, i100th) 
!		write(*,*)'ihr=',ihr, ' imin=',imin,
!    &         ' isec=',isec,' i100th=',i100th
	    strt=STIME
        tcpu=3600.0E+0*ihr+60.0E+0*imin+1.0E+0*isec+i100th*1.E-02-strt
#endif

      return     
      end  
*
      subroutine dajczas(rntime,hrtime,mintime,sectime)
      include 'COMMON.IOUNIT'
      real rntime,hrtime,mintime,sectime 
      hrtime=rntime/3600.0 
      hrtime=aint(hrtime)
      mintime=aint((rntime-3600.0*hrtime)/60.0)
      sectime=aint((rntime-3600.0*hrtime-60.0*mintime)+0.5)
      if (sectime.eq.60.0) then
        sectime=0.0
        mintime=mintime+1.0
      endif
      ihr=hrtime
      imn=mintime
      isc=sectime
      write (jout,328) ihr,imn,isc
  328 FORMAT(//'***** Computation time: ',I4  ,' hours ',I2  ,
     1         ' minutes ', I2  ,' seconds *****')       
      return
      end
