      FUNCTION ALPHADIST(IA,JA)                                              
C
C This subroutine retrieves the distance between two CA atoms on residues
C IA and JA.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.ACAR'
      IAA=IALPH(IA)
      JAA=IALPH(JA)
      XX=COORD(1,JAA)-COORD(1,IAA)
      YY=COORD(2,JAA)-COORD(2,IAA)
      ZZ=COORD(3,JAA)-COORD(3,IAA)
      ALPHADIST=SQRT(XX*XX+YY*YY+ZZ*ZZ)
      RETURN
      END
******************************************************************************
      FUNCTION ANGLAM(THETA)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      IF (THETA.LT.-PI) THEN
        ANGLAM=THETA+DWAPI
      ELSE IF (THETA.GT.PI) THEN
        ANGLAM=THETA-DWAPI
      ELSE
        ANGLAM=THETA
      ENDIF
      RETURN
      END
******************************************************************************
      SUBROUTINE ANGLEP(A,B,C,ANG1)
      DIMENSION A(3),B(3),C(3),AXB(3),BXC(3)
      DATA C1/57.29578/
      CALL VECTPR(A,B,AXB)
      CALL VECTPR(B,C,BXC)
      D = SQRT(SCAL(AXB,AXB)*SCAL(BXC,BXC))
      DD=D
      IF (DD.LT.0.000001) THEN
        ANG1=999.00
      ELSE
        ANG1 = SCAL(AXB,BXC)/D
        IF (ANG1.GT.1.0) THEN
          ANG1 = 1.0
        ELSE IF ( ANG1.LT.-1.0) THEN
          ANG1 = -1.0
        END IF
C       ANG1 = C1*ARCOS(ANG1)
        ANG1 = C1*ACOS(ANG1)
        IF (SCLPRD(A,B,C).LE.0) ANG1 = -ANG1
      END IF

      RETURN
      END
******************************************************************************
      FUNCTION ANGS(PROD)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      IF (ABS(PROD).GT.1.0) THEN 
         ANGS=0.5*PI*(1.0-PROD/ABS(PROD))
      ELSE
       ANGS=ACOS(PROD)
      ENDIF
      RETURN
      END 
C******************************************************************************
C
      FUNCTION ALPHA(I1,I2,I3)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
C
C  Calculates the planar angle between atoms (i1), (i2), and (i3).
C
      INCLUDE 'COMMON.ATOMSS'
      X12=COORD(1,I1)-COORD(1,I2)
      X23=COORD(1,I3)-COORD(1,I2)
      Y12=COORD(2,I1)-COORD(2,I2)
      Y23=COORD(2,I3)-COORD(2,I2)
      Z12=COORD(3,I1)-COORD(3,I2)
      Z23=COORD(3,I3)-COORD(3,I2)
      VNORM=SQRT(X12*X12+Y12*Y12+Z12*Z12)
      WNORM=SQRT(X23*X23+Y23*Y23+Z23*Z23)
      SCALAR=(X12*X23+Y12*Y23+Z12*Z23)/(VNORM*WNORM)
      ALPHA=ACOS(SCALAR)
      RETURN
      END
C------------------------------------------------------------------------------
      FUNCTION ARCOS(X)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      IF (ABS(X).LT.1.0) GOTO 1
      ARCOS=0.5*(PI-SIGN(1.0,X)*PI)
      RETURN
    1 ARCOS=ACOS(X)
      RETURN
      END
C------------------------------------------------------------------------------
      FUNCTION BETA(I1,I2,I3,I4)
C
C  Calculates the dihedral angle between atoms (i1), (i2), (i3) and (i4)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      X12=COORD(1,I1)-COORD(1,I2)
      X23=COORD(1,I3)-COORD(1,I2)
      X34=COORD(1,I4)-COORD(1,I3)
      Y12=COORD(2,I1)-COORD(2,I2)
      Y23=COORD(2,I3)-COORD(2,I2)
      Y34=COORD(2,I4)-COORD(2,I3)
      Z12=COORD(3,I1)-COORD(3,I2)
      Z23=COORD(3,I3)-COORD(3,I2)
      Z34=COORD(3,I4)-COORD(3,I3)
      WX=-Y23*Z34+Y34*Z23
      WY=X23*Z34-Z23*X34
      WZ=-X23*Y34+Y23*X34
      WNORM=SQRT(WX*WX+WY*WY+WZ*WZ)
      VX=Y12*Z23-Z12*Y23
      VY=-X12*Z23+Z12*X23
      VZ=X12*Y23-Y12*X23
      VNORM=SQRT(VX*VX+VY*VY+VZ*VZ)
      IF (VNORM.GT.1.E-7 .AND. WNORM.GT.1.E-7) THEN
        SCALAR=(VX*WX+VY*WY+VZ*WZ)/(VNORM*WNORM)
        IF (ABS(SCALAR).GT.1.0) SCALAR=0.9999999*SCALAR/ABS(SCALAR)
        ANGLE=ACOS(SCALAR)
      ELSE
        ANGLE=PI
      ENDIF 
      IF (ANGLE.LE.0.0) ANGLE=PI+ANGLE
      TX=VY*WZ-VZ*WY
      TY=-VX*WZ+VZ*WX
      TZ=VX*WY-VY*WX
      SCALAR=TX*X23+TY*Y23+TZ*Z23
      IF (SCALAR.LT.0.0) ANGLE=-ANGLE
      BETA=ANGLE
      RETURN
      END
C
C******************************************************************************
      FUNCTION DIST(I1,I2)
C  Calculates the distance between atoms (i1) and (i2).
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
C
      X12=COORD(1,I1)-COORD(1,I2)
      Y12=COORD(2,I1)-COORD(2,I2)
      Z12=COORD(3,I1)-COORD(3,I2)
      DIST=SQRT(X12*X12+Y12*Y12+Z12*Z12)
      RETURN
      END
C******************************************************************************
      FUNCTION DISTA(A,B)
C     DISTANCE BETWEEN TWO POINTS
      DIMENSION A(3),B(3)

      DISTA=SQRT((A(1)-B(1))**2+(A(2)-B(2))**2+(A(3)-B(3))**2)
      RETURN
      END
C******************************************************************************
      FUNCTION DLENG(A)
C LENGTH OF VECTOR A
      DIMENSION A(3)
      DLENG=SQRT(A(1)**2+A(2)**2+A(3)**2)
      RETURN
      END
C******************************************************************************
      SUBROUTINE EXCHR(A,B)
      AUX=A
      A=B
      B=AUX
      RETURN
      END
C******************************************************************************
      SUBROUTINE EXCH(IA,IB)
      IAUX=IA
      IA=IB
      IB=IAUX
      RETURN
      END
C******************************************************************************
      SUBROUTINE TRANSFER(N,X1,X2)
C Exchange of vectors
      DIMENSION X1(N),X2(N)
      DO 1 I=1,N
    1   X2(I)=X1(I)
      RETURN
      END      
C******************************************************************************
      INTEGER FUNCTION ICANT(I,J)
      IF (I.GE.J) THEN
        ICANT=(I*(I-1))/2+J
      ELSE
        ICANT=(J*(J-1))/2+I
      ENDIF
      RETURN
      END
C******************************************************************************
      LOGICAL FUNCTION LHISTID(I)
C true if residue  at position I is a histidine.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'

      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      KINDI=IABS(KNDRES(LISTI))

      LHISTID= (KINDI.EQ.7 .OR. KINDI.EQ.26 .OR. KINDI.EQ.27)
      RETURN
      END
C******************************************************************************
      INTEGER FUNCTION JON_RESIDUE(I)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.IOUNIT'

      IF (I.LT.0) THEN
           WRITE(JOUT,*)'ERROR, CAN"T FIND RESIDUE FOR ATOM',I
      ENDIF
      DO J=1,INUMRS
         IF ( ( I.GT.NPRE(J) ) .AND.( I.LE.NPRE(J+1) )  ) THEN
            JON_RESIDUE=J
            RETURN
         ENDIF
      ENDDO
      WRITE(JOUT,*)'ERROR, CAN"T FIND RESIDUE FOR ATOM',I
      RETURN
      END
C******************************************************************************
      LOGICAL FUNCTION NATURAL_RES(I)
      PARAMETER (NATRES=28)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'
      INTEGER INATUR(NATRES)
      DATA INATUR /1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14,
     &  15, 16, 17, 18, 19, 20, 21, 26, 27, 28, 29, 31, 32, 33 /
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      KINDI=KNDRES(LISTI)
      KINDI=IABS(KINDI)
      NATURAL_RES=.FALSE. 
      DO J=1,NATRES
        IF(KINDI.EQ.INATUR(J) ) THEN
           NATURAL_RES=.TRUE. 
        ENDIF
      ENDDO
      RETURN
      END
C******************************************************************************
      LOGICAL FUNCTION LPROLIN(I)
C true if residue  at position I is a proline or hydroxiproline.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'

      LISTIJ=LIST(I)
      LISTIJ=IABS(LISTIJ)
      KINDIJ=IABS(KNDRES(LISTIJ))
      LPROLIN= (KINDIJ.EQ.13.OR.KINDIJ.EQ.22.OR.KINDIJ.EQ.75)
      RETURN
      END
C******************************************************************************
      LOGICAL FUNCTION NMETHYL(I)
C true if residue  at position I is an nmethyl residue.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.PRAMX'

      LISTIJ=LIST(I)
      LISTIJ=IABS(LISTIJ)
C     KINDIJ=IABS(KNDRES(LISTIJ))
C     NMETHYL= (KINDIJ.GE.50.AND.KINDIJ.LE.80)
      NMETHYL= NMETRES(LISTIJ)
      RETURN
      END
C******************************************************************************
      FUNCTION NCHVAR(J,I)
C NCHVAR =1 if dihedral angle I of residue J is a variable.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (nsuppl=maxnum_dihe-3)
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.BONDSX'
      CHARACTER*3 ANGCHAR(maxnum_dihe)/'phi','psi','ome',nsuppl*'chi'/
      NCHVAR=0
      IF(NV(J) .LT. 1)THEN
         IF (NUK.NE.0) THEN
           IF (I.GT.3) THEN
             WRITE(JOUT,200) ANGCHAR(I),I-3,J
           ELSE
             WRITE(JOUT,201) ANGCHAR(I),J
           ENDIF
         ENDIF
         RETURN
      END IF
      DO 10 L=1,NV(J)
      IF (I .EQ. NDXARR(L,J)) THEN
         NCHVAR=1
         RETURN
      END IF
10    CONTINUE
      IF (NUK.NE.0)THEN
        IF (I.GT.3) THEN
          WRITE(JOUT,200) ANGCHAR(I),I-3,J
        ELSE
          WRITE(JOUT,201) ANGCHAR(I),J
        ENDIF
      ENDIF
200   FORMAT(A3,I2,'(',I3,') is constant.')
201   FORMAT(A3,'(',I3,') is constant.')
      RETURN
      END
C******************************************************************************
      SUBROUTINE ORTHO(A,B)
C ORTHOGONALIZES VECTOR A WITH RESPECT TO VECTOR B. A CONTAINS THE
C ORTHOGONAL VECTOR.
      DIMENSION A(3),B(3),C(3)
C
      DL=DLENG(B)
      C(1)=B(1)/DL
      C(2)=B(2)/DL
      C(3)=B(3)/DL
      SK=SCAL(A,C)
      DO 1 K=1,3
      A(K)=A(K)-C(K)*SK
1     CONTINUE
      RETURN
      END
******************************************************************************
      SUBROUTINE VECTPR(A,B,C)
C VECTOR PRODUCT OF A AND B IS C
      DIMENSION A(3),B(3),C(3)
      C(1)=A(2)*B(3)-A(3)*B(2)
      C(2)=A(3)*B(1)-A(1)*B(3)
      C(3)=A(1)*B(2)-A(2)*B(1)
      RETURN
      END
******************************************************************************
      SUBROUTINE ORTPAL(A,B,D,E) 
C ORTHOGONALIZES VECTOR A WITH RESPECT TO VECTOR B. D CONTAINS THE
C ORTHOGONAL VECTOR AND E THE PARALLEL ONE.
      DIMENSION A(3),B(3),C(3),D(3),E(3)

      DL=DLENG(B)
      C(1)=B(1)/DL
      C(2)=B(2)/DL
      C(3)=B(3)/DL
      SK=SCAL(A,C)
      DO 1 K=1,3
      PLC=C(K)*SK
      E(K)=PLC
      D(K)=A(K)-PLC
1     CONTINUE
      RETURN
      END
******************************************************************************
      FUNCTION SCAL(A,B)
C SCALAR OR DOT PRODUCT
      DIMENSION A(3),B(3)
      SCAL=A(1)*B(1)+A(2)*B(2)+A(3)*B(3)
      RETURN
      END
******************************************************************************
      FUNCTION SCLPRD(A,B,C )
      DIMENSION A(3),B(3),C(3)
      SCLPRD = A(1)*B(2)*C(3) - A(1)*B(3)*C(2) - A(2)*B(1)*C(3)
     &  + A(2)*B(3)*C(1) + A(3)*B(1)*C(2) - A(3)*B(2)*C(1)
      RETURN
      END
******************************************************************************
      FUNCTION SIG(A,B,C)
C GIVEN A&B O R T H O G O N A L  TO C
C THIS FUNCTION RETRIEVES THE SIGN OF THE ROTATION ANGLE
      DIMENSION A(3),B(3),C(3),V(3)
      INCLUDE 'COMMON.IOUNIT'
      V1=ABS(SCAL(A,C))
      V2=ABS(SCAL(B,C))
      IF(V1.LT.0.1E-2.AND. V2.LT.0.1E-2) GO TO 1
      WRITE(JPRINT,'(a,2e12.5)') 'ERROR IN FUNCTION SIG ' , V1,V2
1     CALL VECTPR(A,B,V)
      V3=SCAL(V,C)
      IF(V3) 5,4,3
5     SIG=-1.
      RETURN
3     SIG=1.
      RETURN
4     WRITE(JPRINT,'(a,e12.5)') 'ERROR IN SIG ' , V3
      RETURN
      END
C******************************************************************************
      FUNCTION ANGLTHET(A,B,C)
      DIMENSION A(3),B(3),C(3)
C ANGLE BETWEEN VECTORS A & B, GIVEN A & B  ORTHOGONAL TO C!!!!!
C THE SIGN IS GIVEN WITH RESPECT TO AXIS GIVEN BY VECTOR C.
C  ANGLE VALUE IN RADIANS.
      C1=DLENG(A)
      C2=DLENG(B)
      D=SCAL(A,B)
      CS=D/(C1*C2)
      IF(ABS(CS).GT.1.)CS=SIGN(1.0,CS)
      AN=ACOS(CS)
      ANGLTHET=PINORM(AN)*SIG(A,B,C)
      RETURN
      END
******************************************************************************
      FUNCTION PINORM( RVAL )
C
C THIS FUNCTION TAKES AN ANGLE (IN RADIANS) AND PUTS IT IN THE RANGE OF
C -PI TO +PI.
C LARGE IS THE LARGEST INTEGER (IBM D.R. 4-90)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.IOUNIT'
      INTEGER NHH
      REAL PI_1, RVAL,ULARGE, XNORM, UXN, PINORM
      PI_1= 1.0*PI
      SWAPI= 1.0*DWAPI
      ULARGE = 1.0*fctor
      XNORM = 1.0 / DWAPI
C
      UXN = RVAL * XNORM
      IF(UXN.GT.ULARGE) THEN
         WRITE(JOUT,100) UXN
      END IF
100   FORMAT ('IN PINORM THE NORMALIZATION FACTOR IS BIG ',E12.5)
      NHH= INT(UXN)
      PINORM = RVAL -  FLOAT(NHH) * SWAPI
      IF ( PINORM .GT. PI_1 ) THEN
         PINORM = PINORM - SWAPI
      ELSE IF ( PINORM .LT. - PI_1 ) THEN
         PINORM = PINORM + SWAPI
      END IF
      RETURN
      END
******************************************************************************
      SUBROUTINE NDX_DECODE(NDX,ID,IANG)
C Given the index (NDX) of a variable dihedral angle, this routine 
C retrieves the residue no.(ID) and the dihedral angle no. (IANG) 
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

      IQ=INT(NDX/maxnum_dihe)
      ID=IQ+1
      IANG=NDX-maxnum_dihe*IQ
      IF (IANG.EQ.0) THEN
         ID=IQ
         IANG=maxnum_dihe
      END IF
      RETURN
      END
C******************************************************************************
      SUBROUTINE SYMM(ANGL)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.BONDSX'
      DIMENSION ANGL(maxnum_dihe,maxnum_res)
      DIMENSION ME(30),MS(30),NDE(30),NDS(30)
      DATA ME /1,3*0,2,2*0,34,0,34,4,3,0,4,7,0,3,23,0,23,2*0,2,3,0,5,67,
     +  3*0/
      DATA MS /3,3*0,2,2*0,3,0,2*3,2,0,2*2,0,2*3,0,2,2*0,2*2,0,3,2,3*0/
      DATA NDS /0,3*3,10*0,4*3,2*0,10*0/
      DATA NDE /0,3*1,10*0,1,12,2*2,2*0,10*0/
      r4dwapi=dwapi
      r4pi=pi
      DO 70 J=1,INUMRS
         IF(NV(J) .EQ. 0) GOTO 70
         LT=IABS(LIST(J))
C Temporary.  We treat only 30 residues,     DR    OCT26-93
         IF (LT.GT.30) GOTO 70
         IF (J.EQ.1.OR.J.EQ.INUMRS) THEN
            MSYM=NDS(LT)
            IF (MSYM.EQ.0) GOTO 70
            MQ=NDE(LT)/10
            MR=NDE(LT)-10*MQ
C              MQ=NDE(LT)/maxnum_dihe
C              MR=NDE(LT)-maxnum_dihe*MQ
C              VA=180.0
            VA=PI
         ELSE
            MSYM=MS(LT)
            IF (MSYM.EQ.0) GO TO 70
            MQ=NDE(LT)/10
            MR=ME(LT)-10*MQ
C              MQ=ME(LT)/maxnum_dihe
C              MR=ME(LT)-maxnum_dihe*MQ
C                VA=60.0
            VA=PI/3
         ENDIF
         LASTDH=7
C        LASTDH=maxnum_dihe-3 
         DO 60 I=1,LASTDH
            I3=I+3
            IF (J.EQ.1.OR.J.EQ.INUMRS) I3=I
            IF (LT.EQ.20) GO TO 40
            IF (I.NE.MR.AND.I.NE.MQ) GO TO 60
            GO TO (60,10,20),MSYM
C  10       VT=RAD*ANGL(I3,J)
   10       VT=ANGL(I3,J)
            VTPI=VT+PI
C           IF (COS(VT).LT.0.0) ANGL(I3,J)=ANGL(I3,J)+180.0
C           IF (COS(VT).LT.0.0) ANGL(I3,J)=ANGL(I3,J)+PI
            IF (COS(VT).LT.0.0) ANGL(I3,J)=PINORM(VTPI)
            GO TO 50
C  20       VT=AMOD(3.0*ANGL(I3,J),360.0)
   20       VT=AMOD(3.0*ANGL(I3,J),R4DWAPI)
C           ANGL(I3,J)=VA+(VT-SIGN(180.0,VT))/3.0
            ANGUL=VA+(VT-SIGN(R4PI,VT))/3.0
            ANGL(I3,J)=PINORM(ANGUL)
            GO TO 50
   40       IF (I.NE.2) GO TO 50
C           VT=RAD*ANGL(5,J)
            VT=ANGL(5,J)
            IF (COS(VT).GE.0.0) GO TO 50
C           ANGL(5,J)=ANGL(5,J)+180.0
            ANGUL=ANGL(5,J)+PI
            ANGL(5,J)=PINORM(ANGUL)
C           ANGL(6,J)=ANGL(6,J)+180.0
            ANGUL=ANGL(6,J)+PI
            ANGL(6,J)=PINORM(ANGUL)
C  50       IF (ANGL(I3,J).GT.180.0) ANGL(I3,J)=ANGL(I3,J)-360.0
C           IF (ANGL(I3,J).LT.-180.0) ANGL(I3,J)=ANGL(I3,J)+360.0
   50       CONTINUE
   60    CONTINUE
   70 CONTINUE
      RETURN
      END
C******************************************************************************
      SUBROUTINE NONSTGEO(FIRSTCALL)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      LOGICAL FIRSTCALL
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.IOUNIT'
C
C Calculate the virtual-bond geometry of the polypeptide chain (i.e. the
C angles theta and gamma). 
C
      IF (FIRSTCALL) THEN
C
C If this is the first call we have to calculate the angles xi and eta
C for the subsequent peptide groups.
C
        DO I=NST+1,NEN-1
          KSI(I)=ALPHA(IAT(I,2),IAT(I,1),IAT(I-1,1))
          ETA(I)=ALPHA(IAT(I,3),IAT(I,1),IAT(I+1,1))
          ALPH1(I)=ALPHA(IAT(I,2),IAT(I,1),IAT(I,3))
        ENDDO
      ENDIF
      DO I=NST+3,NEN
        GAMA(I)=BETA(IAT(I-3,1),IAT(I-2,1),IAT(I-1,1),IAT(I,1))
      ENDDO
      DO I=NST+2,NEN
        THETT(I)=ALPHA(IAT(I-2,1),IAT(I-1,1),IAT(I,1))
      ENDDO
      DO I=NST,NEN-2
        RRL(I)=BETA(IAT(I+2,1),IAT(I+1,1),IAT(I,1),IAT(I,3))
      ENDDO
      RRL(NEN-1)=BETA(IAT(NEN,2),IAT(NEN,1),IAT(NEN-1,1),IAT(NEN-2,1))
************************************************************************
C Uncomment the following for diagnostics.
************************************************************************
cd    do i=nst,nen
cd    write (jout,*) 'residue:',i,'iat',iat(i,1),iat(i,2),iat(i,3)
cd    write (jout,*) 'ksi ',ksi(i)/rad,' eta ',eta(i)/rad,
cd   1            ' alpha ',alph(i)/rad
cd    write (jout,*) 'theta',theta(i)/rad,' gamma ',gama(i)/rad
cd    enddo
cd    do i=nst+1,nen-1
cd      phi1=beta(iat(i-1,3),iat(i,2),iat(i,1),iat(i,3))/rad
cd      psi1=beta(iat(i,2),iat(i,1),iat(i,3),iat(i+1,2))/rad 
cd      rl1=rrl(i-1)  
cd      rl2=alam2(i)
cd      rrl2=beta(iat(i+1,2),iat(i+1,1),iat(i,1),iat(i-1,1))
cd      phi2=phi(i,rl1,rl2)/rad
cd      psi2=psi(i,rl1,rl2)/rad
cd      write (jout,'(2hi=,i2,4h phi=,2f10.3,4h psi=,2f10.3)') i,phi1,
cd   &         phi2,psi1,psi2
cd      write (jout,'(2x,5hlam1=,f10.3,6h lam2=,f10.3)') rl1/rad,rl2/rad
cd      write (jout,*) rrl2/rad
cd    enddo 
*************************************************************************
      RETURN
      END
      SUBROUTINE SUBPDB ( NATM, RCOR, JUSE, KUNIT )
C This subroutine reads a PDB file through unit "KUNIT". Before it
C is called, you have to define the polypeptide sequence and the number
C of atoms (NATM) that should be read. The routine will attempt to match 
C the "read-in" atoms with the residue information generated from ECEPP. 
C
C The program will collapse if the number of atoms read is greater than
C the one define by ECEPP. If the number of atoms that are read-in is
C smaller than NATM, a warning will be printed.
C
C The program will stop if the ALPHA character descriptor of a read-in atom 
C does not match with any of the ALPH(I) descriptors of the atoms in the
C specified residue as defined by ECEPP. 
C 
C Since original PDB files usually label as residue 1 the first full residue,
C there is a flag to indicate when a given file contains the end-groups.
C   A- Original brookhaven file WITH NO END GROUPS.
C   B- File written with ECEPP or AMBER, WITH END GROUPS. 
C
C Flag JUSE=1 (ICON) indicates that the atom could be used in the comparison.
C In those cases where the heavy atoms are not found (i.e. missing atoms in 
C PDB files), the flags for such atoms are set to zero.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.TYYY'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.PRAMX'
      CHARACTER*3 TYPE,ARESID
      CHARACTER*80 LINE
      DIMENSION IREXJ(matres)
      DIMENSION RCOR(3,maxnum_atoms), JUSE(maxnum_atoms)
      LOGICAL LPRNT
      CHARACTER*6 KREADLIN(2) /'ATOM  ','HETATM'/

C
C CHANGE LPRNT TO TRUE FOR DEBUGGING.
C     LPRNT=.TRUE.
      LPRNT=.FALSE.
C
      NREOLD=0
C
      DO 10 I=1, NATM
        JUSE(I)=0
 10   CONTINUE

C     IF(LPRNT)WRITE (JOUT, '(11a)')'ALPHAS ', (ALPH(JD),JD=1,10)

      IRD=0  
 15   READ (KUNIT, '(a)', END = 70) LINE
      IF ( (LINE(1:6).NE. KREADLIN(1)) .AND.
     &              (LINE(1:6).NE. KREADLIN(2)) ) THEN
        GOTO 15
      ENDIF
      IRD=IRD+1
      READ (LINE, 1020, ERR=100) TYPE, ARESID,  NRESX, X,Y,Z

      NRE=NRESX-IFRSTRS+1
      IF (IGNORE_H) THEN
         IF (TYPE(1:1).EQ.' ') THEN 
           IF (TYPE(2:2).EQ.'H') GOTO 15
         ENDIF
      ELSE
         IF (TYPE(1:1).EQ.'H') GOTO 15
      ENDIF

      IF(ITYPF.EQ.1) THEN 
C  IF THE FILE IS AN ORIGINAL PDB FILE RESIDUE READ IS
C  NUMBERED AS (NRES + 1) IN THE ECEPP STRUCTURE.
C                                                 DR    NOV 30/93
         NRE=NRE+1
C        WRITE (JOUT, '(a)') 'READING A PDB'
      END IF
      IF(LPRNT) WRITE (JOUT, 1020) TYPE, ARESID, NRESX, X,Y,Z
      IF (NRE.GT.NREOLD) THEN
           NPR = NPRE(NRE)
           LF = NPRE(NRE+1)-NPR
           IF ((NRE.EQ.1).OR.(NRE.EQ.INUMRS) ) THEN
             NT = IABS(LIST(NRE))+num_restypes
           ELSE
             NT = IABS(LIST(NRE))
           ENDIF
           WRITE (JOUT,*) 'ECEPP RESIDUE:', 
     &          ARES(NT),'(',NRE,')', ARESID,'(',NRESX,')'
           IF(LPRNT) WRITE (JOUT,730)NRE, LF
 730       FORMAT('No. of Atoms in residue(',I4,') =',3I5)
           DO 31 K= 1, matres
              IREXJ(K)=0
  31       CONTINUE
           NREOLD =NRE
      ENDIF
      DO 40 L= 1, LF
          JATO=NPR+L
          IF(LPRNT) WRITE (JOUT,*) 'ATOM No.', JATO,' TYPE= ', 
     &                            ALPH(JATO), ' RES.No ', NRE
          IF (TYPE.EQ.ALPH(JATO)) THEN
            DO 41 K= 1, LF
              IF ((IREXJ(K).EQ.JATO).AND.(TYPE(1:1).NE.'H')) THEN
                WRITE (JOUT,1031) IRD, TYPE, ARESID, NRESX,NRE
                STOP 221
              ENDIF
  41        CONTINUE
            IREXJ(L)=JATO
            IF (TYPE(1:1).EQ.'H') THEN
              JUSE(JATO) = 0
              RCOR(1,JATO) = 0.0
              RCOR(2,JATO) = 0.0
              RCOR(3,JATO) = 0.0
            ELSE
              JUSE(JATO) = 1
              RCOR(1,JATO) = X
             RCOR(2,JATO) = Y
              RCOR(3,JATO) = Z
            ENDIF
            GOTO 15
          END IF
   40 CONTINUE
      WRITE (JOUT,1032) IRD, TYPE, ARESID, NRESX,NRE
      STOP 222
C  60 CONTINUE

   70 CONTINUE
      IF(IRD.NE.NATM)  THEN
        IF(KUNIT.EQ.27) WRITE (JOUT,'(a,i3,a/a,i5/a)') 
     & 'Warning: Missing atoms in PDB file (unit: ',KUNIT,') ',
     & 'No. of atoms read =', IRD,' CHECK YOUR OUTPUT REFERENCE FILE',
     & ' The No. of atoms in the molecule (including H"s) is ',NATM

        IF(KUNIT.EQ.44) WRITE (JOUT,'(a,i3,a/a,i5/a)') 
     & 'Warning: Missing atoms in PDB file (unit: ',KUNIT,') ',
     & 'No. of atoms read =', IRD,' CHECK YOUR PDB INPUT FILE',
     & ' The No. of atoms in the molecule (including H"s) is ',NATM
      ENDIF 
      IF(KUNIT.EQ.27) THEN
        DO 80 I=1, NATM
          WRITE (39,1040) ( RCOR(K,I),K=1,3), JUSE(I), ALPH(I)
  80    CONTINUE
      END IF
  90  RETURN
 100  WRITE (JOUT,'(2A)')'Error when reading line in SUBPDB: ',LINE
 1000 FORMAT (2I10)
 1001 FORMAT (2F10.3)
 1002 FORMAT (I10,F10.3)
 1020 FORMAT (13X,A3,1X,A3,2X,I4,4X,3F8.3)
 1031 FORMAT ('%ERR - ATOM ALREADY ASSIGNED: ', I5, 2X, 'TYPE ', 
     &        A4,' ',A3,'(', i5,'),  ECEPP RESIDUE ', I5 )
 1032 FORMAT ('%ERR - ATOM NOT FOUND : ', I5, 2X, 'TYPE ', 
     &        A4,' ',A3,'(', i5,'),  ECEPP RESIDUE ', I5 )
 1040 FORMAT (5X,3F9.3,I6,5X,A4)
      END
******************************************************************************
      SUBROUTINE INGEN ( COORD, LIST,  NPREH, NRES)
C
C     RECOVER DIHEDRAL ANGLES (IN DEGREES) FROM COORDINATES OF HEAVY ATOMS
C  This routine is not been used, but may be needed in future applications.
C 
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      REAL*8 COORD(3,maxnum_atoms)
      DIMENSION LIST(maxnum_res), NPREH(maxnum_res)
      DIMENSION LAST(23), NCHI(23), NBEGIN(5,23), NEND (5,23)

      DIMENSION ANGLES(8,maxnum_res)

      DATA LAST/0,8,6,9,7,0,7,8,9,7,8,8,0,9,11,6,7,7,7,7,8,9,0/

      DATA NCHI/0,2,1,3,2,0,2,2,4,2,3,2,0,3,5,1,1,1,2,2,2,3,0/

      DATA NBEGIN/5*0,2,3,3*0,2,4*0,2,3,6,2*0,2,3,3*0,5*0,2,3,3*0,
     1   2,3,3*0,2,3,6,7,0,2,3,3*0,2,3,6,2*0,2,3,3*0,5*0,2,3,6,2*0,
     2   2,3,6,7,8,2,4*0,2,4*0,2,4*0,2,3,3*0,2,3,3*0,
     3   2,3,3*0,2,3,6,2*0,5*0/

      DATA NEND/5*0,3,6,3*0,3,4*0,3,6,7,2*0,3,6,3*0,5*0,3,6,3*0,
     1   3,7,3*0,3,6,7,8,0,3,6,3*0,3,6,7,2*0,3,6,3*0,5*0,3,6,7,2*0,
     2   3,6,7,8,9,3,4*0,3,4*0,3,4*0,3,6,3*0,3,6,3*0,
     3   3,6,3*0,3,6,7,2*0,5*0/

      DO 100 IR =1,NRES
        INAN = 0
        ITYPE = LIST(IR+1)
C    PHI
        IF ( IR .GT. 1) THEN
          ITYPP = LIST(IR)
C    GET POINTER TO (IR-1)-TH C-PRIME : N1

          IF (ITYPP.EQ.13) THEN

C                                          PROLINE
            N1 = 5
          ELSE IF ( ITYPP.EQ.6) THEN
C                                          GLYCINE
            N1 = 3
          ELSE
C                                          OTHER
            N1 = 4
          END IF
          N1 = NPREH(IR-1) + N1

C    GET POINTER TO IR-TH NITROGEN: N2,
C                TO IR-TH C-ALPHA: N3,
C                TO IR-TH C-PRIME: N4,

          IF (ITYPE.EQ.13) THEN

C                                          PROLINE
            N3 = 3
            N4 = 5
          ELSE IF ( ITYPE.EQ.6) THEN
C                                          GLYCINE
            N3 = 2
            N4 = 3
          ELSE
C                                          OTHER
            N3 = 2
            N4 = 4
          END IF
          N2 = NPREH(IR) + 1
          N3 = NPREH(IR) + N3
          N4 = NPREH(IR) + N4

          CALL PREAN ( N1,N2,N3,N4, ANG, COORD)

          INAN = INAN + 1
          ANGLES (INAN,IR) = ANG
        ELSE
          INAN = INAN + 1
          ANGLES(INAN,1) = 999.0
        END IF


C  PSI

        IF (IR.NE.NRES) THEN
          ITYPN = LIST(IR+2)
C   GET POINTER TO IR-TH NITROGEN:N1,
C               TO IR-TH C-ALPHA:N2,
C               TO IR-TH C-PRIME:N3,
C               TO (IR+1)-TH NITROGEN:N4

          IF (ITYPE.EQ.13) THEN
C                                          PROLINE
            N2 = 3
            N3 = 5
          ELSE IF ( ITYPE.EQ.6) THEN
C                                          GLYCINE
            N2 = 2
            N3 = 3
          ELSE
C                                          OTHER
            N2 = 2
            N3 = 4
          END IF

          N1 = NPREH(IR) + 1
          N2 = NPREH(IR) + N2
          N3 = NPREH(IR) + N3
          N4 = NPREH(IR+1) + 1

          CALL PREAN ( N1,N2,N3,N4, ANG, COORD)

          INAN = INAN + 1
          ANGLES (INAN,IR) = ANG
        ELSE
          INAN = INAN + 1
          ANGLES(INAN,IR) = 999.0
        END IF

C    OMEGA

        IF (IR.NE.NRES) THEN

C   GET POINTER TO IR-TH C-ALPHA:N1,
C               TO IR-TH C-PRIME:N2,
C               TO (IR+1)-TH NITROGEN:N3
C               TO (IR+1)-TH C-ALPHA:N4

          IF (ITYPE.EQ.13) THEN
C                                          PROLINE
            N1 = 3
            N2 = 5
          ELSE IF (ITYPE.EQ.6) THEN
C                                          GLYCINE
            N1 = 2
            N2 = 3
          ELSE
C                                          OTHER
            N1 = 2
            N2 = 4
          END IF

C   GET POINTER TO (IR+1)-TH C-ALPHA:N4

          IF (ITYPN.EQ.13) THEN
C                                          PROLINE
            N4 = 3
          ELSE
            N4 = 2
          END IF


          N1 = NPREH(IR) + N1
          N2 = NPREH(IR) + N2
          N3 = NPREH(IR+1) + 1
          N4 = NPREH(IR+1) + N4

          CALL PREAN ( N1,N2,N3,N4, ANG, COORD)

          INAN = INAN + 1
          ANGLES (INAN,IR) = ANG
        ELSE
          INAN = INAN + 1
          ANGLES(INAN,IR) = 999.0
        END IF

C  CHI'S

        NSIDE = NCHI ( ITYPE )
        DO 50 IS =1, NSIDE
          N2 = NBEGIN (IS, ITYPE)
          N3 = NEND (IS, ITYPE)
          IF (NSIDE .EQ. 1) THEN
C                                    ONLY ONE CHI
            N1 = N2 -1
            N4 = LAST (ITYPE)
          ELSE IF ( IS.EQ.1) THEN
C                                    FIRST CHI OF SEVERAL
            N1 = N2 -1
            N4 = NEND(2,ITYPE)
          ELSE IF (IS.EQ.NSIDE) THEN
C                                    LAST CHI OF SEVERAL
            N1 = NBEGIN(IS-1,ITYPE)
            N4 = LAST (ITYPE)
          ELSE

            N1 = NBEGIN(IS-1,ITYPE)
            N4 = NEND(IS+1,ITYPE)

          END IF

          N1 = NPREH(IR) + N1
          N2 = NPREH(IR) + N2
          N3 = NPREH(IR) + N3
          N4 = NPREH(IR) + N4

          CALL PREAN ( N1,N2,N3,N4, ANG, COORD)
          INAN = INAN + 1
          ANGLES (INAN,IR) = ANG

 50     CONTINUE

 100  CONTINUE
C     WRITE ( 33,'(8F8.3)') ((ANGLES(I,J),I=1,8),J=1,NRES)
      RETURN
      END
C ***************************************************************************
      SUBROUTINE PREAN ( N1,N2,N3,N4,ANG,COORD)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      REAL*8 COORD (3,maxnum_atoms)
      DIMENSION A(3), B(3), C(3)

      DO 20 J=1,3
        A(J) = COORD(J,N2)-COORD(J,N1)
        B(J) = COORD(J,N3)-COORD(J,N2)
        C(J) = COORD(J,N4)-COORD(J,N3)
  20  CONTINUE

      CALL ANGLEP( A, B, C, ANG )

      RETURN
      END
      SUBROUTINE GENDISTR ( ISIZE,DIST,P)
      INCLUDE 'COMMON.IOUNIT'
      INTEGER ISIZE
      DIMENSION P(ISIZE+1)
      DOUBLE PRECISION DIST(ISIZE)

      SUM=0.0
      DO I=1,ISIZE
      	SUM=DIST(I)+SUM
         IF(DIST(I).LT.0.0) THEN
           WRITE(JOUT,80) I,DIST(I)
           WRITE(*,80) I,DIST(I)
         END IF
      ENDDO
      P0=0.0
      P(1)=0.0
      DO I=1, ISIZE
      P(I+1)=DIST(I)/SUM + P0
      P0=P(I+1)
C     IF(DIST(I).GT.0.0) THEN
C        WRITE(JOUT,90) (I+1),P(I+1)
C     END IF
      ENDDO
      IF (P(ISIZE+1).LT.0.9990)THEN
         WRITE(JOUT,'(A)') 'DISTRIBUTION'
         WRITE(JOUT,'(6e12.5)') (I,DIST(I) ,I=1,ISIZE)
         WRITE(JOUT,'(A)') 'PROBABILITY'
         WRITE(JOUT,'(6e12.5)')(P(I),I=1,ISIZE+1)
      END IF
      P(ISIZE+1)=1.0
C     WRITE(JOUT,'(A)') 'OUT OF GENDISTR'
      RETURN
80    FORMAT('ERROR GENDISTR: DIST(',I4,') =',E12.5)
90    FORMAT('P(',I4,') =',F8.6)
100   FORMAT('P(ISIZE+1) =',E12.5)
      END
      SUBROUTINE RNDNDX(ISIZE, P, NDX)
      INCLUDE 'COMMON.IOUNIT'
      DIMENSION P(ISIZE+1)
C
C  GET A RANDOM NUMBER
      RND=RNUNF(1)
      N=0
      DO 130 L=1,ISIZE
      IF ((RND .GT.P(L)) .AND. (RND .LE. P(L+1))) THEN
         NDX=L
C        WRITE(JOUT,115)RND,NDX
C115      FORMAT('RANDOM NUMBER=',F10.8,'NDX=',I4)
         N=1 + N
      END IF
130   CONTINUE
      IF ((N .EQ. 0) .OR.(N.GT.1))THEN
         WRITE(JOUT,180)N
180      FORMAT('N=',I3,'  Error ....error......error.....!!!.'
     &,' Exitting at RNDNDX. .')
         STOP
      END IF
      RETURN
      END

      subroutine close_app(iunit,fname)

      integer iunit
      character*64 fname

      close(iunit)
#ifdef AIX
      open (iunit,file=fname,status='unknown',position='append',
     &      err=100)
#else
      open (iunit,file=fname,status='unknown',access='append',
     &      err=100)
#endif

      goto 110
  100 write (*,'(a,i4,/2a)') '%ERR Close_app: can"t open logical unit',
     &      iunit, ' file= ', fname
      stop
  110 continue
      return
      end

      integer function lhyperdist(MRES)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.IOUNIT'
      real prob(0:maxnum_res)
      save prob,init
      logical init
      data init /.true./

      if (mres.eq.0) then
        lhyperdist=0
        return
      endif

      if (init) then

      SUM= 0.0
      prob(0)=0.0
      do i=1, MRES
          II=i*i
          XNU= 1.0/float (II)
          SUM= SUM+XNU
          prob(i)=sum
      enddo

c     write (*,*) 'MRES=',MRES
c     write (*,*) 'PROB:',(prob(i),i=1,mres)
      init = .false.

      endif

C     write (*,*) 'MRES=',MRES
      ran=ran_number(0.0,prob(mres))
      do i=1,MRES
        if (ran.le.prob(i).and.ran.ge.prob(i-1)) then
          lhyperdist = i
          return
        endif
      enddo
      write (jout,'(a)') 'Error in LHYPERDIST: number of residues',
     &  ' cannot be selected.'
      lhyperdist = -1
      return
      END
